$MODULE_FACTORY_REGISTRY = typeof $MODULE_FACTORY_REGISTRY != 'undefined' ? $MODULE_FACTORY_REGISTRY : {};
$MODULE_REGISTRY = typeof $MODULE_REGISTRY != 'undefined' ? $MODULE_REGISTRY : {};
if(typeof require == 'undefined')
function require(path){if(!$MODULE_REGISTRY[path]) $MODULE_REGISTRY[path] = $MODULE_FACTORY_REGISTRY[path](); return $MODULE_REGISTRY[path]};$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/NGJSEnvironmentSupport'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/NGJSEnvironmentSupport'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/NGJSEnvironmentSupport'] = exports; /**

 # NGJSEnvironmentSupport.js
 # webgame
 #
 # Created by Frederic Barthelemy on 10/01/10.
 # Copyright 2010 ngmoco:). All rights reserved.

 */

/**
 * Provides Environmental support for features missing on certain platforms.
 */


/**
 * setTimeout and setInterval implementation for platforms that don't have it.
 *	It fires timers at the beginning of the first frame past the requested millisecond,
 *	before it processes messages for a particular frame.
 *
 * Platform Consumers:
 *	- Android
 *
 * Note:
 *	- Only accurate to within the frame.
 *	- Does behaves like webkit in that it lets clearInterval and clearTimeout
 *		clear timers created by each other's constructor style.
 *
 */
var NGSetTimeoutCustom = false;
var NGSetTimeoutCallbacks = {};
var NGSetTimeoutUIDGenerator = 0;

exports.NGSetTimeoutRunTimers = function() {
	if(NGSetTimeoutCustom) {
		var timersToExecute = [];
		var curTime = new Date().getTime();
		for (var tk in NGSetTimeoutCallbacks) {
			if (NGSetTimeoutCallbacks.hasOwnProperty(tk) && NGSetTimeoutCallbacks[tk].shouldExecute(curTime)) {
				timersToExecute.push(NGSetTimeoutCallbacks[tk]);
			}
		}

		for (var i in timersToExecute) {
			if (timersToExecute.hasOwnProperty(i)) {
				timersToExecute[i].execute();
			}
		}
	}
};

if(typeof(setTimeout) != "function") {
	NGSetTimeoutCustom = true;

	var NGSingleTimeoutInstance = function(fptr, timeMs) {
		this.uid = NGSetTimeoutUIDGenerator++;
		if (NGSetTimeoutUIDGenerator == Infinity)
		{
			NGSetTimeoutUIDGenerator = 0;
		}
		this.fptr = fptr;
		this.interval = timeMs;
		this.requestedTime = new Date().getTime() + timeMs;
	};

	NGSingleTimeoutInstance.prototype.shouldExecute = function(curTime) {
		if(curTime < this.requestedTime) {
			return false;
		}
		return true;
	};

	NGSingleTimeoutInstance.prototype.execute = function() {
		delete NGSetTimeoutCallbacks[this.uid];
		this.fptr();
	};
	/**
	*
	*/
	setTimeout = function(fptr,requestedTime) {
		if(requestedTime < 0 || typeof(requestedTime) != "number") {
			requestedTime = 0;
		}

		var inst = new NGSingleTimeoutInstance(fptr,requestedTime);
		NGSetTimeoutCallbacks[inst.uid] = inst;
		return inst.uid;
	};
	/**
	*
	*/
	clearTimeout = function(uid) {
		if(NGSetTimeoutCallbacks.hasOwnProperty(uid)) {
			delete NGSetTimeoutCallbacks[uid];
		}
	};
	/**
	*
	*/
	setInterval = function(fptr,requestedTime) {
		if(requestedTime < 0 || typeof(requestedTime) != "number") {
			requestedTime = 0;
		}

		var inst = new NGSingleTimeoutInstance(fptr,requestedTime);
		/*Special setIntervalMagic */
		inst.execute = function() {
			this.requestedTime = new Date().getTime() + this.interval;
			this.fptr();
		};
		/*End setIntervalMagic */
		NGSetTimeoutCallbacks[inst.uid] = inst;
		return inst.uid;
	};
	clearInterval = clearTimeout;
	
}
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/SystemBinding'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/SystemBinding'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/SystemBinding'] = exports; var ClassReq = require('NGCore/Client/Core/Class');
var Base64 = require('NGCore/Client/Core/Base64').Base64;
var ResultSetReq = require('NGCore/Client/Plus/ResultSet');

var NGSystemBindingCommands = {
    HandleAction: 0
};

var SystemBinding = ClassReq.Class.subclass({
    classname: "SystemBinding",
    callbacks: {},
    callbacksUidGenerator: 0,
    _contResultSets: {},
    _contResultSetIdxs: {}
});

var ResultSet = ClassReq.Class.subclass({
    classname: "ResultSet",
    initialize: function(continueId) {
        this.items = [];
        this._continueId = continueId;
        this.totalLength = Number.MAX_VALUE;
    },
    /*
	 * Call to getMore adds more items to items list.
	 * Please note that in the callback, it is possible that addedCount == 0
	 * in some cases.  In that case access to items[newIdx] does not yield
	 * any result
	 */
    getMore: function(cb) {
        return SystemBinding._getMoreContacts(this, cb);
    },
    /*
	 * Releases resource used by current ResultSet.
	 *
	 * To avoid resource leakage, please call closeResultSet if getMore
	 * is not called all the way to the end.
	 */
    closeResultSet: function() {
        SystemBinding._closeContactsResultSet(this);
    }
});

SystemBinding._pushContactsCmd = function(cmdname, callbackFunc, continueId) {
    // Generate unused callbackEntry
    var callbackId = SystemBinding.callbacksUidGenerator++;
    if ( !! !callbackFunc) {
        callbackFunc = function() {};
    }
    SystemBinding.callbacks[callbackId] = callbackFunc;
    var message = {
        name: cmdname,
        callbackId: callbackId
    };
    if (typeof continueId != 'undefined') {
        message.continueId = continueId;
    }
    message = JSON.stringify(message);
    NgPushCommand3(NgEntityTypes.NgSystemBinding, NGSystemBindingCommands.HandleAction,
    Base64.encode(message));
};

SystemBinding._closeContactsResultSetfunction = function(rSet) {
    // Passing empty callback as caller does not need to know when the close
    // is complete
    var cb = function() {};
    SystemBinding._pushContactsCmd('closecontacts', cb, rSet._continueId);
};

SystemBinding._getMoreContacts = function(rSet, callbackFunc) {
    if ((typeof rSet._continueId != 'undefined') &&
    (rSet.items.length < rSet.totalLength)) {
        SystemBinding._pushContactsCmd('morecontacts', callbackFunc, rSet._continueId);
        return true;
    }
    return false;
};

SystemBinding.getContacts = function(callbackFunc) {
    SystemBinding._pushContactsCmd('contacts', callbackFunc, undefined);
};

SystemBinding.getDeviceToken = function(callbackFunc) {
    // Generate unused callbackEntry
    var callbackId = SystemBinding.callbacksUidGenerator++;
    if ( !! !callbackFunc) {
        callbackFunc = function() {};
    }
    SystemBinding.callbacks[callbackId] = callbackFunc;
    var message = {
        name: 'devicetoken',
        callbackId: callbackId
    };
    message = JSON.stringify(message);
    NgPushCommand3(NgEntityTypes.NgSystemBinding, NGSystemBindingCommands.HandleAction,
    Base64.encode(message));
};

SystemBinding.handleCommand = function(command) {
    var fields = NgParseCommand2(command, NgParseInt, NgParseBase64);
    var cmd = JSON.parse(fields[1]);
    if (cmd.name == 'callback') {
    	var cb = SystemBinding.callbacks[cmd.callbackId];
		if (typeof cb == "function") {
            if (cmd.callbackname == 'contacts') {
                var obj = SystemBinding._contResultSets[cmd.continueId];
                if (typeof obj == 'undefined') {
                    // First time for this callback
                    obj = new ResultSetReq.ResultSet(cmd.continueId);
                    SystemBinding._contResultSets[cmd.continueId] = obj;
                    SystemBinding._contResultSetIdxs[cmd.continueId] = 0;
                }

                var addedCount = cmd.list.length;
                while (cmd.list.length > 0) {
                    var item = cmd.list.shift();
                    obj.items.push(item);
                }

                var newIdx = SystemBinding._contResultSetIdxs[cmd.continueId];
				if ((typeof newIdx) != 'undefined') {
                	SystemBinding._contResultSetIdxs[cmd.continueId] = newIdx + addedCount;
				}

                // Invalidate the continueId if done - when total is return (no
                // more result) or when result set is explicitly closed (cmd.closed)
                if ((typeof cmd.total != 'undefined') ||
                (typeof cmd.rsclosed != 'undefined')) {
                    if (typeof cmd.total != 'undefined') {
                        obj.totalLength = cmd.total;
                    }
                    delete obj._continueId;
                    delete SystemBinding._contResultSets[cmd.continueId];
                    delete SystemBinding._contResultSetIdxs[cmd.continueId];
                }

                delete SystemBinding.callbacks[cmd.callbackId];
				if (cmd.success) {
                	cb(undefined, obj, newIdx, addedCount);
				} else {
                	cb(cmd.error, obj, newIdx, addedCount);
				}
            } else {
                // other callbacks
                delete SystemBinding.callbacks[cmd.callbackId];
                cb(cmd);
            }
        }
    }
};

exports.SystemBinding = SystemBinding;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI'] || {}; $MODULE_REGISTRY['NGCore/Client/UI'] = exports; var Commands = require('NGCore/Client/UI/Commands').Commands;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');

/**
 * <p>Classes and objects contained by the UI module.</p>
 * @name UI
 * @namespace
 * @description <p>The UI module is a collection of classes that control user interface components of a device.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 * <li><code>{@link UI.AbstractView}</code>A base class object for constructing other UI objects.</li>
 * <li><code>{@link UI.CellView}</code>: Construct <code>CellView</code> objects.</li>
 * <li><code>{@link UI.CheckBox}</code>: Construct objects that are used as checkboxes in an application.</li>
 * <li><code>{@link UI.CheckoutView}</code>: Construct objects that handle and manage information associated with <code>POST</code> methods in an application.</li>
 * <li><code>{@link UI.DateField}</code>: Construct objects used for handling data returned by date functions.</li>
 * <li><code>{@link UI.DocumentView}</code>: Constructs objects that control the location of application documents.</li>
 * <li><code>{@link UI.EditText}</code>: Constructs objects for handling editable text in an application.</li>
 * <li><code>{@link UI.EditTextArea}</code>: Constructs objects for handling multiline editable text in an application.</li>
 * <li><code>{@link UI.Element}</code>: A base class object for constructing other UI objects.</li>
 * <li><code>{@link UI.GLView}</code>: Construct objects that provide applications with access to OpenGL.</li>
 * <li><code>{@link UI.Image}</code>: Constructs objects that control the location and size of images used in the user interface.</li>
 * <li><code>{@link UI.Label}</code>: Constructs objects that control the look and feel of application labels.</li>
 * <li><code>{@link UI.ListView}</code>: Construct <code>ListView</code> objects.</li>
 * <li><code>{@link UI.ListViewItem}</code>: Construct <code>ListViewItem</code> objects.</li>
 * <li><code>{@link UI.ListViewSection}</code>: Construct <code>ListViewSection</code> objects.</li>
 * <li><code>{@link UI.NavController}</code>: Construct objects that control the flow of applcation navigation.</li>
 * <li><code>{@link UI.ProgressDialog}</code>: Construct objects that control application progress messaging.</li>
 * <li><code>{@link UI.ScrollView}</code>: Construct <code>ScrollView</code> objects.</li>
 * <li><code>{@link UI.Spinner}</code>: Construct objects that handle application menu spinners.
 * <li><code>{@link UI.Toast}</code>: Construct <code>Toast</code> objects.
 * <li><code>{@link UI.View}</code>: Construct objects that control the look and feel of the application view state.</li>
 * <li><code>{@link UI.ViewGeometry.Rect}</code>: Construct rectangle objects for use as positionable elements in the user interface.</li>
 * <li><code>{@link UI.ViewGeometry.Scale}</code>: Construct objects that handle view geometry for different scales of measurement.</li>
 * <li><code>{@link UI.WebView}</code>: Construct objects that pass event callback functions when web page events occur.</li>
 * <li><code>{@link UI.Window}</code>: Construct application window objects.</li>
 * </ul>
 */

var UI = exports.UI = {
	Commands: Commands,

	FontStyle: Commands.FontStyle,
	State: Commands.State,
	FitMode: Commands.FitMode,

	ViewGeometry: ViewGeometry,
	Scale: ViewGeometry.Scale,

    /**
	 *	@function
	 * 	@name UI#animate
	 * 	Animate changes to the properties of one or more UI objects.
	 * 	Currently animates changes to frame and alpha, and animates the addition / removal of subviews.
	 * 	@param {Function} action A closure that sets the property or properties to be animated.
	 * 		This function may manipulate several objects.
	 * 	@param {Number} duration The time over which to execute the animation, in milliseconds.
	 * 	@param {Function} onCompletion A closure to be executed after the animation has completed.
	 */
    animate: Commands.animate,

    /**
		@name UI#compositeImages
		Creates a composition of images to an offscreen bitmap, writing the resulting picture to disk.
		
		The filename returned in the callback may not be the same as originally requested!
		
		@example
		UI.compositeImages( 200, 200, "basic.png", [
			{
				image:'./Content/background.png',
				rect:[ 0,0, 200, 200 ]
			},
			{
				image:'./Content/CanYouSeeThisImage.png',
				rect:[ 50, 50, 100, 100 ]
			},
		], function( data ) { 
			if ( data.error == undefined ) { 
				NgLogD("yay, picture! at:"+data.filename);
			}
		} );
	 */
    compositeImages: function(w, h, filename, infoArray, callback) {
        var cb = Commands.registerTemporaryCallback(callback);
        if (cb) {
			Commands.doCompositeImages(w, h, filename, infoArray, cb);
		}
    },

    /**
		@name UI#choosePhoto
		Show fullscreen user interface for taking a picture with the camera or choosing an existing
		photo.
		
		Currently there are no 'options' keys defined.  
		In the future, we're considering "forAvatar" key to use a custom cropping UI.
		
		The filename returned in the callback may not be the same as originally requested!
		If the user cancels or an error occurs, the callback will be passed an error string.
		
		Passing 0 for targetWide or High will return the original unscaled image.
		
		@example
		UI.choosePhoto( 0, 0, "basic.png", undefined, function( data ) { 
			if ( data.error == undefined ) { 
				NgLogD("yay, picture! at:"+data.filename);
			}
		} );
	*/
    choosePhoto: function(width, height, filename, options, callback, invokingView) {
       if (!invokingView || !invokingView.__objectRegistryId) {
            new exports.UI.Toast({
                'text': "Photo picker requires an invoking view.",
                'onDisappear': function() {
                    this.destroy();
                }
            }).show();
            return;
        }

        var cb = Commands.registerTemporaryCallback(callback);
		if (cb) {
        	Commands.doChoosePhoto(width, height, filename, options || {}, cb, invokingView.__objectRegistryId);
		}
    },

    /**
		@name UI#choosePhotoCamera
		Show fullscreen user interface for taking a picture with the camera or choosing an existing
		photo.
		
		Currently there are no 'options' keys defined.  
		In the future, we're considering "forAvatar" key to use a custom cropping UI.
		
		The filename returned in the callback may not be the same as originally requested!
		If the user cancels or an error occurs, the callback will be passed an error string.
		
		Passing 0 for targetWide or High will return the original unscaled image.
		
		@example
		UI.choosePhoto( 0, 0, "basic.png", undefined, function( data ) { 
			if ( data.error == undefined ) { 
				NgLogD("yay, picture! at:"+data.filename);
			}
		} );
	*/
    choosePhotoCamera: function(width, height, filename, options, callback) {
        var cb = Commands.registerTemporaryCallback(callback);
		if (cb) {
        	Commands.doChooseCamera(width, height, filename, options || {}, cb);
		}
    },

	measureText: function( text, w, h, font, size, callback) {
		var cb = Commands.registerTemporaryCallback(callback);
		if (cb != '') {
			Commands.measureText(text, w || -1, h || -1, font, size, cb);
		}
	}
};

exports.UI.__defineGetter__("Window",
function() {
    delete UI.Window;
    return UI.Window = require('NGCore/Client/UI/Window').Window;
});
exports.UI.__defineGetter__("Element",
function() {
    delete UI.Element;
    return UI.Element = require('NGCore/Client/UI/Element').Element;
});
exports.UI.__defineGetter__("View",
function() {
    delete UI.View;
    return UI.View = require('NGCore/Client/UI/View').View;
});
exports.UI.__defineGetter__("Label",
function() {
    delete UI.Label;
    return UI.Label = require('NGCore/Client/UI/Label').Label;
});
exports.UI.__defineGetter__("Image",
function() {
    delete UI.Image;
    return UI.Image = require('NGCore/Client/UI/Image').Image;
});
exports.UI.__defineGetter__("Button",
function() {
    delete UI.Button;
    return UI.Button = require('NGCore/Client/UI/Button').Button;
});
exports.UI.__defineGetter__("GLView",
function() {
    delete UI.GLView;
    return UI.GLView = require('NGCore/Client/UI/GLView').GLView;
});
exports.UI.__defineGetter__("NavController",
function() {
    delete UI.NavController;
    return UI.NavController = require('NGCore/Client/UI/NavController').NavController;
});
exports.UI.__defineGetter__("WebView",
function() {
    delete UI.WebView;
    return UI.WebView = require('NGCore/Client/UI/WebView').WebView;
});
exports.UI.__defineGetter__("ScrollView",
function() {
    delete UI.ScrollView;
    return UI.ScrollView = require('NGCore/Client/UI/ScrollView').ScrollView;
});
exports.UI.__defineGetter__("ListView",
function() {
    delete UI.ListView;
    return UI.ListView = require('NGCore/Client/UI/ListView').ListView;
});
exports.UI.__defineGetter__("ListViewSection",
function() {
    delete UI.ListViewSection;
    return UI.ListViewSection = require('NGCore/Client/UI/ListViewSection').ListViewSection;
});
exports.UI.__defineGetter__("ListViewItem",
function() {
    delete UI.ListViewItem;
    return UI.ListViewItem = require('NGCore/Client/UI/ListViewItem').ListViewItem;
});
exports.UI.__defineGetter__("CellView",
function() {
    delete UI.CellView;
    return UI.CellView = require('NGCore/Client/UI/CellView').CellView;
});
exports.UI.__defineGetter__("CheckBox",
function() {
    delete UI.CheckBox;
    return UI.CheckBox = require('NGCore/Client/UI/CheckBox').CheckBox;
});
exports.UI.__defineGetter__("EditText",
function() {
    delete UI.EditText;
    return UI.EditText = require('NGCore/Client/UI/EditText').EditText;
});
exports.UI.__defineGetter__("EditTextArea",
function() {
    delete UI.EditTextArea;
    return UI.EditTextArea = require('NGCore/Client/UI/EditTextArea').EditTextArea;
});
exports.UI.__defineGetter__("DateField",
function() {
    delete UI.DateField;
    return UI.DateField = require('NGCore/Client/UI/DateField').DateField;
});
exports.UI.__defineGetter__("AlertDialog",
function() {
    delete UI.AlertDialog;
    return UI.AlertDialog = require('NGCore/Client/UI/AlertDialog').AlertDialog;
});
exports.UI.__defineGetter__("ProgressDialog",
function() {
    delete UI.ProgressDialog;
    return UI.ProgressDialog = require('NGCore/Client/UI/ProgressDialog').ProgressDialog;
});
exports.UI.__defineGetter__("Toast",
function() {
    delete UI.Toast;
    return UI.Toast = require('NGCore/Client/UI/Toast').Toast;
});
/** @private */
exports.UI.__defineGetter__("AdView",
function() {
    delete UI.AdView;
    return UI.AdView = require('NGCore/Client/UI/AdView').AdView;
});
exports.UI.__defineGetter__("DocumentView",
function() {
    delete UI.DocumentView;
    return UI.DocumentView = require('NGCore/Client/UI/DocumentView').DocumentView;
});
exports.UI.__defineGetter__("CheckoutView",
function() {
    delete UI.CheckoutView;
    return UI.CheckoutView = require('NGCore/Client/UI/CheckoutView').CheckoutView;
});
exports.UI.__defineGetter__("Spinner",
function() {
    delete UI.Spinner;
    return UI.Spinner = require('NGCore/Client/UI/Spinner').Spinner;
});
exports.UI.__defineGetter__("ProgressBar",
function() {
    delete UI.ProgressBar;
    return UI.ProgressBar = require('NGCore/Client/UI/ProgressBar').ProgressBar;
});
exports.UI.__defineGetter__("MapView",
function() {
    delete UI.MapView;
    return UI.MapView = require('NGCore/Client/UI/MapView').MapView;
});
exports.UI.__defineGetter__("MapAnnotation",
function() {
    delete UI.MapAnnotation;
    return UI.MapAnnotation = require('NGCore/Client/UI/MapAnnotation').MapAnnotation;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/DownloadManifest'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/DownloadManifest'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/DownloadManifest'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class XHR
// XMLHttpRequest implementation
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
var XHR = require('NGCore/Client/Network/XHR').XHR;
var Util = require('NGCore/Client/Network/Util').Util;
var DownloadFile = require('NGCore/Client/Network/DownloadFile').DownloadFile;
var FileSystem = require('NGCore/Client/Storage/FileSystem').FileSystem;
var LocalGameList = require('NGCore/Client/Core/LocalGameList').LocalGameList;

// JMarr temporary hack to supress archive downloads on flash.
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;

////////////////////////////////////////////////////////////////////////////////

var Manifest = Class.subclass(
{
	classname: 'Manifest',

	initialize: function()
	{
	},

	reset: function ()
	{
		this.mJson = null;
		this.mArchives = null;
	},

	initWithJsonText: function ( text, emptyOnFail)
	{
		try
		{
			this.mJson = JSON.parse ( text );
			if (!this.mJson)
			{
				this.mJson = {};
			}
		}
		catch (e)
		{
			this.mJson = {};
		}

		if('__archives' in this.mJson)
		{
			this.mArchives = this.mJson['__archives'].files;
			delete this.mJson['__archives'];
		}
		else
		{
			this.mArchives = [];
		}
	},

	//cb: function ( itemKey, dstList, srcList ), which is compareItems
	//cb returns ! null, then dst[ item ] = cb return value.
	//cb returns null, then delete dst[ item ].
	foreach: function ( other, cb )
	{
		var dst = this.mJson;
		var src = other.mJson;
		// Handle all things in src.
		for ( var key in src )
		{
			this.handleItem ( key, dst, src, cb );
		}
		// Build up list of all things not in src.
		for ( var key in dst )
		{
			// Handle all things not in src.
			if ( ! (key in src) )
			{
				this.handleItem ( key, dst, src, cb );
			}
		}
	},

	handleItem: function ( key, dst, src, cb )
	{
		var ret = cb ( key, dst, src );
		if ( !ret )
		{
			delete dst[ key ];
		}
	},

	write: function ( fname )
	{
		var cb = function (err)
		{
			if (err)
			{
				console.log('Error writing manifest! ' + err);
			}
			// DO stuff?
		};

		if (this.mJson)
		{
			var out = JSON.stringify(this.mJson);
			FileSystem.writeFile(fname, out, cb);
		}
	}
});

////////////////////////////////////////////////////////////////////////////////

exports.DownloadManifest = MessageListener.subclass(
/** @lends Network.DownloadManifest.prototype */
{
	classname: 'DownloadManifest',

	/**
	 * @class The <code>DownloadManifest</code> class constructs objects that initiate the handling of a manifest file. 
	 * This ensures a set of files are kept up-to-date in the specified directory from the specified URL.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this.reset();
	},

	_clearConnections: function()
	{
		for (var i in this.mConnections)
		{
			if(!this.mConnections.hasOwnProperty(i)) continue;
			
			this.mConnections[i].abort();
		}
		this.mConnections = [];
	},

	reset: function ()
	{
		this.mConcurrentRequests = 6;

		this.mManifest = null;

		this.mRemoteUrl = null;
		this.mLocalPath = null;
		this.mLocalRoot = null;

		this.mLocalText = null;
		this.mRemoteText = null;
		/** @private */
		this.mProgressCb = function() {};
		/** @private */
		this.mDoneCb = function() {};

		this.mPaused = false;
		this.mValid = false;

		this._clearConnections();
		this.mPendingItems = [];
		this.mCompleteBytes = 0;
		this.mTotalBytes = 0;
		
		this.mSpaceNeeded = 0;
		
		this.mNumRemoteManifestFiles = 0;
		this.mNumRemoteManifestBytes = 0;
		
		this.mDownloadArchives = true;
		this.mActiveRequests = [];

		this.mLocalGameList = LocalGameList;

		this.mNewJS = false;
		this.mAppObserver = null;

		this.mRetrySchedule = Util.RetrySchedule(50, 2000);
		this.mManifestRetrySchedule = this.mRetrySchedule.slice(0);

		if(this._statusListener)
		{
			this._statusListener.destroy();
			this._statusListener = null;
		}
		this.mCheckUpdateOnly = false;
		this.mCheckUpdateCallback = null;
	},

	_ensureTrailingSlashes: function(remoteUrl, localPath, secureContentUrl)
	{
		// Check for trailing slashes
		this.mRemoteUrl = remoteUrl.match(/.*\/$/) ? remoteUrl : remoteUrl + '/';
		// If the local path is nothing, do not alter the filename. Otherwise, ensure trailing slash
		this.mLocalRoot = (localPath.match(/.*\/$/) || (!localPath)) ? localPath : localPath + '/';
		this._secureContentUrl = ((!secureContentUrl) || secureContentUrl.match(/.*\/$/)) ? secureContentUrl : secureContentUrl + '/';
	},

	_readLocalManifest: function()
	{
		FileSystem.readFile ( this.mLocalPath, this._onReadLocalManifest.bind(this) );
	},

	_setRemotePath: function(manifestName)
	{
		if (this._secureContentUrl)
		{
			this.mRemotePath = this._secureContentUrl + manifestName;
		}
		else
		{
			this.mRemotePath = this.mRemoteUrl + manifestName;
		}
	},

	_parseManNames: function (man)
	{
		if (typeof man === 'string')
		{
			var obj = {};
			obj[man] = man;
			man = obj;
		}
		return man;
	},

	isUpdated: function(remoteUrl, localPath, manifest, doneCB, errorCB)
	{
		this.mCheckUpdateOnly = true;
		this.mCheckUpdateCallback = doneCB;

		this.mDoneCb = (typeof errorCB == 'function') ? errorCB : function() {};
		this.mProgressCb = function(done, left) {};
		var httpStatusCode = 0;
		var fullUrl = remoteUrl + "/configuration.json" + Util.getCacheBustingString();
		Util.OperationWithRetries(
			(function(failCall, abortCall)
			{
				// Start remote manifest download.
				var req = new XHR();
				req.onreadystatechange = (function()
				{
					if( req.readyState == 4 && this.mValid )	// done && not cancelled
					{
						this.mManifest = new Manifest ();
						var manifestUrl = null;
						// Only parse if we got a good response back
						if (req.status == 200 && req.responseText)
						{
							var config = JSON.parse(req.responseText);
							manifestUrl = config.contentUrl;
							if (!manifest)
							{
								manifest =
								{
									"webgame.ngmanifest":
									require('NGCore/Client/Core/_int_LGL')._int_LGL.getManifestName(config)
								};
							}

							// If config didn't have contentUrl or we never parsed(local testing), use the base URL
							if (!manifestUrl)
								manifestUrl = remoteUrl;

							manifest = this._parseManNames(manifest);
							var manifestSourceName;
							var manifestName;
							for (var key in manifest)
							{
								manifestSourceName = manifest[key];
								manifestName = key;
								break;
							}

							this._ensureTrailingSlashes(manifestUrl, localPath);
							this.mLocalPath = this.mLocalRoot + manifestName;
							this._setRemotePath(manifestSourceName);
							this._readLocalManifest();
						}
						else if (req.status == 404)
						{
							this._processError('404! Failed to download configuration at '+ fullUrl, false);
						}
						else
						{
							httpStatusCode = req.status;
							failCall();
						}
					}
				}).bind(this);

				req.open ( 'GET', fullUrl, true );
				req.send ();
			}).bind(this),
			(function()
			{
				console.log('Exceeded maximum number of manifest download retires, failing');
				this._processError('Failed to download manifest (' + httpStatusCode + ') at ' + fullUrl, false);
			}).bind(this),
			this.mFailEarly
		);

		this.mValid = true;
	},

	// progressCb: function ( completedRequests, totalRequests )
	// doneCb: function ( err, manifest )
	// throws if url/path arguments are null or empty.
	// TODO: Allow headers argument.  Currently null.
	// TODO: Allow HTTP method argument.  Currently GET.
	/**
	* @name Network.DownloadManifest#start
	* @description Start a download of a remote manifest file at <code>[remoteUrl + manifestName]</code> 
	* and read a local manifest at <code>[localPath + manifestName]</code>.<br><br>
	* <ul>
	* <li>If the local manifest does not exist, all files specified by the remote manifest are downloaded.</li>
	* <li>If the local manifest does exist, this method will update the file system at 
	* <code>[localPath]</code> to match the files specified in the remote manifest.</li>
	* </ul>
	* Each file download will trigger a <code>progress</code> callback function that returns the 
	* number of items downloaded and the total number of items to download.
	* <pre class="code">progressCb: function ( completedRequests, totalRequests )</pre>
	* When all downloads are complete, a <code>done</code> callback function is triggered that returns an error (if any) 
	* and the contents of <code>[localPath + manifestName]</code>. 
	* <pre class="code">doneCb: function ( err, manifest )</pre>
	* If an error does not occur, this function returns <code>undefined</code>.<br><br>
	* <b>Note:</b> The contents of <code>[localPath + manifestName]</code> are saved whether an error occurs or not.
	* @param {String} remoteUrl The URL to a manifest file.
	* @param {String} localPath The directory path to a manifest file.
	* @param {String} manifestName The manifest filename. 
	* @param {Function} progressCb The callback function to call for download progress.
	* @param {Function} doneCb The callback function to call when the download is complete.
	* @throws {invalid arguments} If the URL or directory path returns as empty or <code>null</code>.
	* @example Network.DownloadManifest.start(this._URL, './', this._manifestName, progressCb, doneCallback);
	* @function
    * @status iOS, Android
	*/
	/** @ignore */
	start: function ( remoteUrl, localPath, manifest, progressCb, doneCb, disableArchives, failEarly )
	{
		this.mCheckUpdateOnly = false;
		
		// Allow manifestName to be a hash with {manifestDestName: manifestSourceName}
		manifest = this._parseManNames(manifest);
		var manifestSourceName;
		var manifestName;
		for (var key in manifest)
		{
			manifestSourceName = manifest[key];
			manifestName = key;
			break;
		}

		console.log('DownloadManifest.start(', remoteUrl, localPath, manifestSourceName, ')');
		if ( ! remoteUrl || ! localPath || remoteUrl == '' || localPath == '' )
		{
			throw new Error ( 'invalid arguments: ' + JSON.stringify ( arguments ) );
		}

		// Set up instance state for this request.
		this.mManifest = new Manifest ();
		if(disableArchives)
			this.mDownloadArchives = false;
		
		// JMarr temporary hack to disable archive downloads on flash.
		if(Capabilities.getPlatformOS() == 'flash')
		{
			console.log('Flash does not yet support archive downloads');
			this.mDownloadArchives = false;
		}

		this._ensureTrailingSlashes(remoteUrl, localPath, this._secureContentUrl);
		this._setRemotePath(manifestSourceName);
		this.mLocalPath = this.mLocalRoot + manifestName;
		this.mFailEarly = failEarly;

		// try these to prevent a failed update due to bad code
		/** @private */
		this.mProgressCb = function (done, left)
		{
			try
			{
				progressCb(done, left);
			}
			catch (ex)
			{
				NgLogException(ex);
			}
		};

		var that = this;
		/** @private */
		this.mDoneCb = function (err, man, hadCache)
		{
			try
			{
				// touch the .nomedia file (MOB-1355)
				FileSystem.writeFile(that.mLocalRoot + '/.nomedia', '');

				/** @private */
				this.mProgressCb = function() {};
				/** @private */
				this.mDoneCb = function() {};
				this._setLifecycleListening(false);
				doneCb(err, man, hadCache);
			}
			catch (ex)
			{
				NgLogException(ex);
			}
		};

		this._readLocalManifest();
		this._setLifecycleListening(true);
		this.mValid = true;
	},

	abort: function()
	{
		this.reset();
	},

	pause: function()
	{
		// Cancel downloads
		this._clearConnections();

		// move active requests back to pending
		this.mPendingItems = this.mPendingItems.concat(this.mActiveRequests);
		this.mActiveRequests = [];

		this.mPaused = true;
	},

	resume: function()
	{
		if (this.mPaused)
		{
			this.mPaused = false;
			this._downloadPendingItems();
		}
	},

	_setLifecycleListening: function(toListen)
	{
		if (toListen && !this.lifeListening)
		{
			Device.LifecycleEmitter.addListener(this,
				function (event)
				{
					switch (event)
					{
						case Device.LifecycleEmitter.Event.Suspend:
						case Device.LifecycleEmitter.Event.Terminate:
							this._writeManifest();
						break;
					}
				}
			);
			this.lifeListening = true;
		}
		else if (this.lifeListening)
		{
			Device.LifecycleEmitter.removeListener(this);
			this.lifeListening = false;
		}
	},

	_theQuestion: function (toBe)
	{
		return toBe | !toBe;
	},

	_setConfig: function (cfg)
	{
		// For saving after completion
		this._Config = cfg;
		// for skipping JS download
		this._noJS = cfg.omitJsUpdate;
		// For using separate content URL
		this._secureContentUrl = cfg.secureContentUrl;
	},

	// Callback for read of local manifest file in start method.

	_onReadLocalManifest: function ( err, data )
	{
		if (this.mValid)
		{
			try	// always start try block in async callbacks
			{
				if ( ! err )
				{
					this.mLocalText = data;
				}
				else
				{
					this.mLocalText = '{}';	// Empty string is ! null.  It's ok for the read to fail.
				}
				this._downloadManifest();
			}
			catch ( ex )
			{
				NgLogException ( ex );
				this._processError ( 'Error reading local manifest err: ' + err , false );
			}
		}
	},

	// Called to start the manifest download.
	_downloadManifest: function()
	{
		var httpStatusCode = 0;
		Util.OperationWithRetries(
			(function(failCall, abortCall)
			{
				// Start remote manifest download.
				var req = new XHR();
				var id = this.mConnections.push(req) - 1;
				req.onreadystatechange = (function()
				{
					if( req.readyState == 4 && this.mValid )	// done && not cancelled
					{
						delete this.mConnections[id];
						httpStatusCode = req.status;
						if ( httpStatusCode == 200 )
						{
							this.mRemoteText = req.responseText;
							this._checkItems();

							if (this.mCheckUpdateOnly)
								this._checkUpdate();
							else
								this._evalManifests ();
						}
						else
						{
							console.log( 'Download of manifest at ' + this.mRemotePath
								+Util.getCacheBustingString() + ' failed: ' + httpStatusCode + ' '
								+ req.responseText);
							if (httpStatusCode == 404)
							{
								abortCall();
							}
							else
							{
								failCall();
							}
						}
					}
				}).bind(this);

				req.open ( 'GET', this.mRemotePath + Util.getCacheBustingString(), true );
				req.send ();
			}).bind(this),
			(function()
			{
				this._processError('Failed to download manifest (' + httpStatusCode + ')', false);
			}).bind(this),
			this.mFailEarly
		);
	},

	// Can be called at any time.

	_processError: function ( message , writeManifest)
	{
		if (writeManifest && this.mManifest)
		{
			this._writeManifest();
		}

		// Don't call the doneCB without checking local text
		if (this.mValid)
		{
			this.mDoneCb ( message, null,  this.mLocalText ? this.mLocalText.length > 2 : false );
			this.reset ();
		}
	},

	_checkItems: function()
	{
		// Init source and destination manifests.
		this.mManifest.initWithJsonText ( this.mLocalText , true );
		var other = new Manifest ();
		other.initWithJsonText ( this.mRemoteText );

		// Build list of pending local items.
		this.mManifest.foreach ( other, this._compareItems.bind(this));
	},

	_checkUpdate: function()
	{
		this.mPendingItems = [];
		this.mCheckUpdateCallback(this.mTotalBytes > 0, this.mTotalBytes);
	},

	_evalManifests: function ()
	{
		try
		{
			// JMarr always download with zips if they are available.
			// If we only need to download less than 33% of files and less than 33% of bytes, then don't use an archive.
			// Additinoally, we must be on wifi, or else carriers might tamper with our files.
			/*var NetworkEmitter = require('../Device/NetworkEmitter').NetworkEmitter;
			if(this.mPendingItems.length < this.mNumRemoteManifestFiles * 0.33
				&& this.mTotalBytes < this.mNumRemoteManifestBytes * 0.33
				&& NetworkEmitter.getLastStatus() == NetworkEmitter.Status.Wifi)
			{
				this.mDownloadArchives = false;
			}*/
			
			// Cache total bytes into separate variable. Archive download might increase
			// space needed, but not total bytes.
			this.mSpaceNeeded = this.mTotalBytes;

			var other = new Manifest ();
			other.initWithJsonText ( this.mRemoteText );
			// If there is no archive in the manifest, don't download an archive.
			if(!other.mArchives)
				this.mDownloadArchives = false;

			// Prepare for archive downloads. If mDownloadArchives is true,
			// then all files will be downloaded through an archive. Otherwise,
			// only files that are makred as force archive will be downloaded
			// through archive.
			this._prepareForArchiveDownload(other.mArchives, !this.mDownloadArchives);
			
			// Trigger progress callback.
			this.mProgressCb ( this.mCompleteBytes, this.mTotalBytes );

			this.mLocalGameList.freeSpace(this.mSpaceNeeded, (function (err)
			{
				if (err)
				{
					this._processError(err, false);
					return;
				}
				var num = this.mPendingItems.length;
				if (num)
				{
					console.log("Going to download %d items.", num);
					if (num < 10)
					{
						console.log("Items: " + JSON.stringify(this.mPendingItems));
					}
				}
				// Download anything that got into pending list
				this._downloadPendingItems ();
			}).bind(this));
		}
		catch (e)
		{
			NgLogException ( e );
			this.mDoneCb ( 'Failed processing manifests!', null );
		}
	},
	
	// Decides which archives need to be downloaded to ensure that all of the pending files are downloaded.
	_prepareForArchiveDownload: function(archives, onlyForcedFiles)
	{
		console.log('DownloadManfiest._prepareForArchiveDownload onlyForcedFiles:', onlyForcedFiles);
		// Iterate over files that need to be covered and make sure they are included.
		var neededFiles = [];
		var includedArcns = {};
		var includedExpSize = 0;
		var includedArcSize = 0;
		var filesToCover = this.mPendingItems;
		var nonForcedFiles = [];
		for(var i=0; i < filesToCover.length; ++i)
		{
			// If this file isn't an archive, just download the file.
			var f = filesToCover[i];
			if(!f.arcn)
			{
				//console.log('NonForced: including arnc-less %s', f.name);
				neededFiles.push(f);
				includedExpSize += f.size;
				continue;
			}
			
			// Record that this archive provides this file.
			var arcn = f.arcn;
			var a = archives[arcn];
			if(!a.files)
				a.files = [f];
			else
				a.files.push(f);
			
			// Is this archive already incldued?
			if(includedArcns[arcn])
				continue;
			
			// If we are only including forced files, remember that this
			// is a non forced file that we need to download. If after evaluating
			// all of the forced files and these files are not included, they will
			// be explicitly included.
			if(onlyForcedFiles && !f.arcForce)
			{
				nonForcedFiles.push(f);
				//console.log('NonForced: delaying decision about %s in arcn %d', f.name, f.arcn);
				continue;
			}
			
			//console.log('Forced: including %s from arcn %d', f.name, f.arcn);
			
			// Include the archive associated with this arcn.
			neededFiles.push(a);
			includedArcns[arcn] = true;
			includedExpSize += a.expSize;
			includedArcSize += a.arcSize;
		}
		
		// If only downloading forced archives, examine all of the queued
		// files that are not forced. If their archive is not included, then 
		// directly include the file.
		for(i=0; i < nonForcedFiles.length; ++i)
		{
			// Is the archive for this file already incldued?
			// This will happen if a forced file (like a .js) 
			// forced the archive to be included.
			var f = nonForcedFiles[i];
			if(includedArcns[f.arcn])
			{
				//console.log('NonForced: skipping %s because it is already in arcn %d', f.name, f.arcn);
				continue;
			}
			
			//console.log('NonForced: including %s from arch %d', f.name, f.arcn);
			
			// Otherwise, include this file.
			neededFiles.push(f);
			includedExpSize += f.size;
		}
		
		// Tell the rest of the world about our choices.
		this.mPendingItems = neededFiles;
		this.mTotalBytes = includedExpSize;
		this.mSpaceNeeded = includedExpSize + includedArcSize;
	},

	// Callback from Manifest.foreach.

	_compareItems: function ( key, dst, src )
	{
		var ditem = dst[key];
		var sitem = src[key];

		// Early out for removed file.  Always delete.
		if ( ! sitem )
		{
			var fname = this.mLocalRoot + key;
			var cb = function(err)
			{
				if (err)
				{
					console.log('Error deleting ' + fname + ' error: ' + err);
				}
			};
			FileSystem.deleteFile(fname, cb);

			// If the item was pending, delete the temporary file it was downloading
			if ('pending' in ditem )
			{
				fname = fname + '.tmp';
				FileSystem.deleteFile(fname, cb);
			}
			return false;
		}

		var isJS = this._extensionMatch ( key, 'js' );

		// Don't download the html or the js with noJS.
		if (this._noJS && (isJS || key == "index.html"))
		{
			// Don't download JS!! keep it in the local manifest, but don't push it to download
			return true;
		}

		sitem.name = key;
		this.mNumRemoteManifestFiles += 1;
		this.mNumRemoteManifestBytes += sitem.size;

		// No local version or version mismatch, must download.
		if ( ! ditem || ditem.hash != sitem.hash)
		{
			if ( isJS )
			{
				this.mNewJS = true;
			}

			// Tally the space we need for downloading new items
			this.mTotalBytes += sitem.size;

			// Add to the pending queue.
			this.mPendingItems.push ( sitem );
		}
		
		return true;
	},

	// Utility method to check for case-insensitive match for file extension.
	
	_extensionMatch: function ( fname, ext )
	{
		var pattern = new RegExp ( '^.*\.(' + ext + ')$', 'i' );
		var ret = fname.match ( pattern );
		return ret;
	},

	// Once in download state, this method is called to start downloading 
	// assets from manifest.  When each asset successfully completes, this method
	// will also be called to start the next download.  This method institutes
	// the logic for having a limited number of concurrent downloads from
	// the mCurrentRequests and mConcurrentRequests members.

	_downloadPendingItems: function ()
	{
		if (this.mValid && !this.mPaused)
		{
			// Are we done?
			if ( this.mPendingItems.length == 0 && this.mActiveRequests.length == 0)
			{
				if (this.mTotalBytes > 0)
				{
					this._writeManifest ();
				}
				this._writeConfig();

				// Trigger done callback and reset.
				this.mDoneCb ( null, this.mManifest );
				this.reset ();
				return;
			}

			// Not done, pop more pending items and start their downloads.
			while ( this.mPendingItems.length && this.mActiveRequests.length < this.mConcurrentRequests )
			{
				// Download the next pending file.
				var item = this.mPendingItems.pop ();
				item.retrySchedule = this.mRetrySchedule.slice(0);
				this._downloadItem(item);
			}
		}
	},
	
	_downloadItem: function(item)
	{
		this.mActiveRequests.push(item);
		var remoteUrl = this.mRemoteUrl + item.name;
		if(item.mangled)
		{
			var i = remoteUrl.lastIndexOf('.');
			remoteUrl = remoteUrl.substr(0, i) + '-' + remoteUrl.substr(i+1) + '.bin';
		}

		Util.OperationWithRetries((function(failCb)
		{
			// Start the download.
			var dlFile = new DownloadFile();
			var id = this.mConnections.push(dlFile) - 1;
			dlFile.start(this.mLocalRoot + item.name,
				'GET',
				remoteUrl + Util.getCacheBustingString(),
				[],
				this._onDownloadItemComplete.bind(this, item, failCb, id));
		}).bind(this), (function()
		{
			console.log('Manifest download failed. Too many failed download attempts for ' + item.name );
			this._processError ( 'Could not download file ' + item.name , true);
		}).bind(this), this.mFailEarly);
	},

	_removeActiveRequest: function (item)
	{
		for (var i in this.mActiveRequests)
		{
			if (item == this.mActiveRequests[i])
			{
				this.mActiveRequests.splice(i, 1);
			}
		}
	},

	// Callback for completion of download started in downloadItem method.
	// Will throw if item does not have pending member set.

	_onDownloadItemComplete: function ( item, failCb, id, status, hash )
	{
		try
		{
			delete this.mConnections[id];
			// Was there an error or bad download?
			if(status != 200 || item.hash != hash)
			{
				// Try to download the item again.
				console.log('Download failed.  Retrying ' + item.name );
				console.log('Status: ' + status + ' manifest hash: ' + item.hash + ' actual hash: ' + hash);
				failCb();
				return;
			}
			
			// Is this an archive?
			if(item.files)
			{
				// Temporarially increase the max number of connections while we decompress the archive.
				++this.mConcurrentRequests;
				
				FileSystem.decompressFile(this.mLocalRoot + item.name, this.mLocalRoot, false, (function(err, files)
				{
					// Restore max connections to original value.
					--this.mConcurrentRequests;
					
					// Delete the zip file.
					FileSystem.deleteFile(this.mLocalRoot + '/' + item.name);
					
					if(err)
					{
						// Try to download the item again.
						console.log('Decompress failed.  Retrying ' + item.name );
						failCb();
					}
					
					for(var i=0; i < item.files.length; ++i)
					{
						var f = item.files[i];
						this.mManifest.mJson[f.name] = {size: f.size, hash: f.hash};
					    if (typeof f.encryption != "undefined")
						this.mManifest.mJson[f.name].encryption = f.encryption;
					}

					this._removeActiveRequest(item);
					this.mCompleteBytes += Number(item.expSize);
					this.mProgressCb ( this.mCompleteBytes, this.mTotalBytes );
					this._downloadPendingItems ();
				}).bind(this));
			}
			else
			{
				// Update our working manifest.
				this.mManifest.mJson[item.name] = {size: item.size, hash: item.hash};
			    if (typeof item.encryption != "undefined")
				this.mManifest.mJson[item.name].encryption = item.encryption;
				
				// Make callbacks (like a boss).
				this._removeActiveRequest(item);
				this.mCompleteBytes += Number(item.size);
				this.mProgressCb ( this.mCompleteBytes, this.mTotalBytes );
				this._downloadPendingItems ();
			}
		}
		catch ( ex )
		{
			// Unlikely, but safety
			NgLogException ( ex );
			this._processError ( 'Error after finishing the download of item ' + item 
				+ '. status is ' + status , true );
		}
	},

	// Flush changes to locally cached manifest file.

	_writeManifest: function ()
	{
		console.log("DM Complete!");
		try
		{
			if (this.mManifest)
				this.mManifest.write ( this.mLocalPath );
		}
		catch (ex)
		{
			NgLogException(ex);
		}
	},

	_writeConfig: function ()
	{
		try
		{
			if (this._Config)
			{
				// console.log("writing |%s| to %s", JSON.stringify(this._Config), this.mLocalRoot + Capabilities._getConfigFile());
				FileSystem.writeFile(this.mLocalRoot + Capabilities._getConfigFile(),
					JSON.stringify(this._Config), function(err) {console.log(err); } );
			}
		}
		catch (ex)
		{
			NgLogException(ex);
		}
	}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/LocalGameList'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/LocalGameList'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/LocalGameList'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class LocalGameList
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Proc = require('NGCore/Client/Core/Proc').Proc;
var Class = require('NGCore/Client/Core/Class').Class;
var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Base64 = require('NGCore/Client/Core/Base64').Base64;
var toMD5 = require('NGCore/Client/Core/toMD5').toMD5;
var Util = require('NGCore/Client/Network/Util').Util;
var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;

////////////////////////////////////////////////////////////////////////////////

var LifeListener = MessageListener.subclass(
{
	initialize: function(listen)
	{
		LifecycleEmitter.addListener(this, this.onLifecycleUpdate);
		this._listener = listen;
	},

	destroy: function()
	{
		LifecycleEmitter.removeListener(this);
	},

	onLifecycleUpdate: function(event)
	{
		switch (event)
		{
			case Device.LifecycleEmitter.Event.Resume:
				this._listener.onResume();
				break;
		}
	}
});

exports.LocalGameList = Class.singleton (
/** @lends Core.LocalGameList.prototype */
{
	classname: 'LocalGameList',

	/**
	 * @class The <code>LocalGameList</code> class constructs objects that handle the loading and updating of a user's game list.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		new LifeListener(this);
		this.mRefCount = 0;
		this.mRefTable = [];
		this.mSpaceAvailable = 0;
		this.mRequiredAvailableSpace = 0;
		
		this.mSpaceCB = [];

		this._getRepoSpaceSendGen();

		var self = this;
		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		this.mGameStore = KeyValueCache.global("Core.GameList");
		this.mActiveGameKey = "activeGames";
		this.onResume();
	},


	/** @private */
	onResume: function()
	{
		this._reloadGameList();
	},

	_reloadGameList: function()
	{
		this.mGameStore.getItem(this.mActiveGameKey,
			(function(error, value)
			{
				var list;
				if (value)
					list = JSON.parse(value);
				else
					list = [];

				this.mGameList = list;
				if (typeof this.mListListen == 'function')
					this.mListListen();
			}).bind(this),
			true
		);
	},

	/** @private */
	setListListener: function(funk)
	{
		this.mListListen = funk;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 302
	// Method create = -1
	// Method updateGame = 2
	// Method updateDone = 3
	// Method getRepoSpace = 4
	// Method repoSpace = 5
	// Method deleteGame = 6
	// Method _setUpdateProgressVisible = 7
	// Method _setUpdateProgressBounds = 8
	// Method pauseUpdate = 9
	// Method resumeUpdate = 10
	// Method cancelUpdate = 11
	// Method updateProgress = 12
	// Method runGame = 13
	// Method finishGame = 14
	// Method _forwardException = 15
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._updateDoneRecv( cmd );
					break;
				case 5:
					instance._repoSpaceRecv( cmd );
					break;
				case 12:
					instance._updateProgressRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[302] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_updateDoneRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in LocalGameList.updateDone from command: " + cmd );
			return false;
		}
		
		obj[ "id" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "id" ] === undefined )
		{
			NgLogE("Could not parse id in LocalGameList.updateDone from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in LocalGameList.updateDone from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_repoSpaceRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		obj[ "space" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "space" ] === undefined )
		{
			NgLogE("Could not parse space in LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_updateProgressRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 4 )
		{
			NgLogE("Could not parse due to wrong argument count in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "cur" ] = Proc.parseInt( cmd[ 1 ] );
		if( obj[ "cur" ] === undefined )
		{
			NgLogE("Could not parse cur in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "total" ] = Proc.parseInt( cmd[ 2 ] );
		if( obj[ "total" ] === undefined )
		{
			NgLogE("Could not parse total in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Proc.parseBool( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":302,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_updateGameSendGen: function( url, id )
	{
		Proc.appendToCommandString( ":302,2," + this.__objectRegistryId + "," + Base64.encode( url ) + "," + id  );
	},
	
	/** @private */
	_getRepoSpaceSendGen: function(  )
	{
		Proc.appendToCommandString( ":302,4," + this.__objectRegistryId );
	},
	
	/** @private */
	_deleteGameSendGen: function( mdFive )
	{
		Proc.appendToCommandString( ":302,6," + this.__objectRegistryId + "," + Base64.encode( mdFive )  );
	},
	
	/** @private */
	__setUpdateProgressVisibleSendGen: function( visible )
	{
		Proc.appendToCommandString( ":302,7," + this.__objectRegistryId + "," + ( visible ? 1 : 0 )  );
	},
	
	/** @private */
	__setUpdateProgressBoundsSendGen: function( x, y, w, h )
	{
		Proc.appendToCommandString( ":302,8," + this.__objectRegistryId + "," + x + "," + y + "," + w + "," + h  );
	},
	
	/** @private */
	_pauseUpdateSendGen: function( url )
	{
		Proc.appendToCommandString( ":302,9," + this.__objectRegistryId + "," + Base64.encode( url )  );
	},
	
	/** @private */
	_resumeUpdateSendGen: function( url )
	{
		Proc.appendToCommandString( ":302,10," + this.__objectRegistryId + "," + Base64.encode( url )  );
	},
	
	/** @private */
	_cancelUpdateSendGen: function( url )
	{
		Proc.appendToCommandString( ":302,11," + this.__objectRegistryId + "," + Base64.encode( url )  );
	},
	
	/** @private */
	_runGameSendGen: function( url )
	{
		Proc.appendToCommandString( ":302,13," + this.__objectRegistryId + "," + Base64.encode( url )  );
	},
	
	/** @private */
	_finishGameSendGen: function(  )
	{
		Proc.appendToCommandString( ":302,14," + this.__objectRegistryId );
	},
	
	/** @private */
	__forwardExceptionSendGen: function( exceptionString )
	{
		Proc.appendToCommandString( ":302,15," + this.__objectRegistryId + "," + Base64.encode( exceptionString )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// updateGame: function( url, id ) {}
	
	// _updateDoneRecv: function( cmd ) {}
	// getRepoSpace: function(  ) {}
	
	// _repoSpaceRecv: function( cmd ) {}
	// deleteGame: function( mdFive ) {}
	
	// _setUpdateProgressVisible: function( visible ) {}
	
	// _setUpdateProgressBounds: function( x, y, w, h ) {}
	
	// pauseUpdate: function( url ) {}
	
	// resumeUpdate: function( url ) {}
	
	// cancelUpdate: function( url ) {}
	
	// _updateProgressRecv: function( cmd ) {}
	// runGame: function( url ) {}
	
	// finishGame: function(  ) {}
	
	// _forwardException: function( exceptionString ) {}
	

// {{/Wg Generated Code}}
	
	_setProgressVisible: function (progressVisible) {
		this.progressVisible = progressVisible;
		this.__setUpdateProgressVisibleSendGen(progressVisible);
	},
	
	_setProgressBounds: function(bounds) {
		this.__setUpdateProgressBoundsSendGen(bounds[0],bounds[1],bounds[2],bounds[3]);
	},
	
	_createProcSwitchDialog: function(title)
	{
		var UI = require('NGCore/Client/UI').UI;
		var Device = require('NGCore/Client/Device').Device;
		var w = NGWindow.outerWidth;
		var h = NGWindow.outerHeight;
		
		if(Device.OrientationEmitter.getInterfaceOrientation() == Device.OrientationEmitter.Orientation.Landscape
			|| Device.OrientationEmitter.getInterfaceOrientation() == Device.OrientationEmitter.Orientation.LandscapeLeft)
		{
			w = NGWindow.outerHeight;
			h = NGWindow.outerWidth;
		}
		
		var r = new UI.ViewGeometry.Rect(0, 0, w, h);
		
		var background = new UI.View({
			'frame': r.array(),
			'title': title,
			'backgroundColor': "8000"
		});
		
		r.inset(Math.round( (h - 238) / 2.0 ), 10);
		
		var dialog = new UI.View({
			'frame': r.array(),
			'gradient': {
				gradient: ["FF102031 0.0", "FF102031 0.394", "FF101820 0.394", "FF101820 1.0"],
				outerLine: "FF9c 1.0"
			}
		});
		background.addChild(dialog);

		r.x = r.y = 0;
		
		var header = new UI.Label({
			'frame': r.sliceVertical(94).array(),
			'text': (title || "Please Wait…"),
			'textColor': "FFFF",
			'textShadow': "8000 1.0 {0,-1}",
			'textSize': 24.0,
			'textGravity': [0.0, 0.5],
			'textInsets': [10, 30, 10, 30]
		});
		dialog.addChild(header);
		
		r.inset(36, 36 + Math.floor( (r.w - r.h) / 2));
		r.h = r.w;
		
		var spinner = new UI.Spinner({
			'frame': r.array()
		});
		dialog.addChild(spinner);
		
		UI.Window.document.addChild(background);
		
		return background;
	},

	/**
	* Restart the current game
	*/
	restartGame: function()
	{
		this.runGame(Capabilities.getServer() + "/" + Capabilities.getGame());
	},

	/**
	* Launch a game from the specified URL.
	* @param {String} url The specified URL of a game. Null to return to mobage.
	*/
	
	runGame: function( url )
	{
		console.log("Calling runGame with " + url);
		if (!url)
		{
			console.log("Finishing");
			this._finishGame();
		}
		else
		{
			this._runGameSendGen(Util.NormalizeUrl(url));
		}
	},

/** private */
	_finishGame: function()
	{
		this._finishGameSendGen();
	},

	// Next 5 functions are for mobage, not developers.

	// callback = function(gameUrl, dl'd, total, error)
	// mobage responsibility to intercept when dl'd == total, update is finished
	//	or know if there was an error by checking that param

	listenUpdates: function(callback)
	{
		this.mUpdateListener = callback;
	},

	stopUpdateListening: function()
	{
		delete this.mUpdateListener;
	},

	pauseUpdate: function(url)
	{
		this._pauseUpdateSendGen(Util.NormalizeUrl(url));
	},

	resumeUpdate: function(url)
	{
		this._resumeUpdateSendGen(Util.NormalizeUrl(url));
	},

	cancelUpdate: function(url)
	{
		this._cancelUpdateSendGen(Util.NormalizeUrl(url));
	},

	/**
	* Update an application at the specified URL.
	* @example Core.LocalGameList.updateGame(url, (function(err)
	*	{
	*		if (err)
	*		{
	*			NgLogE("GameHub error updating game! " + err);
	*			Network.Util.showSimpleNetworkError();
	*			this._loadingGame = false;
	*		}
	*		else
	*		{
	*			Core.LocalGameList.runGame(url);
	*		}
	*	});
	* @param {String} url The specified URL.
	* @param {Function} cb The callback function to pass in.
	*/
	
	updateGame: function( url , cb )
	{
		var reqId = this.mRefCount;
		this.mRefTable[this.mRefCount++] = cb;

		this._updateGameSendGen( Util.NormalizeUrl(url), reqId );
		return reqId;
	},
	
	/**
	* Launch an updated application from the specified URL.
	* @example Core.LocalGameList.runUpdatedGame('/games/MyGames');
	* @param {String} url The specified URL of an updated application.
	*/
	
	runUpdatedGame: function (url)
	{
		if (!url)
		{
			this._finishGame();
			return;
		}

		this.updateGame(url,
			(function(err)
			{
				if (err)
				{
					NgLogE("LGL Error updating game! " + err);
					Util.showFatalErrorDialog();
				}
				else
				{
					this.runGame(url);
				}
			}).bind(this)
		);
	},

	_updateProgressRecv: function( cmd )
	{
		var obj = {};
		this._updateProgressRecvGen(cmd, obj);
		if (this.mUpdateListener)
			this.mUpdateListener(obj.url, obj.cur, obj.total, obj.error);
	},

	_updateDoneRecv: function( cmd )
	{
		var obj = {};
		this._updateDoneRecvGen(cmd, obj);

		this._reloadGameList();

		var cb = this.mRefTable[obj.id];
		if (cb)
		{
			cb(obj.error);
		}

		delete this.mRefTable[obj.id];
		this._getRepoSpaceSendGen();
	},

	_repoSpaceRecv: function( cmd )
	{
		var obj = {};
		this._repoSpaceRecvGen(cmd, obj);
		this.mSpaceAvailable = obj.space - 7340032; // KJ report 7mb less
		console.log('LocalGameList.got response:', this.mSpaceAvailable, 'and need:', this.mRequiredAvailableSpace);
		
		if(this.mRequiredAvailableSpace > this.mSpaceAvailable)
		{
			var errorAlert = new UI.AlertDialog();
			errorAlert.setText(Core.Localization.getString("SD card is full"));
			errorAlert.setChoices([Core.Localization.getString("Exit")]);
			errorAlert.game = this.game;
			errorAlert.onchoice = function(ret)
			{
				errorAlert.hide();
				LifecycleEmitter.exitProcess();
			};
			errorAlert.show();
		}
		else
		{
			for(var i=0; i < this.mSpaceCB.length; ++i)
			{
				this.mSpaceCB[i]();
			}
			this.mSpaceCB = [];
			this.mRequiredAvailableSpace = 0;
		}
	},

	/**
	 * @private
	 */
	getGameList: function()
	{
		// Caveat! This will return an empty list if it is the first call. Must initialize beforehand.-KJ
		return this.mGameList;
	},

	/**
	 * @private
	 */
	updateGameList: function(list)
	{
		this.mGameList = list;
	},

	/**
	 * @private
	 */
	freeSpace: function(space, cb)
	{
		this.mRequiredAvailableSpace += space;
		
		this.mSpaceCB.push(cb);
		console.log('LocalGameList.freeSpace space=', this.mRequiredAvailableSpace);
		if(this.mSpaceCB.length == 1)
		{
			console.log('LocalGameList.sending request to native');
			// Send request to native if this is the first requester.
			this._getRepoSpaceSendGen();
		}
	},

	/**
	 * @private
	 */
	deleteGame: function(url)
	{
		url = Util.NormalizeUrl(url);
		var hash = toMD5(url);
		this._deleteGameSendGen(hash);

		var self = this;
		var doneCB = function ()
		{
			NgLogD("LocalGameList finished deleting game from " + self.mActiveGameKey + " for " + hash );
		};

		// Update cached game list to match what's going to happen in high-priv.
		// Matches logic in _LocalGameList._deleteGameFromStorage, but doesn't
		// write to Storage key.
		if( this.mGameList )
		{
			var list = this.mGameList;
			var good = false;
			var ind;
			var out = [];
			for(ind = 0; ind < list.length; ++ind)
			{
				if(list[ind].name == hash)
					good = true;
				else
					out.push(list[ind]);
			}

			if( good )
			{
				NgLogD("LocalGameList found and removed " + hash);
				this.mGameList = out;
			}
			else
				NgLogD("LocalGameList failed to find and remove " + hash);
		}
		else
			NgLogD("LocalGameList cache not warm, can't remove " + hash);
	},

	/**
	 * Check if an update is available for the specified application.<br><br>
	 * The following code illustrates how to retrieve an application name to pass in for this call.
	 * @param {String} game The specified game. Use <code>{@link Core.Capabilities.getGame}</code> to return the game name.
	 * @param {Function} callback The function to call once the check is complete.
	 * @example
	 *
	 * updateButton.onclick = function() {
	 *     LocalGameList.updateAvailable(Core.Capabilities.getUrl(), function(updated, spaceNeeded) {
	 *         if (updated)
	 *             LGL.runUpdatedGame(Core.Capabilities.getUrl());
	 *     });
	 * };
	 * @status
	 */
	updateAvailable: function(game, doneCB, errorCB)
	{
		var _int_LGL = require('NGCore/Client/Core/_int_LGL')._int_LGL;
		_int_LGL.updateAvailable(game, doneCB, errorCB);
	},

	_forwardException: function( exceptionString )
	{
		this.__forwardExceptionSendGen({exceptionString:exceptionString});
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device'] || {}; $MODULE_REGISTRY['NGCore/Client/Device'] = exports; /**
 * <p>Classes and objects contained by the Device module.</p>
 * @name Device
 * @namespace
 * @description <p>The Device module is a collection of classes that support the effect of physical movement on a device.
 * Each class instantiates a device singleton that emits when specific device conditions are met:</p>
 *<ul>
 *<li><code>{@link Device.KeyEmitter}</code>: A singleton object for emitting when the user presses or releases a device hardware key.</li>
 *<li><code>{@link Device.LifecycleEmitter}</code>: A singleton object for emitting when device lifecycle events occur.</li>
 *<li><code>{@link Device.LocationEmitter}</code>: A singleton object for emitting the geographic location of a device.</li>
 *<li><code>{@link Device.MemoryEmitter}</code>: A singleton object for emitting when low-memory states occur on a device.</li>
 *<li><code>{@link Device.MotionEmitter}</code>: A singleton object for emitting objects that collect spatial data from a device.</li>
 *<li><code>{@link Device.NetworkEmitter}</code>: A singleton object for emitting when a change in network status occurs for a device.</li>
 *<li><code>{@link Device.OrientationEmitter}</code>: A singleton object for emitting when a change to the physical orientation of the device occurs.</li>
 *<li><code>{@link Device.ShakeEmitter}</code>: A singleton object for emitting when the device detects a shake gesture.</li>
 *</ul>
 */
exports.Device = {};

exports.Device.__defineGetter__("LifecycleEmitter", function() {
	delete this.LifecycleEmitter;
	return this.LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;
});
exports.Device.__defineGetter__("LocationEmitter", function() {
	delete this.LocationEmitter;
	return this.LocationEmitter = require('NGCore/Client/Device/LocationEmitter').LocationEmitter;
});
exports.Device.__defineGetter__("MemoryEmitter", function() {
	delete this.MemoryEmitter;
	return this.MemoryEmitter = require('NGCore/Client/Device/MemoryEmitter').MemoryEmitter;
});
exports.Device.__defineGetter__("MotionEmitter", function() {
	delete this.MotionEmitter;
	return this.MotionEmitter = require('NGCore/Client/Device/MotionEmitter').MotionEmitter;
});
exports.Device.__defineGetter__("NetworkEmitter", function() {
	delete this.NetworkEmitter;
	return this.NetworkEmitter = require('NGCore/Client/Device/NetworkEmitter').NetworkEmitter;
});
exports.Device.__defineGetter__("OrientationEmitter", function() {
	delete this.OrientationEmitter;
	return this.OrientationEmitter = require('NGCore/Client/Device/OrientationEmitter').OrientationEmitter;
});
exports.Device.__defineGetter__("ShakeEmitter", function() {
	delete this.ShakeEmitter;
	return this.ShakeEmitter = require('NGCore/Client/Device/ShakeEmitter').ShakeEmitter;
});
exports.Device.__defineGetter__("KeyEmitter", function() {
	delete this.KeyEmitter;
	return this.KeyEmitter = require('NGCore/Client/Device/KeyEmitter').KeyEmitter;
});
exports.Device.__defineGetter__("PushNotificationEmitter", function() {
	delete this.PushNotificationEmitter;
	return this.PushNotificationEmitter = require('NGCore/Client/Device/_PushNotificationEmitter').PushNotificationEmitter;
});
exports.Device.__defineGetter__("InAppPurchaseEmitter", function() {
	delete this.InAppPurchaseEmitter;
	return this.InAppPurchaseEmitter = require('NGCore/Client/Device/_InAppPurchaseEmitter').InAppPurchaseEmitter;
});
exports.Device.__defineGetter__("InAppPurchase", function() {
	delete this.InAppPurchase;
	return this.InAppPurchase = require('NGCore/Client/Device/_InAppPurchase').InAppPurchase;
});
exports.Device.__defineGetter__("IPCEmitter", function() {
	delete this.IPCEmitter;
	return this.IPCEmitter = require('NGCore/Client/Device/IPCEmitter').IPCEmitter;
});
exports.Device.__defineGetter__("LayoutEmitter", function() {
	delete this.LayoutEmitter;
	return this.LayoutEmitter = require('NGCore/Client/Device/LayoutEmitter').LayoutEmitter;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core'] || {}; $MODULE_REGISTRY['NGCore/Client/Core'] = exports; /**
 * <p>Classes and objects contained by the Core module.</p>
 * @name Core
 * @namespace
 * @description <p>The Core module is a collection of classes that provide applications with access to:</p>
 * <ul>
 * <li>Core components of a device.</li>
 * <li>APIs that define a class-based structure for development.</li>
 * <li>Objects that support application updates.</li>
 * </ul>
 * <p>Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 * <li><code>{@link Core.Analytics}</code>: Construct objects that keep track of game-specific items that require analysis and counting.</li>
 * <li><code>{@link Core.Capabilities}</code>: A singleton object that contains data about device hardware components.</li>
 * <li><code>{@link Core.Class}</code>: Supports construction of objects and classes for use in OOP environments.</li>
 * <li><code>{@link Core.Color}</code>: Control the RGB color components of a device.</li>
 * <li><code>{@link Core.LocalGameList}</code>: Construct objects that manage a user's game list.</li>
 * <li><code>{@link Core.MessageEmitter}</code>: A base class object for constructing objects that emit application notifications.</li>
 * <li><code>{@link Core.MessageListener}</code>: A base class object for constructing objects that handle application notifications.</li>
 * <li><code>{@link Core.NativeAppLaunch}</code>: Construct objects for storing <code>intent</code> strings.</li>
 * <li><code>{@link Core.Point}</code>: Control the point values for <i>x</i> and <i>y</i> coordinates.</li>
 * <li><code>{@link Core.Rect}</code>: Construct rectangle objects.</li>
 * <li><code>{@link Core.Size}</code>: Control the values for <i>height</i> and <i>width</i> components.</li>
 * <li><code>{@link Core.Time}</code>: A singleton that contains data about device timing values.
 * <li><code>{@link Core.UpdateEmitter}</code>: Control the application update time rate.</li>
 * <li><code>{@link Core.Vector}</code>: Control the vector values for <i>x</i> and <i>y</i> coordinates.</li>
 * </ul>
 */
exports.Core = {};

exports.Core.__defineGetter__("Analytics", function() {
	delete this.Analytics;
	return this.Analytics = require('NGCore/Client/Core/Analytics').Analytics;
});
exports.Core.__defineGetter__("Base64", function() {
	delete this.Base64;
	return this.Base64 = require('NGCore/Client/Core/Base64').Base64;
});
exports.Core.__defineGetter__("Capabilities", function() {
	delete this.Capabilities;
	return this.Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
});
exports.Core.__defineGetter__("Class", function() {
	delete this.Class;
	return this.Class = require('NGCore/Client/Core/Class').Class;
});
exports.Core.__defineGetter__("Color", function() {
	delete this.Color;
	return this.Color = require('NGCore/Client/Core/Color').Color;
});
exports.Core.__defineGetter__("Vector", function() {
	delete this.Vector;
	return this.Vector = require('NGCore/Client/Core/Vector').Vector;
});
exports.Core.__defineGetter__("Point", function() {
	delete this.Point;
	return this.Point = require('NGCore/Client/Core/Point').Point;
});
exports.Core.__defineGetter__("Size", function() {
	delete this.Size;
	return this.Size = require('NGCore/Client/Core/Size').Size;
});
exports.Core.__defineGetter__("Rect", function() {
	delete this.Rect;
	return this.Rect = require('NGCore/Client/Core/Rect').Rect;
});
exports.Core.__defineGetter__("MessageEmitter", function() {
	delete this.MessageEmitter;
	return this.MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
});
exports.Core.__defineGetter__("MessageListener", function() {
	delete this.MessageListener;
	return this.MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
});
exports.Core.__defineGetter__("ObjectRegistry", function() {
	delete this.ObjectRegistry;
	return this.ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
});
exports.Core.__defineGetter__("Time", function() {
	delete this.Time;
	return this.Time = require('NGCore/Client/Core/Time').Time;
});
exports.Core.__defineGetter__("toMD5", function() {
	delete this.toMD5;
	return this.toMD5 = require('NGCore/Client/Core/toMD5').toMD5;
});
exports.Core.__defineGetter__("SHA1", function() {
	delete this.SHA1;
	return this.SHA1 = require('NGCore/Client/Core/SHA1').SHA1;
});
exports.Core.__defineGetter__("UpdateEmitter", function() {
	delete this.UpdateEmitter;
	return this.UpdateEmitter = require('NGCore/Client/Core/UpdateEmitter').UpdateEmitter;
});
exports.Core.__defineGetter__("Proc", function() {
	delete this.Proc;
	return this.Proc = require('NGCore/Client/Core/Proc').Proc;
});
exports.Core.__defineGetter__("Logger", function() {
	delete this.Logger;
	return this.Logger = require('NGCore/Client/Core/Logger').Logger;
});
exports.Core.__defineGetter__("LocalGameList", function() {
	delete this.LocalGameList;
	return this.LocalGameList = require('NGCore/Client/Core/LocalGameList').LocalGameList;
});
exports.Core.__defineGetter__("Localization", function() {
	delete this.Localization;
	return this.Localization = require('NGCore/Client/Core/Localization').Localization;
});
exports.Core.__defineGetter__("_LocalGameList", function() {
	delete this._LocalGameList;
	return this._LocalGameList = require('NGCore/Client/Core/_LocalGameList')._LocalGameList;
});
exports.Core.__defineGetter__("NativeAppLaunch", function() {
	delete this.NativeAppLaunch;
	return this.NativeAppLaunch = require('NGCore/Client/Core/NativeAppLaunch').NativeAppLaunch;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Capabilities'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Capabilities'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Capabilities'] = exports; 	////////////////////////////////////////////////////////////////////////////////
// Class Capabilities
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Proc = require('NGCore/Client/Core/Proc').Proc;

////////////////////////////////////////////////////////////////////////////////

exports.Capabilities = Class.singleton(
/** @lends Core.Capabilities.prototype */
{
	classname: 'Capabilities',
	_configFile: 'configuration.json',

	/**
	 * @class The <code>Capabilities</code> class constructs a singleton object that contains device properties. These objects represent the device and provide access to device information. 
	 * This class also provides information about how a device and game servers communicate.
	 * <br><br>
	 * <b>Note:</b> An application should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

        // Please keep this on one line, sed won't update otherwise
		this._fields = {version: 'sdks_1.3-20110930-1.3.2', buildDate: '20110930', buildHash: 'ge2bd659'};
	},

	_getConfigFile:			function() {return this._configFile;},
	_isGameLoaded:			function() {return this._fields._gamePreLoaded;},
	_getAccts:				function() {return this._fields._accts;},

	meetsBinaryVersion: function(desiredVersion)
	{
		var binary = this.getBinaryVersion().split('-').pop().split('.');
		var desired = desiredVersion.split('.');

		// A shorter length means a lower version (if all other items match)
		var meets = binary.length >= desired.length;
		var len = Math.min(desired.length, binary.length);
		for (var i = 0; i < len; ++i)
		{
			var bin = Number(binary[i]);
			var des = Number(desired[i]);
			if (bin != des)
			{
				meets = bin > des;
				break;
			}
		}
		return meets;
	},

	/**
	 * Return the object stored in configuration.json for your game.
	 * @returns {Object} The JSON.parsed object represented in your configuration.json file.
	 * @type Object
	 * @status
	 */
	getConfigs:			function() {return this._configuration;},

	/**
	 * Return the SDK version number from the <code>Capabilities</code> of this device.
	 * @returns {String} The version of the SDK on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSDKVersion:           function() { return this._fields.version; },

	/**
	 * Return the build date for the currently installed SDK. The build date is in the format <i>YYYYMMDD</i>.
	 * @returns {String} The build date for the SDK on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSDKBuildDate:           function() { return this._fields.buildDate; },
	
	/**
	 * Return the build hash of the currently installed SDK.
	 * @returns {String} The build hash for the SDK on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSDKBuildHash:           function() { return this._fields.buildHash; },

	/**
	 * Return the version of the currently running ngCore binary
	 * @returns {String} The version of ngCore running
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBinaryVersion:           function() { return this._fields.binaryVersion; },

	/**
	 * Return the build date for the currently running ngCore binary. The build date is in the format <i>YYYYMMDD</i>.
	 * @returns {String} The build date for the ngCore binary
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBinaryBuildDate:           function() { return this._fields.binaryBuildDate; },

	/**
	 * Return the build hash of the currently running ngCore binary
	 * @returns {String} The build hash for the ngCore binary
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBinaryBuildHash:           function() { return this._fields.binaryBuildHash; },
	
	/**
	 * Return the device ID. 
	 * @returns {String} The device ID for the device running the application.
	 * @type String
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getUniqueId:           function() { return this._fields.uniqueId; },

	/**
	 * Return the lifetime constant value of the device.<br><br>
	 * <b>Note:</b> Currently only available on Android.
	 * @returns {String} <code>Settings.Secure.ANDROID_ID</code>: A 64-bit number as a hex string randomly generated on first boot of the device. 
	 * <b>Note:</b> This value only changes when the device is reset.
	 * @status Android
	 */
	getLifetimeName: function() { return this._fields.lifetimeName; },
	
	/**
	 * Return the device name.
	 * @returns {String} The device name for the device running the application.
	 * @type String
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getDeviceName:         function() { return this._fields.deviceName; },
	
	/**
	 * Return the operating system.
	 * @returns {String} The operating system of the device running the application.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPlatformOS:         function() { return this._fields.platformOs; },
	
	/**
	 * Return the operating system version number.
	 * @returns {String} The version number of the operating system running on the device.
	 * @type String
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPlatformOSVersion:  function() { return this._fields.platformOsVersion; },
	
	/**
	 * Return the device hardware type.
	 * @returns {String} The type of device hardware running the application.
	 * @type String
	 * @status iOS, Flash, Test, iOSTested, AndroidTested
	 */
	getPlatformHW:         function() { return this._fields.platformHw; },
	
	/**
	 * Return the total amount of installed memory.
	 * @returns {Number} The amount of installed memory on the device running the application.
	 * @type Number
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPhysicalMem:        function() { return this._fields.physicalMem; },
	
	/**
	 * Return the total number of installed CPUs.
	 * @returns {Number} The number of CPUs installed on the device running the application.
	 * @type Number
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getPhysicalCpus:       function() { return this._fields.physicalCpus; },
	
	/**
	 * Return the number of active CPUs.
	 * @returns {Number} The number of active CPUs on the device running the application.
	 * @type Number
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getActiveCpus:         function() { return this._fields.activeCpus; },
	
	/**
	 * Return the installed user language. 
	 * @returns {String} The installed user language on the device running the application.
	 * Expressed as a canonicalized IETF BCP 47 language identifier.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLanguage:         function() { return this._fields.language; },

	_getBoot:         function() { return this._fields.boot; },
	_getBootServer:         function() { return this._fields.bootServer; },

	/**
	 * Return the URL for the content of this application.
	 * @returns {String} The URL to content for this application.
	 * @status
	 */
	getContentUrl:			function() {return this._fields.contentUrl;},

	/**
	 * Return the name of the root application. Root application refers to the application that launches when the user taps the application icon.
	 * @returns {String} The directory name for the root application.
	 * @status
	 */
	getBootGame:         function() { return this._fields.bootgame; },

	/**
	 * Return the starting server for an application.
	 * @returns {String} The start server.
	 * @type String
	 * @status
	 */
	getStartingServer:         function() { return this._fields.startingServer; },

	/**
	 * Return the name of the application bundled with the binary of this build.
	 * @returns {String} The name of the bundled game.
	 * @type String
	 * @status
	 */
	getBundleGame:         function() { return this._fields.bundleGame; },

	/**
	 * Return the server bundled with the binary of this build.
	 * @returns {String} The bundle server.
	 * @type String
	 * @status
	 */
	getBundleServer:         function() { return this._fields.bundleServer; },

	/**
	 * Return the bundle identifier for the binary of this build.
	 * @returns {String} The bundle identifier.
	 * @type String
	 * @status
	 */
	getBundleIdentifier:         function() { return this._fields.bundleIdentifier; },
	
	/**
	 * Return the directory name of the currently running application.
	 * @returns {String} The current folder name for the application.
	 * @type String
	 * @status iOS, Android, Flash
	 */
	getGame:         function() { return this._fields.game; },

	/**
	 * Return the server from which an application was downloaded.
	 * @returns {String} The download server.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getServer:         function() { return this._fields.server; },

	/**
	 * Return the full URL for the current application.
	 * @returns {String} The URL from which a application is downloaded.
	 * @type String
	 * @status
	 */
	getUrl:         function() { return this._fields.url; },

	/**
	 * Return the logical screen width for this device.
	 * @returns {Number} The current screen width of the device.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getScreenWidth:        function() { return this._fields.screenWidth; },
	
	/**
	 * Return the logical screen height for this device.
	 * @returns {Number} The current screen height of the device.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getScreenHeight:       function() { return this._fields.screenHeight; },
	
	/**
	 * Return a reasonable factor for scaling logical coordinates to the current display.
	 * @returns {Number} Logically scaled screen units for the device.
	 * @type Number
	 * @status
	 */
	getScreenUnits:        function() { return this._fields.screenUnits; },
	
	/**
	 * Return the number of physical pixels associated with one unit of logical space.
	 * @returns {Number} The total number of pixels that equal one screen unit.
	 * @type Number
	 * @status
	 */
	getScreenPixelUnits:       function() { return this._fields.screenPixelUnits; },
	
	/**
	 * Return the maximum number of supported textures.
	 * @returns {Number} The maximum number of supported textures per coordinate (<i>x</i>,<i>y</i>).
	 * @type Number
	 * @status Test, iOSTested, AndroidTested
	 */
	getMaxTextureSize:     function() { return this._fields.maxTextureSize; },
	
	/**
	 * Return the maximum number of supported texture units.
	 * @returns {Number} The maximum number of supported texture units per coordinate (<i>x</i>,<i>y</i>).
	 * @type Number
	 * @status Test, iOSTested, AndroidTested
	 */
	getMaxTextureUnits:    function() { return this._fields.maxTextureUnits; },
	
	/**
	 * @deprecated Replaced by {@link UI.GLView#getGLExtensions}.
	 */
	getOglExtensions:      function()
	{
		if (this._fields.oglExtensions)
			return this._fields.oglExtensions;

		// This table should stay in sync with:
		// https://spreadsheets.google.com/a/ngmoco.com/spreadsheet/ccc?key=0AinqDSqLOjJtdDMwNGk0eDgtRFdvQ2N0eWRUcGlsc0E&hl=en_US&authkey=CMWLyoAC
		switch (this._fields.deviceName)
		{
			case "Droid":                // Motorola Droid
			case "DROID2":               // Motorola Droid 2
			case "DROIDX":               // Motorola Droid X
			case "SGH-T959":             // Samsung Galaxy S 19000 8GB
			case "SGH-T959V":            // Samsung Galaxy S 4G
			case "SAMSUNG-SGH-I997":     // Samsung Galaxy S2
			case "SAMSUNG-SGH-I897":     // Samsung Captivate
			case "Nexus S":              // Google Nexus S
				return ["GL_IMG_texture_compression_pvrtc"];
			case "HTC Desire":           // HTC Desire GSM
			case "PC36100":              // HTC Evo 4G
			case "ADR6300":              // HTC Droid Incredible
			case "001HT":                // HTC Desire HD
			case "Nexus One":            // Google Nexus One
			case "HTC Glacier":          // HTC myTouch 4G
				return ["GL_AMD_compressed_ATC_texture"];
			default:
				return [];
		}
	},

	/**
	 * Return the directory path to the temp directory for this device.
	 * @returns {String} The directory path to the temp directory on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTmpDir:           function() { return this._fields.tmpDir; },

	/**
	 * Check the <code>Capabilities</code> of this device for an accelerometer.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains an accelerometer.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasAccel:           function() { return this._fields.hasAccel; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a gyroscope.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains an gyroscope.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasGyro:            function() { return this._fields.hasGyro; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for touchscreen input support.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application supports touchscreen input.
	 * @type Boolean
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getHasTouch:           function() { return this._fields.hasTouch; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for multi-touch input support.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application supports multi-touch input.
	 * @type Boolean
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getHasMultiTouch:      function() { return this._fields.hasMultiTouch; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a GPS unit.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a GPS unit.
	 * @type Boolean
	 * @status Android, Test, iOSTested, AndroidTested
	 */
	getHasGps:             function() { return this._fields.hasGps; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a magnetic compass.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a magnetic compass.
	 * @type Boolean
	 * @status Android, Test, iOSTested, AndroidTested
	 */
	getHasCompass:         function() { return this._fields.hasCompass; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a hardware keyboard.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a hardware keyboard.
	 * @type Boolean
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHasHwKeyboard:      function() { return this._fields.hasHwKeyboard; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a <b>Back</b> button.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a <b>Back</b> button.
	 * @status
	 */
	getHasBackButton:      function() { return this._fields.hasBackButton; },

	/**
	 * Check the <code>Capabilities</code> of this device for a camera.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a camera.
	 * @type Boolean
	 * @status Test, iOSTested, AndroidTested
	 */
	getHasCamera:          function() { return this._fields.hasCamera; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for access to a wide area network (WAN).
	 * @returns {Boolean} Returns <code>true</code> when the device running the application has access to a WAN.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasWwan:            function() { return this._fields.hasWwan; },

	/**
	 * Check the <code>Capabilities</code> of this device for access to a Wi-Fi network.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application has access to Wi-Fi.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasWifi:            function() { return this._fields.hasWifi; },

	/**
	 * Check the <code>Capabilities</code> of this device for access to a Wi-Fi network.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application has access to Wi-Fi.
	 * @status
	 */
	getCarrier:            function() { return this._fields.carrier; },

	/**
	 * Return the URL used to launch this application.
	 * @returns {String} The URL for launching this application. If the application is not launched from a URL, returns an empty string.
	 * @type String
	 * @status
	 */
	getIntentUrl:            function() { return this._fields.intentUrl; },
	
	/**
	 * Return the height of the system status bar.
	 * @returns {Number} The status bar height rounded to the nearest integer (in pixels).
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 * @status Android
	*/
     getStatusBarHeight:            function() { return this._fields.statusBarHeight; },
	
	/**
	 * Return the device locale.
	 * @returns {String} The regional location of a device.
	 * The <code>locale</code> string is a combination of ISO 639-1 and ISO 3166-1. For example, <code>en_US</code>, <code>ja_JP</code>.
	 * @type String
	 * @status
	 */
	getLocale: function() { return this._fields.locale; },

	/**
	 * Return a list of installed fonts on this device.
	 * @returns {Array (Strings)} An array of font names installed on the system or addressable by name.
	 * @type Array
	 * @status iOS, Android
	 */
	getAvailableFonts: function()
	{
		return this._deserializedFonts || (this._deserializedFonts = JSON.parse(this._fields.availableFonts));
	},
	
	/** @private */
	getAutorotateDisabled: function()
	{
		return this._fields.autorotateDisabled || false;
	},
	

	/**
	 * Return the social server used for this application.
	 * @returns {String} The social server URL. For example, partner.plusplus.com.
	 * @status
	 */	
	getSocialServer: function()
	{
		return this.socialServer;
	},

	/*
	 * Returns the name of the Mobage distribution first installed on the device.
	 * @returns {String} The name of the distribution.
	 */
	getDistributionName: function() 
	{
		return this._fields.distributionName;
	},

	/*
	 * @status
	 */	
	getSourceAppID: function()
	{
		return this._fields.sourceAppID;
	},

	/*
	 * @status Android
	 */	
	getAppSignatures: function()
	{
		return this._fields.appSignatures;
	},
	
	/*
	 * Return the release version of this application.  The value comes directly from the 
	 * configuration.json value for releaseVersion.
	 * @returns {String} The version identifier. For example, 1.1:20110607183748_blf7gety.
	 * @status
	 */
	getAppReleaseVersion: function()
	{
		return this._releaseVersion;
	},
	
	
	/** @private */
	_init: function(dict)
	{
		// parse the dict
		var ifields = [];
		NgParseCommandDictionary(dict, 2, this._fields, ifields);

		try {
			// Change server based on URL passed in
			var items = /(https?:\/\/.+?)\/(.*)/.exec(this._fields.url);
			this._fields.server = items[1];
			this._fields.game  = items[2];
		}
		catch (e)
		{
			NgLogException(e);
		}

		// KJ this is necessary because an empty string passed becomes undefined
		if (!this._fields.intentUrl)
			this._fields.intentUrl = "";

		if (this._fields.oglExtensions)
		try
		{
			this._fields.oglExtensions = JSON.parse(this._fields.oglExtensions);
		}
		catch (e)
		{
			NgLogE("Unable to parse OGL Extensions! " + this._fields.oglExtensions);
			NgLogException(e);
		}

		if (this._fields._accts)
		try
		{
			this._fields._accts = JSON.parse(this._fields._accts);
		}
		catch (e)
		{
			NgLogE("Unable to parse Accounts! " + this._fields._accts);
			NgLogException(e);
		}

		try
		{
			this._configuration = JSON.parse(this._fields.configJSON);
			this._fields.contentUrl = this._configuration.contentUrl;
			this.socialServer = this._configuration.socialServer;
			this._releaseVersion = this._configuration.releaseVersion;
		}
		catch (e)
		{
			NgLogE("Unable to parse config!! (" + this._fields.configJSON + ")");
			NgLogException(e);
		}

		console.log( "dict : JS version : " + this.getSDKVersion() );
		console.log( "dict : JS build date : " + this.getSDKBuildDate() );
		console.log( "dict : JS build hash : " + this.getSDKBuildHash() );

		console.log("dict : contentUrl : " + this._fields.contentUrl);
		console.log("dict : socialServer : " + this.socialServer);
		console.log("dict : releaseVersion : " + this._releaseVersion);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 301
	// Method create = -1
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Capabilities._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Capabilities._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[301] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":301,-1," + __objectRegistryId  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	

// {{/Wg Generated Code}}
	// This kills the JSLint error for trailing comma (since we can't change the generated code)
	t: 0
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Localization'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Localization'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Localization'] = exports; var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var FileSystem = require('NGCore/Client/Storage/FileSystem').FileSystem;

var LocalizationEngine = exports.LocalizationEngine = MessageEmitter.subclass(
/** @lends Core.Localization.prototype */
{
	classname: 'Localization',
    
    /**
     * Specifies the directory path to language files this object will load.
     */
    directoryPath:null,
    
    /**
     * Specifies the directory path to a language file for a specific language.
     */
	languageFilePath:null,
    
	/**
	 * @class The <code>Localization</code> class provides applications with access to localized strings.
	 * Applications supply a language code corresponding to a file in <code>Content/Localization/</code> or a JSON object.<br><br> 
     * Loading of dictionary files is an anynchronous process. Applications need to listen for emitted notifications from <code>Localization</code> objects that signal when the language dictionary
     * is modified. When a <code>Localization</code> object emits a notification, localized strings are available to the application (see <code>{@link Core.MessageEmitter#emit}</code>).
	 * @constructs The default constructor.
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Flash
	 */
	initialize: function(directoryPath)
	{
		if(!directoryPath){directoryPath = "./Content/Localization/";}
	    NgLogD("Localization : init ("+directoryPath+")");
	    this.directoryPath = directoryPath;
	    
        this.setLanguage(Capabilities.getLanguage());
	},
    
	/**
	 * Aynchronously load the localization dictionary for the specified language.
     * <br><br>
	 * <b>Notes:</b> 
	 * <ul>
	 * <li>This function looks for the corresponding JSON dictionary file in the <code>Content/Localization</code> directory.
     * For example, <code>Content/Localization/fr.json</code>. If the application cannot load a dictionary, this call has no effect.</li>
     * <li><code>Localization</code> objects emit a notification with the new language string if this call succeeds.</li>
     *</ul>
	 *
	 * @example
	 * Core.Localization.addListener(listener, function()
     * {
     *     listener.label.setText(Core.Localization.getString("Hello World"));
     * });
	 * Core.Localization.setLanguage('es');
	 *
	 * @param {String} language The base name of a JSON dictionary file in <code>./Content/Language</code>.
	 * @see Core.Localization#setDictionary, 
	 * @see Core.MessageListener
	 * @status
	 */    
    setLanguage: function(language)
    {
        var dictionaryPath = this.languageFilePath = this.directoryPath + language + '.json';
        var self = this;
        NgLogD("Localization : reading json file "+ dictionaryPath);
        
		FileSystem.readFile(dictionaryPath, function(error, data)
        {
            if(error === '')
            {
                NgLogD("Localization : successfully read json file "+ dictionaryPath);  
                self.setDictionary(language, JSON.parse(data));
            }
            else
            {
                NgLogD("Localization: unable to read json file "+ dictionaryPath + ", use default english setting instead");                
            }
        });
    },

	/**
	 * Directly set the language code and localization dictionary.
     * <code>Localization</code> objects emit a message with the new language string during this call.
	 * 
	 * @example
     * var chDictionary =    
     * {
     *     "Hello World": "你好世界"
     * };
	 * Core.Localization.setDictionary('ch', chDictionary);
	 * label.setText(Core.Localization.getString("Hello World"));
	 *
	 * @param {String} language A string identifying the specified language or localization.
	 * @param {Object} dictionary An object containing key/value pairs for the specified language.
	 * @see Core.Localization#setLanguage,
	 * @see Core.MessageEmitter#emit
	 * @status
	 */    
    setDictionary: function(lang, dictionary)
    {
        this._lang = lang;
        this._dictionary = dictionary;
        this.emit(this._lang);
    },    
    
    /**
	 * Retrieve a localized string.
     * @param {String} str A localization key.
	 * @returns {String} The localized string or the provided key if the application is unable to lcoate the specified string.
	 * @status
	 */
	getString: function(str)
	{        
        if(this._dictionary && typeof this._dictionary === 'object')
        {
            var value = this._dictionary[str];
            if(value && typeof value !== 'undefined')
            {
                return value;
            }
        }
        
        return this.unknownString(str);
	},
	
	/** @protected */
	unknownString:function(str){
		NgLogD("Localization: ... No localization for "+str+" in "+this._lang);
		return str;
	}
});

/**
 * Global Localization Singleton, gets initialized when the device locale is known.
 */
exports.Localization = LocalizationEngine.singleton({});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Storage'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Storage'] || {}; $MODULE_REGISTRY['NGCore/Client/Storage'] = exports; /**
 * <p>Classes and objects contained by the Storage module.</p>
 * @name Storage
 * @namespace
 * @description <p>The Storage module is a collection of classes that support file manipulation operations.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 *  <li><code>{@link Storage.FileSystem}</code>: Construct objects for reading a file, writing to a file, deleting a file, or decompressing a file.</li>
 *  <li><code>{@link Storage.KeyValue}</code>: Construct objects that store key/value pairs.</li>
 * </ul>
 * <b>Note:</b> The static method <code>KeyValueCache.global()</code> creates a <code>KeyValueCache</code> object that multiple applications can use. 
 * @param {String} globalKey The module name for the <code>KeyValueCache</code> object. The <code>global()</code> method creates a new <code>KeyValueCache</code> 
 * when the module with that name doesn't already exist.
 */
var Storage = exports.Storage = {};

Storage.__defineGetter__("KeyValue", function() {
	delete this.KeyValue;
	return this.KeyValue = require('NGCore/Client/Storage/KeyValue').KeyValue;
});
Storage.__defineGetter__("KeyValueCache", function() {
	delete this.KeyValueCache;
	return this.KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
});
Storage.__defineGetter__("FileSystem", function() {
	delete this.FileSystem;
	return this.FileSystem = require('NGCore/Client/Storage/FileSystem').FileSystem;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Logger'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Logger'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Logger'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var sprintf = require('NGCore/Shared/Lib/sprintf').sprintf;
var Base64 = require('NGCore/Client/Core/Base64').Base64;

var Logger = Class.singleton(
/** @lends Core.Logger.prototype */
{
	classname: 'Logger',

	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/** @private */
	_disable: function()
	{
		console.log("Logger : javascript logging disabled");
		console.log = Logger.log = function(message, argv) {};
	},

	_enable: function()
	{
		console.log = Logger.log = function(message, argv)
		{
			if (arguments.length > 1) {
				try {
					var params = new Array();
					for (var i = 0; i < arguments.length; ++i) {
						params[i] = arguments[i];
					}
					var result = sprintf(params);
					params.unshift(result);
					message = params.join(" ");
				} catch (err) {
					var concat = new Array();
					for (var i = 0; i < arguments.length; ++i) {
						concat[i] = arguments[i];
					}
					message = concat.join(" ");
				}
			}
			__underscore_SysLog(message);
		};

		console.log("Logger : javascript logging enabled");
	},

	/**
	 * Log a message to the development console.
	 * @param {string} message
	 * @param {Array} argv Additional arguments to log.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	log: function(message, argv)
	{
		
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 305
	// Method create = -1
	// Method log = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Logger._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Logger._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[305] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":305,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_logSendGen: function( msg )
	{
		Proc.appendToCommandString( ":305,2," + this.__objectRegistryId + "," + Base64.encode( msg )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// log: function( msg ) {}
	

// {{/Wg Generated Code}}
	
});

Logger.instantiate();

__underscore_SysLog = function(_massage)
{
	Logger._logSendGen( _massage );
};

// JMarr Don't override console.log when on flash.
if(typeof(_NG_TARGET_FLASH) == 'undefined')
	console.log = Logger.log;

exports.Logger = Logger;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Class'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Class'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Class'] = exports; exports.Class = require('NGCore/Shared/Class').Class;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Base64'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Base64'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Base64'] = exports; exports.Base64 = require('NGCore/Shared/Lib/base64').Base64;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Plus/ResultSet'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Plus/ResultSet'] || {}; $MODULE_REGISTRY['NGCore/Client/Plus/ResultSet'] = exports; var ClassReq = require('NGCore/Client/Core/Class');
var SystemBindingReq = require('NGCore/Client/UI/SystemBinding');

var ResultSet = ClassReq.Class.subclass({
    classname: "ResultSet",
    initialize: function(continueId) {
        this.items = [];
        this._continueId = continueId;
        this.totalLength = Number.MAX_VALUE;
    },
    /*
	 * Call to getMore adds more items to items list.
	 * Please note that in the callback, it is possible that addedCount == 0
	 * in some cases.  In that case access to items[newIdx] does not yield
	 * any result
	 */
    getMore: function(cb) {
        return SystemBindingReq.SystemBinding._getMoreContacts(this, cb);
    },
    /*
	 * Releases resource used by current ResultSet.
	 *
	 * To avoid resource leakage, please call closeResultSet if getMore
	 * is not called all the way to the end.
	 */
    closeResultSet: function() {
        SystemBindingReq.SystemBinding._closeContactsResultSet(this);
    }
});

exports.ResultSet = ResultSet;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Class'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Class'] || {}; $MODULE_REGISTRY['NGCore/Shared/Class'] = exports; /**
 * The default constructor.
 * @constructor 
 * @class The <code>Class</code> object provides an environment for Object Oriented Programming (OOP) development in Javascript, such as Java or C++.
 * @name Core.Class
 */
var Class = function() {}
exports.Class = Class;

/**
 * Create a new class by extending another class.
 * @example
 * var MyClass = Class.subclass(
 * {
 *    initialize: function()
 *    {
 *        console.log('constructor');
 *    },
 *    foo: function(v)
 *    {
 *        console.log('MyClass.foo(' + v + ')');
 *    },
 * });
 * var myClass = new MyClass();
 * myClass.foo('param');
 * @param {Object} extensions Object literal containing new functions for the derived class.
 * @function
 * @name Core.Class.subclass
 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
 */
Class.subclass = (function()
{
/**#@+ @ignore */
	// Parse a function body and extract the parameter names.
	function argumentNames(body)
	{
		var names = body.toString().match(/^[\s\(]*function[^(]*\(([^)]*)\)/)[1]
			.replace(/\/\/.*?[\r\n]|\/\*(?:.|[\r\n])*?\*\//g, '')
			.replace(/\s+/g, '').split(',');
		return names.length == 1 && !names[0] ? [] : names;
	}
	
	// Create a function that calls overrideBody with a closure to ancestorBody.
	function overrideMethod(overrideBody, ancestorBody)
	{
		if(ancestorBody !== undefined)
		{
			// Create a function that calls overrideBody with a closure to ancestorBody as the first param.
			var override = function()
			{
				var localThis = this;
				var $super = function() { return ancestorBody.apply(localThis, arguments) };
				Array.prototype.unshift.call(arguments, $super);
				return overrideBody.apply(this, arguments);
			}
		}
		else
		{
			// Create a function that calls overrideBody with undefined as the first param, because ancestorBody is undefined.
			var override = function()
			{
				Array.prototype.unshift.call(arguments, undefined);
				return overrideBody.apply(this, arguments);
			}
		}

		// Hide our dirty tricks from the rest of the world.
		override.valueOf = function() { return overrideBody.valueOf() };
		override.toString = function() { return overrideBody.toString() };
		return override;
	}
	
	// Define some empty functions used later. This is a speed optimization.
	function TempClass() {}
	function emptyFunction() {}
	
	return function()
	{
		// Constructor for new class to be created.
		var properties = arguments[0];
		var classname = properties.classname || "AnonymousClass";
		var NewClass = eval('(function ' + classname + '(){this.initialize.apply(this, arguments)})');
		
		// Copy statics from this.
		for(var property in this)
		{
			if(!this.hasOwnProperty(property)) continue;
			NewClass[property] = this[property];
		}
		
		// Copy prototype from this.
		var ancestorPrototype = this.prototype;
		TempClass.prototype = ancestorPrototype;
		NewClass.prototype = new TempClass();
		NewClass.prototype.superclass = ancestorPrototype;
		NewClass.prototype.constructor = NewClass;
		
		// Copy properties into NewClass prototype.
		for(var property in properties)
		{
			if(!properties.hasOwnProperty(property)) continue;

			// getters / setters behave differently than normal properties.
			var getter = properties.__lookupGetter__(property)
			var setter = properties.__lookupSetter__(property)
			if(getter || setter)
			{
				if(getter)
				{
					// Copy getter into klass.
					var value = getter;
					if(argumentNames(value)[0] == "$super")
						value = overrideMethod(value, ancestorPrototype.__lookupGetter__(property));
					NewClass.prototype.__defineGetter__(property, value);
				}

				if(setter)
				{
					// Copy setter into klass.
					var value = setter;
					if(argumentNames(value)[0] == "$super")
						value = overrideMethod(value, ancestorPrototype.__lookupSetter__(property));
					NewClass.prototype.__defineSetter__(property, value);
				}
			}
			else
			{
				var value = properties[property];
				if(typeof value === "function" && property[0] != '$')
				{
					if(argumentNames(value)[0] == "$super")
					{
						// Create override method if first param is $super.
						value = overrideMethod(value, ancestorPrototype[property]);
					}
					else if(property == 'initialize')
					{
						var ancestorInitialize = ancestorPrototype.initialize
						if(ancestorInitialize)
						{
							// Automatically call inherited constructor.
							var derivedInitialize = value;
							value = function()
							{
								ancestorInitialize.apply(this, arguments);
								derivedInitialize.apply(this, arguments);
							};
						}
					}
					else if(property == 'destroy')
					{
						var ancestorDestroy = ancestorPrototype.destroy
						if(ancestorDestroy)
						{
							// Automatically call inherited destructor.
							var derivedDestroy = value;
							value = function()
							{
								derivedDestroy.apply(this, arguments);
								ancestorDestroy.apply(this, arguments);
							};
						}
					}

					// Copy function into new class prototype.
					NewClass.prototype[property] = value;
				}
				else
				{
					if(property[0] == '$')
						property = property.slice(1);

					// Copy enum into new class and the prototype.
					NewClass[property] = value;
					NewClass.prototype[property] = value;
				}
			}
		}
		
		// Make sure the is an initialize function.
		if(!NewClass.prototype.initialize)
			NewClass.prototype.initialize = emptyFunction;

		return NewClass;
	}
/**#@-*/
})();

/**
 * Create a singleton by extending a class.
 * @example
 * var MySingleton = Class.singleton(
 * {
 *    initialize: function()
 *    {
 *        console.log('constructor');
 *    },
 *    foo: function(v)
 *    {
 *        console.log('MyClass.foo(' + v + ')');
 *    },
 * });
 * MySingleton.foo('param');
 * @param {Object} extensions Object literal containing new functions for the singleton.
 * @function
 * @name Core.Class.singleton
 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
 */
Class.singleton = function()
{
	// Create sublcass as normal.
	var tempClass = this.subclass.apply(this, arguments);
	
	// Hide the initialize.
	var initialize = tempClass.prototype.initialize;
	tempClass.prototype.initialize = function() {};
	
	// Now instantiate.
	var instance = new tempClass();
	
	// Hide every prototype function with an instance function that calls initialize.
	var functions = [];
	/** 
	 * Ensure that the singleton has been created and fully initialized.
	 * @status iOS, Android, Flash
	*/
	var instantiate = function(real)
	{
		// Delete all of the instance functions we added.
		for(var i in functions)
		{
			var func = functions[i];
			delete instance[func];
		}
		
		// Restore the initialize function and call it.
		instance.initialize = initialize;
		instance.initialize();
		
		// Replace instantiate method with an empty function.
		instance.instantiate = function() {};
		
		// Call the function that caused this instantiation.
		var args = Array.prototype.slice.call(arguments, 1);
		return real.apply(instance, args);
	}
	
	// Iterate over all prototype functions.
	for(var i in instance)
	{
		// Don't do anything for setters or getters.
		if(instance.__lookupGetter__(i)
			|| instance.__lookupSetter__(i))
		{
			//TODO Should put proxies here too.
			continue;
		}
			
		var value = instance[i];
		if(typeof(value) == 'function')
		{
			// Remember the function names that we added so that instantiate() can remove them.
			functions.push(i);
			
			// Add an instance function to hide the prototype function, which will call instantiate.
			instance[i] = instantiate.bind(this, value);
		}
	}
	
	// Add instantiate method.
	instance.instantiate = instantiate.bind(this, function() {});
	
	// Return the isntance.
	return instance;
}

/**
 * @ignore
 */
Class.prototype.bind = function(func)
{
	var context = this;
	if(arguments.length < 2)
	{
		// Fast path if only the 'this' pointer is being bound.
		return function()
		{
			return func.apply(context, arguments);
		}
	}
	else
	{
		// Slower path if additional parameters are being bound.
		var args = Array.prototype.slice.call(arguments, 1);
		return function()
		{
			var finalArgs = args.concat(Array.prototype.slice.call(arguments, 0));
			return func.apply(context, finalArgs);
		}
	}
}

/**
 * @ignore
 */
Class.prototype.toString = function()
{
	return this.constructor.name;
}

// Debug implementation that will replace every method in destroyed objects with a grenade.
/*Class.prototype.destroy = function()
{
	function suicide()
	{
		throw new Error('Function called on destroyed object');
	}
	
	for(var i in this)
	{
		var value = this[i];
		if(typeof(value) == 'function')
		{
			this[i] = suicide;
		}
	}
}*/
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/base64'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/base64'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/base64'] = exports; /**
* @description
* Takes a string and encodes or decodes base-64.
* @class Base64
* @see http://coderepos.org/share/browser/lang/javascript/Base64/trunk/base64.js
*
**/

/*
 * $Id: base64.js,v 1.1 2009/03/01 22:38:45 dankogai Exp dankogai $
 *
 * History:
 *   dankogai's original: character-based
 *   drry's fix: split string to array then join
 *   new version: regexp-based
 */

var Base64 = (function() {
    var b64chars
        = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
    var b64tab = function(bin){
        var t = {};
        for (var i = 0, l = bin.length; i < l; i++) {
            t[bin.charAt(i)] = i;
        }
        return t;
    }(b64chars);

    var fromCharCode = String.fromCharCode;

    var sub_toBase64 = function(m){
        var n = (m.charCodeAt(0) << 16)
              | (m.charCodeAt(1) <<  8)
              | (m.charCodeAt(2)      );
        return b64chars.charAt( n >>> 18)
             + b64chars.charAt((n >>> 12) & 63)
             + b64chars.charAt((n >>>  6) & 63)
             + b64chars.charAt( n         & 63);
    };

    var toBase64 = function(bin){
        if (bin.match(/[^\x00-\xFF]/)) {
            throw 'unsupported character found';
        }
        var padlen = 0;
        while(bin.length % 3) {
            bin += '\x00';
            padlen++;
        }
        var b64 = bin.replace(/[\x00-\xFF]{3}/g, sub_toBase64);
        if (!padlen) return b64;
        b64 = b64.substr(0, b64.length - padlen);
        while(padlen--) b64 += '=';
        return b64;
    };

    // use native btoa() if it exists
    var _btoa = typeof(btoa) !== "undefined" ? btoa : toBase64;

    var sub_fromBase64 = function(m){
            var n = (b64tab[ m.charAt(0) ] << 18)
                |   (b64tab[ m.charAt(1) ] << 12)
                |   (b64tab[ m.charAt(2) ] <<  6)
                |   (b64tab[ m.charAt(3) ]);
        return fromCharCode(  n >> 16 )
            +  fromCharCode( (n >>  8) & 0xff )
            +  fromCharCode(  n        & 0xff );
    };

    var fromBase64 = function(b64){
        b64 = b64.replace(/[^A-Za-z0-9\+\/]/g, '');
        var padlen = 0;
        while(b64.length % 4){
            b64 += 'A';
            padlen++;
        }
        var bin = b64.replace(/[A-Za-z0-9\+\/]{4}/g, sub_fromBase64);
        bin.length -= [0,0,2,1][padlen];
        return bin;
    };

    // use native atob() if it exists
    var _atob = typeof(atob) !== "undefined" ? atob : fromBase64;

    var re_char_nonascii = /[^\x00-\xFF]/g;

    var sub_char_nonascii = function(m){
        var n = m.charCodeAt(0);
        return n < 0x800 ? fromCharCode(0xc0 | (n >>>  6))
                         + fromCharCode(0x80 | (n & 0x3f))
            :              fromCharCode(0xe0 | ((n >>> 12) & 0x0f))
                         + fromCharCode(0x80 | ((n >>>  6) & 0x3f))
                         + fromCharCode(0x80 |  (n         & 0x3f))
            ;
    };

    var utob = function(uni){
        return uni.replace(re_char_nonascii, sub_char_nonascii);
    };

    var re_bytes_nonascii
        = /[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3}/g;

    var sub_bytes_nonascii = function(m){
        var c0 = m.charCodeAt(0);
        var c1 = m.charCodeAt(1);
        if(c0 < 0xe0){
            return fromCharCode(((c0 & 0x1f) << 6) | (c1 & 0x3f));
        }else{
            var c2 = m.charCodeAt(2);
            return fromCharCode(
                ((c0 & 0x0f) << 12) | ((c1 & 0x3f) <<  6) | (c2 & 0x3f)
            );
        }
    };

    var btou = function(bin){
        return bin.replace(re_bytes_nonascii, sub_bytes_nonascii);
    };
    return {
        fromBase64:fromBase64,
        toBase64:toBase64,
        atob:_atob,
        btoa:_btoa,
        utob:utob,
        btou:btou,
        /**
        * @description
        * Takes an input value and returns a base-64 encoded string.
        * @name Base64.encode
        * @function
        * @param String input The input to return as a base-64 encoded string.
        * @return String A base-64 encoded string of the input parameter.
        */
        encode:function(u){
            if(!u) {
                return "";
            }
            return _btoa(utob(new String(u)));
        },
        decode:function(a){
            if(!a) {
                return "";
            }
            return btou(_atob(a.replace(/[\-_]/g, function(m0){
                return m0 == '-' ? '+' : '/';
            })));
        }
    };
})();

exports.Base64 = Base64;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Commands'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Commands'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Commands'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Commands
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

function UIAnimationOptions() {
	this.animationCurve = "EaseInOut";
	return this;
}

var Commands = exports.Commands = Core.Class.singleton(
/** @lends UI.Commands.prototype */
{
	/**
	 * @name UI.Commands
	 * @class 
	 * @augments Core.Class
	 */
	/** 
	 * @field
	 */
	classname: 'Commands',
	
	/**
	 * @constructs
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this.initializeNative(this.__objectRegistryId);
		this._tempCBs = {};
		this._tempCBCount = 0;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
			* Enumeration for image fit modes.
			* Image Fit is always applied relative to view bounds *after* content insets are applied.
			* @namespace
			 */
	FitMode:
	{ 
		/** The image content is not scaled at all. */
		None: 0,
		/** The image will be aspect-scaled to fit completely within the view. */
		Inside: 1,
		/** The image will be aspect-scaled to cover the entire view bounds. Clipping may occur. */
		Fill: 2,
		/** The image will be distorted to cover the exact view bounds. */
		Stretch: 3,
		/** The image will be aspect-scaled so its width matches the view bounds. Clipping may occur. */
		AspectWidth: 5,
		/** The image will be aspect-scaled so its height matches the view bounds. Clipping may occur. */
		AspectHeight: 6,
		/** The image will be scaled down to fit completely within the view, but not upscaled. */
		InsideNoUpscaling: 7,
	},
	
	/** 
			* Enumeration for supported units for dimensions.
			* Math.round() is your friend. Sending decimal pixel coordinates can result in unpredictable behavior on various platforms, but half- and quarter-pixels can be useful tools on iOS.
			* @namespace
			 */
	Scaling:
	{ 
		/** The native format, and the default for view bounds. No conversion will be performed. */
		Pixels: 0,
		/** Adjusted to roughly one typesetting point, downscaled from 72 to 160 dpi. */
		Points: 1,
		/** 1.0 represents 100% of the provided or implied size (usually a view width or height). */
		Unit: 2,
		/** A percentage of the provided or implied size (typically from 0 to 100). */
		Percent: 3,
		/** At this scale, the device's screen is always 320 units wide. */
		iPhone: 4,
	},
	
	/** 
			* Enumeration for text font styles.
			* @namespace
			 */
	FontStyle:
	{ 
		/** * */
		Normal: 0,
		/** * */
		Bold: 1,
		/** * */
		Italic: 2,
		/** * */
		BoldItalic: 3,
	},
	
	/** 
			* Flags for control / view states. Used in View and its subclasses.
			* When setting content and properties for states, the value with the highest id when AND'ed with the current state, but no additional bits, will be used.
			* @namespace
			 */
	State:
	{ 
		/** The view is in an unexceptional state. */
		Normal: 0x00,
		/** * */
		Focused: 0x01,
		/** * */
		Selected: 0x02,
		/** * */
		Pressed: 0x04,
		/** * */
		Checked: 0x08,
		/** * */
		Custom: 0x00FF0000,
		/** * */
		Disabled: 0x40000000,
	},
	
	/** 
			* Enumeration for Enter Key Behavior in editable text fields.
			* @namespace
			 */
	EnterKeyType:
	{ 
		/** * */
		Return: 0,
		/** * */
		Done: 1,
		/** * */
		Next: 2,
		/** * */
		Submit: 3,
		/** * */
		Go: 4,
		/** * */
		Search: 5,
		/** * */
		Send: 6,
	},
	
	/** 
			* Enumeration for Input Types for editable text fields.
			* @namespace
			 */
	InputType:
	{ 
		/** * */
		None: 0,
		/** * */
		TextWithCorrection: 1,
		/** * */
		Password: 2,
		/** * */
		Numeric: 4,
		/** * */
		Email: 5,
		/** * */
		URL: 6,
		/** * */
		Date: 7,
		/** * */
		ANDROID_LANDSCAPE_FULLSCREEN: 8,
	},
	
	/** 
			* Arrangement of combinations of text and images for buttons. When stacked, the button rect will be divided proportionally into two rects that completely cover the button. Gravity will apply to the image and text within their rects.
			* @namespace
			 */
	ButtonLayout:
	{ 
		/** The view is in an unexceptional state. */
		CenterTextOver: 0,
		/** * */
		StackImageLeft: 1,
		/** * */
		StackImageTop: 2,
		/** * */
		StackImageRight: 3,
		/** * */
		StackImageBottom: 4,
		/** * */
		CenterImageOver: 5,
	},
	
	/** 
			* Describes what direction a user swiped during a swipe callback.
			* @see UI.AbstractView#setOnSwipe
			* @namespace
			 */
	SwipeDirection:
	{ 
		/** * */
		Left: 1,
		/** * */
		Right: 2,
		/** * */
		Up: 3,
		/** * */
		Down: 4,
	},
	
	///////
	// Class Summary and Generated Constants (for internal use only):
	// Class ID = 337
	// Method -1: _initializeNative ( int reservedId )
	// Method -2: _create ( int newObjectId, str className )
	// Method 3: _destroy (  )
	// Method 4: _setActive ( bool active )
	// Method 5: _setTouchable ( bool touchable )
	// Method 6: _enableEvent ( str eventName )
	// Method 7: _disableEvent ( str eventName )
	// Method -8: _eventOccurred ( json eventObject )
	// Method 9: _setIsVisible ( bool visible )
	// Method 10: _setEnabled ( bool enable )
	// Method 11: _setState ( int state )
	// Method 12: _addSubview ( int __objectRegistryId, int index )
	// Method 13: _removeFromSuperview (  )
	// Method -14: _startAnimation ( int durationMs, str callbackId )
	// Method -15: _executeAnimation ( json options )
	// Method 16: _setFrame ( float x, float y, float w, float h )
	// Method 17: _setOrigin ( float x, float y )
	// Method 18: _setAnchor ( float x, float y )
	// Method 19: _setSize ( float w, float h )
	// Method 20: _setTransform ( float a, float b, float c, float d, float tx, float ty )
	// Method 21: _setBackgroundColor ( str color )
	// Method 22: _setImage ( int state, str imageURL )
	// Method 23: _setImageBorder ( int state, json gradientJSON )
	// Method 24: _setImageFitMode ( int fitMode )
	// Method 25: _setImageGravity ( float x, float y )
	// Method 26: _setImageOrigin ( float x, float y )
	// Method 27: _setImageAnchor ( float x, float y )
	// Method 28: _setImageSize ( float w, float h )
	// Method 29: _setImageInsets ( float t, float r, float b, float l )
	// Method 30: _setImageTransform ( float a, float b, float c, float d, float tx, float ty )
	// Method 31: _setText ( int state, str text )
	// Method 32: _setTextColor ( int state, str text )
	// Method 33: _setTextFont ( int state, str fontName )
	// Method 34: _setTextShadow ( int state, str shadow )
	// Method 35: _setTextSize ( float textFontSize )
	// Method 36: _setTextGravity ( float x, float y )
	// Method 37: _setTextInsets ( float t, float r, float b, float l )
	// Method 38: _setTextOverflow ( int overflowMode )
	// Method 39: _setTextMaxLines ( int maxLines )
	// Method 40: _setTextMinSize ( float minSize )
	// Method 41: _setTitle ( int state, str title )
	// Method 42: _setTitleColor ( int state, str title )
	// Method 43: _setTitleFont ( int state, str fontName )
	// Method 44: _setTitleShadow ( int state, str shadow )
	// Method 45: _setTitleSize ( float titleFontSize )
	// Method 46: _setTitleGravity ( float x, float y )
	// Method 47: _setTitleInsets ( float t, float r, float b, float l )
	// Method 48: _setTitleOverflow ( int overflowMode )
	// Method 49: _setTitleMaxLines ( int maxLines )
	// Method 50: _setTitleMinSize ( float minSize )
	// Method 51: _setGradient ( int state, json gradientJSON )
	// Method 52: _setStringValue ( str value )
	// Method 53: _setFloatValue ( float value )
	// Method 54: _setIntValue ( int value )
	// Method 55: _setBoolValue ( bool value )
	// Method 56: _setButtonLayout ( int layoutType )
	// Method 57: _setContentInsets ( float t, float r, float b, float l )
	// Method 58: _setBarGradient ( int state, json gradientJSON )
	// Method 59: _setPlaceholderText ( str placeholder )
	// Method 60: _setPlaceholderTextColor ( str color )
	// Method 61: _setPlaceholderTextShadow ( str shadow )
	// Method 62: _setEnterKeyType ( int enterKeyType )
	// Method 63: _setInputType ( int inputType )
	// Method 64: _setChecked ( bool checked )
	// Method 65: _setScrollPosition ( float x, float y )
	// Method 66: _setScrollableSize ( float w, float h )
	// Method 67: _setSections ( json idArray )
	// Method 68: _setTitleView ( int titleObjectID )
	// Method 69: _setSourceDocument ( str documentURL )
	// Method 70: _setChoices ( json stringArray, int defaultChoiceIndex, int cancelChoiceIndex )
	// Method 71: _show (  )
	// Method 72: _hide (  )
	// Method 73: _setPostData ( str data )
	// Method 74: _loadPostURL ( str url )
	// Method 75: _loadGetURL ( str url )
	// Method 76: _loadURL ( str url, json headers, float timeout )
	// Method 77: _stopLoading (  )
	// Method 78: _reload (  )
	// Method 79: _invoke ( str script )
	// Method 80: _goBack (  )
	// Method 81: _goForward (  )
	// Method 82: _setBasicAuthCredentials ( json credentials )
	// Method 83: _setRightImage ( int state, str rightImageURL )
	// Method 84: _setRightImageBorder ( int state, json gradientJSON )
	// Method 85: _setRightImageFitMode ( int fitMode )
	// Method 86: _setRightImageGravity ( float x, float y )
	// Method 87: _setRightImageOrigin ( float x, float y )
	// Method 88: _setRightImageAnchor ( float x, float y )
	// Method 89: _setRightImageSize ( float w, float h )
	// Method 90: _setRightImageInsets ( float t, float r, float b, float l )
	// Method 91: _setRightImageTransform ( float a, float b, float c, float d, float tx, float ty )
	// Method -92: _setStatusBarHidden ( bool statusBarStatus )
	// Method 93: _pauseAds (  )
	// Method 94: _resumeAds (  )
	// Method 95: _setAdRefreshRate ( int refreshRate )
	// Method 96: _setAdAllowAutoplay ( bool autoplay )
	// Method 97: _setAlpha ( float alpha )
	// Method 98: _postURL ( str url, str data )
	// Method 99: _setProgressGradient ( int state, json gradientJSON )
	// Method 100: _setSecondaryGradient ( int state, json gradientJSON )
	// Method 101: _setProgress ( float progress, float secondaryProgress )
	// Method 102: _useForUpdateProgress ( bool use )
	// Method 103: _setDarkStyle ( bool use )
	// Method -104: _doCompositeImages ( int w, int h, str filename, json infoArray, str callbackId )
	// Method -105: _REMOVED_doChoosePhoto ( int w, int h, str filename, json options, str callbackId )
	// Method -106: _doChooseCamera ( int w, int h, str filename, json options, str callbackId )
	// Method 107: _setScrollable ( bool enabled )
	// Method 108: _setZoomable ( bool enabled )
	// Method 109: _addAnnotation ( int __objectRegistryId )
	// Method 110: _removeAnnotation ( int __objectRegistryId )
	// Method 111: _selectAnnotation ( int __objectRegistryId )
	// Method 112: _setRegion ( float latitude, float longitude, float latitudeDelta, float longitudeDelta, bool animated )
	// Method 113: _setView ( int __objectRegistryId )
	// Method 114: _setCoordinate ( float latitude, float longitude )
	// Method 115: _setCalloutTitle ( str title )
	// Method 116: _setCalloutSubtitle ( str subTitle )
	// Method 117: _setCalloutEnabled ( bool enabled )
	// Method 118: _setCalloutLeftView ( int __objectRegistryId )
	// Method 119: _setCalloutRightView ( int __objectRegistryId )
	// Method 120: _setCenterOffset ( float xOffset, float yOffset )
	// Method -121: _doChoosePhoto ( int w, int h, str filename, json options, str callbackId, int invokingView )
	// Method 122: _setScrollIndicatorsVisible ( bool enabled )
	// Method -123: _measureText ( str string, int w, int h, str font, float fontSize, str callbackId )
	// Method 124: _setFocus ( bool enabled )
	// Method 125: _setViewportEnabled ( bool enabled )
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Commands._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				case -8:
					Commands._eventOccurredRecv( cmd );
					break;
				default:
					NgLogE("Unknown static method id " + cmdId + " in Commands._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[337] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	$_eventOccurredRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Commands.eventOccurred from command: " + cmd );
			return false;
		}
		
		obj[ "eventObject" ] = Core.Proc.parseJSONString( cmd[ 0 ] );
		if( obj[ "eventObject" ] === undefined )
		{
			NgLogE("Could not parse eventObject in Commands.eventOccurred from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$initializeNative: function( reservedId )
	{
		Core.Proc.appendToCommandString( ":337,-1," + reservedId  );
	},
	
	/** @private */
	$create: function( newObjectId, className )
	{
		Core.Proc.appendToCommandString( ":337,-2," + newObjectId + "," + Core.Base64.encode( className )  );
	},
	
	/** @private */
	destroy: function(  )
	{
		Core.Proc.appendToCommandString( ":337,3," + this.__objectRegistryId );
	},
	
	/** @private */
	setActive: function( active )
	{
		Core.Proc.appendToCommandString( ":337,4," + this.__objectRegistryId + "," + ( active ? 1 : 0 )  );
	},
	
	/** @private */
	setTouchable: function( touchable )
	{
		Core.Proc.appendToCommandString( ":337,5," + this.__objectRegistryId + "," + ( touchable ? 1 : 0 )  );
	},
	
	/** @private */
	enableEvent: function( eventName )
	{
		Core.Proc.appendToCommandString( ":337,6," + this.__objectRegistryId + "," + Core.Base64.encode( eventName )  );
	},
	
	/** @private */
	disableEvent: function( eventName )
	{
		Core.Proc.appendToCommandString( ":337,7," + this.__objectRegistryId + "," + Core.Base64.encode( eventName )  );
	},
	
	/** @private */
	setIsVisible: function( visible )
	{
		Core.Proc.appendToCommandString( ":337,9," + this.__objectRegistryId + "," + ( visible ? 1 : 0 )  );
	},
	
	/** @private */
	setEnabled: function( enable )
	{
		Core.Proc.appendToCommandString( ":337,10," + this.__objectRegistryId + "," + ( enable ? 1 : 0 )  );
	},
	
	/** @private */
	setState: function( state )
	{
		Core.Proc.appendToCommandString( ":337,11," + this.__objectRegistryId + "," + state  );
	},
	
	/** @private */
	addSubview: function( __objectRegistryId, index )
	{
		Core.Proc.appendToCommandString( ":337,12," + this.__objectRegistryId + "," + __objectRegistryId + "," + index  );
	},
	
	/** @private */
	removeFromSuperview: function(  )
	{
		Core.Proc.appendToCommandString( ":337,13," + this.__objectRegistryId );
	},
	
	/** @private */
	$startAnimation: function( durationMs, callbackId )
	{
		Core.Proc.appendToCommandString( ":337,-14," + durationMs + "," + Core.Base64.encode( callbackId )  );
	},
	
	/** @private */
	$executeAnimation: function( options )
	{
		Core.Proc.appendToCommandString( ":337,-15," + Core.Base64.encode( JSON.stringify( options ) )  );
	},
	
	/** @private */
	setFrame: function( x, y, w, h )
	{
		Core.Proc.appendToCommandString( ":337,16," + this.__objectRegistryId + "," + x + "," + y + "," + w + "," + h  );
	},
	
	/** @private */
	setOrigin: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,17," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setAnchor: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,18," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":337,19," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setTransform: function( a, b, c, d, tx, ty )
	{
		Core.Proc.appendToCommandString( ":337,20," + this.__objectRegistryId + "," + a + "," + b + "," + c + "," + d + "," + tx + "," + ty  );
	},
	
	/** @private */
	setBackgroundColor: function( color )
	{
		Core.Proc.appendToCommandString( ":337,21," + this.__objectRegistryId + "," + Core.Base64.encode( color )  );
	},
	
	/** @private */
	setImage: function( state, imageURL )
	{
		Core.Proc.appendToCommandString( ":337,22," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( imageURL )  );
	},
	
	/** @private */
	setImageBorder: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,23," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setImageFitMode: function( fitMode )
	{
		Core.Proc.appendToCommandString( ":337,24," + this.__objectRegistryId + "," + fitMode  );
	},
	
	/** @private */
	setImageGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,25," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setImageOrigin: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,26," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setImageAnchor: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,27," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setImageSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":337,28," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setImageInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,29," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setImageTransform: function( a, b, c, d, tx, ty )
	{
		Core.Proc.appendToCommandString( ":337,30," + this.__objectRegistryId + "," + a + "," + b + "," + c + "," + d + "," + tx + "," + ty  );
	},
	
	/** @private */
	setText: function( state, text )
	{
		Core.Proc.appendToCommandString( ":337,31," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( text )  );
	},
	
	/** @private */
	setTextColor: function( state, text )
	{
		Core.Proc.appendToCommandString( ":337,32," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( text )  );
	},
	
	/** @private */
	setTextFont: function( state, fontName )
	{
		Core.Proc.appendToCommandString( ":337,33," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( fontName )  );
	},
	
	/** @private */
	setTextShadow: function( state, shadow )
	{
		Core.Proc.appendToCommandString( ":337,34," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( shadow )  );
	},
	
	/** @private */
	setTextSize: function( textFontSize )
	{
		Core.Proc.appendToCommandString( ":337,35," + this.__objectRegistryId + "," + textFontSize  );
	},
	
	/** @private */
	setTextGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,36," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setTextInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,37," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setTextOverflow: function( overflowMode )
	{
		Core.Proc.appendToCommandString( ":337,38," + this.__objectRegistryId + "," + overflowMode  );
	},
	
	/** @private */
	setTextMaxLines: function( maxLines )
	{
		Core.Proc.appendToCommandString( ":337,39," + this.__objectRegistryId + "," + maxLines  );
	},
	
	/** @private */
	setTextMinSize: function( minSize )
	{
		Core.Proc.appendToCommandString( ":337,40," + this.__objectRegistryId + "," + minSize  );
	},
	
	/** @private */
	setTitle: function( state, title )
	{
		Core.Proc.appendToCommandString( ":337,41," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( title )  );
	},
	
	/** @private */
	setTitleColor: function( state, title )
	{
		Core.Proc.appendToCommandString( ":337,42," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( title )  );
	},
	
	/** @private */
	setTitleFont: function( state, fontName )
	{
		Core.Proc.appendToCommandString( ":337,43," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( fontName )  );
	},
	
	/** @private */
	setTitleShadow: function( state, shadow )
	{
		Core.Proc.appendToCommandString( ":337,44," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( shadow )  );
	},
	
	/** @private */
	setTitleSize: function( titleFontSize )
	{
		Core.Proc.appendToCommandString( ":337,45," + this.__objectRegistryId + "," + titleFontSize  );
	},
	
	/** @private */
	setTitleGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,46," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setTitleInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,47," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setTitleOverflow: function( overflowMode )
	{
		Core.Proc.appendToCommandString( ":337,48," + this.__objectRegistryId + "," + overflowMode  );
	},
	
	/** @private */
	setTitleMaxLines: function( maxLines )
	{
		Core.Proc.appendToCommandString( ":337,49," + this.__objectRegistryId + "," + maxLines  );
	},
	
	/** @private */
	setTitleMinSize: function( minSize )
	{
		Core.Proc.appendToCommandString( ":337,50," + this.__objectRegistryId + "," + minSize  );
	},
	
	/** @private */
	setGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,51," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setStringValue: function( value )
	{
		Core.Proc.appendToCommandString( ":337,52," + this.__objectRegistryId + "," + Core.Base64.encode( value )  );
	},
	
	/** @private */
	setFloatValue: function( value )
	{
		Core.Proc.appendToCommandString( ":337,53," + this.__objectRegistryId + "," + value  );
	},
	
	/** @private */
	setIntValue: function( value )
	{
		Core.Proc.appendToCommandString( ":337,54," + this.__objectRegistryId + "," + value  );
	},
	
	/** @private */
	setBoolValue: function( value )
	{
		Core.Proc.appendToCommandString( ":337,55," + this.__objectRegistryId + "," + ( value ? 1 : 0 )  );
	},
	
	/** @private */
	setButtonLayout: function( layoutType )
	{
		Core.Proc.appendToCommandString( ":337,56," + this.__objectRegistryId + "," + layoutType  );
	},
	
	/** @private */
	setContentInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,57," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setBarGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,58," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setPlaceholderText: function( placeholder )
	{
		Core.Proc.appendToCommandString( ":337,59," + this.__objectRegistryId + "," + Core.Base64.encode( placeholder )  );
	},
	
	/** @private */
	setPlaceholderTextColor: function( color )
	{
		Core.Proc.appendToCommandString( ":337,60," + this.__objectRegistryId + "," + Core.Base64.encode( color )  );
	},
	
	/** @private */
	setPlaceholderTextShadow: function( shadow )
	{
		Core.Proc.appendToCommandString( ":337,61," + this.__objectRegistryId + "," + Core.Base64.encode( shadow )  );
	},
	
	/** @private */
	setEnterKeyType: function( enterKeyType )
	{
		Core.Proc.appendToCommandString( ":337,62," + this.__objectRegistryId + "," + enterKeyType  );
	},
	
	/** @private */
	setInputType: function( inputType )
	{
		Core.Proc.appendToCommandString( ":337,63," + this.__objectRegistryId + "," + inputType  );
	},
	
	/** @private */
	setChecked: function( checked )
	{
		Core.Proc.appendToCommandString( ":337,64," + this.__objectRegistryId + "," + ( checked ? 1 : 0 )  );
	},
	
	/** @private */
	setScrollPosition: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,65," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setScrollableSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":337,66," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setSections: function( idArray )
	{
		Core.Proc.appendToCommandString( ":337,67," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( idArray ) )  );
	},
	
	/** @private */
	setTitleView: function( titleObjectID )
	{
		Core.Proc.appendToCommandString( ":337,68," + this.__objectRegistryId + "," + titleObjectID  );
	},
	
	/** @private */
	setSourceDocument: function( documentURL )
	{
		Core.Proc.appendToCommandString( ":337,69," + this.__objectRegistryId + "," + Core.Base64.encode( documentURL )  );
	},
	
	/** @private */
	setChoices: function( stringArray, defaultChoiceIndex, cancelChoiceIndex )
	{
		Core.Proc.appendToCommandString( ":337,70," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( stringArray ) ) + "," + defaultChoiceIndex + "," + cancelChoiceIndex  );
	},
	
	/** @private */
	show: function(  )
	{
		Core.Proc.appendToCommandString( ":337,71," + this.__objectRegistryId );
	},
	
	/** @private */
	hide: function(  )
	{
		Core.Proc.appendToCommandString( ":337,72," + this.__objectRegistryId );
	},
	
	/** @private */
	setPostData: function( data )
	{
		Core.Proc.appendToCommandString( ":337,73," + this.__objectRegistryId + "," + Core.Base64.encode( data )  );
	},
	
	/** @private */
	loadPostURL: function( url )
	{
		Core.Proc.appendToCommandString( ":337,74," + this.__objectRegistryId + "," + Core.Base64.encode( url )  );
	},
	
	/** @private */
	loadGetURL: function( url )
	{
		Core.Proc.appendToCommandString( ":337,75," + this.__objectRegistryId + "," + Core.Base64.encode( url )  );
	},
	
	/** @private */
	loadURL: function( url, headers, timeout )
	{
		Core.Proc.appendToCommandString( ":337,76," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( JSON.stringify( headers ) ) + "," + timeout  );
	},
	
	/** @private */
	stopLoading: function(  )
	{
		Core.Proc.appendToCommandString( ":337,77," + this.__objectRegistryId );
	},
	
	/** @private */
	reload: function(  )
	{
		Core.Proc.appendToCommandString( ":337,78," + this.__objectRegistryId );
	},
	
	/** @private */
	invoke: function( script )
	{
		Core.Proc.appendToCommandString( ":337,79," + this.__objectRegistryId + "," + Core.Base64.encode( script )  );
	},
	
	/** @private */
	goBack: function(  )
	{
		Core.Proc.appendToCommandString( ":337,80," + this.__objectRegistryId );
	},
	
	/** @private */
	goForward: function(  )
	{
		Core.Proc.appendToCommandString( ":337,81," + this.__objectRegistryId );
	},
	
	/** @private */
	setBasicAuthCredentials: function( credentials )
	{
		Core.Proc.appendToCommandString( ":337,82," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( credentials ) )  );
	},
	
	/** @private */
	setRightImage: function( state, rightImageURL )
	{
		Core.Proc.appendToCommandString( ":337,83," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( rightImageURL )  );
	},
	
	/** @private */
	setRightImageBorder: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,84," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setRightImageFitMode: function( fitMode )
	{
		Core.Proc.appendToCommandString( ":337,85," + this.__objectRegistryId + "," + fitMode  );
	},
	
	/** @private */
	setRightImageGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,86," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setRightImageOrigin: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,87," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setRightImageAnchor: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,88," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setRightImageSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":337,89," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setRightImageInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,90," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setRightImageTransform: function( a, b, c, d, tx, ty )
	{
		Core.Proc.appendToCommandString( ":337,91," + this.__objectRegistryId + "," + a + "," + b + "," + c + "," + d + "," + tx + "," + ty  );
	},
	
	/** @private */
	$setStatusBarHidden: function( statusBarStatus )
	{
		Core.Proc.appendToCommandString( ":337,-92," + ( statusBarStatus ? 1 : 0 )  );
	},
	
	/** @private */
	pauseAds: function(  )
	{
		Core.Proc.appendToCommandString( ":337,93," + this.__objectRegistryId );
	},
	
	/** @private */
	resumeAds: function(  )
	{
		Core.Proc.appendToCommandString( ":337,94," + this.__objectRegistryId );
	},
	
	/** @private */
	setAdRefreshRate: function( refreshRate )
	{
		Core.Proc.appendToCommandString( ":337,95," + this.__objectRegistryId + "," + refreshRate  );
	},
	
	/** @private */
	setAdAllowAutoplay: function( autoplay )
	{
		Core.Proc.appendToCommandString( ":337,96," + this.__objectRegistryId + "," + ( autoplay ? 1 : 0 )  );
	},
	
	/** @private */
	setAlpha: function( alpha )
	{
		Core.Proc.appendToCommandString( ":337,97," + this.__objectRegistryId + "," + alpha  );
	},
	
	/** @private */
	postURL: function( url, data )
	{
		Core.Proc.appendToCommandString( ":337,98," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( data )  );
	},
	
	/** @private */
	setProgressGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,99," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setSecondaryGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,100," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setProgress: function( progress, secondaryProgress )
	{
		Core.Proc.appendToCommandString( ":337,101," + this.__objectRegistryId + "," + progress + "," + secondaryProgress  );
	},
	
	/** @private */
	useForUpdateProgress: function( use )
	{
		Core.Proc.appendToCommandString( ":337,102," + this.__objectRegistryId + "," + ( use ? 1 : 0 )  );
	},
	
	/** @private */
	setDarkStyle: function( use )
	{
		Core.Proc.appendToCommandString( ":337,103," + this.__objectRegistryId + "," + ( use ? 1 : 0 )  );
	},
	
	/** @private */
	$doCompositeImages: function( w, h, filename, infoArray, callbackId )
	{
		Core.Proc.appendToCommandString( ":337,-104," + w + "," + h + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( JSON.stringify( infoArray ) ) + "," + Core.Base64.encode( callbackId )  );
	},
	
	/** @private */
	$doChooseCamera: function( w, h, filename, options, callbackId )
	{
		Core.Proc.appendToCommandString( ":337,-106," + w + "," + h + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( JSON.stringify( options ) ) + "," + Core.Base64.encode( callbackId )  );
	},
	
	/** @private */
	setScrollable: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,107," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	setZoomable: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,108," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	addAnnotation: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,109," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	removeAnnotation: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,110," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	selectAnnotation: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,111," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setRegion: function( latitude, longitude, latitudeDelta, longitudeDelta, animated )
	{
		Core.Proc.appendToCommandString( ":337,112," + this.__objectRegistryId + "," + latitude + "," + longitude + "," + latitudeDelta + "," + longitudeDelta + "," + ( animated ? 1 : 0 )  );
	},
	
	/** @private */
	setView: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,113," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setCoordinate: function( latitude, longitude )
	{
		Core.Proc.appendToCommandString( ":337,114," + this.__objectRegistryId + "," + latitude + "," + longitude  );
	},
	
	/** @private */
	setCalloutTitle: function( title )
	{
		Core.Proc.appendToCommandString( ":337,115," + this.__objectRegistryId + "," + Core.Base64.encode( title )  );
	},
	
	/** @private */
	setCalloutSubtitle: function( subTitle )
	{
		Core.Proc.appendToCommandString( ":337,116," + this.__objectRegistryId + "," + Core.Base64.encode( subTitle )  );
	},
	
	/** @private */
	setCalloutEnabled: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,117," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	setCalloutLeftView: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,118," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setCalloutRightView: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,119," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setCenterOffset: function( xOffset, yOffset )
	{
		Core.Proc.appendToCommandString( ":337,120," + this.__objectRegistryId + "," + xOffset + "," + yOffset  );
	},
	
	/** @private */
	$doChoosePhoto: function( w, h, filename, options, callbackId, invokingView )
	{
		Core.Proc.appendToCommandString( ":337,-121," + w + "," + h + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( JSON.stringify( options ) ) + "," + Core.Base64.encode( callbackId ) + "," + invokingView  );
	},
	
	/** @private */
	setScrollIndicatorsVisible: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,122," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	$measureText: function( string, w, h, font, fontSize, callbackId )
	{
		Core.Proc.appendToCommandString( ":337,-123," + Core.Base64.encode( string ) + "," + w + "," + h + "," + Core.Base64.encode( font ) + "," + fontSize + "," + Core.Base64.encode( callbackId )  );
	},
	
	/** @private */
	setFocus: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,124," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	setViewportEnabled: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,125," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	

// {{/Wg Generated Code}}

	_eventOccurredRecv: function( cmd ) {
		var str = Core.Proc.parseString( cmd[ 0 ] );
		Commands.Window.doCommand(str);
	},
	
	registerTemporaryCallback: function( callback ) {
		if (typeof callback != 'function') return null;
		var regId = (++this._tempCBCount).toString(36);
		Commands._tempCBs[regId] = callback;
		return regId;
	},
	
	takeTemporaryCallback: function( regId ) {
		var cb = Commands._tempCBs[regId];
		delete Commands._tempCBs[regId];
		return cb;
	},

	/**
	 *	@function UI#animate
	 * 	Animate changes to the properties of one or more UI objects.
	 * 	Currently animates changes to frame and alpha, and animates the addition / removal of subviews.
	 * 	@param {Function} action A closure that sets the property or properties to be animated.
	 * 		This function may manipulate several objects.
	 * 	@param {Number} duration The time over which to execute the animation, in milliseconds.
	 * 	@param {Function} onCompletion A closure to be executed after the animation has completed.
	 */
	animate: function(action, duration, callback) {
		if (typeof action == 'function') {
			var cbFn = (typeof callback == 'function') ? callback : duration;
			var duration = (typeof duration == 'number') ? duration : callback;
			if (typeof duration != 'number') duration = 400;

			Commands.startAnimation( duration, Commands.registerTemporaryCallback(callback));
			var options = new UIAnimationOptions();
			action(options);
			Commands.executeAnimation(options);
		}
	},
});

exports.Commands.instantiate();
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ViewGeometry'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ViewGeometry'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ViewGeometry'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;

/**
 * <p>Classes and objects contained by the <code>ViewGeometry</code> class.</p>
 * @name UI.ViewGeometry
 * @namespace
 * @description <p>The <code>ViewGeometry</code> class is a collection of classes and objects that control spatial components for UI views. 
 * Derived classes from <code>ViewGeometry</code> include:</p>
 * <ul>
 * <li><code>{@link UI.ViewGeometry.Rect}</code></li>
 * <li><code>{@link UI.ViewGeometry.Scale}</code></li>
 * </ul>
 * <p><code>ViewGeometry</code> utilizes the following enumerated constants:</p>
 * <ul>
 * <li><code>{@link UI.ViewGeometry.FitMode}</code></li>
 * <li><code>{@link UI.ViewGeometry.Gravity}</code></li>
 * </ul>
 */

var Scale = exports.Scale = Class.singleton(
/** @lends UI.ViewGeometry.Scale.prototype */
{
	/**
	 * @name UI.ViewGeometry.Scale
	 * @class The <code>Scale</code> class constructs objects that handle view geometry for different scales of measurement.
         * @constructs The default constructor.
	 * @augments Core.Class
	 */
   
	initialize: function() {
		var screenUnits = Capabilities.getScreenUnits();
		this.iOSConversion = screenUnits;
		this.pointConversion = this.iOSConversion * 160 / 72; 
	},

	// Use the values of generated constants... Mostly for if we need to send these to native in the future.
	Pixels: Commands.Scaling.Pixels,
	Points: Commands.Scaling.Points,
	Unit: Commands.Scaling.Unit,
	Percent: Commands.Scaling.Percent,
	iPhone: Commands.Scaling.iPhone,
	
	// Internals.
    
	pointConversion: 1.0,
    
	iOSConversion: 1.0,

    /** 
     * Retrieve the supported measurement scale from the device.
     * @param {Number} units The unit of measure.
     * @param {Number} size The screen size of the device.
     * @returns The current screen dimension supported by the device.
     */
	getScale: function(units, size) {
		switch (+units) {
			case this.Points:
				return this.pointConversion;
			case this.Unit:
				return size;
			case this.Percent:
				return size / 100;
			case this.iPhone:
				return this.iOSConversion;
		}
		return 1.0;
	}
});

var Gravity = exports.Gravity = 
{
		
	/** 
	 * @name UI.ViewGeometry.Gravity
	 * @class Enumeration for image gravity in a view.
	 */
	/** 
	* Center of gravity is the top-left corner of the image.
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	TopLeft: [0.0,0.0],
	/** 
	* Center of gravity is the top-center portion of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	TopCenter: [0.5,0.0],
	/** 
	* Center of gravity is the top-right corner of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	TopRight: [1.0, 0.0],
	/** 
	* Center of gravity is the left side of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	Left: [0.0,0.5],
	/** 
	* Center of gravity is the center of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	Center: [0.5,0.5],
	/** 
	* Center of gravity is the right side of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	Right: [1.0,0.5],
	/** 
	* Center of gravity is the bottom-left corner of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	BottomLeft: [0.0,1.0],
	/** 
	* Center of gravity is the bottom-center portion of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	BottomCenter: [0.5,1.0],
	/** 
	* Center of gravity is the bottom-right corner of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	BottomRight: [1.0,1.0]
};

 
exports.FitModes = Commands.FitMode;
/** 
* @name UI.ViewGeometry.FitMode
* @class Enumeration for image fit modes in a view.
* @see UI.Commands#FitMode
*/

	
var Rect = exports.Rect = Class.subclass(
/** @lends UI.ViewGeometry.Rect.prototype */
{
	/**
	 * @name UI.ViewGeometry.Rect
	 * @class <code>Rect</code> constructs rectangle objects for use as positionable elements in the user interface. 
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */

    initialize: function(arg0)
    {
    	if (arg0 instanceof this.constructor){
    		// Another Rect
    		this.x = arg0.x;
    		this.y = arg0.y;
    		this.w = arg0.w;
    		this.h = arg0.h;
    	} else if (arg0 instanceof Array) {
    		if (arguments.length == 2 
    			&& arguments[0].length >= 2 
    			&& arguments[1] instanceof Array 
    			&& arguments[1].length >= 2) {
				
				// Arguments can be two arrays, one of which is a point and one of which is a size,
				this.x = arguments[0][0];
				this.y = arguments[0][1];
				this.w = arguments[1][0];
				this.h = arguments[1][1];
			}
			else if (arguments.length == 1 && arg0.length >= 4) {
				// Single Array
				this.x = arg0[0];
				this.y = arg0[1];
				this.w = arg0[2];
				this.h = arg0[3];
			}
			else {
				NgLogD("UI.ViewGeometry.Rect initialized with unparseable Array(s)");
			}
		} else if (arguments.length == 4) {
			// Four numbers
			this.x = arguments[0];
			this.y = arguments[1];
			this.w = arguments[2];
			this.h = arguments[3];
		}
		return this;
    },
	/**
	 * @returns {Boolean} Returns <code>true</code> if any component value is undefined, NaN, or the value indicates this rect has an area of 0 (<i>width</i> * <i>height</i>).
	 */
	isEmpty: function(){
		return !(this.w * this.h > 0) || isNaN(this.x) || isNaN(this.y) || isNaN(this.w) || isNaN(this.h);
	},
	/**
	 * Copy the component values of this <code>Rect</code>
	 * @returns {UI.ViewGeometry.Rect} A new <code>Rect</code> with identical component values.
	 */	
	copy: function() {
		return new (this).constructor(this);
	},
    /**
	 * Retrieve the component values of this <code>Rect</code>.
	 * @returns {Array (Number)} An array of component values for the specified <code>Rect</code> (<i>x</i>, <i>y</i>, <i>height</i>, <i>width</i>).
	 */	
	array: function() {
		return [this.x, this.y, this.w, this.h];
	},
    /**
	 * Set the dimensions of this <code>Rect</code> as an inset.
	 * @example var imageRect = null;
	 * var remainingRect = rect.copy();
	 * ...
	 * imageRect = remainingRect.sliceHorizontal(110).inset(8,15,8,15);
	 * @param {Number} t The size for the top of the rectangle.
	 * @param {Number} r The size for the right side of the rectangle.
	 * @param {Number} b The size for the bottom of the rectangle.
	 * @param {Number} l The size for the left side of the rectangle.
	 * @param {UI.ViewGeometry.Scale} units The unit of measure for the rectangle.
	 * @returns {UI.ViewGeometry.Rect} This function returns <code>this</code> to support method invocation chaining.
	 */	
	inset: function(t, r, b, l, units) {
		if (arguments.length > 4) {
			var xScale = Scale.getScale(units, this.w);
			var yScale = Scale.getScale(units, this.h);
			t = Math.floor(t * yScale);
			r = Math.floor(r * xScale);
			b = Math.floor(b * yScale);
			l = Math.floor(l * xScale);
		}
		
		if (arguments.length < 2) {
			r = t;
		}
		if (arguments.length < 4) {
			b = t;
			l = r;
		}
		this.y += t;
		this.h -= t + b;
		this.x += l;
		this.w -= l + r;
		return this;
	},
    /**
	 *	Create and return a new <code>Rect</code> representing the top (if positive) or bottom (if negative).
	 *	Destructively modifies this Rect, removing the new rect area from the receiver.
	 * @example var topPart = rect.inset(10).sliceVertical(50, UI.Scale.Percent);
	 * @param {Number} height The new rect height.
	 * @param {UI.ViewGeometry.Scale} [units] The scale of measurement.
	 * @returns {UI.ViewGeometry.Rect} A new <code>Rect</code> object.<br>
	 * @see UI.ViewGeometry.Rect#sliceHorizontal
	 */	
	sliceVertical: function(height, units) {
		if (arguments.length > 1) height = Math.floor(height * Scale.getScale(units, this.h));
		
		var newRect = this.copy();
		if (height < 0) {
			// Return the bottom area...
			newRect.h = -height;
			this.h += height;
			newRect.y += this.h;
		} else {
			newRect.h = height;
			this.y += height;
			this.h -= height;
		}
		return newRect;
	},
    /**
	 *	Create and return a new <code>Rect</code> representing the left (if positive) or right (if negative).
	 *	Destructively modifies this Rect, removing the new rect area from the receiver.
	 * @example var imageRect = null;
	 * var remainingRect = rect.copy();
	 * ...
	 * imageRect = remainingRect.sliceHorizontal(110).inset(8,15,8,15);
	 * @param {Number} width The new rect width.
	 * @param {UI.ViewGeometry.Scale} [units] The scale of measurement.
	 * @returns {UI.ViewGeometry.Rect} A new <code>Rect</code> object.<br>
	 * @see UI.ViewGeometry.Rect#sliceVertical
	 */	
	sliceHorizontal: function(width, units) {
		if (arguments.length > 1) width = Math.floor(width * Scale.getScale(units, this.w));

		var newRect = this.copy();
		if (width < 0) {
			newRect.w = -width;
			this.w += width;
			newRect.x += this.w;
		} else {
			newRect.w = width;
			this.x += width;
			this.w -= width;
		}
		return newRect;
	},

	toString: function() {
		return "Rect: {" + this.array().join(',') + "}";
	},

	/**
	 * Retrieve an array of component values for this <code>Rect</code> with rows and columns redistributed evenly.
	 * @returns {Array (Number)}
	 * @param {Number} rows The rect rows.
	 * @param {Number} columns The rect columns.
	 * @param {String} flat A one-dimensional array (left to right, top to bottom).
	 */
	getGrid: function(rows, columns, flat) {
		// Return an array of this rect divided equally into columns and rows.
		flat = (flat == true);
		var cellW = Math.floor(this.w / columns);
		var cellH = Math.floor(this.h / rows);
		
		var rowSet = new Array();
		for (var i = 0; i < rows; i++) {
			var colSet = new Array();
			for (var j = 0; j < columns; j++) {
				var r = new this.constructor(this.x + j * cellW, this.y + i * cellH, cellW, cellH);
				(flat ? rowSet : colSet).push(r);
			}
			if (!flat) rowSet.push(colSet);
		}
		return rowSet;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Window'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Window'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Window'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Element = require('NGCore/Client/UI/Element').Element;
var Rect = require('NGCore/Client/UI/ViewGeometry').Rect;

var WindowLayer = require('NGCore/Client/UI/WindowLayer').WindowLayer;

// Singleton
// Methods beginning with an underscore are considered private and should
// not be called from outside of the class.

Commands.Window = exports.Window = Class.singleton({

	/**
	 * @deprecated Replaced by {@link UI.Window#getWidth}.
	 */
	_outerWidth: 0,

	/**
	 * @deprecated Replaced by {@link UI.Window#getHeight}.
	 */
	_outerHeight: 0,

	/**
	 * @private
	 */
	_width: 0,
	/**
	 * @private
	 */
	_height: 0,

	 /**
	 * @class The <code>Window</code> class constructs a singleton object that manages application access to native UI.<br><br>
	 * <b>Note:</b> An application should never directly allocate a singleton.
	 * @name UI.Window
	 * @augments Core.Class	
	 * @see UI.Window#document
	 * @constructs The default constructor.
	 */
	initialize: function() {
		if (!this._outerWidth || !this._outerHeight) this.setWidthAndHeight(Capabilities.getScreenWidth(), Capabilities.getScreenHeight());
		if (!this._width || !this._height) this._setWidthAndHeight(Capabilities.getScreenWidth(), Capabilities.getScreenHeight());
		
		Commands.instantiate();
		var LayoutListener = Core.MessageListener.subclass(
		{
			initialize: function()
			{
				Device.LayoutEmitter.addListener(this, this.onUpdate);
			},
			
			onUpdate: function(layout)
			{
				UI.Window._setWidthAndHeight(layout['width'], layout['height']);
			}
		});
		var layout = new LayoutListener();
		NgLogD("window: outer = " + this._outerWidth + " × " + this._outerHeight + " frame = " + this._width + " × " + this._height);
	},
	
	document: WindowLayer.singleton({
		'type': 'document',
		register: function() {
			// This is not a registered object.
			this.__objectRegistryId = 0;
		}
	}),
	
	_layers: {},
	_getLayer: function(level) {
		return this._layers[level] || (this._layers[level] = new WindowLayer({'level':level || 0}));
	},
	
	/**
	 * @private
	 */
	destroyObject: function(obj) {
		obj.removeFromParent();
		Commands.destroy.call(obj);
		ObjectRegistry.unregister(obj);
	},
	
	/**
	 * @private
	 */
	handleCommand: function(command) {
		// this.log(["Raw Command", command]);
		var fields = NgParseCommand2(command, NgParseInt, NgParseBase64);
	//	this.log(["handleCommand:", fields[1]]);
		this.doCommand(fields[1]);
	},
	/**
	* @private
	*/
	setStatusBarHidden: function(value) {
		Commands.setStatusBarHidden(value);
		this._outerHeight = Capabilities.getScreenHeight() - (value ? 0 : (Capabilities.getStatusBarHeight() || 0));
	},
	
	/**
	 * @private
	 */
	doCommand: function(jsonString) {
		//NgLogD(jsonString);
		var command = JSON.parse(jsonString);
		if(command.name == 'callback'){
			var cb = Commands.takeTemporaryCallback(command.callback_id);
			if (typeof cb == 'function') {
				cb(command);
			}
		} else {
			var object = ObjectRegistry.idToObject(command.objId);
			if (object instanceof Element) {
				switch (command.name) {
					case 'event':
						object.performEventCallback(command);
						break;
					case 'update':
						var properties = command.properties || {};
						for (var property in properties) {
							try {
								var setter = object['update' + property.charAt(0).toUpperCase() + property.substr(1)];
								if (typeof setter == 'function') {
									setter.apply(object, [properties[property]]);
								} else {
									// Set read-only properties!
									object['_'+property] = properties[property];
								}
							} catch (e) {};
						}
						break;
					default:
						object.handleCommand(command);
				}
			} else {
				console.log("Message received for non-element object with id " + command.objId);
				return;
			}
		}
		// log(["Got message back", command]);
	},
    
	/**
	 * @private
	 */    
	log: function(object) {
		NgLogD(object.toString());
		// this.postMessage({name: 'log', message: object});
	},
	/**
	 * Return the available screen width, with respect to orientation and system status bars.
	 * @returns {Number} The currently available width in pixels that can be drawn to.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getWidth: function()
	{
		return this._width;
	},

	/**
	 * Return the available screen height, with respect to orientation and system status bars.
	 * @returns {Number} The currently available height in pixels that can be drawn to.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHeight: function()
	{
		return this._height;
	},

	getOuterWidth: function() {
		return this._outerWidth;
	},
	
	getOuterHeight: function() {
		return this._outerHeight;
	},

	getFrame: function() {
		return new Rect(0, 0, this._width, this._height);
	}
});

// Cause property access to initialize the singleton. Needed for backward compatibility.
Commands.Window.__defineGetter__("outerWidth", function() {return this.getOuterWidth()});
Commands.Window.__defineGetter__("outerHeight", function() {return this.getOuterHeight()});

/**
 * @private
 */
Commands.Window._setWidthAndHeight = function(width, height)
{
	console.log("window: set layout size to: " + width + ' × ' + height);
	this._width = width;
	this._height = height;
};

/**
 * @private
 */
Commands.Window.setWidthAndHeight = function(width, height)
{
	console.log("window: set outer size to: " + width + ' × ' + height);
	this._outerWidth = width;
	this._outerHeight = height;
};

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Element'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Element'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Element'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;

var Element = exports.Element = Class.subclass(
/** @lends UI.Element.prototype */
{
	$subclass: function() {
		if (typeof this._init == 'function') this._init();
		return Class.subclass.apply(this, arguments);
	},
	
	classname: "UI_Element",

	/**
	 * @class The <code>Element</code> class is a base class for derived classes that manage object properties and handle user interface events.<br><br>
	 * <b>Caution!:</b> This base class is not exported in the UI module. Do not access it or subclass it at runtime.
	 * Derived classes from <code>Element</code> include:
	* <div class="ul">
	 * <li>{@link UI.AbstractView}</li>
	 * <li>{@link UI.AlertDialog}</li>
	 * <li>{@link UI.ListViewSection}</li>
	 * <li>{@link UI.ProgressDialog}</li>	 
	 * </div>
	 * @constructs The default constructor. 
	 * @param {String} properties
	 * @augments Core.Class
	*/
	initialize: function(properties) {
		if (Element._init) Element._init();
		
		this.register();
		
		// Enable events that are being handled at the class level...
		var events = this._eventNames;
		if (events) for (var e in events) {
			if (this[events[e]]) Commands.enableEvent.call(this, e);
		}
		
		//	Reimplement setAttributes here for speed
		var setters = this._setters;
		if (setters) for (var k in properties) {
			if (typeof setters[k] == 'function') try {
				setters[k].call(this, properties[k]);
			} catch (e) {
				NgLogD("Unable to set " + this.type + '.' + k);
			}
		}
		
	/*	This is awesome. Maybe use it in production code, but we want to keep
	//	our stylistic constraints for core development.
	
		for (var propName in this._setters) {
			this.__defineSetter__(propName, this._setters[propName]);
		}
		for (propName in this._getters) {
			this.__defineGetter__(propName, this._getters[propName]);
		}
	*/
	
		return this;
	},
	
	register: function() {
		try {
			ObjectRegistry.register(this);
			Commands.create(this.__objectRegistryId, this.type || this.classname);
		} catch (e) {
			// Nothing yet
		} finally {
			return this.__objectRegistryId;
		}
	},
	
	retain: function() {
		(this.__retainCount) ? ++this.__retainCount : (this.__retainCount = 1);
		return this;
	},
	
	release: function() {
		if (--this.__retainCount === 0) {
			this.destroy();
		}
	},
		
	/**
	 * Retrieve the property value of the given key. 
	 * @param {String} key The property keyword.
	 * @returns {String} The current property value.
	 * @see UI.Element#getAttributes,
	 * @see UI.Element#setAttribute,
	 * @see UI.Element#setAttributes
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getAttribute: function(key) {
		var getter = this._getters[key];
		return (typeof getter == 'function') ? getter.call(this) : undefined;
	},
	
	/**
	 * Set the property value for the given key.
	 * @example var glView = new UI.GLView
	 * ...
	 * glView.setAttribute('active', true);
	 * @param {String} key The property keyword.
	 * @param {String} value The new property value.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see UI.Element#getAttribute,
	 * @see UI.Element#getAttributes,
	 * @see UI.Element#setAttributes
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	setAttribute: function(key, value){
		var setter = this._setters[key];
		if (typeof setter == 'function') {
			return setter.call(this, value);
		} else {
			NgLogD("Unable to set " + this.type + '.' + key);
		}
		return this;
	},
	
	/**
	 * Set the property value for each specified key. Property values are passed in as key/value pairs.
	 * @param {Object} dict A dictionary of property key/value pairs.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see UI.Element#getAttribute,
	 * @see UI.Element#getAttributes,
	 * @see UI.Element#setAttribute
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	setAttributes: function(dict) {
		var setters = this._setters;
		if (setters) for (var k in dict) {
			if (typeof setters[k] == 'function') try {
				setters[k].call(this, dict[k]);
			} catch (e) {
				NgLogD("Unable to set " + this.type + '.' + k);
			}
		}
		return this;
	},
	
	/**
	 * Retrieve property values for each specified key. 
	 * @param {String} list A list of property keywords.
	 * @returns {Object} A list of key/value pairs.
	 * @see UI.Element#getAttribute,
	 * @see UI.Element#setAttribute,
	 * @see UI.Element#setAttributes
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getAttributes: function(list) {
		var output = {};
		if (list instanceof Array) {
			var key;
			for (var i = 0; i < list.length; i++) {
				key = list[i];
				output[key] = this._getters[key].call(this);
			}
		} else {
			for (var key in this._getters) {
				output[key] = this._getters[key].call(this);
			}
		}
		return output;
	},

	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	enableEvent: Commands.enableEvent,
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	toString: function() {
		return this.type + '(' + this.__objectRegistryId + ')';
	},

	/**
	 * @function
	 * @description Destroy this instance and release resources on the backend.
	 * @status Javascript, iOS, Android, Flash, Test
	*/
	destroy: function() {
		Commands.destroy.call(this);
		ObjectRegistry.unregister(this);
		delete this.prototype;
		for (var i in this) {
			if (this.hasOwnProperty(i)) {
				delete this[i];
			}
		}
		this._destroyed = true;
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	*/
	registerCallback: function(func, oneTime) {
		var callbackId = ++this.callbackCounter;
		var obj = this;
		this.callbacks[callbackId] = function(obj, args) {
			try {
				func(obj, args);
				if(oneTime) {
					delete obj.callbacks[callbackId];
				}
			}
			catch(e) {
				NgHandleException(e);
			}
		};
		return callbackId;
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	performCallback: function(event) {
		var cb = this.callbacks[event.callbackId];
		if(cb) {
			cb(this, event.arguments);
		}
	},
	
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	performEventCallback: function(event) {
		try {
			// Look up the event by its 'onXXX' name...
			var eName = this._eventNames[event.eventType];
			var fn = this['_'+eName] || this[eName];
			if (typeof fn == 'function') {
				fn.call(this, event);
			}
		}
		catch(e) {
			NgHandleException(e);
		}
	},	
	
	// STATICS: Setter and Getter Registration
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$registerAccessors: function(propName, getterFn, setterFn, deprecationMessage) {
		// Put the new setter / getter functions into the prototype.
		var caseAdjusted = propName.charAt(0).toUpperCase() + propName.substr(1);
		var byKeyOnly = Boolean(deprecationMessage || false);
	//	NgLogD("Synthesizing set" + caseAdjusted + (shouldSetClosure ? " (custom)" : " (standard)") +
	//		" and get" + caseAdjusted + (onGetClosure ? " (custom)" : " (standard)") + " for member variable " + localVar);
	
		// If this is an instance, use the instance. Otherwise, if we are a class constructor, modify the prototype.
		var pType = (this instanceof Element) ? this : this.prototype;
		if (typeof getterFn == 'function') {
			if (!pType.hasOwnProperty('_getters')) {
				try {
					var heritableMap = function() {return this;};
					var superGetters = pType.superclass._getters;
					if (superGetters) heritableMap.prototype = superGetters;
					pType._getters = new heritableMap();
				} catch (e) {};
			}
			if (byKeyOnly) {
				pType['get'+caseAdjusted] = function() {
					NgLogD("WARNING: Use of get" + caseAdjusted + "() is deprecated. " + deprecationMessage);
					getterFn.apply(this, arguments);
				};
			} else {
				pType['get'+caseAdjusted] = getterFn;
			}
			pType._getters[propName] = getterFn;
		}
		if (typeof setterFn == 'function') {
			if (!pType.hasOwnProperty('_setters')) {
				try {
					var heritableMap = function() {return this;};
					var superSetters = pType.superclass._setters;
					if (superSetters) heritableMap.prototype = superSetters;
					pType._setters = new heritableMap();
				} catch (e) {};
			}
			if (byKeyOnly) {
				pType['set'+caseAdjusted] = function() {
					NgLogD("WARNING: Calling set" + caseAdjusted + "() is deprecated. " + deprecationMessage);
					setterFn.apply(this, arguments);
				}
			} else {
				pType['set'+caseAdjusted] = setterFn;
			}
			pType._setters[propName] = setterFn;
		}
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$registerEventType: function(eventName) {
		var onEventName = 'on' + eventName.charAt(0).toUpperCase() + eventName.substr(1);
		var localVar = '_' + onEventName;
		var pType = this.prototype;
		
		var getterFn = function() {
			return this[localVar] || this[onEventName];
		};
		var setterFn = function(callback) {
			var isFn = (typeof callback == 'function');
			if (isFn) {
				this[localVar] = callback;
			} else {
				delete this[localVar];
			}
			this.enableEvent(eventName, isFn);
		};
		if (!pType.hasOwnProperty('_eventNames')) {
			try {
				var heritableMap = function() {return this;};
				var superEvents = pType.superclass._eventNames;
				if (superEvents) heritableMap.prototype = superEvents;
				pType._eventNames = new heritableMap();
			} catch (e) {};
		}
		pType._eventNames[eventName] = onEventName;
		
		this.registerAccessors(onEventName, getterFn, setterFn);
		
		// Legacy support. Let's concentrate on removing this soon or at least fixing the casing.
		pType.__defineGetter__(onEventName.toLowerCase(), getterFn);
		pType.__defineSetter__(onEventName.toLowerCase(), setterFn);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$synthesizePropertyWithState: function(propName, CommandsFn) {
		var lVarName = '_' + propName + 'Map';
		var setterFn;
		if (propName) {
			setterFn = function(value, optState) {
				optState |= 0;
			//	NgLogD("Set " + this.type + "." + propName + "[" + optState + "] = " + value);
				(this[lVarName] || (this[lVarName] = {}))[optState] = value;
				CommandsFn.call(this, optState, value);
				return this;
			};
		} else {
			setterFn = function(value, optState) {
				CommandsFn.call(this, (optState | 0), value);
				return this;
			};
		}
		
		var getterFn = function(state) {
			return (this[lVarName] || 0)[(state | 0)];
		};
		
		this.registerAccessors(propName, getterFn, setterFn);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$synthesizeCompoundProperty: function(propName, CommandsFn) {
		var lVarName = '_' + propName;
		var setterFn;
		if (CommandsFn) {
			// Synthesized setters accept EITHER an array of reasonable length OR individual args.
			setterFn = function(args) {
				this[lVarName] = (args instanceof Array)
					? args
					: Array.prototype.slice.call(arguments);
				CommandsFn.apply(this, this[lVarName]);
				return this;
			}
		} else {
			setterFn = function(args) {
				this[lVarName] = (args instanceof Array) ? args : Array.prototype.slice.call(arguments);
				return this;
			}
		}
		
		this.registerAccessors(propName, function() {return this[lVarName];} , setterFn);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$synthesizeProperty: function(propName, CommandsFn) {
		var lVarName = '_' + propName;
		var setterFn;
		if (CommandsFn) {
			// Optional args are still passed through, even though only the first arg is assigned.
			setterFn = function(arg) {
				this[lVarName] = arg;
				CommandsFn.apply(this, arguments);
				return this;
			}
		} else {
			setterFn = function(arg) {
				this[lVarName] = arg;
				return this;
			}
		}
		
		this.registerAccessors(propName, function() {return this[lVarName];} , setterFn);
	}
});


// Event Handlers
Element._init = function() {
	delete Element._init;
	
	/**
	 * @name UI.Element#setOnLoad
	 * @description Set a function to call when the <code>load</code> event occurs.
	 * @param {Function} loadCallback The new functoin to call.<br><br><b>Note:</b> The <code>load</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onLoad.loaded = true; 
	 * };
	 * @see UI.Element#event:getOnLoad
	 * @event
	 */
	/**
	 * @name UI.Element#getOnLoad
	 * @description Retrieve the function to call when the <code>load</code> event occurs.
	 * @returns {Function} The current function to call.
	 * @see UI.Element#event:setOnLoad
	 * @event
	 */
	Element.registerEventType('load');
	/**
	 * @name UI.Element#setOnUnload
	 * @description Set a function to call when the <code>unload</code> event occurs.
	 * @param {Function} unloadCallback The new functoin to call.<br><br><b>Note:</b> The <code>unload</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onUnload.unloaded = true; 
	 * };
	 * @see UI.Element#event:getOnUnload	
	 * @event
	 */
	/**
	 * @name UI.Element#getOnUnload
	 * @description Retrieve the function to call when the <code>unload</code> event occurs.
	 * @returns {Function} The current function to call.
	 * @see UI.Element#event:setOnUnload	 
	 * @event
	 */
	Element.registerEventType('unload');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/View'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/View'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/View'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Window = require('NGCore/Client/UI/Window').Window;

var ViewParent = require('NGCore/Client/UI/ViewParent').ViewParent;

var View = exports.View = AbstractView.subclass(
/** @lends UI.View.prototype */
{
	'type':'view',

	/**	 
	 * @class The <code>View</code> class is a base class for derived classes that handle application views. Derived classes from <code>View</code> include:
	 * <div class="ul">
	 * <li>{@link UI.ScrollView}</li>
	 * <li>{@link UI.Toast}</li>
	 * </div>
	 * @constructs The default constructor. 
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties Object properties.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (View._init) View._init();
		ViewParent.initialize.call(this);
		return $super(properties);
	},
	/**
	* Add a child node to this <code>View</code> at the specified index.
	* @example var mainView = new UI.View();
	* ...
	* var errorView = new UI.View();
	* ...
	* mainView.addChild(errorView);
	* @param {GL2.Node} childNode The child node to add.
	* @param {Number} index The specified index.
	* @throws {this.type + ".addChild: " + childNode + " is not a view!"} Specified node is not attached to a view.
	* @returns This function returns <code>this</code> to support method invocation chaining.
	* @see UI.View#removeChild
    * @status iOS, Android, Test
	*/
	addChild: ViewParent.addChild,
	
	/**
	* Remove a child node from this <code>View</code> at the specified index.
	* @example mainView.removeChild(errorView);
	* @param {GL2.Node} childNode The child node to remove.
	* @throws {this.type + ".removeChild: " + childNode + " is not a view!} Specified node is not attached to a view.
	* @returns The child node that was removed.
	* @see UI.View#addChild
    * @status iOS, Android, Test
	*/    
	removeChild: ViewParent.removeChild,


	/**
	 * Retrieve a count of the child nodes attached to this <code>View</code>.
	 * @return {Number} The current number of child nodes.
	 * @status Javascript, iOS, Android, Flash
	 */
	getChildCount: ViewParent.getChildCount,

	/**
	 * Retrieve the child nodes attached to this <code>View</code>.
	 * @return {Object} All attached children nodes.
	 * @status Javascript, iOS, Android, Flash
	 */
	getChildren: ViewParent.getChildren,

	/**
	 * @function
	 * @description Override this for custom view subclass layout code.
	 */
	layoutSubviews: function() {
		//Override this for custom view subclass layout code
	},
	/** @protected */
	_style:null,
	/**
	 * Retrieve the style for this <code>View</code>.
	 * @returns {UI.Style} The current <code>View</code> style.
	 * @see UI.View#setStyle
	 * @status Javascript, iOS, Android, Flash
	 */
	getStyle:function(){
		return this._style;
	},
	/**
	 * Set the style for this <code>View</code>. This call allows custom view objects to process and update their styles more easily.
	 * @param {UI.Style} style The new <code>View</code> style.
	 * @see UI.View#getStyle
	 * @status Javascript, iOS, Android, Flash
	 */
	setStyle: function(/*UI.Style*/style) {
		//Override this for custom view subclass styling code
		this._style = style;
	},
	
	/**
	 * @protected
	 * @function
	 * @status Javascript, iOS, Android, Flash
	 */
	_setVisible: function($super, makeVisible) {
		var wasVisible = this._visible;
		$super(makeVisible);
		if (this._visible != wasVisible) {
			var l = this._children.length;
			for (var i = 0; i < l; i++) {
				this._children[i]._setVisible(makeVisible);
			}
		}
	},
});

// Properties
View._init = function() {
	delete View._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.View#setImage
	 * @description Set an image URL for a view state. This property defines a remote image resource to use in arbitrary contexts.
	 * @example var someSprite = new UI.View();        
	 * someSprite.setImage('./Content/mySprite.png', [w, h], [0, 0]);
	 * @see UI.View#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] A set of flags describing the view state(s) for using this URL.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.View#getImage
	 * @description Retrieve the <code>image</code> URL for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state.
	 * @see UI.View#setImage
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	View.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.View#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.View#getImageBorder
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.View#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.View#setImageBorder
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	View.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	/**
	 * @name UI.View#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how an image is positioned within a viewable area.
	 * @example var someSprite = new UI.View();
	 * ...
	 * someSprite.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> (expressed as two floats).
	 * @see UI.View#getImageGravity
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.View#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> (expressed as two floats).
	 * @see UI.View#setImageGravity
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	View.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
	/**
	 * @name UI.View#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example var someSprite = new UI.View();
	 * ...
	 * someSprite.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.View#getImageFit
	 * @function
	 */
	/**
	 * @name UI.View#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.View#setImageFit
	 * @function
 	 * @status 
	 */
	View.synthesizeProperty('imageFit', Commands.setImageFitMode);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		//** extra-deprecated */
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing View." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			View.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('image');
	bindStateProperties('imageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Label'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Label'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Label'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Label = exports.Label = AbstractView.subclass(
/** @lends UI.Label.prototype */
{
	'type':'label',
	/**
	 * @name UI.Label
	 * @class The <code>Label</code> class constructs objects for managing strings that are used as application labels. 
	 * These objects include access to a wide range of attributes for manipulating the look and feel of application labels.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (Label._init) Label._init();
		$super(properties);
	}
});

Label._init = function() {
	delete Label._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.Label#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use as a label in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setText("Friends List");
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getText
	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>text</code>.
	 * @see UI.Label#setText
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('text', Commands.setText);	
	/**
	 * @name UI.Label#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getTextFont
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code>.
	 * @see UI.Label#setTextFont
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('textFont', Commands.setTextFont);
	/**
	 * @name UI.Label#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string for a label in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextColor('FFFF');
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getTextColor
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code>.
	 * @see UI.Label#setTextColor
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.Label#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on labels in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextShadow("FF00 2.0 {0,-1}");
	 * @param {String} textShadow The new value for <code>textShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getTextShadow
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.
	 * @see UI.Label#setTextShadow
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	
	/**
	 * @name UI.Label#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property for this <code>Label</code>. This property defines how a text string is positioned within a viewable area.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a single array of components.
	 * @see UI.Label#getTextGravity
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property for this <code>Label</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.Label#setTextGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);
	/**
	 * @name UI.Label#setTextSize
	 * @description Set the value of the <code>textSize</code> property for this <code>Label</code>. This property defines the size of text strings for a label.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextGravity(24);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.Label#getTextSize
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property for this <code>Label</code>.
	 * @returns {Number} The current value of <code>textSize</code>.
	 * @see UI.Label#setTextSize
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizeProperty('textSize', Commands.setTextSize);

	/**
	 * @name UI.Label#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property for this <code>Label</code>. This property defines the viewable area of a text string when applying gravity.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextInsets(0, 0, 0, 64);
	 * @param {Number, Array (Number)} textInsets The new value for <code>textInsets</code>. Set as individual components or a single array of components.
	 * @see UI.Label#getTextInsets
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property for this <code>Label</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textInsets</code>.
	 * @see UI.Label#setTextInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
			// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Label." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			Label.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('text');
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Image'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Image'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Image'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Image = exports.Image = AbstractView.subclass(
/** @lends UI.Image.prototype */
{
	/**
	 * @name UI.Image
	 * @class The <code>Image</code> class constructs objects that control the location and size of images used in the user interface.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (Image._init) Image._init();
		$super(properties);
	},
	
	'type':'image'
});


// Properties
Image._init = function() {
	delete Image._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.Image#setImage
	 * @description Set an image URL for a view state. This property defines how an image appears for specific conditions. For example,
	 * set one image for the default view state and another image for a view state with focus.
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImage('./Content/splash.png');
	 * @see UI.Image#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] A set of flags describing the view state(s) for using this URL.
	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.Image#getImage
	 * @description Retrieve the <code>image</code> URL for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state..
	 * @see UI.Image#setImage
	 * @status iOS, Android, Test
	 * @function
	 */
	Image.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.Image#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Image#getImageBorder
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Image#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.Image#setImageBorder
	 * @function
	 * @status iOS, Android, Test
	 */
	Image.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	/**
	 * @name UI.Image#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how an image is positioned within a viewable area.
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> expressed as two floats.
	 * @see UI.Image#getImageGravity
	 * @function
	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Image#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> expressed as two floats.
	 * @see UI.Image#setImageGravity
	 * @function
	 * @status iOS, Android, Test
	 */
	Image.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
	 /**
	 * @name UI.Image#setImageTransform
	 * @description Set the value of the <code>imageTransform</code> property. This property defines data compression for images.
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} imageTransform The new value for <code>imageTransform</code>. 
	 * Set as an array of floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.Image#getImageTransform
	 * @function
	 */
	/**
	 * @name UI.Image#getImageTransform
	 * @description Retrieve the value of the <code>imageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>imageTransform</code>.
	 * @see UI.Image#setImageTransform
	 * @function
	 */
	 Image.synthesizeCompoundProperty('imageTransform', Commands.setImageTransform);
	/**
	 * @name UI.Image#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.Image#getImageFit
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Image#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.Image#setImageFit
	 * @function
 	 * @status iOS, Android, Test
	 */
	Image.synthesizeProperty('imageFit', Commands.setImageFitMode);
	
		// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Image." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			Image.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('image');
    bindStateProperties('imageBorder');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Button'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Button'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Button'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Button = exports.Button = AbstractView.subclass(
/** @lends UI.Button.prototype */
{
	/**
	 * @name UI.Button
	 * @class The <code>Button</code> class constructs objects that are used as application buttons.
	 * @augments UI.AbstractView
	 */
	'type':'button',

	'Layout':Commands.ButtonLayout,
	
	initialize: function($super, properties) {
		if (Button._init) Button._init();
		$super(properties);
	}
});

// Properties
Button._init = function() {
	delete Button._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.Button#setImage
	 * @description Set an image URL for a view state. This defines how buttons appear for specific conditions. For example, 
	 * set different images for a button in the default view state and a button when it is pressed.
	 * @example var backButton = new UI.Button();        
	 * backButton.setImage('./Content/backButton.png', [w, h], [0, 0]);
	 * @see UI.Button#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] A set of flags describing the view state(s) for using this URL.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.Button#getImage
	 * @description Retrieve the <code>image</code> URL for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state..
	 * @see UI.Button#setImage
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.Button#setImageInsets
	 * @description Set the value of the <code>imageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example var backButton = new UI.Button();
	 * ...
	 * backButton.setImageInset([10,10,10,10]);
	 * @param {Number, Array (Number)} imageInsets The new value for <code>imageInsets</code>. Set as insets or an array of insets (expressed as floats).
	 * @see UI.Button#getImageInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getImageInsets
	 * @description Retrieve the value of the <code>imageInsets</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>imageInsets</code>.
	 * @see UI.Button#setImageInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeCompoundProperty('imageInsets', Commands.setImageInsets);
	/**
	 * @name UI.Button#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example var backButton = new UI.Button();
	 * ...
	 * backButton.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.Button#getImageFit
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Button#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.Button#setImageFit
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizeProperty('imageFit', Commands.setImageFitMode);
	/**
	 * @name UI.Button#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how a image for a button is positioned within a viewable area.
	 * @example var backButton = new UI.Button();
	 * ...
	 * backButton.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> (expressed as two floats).
	 * @see UI.Button#getImageGravity
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Button#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> (expressed as two floats).
	 * @see UI.Button#setImageGravity
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
	/**
	 * @name UI.Button#setImageTransform
	 * @description Set the value of the <code>imageTransform</code> property. This property defines data compression for an image used as a button.
	 * @example var button = new UI.Button()
	 * ...
	 * button.setImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} imageTransform The new value for <code>imageTransform</code>. 
	 * Set as an array of floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.Button#getImageTransform
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.Button#getImageTransform
	 * @description Retrieve the value of the <code>imageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>imageTransform</code>.
	 * @see UI.Button#setImageTransform
 	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	Button.synthesizeCompoundProperty('imageTransform', Commands.setImageTransform);
	/**
	 * @name UI.Button#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Button#getImageBorder
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.Button#setImageBorder
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	
	/**
	 * @name UI.Button#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use as a label for a button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setText("More information");
	 * @see UI.Button#getText
	 * @param {String} text The new value for <code>text</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code> in the specified view state..
	 * @see UI.Button#setText
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('text', Commands.setText);
	/**
	 * @name UI.Button#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string used as a label on a 
	 * button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextColor('FFFFFF');
	 * @see UI.Button#getTextColor
	 * @param {String} textColor The new value for <code>textColor</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.Button#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code> in the specified view state..
	 * @see UI.Button#setTextColor
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.Button#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels for a button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Button#getTextFont
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code> in the specified view state.
	 * @see UI.Button#setTextFont
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('textFont', Commands.setTextFont);
	/**
	 * @name UI.Button#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on text strings for a button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextShadow("FF00 2.0 {0,-1}");
	 * @see UI.Button#getTextShadow
	 * @param {String} textShadow The new value for <code>textShadow</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code> in the specified view state..
	 * @see UI.Button#setTextShadow	
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	/**
	 * @name UI.Button#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property. This property defines how a text string for a button is positioned within a viewable area.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a single array of components.
	 * @see UI.Button#getTextGravity
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.Button#setTextGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);

	/**
	 * @name UI.Button#setTextSize
	 * @description Set the value of the <code>textSize</code> property. This property defines the text size of labels for a button.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextSize(24);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.Button#getTextSize
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property.
	 * @returns {Number} The current value for <code>textSize</code>.
	 * @see UI.Button#setTextSize
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.Button#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property. This property defines the viewable area of a text string when applying gravity.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextInsets(0, 0, 0, 64);
	 * @param {Array (Number)} textInsets The new value for <code>textInsets</code>.
	 * @see UI.Button#getTextInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property.
	 * @returns {Array (Number)} The curent value for <code>textInsets</code>.
	 * @see UI.Button#setTextInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		//** extra-deprecated */
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			Button.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('text');
	bindStateProperties('textColor');
    bindStateProperties('textFont');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
	bindStateProperties('image');
    bindStateProperties('imageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/GLView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/GLView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/GLView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var GLView = exports.GLView = AbstractView.subclass(
/** @lends UI.GLView.prototype */
{
	'type':'glview',
	/**
	* @class The <code>GLView</code> class constructs objects that provide applications with access to OpenGL. Games must instantiate a <code>GLView</code> object, 
	* set the active state to <code>true</code> and wait for the callback before instantiating any objects in the {@link GL2} module.
	* @name UI.GLView
	* @augments UI.AbstractView	
	*/
	initialize: function($super, properties) {
		if (GLView._init) GLView._init();
		$super(properties);
	}
});

GLView._init = function() {
	delete GLView._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.GLView#setActive
	 * @description Set the value of the <code>active</code> property.
	 * @example var glView = new UI.GLView()
	 * ...
	 * glView.setActive(true);
	 * @param {Boolean} active Set as <code>true</code> if the <code>GLView</code> object is active.
	 * @see UI.GLView#getActive
	 * @status iOS, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.GLView#getActive
	 * @description Retrieve the value of the <code>active</code> property.
	 * @returns {Boolean} Returns <code>true</code> if the <code>GLView</code> object is active.
	 * @see UI.GLView#setActive
	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	GLView.synthesizeProperty('active', Commands.setActive);
	
	/**
	 * @name UI.GLView#getOGLExtensions
	 * @description Return an array containing all of the OpenGL extensions that are supported within the context of this view.
	 * The return value of this method is only valid when the view is active.
	 * @status Android
	 * @function
	 */
	GLView.registerAccessors('OGLExtensions', function() {return this['_OGLExtensions'];}, function() {} );
	
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/NavController'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/NavController'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/NavController'] = exports; var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
var KeyEmitter = require('NGCore/Client/Device/KeyEmitter').KeyEmitter;
var Window = require('NGCore/Client/UI/Window').Window;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Device = require('NGCore/Client/Device').Device;
var Element = require('NGCore/Client/UI/Element').Element;
var View = require('NGCore/Client/UI/View').View;

function getAnalyticsName(item){
	if(item && item.hasOwnProperty("analyticsName")){
		return item["analyticsName"] || undefined;	// If NULL, return undefined.
	}
	return undefined;
}

var NavKeyListener = MessageListener.subclass({
	classname: "UI_NavController_KeyListener",
});

var NavController = exports.NavController = View.subclass(
/** @lends UI.NavController.prototype */
{
	/**
	 * @class The <code>NavController</code> class constructs objects that define application navigation components.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties Object properties.
	 */
	initialize: function($super, properties) {
		if (NavController._init) NavController._init();
		
	    this.navStack = [];
		var onAndroid = Capabilities.getPlatformOS() == 'Android';
	    this._useBackButton = !onAndroid;
	
		this.keyListener = new NavKeyListener();
		KeyEmitter.addListener(this.keyListener, this.onKeyPressed.bind(this));
		$super(properties);
	},
	
	/**
	 * Turn on the onscreen <b>Back</b> button. Applications designed for iOS should always provide the <b>Back</b> button 
	 * and integrate it into the application UI (calling <code>{@link UI.NavController#back}</code> when pressed).<br><br>
	 * <b>Note:</b> This is turned off by default for applcations designed for Android because Android devices contain a hardware <b>Back</b> button.
	 * @param {Boolean} toUse Set as <code>true</code> to enable the onscreen <b>Back</b> button.
	 * @function
	 * @status Javascript, iOS, Android, Flash
	 */
	setUseBackButton: function(toUse) {
		this._useBackButton = toUse;
		if (toUse) {
			this._createBackButton();
		} else if (this.backButton) {
			this.backButton.removeFromParent();
		}
	},
    
	/**
	 * Reset the stack for this <code>NavController</code>.
	 * @param {String} fromButton The button to reset.
	 * @status Javascript, iOS, Android, Flash
	 */    
	clear: function(fromButton) {
		return this.backToView(undefined);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	logNavEvent: function (from, to, via) {
		var toName = getAnalyticsName(to);
		var fromName = getAnalyticsName(from);
		var viaName = getAnalyticsName(via);
		if (fromName || toName) {
			Core.Analytics._getPipe().navigationEvent(fromName, toName, viaName);
		}
	},
	
	/**
	 * Retrieve the top view from the nav stack of this <code>NavController</code>.
	 * @returns {Object} The top view in the nav stack
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	getTopView: function() {
		return (this.navStack.length > 0) ? this.navStack[ (this.navStack.length - 1) ] : undefined;
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	navStackDepth: function() {
		return this.navStack.length;
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	depthOfView: function(targetView) {
		var targetIndex = this.navStack.indexOf(targetView);
		if(targetIndex == -1){return -1;}
		
		return this.navStack.length - targetIndex - 1;
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	viewAtDepth: function(targetDepth) {
		if(targetDepth >= this.navStack.length){
			return null;
		}
		return this.navStack[this.navStack.length - targetDepth - 1];
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	removeDeepView:function(targetView) {
		var targetIndex = this.navStack.indexOf(targetView);
		if(targetIndex == -1){
			NgLogE("NavController: trying to remove a nonexistent view from the nav stack!");
			return;
		}
		this.navStack.splice(targetIndex,1);
	},
    
	/**
	 * @protected
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	_viewTransition: function(fromView, toView, back, buttonRef) {
		//The views transition within the container (which is 'this')
		var myFrame = this.getFrame();
		var w = myFrame[2];
		var h = myFrame[3];
		
		//TODO: animate this (below) transition.
		if (toView) {
			toView.setFrame( (back ? -w : w), 0, w, h);
			this.addChild(toView);
		}
		
		UI.animate(function() {
			if (fromView) fromView.setFrame( (back ? w : -w), 0, w, h);
			if (toView) toView.setFrame(0, 0, w, h);
		}, 400, function() {
			if (fromView) fromView.removeFromParent();
		});
		
		this.logNavEvent(fromView, toView, buttonRef);
		this._createBackButton();
	},

	/**
	 * Retrieve removed views in the reverse order they were removed.
	 * @example var page = new NavPage({...});
	 *
	 * var controller = new UI.NavController({...});
	 *
	 * NavPage.navController = controller;
	 * controller.forwardToView(page);
	 * @param {String} destView The destination view for this navigation component.
	 * @param {String} fromButton The button that triggers this navigation component.
	 * @status Javascript, iOS, Android, Flash
	 * @see UI.NavController#backToView
	 */    
	forwardToView: function(destView, fromButton) {
		var currentView = this.getTopView();
		if (destView && 
			(!this._delegate 
				|| (this._delegate 
					&& typeof this._delegate.navControllerShouldPush == "function" 
					&& this._delegate.navControllerShouldPush(this,destView))
			)) {
			
			destView.performEventCallback({eventType:"push",navController:this})
			
			this.navStack.push(destView);
			this._viewTransition(currentView, destView, false, fromButton);
		}
	},
    
	/**
	 * Set back navigation for this <code>NavController</code>.
	 * @param {String} fromButton The button that triggers this navigation component.
	 * @status Javascript, iOS, Android, Flash
	 * @see UI.NavController#forward	
	 */
	back: function(fromButton) {
		var removed = this.navStack.pop();
		
		if (removed && 
			(!this._delegate 
				|| (this._delegate 
					&& typeof this._delegate.navControllerShouldPop == "function" 
					&& this._delegate.navControllerShouldPop(this,removed))
			)) {
			removed.performEventCallback({eventType:"pop",navController:this});
		} else {
			return null;
		}
		this._viewTransition(removed, this.getTopView(), true, fromButton);
		return removed;
	},

	/**
	 * Retrieve removed views in the order they were removed.
	 * @example var page = new NavPage({...});
	 *
	 * var controller = new UI.NavController({...});
	 *
	 * NavPage.navController = controller;
	 * controller.backToView(page);
	 * @param {String} destView The destination view for this navigation component.
	 * @param {String} fromButton The button that triggers this navigation component.
	 * @status Javascript, iOS, Android, Flash
	 * @see UI.NavController#forwardToView
	 */    
	backToView: function(destView, fromButton) {
		var removedSet = [];
		var removed = this.navStack.pop();
		var originalView = removed;
		if (removed) {
			do {
				if (removed && 
					(!this._delegate 
						|| (this._delegate 
							&& typeof this._delegate.navControllerShouldPop == "function" 
							&& this._delegate.navControllerShouldPop(this,removed))
					)) {
					removedSet.push(removed);
					removed.performEventCallback({eventType:"pop",navController:this});
				}
				else {
					//There was nothing to remove, or the this._delegate said "don't remove".
					break;
				}
				
				if (this.getTopView() == destView){break;}
			} while ((removed = this.navStack.pop()));
		}
		if(removedSet.length > 0) {
			this._viewTransition(originalView, this.getTopView(), true, fromButton);
		}
		return removedSet;
	},

	/**
	 * Set this <code>NavController</code> to launch the application when activated.
	 * @status Javascript, iOS, Android, Flash
	 */    
	loadApp: function() {		
	},
    
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */    
	onBackPressed: function() {
		if (this.navStack.length > 1) {
		//	NgLogD("Handle back on nav stack. Number of views on stack=" + this.navStack.length);
			
			var analyticsName = "bcksbtn"; // Back System Button
			
			// if the topmost view has an analytics name, prefix the button
			var topView = this.getTopView();
			if(topView.analyticsName){
				analyticsName = topView.analyticsName + "." + analyticsName;
			}

			this.back({
				analyticsName: analyticsName
			});
			return true;
		}
		return false;
	},
	
	onKeyPressed: function(event) {
		if ((event.code === Device.KeyEmitter.Keycode.back) && (this.navStack.length > 1)) {
			this.back();
			return true;
		}
		return false;
	},
	
	/**
	 * @protected
	 * @status Javascript, iOS, Android, Flash
	 */
	_delegate:null,
	/**
	 * @description Set subscribers to the <code>NavController</code> behavior. Subscribers can modify what happens. 
	 * NavControllerDelegateProtocol:
	 *	@optional - (BOOL)navControllerShouldPop(NavController,View)
	 *	@optional - (BOOL)navControllerShouldPush(NavController,View)
	 * @param {String} navDelegate A <code>NavController</code> subscriber.
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	setDelegate:function( /*NavControllerDelegate*/ navDelegate){
		this._delegate = navDelegate;
	},
	
	delegate:function(){return this._delegate;},
	
	/**
	 * @protected
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	_createBackButton: function() {
		// Do nothing if this device does not require an onscreen button.
		if (!this._useBackButton) return;
		
		if (!this.backButton) {
			this.backButton = new UI.Button({
				normalText: 'Back',
				textSize: 13.0,
				normalTextColor: "FF",
				normalTextShadow: "00 1.5 {0,-1}",
				frame: [-2, 20, Window.outerWidth / 5, Window.outerHeight / 12],
				normalGradient: {
					corners: "0 8 8 0",
					outerLine: "00 1.5",
					innerShadow: "99FF 2.0 {0,-1}",
					gradient: [
						"FFCC 0.0",
						"FF80 1.0"
					]
				},
				highlightedGradient: {
					corners: "0 8 8 0",
					outerLine: "00 1.5",
					innerLine: "FF00 15 {0,-1}",
					gradient: [
						"FF50 0.0",
						"FF80 1.0"
					]
				}
			});
			this.backButton.onclick = this.bind(this.onBackPressed);
		}
		
		if (this.navStack.length > 1) {
			if (!this.backButton.getParent()) Window.document.addChild(this.backButton);
		} else if ( this.backButton.getParent() ) {
			this.backButton.removeFromParent();
		}
	}
});

NavController._init = function() {
	delete NavController._init;
	if (View._init) View._init();
}; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/WebView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/WebView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/WebView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var WebView = exports.WebView = AbstractView.subclass(
/** @lends UI.WebView.prototype */
{
	'type':'webview',

	/**
	 * @class The <code>WebView</code> class constructs objects for loading and navigating documents. 
	 * <code>WebView</code> objects also trigger event callback functions when web page events occur.
	 * @constructs The default constructor. 
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties Object properties.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (WebView._init) WebView._init();
		this._canGoBack = false;
		this._canGoForward = false;
		return $super(properties);
	},
	
	/** @private */
	_onShouldLoad: function(event) {
		NgLogD("Should Load " + event.url + " ???????");
		var fn = this.getOnShouldload();
		if (typeof fn == 'function') {
			// If we SHOULDN'T load the url, bail.
			if (!Boolean(fn.call(this, event))) return;
		}
		// The default (if the function was missing or not a function) is to load the url.
		this.loadUrl(event.url);
	},
	
	/** @private */
	performEventCallback: function($super, event) {
		try {
			if (event.eventType == 'shouldload') {
				// We need to call the onShouldLoad function in a way that captures the return value.
				this._onShouldLoad(event);
				return;
			}
			if (event.eventType == 'pageload') {
				// Do not touch this parsing code. Everything else is wrong, extensive testing was done.
				this._canGoBack = event.canGoBack = Boolean(JSON.parse(event.canGoBack));
				this._canGoForward = event.canGoForward = Boolean(JSON.parse(event.canGoForward));
			}
			$super(event);
		} catch(e) {
			NgHandleException(e);
		}
	},
	// invoke doesn't return a value. to get response, use onpageevent
	/**
	* Run a string of Javascript code in this <code>WebView</code>. Any code requiring a result from <code>invoke()</code> must explicitly 
	* return a value by attempting to load an ngcore:// URL. The attempted load is caught by <code>pageEvent</code>. 
	* @see UI.WebView#event:setOnPageevent
	* @function
    * @status iOS, Android
	*/
	invoke: Commands.invoke,
	/**
	* Set a document to load from the specified URL.
	* @example myWebView = new UI.WebView();
	* ...
	* myWebView.loadUrl('http://www.webdoc.com/");
	* @param {String} url The URL from which to load a document.
	* @param {String} [headers] The document headers.
	* @param {Number} [timeout] The timeout duration.
	* @see UI.WebView#loadDocument
    * @status iOS, Android
	*/
	loadUrl: function(url, headers, timeout) {
		Commands.loadURL.call(this, url, headers || null, +(timeout || 0));
	},
	/**
	* Set a document to load from the specified local path.
	* @example myWebView = new UI.WebView();
	* ...
	* myWebView.loadUrl('./path/to/document/");
	* @param {String} relativePath The local path from which to load a document.
	* @see UI.WebView#loadUrl
    * @status iOS, Android
	*/
	loadDocument: function(relativePath){
		Commands.setSourceDocument.call(this, relativePath);
	},
	/**
	* Load a URL using the HTTP <code>POST</code> method.
	* @param {String} url The URL to load using <code>POST</code>.
	* @param {String / Object} data A string containing the raw <code>POST</code> body, or an object to post with <code>www/form-data</code> encoding containing key/value pairs.
	* @see UI.WebView#loadUrl,
	* @see UI.WebView#loadDocument
    * @status iOS, Android
	*/
	postUrl: function(url, data){
		var dataStr;
		if(typeof data == "object"){
			var params = [];
			for(var key in data){
				params.push(encodeURIComponent(key) + '=' + encodeURIComponent(data[key]));
			}
			dataStr = params.join('&');
		}else{
			dataStr = data;
		}
		Commands.postURL.call(this, url, dataStr);
	},
	/**
	* Stop loading a document. 
	* @function
    * @status iOS, Android
	*/
	stopLoading: Commands.stopLoading,
	/**
	* Reload a document called with <code>loadDocument()</code> or <code>loadUrl()</code>.
	* @see UI.WebView#loadDocument,
	* @see UI.WebView#loadUrl
	* @function
    * @status iOS, Android
	*/
	reload: Commands.reload,
	/**
	* Navigate to the previous page in a document view.
	* @see UI.WebView#goForward
	* @function
    * @status iOS, Android
	*/
	goBack: Commands.goBack,
	/**
	* Navigate to the next page in a document view.
	* @see UI.WebView#goBack
	* @function
    * @status iOS, Android
	*/
	goForward: Commands.goForward,
	/**
	* Set back navigation as supported in this <code>WebView</code>.
	* @returns {Boolean} Returns <code>true</code> if this <code>WebView</code> supports back navigation.
	* @see UI.WebView#canGoForward
    * @status iOS
	*/
	canGoBack: function(){
		return this._canGoBack;
	},
	/**
	* Set that forward navigation is supported in this <code>WebView</code>.
	* @returns {Boolean} Returns <code>true</code> if this <code>WebView</code> supports forward navigation.
	* @see UI.WebView#canGoBack
    * @status iOS
	*/
	canGoForward: function(){
		return this._canGoForward;
	},
	/**
	* Set the authentication credentials for this <code>WebView</code> session.
	* @param {String} host The authentication host.
	* @param {String} realm The security realm.
	* @param {String} username The username to use for authenticating the session.
	* @param {String} password The password to use for authenticating the session.
    * @status iOS, Android
	*/
	setBasicAuthCredential: function(host, realm, username, password){
		Commands.setBasicAuthCredentials.call(this, {'host':host, 'realm':realm, 'username':username, 'password':password});
	},

	setViewportEnabled: function(enabled) {
		Commands.setViewportEnabled.call(this, enabled);
	}
});

WebView._init = function() {
	delete WebView._init;
	if (AbstractView._init) AbstractView._init();
	
	WebView.synthesizeProperty('scrollable', Commands.setScrollable);
	
	/**
	 * @name UI.WebView#setOnStartload
	 * @description Set a function to call when the <code>startload</code> event occurs.
	 * @param {Function} startloadCallback The function to call.<br><br>
	 * <b>Note:</b> The <code>startload</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnStartload
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnStartload
	 * @description Retrieve the function to call when the <code>startload</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnStartload
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('startload');
	/**
	 * @name UI.WebView#setOnPageload
	 * @description Set a function to call when the <code>pageload</code> event occurs.
	 * @param {Function} pageloadCallback The function to call.<br><br>
	 * <b>Note:</b> The <code>pageload</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnPageload
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnPageload
	 * @description Retrieve the function to call when the <code>pageload</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnPageload
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('pageload');
	/**
	 * @name UI.WebView#setOnError
	 * @description Set a function to call when the <code>error</code> event occurs.
	 * @param {Function} [errorCallback] The function to call.<br><br>
	 * <b>Note:</b> The <code>error</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnError
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnError
	 * @description Retrieve the function to call when the <code>error</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnError
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('error');
	/**
	 * @name UI.WebView#setOnPageevent
	 * @description Set a function to call when the <code>pageevent</code> event occurs.
	 * @param {Function} pageeventCallback The new callback function.<br><br>
	 * <b>Note:</b> The <code>pageevent</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnPageevent
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnPageevent
	 * @description Retrieve the function to call when the <code>pageevent</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnPageevent
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('pageevent');	
	/** 
	* @name UI.WebView#setOnShouldLoad
	* @description Set a function to call when the <code>shouldload</code> event occurs. The callback for the event returns 
	* <code>true</code> if the page should be loaded. Otherwise, the callback returns <code>false</code>.
	* @param {function} shouldloadCallback The new callback function.<br><br>
	* <b>Note:</b> The <code>shouldload</code> event is disabled if the value of this parameter is not a function.
	* @example  myWebView.setOnShouldload( function(event) {
	NgLogD("URL is " + event.url);
	NgLogD("Nav Type is " + event.navigation);
  } );
	* @see UI.WebView#event:getOnShouldLoad
	* @event
	*/
	/**
	* @name UI.WebView#getOnShouldLoad
	* @description Retrieve the function to call when the <code>shouldload</code> event occurs.
	* @returns {function} The current callback function.
	* @see UI.WebView#event:setOnShouldLoad
	* @event
	*/
	WebView.registerEventType('shouldload');
	
	/** 
	* @name UI.WebView#setOnExternalLink
	* @description Set a function to call when a link will be opened in an external application.
	* @param {function} ExternalLinkCallback The new callback function.<br><br>
	* @see UI.WebView#event:getOnExternalLink
	* @event
	*/
	/**
	* @name UI.WebView#getOnExternalLink
	* @description Retrieve the function to call when the <code>ExternalLink</code> event occurs.
	* @returns {function} The current callback function.
	* @see UI.WebView#event:setOnExternalLink
	* @event
	*/
	WebView.registerEventType('externalLink');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ScrollView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ScrollView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ScrollView'] = exports; var View = require('NGCore/Client/UI/View').View;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');
var Commands = require('NGCore/Client/UI/Commands').Commands;

var ScrollView = exports.ScrollView = View.subclass(
/** @lends UI.ScrollView.prototype */
{
	'type':'scrollview',
	/**
	* @class The <code>ScrollView</code> class constructs objects that handle views in a scrolling list (see <code>{@link UI.ListView}</code>). 
	* You can define these views as scrolling vertically, horizontially, or both directions.<br><br>
	* <b>Note:</b> Android devices can only scroll in one direction at a time.
	* @name UI.ScrollView
	* @augments UI.View
	*/
	initialize: function($super, properties) {
		if (ScrollView._init) ScrollView._init();
		this._scrollPosition = [0, 0];
		return $super(properties);
	},
	
	/**
	 * @private
	 */    
	updateScrollPosition: function(newVal) {
		this._scrollPosition = newVal;
	},
	
	/**
	 * @private
	 */    
	performEventCallback: function($super, e) {
		if (e.eventType == 'scroll') this.updateScrollPosition(e.scrollPosition);
		$super(e);
	}
});

// Properties
ScrollView._init = function() {
	delete ScrollView._init;
	if (View._init) View._init();

	/**
	 * @name UI.ScrollView#setContentSize
	 * @description Set the value for the <code>contentSize</code> property. This property defines the size of a scroll area.
	 * @example var dialog = {
	 * 	width: screen.width * sizeRate.width / 100,
	 *	height: screen.height * sizeRate.height / 100
	 * };
	 * ...
	 * this.scrollView.setContentSize([dialog.width, 600]);
	 * @params {Number, Array (Number, String)} Individual components or a component array.
	 * @see UI.ScrollView#getContentSize
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ScrollView#getContentSize
	 * @description Retrieve the value of the <code>contentSize</code> property.
	 * @returns {Number, Array (Number, String)} The current value of <code>contentSize</code>.
	 * @see UI.ScrollView#setContentSize
	 * @function
     * @status iOS, Android, Test
	 */
	ScrollView.synthesizeCompoundProperty('contentSize', Commands.setScrollableSize);
	/**
	 * @name UI.ScrollView#setScrollPosition
	 * @description Set the value for the <code>scrollPosition</code> property.
	 * @example var hscroller = new UI.ScrollView();
	 * ...
	 * hscroller.setScrollPosition([0.5,0]);
	 * @params {Number, Array (Number)} Individual components or a component array.
	 * @see UI.ScrollView#getScrollPosition
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ScrollView#getScrollPosition
	 * @description Retrieve the value of the <code>scrollPosition</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>scrollPosition</code>.
	 * @see UI.ScrollView#setScrollPosition
	 * @function
     * @status iOS, Android, Test
	 */
	ScrollView.synthesizeCompoundProperty('scrollPosition', Commands.setScrollPosition);
	
	/**
	 * @name UI.ScrollView#setScrollIndicatorsVisible
	 * @description Set the value for the <code>scrollIndicatorsVisible</code> property.
	 * @example var hscroller = new UI.ScrollView();
	 * ...
	 * hscroller.setScrollIndicatorsVisible(false);
	 * @params {Boolean} Whether scroll indicators should be visible.
	 * @see UI.ScrollView#getScrollIndicatorsVisible
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ScrollView#getScrollIndicatorsVisible
	 * @description Retrieve the value of the <code>scrollIndicatorsVisible</code> property.
	 * @returns {Boolean} Whether scroll indicators will be visible during scrolling.
	 * @see UI.ScrollView#setScrollIndicatorsVisible
	 * @function
     * @status iOS, Android, Test
	 */
	ScrollView.synthesizeCompoundProperty('scrollIndicatorsVisible', Commands.setScrollIndicatorsVisible);

	/**
	 * @name UI.ScrollView#setOnScroll
	 * @description Set a function to call when the <code>scroll</code> event occurs.
	 * @param {Function} scrollCallback The new callback function.<br><br>
	 * <b>Note:</b> The <code>scroll</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.ScrollView#event:getOnScroll
	 * @event
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ScrollView#getOnScroll
	 * @description Retrieve the function to call when the <code>scroll</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.ScrollView#event:setOnScroll
	 * @event
     * @status iOS, Android, Test
	 */
	ScrollView.registerEventType('scroll');
	
	ScrollView.registerEventType('scrollEnded');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ListView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ListView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ListView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var ScrollView = require('NGCore/Client/UI/ScrollView').ScrollView;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');

var ListView = exports.ListView = ScrollView.subclass(
/** @lends UI.ListView.prototype */
{
	'type':'listview',
	/**
	* @class The <code>ListView</code> class constructs objects that contain <code>{@link UI.ListViewItem}</code> and <code>{@link UI.ListViewSection}</code> objects. 
	* These objects handle and render scrolling lists in an application.
	* A <code>ListView</code> object can contain potentially thousands of items, 
	* in sections, that use a pool of reusable views to display content.
	* @name UI.ListView
	* @augments UI.ScrollView
	*/
	initialize:function($super, properties) {
		if (ListView._init) ListView._init();
		$super(properties);
		
		this._sections = [];
		this._scrollPosition = [0,0];
		this.enableEvent('scroll', true);
		
		this._ownedViews = [];
		this._queuedViews = {};
		
		this._cellDivider = 0;
		
		return this;
	},
	
	destroy: function($super) {
		var l = this._ownedViews.length;
		for (var i = 0; i < l; i++) {
			this._ownedViews[i].release();
		}
		this._ownedViews = null;
		$super();
	},
	
	addChild: function($super, child, index) {
		if (index == "cell") {
			index = this._cellDivider++;
		} else if ((index || -1) >= 0) {
			index += this._cellDivider;
		}
		$super(child, index);
	},
	
	_viewForItem: function(lvItem) {
		if (lvItem._currentView instanceof AbstractView) return lvItem._currentView;
		
		var rID = lvItem._reuseId;
		var queue = this._queuedViews[rID];
		
		var view = null;
		while (queue && queue.length > 0) {
			if ((view = queue.pop()) instanceof AbstractView) break;
		}
		
		if (!(view instanceof AbstractView)) {
			view = lvItem._onCreateView(lvItem);
			if (view instanceof AbstractView) {
				this._ownedViews.push(view.retain());
				this.addChild(view, "cell");
			} else {
				console.log("Error creating view for list item with reuse id " + rID);
			}
		}
	//	console.log("_viewForItem: " + lvItem + " = " + view);
		return view;
	},
	
	_queueViewForItem: function(lvItem) {
		var viewToQueue = lvItem._currentView;
		if (viewToQueue instanceof AbstractView) {
			var rId = lvItem._reuseId;
			var queue = this._queuedViews[rId] || (this._queuedViews[rId] = []);
			queue.push(viewToQueue);
		}
		lvItem._setCurrentView();
	},
	
	_removeQueuedViews: function() {
		for (var q in this._queuedViews) {
			if (!this._queuedViews.hasOwnProperty(q)) continue;
			
			q = this._queuedViews[q];
			for (var i = 0, l = q.length; i < l; i++) {
				q[i].removeFromParent();
			}
		}
		this._cellDivider = 0;
	},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	flushSections: function() {
		for (var i in this._sections) {
			if(!this._sections.hasOwnProperty(i)) { continue; }
				
			var section = this._sections[i];
			// Cause every section to completely queue out its item views.
			section.flush();
			section.calculateItemPositions();
		}
		this._removeQueuedViews();
	},
	
	/**
	 * Clear this <code>ListView</code> and reload all list data.
	 * @see UI.ListViewItem,
	 * @see UI.ListViewSection
 	 * @status Javascript, iOS, Android, Flash
	 */
	reloadData: function() {
		this.flushSections();
		this.calculateSectionPositions();
		this.updateScrollPosition(this._scrollPosition);
	},
	
	/**
	 * Retrieve all contained sections by this <code>ListView</code>.
	 * @returns {Object} The current section list as an array of section IDs.
	 * @see UI.ListView#setSections
 	 * @status Javascript, iOS, Android, Flash
	 */
	getSections: function() {
		return this._sections;
	},
	
	/**
	 * Set the list of sections that this <code>ListView</code> contains.
	 * @example var sections = [];
	 * var section = new UI.ListViewSection;
	 * ...
	 * var items = [];
	 * for(news in News)
	 * {
	 *	var item = new ListItem.ListItem();
	 *	item.game = News[news];
	 *	items.push(item);
	 * }
	 *
	 * section.setItems(items);
	 * sections.push(section);
	 *
	 * gameNews.setSections(sections);
	 * @param {Object} newSections A new aray of section IDs.
	 * @see UI.ListView#getSections
 	 * @status Javascript, iOS, Android, Flash
	 */
	setSections: function(newSections) {
		this.flushSections();
		for (var i in this._sections) {
			if(this._sections.hasOwnProperty(i)) {
				this._sections[i].setListView(null);
			}
		}
		this._sections = newSections;
		var idArray = new Array();
		for (var i in newSections) {
			if(newSections.hasOwnProperty(i)) {
				idArray.push(0+(newSections[i].__objectRegistryId || 0));
			}
		}
		UI.Commands.setSections.call(this, idArray);
		this.reloadData();
	},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	calculateSectionPositions: function() {
		this._stackedSections = {};
		topY = 0;
		// Should account for header here.
		var l = this._sections.length;
		for (var i = 0; i < l; i++) {
		//	NgLogD("Calculating height for Section " + i + " / " + l + " from yPos " + topY);
			var section = this._sections[i];
			this._stackedSections[topY] = section;
			section.setListView(this);
			section.setYPosition(topY);
			var relTopY = this._scrollPosition[1/*y*/] - topY;
			section.updateVisibleRange(relTopY, relTopY + this._frame[3/*h*/]);
			var h = section._measureHeight();
			// Set the section's frame...
			section._setFrame(0, topY, this._frame[2], h);
			topY += h;
		}
		// Should account for footer here.
		this.setContentSize([this._frame[2], topY]);
	},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	updateScrollPosition:function(newVal) {
		if (this._scrollPosition[1] === newVal[1]) return;
		this._scrollPosition = newVal;
		
		var myHeight = this._frame[3];
		for (var yPos in this._stackedSections) {
			if(this._stackedSections.hasOwnProperty(yPos)) {
				var section = this._stackedSections[yPos];
				relTopY = newVal[1] - yPos;
				section.updateVisibleRange(relTopY, relTopY + myHeight);
			}
		}
	},
	
	/**
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	'_onScroll': function() {},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	enableEvent: function($super, eventName, enable) {
		// Don't allow scrolling events to be turned off!
		if ( (eventName == 'scroll') && !enable ) return;
		$super(eventName, enable);
	}
});

ListView._init = function() {
	delete ListView._init;
	if (ScrollView._init) ScrollView._init();

	/**
	 * @name UI.ListView#setHeader
	 * @description Set the value for the <code>header</code> property. This string is used as a header for the <code>ListView</code>.
	 * @example var friendHeader = mew UI.ListView();
	 * ...
	 * friendHeader.setHeader('Friends List');
	 * @param {String} header The new header.
	 * @see UI.ListView#getHeader
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.ListView#getHeader
	 * @description Retrieve the value of the <code>header</code> property.
	 * @returns {String} The current header.
	 * @see UI.ListView#setHeader
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	ListView.synthesizeProperty('header');
	/**
	 * @name UI.ListView#setFooter
	 * @description Set the value for the <code>footer</code> property. This string is used as a footer for the <code>ListView</code>.
	 * @example var friendFooter = mew UI.ListView();
	 * ...
	 * friendHeader.setHeader('This is a footer');
	 * @param {String} footer The new footer.
	 * @see UI.ListView#getFooter
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.ListView#getFooter
	 * @description Retrieve the value of the <code>footer</code> property.
	 * @returns {String} The current footer.
	 * @see UI.ListView#setFooter
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	ListView.synthesizeProperty('footer');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ListViewSection'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ListViewSection'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ListViewSection'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var ListViewItem = require('NGCore/Client/UI/ListViewItem').ListViewItem;

/* This class does not have a physical view representation.
	We still fully map and register it so that sections can be persisted independently of tables. */

var ListViewSection = exports.ListViewSection = Element.subclass(
/** @lends UI.ListViewSection.prototype */
{
	'type':'listview-section',
	/**
	* @class The <code>ListViewSection</code> class constructs objects that contain <code>ListViewItem</code> objects. 
	* These objects are rendered as individual sections of a scrolling list (see <code>{@link UI.ListView}</code>).
	* @name UI.ListViewSection
	* @augments UI.Element
	*/
	initialize:function($super, properties) {
		if (ListViewSection._init) ListViewSection._init();
		
		this._visibleRange = [0,0];
		this._headerHeight = 0;
		this._titleHeight = 0;
		
		delete this._measuredHeight;
		this._needsLayout = false;
		
		$super(properties);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	addItemToVisible: function(lvItem, index) {
		if (!(lvItem instanceof ListViewItem)) return;
		if (lvItem._currentView instanceof Element) return;
		
		var useView = this._listView._viewForItem(lvItem);
		var w = this._listView.getFrame()[2];
		
		if (this._rowHeight > 0) {
			useView.setFrame(0, this._yPosition + this._titleHeight + index * this._rowHeight, w, this._rowHeight);
		} else {
			useView.setFrame(0, this._yPosition + this._cellPositions[index], w, lvItem._height);
		}
		
		lvItem._setCurrentView(useView);
		if (!useView.getParent()) this._listView.addChild(useView, "cell");
	},
	
	_setFrame: function(l, t, w, h) {
		UI.Commands.setFrame.call(this, l, t, w, h);
		if (this._titleView) {
			var f = this._titleView.getFrame();
			this._titleView.setFrame(l, t, w, f[3]);
		}
	},
	
	/**
	 * Reset the visible range for this <code>ListViewSection</code>.
	 * @function
	 * @status Javascript, iOS, Android, Flash
	 */
	flush: function() {
		for (var i = this._visibleRange[0], l = this._visibleRange[1]; i < l; i++) {
			this._listView._queueViewForItem(this._items[i]);
		}
		this._visibleRange = [0,0];
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	updateVisibleRange: function(topY, bottomY) {
		var totalH = this._getMeasuredHeight();
		
		// Expand the view window. This is really only necessary for Android...
		var l = this._items.length;
		var rowH = this._rowHeight > 0 ? this._rowHeight : totalH / l;
		topY -= rowH * 5;
		bottomY += rowH * 5;
		
		var oldStartIndex = this._visibleRange[0];
		var oldEndIndex = this._visibleRange[1];
		var startIndex = l > 0 ? Math.max(0, Math.floor(topY / rowH)) : 0;
		var endIndex = l > 0 ? Math.min(l, startIndex + Math.floor((bottomY - topY) / rowH)) : 0;
		
		if (this._cellPositions) {
			// We should have a good guess into the array from the above code,
			// so now it just needs to be adjusted until accurate.
			while (startIndex < l && this._cellPositions[startIndex] < topY) startIndex++;
			while (startIndex > 0 && this._cellPositions[startIndex] > topY) startIndex--;
			if (startIndex >= l) startIndex = Math.max(0, l - 1);
			
			while (endIndex < l && this._cellPositions[endIndex] < bottomY) endIndex++;
			while (endIndex > startIndex && this._cellPositions[endIndex] > bottomY) endIndex--;
		
			topY = this._cellPositions[startIndex];
			// EndIndex is one past the last element...
			bottomY = endIndex == 0 ? topY : (this._cellPositions[endIndex-1] + this._items[endIndex-1]._height );
		}
		if (bottomY < 0 || topY > totalH) {
			for (var i = this._visibleRange[0]; i < this._visibleRange[1]; i++) {
				this._listView._queueViewForItem(this._items[i]);
			}
			this._visibleRange = [0,0];
			return;
		}
		
		if (oldStartIndex == startIndex && oldEndIndex == endIndex) return;
		
//		NgLogD("(" + oldStartIndex + "," + oldEndIndex + ") -> (" + startIndex + "," + endIndex + ")");
		
		if (oldStartIndex == oldEndIndex) {
			for (var i = startIndex; i < endIndex; i++) {
				this.addItemToVisible(this._items[i], i);
			}
		} else {
			// Dequeue and requeue from both ends.
			if (oldStartIndex < startIndex) {
				do {
					this._listView._queueViewForItem(this._items[oldStartIndex]);
				} while (++oldStartIndex < startIndex);
			}
			if (oldEndIndex > endIndex) {
				while (oldEndIndex-- > endIndex) {
					this._listView._queueViewForItem(this._items[oldEndIndex]);
				}
				oldEndIndex = endIndex;	// Keep later codepath from triggering
			}
		
			if (oldStartIndex > startIndex) {
				while (oldStartIndex-- > startIndex) {
					this.addItemToVisible(this._items[oldStartIndex], oldStartIndex);
				}
				oldStartIndex = startIndex;
			} 
			if (oldEndIndex < endIndex) {
				do {
					this.addItemToVisible(this._items[oldEndIndex], oldEndIndex);
				} while (++oldEndIndex < endIndex)
			}
		
		}
		this._visibleRange = [startIndex, endIndex];
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	setListView : function(listView) {
		this._listView = listView;
		delete this._measuredHeight;
		return this;
	},
	
	_getMeasuredHeight : function() {
		return this._measuredHeight || this._measureHeight();
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	_measureHeight : function() {
		// Sum the heights of the rows.  No variable-heights yet!!!
		if (this._rowHeight < 0) {
			// Variable Height Trigger
			var totalHeight = this._titleHeight + this._headerHeight;
			var runningHeights = [];
			var l = this._items.length;
			for (var i = 0; i < l; i++) {
				runningHeights.push(totalHeight);
				totalHeight += this._items[i]._height;
			}
			this._cellPositions = runningHeights;
			return this._measuredHeight = totalHeight;
		}
		
		delete this._cellPositions;
		return this._measuredHeight = this._titleHeight + this._headerHeight + this._rowHeight * this._items.length;
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	calculateItemPositions: function() {
		// Not used?.
	},
});

ListViewSection._init = function() {
	delete ListViewSection._init;
	if (Element._init) Element._init();

	// We don't have a set pattern for sending the id of a view we want to assign by reference...
	/**
	 * @name UI.ListViewSection#setTitleView
	 * @description 
	 * @function
	 * @see UI.ListViewSection#getTitleView
 	 * @status Javascript, iOS, Android, Flash
	 */
	var boundTitleFunction = function() {
		if (this.listViewMonitor) this.listViewMonitor.setTitleView(this);
		boundTitleFunction._superfunc.apply(this, Array.prototype.slice.call(arguments));
	};
	var setTitleView = function(titleView) {
		if (this._titleView && this._titleView.listViewMonitor == this) {
			delete this._titleView.listViewMonitor;
		}
		this._titleView = titleView;
		
		if (!(titleView.listViewMonitor == this)) {
			titleView.listViewMonitor = this;
			if (!boundTitleFunction._superfunc) {
				boundTitleFunction._superfunc = titleView.setFrame;
			}
			if (titleView.setFrame != boundTitleFunction) {
				titleView.registerAccessors('frame', null, boundTitleFunction);
			}
		}
		
		this._titleHeight = titleView.getFrame()[3];
		delete this._measuredHeight;
		Commands.setTitleView.call(this, ObjectRegistry.objectToId(titleView));
		return this;
	}
	/**
	 * @name UI.ListViewSection#getTitleView
	 * @description 
	 * @function
	 * @see UI.ListViewSection#setTitleView
 	 * @status Javascript, iOS, Android, Flash
	 */
	var getTitleView = function() {
		return this._titleView;
	}
	/**
	 * @name UI.ListViewSection#setTitle
	 * @description Set the value for the <code>title</code> property.
	 * @param {String} title The new section title.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.ListViewSection#getTitle
	 * @function
	 */
	/**
	 * @name UI.ListViewSection#getTitle
	 * @description Retrieve the value of the <code>title</code> property.
	 * @returns {String} The current section title.
	 * @see UI.ListViewSection#setTitle
	 * @function
	 */
	ListViewSection.registerAccessors('titleView', getTitleView, setTitleView);
	
	// Other properties
	/**
	 * @name UI.ListViewSection#setRowHeight
	 * @description Set the value for the <code>rowHeight</code> property.
	 * @param {Number} rowHeight The new row height.
	 * @see UI.ListViewSection#getRowHeight
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.ListViewSection#getRowHeight
	 * @description Retrieve the value of the <code>rowHeight</code> property.
	 * @returns {Number} The current row height.
	 * @see UI.ListViewSection#setRowHeight
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	ListViewSection.synthesizeProperty('rowHeight');
	/**
	 * @name UI.ListViewSection#setItems
	 * @description Set the value for the <code>items</code> property.
	 * Setting this updates the visual state of the <code>listView</code> if the section is in a <code>listView</code> that is visible.
	 * @param {UI.ListViewItem} items The new <code>ListView</code> items.
	 * @see UI.ListViewSection#getItems
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	var setItems = function(newItems) {
		newItems = (newItems instanceof Array) ? newItems : Array.prototype.slice.call(arguments);
		
		this.flush();
		this._items = newItems;
		
		if (!this._listView) return;
		this._listView.reloadData();
		delete this._measuredHeight;
	}
	/**
	 * @name UI.ListViewSection#getItems
	 * @description Retrieve the value of the <code>items</code> property.
	 * @returns {UI.ListViewItem} The current <code>ListView</code> items.
	 * @see UI.ListViewSection#setItems
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	var getItems = function() {
		return this._items;
	}
	ListViewSection.registerAccessors('items', getItems, setItems);
	/**
	 * @name UI.ListViewSection#setYPosition
	 * @description Set the value for the <code>yPosition</code> property.
	 * @param {Number} yPosition The new position for <i>y</i>.
	 * @see UI.ListViewSection#getYPosition
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.ListViewSection#getYPosition
	 * @description Retrieve the value of the <code>yPosition</code> property.
	 * @returns {Number} The current position of <i>y</i>.
	 * @see UI.ListViewSection#setYPosition
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	ListViewSection.synthesizeProperty('yPosition');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ListViewItem'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ListViewItem'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ListViewItem'] = exports; /* This class does not have a physical view representation, and is just a holder for closures / a bag for data...
	We still fully map and register it so that sections can be persisted independently of tables. */
var Class = require('NGCore/Client/Core/Class').Class;

var ListViewItem = exports.ListViewItem = Class.subclass(
/** @lends UI.ListViewItem.prototype */
{	/**
	* @class The <code>ListViewItem</code> class constructs objects that contain data for individual items in a scrolling list (see <code>{@link UI.ListView}</code>).
	* @name UI.ListViewItem
	* @constructs The default constructor.
	* @augments Core.Class
	*/
	
	'type':'listview-item',
	
	_reuseId: "__default__",
	/** @protected */
	_currentView: null,
	
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_onCreateView: function() {},
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_onReleaseView: function(oldView) {},
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_onSetView: function(newView) {},
	
	/**
	 * Set the callback for the <code>onCreateView</code> event. 
	 * This event must return a newly created view that displays the data type represented by the item.
	 * @param {Function} newFn The new function to call.
	 * @event
	 */
	setOnCreateView: function(newFn)	{this._onCreateView = newFn},
	/**
	 * Set the callback for the <code>onReleaseView</code> event. This event occurs when the view is set to <code>null</code>. 
	 * Use this to remove uncommon view states or clean up the view when necessary.
	 * @param {Function} newFn The new function to call.
	 * @event
	 */
	setOnReleaseView: function(newFn)	{this._onReleaseView = newFn},
	/**
	 * Set the callback for the <code>onSetView</code> event. When this event occurs, the item puts any relevant visual state / data into <code>newView</code>.
	 * This transfer should occur before the item is visible to the user:
	 * <pre class="code">onSetView(newView)</pre>
	 * @param {Function} newFn The new function to call.
	 * @event
	 */
	setOnSetView: function(newFn)		{this._onSetView = newFn},
	
	/**
	 * Set the height of the current ListViewItem in pixels.
	 * <pre class="code">setHeight(Number)</pre>
	 * This should occur before the item is visible to the user.
	 * This setting is only used when the item's ListViewSection has height = -1
	 * @param {Function} newFn The new function to call.
	 */
	setHeight: function(h) {
		this._height = h;
	},
	
	/**
	 * Get the current height of the ListViewItem.
	 * <pre class="code">getHeight()</pre>
	 * This should occur before the item is visible to the user.
	 * @returns {Number} The height of this ListViewItem.
	 */
	getHeight: function() {
		return this._height;
	},
	
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_setCurrentView: function(newView) {
		if (newView instanceof Class) {
			this._onSetView(newView);
		} else {
			this._onReleaseView(this._currentView);
		}
		this._currentView = newView;
		return this;
	},
	
	/**
 	 * Retrieve the current view attached to this <code>ListViewItem</code>.
	 * @returns {UI.View} The current <code>ListViewItem</code> view.
	 * @status Javascript, iOS, Android, Flash
	 */
	getCurrentView: function(){
		return this._currentView;
	},
		
	initialize: function(reuseId) {
		if (reuseId) this._reuseId = reuseId;
		return this;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/CellView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/CellView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/CellView'] = exports; var View = require('NGCore/Client/UI/View').View;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var CellView = exports.CellView = View.subclass(
/** @lends UI.CellView.prototype */
{
	'type':'cell',
	/**
	* @class The <code>CellView</code> class constructs objects that handle cell views in an application. For example, a cell in a scrolling list.
	* These objects are rendered with images on the left and right, and two text areas (title and text) stacked vertically in the middle.
	* @name UI.CellView
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (CellView._init) CellView._init();
		$super(properties);
	}
});

// Properties
CellView._init = function() {
	delete CellView._init;
	if (View._init) View._init();
	
	/**
	 * @name UI.CellView#setImage
	 * @description Set the value of the <code>image</code> property for a view state. This defines how a cell view appears for specific conditions. For example,
	 * set different images for a cell view in the default state and when the cell view has focus.
	 * @example background.setImage('./Content/blank.png', [w, h], [0, 0]);
	 * @param {String} image The new <code>image</code> URL.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getImage
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.CellView#getImage
	 * @description Retrieve the value of the <code>image</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current <code>image</code> URL.
	 * @see UI.CellView#setImage
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.CellView#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getImageBorder
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.CellView#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.CellView#setImageBorder
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	/**
	 * @name UI.CellView#setImageInsets
	 * @description Set the value of the <code>imageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example background.setImageInsets([10,10,10,10]);
	 * @param {Number, Array (Number)} imageInsets The new value for <code>imageInsets</code>. Set as insets or an array of insets (float).
	 * @see UI.CellView#getImageInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#getImageInsets
	 * @description Retrieve the value of the <code>imageInsets</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>imageInsets</code>.
	 * @see UI.CellView#setImageInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	CellView.synthesizeCompoundProperty('imageInsets', Commands.setImageInsets);
	/**
	 * @name UI.CellView#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example background.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.CellView#getImageFit
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.CellView#setImageFit
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	CellView.synthesizeProperty('imageFit', Commands.setImageFitMode);
	/**
	 * @name UI.CellView#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how an image is positioned within a viewable area.
	 * @example background.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> (expressed as two floats).
	 * @see UI.CellView#getImageGravity
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.CellView#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> (expressed as two floats).
	 * @see UI.CellView#setImageGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	CellView.synthesizeProperty('imageGravity', Commands.setImageGravity);
	 /**
	 * @name UI.CellView#setImageTransform
	 * @description Set the value of the <code>imageTransform</code> property. This property defines data compression for images used with a cell view.
	 * @example background.setImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} imageTransform The new value for <code>imageTransform</code>. Set as an array of floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.CellView#getImageTransform
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#getImageTransform
	 * @description Retrieve the value of the <code>imageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>imageTransform</code>.
	 * @see UI.CellView#setImageTransform
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	 CellView.synthesizeCompoundProperty('imageTransform', Commands.setImageTransform);
	/**
	 * @name UI.CellView#getRightImage
	 * @description Retrieve the value of the <code>rightImage</code> property in the specified view state.
	 * @returns {String} The current value of <code>rightImage</code>.
	 * @function
	 * @see UI.CellView#setRightImage
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setRightImage
	 * @description Set the value of the <code>rightImage</code> property in the specified view state. This defines how images used for UI controls appear for specific conditions. For example, 
	 * use seperate images for a closure arrow in the default state and a closure arrow when expanded.
	 * @example var cellClosure = new UI.CellView()
	 * ...
	 * cellClosure.setRightImage('./Content/closure.png', [w, h], [0, 0]);
	 * @param {String} rightImage The new value for <code>rightImage</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI State.
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImage
	 */
	CellView.synthesizePropertyWithState('rightImage', Commands.setRightImage);
	/**
	 * @name UI.CellView#getRightImageBorder
	 * @description Retrieve the value of the <code>rightImageBorder</code> property in the specified view state. 
	 * @returns {Object} The current value of <code>rightImageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 * @see UI.CellView#setRightImageBorder
	 */
	/**
	 * @name UI.CellView#setRightImageBorder
	 * @description Set the value of the <code>rightImageBorder</code> property in the specified view state. This property defines a border for images used in the specified view state.
	 * @param {Object} rightImageBorder The new value for <code>rightImageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI View state.
 	 * @status iOS, Android, Test
	 * @function
	 * @see UI.CellView#getRightImageBorder
	 */
	CellView.synthesizePropertyWithState('rightImageBorder', Commands.setRightImageBorder);
	/**
	 * @name UI.CellView#getRightImageInsets
	 * @description Retrieve the value of the <code>rightImageInsets</code> property.
	 * @returns {Array (Number)} The current value of <code>rightImageInsets</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setRightImageInsets
	 */
	/**
	 * @name UI.CellView#setRightImageInsets
	 * @description Set the value of the <code>rightImageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example closureIcon.setRightImageInsets([10,10,10,10]);
	 * @param {Array (Number)} rightImageInsets The new value for <code>rightImageInsets</code>. Set as floats (<i>t</i>, <i>r</i>, <i>b</i>, <i>l</i>).
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImageInsets
	 */
	CellView.synthesizeProperty('rightImageInsets', Commands.setRightImageInsets);
	/**
	 * @name UI.CellView#getRightImageFit
	 * @description Retrieve the value of the <code>rightImageFit</code> property. 
	 * @returns {Number} The current value of <code>rightImageFit</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setRightImageFit
	 */
	/**
	 * @name UI.CellView#setRightImageFit
	 * @description Set the value of the <code>rightImageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example closureIcon = new UI.CellView();
	 * ...
	 * closureIcon.setRightImageFit(UI.FitMode.None);
	 * @param {Number} rightImageFit The new value for <code>rightImageFit</code>.
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImageFit
	 */
	CellView.synthesizeProperty('rightImageFit', Commands.setRightImageFitMode);
	/**
	 * @name UI.CellView#getRightImageGravity
	 * @description Retrieve the value of the <code>rightImageGravity</code> property. 
	 * @returns {Number} The current value of <code>rightImageGravity</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setRightImageGravity
	 */
	/**
	 * @name UI.CellView#setRightImageGravity
	 * @description Set the value of the <code>rightImageGravity</code> property. This property defines how a image for a control is positioned within a viewable area.
	 * @example var closureIcon = new UI.CellView();
	 * ...
	 * closureIcon.setRightImageGravity([0.5, 0.0]);
	 * @param {Number} rightImageGravity The new value for <code>rightImageGravity</code>. Set as two floats (<i>x</i>, <i>y</i>).
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImageGravity
	 */
	CellView.synthesizeProperty('rightImageGravity', Commands.setRightImageGravity);
	/**
	 * @name UI.CellView#getRightImageTransform
	 * @description Retrieve the value of the <code>rightImageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>rightImageTransform</code>.
	 * @see UI.CellView#setRightImageTransform
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	 /**
	 * @name UI.CellView#setRightImageTransform
	 * @description Set the value of the <code>rightImageTransform</code> property. This property defines data compression for images used with right image objects.
	 * @example var closureIcon = new UI.CellView();
	 * ...
	 * closureIcon.setRightImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} rightImageTransform The new value for <code>rightImageTransform</code>. 
	 * Set as six floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.CellView#getRightImageTransform
 	 * @status iOS, Android, Test
	 * @function
	 */
	 CellView.synthesizeCompoundProperty('rightImageTransform', Commands.setRightImageTransform);
	 
	/**
	 * @name UI.CellView#getTitle
	 * @description Retrieve the value of the <code>title</code> property in a view state.
	 * @returns {String} The current value of <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 * @see UI.CellView#setTitle
	 */
	/**
	 * @name UI.CellView#setTitle
	 * @description Set the value of the <code>title</code> property for a view state. This property defines the title string for a view in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitle('Game of Foo');
	 * @param {String} title The new value for <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getTitle
	 * @function
	 */
	CellView.synthesizePropertyWithState('title', Commands.setTitle);
	/**
	 * @name UI.CellView#getTitleColor
	 * @description Retrieve the value of the <code>titleColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>titleColor</code>.
	 * @see UI.CellView#setTitleColor
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setTitleColor
	 * @description Set the value of the <code>titleColor</code> property for a view state. This property defines the title string color for the <code>CellView</code> object in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleColor(0,0,1);
	 * @param {String} titleColor The new value for <code>titleColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getTitleColor
	 * @function 
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizePropertyWithState('titleColor', Commands.setTitleColor);
	/**
	 * @name UI.CellView#getTitleFont	 
	 * @description Retrieve the value of the <code>titleFont</code> property in a view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>titleFont</code>.
	 * @function
	 * @see UI.CellView#setTitleFont
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleFont
	 * @description Set the value of the <code>titleFont</code> property in a view state. This property defines the title string font for cell view labels in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleFont('Content/Cacophony.ttf');
	 * @param {String} titleFont The new value for <code>titleFont</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @function
	 * @see UI.CellView#getTitleFont
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizePropertyWithState('titleFont', Commands.setTitleFont);
	/**
	 * @name UI.CellView#getTitleShadow
	 * @description Retrieve the value of the <code>titleShadow</code> property in a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>titleShadow</code>.
	 * @see UI.CellView#setTitleShadow
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleShadow
	 * @description Set the value of the <code>titleShadow</code> property in a view state. This property defines the amount of text shadowing used for title strings in a cell view.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleShadow('FFCCCCFF 2.0 {0,0}');
	 * @param {String} titleShadow The new value for <code>titleShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getTitleShadow
	 * @function
	 */
	CellView.synthesizePropertyWithState('titleShadow', Commands.setTitleShadow);

	/**
	 * @name UI.CellView#getTitleGravity
	 * @description Retrieve the value of the <code>titleGravity</code> property. 
	 * @returns {Array (Number)} The current value of <code>titleGravity</code>.
	 * @see UI.CellView#setTitleGravity
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleGravity
	 * @description Set the value of the <code>titleGravity</code> property. This property defines how a title string is positioned within a viewable area.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleGravity([0.5, 0.0]);	 
	 * @param {Array (Number)} titleGravity The new value for <code>titleGravity</code>. Set as two floats (<i>x</i>, <i>y</i>).
	 * @see UI.CellView#getTitleGravity
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizeCompoundProperty('titleGravity', Commands.setTitleGravity);

	/**
	 * @name UI.CellView#getTitleSize
	 * @description Retrieve the value of the <code>titleSize</code> property.
	 * @returns {Number} The current value of <code>titleSize</code>.
	 * @see UI.CellView#setTitleSize
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleSize
	 * @description Set the value of the <code>titleSize</code> property. This property defines the text size of title strings in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleSize(32);
	 * @param {Number} titleSize The new value for <code>titleSize</code>. Set as two floats (<i>x</i>, <i>y</i>).	
	 * @function
	 * @see UI.CellView#getTitleSize
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizeProperty('titleSize', Commands.setTitleSize);
	/**
	 * @name UI.CellView#getTitleInsets
	 * @description Retrieve the value of the <code>titleInsets</code> property.	 
	 * @returns {Array (Number)} The current value of <code>titleInsets</code>.
	 * @function
	 * @see UI.CellView#setTitleInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleInsets
	 * @description Set the value of the <code>titleInsets</code> property. This property defines the viewable area of a title string when applying gravity.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleInsets([10,10,10,10]);	 
	 * @param {Array (Number)} titleInsets The new value for <code>titleInsets</code>. Set as four floats (<i>t</i>, <i>r</i>, <i>b</i>, <i>l</i>).
	 * @function
	 * @see UI.CellView#getTitleInsets
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizeCompoundProperty('titleInsets', Commands.setTitleInsets);
	
	/**
	 * @name UI.CellView#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>..
	 * @see UI.CellView#setText
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use in the specified view state.
	 * @example var cellView = new UI.CellView();
	 * ...
	 * cellView.setText(this.game.description);
	 * @see UI.CellView#getText
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizePropertyWithState('text', Commands.setText);
	/**
	 * @name UI.CellView#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code>.
	 * @see UI.CellView#setTextColor
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string in the specified view state.
	 * @example var cellText = new UI.CellView();
	 * ...
	 * cellText.setTextColor('FFFF');
	 * @see UI.CellView#getTextColor
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	CellView.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.CellView#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.
	 * @see UI.CellView#setTextShadow	
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on text strings in this view.
	 * @example var cellText = new UI.CellView();
	 * ...
	 * cellText.setTextShadow('FFCCCCFF 2.0 {0,0}');
	 * @see UI.CellView#getTextShadow
	 * @param {String} textShadow The new value for <code>textShadow</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	/**
	 * @name UI.CellView#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code> in the specified view state.
	 * @see UI.CellView#setTextFont
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels for a cell view.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextFont('Content/Cacophony.ttf');
	 * @param {String} textFont The new value for <code>textFont</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getTextFont
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizePropertyWithState('textFont', Commands.setTextFont);
	
	/**
	 * @name UI.CellView#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setTextGravity
	 */
	/**
	 * @name UI.CellView#setTextGravity	 
	 * @description Set the value of the <code>textGravity</code> property. This property defines how a text string is positioned within a viewable area.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextGravity([0.5, 0.0]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a component array (<i>x</i>, <i>y</i>).
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getTextGravity
	 */
	CellView.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);

	/**
	 * @name UI.CellView#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property.
	 * @returns {Number} The current value for <code>textSize</code>.
	 * @see UI.CellView#setTextSize
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setTextSize
	 * @description Set the value of the <code>textSize</code> property. This property defines the size of text strings for a view.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextSize(18);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.CellView#getTextSize
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.CellView#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property.
	 * @returns {Array (Number)} The curent value for <code>textInsets</code>.
	 * @see UI.CellView#setTextInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property. This property defines the viewable area of a text string when applying gravity.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextInsets([10,10,10,10]);
	 * @param {Array (Number)} textInsets The new value for <code>textInsets</code>.
	 * @see UI.CellView#getTextInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		//** extra-deprecated */
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing CellView." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			CellView.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('text');
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
	bindStateProperties('textFont');
	bindStateProperties('title');
	bindStateProperties('titleColor');
	bindStateProperties('titleFont');
	bindStateProperties('titleShadow');
	bindStateProperties('gradient');
	bindStateProperties('image');
	bindStateProperties('imageBorder');
	bindStateProperties('rightImage');
	bindStateProperties('rightImageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/CheckBox'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/CheckBox'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/CheckBox'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var WindowR = require('NGCore/Client/UI/Window');

var gradients = {
	'normal': {
		"gradient": ["FFED 0.000", "FFA4 1.000"],
		"insets": "{4.0,4.0,4.0,4.0}",
		"outerLine": "FF51 2.0",
		"outerShadow": "0000 0.0 {0.0,0.0}",
		"corners": "3.0 3.0 3.0 3.0"
	},
	'pressed': {
		"innerShadow": "FF00 6.0 {0.0,-1.0}",
		"gradient": ["FF80 0.000", "FF80 1.000"],
		"insets": "{4.0,4.0,4.0,4.0}",
		"outerLine": "FF51 2.0",
		"outerShadow": "0000 0.0 {0.0,0.0}",
		"corners": "3.0 3.0 3.0 3.0"
	},
	'checked': {"innerLine":"FF27A227 2.0","corners":"3.0 3.0 3.0 3.0","insets":"{4.0,4.0,4.0,4.0}","gradient":["FF2CFF2B 0.000","FF179117 1.000"],"outerShadow":"0000 0.0 {0.0,0.0}","outerLine":"FF51 3.0","innerShadow":"FF97FE97 1.0 {0.0,0.0}"},
	'checkedpressed': {"innerShadow":"FF0F610F 5.0 {0.0,-1.0}","gradient":["FF179117 0.000","FF179117 1.000"],"insets":"{4.0,4.0,4.0,4.0}","outerLine":"FF2B512B 3.0","outerShadow":"0000 0.0 {0.0,0.0}","corners":"3.0 3.0 3.0 3.0"},
	'disabled': {
		"innerShadow": "0000 0.0 {0.0,0.0}",
		"gradient": ["66B6 0.000", "66CA 1.000"],
		"insets": "{4.0,4.0,4.0,4.0}",
		"outerLine": "7FE0 3.0",
		"outerShadow": "0000 0.0 {0.0,0.0}",
		"corners": "3.0 3.0 3.0 3.0"
	},
};

var CheckBox = exports.CheckBox = AbstractView.subclass(
/** @lends UI.CheckBox.prototype */
{
	'type':'checkbox',

    /**
     * @class The <code>CheckBox</code> class constructs objects that handle the state of application checkboxes.
     * @constructs The default constructor. 
     * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
     * @param {String} properties Object properties.
     * @augments UI.AbstractView
     */
    initialize: function($super, properties) {
		if (CheckBox._init) CheckBox._init();
        this._checked = false;
        $super();
		this.setGradient(gradients['normal'], Commands.State.Normal);
		this.setGradient(gradients['pressed'], Commands.State.Pressed);
		this.setGradient(gradients['checked'], Commands.State.Checked);
		this.setGradient(gradients['checkedpressed'], Commands.State.Checked | Commands.State.Pressed);
		this.setGradient(gradients['disabled'], Commands.State.Disabled);
		this.setImageInsets([4,4,4,4]);
		this.setAttributes(properties);
    },
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
    performEventCallback: function($super, event) {
		if (event.eventType == 'click') {
        	this._checked = event.checked;
			if (this._checked) {
				this._state = this._state | Commands.State.Checked;
			} else {
				this._state = this._state & ~Commands.State.Checked;
			}
		}
		$super(event);
    }
});

CheckBox._init = function() {
	delete CheckBox._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.CheckBox#getImage
	 * @description Retrieve the <code>image</code> URL for a view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state.
	 * @see UI.CheckBox#setImage
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setImage
	 * @description Set an image URL for a view state. This defines how a checkbox appears for specific conditions. For example,
	 * set different images for a checkbox in the default state and when the checkbox is checked.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setImage('./Content/checkbox.png', [w, h], [0, 0]);
	 * @see UI.CheckBox#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function 
	 */
	CheckBox.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.CheckBox#getImageInsets
	 * @description Retrieve the value of the <code>imageInsets</code> property (expressed as floats).
	 * @returns {Number, Array (Number)} The current value of <code>imageInsets</code>.
	 * @see UI.CheckBox#setImageInsets
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setImageInsets
	 * @description Set the value of the <code>imageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setImageInset([10,10,10,10]);
	 * @param {Number, Array (Number)} imageInsets The new value for <code>imageInsets</code>. Set as insets or an array of insets (expressed as floats).
	 * @see UI.CheckBox#getImageInsets
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeCompoundProperty('imageInsets', Commands.setImageInsets);
	
	/**
	 * @name UI.CheckBox#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code> in the specified view state.
	 * @see UI.CheckBox#setText
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use as a label for a 
	 * checkbox in the specified view state.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setText("Yes");
	 * @see UI.CheckBox#getText
	 * @param {String} text The new value for <code>text</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizePropertyWithState('text', Commands.setText);
	/**
	 * @name UI.CheckBox#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code> in the specified view state.
	 * @see UI.CheckBox#setTextColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string used as a label for a 
	 * checkbox in different view states.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextColor('FFFFFF');
	 * @see UI.CheckBox#getTextColor
	 * @param {String} textColor The new value for <code>textColor</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function 
	 */
	CheckBox.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.CheckBox#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code> in the specified view state.
	 * @see UI.CheckBox#setTextShadow	
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of shadowing used on text strings for a checkbox in different view states.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextShadow("FF00 2.0 {0,-1}");
	 * @see UI.CheckBox#getTextShadow
	 * @param {String} textShadow The new value for <code>textShadow</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	/**
	 * @name UI.CheckBox#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property (expressed as floats).
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.CheckBox#setTextGravity
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property. This property defines how a text string is positioned within a viewable area.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a single array of components (expressed as floats).
	 * @see UI.CheckBox#getTextGravity
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);

	/**
	 * @name UI.CheckBox#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property.
	 * @returns {Number} The current value for <code>textSize</code>.
	 * @see UI.CheckBox#setTextSize
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextSize
	 * @description Set the value of the <code>textSize</code> property. This property defines the text size of labels for a checkbox.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextSize(18);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.CheckBox#getTextSize
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.CheckBox#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code> in the specified view state.
	 * @see UI.CheckBox#setTextFont
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels for a checkbox in different view states.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CheckBox#getTextFont
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizePropertyWithState('textFont', Commands.setTextFont);
	/**
	 * @name UI.CheckBox#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property.
	 * @returns {Array (Number)} The curent value for <code>textInsets</code>.
	 * @see UI.CheckBox#setTextInsets
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property. This property defines the viewable area of a text string when applying gravity.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextInsets(0, 0, 0, 64);
	 * @param {Array (Number)} textInsets The new value for <code>textInsets</code>.
	 * @see UI.CheckBox#getTextInsets
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
	// Corresponding event is onClick
	/**
	 * @name UI.CheckBox#getChecked
	 * @description Retrieve whether this <code>CheckBox</code> is currently "checked".
	 * @returns {Boolean} Returns <code>true</code> if this <code>CheckBox</code> is currently "checked".
	 * @see UI.CheckBox#setChecked
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setChecked
	 * @description Set whether this <code>CheckBox</code> is "checked".
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setChecked(true);
	 * @param {Boolean} checked Set as <code>true</code> if this <code>CheckBox</code> is "checked".
	 * @see UI.CheckBox#getChecked
	 * @status iOS, Android
	 * @function 
	 */
	CheckBox.synthesizeProperty('checked', Commands.setChecked);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		'checked': Commands.State.Checked,
	};

	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			CheckBox.registerAccessors(thisStatePropName, getterFn, setterFn, 
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};

	bindStateProperties('text');
	bindStateProperties('textColor');
    bindStateProperties('textFont');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
	bindStateProperties('image');
    bindStateProperties('imageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/EditText'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/EditText'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/EditText'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var EditText = exports.EditText = AbstractView.subclass(
/** @lends UI.EditText.prototype */
{
	'type':'edittext',
	/**
	* @class The <code>EditText</code> class is a base class for derived classes that handle text-editing functions.
	* Derived classes from <code>EditText</code> include:
	* <div class="ul">
	 * <li>{@link UI.DateField}</li>
	 * </div>
	* @name UI.EditText
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (EditText._init) EditText._init();
		$super(properties);
	},
	
	
	'InputTypes': Commands.InputType,
	'EnterKeyTypes': Commands.EnterKeyType,
	
	
	performEventCallback: function($super, event) {
		try {
			switch (event.eventType) {
				case 'change':
					this._text = event.text;
					// Fallthrough
				default: $super(event);
			}
		} catch(e) {
			NgHandleException(e);
		}
	},
	
	// Adapt API to the single-state model for "text" on editable text.
	/**
	 * Retrieve the value of the <code>text</code> property.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.EditText#setText
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */	
	getText: function() {
		return this._text || "";
	},
	
	/**
	 * Set the value of the <code>text</code> property. This property defines a text string to use in arbitrary fashion.
	 * @example var someText = new UI.EditText();
	 * ...
	 * someText.setText("Pow!");
	 * @param {String} text The new value for <code>text</code>.
	 * @see UI.EditText#getText
	 * @status Javascript, iOS, Android, Test
	 * @function
	 */
	setText: function(text) {
		this._text = text;
		Commands.setText.call(this, 0, text);
	},

	setFocus: function(focus) {
		Commands.setFocus.call(this, focus);
	}
});

EditText._init = function() {
	delete EditText._init;
	if (AbstractView._init) AbstractView._init();
	
	// ==== Content
	// API defines state for the text property, but we ONLY support one state for this control.
	
	EditText.registerAccessors('text', EditText.prototype.getText, EditText.prototype.setText);
	
	/**
	 * @name UI.EditText#getPlaceholder
	 * @description Retrieve the value of the <code>placeholderText</code> property.
	 * @returns {String} The current value of <code>placeholder</code>.
	 * @see UI.EditText#setPlaceholder
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setPlaceholder
	 * @description Set the value of the <code>placeholderText</code> property. This property defines a text string to use as a placeholder for fields that require text input.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setPlaceholder("This is a placeholder");
	 * @param {String} placeholder The new value for <code>placeholder</code>.
	 * @see UI.EditText#getPlaceholder
	 * @function
	 */
	EditText.synthesizeProperty('placeholder', Commands.setPlaceholderText);
	/**
	 * @name UI.EditText#getPlaceholderColor
	 * @description Retrieve the value of the <code>placeholderTestColor</code> property. 
	 * @see UI.EditText#setPlaceholderColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */	
	/**
	 * @name UI.EditText#setPlaceholderColor
	 * @description Set the value of the <code>placeholderTestColor</code> property. This property defines the color of the placeholder text string.
	 * @returns {String} The current value of <code>placeholderTextColor</code>.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setPlaceholderColor('FFFFFF');
	 * @param {String} placeholderColor The new value for <code>placeholderTestColor</code>.
	 * @see UI.EditText#getPlaceholderColor
	 * @function
	 */
	EditText.synthesizeProperty('placeholderColor', Commands.setPlaceholderTextColor);
	/**
	 * @name UI.EditText#getPlaceholderShadow
	 * @description Retrieve the value of the <code>placeholderTestShadow</code> property.
	 * @returns {String} The current value of <code>placeholderTestShadow</code>.
	 * @see UI.EditText#setPlaceholderShadow
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setPlaceholderShadow
	 * @description Set the value of the <code>placeholderTestShadow</code> property.  This property defines the amount of shawdow applied to the placeholder text string.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setPlaceholderShadow("FF00 2.0 {0,-1}");
	 * @param {String} placeholderShadow The new value for <code>placeholderTestShadow</code>.
	 * @see UI.EditText#getPlaceholderShadow
	 * @function
	 */
	 EditText.synthesizeProperty('placeholderShadow', Commands.setPlaceholderTextShadow);
	
	// ==== Behavior
	/**
	 * @name UI.EditText#getInputType
	 * @description Retrieve the value of the <code>inputType</code> property.
	 * @returns {Number} The current value of <code>inputType</code>.
	 * @see UI.EditText#setInputType
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setInputType
	 * @description Set the value of the <code>inputType</code> property.
	 * @param {Number} inputType The new value for <code>inputType</code>.
	 * @see UI.EditText#getInputType
	 * @function
	 */	
	 EditText.synthesizeProperty('inputType', Commands.setInputType);
	/**
	 * @name UI.EditText#getEnterKeyType
	 * @description Retrieve the value of the <code>enterKeyType</code> property.
	 * @returns {Number} The current value of <code>enterKeyType</code>.
	 * @see UI.EditText#setEnterKeyType
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setEnterKeyType
	 * @description Set the value of the <code>enterKeyType</code> property.
	 * @param {Number} enterKeyType The new value for <code>enterKeyType</code>.
	 * @see UI.EditText#getEnterKeyType
	 * @function
	 */
	EditText.synthesizeProperty('enterKeyType', Commands.setEnterKeyType);
	
	// ==== Appearance
	/**
	 * @name UI.EditText#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} textColor The current value of <code>textColor</code>.
	 * @see UI.EditText#setTextColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string in the specified view state.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextColor('FFFFFF');
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditText#getTextColor
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.EditText#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.
	 * @see UI.EditText#setTextShadow
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on text strings in this view.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextShadow("FF00 2.0 {0,-1}");
	 * @param {String} textShadow The new value for <code>textShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditText#getTextShadow
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	
	/**
	 * @name UI.EditText#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property for this <code>EditText</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.EditText#setTextGravity
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property for this <code>EditText</code>. This property defines how a text string is positioned within a viewable area.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as a float or an array.
	 * @see UI.EditText#getTextGravity
	 * @function
	 */
	EditText.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);
	/**
	 * @name UI.EditText#getTextSize
	 * @description Retrieve the value of the <code>teztSize</code> property for this <code>EditText</code>.
	 * @returns {Number} The current value of <code>textSize</code>.
	 * @see UI.EditText#setTextSize
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextSize
	 * @description Set the value of the <code>textSize</code> property for this <code>EditText</code>. This property defines the size of text strings for a view.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextSize(18);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.EditText#getTextSize
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.EditText#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property for this <code>EditText</code>.
	 * @returns {String} The current value of <code>textFont</code>.
	 * @see UI.EditText#setTextFont
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with text strings in a view.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code>.
	 * @see UI.EditText#getTextFont
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizePropertyWithState('textFont', Commands.setTextFont);
	
	// ==== Events
	/**
	 * @name UI.EditText#getOnChange
	 * @description Retrieve the function to call when the <code>change</code> event occurs.
	 * @returns {Function} The current <code>change</code> callback function.
	 * @see UI.EditText#event:setOnChange
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditText#setOnChange
	 * @description Set a function to call when the <code>change</code> event occurs.
	 * @param {Function} changeCallback The new <code>change</code> callback function. <br><br><b>Note:</b> The <code>change</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example EditText.setOnChange( function(event) { 
	 * 	console.log(event.text) 
	 *	} 
	 * );
	 * @see UI.EditText#event:getOnChange
	 * @status iOS
	 * @event
	 */
	EditText.registerEventType('change');
	/**
	 * @name UI.EditText#getOnFocus 
	 * @description Retrieve the function to call when the <code>focus</code> event occurs.
	 * @returns {Function} The current <code>focus</code> callback function.
	 * @see UI.EditText#event:setOnFocus
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event	 
	 */
	/**
	 * @name UI.EditText#setOnFocus
	 * @description Set a function to call when the <code>focus</code> event occurs.
	 * @param {Function} focusCallback The new <code>focus</code> callback function. <br><br><b>Note:</b> The <code>focus</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example EditText.setOnFocus( function(event) { 
	 * 	console.log(event.text) 
	 *	} 
	 * );
	 * @see UI.EditText#event:getOnFocus
	 * @event
	 */
	EditText.registerEventType('focus');
	/**
	 * @name UI.EditText#getOnBlur
	 * @description Retrieve the function to call when the <code>blur</code> event occurs.
	 * @returns {Function} The current <code>blur</code> callback function.
	 * @see UI.EditText#event:setOnBlur
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditText#setOnBlur
	 * @description Set a function to call when the <code>blur</code> event occurs.
	 * @note WARNING! This event is not guaranteed to occur on Android devices. Developers must not rely on this event occurring.
	 * @param {Function} blurCallback The new <code>blur</code> callback function.<br><br><b>Note:</b> The <code>blur</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example EditText.setOnBlur( function(event) { 
	 * 	console.log(event.text) 
	 *	} 
	 * );
	 * @see UI.EditText#event:getOnBlur
	 * @event
	 */
	EditText.registerEventType('blur');

	/**
	 * @name UI.EditText#getOnAction
	 * @description Retrieve the function to call when the <code>action</code> event occurs.
	 * @returns {Function} The current <code>action</code> callback function.
	 * @see UI.EditText#event:setOnAction
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditText#setOnAction
	 * @description Set a function to call when a keyboard key corresponding to executing an action is pressed.
	 * Available since 1.1.6
	 * @note WARNING! Soft keyboards on Android devices are not required to offer actions. Developers must not rely on this event occurring.
	 * @param {Function} actionCallback The new <code>action</code> callback function.<br><br><b>Note:</b> The <code>action</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditText#event:getOnAction
	 * @event
	 */
	EditText.registerEventType('action');

	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			};
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			};
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			EditText.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		};
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/EditTextArea'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/EditTextArea'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/EditTextArea'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var EditTextArea = exports.EditTextArea = AbstractView.subclass(
/** @lends UI.EditTextArea.prototype */
{
	'type':'edittextarea',
	/**
	* @class The <code>EditTextArea</code> class is multiline text-editing area.
	* @name UI.EditTextArea
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (EditTextArea._init) EditTextArea._init();
		$super(properties);
	},
	
	
	performEventCallback: function($super, event) {
		try {
			switch (event.eventType) {
				case 'change':
					this._text = event.text;
					$super(event);
					break;
				case 'focus':
				case 'blur':
					$super(event);
					break;
			}
		} catch(e) {
			NgHandleException(e);
		}
	},
	
	// Adapt API to the single-state model for "text" on editable text.
	/**
	 * Retrieve the value of the <code>text</code> property.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.EditTextArea#setText
	 * @status Javascript, iOS
	 * @function
	 */	
	getText: function() {
		return this._text || "";
	},
	
	/**
	 * Set the value of the <code>text</code> property.
	 * @param {String} text The new value for <code>text</code>.
	 * @see UI.EditTextArea#getText
	 * @status Javascript, iOS
	 * @function
	 */
	setText: function(text) {
		this._text = text;
		Commands.setText.call(this, 0, text);
	},

	setFocus: function(focus) {
		Commands.setFocus.call(this, focus);
	}
});

EditTextArea._init = function() {
	delete EditTextArea._init;
	if (AbstractView._init) AbstractView._init();
	
	// ==== Content
	// API defines state for the text property, but we ONLY support one state for this control.
	
	EditTextArea.registerAccessors('text', EditTextArea.prototype.getText, EditTextArea.prototype.setText);
	
	/**
	 * @name UI.EditTextArea#getPlaceholder
	 * @description Retrieve the value of the <code>placeholder</code> property.
	 * @returns {String} The current value of <code>placeholder</code>.<br>
	 * @see UI.EditTextArea#setPlaceholder
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setPlaceholder
	 * @description Set the value of the <code>placeholder</code> property.
	 * @param {String} placeholder The new value for <code>placeholder</code>.
	 * @see UI.EditTextArea#getPlaceholder
	 * @function
	 */
	EditTextArea.synthesizeProperty('placeholder', Commands.setPlaceholderText);
	/**
	 * @name UI.EditTextArea#getPlaceholderColor
	 * @description Retrieve the value of the <code>placeholder color</code> property.
	 * @returns {String} The current value of <code>placeholder color</code>.<br>
	 * @see UI.EditTextArea#setPlaceholderColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */	
	/**
	 * @name UI.EditTextArea#setPlaceholderColor
	 * @description Set the value of the <code>placeholder color</code> property.
	 * @param {String} placeholderColor The new value for <code>placeholder color</code>.
	 * @see UI.EditTextArea#getPlaceholderColor
	 * @function
	 */
	EditTextArea.synthesizeProperty('placeholderColor', Commands.setPlaceholderTextColor);
	/**
	 * @name UI.EditTextArea#getPlaceholderShadow
	 * @description Retrieve the value of the <code>placeholder shadow</code> property.
	 * @returns {String} The current value of <code>placeholder shadow</code>.<br>
	 * @see UI.EditTextArea#setPlaceholderShadow
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setPlaceholderShadow
	 * @description Set the value of the <code>placeholder shadow</code> property.
	 * @param {String} placeholderShadow The new value for <code>placeholder shadow</code>.
	 * @see UI.EditTextArea#getPlaceholderShadow
	 * @function
	 */
	 EditTextArea.synthesizeProperty('placeholderShadow', Commands.setPlaceholderTextShadow);
	
	
	// ==== Appearance
	/**
	 * @name UI.EditTextArea#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} textColor The current value of <code>textColor</code>.<br>
	 * @see UI.EditTextArea#setTextColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state.
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditTextArea#getTextColor
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.EditTextArea#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.<br>
	 * @see UI.EditTextArea#setTextShadow
	 * @private not working on iOS
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state.
	 * @param {String} textShadow The new value for <code>textShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditTextArea#getTextShadow
	 * @private not working on iOS
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	
	/**
	 * @name UI.EditTextArea#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property for this <code>EditTextArea</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.<br>
	 * @see UI.EditTextArea#setTextGravity
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property for this <code>EditTextArea</code>.
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as a float or an array.
	 * @see UI.EditTextArea#getTextGravity
	 * @function
	 */
	EditTextArea.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);
	/**
	 * @name UI.EditTextArea#getTextSize
	 * @description Retrieve the value of the <code>teztSize</code> property for this <code>EditTextArea</code>.
	 * @returns {Number} The current value of <code>textSize</code>.<br>
	 * @see UI.EditTextArea#setTextSize
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextSize
	 * @description Set the value of the <code>textSize</code> property for this <code>EditTextArea</code>.
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.EditTextArea#getTextSize
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.EditTextArea#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property for this <code>EditTextArea</code>.
	 * @returns {String} The current value of <code>textFont</code>.<br>
	 * @see UI.EditTextArea#setTextFont
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextFont
	 * @description Set the value of the <code>textFont</code> property for this <code>EditTextArea</code>.
	 * @param {String} textFont The new value for <code>textFont</code>.
	 * @see UI.EditTextArea#getTextFont
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizePropertyWithState('textFont', Commands.setTextFont);
	
	// ==== Events
	/**
	 * @name UI.EditTextArea#getOnChange
	 * @description Retrieve the function to call when the <code>change</code> event occurs.
	 * @returns {Function} The current <code>change</code> callback function.
	 * @see UI.EditTextArea#event:setOnChange
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditTextArea#setOnChange
	 * @description Set a function to call when the <code>change</code> event occurs.
	 * @param {Function} changeCallback The new <code>change</code> callback function. <br><br><b>Note:</b> The <code>change</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditTextArea#event:getOnChange
	 * @status iOS
	 * @event
	 */
	EditTextArea.registerEventType('change');
	/**
	 * @name UI.EditTextArea#getOnFocus 
	 * @description Retrieve the function to call when the <code>focus</code> event occurs.
	 * @returns {Function} The current <code>focus</code> callback function.
	 * @see UI.EditTextArea#event:setOnFocus
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event	 
	 */
	/**
	 * @name UI.EditTextArea#setOnFocus
	 * @description Set a function to call when the <code>focus</code> event occurs.
	 * @param {Function} focusCallback The new <code>focus</code> callback function. <br><br><b>Note:</b> The <code>focus</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditTextArea#event:getOnFocus
	 * @event
	 */
	EditTextArea.registerEventType('focus');
	/**
	 * @name UI.EditTextArea#getOnBlur
	 * @description Retrieve the function to call when the <code>blur</code> event occurs.
	 * @returns {Function} The current <code>blur</code> callback function.
	 * @see UI.EditTextArea#event:setOnBlur
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditTextArea#setOnBlur
	 * @description Set a function to call when the <code>blur</code> event occurs.
	 * @param {Function} blurCallback The new <code>blur</code> callback function.<br><br><b>Note:</b> The <code>blur</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditTextArea#event:getOnBlur
	 * @event
	 */
	EditTextArea.registerEventType('blur');
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			};
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			};
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			EditTextArea.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		};
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/DateField'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/DateField'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/DateField'] = exports; var EditText = require('NGCore/Client/UI/EditText').EditText;

function isValidDate(d) {
	if ( !d.getTime )
		return false; 
		
	return !isNaN(d.getTime());
}

/*
 Date Parser code to handle WebKit's lack of following the implementation.
 http://stackoverflow.com/questions/3085937/safari-js-cannot-parse-yyyy-mm-dd-date-format/3085993#3085993
 */
function parseDate(input, format) {
  format = format || 'yyyy-mm-dd'; // default format
  var parts = input.match(/(\d+)/g), 
      i = 0, fmt = {};
  // extract date-part indexes from the format
  format.replace(/(yyyy|dd|mm)/g, function(part) { fmt[part] = i++; });

  return new Date(parts[fmt['yyyy']], parts[fmt['mm']]-1, parts[fmt['dd']]);
}
/*
 * Our Code is not actually passing its format to parseDate (already had all the code to rejigger the date pieces to yyyy-mm-dd before I realized the problems with webkit's date constructor / date string parser). -fbartho 2010-11-30
 */

exports.DateField = EditText.subclass(
/** @lends UI.DateField.prototype */
{
	/**
	 * @class The <code>DateField</code> class constructs objects that handle data returned by date functions.
	 * @constructs The default constructor. 
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties
	 * @augments UI.EditText
	 */
	initialize: function($super, properties) {
		var constructorRVal = $super(properties);
		this.setDateFormat("yyyy-mm-dd");
		this.ondatechange = function(newDate){};
		
		this.setInputType(EditText.InputTypes.Date);
		return constructorRVal;
	},
    
	/**
	 * Trigger an event callback for this <code>DateField</code>.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} event The event that triggers a callback function.
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	performEventCallback: function($super, event) {
		try {
			if (event.eventType == 'change') {
				// Make Sure the Text is changed (call $super), before we call our listeners!
				var oldText = this.getText();
				$super(event);
				this.ondatechange(this.getDate());
			}
		} catch(e) {
			NgHandleException(e);
		}
	},
	_filterAndInsertDashes:function(oldText,newText) {
		var t = newText;
		if((oldText.length == t.length + 1) && oldText[oldText.length-1] == "-") {
			//This lets the user backspace through - marks as if they weren't there.
			// fbartho: Currently not in use! 2010-12-10
			//this.setText(t.substring(0,t.length-1));
			return t.substring(0,t.length-1);
		}
		
		var nt = "";
		var j = 0;
		for(var i = 0; i < t.length && nt.length < this.formatStr.length; i++,j++) {
			if(j < this.formatStr.length && this.formatStr[j] == "-" && i < t.length){
				if(t[i] == "-"|| t[i] == "/"){
					nt+="-";
					continue;
				}
				else {
					nt+="-";
					nt+=t[i];
					continue;
				}
			}
			if ( i < t.length && (t[i] == "-" || t[i] == "/") ) {
				--j; 
				continue;
			}
			nt+=t[i];
		}
		
		if(this.formatStr.length > j && (this.formatStr[j] == "-" || this.formatStr[j] == "/") ) {
			nt+="-";
		}
		
		return nt;
	},
	/**
	 * Format a date parsed from this <code>DateField</code> into a human-readable string.
	 * @status Javascript, iOS, Android, Flash, Test
	 */    
	normalizeDateLayout:function() {
		var ot = this.getText();
		var nt = this._filterAndInsertDashes(this.getText(),this.getText());
		if(ot!=nt)this.setText(nt);
	},
	/**
	 * Retrieve the date format of date strings parsed from this <code>DateField</code>
	 * @returns {String} The current date format.
	 * @see UI.DateField#setDateFormat
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getDateFormat:function() {
		return this.formatStr;
	},
	/**
	 * Set the date format for date strings parsed from this <code>DateField</code>.
	 * @param {String} dateFormat The new date format.
	 * @see UI.DateField#getDateFormat
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	setDateFormat:function(fStr) 
	{
		if (   fStr != "yyyy-mm-dd"
			&& fStr != "mm-yyyy"
			&& fStr != "yyyy-mm"
			&& fStr != "mm-dd-yyyy"
			&& fStr != "dd-mm-yyyy" ) {
			// Invalid Format String Error Case
			NgLogD("Error: Invalid Format String set for Birthdate Field!!\n");
			
			return;
		}
		
		this.formatStr = fStr;
		this.setPlaceholder(this.formatStr);
		return;
	},
	/**
	 * Retrieve a date string parsed from this <code>DateField</code>.
	 * @returns {String} The current date.
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getDate:function() {
		return this._dateFromText(this._filterAndInsertDashes(this.getText(),this.getText()));
	}, 
	_dateFromText:function(text) 
	{
		var tmp = null;
		var t = text;
		var bits = null;
		var b2 = null;
		if ( this.formatStr == "dd-mm-yyyy" ) {
			bits = t.split("-");
			if(bits.length != 3 || bits[2].length != 4)
				return null;
			
			b2 = [];
			b2.push(bits.pop());
			b2.push(bits.pop());
			b2.push(bits.pop());
			tmp = parseDate(b2.join("-"));
		} else if ( this.formatStr == "mm-yyyy" ) {
			bits = t.split("-");
			if(bits.length != 2 || bits[1].length != 4)
				return null;
			
			b2 = [];
			b2.push(bits.pop());
			b2.push(bits.pop());
			b2.push("01");
			var tStr = b2.join("-");
			
			tmp = parseDate(tStr);
		} else if ( this.formatStr == "yyyy-mm" ) {
			bits = t.split("-");
			if(bits.length != 2 || bits[0].length != 4)
				return null;
			
			tmp = parseDate(t+"-01");
		} else if ( this.formatStr == "mm-dd-yyyy" ) {
			bits = t.split("-");
			if(bits.length != 3 || bits[2].length != 4)
				return null;
			
			b2 = [];
			b2.push(bits.pop());
			b2.push(bits.shift());
			b2.push(bits.shift());
			tmp = parseDate(b2.join("-"));
		} else {
			tmp = parseDate(t);
		}
		
		if(!isValidDate(tmp)) {
			NgLogD("Failed to parse date: "+tmp+"   -  "+tmp.toString()+"\n");
			return null;
		}
		return tmp;
	}
});

//TODO: make a proper DatePicker?
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/AlertDialog'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/AlertDialog'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/AlertDialog'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var AlertDialog = exports.AlertDialog = Element.subclass(
/** @lends UI.AlertDialog.prototype */
{
	'type':'alertdialog',
	/**
	 * @name UI.AlertDialog
	 * @class The <code>AlertDialog</code> class constructs objects that handle alert dialogs in an application.
	 * @augments UI.Element
	 */
	initialize: function($super, properties) {
		if (AlertDialog._init) AlertDialog._init();
		$super(properties);
	},
	
	/** 
	 * Show this dialog.
	 * @function
	 */
	show: Commands.show,
	/** 
	 * Hide this dialog.
	 * @function
	 */
	hide: Commands.hide
});

// Properties
AlertDialog._init = function() {
	delete AlertDialog._init;
	if (Element._init) Element._init();

	/**
	 * @name UI.AlertDialog#setTitle
	 * @description Set the value of the <code>title</code> property for a view state. This property defines the title string for an alert dialog window.
	 * @example var alertDialog = new UI.AlertDialog();
	 * alertDialog.setTitle("Exiting Game..");
	 * @see UI.AlertDialog#getTitle
	 * @param {String} title The new value for <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.AlertDialog#getTitle
	 * @description Retrieve the value of the <code>title</code> property for a view state.
	 * @see UI.AlertDialog#setTitle
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>title</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	AlertDialog.synthesizePropertyWithState('title', Commands.setTitle);
	/**
	 * @name UI.AlertDialog#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string that is on display within an alert dialog window.
	 * @example var alertDialog = new UI.AlertDialog();
	 * ...
	 * alertDialog.setText("Returning to launcher..");
	 * @see UI.AlertDialog#getText
	 * @param {String} text The new value for <code>text</code>
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.AlertDialog#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @see UI.AlertDialog#setText
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	AlertDialog.synthesizePropertyWithState('text', Commands.setText);
	// Not a compound property; AlertDialog.getChoices() should return the array of strings.
	/**
	 * @name UI.AlertDialog#setChoices
	 * @description Set the value of the <code>choices</code> property. This property defines any available interface options for the user.
	 * @example var errorAlert = new UI.AlertDialog();
	 * ...
	 * errorAlert.setChoices(["Yes", "No"]);
	 * @see UI.AlertDialog#getChoices
	 * @param {String} choices The new value for <code>choices</code>.
	 * @param {Number} defaultChoice The index of the default choice.
	 * @param {Number} cancelChoice The index of the <code>cancel</code> choice.
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.AlertDialog#getChoices
	 * @description Retrieve the value of the <code>choices</code> property.
	 * @see UI.AlertDialog#setChoices
	 * @returns {Array (String)} The current value of <code>choices</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	AlertDialog.synthesizeProperty('choices', Commands.setChoices);
	
	// Event will contain .choice, which is the index of the option chosen.
	/**
	 * @name UI.AlertDialog#setOnChoice
	 * @description Set a function to call on <code>choice</code> events.	 
	 * @param {Function} choiceCallback The new function to call. <br><br>
	 * <b>Note:</b> The <code>choice</code> event is disabled if the value for this parameter is not a function.
	 * @see UI.AlertDialog#event:getOnChoice
 	 * @status iOS, Android, Test
	 * @event
	 */
	/**
	 * @name UI.AlertDialog#getOnChoice
	 * @description Retrieve the function to call on <code>choice</code> events.
	 * @see UI.AlertDialog#event:setOnChoice
	 * @returns {Function} The current function to call.
	 * @event
	 * @type {Function}
 	 * @status iOS, Android, Test
	 */
	 AlertDialog.registerEventType('choice');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ProgressDialog'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ProgressDialog'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ProgressDialog'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var ProgressDialog = exports.ProgressDialog = Element.subclass(
/** @lends UI.ProgressDialog.prototype */
{
	'type':'progressdialog',

    /**
     * @class The <code>ProgressDialog</code> class constructs objects that handle progress updates from the application.
     * @constructs The default constructor. 
     * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
     * @param {String} properties Object properties.
     * @augments UI.Element
     */
    initialize: function($super, properties) {
		if (ProgressDialog._init) ProgressDialog._init();
        return $super(properties);
    },
	/**
	 * Show this dialog.
	 * @function
     * @status iOS, Android, Test
	 */    
    show: Commands.show,
	/**
	 * Hide this dialog.
	 * @function
     * @status iOS, Android, Test
	 */    
    hide: Commands.hide
});

ProgressDialog._init = function() {
	delete ProgressDialog._init;
	if (Element._init) Element._init();
	
	/**
	 * @name UI.ProgressDialog#setTitle
	 * @description Set the value of the <code>title</code> property for a <code>ProgressDialog</code>. This property defines the title string for a progress dialog in the specified view state.
	 * @example var progDialog = new UI.ProgressDialog();
	 * progDialog.setTitle("Downloading game components...");
	 * @param {String} title The new value for <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.ProgressDialog#getTitle
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ProgressDialog#getTitle
	 * @description Retrieve the value of the <code>title</code> property for a <code>ProgressDialog</code> in the specified view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>title</code>.
	 * @see UI.ProgressDialog#setTitle
	 * @function
     * @status iOS, Android, Test
	 */
	ProgressDialog.synthesizePropertyWithState('title', Commands.setTitle);
	/**
	 * @name UI.ProgressDialog#setText
	 * @description Set the value of the <code>text</code> property for a <code>ProgressDialog</code> in the specified view state. This property defines a text string for a progress dialog in the specified view state.
	 * @example var progDialog = new UI.ProgressDialog();
	 * progDialog.setText("Please wait...");
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.ProgressDialog#getText
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ProgressDialog#getText
	 * @description Retrieve the value of the <code>text</code> property for a <code>ProgressDialog</code> in the specified view state.	 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.ProgressDialog#setText
	 * @function
     * @status iOS, Android, Test
	 */
	ProgressDialog.synthesizePropertyWithState('text', Commands.setText);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Toast'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Toast'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Toast'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Toast = exports.Toast = Element.subclass(
/** @lends UI.Toast.prototype */
{	
    'type': 'toast',
    /**
    * @class The <code>Toast</code> class constructs objects that render temporary messages on the device screen.
    * @name UI.Toast
    * @augments UI.View
    */
	initialize: function($super, properties) {
		if (Toast._init) Toast._init();
		$super(properties);
	},
	
	/** 
	 * Show this dialog.
	 * @function
     * @status iOS, Android, Test
	 */
    show: Commands.show
});

Toast._init = function() {
	delete Toast._init;
	if (Element._init) Element._init();

	/**
	 * @name UI.Toast#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use in the specified view state.
	 * @example var tempMessage = new UI.Toast();
	 * tempMessage.setText("Game Over");
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Toast#getText
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Toast#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.Toast#setText
	 * @function	 
     * @status iOS, Android, Test
	 */
	Toast.synthesizePropertyWithState('text', Commands.setText);
	/** 
	* @name UI.Toast#setOnDisappear
	* @description Set a function to call when the <code>disappear</code> event occurs. The callback for the event returns 
	* <code>true</code> if the temporary message should disappear. Otherwise, the callback returns <code>false</code>.
	* @param {function} disappearCallback The new callback function.<br><br>
	* <b>Note:</b> The <code>disappear</code> event is disabled if the value of this parameter is not a function.
	* @see UI.Toast#event:getOnDisappear
	* @event
	*/
	/**
	* @name UI.Toast#getOnDisappear
	* @description Retrieve the function to call when the <code>disappear</code> event occurs.
	* @returns {function} The current callback function.
	* @see UI.Toast#event:setOnDisappear
	* @event
	*/
	Toast.registerEventType('disappear');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/AdView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/AdView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/AdView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

/** @private */
var AdView = exports.AdView = AbstractView.subclass(
{
	'type':'adview',

	/**
	 * @class The <code>AdView</code> class constructs objects that handle event callback functions and ad event metadata.
	 * @constructs The default constructor. 
	 * @param $super This parameter is stripped out during execution. Do not supply it.
	 * @param {String} properties
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (AdView._init) AdView._init();
		$super(properties);
		
		this.onappear = this.bind(this._onappear);
		this.ondisappear = this.bind(this._ondisappear);
		this.onclick = this.bind(this._onclick);
	},
	
	/**
	 * An event for signaling when an <code>AdView</code> is on display.
	 * @event
	 */
	onappear: function() {
	 },
	
	/**
	 * An event for signaling when an <code>AdView</code> has been closed.
	 * @event
	 */
	ondisappear: function() { 
	},
	
	/** @protected */
	_onappear: function($super, event) {
		( $super || function(){} )(event);
//		Core.Analytics._getPipe().revenueEvent("ADSHOW",  this.getAdEventMetadata());
        visible = true;
	},
	
	/** @protected */
	_ondisappear: function($super, event) {
		( $super || function(){} )(event);
//		Core.Analytics._getPipe().revenueEvent("ADCLOSE", this.getAdEventMetadata());
        visible = false;
	},
	
	performEventCallback: function($super, event) {
		if (event.eventType == 'click')
		{
//			Core.Analytics._getPipe().revenueEvent("ADCLCK", this.getAdEventMetadata());
			NgLogD("AD WAS CLICKED in AdView wooo!!!!");
			( $super || function(){} )(event);
		}
		if (event.eventType == 'load')
		{
//			Core.Analytics._getPipe().revenueEvent("ADLOAD", this.getAdEventMetadata());
			NgLogD("AD WAS LOADED in AdView wooo!!!!");
			( $super || function(){} )(event);
		}
	},
	/**
	* Pause this <code>AdView</code>.<br><br>
	* <b>Note:</b> If an <code>AdView</code> is already paused, this call does nothing.
	* @see UI.AdView#resumeAds
	* @status Android
	*/
	pauseAds: function() {
		Commands.pauseAds.call(this);
	},
	/**
	* Resume this <code>AdView</code> from a paused state. Setting this will resume the <code>AdView</code> from the current position.
	* @see UI.AdView#resumeAds
	* @status Android
	*/
	resumeAds: function() {
		Commands.resumeAds.call(this);
	},
	/**
	* Set the refresh rate for this <code>AdView</code>. 
	* @param {Number} refreshRate The amount of time each ad is on display (in milliseconds).
	* @status Android
	*/
	setRefreshRate: function(refreshRate) {
		Commands.setAdRefreshRate.call(this, refreshRate);
	},
	/**
	* Set this <code>AdView</code> to automatically play.
	* @status Android
	* @param {Boolean} autoplay Set as <code>true</code> if autoplay is enabled.
	*/
	setAutoplay: function(autoplay) {
		Commands.setAdRefreshRate.call(this, autoplay);
	},
	
	/**
	 * Retrieve event metadata from this <code>AdView</code>. 
	 */
	getAdEventMetadata: function(){
		NgLogD("AD EventMetetData was requested!");
		var AdMeteData = "DefaultAdEventMetaData";
		return AdMeteData;
	}
});

// Event Handlers
AdView._init = function() {
	delete AdView._init;
	if (AbstractView._init) AbstractView._init();

    /**
	 * @name UI.AdView#getActive
	 * @description Retrieve the value of the <code>active</code> property.
	 * @returns {Boolean} Returns <code>true</code> if the <code>AdView</code> object is set to active.
	 * @see UI.AdView#setActive
	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	AdView.synthesizeProperty('active', Commands.setActive);
    
	/**
	 * @name UI.AdView#setOnClick
	 * @description Set a function to call on <code>click</code> events.	 
	 * @param {Function} clickCallback The new <code>click</code> callback function. <br><br>
	 * <b>Note:</b> The <code>click</code> event is disabled if the value for this parameter is not a function.<br>
	 * @see UI.AdView#event:setOnClick
 	 * @status Android, Test
	 * @event
	 */
	/**
	 * @name UI.AdView#getOnClick
	 * @description Retrieve the function to call on <code>click</code> events.<br>
	 * @see UI.AdView#event:getOnClick
	 * @returns {Function} The current <code>click</code> callback function.<br>
 	 * @status Android, Test
	 * @event
	 */
	AdView.registerEventType('click');
	/**
	 * @name UI.AdView#setOnLoad
	 * @description Set a function to call on <code>load</code> events.	 
	 * @param {Function} loadCallback The new <code>load</code> callback function. <br><br>
	 * <b>Note:</b> The <code>load</code> event is disabled if the value for this parameter is not a function.<br>
	 * @see UI.AdView#event:getOnClick
 	 * @status Android, Test
	 * @event
	 */
	/**
	 * @name UI.AdView#getOnLoad
	 * @description Retrieve the function to call on <code>load</code> events.<br>
	 * @see UI.AdView#event:getOnClick
	 * @returns {Function} The current <code>load</code> callback function.<br>
 	 * @status Android, Test
	 * @event
	 */
	AdView.registerEventType('load');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/DocumentView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/DocumentView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/DocumentView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var DocumentView = exports.DocumentView = AbstractView.subclass(
/** @lends UI.DocumentView.prototype */
{
	'type':'documentview',
	/**
	 * @name UI.DocumentView
	 * @class The <code>DocumentView</code> class constructs objects that handle document locations.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (DocumentView._init) DocumentView._init();
		$super(properties);
	}
});

// Properties
DocumentView._init = function() {
	delete DocumentView._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.DocumentView#setDocumentURL
	 * @description Set the document URL for this <code>DocumentView</code>.
	 * @param {String} documentURL The new document URL.
	 * @see UI.DocumentView#getDocumentURL
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.DocumentView#getDocumentURL
	 * @description Retrieve the document URL of this <code>DocumentView</code>.
	 * @returns {String} The current document URL.
	 * @see UI.DocumentView#setDocumentURL
	 * @status iOS, Android, Test
	 * @function
	 */
	DocumentView.synthesizeProperty('documentURL', Commands.setSourceDocument);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/CheckoutView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/CheckoutView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/CheckoutView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');
var Commands = require('NGCore/Client/UI/Commands').Commands;

var CheckoutView = exports.CheckoutView = AbstractView.subclass(
/** @lends UI.CheckoutView.prototype */
{
	'type':'checkoutview',
	/**
	 * @name UI.CheckoutView
	 * @class The <code>CheckoutView</code> class constructs objects that handle and manage information associated with <code>POST</code> methods in an application.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (CheckoutView._init) CheckoutView._init();
		$super(properties);
	}
});

// Properties
CheckoutView._init = function() {
	delete CheckoutView._init;
	if (AbstractView._init) AbstractView._init();
	
	// THESE ARE METHODS NOT PROPERTIES... THIS SHOULD BE FIXED.
	// We define ONLY setters, and no getters (write-only props, no local copies)
	/**
	 * @name UI.CheckoutView#setPostData
	 * @description Set the value returned by the <code>postData()</code> method of this <code>CheckoutView</code>.
	 * @param {String} postData The new value for <code>postData</code>.
	 * @see UI.CheckoutView#getPostData
	 * @status Android
	 * @function
	 */
	/**
	 * @name UI.CheckoutView#getPostData
	 * @description Retrieve the value returned by the <code>postData()</code> method of this <code>CheckoutView</code>.
	 * @returns {String} The current value of <code>postData</code>.
	 * @see UI.CheckoutView#setPostData
	 * @status Android
	 * @function
	 */
	CheckoutView.registerAccessors('postData', null, Commands.setPostData);
	/**
	 * @name UI.CheckoutView#setPostURL
	 * @description Set the value returned by the <code>postURL()</code> method of this <code>CheckoutView</code>.
	 * @param {String} postURL The new value for <code>postURL</code>.
	 * @see UI.CheckoutView#getPostURL
	 * @status Android
	 * @function
	 */
	/**
	 * @name UI.CheckoutView#getPostURL
	 * @description Retrieve the value returned by the <code>postURL()</code> method of this <code>CheckoutView</code>.
	 * @returns {String} The current value of <code>postURL</code>.
	 * @see UI.CheckoutView#setPostURL
	 * @status Android
	 * @function
	 */
	CheckoutView.registerAccessors('postURL', null, Commands.loadPostURL);
	/**
	 * @name UI.CheckoutView#setGetURL
	 * @description Set the value returned by the <code>getURL()</code> method of this <code>CheckoutView</code>.
	 * @param {String} getURL The new value for <code>getURL</code>.
	 * @see UI.CheckoutView#getGetURL
	 * @status Android
	 * @function
	 */
	/**
	 * @name UI.CheckoutView#getGetURL
	 * @description Retrieve the value returned by the <code>getURL()</code> method of this <code>CheckoutView</code>.
	 * @returns {String} The current value for <code>getURL</code>.
	 * @see UI.CheckoutView#setGetURL
	 * @status Android
	 * @function
	 */
	CheckoutView.registerAccessors('getURL', null, Commands.loadGetURL);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Spinner'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Spinner'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Spinner'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Spinner = exports.Spinner = AbstractView.subclass(
/** @lends UI.Spinner.prototype */
{
	'type':'spinner',
	
	/**
	* @class The <code>Spinner</code> class constructs objects that handle menu spinners in a user interface. 
	* @name UI.Spinner
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (Spinner._init) Spinner._init();
		return $super(properties);
	}
});

Spinner._init = function() {
	delete Spinner._init;
	if (AbstractView._init) AbstractView._init();
	
	Spinner.synthesizeProperty('darkStyle', Commands.setDarkStyle);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ProgressBar'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ProgressBar'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ProgressBar'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var WindowR = require('NGCore/Client/UI/Window');

var ProgressBar = exports.ProgressBar = AbstractView.subclass(
/** @lends UI.ProgressBar.prototype */
{
	'type':'progressbar',

    /**
     * @class <code>ProgressBar</code> constructs a horizontal bar that gives a finite indication of progress.
     * @constructs The default constructor. 
     * @param $super This parameter is stripped out during execution. Do not supply it.
     * @param {String} properties
     * @augments UI.AbstractView
     */
    initialize: function($super, properties) {
		if (ProgressBar._init) ProgressBar._init();
        return $super(properties);
    },

	useForUpdateProgress: Commands.useForUpdateProgress,
});

ProgressBar._init = function() {
	delete ProgressBar._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.ProgressBar#getProgressGradient
	 * @description Retrieve the <code>progressGradient</code> for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current progressGradient for the specified view state.<br>
	 * @see UI.ProgressBar#setProgressGradient
	 * @status Javascript, Android
	 * @function
	 */
	/**
	 * @name UI.ProgressBar#setProgressGradient
	 * @description Set a progressGradient for a view state.
	 * @see UI.ProgressBar#getProgressGradient
	 * @param {Object} progressGradientURL The new progressGradient.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status Android
	 * @function 
	 */
	ProgressBar.synthesizePropertyWithState('progressGradient', Commands.setProgressGradient);
	/**
	 * @name UI.SecondaryBar#getSecondaryGradient
	 * @description Retrieve the <code>secondaryGradient</code> for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current secondaryGradient for the specified view state.<br>
	 * @see UI.SecondaryBar#setSecondaryGradient
	 * @status Javascript, Android
	 * @function
	 */
	/**
	 * @name UI.SecondaryBar#setSecondaryGradient
	 * @description Set a secondaryGradient for a view state.
	 * @see UI.SecondaryBar#getSecondaryGradient
	 * @param {Object} secondaryGradientURL The new secondaryGradient.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status Android
	 * @function 
	 */
	ProgressBar.synthesizePropertyWithState('secondaryGradient', Commands.setSecondaryGradient);
	
	/**
	 * @name UI.ProgressBar#getProgress
	 * @description Retrieve the value of the <code>progress</code> properties.
	 * @returns {Array} The current values of <code>progress</code> and <code>secondaryProgress</code>.<br>
	 * @see UI.ProgressBar#setProgress
	 * @status Javascript, Android
	 * @function
	 */
	/**
	 * @name UI.ProgressBar#setProgress
	 * @description Set the values of the <code>progress</code> properties.
	 * @see UI.ProgressBar#getProgress
	 * @param {Number} progress The new value for <code>progress</code>, as a decimal Number between 0.0 and 1.0.
	 * @param {Number} secondaryProgress The new value for <code>secondaryProgress</code>, as a decimal Number between 0.0 and 1.0.
	 * @status Javascript, Android
	 * @function
	 */
	var setProgressGuarded = function(arg0) {
		var args = (arg0 instanceof Array) ? arg0 : Array.prototype.slice.call(arguments);
		while (args.length < 2) args.push(0);
		Commands.setProgress.apply(this, args);
	}
	ProgressBar.synthesizeCompoundProperty('progress', setProgressGuarded);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
	};

	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			ProgressBar.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};

	bindStateProperties('progressGradient');
	bindStateProperties('secondaryGradient');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/MapView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/MapView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/MapView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var MapAnnotation = require('NGCore/Client/UI/MapAnnotation').MapAnnotation;

var MapView = exports.MapView = AbstractView.subclass(
/** @lends UI.MapView.prototype */
{
	'type':'mapview',
	/**
	* @class <code>MapView</code>
	* @name UI.MapView
	* @augments UI.View
	*/
	initialize: function($super, properties) {
		this._annotations = [];
		this._region = [];
		return $super(properties);
	},
	
	getCenterCoordinate: function()
	{
		return [this._region[0], this._region[1]];
	},
    
    setCenterCoordinate: function(lat, lon, animated)
    {
        this._region[0] = lat;
        this._region[1] = lon;
        if (!this._region[2])
            this._region[2] = 0.05;
        if (!this._region[3])
            this._region[3] = 0.05;            
        this.setRegion(this._region[0], this._region[1], this._region[2], this._region[3], animated);
    },
	
	getCoordinateSpan: function()
	{
		return [this._region[2], this._region[3]];
	},	
	
	selectAnnotation: function(annotation)
	{
		if (annotation instanceof MapAnnotation) {
			var index = this._annotations.indexOf(annotation);
			if (index != -1) {
				Commands.selectAnnotation.call(this, annotation.__objectRegistryId);
				return;
			}
		}
		Commands.selectAnnotation.call(this, -1);
	},
	
	addAnnotation: function(annotation)
	{
		if (annotation instanceof MapAnnotation) {
			this._annotations.push(annotation);
			
			Commands.addAnnotation.call(this, annotation.__objectRegistryId);
			
		} else throw {message: this.type + ".addAnnotation: " + annotation + " is not a MapAnnotation!"};
		return this;
	},
	
	removeAnnotation: function(annotation)
	{
		if (annotation instanceof MapAnnotation) {
			// Remove this node from parent's child list
			var index = this._annotations.indexOf(annotation);
			if (index != -1) {
				this._annotations.splice(index, 1);
			}
			
			// Remove from the parent at the system level
			Commands.removeAnnotation.call(this, annotation.__objectRegistryId);
		} else throw {message: this.type + ".removeAnnotation: " + annotation + " is not a MapAnnotation!"};
		return annotation;
	},
	
	/**
	 * @private
	 */    
	updateRegionFits: function(lat, lon ,latD , lonD) {
		//console.log(lat + " " + lon + " " + latD + " " + lonD);
		//console.log(this._region[0] + " " + this._region[1] + " " + this._region[2] + " " + this._region[3]);
		this._region[0] = lat;
		this._region[1] = lon;
		this._region[2] = latD;
		this._region[3] = lonD;
	},
	
	/**
	 * @private
	 */    
	performEventCallback: function($super, e) {
		if (e.eventType == 'regionchange') this.updateRegionFits(e.latitude, e.longitude , e.latitudeDelta , e.longitudeDelta);
		$super(e);
	}
});

// Properties
(function() {
	MapView.synthesizeProperty('scrollable', Commands.setScrollable);
	
	MapView.synthesizeProperty('zoomable', Commands.setZoomable);
	
	MapView.synthesizeCompoundProperty('region', Commands.setRegion);
	
	MapView.registerEventType('regionchange');
})();
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/MapAnnotation'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/MapAnnotation'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/MapAnnotation'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var MapAnnotation = exports.MapAnnotation = Element.subclass(
/** @lends UI.MapAnnotation.prototype */
{
	'type':'mapannotation',
	/**
	* @class <code>MapAnnotation</code>
	* @name UI.MapAnnotation
	* @augments Core.Class
	*/
	initialize: function($super, properties) {
		return $super(properties);
	},

	setCalloutLeftView: function(view)
	{
		this._calloutLeftView = view;
		Commands.setCalloutLeftView.call(this, view.__objectRegistryId);
	},

	getCalloutLeftView: function()
	{
		return this._calloutLeftView;
	},

	setCalloutRightView: function(view)
	{
		this._calloutRightView = view;
		Commands.setCalloutRightView.call(this, view.__objectRegistryId);
	},

	getCalloutRightView: function()
	{
		return this._calloutRightView;
	},

	setView: function(view)
	{
		this._view = view;
		Commands.setView.call(this, view.__objectRegistryId);
	},

	getView: function()
	{
		return this._view;
	},

	setImage: function(image)
	{
		console.log("WARNING : MapAnnotation.setImage has been deprecated. Use MapAnnotation.setView instead.");
		var iV = new UI.Image();
		iV.setImage(image);
		iV.setFrame([0, 0, 40, 40]);
		this.setView(iV);
	},

	/**
	 * @private
	 */    
	performEventCallback: function($super, e) {
		$super(e);
	}
});

// Properties
(function() {

	MapAnnotation.synthesizeCompoundProperty('coordinate', Commands.setCoordinate);
	
	MapAnnotation.synthesizeCompoundProperty('centerOffset', Commands.setCenterOffset);
	
	MapAnnotation.synthesizeProperty('calloutTitle', Commands.setCalloutTitle);

	MapAnnotation.synthesizeProperty('calloutSubtitle', Commands.setCalloutSubtitle);
	
	MapAnnotation.synthesizeProperty('calloutEnabled', Commands.setCalloutEnabled);

	MapAnnotation.registerEventType('select');
	MapAnnotation.registerEventType('deselect');
})();
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Analytics'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Analytics'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Analytics'] = exports; var Class = require('NGCore/Client/Core/Class').Class,
NgPipe = require('NGCore/Shared/NgPipe').NgPipe,
NgPipesRemote = require('NGCore/Shared/NgPipesRemote').NgPipesRemote;

var Analytics = Class.singleton(
/** @lends Core.Analytics.prototype */
{
    classname: 'Analytics',

    /**
     * @class The <code>Analytics</code> class serves as the custom messaging channel to the ngCore platform. 
     * The <code>Analytics</code> class provides developers with a way to keep track of game-specific items that require analysis and counting.
     * Use this class when you need your games to send custom elements that require in-game analytics support. 
     * @constructs The default constructor for setting up the NgPipe.
     * @augments Core.Class
     * @param {Boolean} [sendToRemote=true] Set <code>sendToRemote</code> to <code>true</code> to send analytics data to a remote server.
     * @param {String} [analyticsServer=ngmoco analytics server] A custom analytics server.
     * @private
     */
    initialize: function() {
        if (!this._pipe) {
          this._pipe = new NgPipe();
        }
    },

	/** @private */
	updateGLEXT: function()
	{
		try
		{
			var caps = require('NGCore/Client/Core/Capabilities').Capabilities;
			var ext = caps.getOglExtensions();
			if (ext.length > 2)	// > 2 means we got some actual data, not our fake string
			{
				// We need to rip out just one of the four tex compressions we want.
				var list = [];
				var goodies =
				[
					"GL_IMG_texture_compression_pvrtc",
					"GL_AMD_compressed_ATC_texture",
					"GL_OES_compressed_ETC1_RGB8_texture",
					"GL_AMD_compressed_3DC_texture"
				];
				for (var i in goodies)
				{
					var item = goodies[i];
					for (var j in ext)
					{
						if (ext[j] ===  item)
						{
							var rep = {};
							rep[caps.getDeviceName()] = item;
							list.push(rep);
						}
					}
				}

				for (i in list)
				{
					Analytics.reportGameEvent("openglexts", list[i]);
				}
			}
		}
		catch (e)
		{
			NgLogException(e);
		}
	},

    /** @private */
    enable: function() {
        this._pipe.enable();
    },

    /** @private */
    disable: function() {
        this._pipe.disable();
    },

    /** @private */
    setUrl: function(url) {
        this._pipe.setRemoteUrl(url);
    },

    /**
    * Report a navigation event that occurs when users navigate between application pages. 
    * Calling this function will alert the analytics platform that a user has generated a navigation event.
    * This information is used to plot how users move through the game, how long they spend on a page, and what page they navigate to next.
    *
    * @param {String} from The name of the page from which navigation originates. 
    * @param {String} to An analytics name for the destination page.
    * @param {String} btnid The ID of the button that triggered the navigation.
    */
    reportNavigation : function(from, to, btnid) {
        if (!(from && to)) {
            return false;
        }
        this._pipe.uiEvent('NAV', {to: to, fro: from, btnid: btnid} );
        return true;
    },
    /**
    * Report a custom game event. Use this when something in your game happens that you want to know about, 
    * but does not change the user's core stats.<br><br>
    * <b>Note:</b> This function serves as a catch-all. If you need your game to count or analyze something that does not fit into any 
    * other category, use this call.
    * 
    * @param {String} eventId The ID for the custom event.
    * @param {Object} payload A hash of extra information.
    * @param {Object} playerState A hash of important player states.
    */
    reportGameEvent : function(eventId, payload, playerState ) {
        if (!eventId) {
            return false;
        }

        this._pipe.gameEvent(eventId, payload, playerState);

        return true;
    },
    /**
    * Report a change to a playerstate. A playerstate is the object representation of the player's core stats. 
    * For example, if a player purchased an in-game item, you would call this to let the analytics system know what happened and how much gold was spent.
    * Everything in the player state is counted and recorded. Make sure to only pass in things for which you want to see the change 
    * (gold, mojo, grow, level, xp, health, lives, and so on).
    * <b>Note:</b> This is only for game state and should not include information that is unique to a user. For example, the user game tag or the user ID.
    *
    * @param {String} action The product ID of a purchased product. This essentially points out when an action is performed.
    * @param {Object} change A hash of currencies spent and/or gained. For example {mojo: 100, gold:-10}
    * @param {Object} playerState A hash of important player states after the purchase.
    */
    reportPlayerStateChange : function(action, change,  playerState) {
        if (action) {
            this._pipe.playerEvent(action, 'PLSTCHANGE', change, playerState);
            return true;
        } else {
            return false;
        }
    },

    /**
    * Report when a user reaches a new stage of a funnel. Funnel refers to a set of pages or requirements a user is required to engage in before proceeding. 
    * You can use this call to keep track of progress for all users. For example, keeping track of various stages users engage in for game registration.
    * Funnel stages are ordered by numeric ID. The funnel <code>stageName</code> is used for display. You do not need to define funnels ahead of time.
    * Funnel stages start at 0 and increase as the user proceeds further.<br><br>
    * <b>Note:</b> Calling <code>reportFunnelStage()</code> multiple times for a single user generates an incorrect count.
    *
    * @param {String} funnelName The name of the funnel that the user has progressed to.
    * @param {Number} funnelStage The integer value of the stage that the user reached.
    * @param {String} stageName The name of the stage that the user reached.
    * @param {Object} playerState A hash of important player states after a funnel stage.
    * @private
    */
    reportFunnelStage : function(funnelName, funnelStage, stageName, playerState) {
        var payload =  {};

        if (!(funnelName)) {
            return false;
        }
        if (funnelStage !== null && funnelStage !== undefined) {
            payload.stage = funnelStage;
        } else {
            return false;
        }

        if (stageName) {
            payload.stageName = stageName;
        }
        this._pipe.funnelEvent(funnelName, payload, playerState);

        return true;
    },
    /**
     * Report an interaction between two users.
     *
     * @param {String} actionId The action that the user is performing to interact with the other user
     * @param {String} friendGamerTag The other user with whom the current user is interacting.
     * @param {Object} payload A hash of extra information
     */
    reportSocialEvent: function(actionId, friendGamerTag, payload) {
        if (actionId && actionId.length && friendGamerTag && friendGamerTag.length ) {
            this._pipe.socialEvent(actionId, friendGamerTag, payload);
            return true;
        }
        return false;
    },
    /**
    * Report an error to analytics.
    *
    * @param {String} error_msg The error message to log.
    */
    reportError : function(error_msg) {
        if (!error_msg) {
            return false;
        }
        this._pipe.gameOpsEvent("ERR", {err: error_msg } );
        return true;
    },
    /**
     * @private
     */
    addTag: function(tag) {
        if (tag) {
            var evpl = {tag:tag};
            this._pipe.gameEvent('tag', evpl);
            return true;
        }
        return false;
    },
    /** @private */
    _getPipe: function() {
        return this._pipe;
    },
    /**
    * Game Service running inside privileged interpreter may use this method
    * to change the Social Analytic object to be used.  Please see MOBWEST-2300
	* for details
	*
    * @private
    */
	_setNgPipeSocialAnalytics: function(socialAnalyticObj) {
		if (this._pipe) {
			this._pipe._setSocialAnalytics(socialAnalyticObj);
		}
	}
});
exports.Analytics = Analytics;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Color'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Color'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Color'] = exports; exports.Color = require('NGCore/Shared/Color').Color;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Vector'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Vector'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Vector'] = exports; exports.Vector = require('NGCore/Shared/Vector').Vector;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Point'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Point'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Point'] = exports; exports.Point = require('NGCore/Shared/Point').Point;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Size'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Size'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Size'] = exports; exports.Size = require('NGCore/Shared/Size').Size;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Rect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Rect'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Rect'] = exports; exports.Rect = require('NGCore/Shared/Rect').Rect;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/MessageEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/MessageEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/MessageEmitter'] = exports; exports.MessageEmitter = require('NGCore/Shared/MessageEmitter').MessageEmitter;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/MessageListener'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/MessageListener'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/MessageListener'] = exports; exports.MessageListener = require('NGCore/Shared/MessageListener').MessageListener;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/ObjectRegistry'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/ObjectRegistry'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/ObjectRegistry'] = exports; var Class = require('NGCore/Client/Core/Class').Class;

exports.ObjectRegistry = Class.singleton(
{
	classname: 'ObjectRegistry',
		
	/** @private @class @status */
	initialize: function()
	{
		this._currentId = 0;
		this._guardId = 0;
		this._objects = {};
	},
	
	/** @status */
	register: function(obj)
	{
		if(obj.__objectRegistryId)
			throw new Error('ObjectRegistry.register: object already registered');
			
		var id = "" + ++this._currentId;
		obj.__objectRegistryId = id;
		this._objects[id] = obj;
	},
	
	/** @status */
	unregister: function(obj)
	{
		if(!obj.__objectRegistryId)
			throw new Error('ObjectRegistry.unregister: object not registered');
			
		var id = obj.__objectRegistryId;
		obj.__objectRegistryId = 0;
		delete this._objects[id];
	},
	
	/** @status */
	isObjectRegistered: function(obj)
	{
		if(obj.__objectRegistryId)
			return true;
		else
			return false;
	},
	
	/** @status */
	isIdRegistered: function(id)
	{
		if(this._objects[id])
			return true;
		else
			return false;
	},
	
	/** @status */
	objectToId: function(obj)
	{
		var id = obj.__objectRegistryId;
		
		if(!id)
			throw new Error('ObjectRegistry.objectToId: object not registered');
		
		return id;
	},
	
	/** @status */
	idToObject: function(id)
	{
		return this._objects[id];
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Time'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Time'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Time'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Time
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;

var Time = Class.singleton(
/** @lends Core.Time.prototype */
{
	classname: 'Time',
	mFrameTime: 0,
	mFrameDelta: 0,

	/**
	 * @class the <code>Time</code> class constructs objects that provide access to the system clock and system timings for a device.
	 * @status iOS, Android, Flash
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
	},

	/**
	 * Return the timestamp for the current time frame (expressed in milliseconds).
	 * @returns {Number} The timestamp for the current time frame.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrameTime: function()
	{
		return this.mFrameTime;
	},

	/**
	 * Return the delta time in milliseconds since the last time frame.
	 * @returns {Number} The delta time since the last time frame.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrameDelta: function()
	{
		return this.mFrameDelta;
	},

	/**
	 * Return the real-time clock in milliseconds. 
	 * <b>Note:</b> This differs from the time frame timestamp, which is constant for the entire time frame.
	 * @returns {Number} The real-time clock.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getRealTime: function()
	{
		return (new Date()).getTime();
	},

	$_frameTimeRecv: function( cmd )
	{
		var o = {};
		this._frameTimeRecvGen(cmd, o);

		this.mFrameDelta = this.mFrameTime ? o.time - this.mFrameTime : 1;
		this.mFrameTime = o.time;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 351
	// Method frameTime = -1
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Time._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				case -1:
					Time._frameTimeRecv( cmd );
					break;
				default:
					NgLogE("Unknown static method id " + cmdId + " in Time._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[351] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	$_frameTimeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Time.frameTime from command: " + cmd );
			return false;
		}
		
		obj[ "time" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "time" ] === undefined )
		{
			NgLogE("Could not parse time in Time.frameTime from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $_frameTimeRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});

exports.Time = Time;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/toMD5'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/toMD5'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/toMD5'] = exports; exports.toMD5 = require('NGCore/Shared/Lib/md5').toMD5;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/SHA1'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/SHA1'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/SHA1'] = exports; var sha1 = require('NGCore/Shared/Lib/sha1');

exports.SHA1 = {
	b64_hmac_sha1: sha1.b64_hmac_sha1,
	hex_sha1: sha1.hex_sha1,
	b64_sha1: sha1.b64_sha1
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/UpdateEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/UpdateEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/UpdateEmitter'] = exports; var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var Time = require('NGCore/Client/Core/Time').Time;

exports.UpdateEmitter = MessageEmitter.singleton(
/** @lends Core.UpdateEmitter.prototype */
{
	classname: 'UpdateEmitter',
		
	/**
	 * @class The <code>UpdateEmitter</code> module constructs a singleton object that emits every frame with the delta in milliseconds since the last frame.<br><br>
	 * <b>Note:</b> <code>{@link Core.UpdateEmitter#setTickRate}</code> is also used to define the framerate of any animation reproduced by a sprite 
	 * (see <code>{@link GL2.Sprite#setAnimation}</code>).
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		
		this.__clubObject = new NgEngineEntity();
		this.__clubObject.mIsUpdatable = true;
		this.__clubObject.onUpdate = this._emitTime.bind(this);
		this.__clubObject.register();
		
		this._createSendGen(this.__objectRegistryId);
	},
	
	_emitTime: function()
	{
		this.emit(Time.getFrameDelta());
	},
	/**
	 * Set the tick rate that this <code>UpdateEmitter</code> object uses to send updates.<br><br>
	 * <b>Example:</b> Calling <code>setTickRate(15)</code>, any <code>MessageListener</code> objects that are listening 
	 * to the <code>UpdateEmitter</code> receive messages 15 times a second.	 
	 * @param {Number} r The new tick rate.
	 * @see GL2.Sprite
	 * @status iOS, Android, Flash
	 */
	setTickRate: function( r ) 
	{
		this._setTickRateSendGen(r);
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 304
	// Method create = -1
	// Method setTickRate = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in UpdateEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in UpdateEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[304] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":304,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_setTickRateSendGen: function( rate )
	{
		Proc.appendToCommandString( ":304,2," + this.__objectRegistryId + "," + rate  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setTickRate: function( rate ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Proc'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Proc'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Proc'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Proc
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var Base64 = require('NGCore/Client/Core/Base64').Base64;

////////////////////////////////////////////////////////////////////////////////

exports.Proc = Class.singleton(
{
	classname: 'Proc',
	
	initialize: function()
	{
		this._commandString = "";
	},
	
	appendToCommandString: function( str )
	{
		this._commandString += str;
	},
	
	getCommandString: function()
	{
		return this._commandString;
	},
	
	clearCommandString: function ()
	{
		this._commandString = "";
	},
	
	parseBool: function( v )
	{
		return v == 1 ? true : false;
	},

	parseInt: function( v )
	{
		return parseInt( v, 10 );
	},
	
	parseFloat: function( v )
	{
		return parseFloat( v );
	},
	
	parseString: function( v )
	{
		return Base64.decode( v );
	},
	
	parseJSONString: function( v )
	{
		return JSON.parse( Base64.decode( v ) );
	},

	setPrivileged: function()
	{
		this._privileged = true;
	},

	isPrivileged: function()
	{
		return this._privileged ? true : false;
	},

// {{?Wg Generated Code}}
	_classRecvGen: function( cmd )
	{
		var classId = parseInt( cmd.shift(), 10 );
		
		var handler = PROC_DISPATCH_TABLE[classId];
		if(handler)
		{
			handler(cmd);
		}
		else
		{
			NgLogE( "Unknown class id " + classId + " in _classRecvGen" );
		}
	}
// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/_LocalGameList'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/_LocalGameList'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/_LocalGameList'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class _LocalGameList
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Time = require('NGCore/Client/Core/Time').Time;
var toMD5 = require('NGCore/Client/Core/toMD5').toMD5;
var Util = require('NGCore/Client/Network/Util').Util;
var Base64 = require('NGCore/Client/Core/Base64').Base64;

////////////////////////////////////////////////////////////////////////////////

exports._LocalGameList = Class.singleton (
/** @lends Core._LocalGameList.prototype */
{
	classname: '_LocalGameList',

	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this.mGameList = [];
		var Storage = require('NGCore/Client/Storage').Storage;
		this.mFile = Storage.FileSystem;
		this.mGameStore = Storage.KeyValueCache.global("Core.GameList");

		this.mLoadingGames = {};
		this.mActiveGameKey = "activeGames";
		this.mRequiredAvailableSpace = 0;
		this.mSpaceAvailable = 0;
		this.mSpaceFreeCallbacks = [];
		this._firstBootGameLaunch = true;

		this._getRepoSpaceSendGen();

		this._setStage(this.ProgressStage.BootFirst);
		this._reloadGameList();
	},
	
	ProgressStage:
	{
		BootFirst: {},
		BootSecond: {},
		GameWithoutSecond: {},
		GameWithSecond: {},
		Regular: {}
	},
	
	_setStage: function(stage)
	{
		this._progressStage = stage;
		switch(stage)
		{
			case this.ProgressStage.BootFirst:
				console.log('setStage BootFirst');
				this._progressMin = 0;
				this._progressRange = 0.25;
				break;
			case this.ProgressStage.BootSecond:
				console.log('setStage BootSecond');
				this._progressMin = 0.25;
				this._progressRange = 0.25;
				break;
			case this.ProgressStage.GameWithoutSecond:
				console.log('setStage GameWithoutSecond');
				this._progressMin = 0.25;
				this._progressRange = 0.75;
				break;
			case this.ProgressStage.GameWithSecond:
				console.log('setStage GameWithSecond');
				this._progressMin = 0.5;
				this._progressRange = 0.5;
				break;
			case this.ProgressStage.Regular:
				console.log('setStage Regular');
				this._progressMin = 0;
				this._progressRange = 1;
				break;
			default:
				console.log('setStage ERROR');
				this._progressMin = 0;
				this._progressRange = 1;
		}
		console.log('min:', this._progressMin, 'range:', this._progressRange);
	},
	
	_nextStage: function()
	{
		switch(this._progressStage)
		{
			case this.ProgressStage.BootFirst:
				this._setStage(this.ProgressStage.GameWithoutSecond);
				break;
			case this.ProgressStage.BootSecond:
				this._setStage(this.ProgressStage.GameWithSecond);
				break;
			case this.ProgressStage.GameWithoutSecond:
				this._setStage(this.ProgressStage.Regular);
				break;
			case this.ProgressStage.GameWithSecond:
				this._setStage(this.ProgressStage.Regular);
				break;
		}
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 303
	// Method create = -1
	// Method updateGame = 2
	// Method updateDone = 3
	// Method getRepoSpace = 4
	// Method repoSpace = 5
	// Method deleteGame = 6
	// Method setUpdateProgress = 7
	// Method pauseUpdate = 8
	// Method resumeUpdate = 9
	// Method cancelUpdate = 10
	// Method updateProgress = 11
	// Method allowBGUpdates = 12
	// Method runGame = 13
	// Method finishGame = 14
	// Method setProgressText = 15
	// Method setSplashVisible = 16
	// Method exceptionForwarded = 17
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._updateGameRecv( cmd );
					break;
				case 5:
					instance._repoSpaceRecv( cmd );
					break;
				case 6:
					instance._deleteGameRecv( cmd );
					break;
				case 8:
					instance._pauseUpdateRecv( cmd );
					break;
				case 9:
					instance._resumeUpdateRecv( cmd );
					break;
				case 10:
					instance._cancelUpdateRecv( cmd );
					break;
				case 12:
					instance._allowBGUpdatesRecv( cmd );
					break;
				case 13:
					instance._runGameRecv( cmd );
					break;
				case 14:
					instance._finishGameRecv( cmd );
					break;
				case 17:
					instance._exceptionForwardedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in _LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in _LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[303] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_updateGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.updateGame from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.updateGame from command: " + cmd );
			return false;
		}
		
		obj[ "id" ] = Proc.parseInt( cmd[ 1 ] );
		if( obj[ "id" ] === undefined )
		{
			NgLogE("Could not parse id in _LocalGameList.updateGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_repoSpaceRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		obj[ "space" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "space" ] === undefined )
		{
			NgLogE("Could not parse space in _LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_deleteGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.deleteGame from command: " + cmd );
			return false;
		}
		
		obj[ "mdFive" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "mdFive" ] === undefined )
		{
			NgLogE("Could not parse mdFive in _LocalGameList.deleteGame from command: " + cmd );
			return false;
		}
		
		obj[ "game" ] = Proc.parseString( cmd[ 1 ] );
		if( obj[ "game" ] === undefined )
		{
			NgLogE("Could not parse game in _LocalGameList.deleteGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_pauseUpdateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.pauseUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.pauseUpdate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_resumeUpdateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.resumeUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.resumeUpdate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_cancelUpdateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.cancelUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.cancelUpdate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_allowBGUpdatesRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.allowBGUpdates from command: " + cmd );
			return false;
		}
		
		obj[ "allow" ] = Proc.parseBool( cmd[ 0 ] );
		if( obj[ "allow" ] === undefined )
		{
			NgLogE("Could not parse allow in _LocalGameList.allowBGUpdates from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_runGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.runGame from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.runGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_finishGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.finishGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_exceptionForwardedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.exceptionForwarded from command: " + cmd );
			return false;
		}
		
		obj[ "exceptionString" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "exceptionString" ] === undefined )
		{
			NgLogE("Could not parse exceptionString in _LocalGameList.exceptionForwarded from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":303,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_updateDoneSendGen: function( id, error )
	{
		Proc.appendToCommandString( ":303,3," + this.__objectRegistryId + "," + id + "," + Base64.encode( error )  );
	},
	
	/** @private */
	_getRepoSpaceSendGen: function(  )
	{
		Proc.appendToCommandString( ":303,4," + this.__objectRegistryId );
	},
	
	/** @private */
	_setUpdateProgressSendGen: function( progress )
	{
		Proc.appendToCommandString( ":303,7," + this.__objectRegistryId + "," + progress  );
	},
	
	/** @private */
	_updateProgressSendGen: function( url, cur, total, error )
	{
		Proc.appendToCommandString( ":303,11," + this.__objectRegistryId + "," + Base64.encode( url ) + "," + cur + "," + total + "," + ( error ? 1 : 0 )  );
	},
	
	/** @private */
	_setProgressTextSendGen: function( text )
	{
		Proc.appendToCommandString( ":303,15," + this.__objectRegistryId + "," + Base64.encode( text )  );
	},
	
	/** @private */
	_setSplashVisibleSendGen: function( visible )
	{
		Proc.appendToCommandString( ":303,16," + this.__objectRegistryId + "," + ( visible ? 1 : 0 )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _updateGameRecv: function( cmd ) {}
	// updateDone: function( id, error ) {}
	
	// getRepoSpace: function(  ) {}
	
	// _repoSpaceRecv: function( cmd ) {}
	// _deleteGameRecv: function( cmd ) {}
	// setUpdateProgress: function( progress ) {}
	
	// _pauseUpdateRecv: function( cmd ) {}
	// _resumeUpdateRecv: function( cmd ) {}
	// _cancelUpdateRecv: function( cmd ) {}
	// updateProgress: function( url, cur, total, error ) {}
	
	// _allowBGUpdatesRecv: function( cmd ) {}
	// _runGameRecv: function( cmd ) {}
	// _finishGameRecv: function( cmd ) {}
	// setProgressText: function( text ) {}
	
	// setSplashVisible: function( visible ) {}
	
	// _exceptionForwardedRecv: function( cmd ) {}

// {{/Wg Generated Code}}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
	_updateGameRecv: function( cmd )
	{
		this._getRepoSpaceSendGen();

		var o = {};
		this._updateGameRecvGen(cmd, o);

		if (o.url in this.mLoadingGames)
		{
			this.mLoadingGames[o.url].id = o.id;
			this.mLoadingGames[o.url].dlman.resume();
		}
		else
		{
			this.updateGame(o.url, o.id,
				(function (url, newFiles, err)
				{
					o.id = this.mLoadingGames[url].id;
					this._updateDoneSendGen(o.id, err);
				}).bind(this, o.url)
			);
		}
	},
	mobageRunGame: function (funk)
	{
		this._gameRunner = funk;
	},
	_runGameRecv: function( cmd )
	{
		var o = {};
		this._runGameRecvGen(cmd, o);
		if (this._gameRunner)
		{
			console.log("_LGL running gameRunner " + o.url);
			this._gameRunner(o.url);
		}
		else
		{
			console.log("_LGL running game " + o.url);
			var _int_LGL = require('NGCore/Client/Core/_int_LGL')._int_LGL;
			_int_LGL.launch(o.url, _int_LGL.ProcID.Game);
		}
	},
	/**
	 * set the function that kills the current game app
	 */
	setFinishGameHandler: function(funk)
	{
		this._finishGameHandler = funk;
	},
	_finishGameRecv: function()
	{
		if (this._finishGameHandler)
		{
			this._finishGameHandler();
		} else {
			console.log("_LocalGameList: finishGameHandler is not set");
		}
	},
	_repoSpaceRecv: function( cmd )
	{
		var obj = {};
		this._repoSpaceRecvGen(cmd, obj);
		this.mSpaceAvailable = obj.space;
		console.log("SD card space available(b): " + this.mSpaceAvailable);

		var length = this.mSpaceFreeCallbacks.length;
		while (length--)
		{
			(this.mSpaceFreeCallbacks.pop())();
		}
	},

	_deleteGameRecv: function( cmd )
	{
		// site to calc md5: http://pajhome.org.uk/crypt/md5/
		var allowedGames =
		[
			"http://10.15.", // Allow partial ones, for testing
			'http://gamehub.mobage.com/app/1.0s/gamehub',
			'url of allowed game'
		];

		var obj = {};
		this._deleteGameRecvGen(cmd, obj);
		var i;
		for(i in allowedGames)
		{
			var match = obj.game.match(allowedGames[i]);
			if(match && !match.index)
			{
				NgLogD("Deleting " + obj.mdFive);
				this.deleteGameFiles(obj.mdFive);

				var doneCB = (function ()
				{
					NgLogD("Finished deleting game from " + this.mActiveGameKey + " for " + obj.mdFive );
				}).bind(this);
				this._deleteGameFromStorage(obj.mdFive,doneCB);

				return;
			}
			else
			{
				// for testing, allow any local server starting with 10.15
			}
		}
		NgLogE("_LocalGameList unauthorized call to deleteGame from "+obj.game+"!");
	},

// _deleteGameFromStorage is for deleting the games info from LGL storage, not the game's storage

	_deleteGameFromStorage: function(mdFive,doneCB)
	{
		var self = this;
		this.mGameStore.getItem(this.mActiveGameKey,
			function(error, value)
			{
				var list = JSON.parse(value);
				
				var good = false;
				var ind;
				var out = [];
				for(ind = 0; ind < list.length; ++ind)
				{
					if(list[ind].name == mdFive)
						good = true;
					else
						out.push(list[ind]);
				}
				
				if( good )
				{
					NgLogD("_LocalGameList found and removed " + mdFive);
					self.mGameStore.setItem(self.mActiveGameKey, JSON.stringify(out), doneCB);
				}
				else
				{
					NgLogD("_LocalGameList failed to find and remove " + mdFive);
					doneCB("Could not remove item: " + error);
				}
				
			}, true
		);
	},

	getGameConfig: function(identifier, isMDFive, callBack)
	{
		if (typeof isMDFive == 'function')
		{
			callBack = isMDFive;
			isMDFive = false;
		}

		var folder;
		if (isMDFive)
		{
			folder = identifier;
		}
		else
		{
			var Util = require('NGCore/Client/Network/Util').Util;
			var norm = Util.NormalizeUrl(identifier);
			folder = toMD5(norm);
		}

		this.mFile.readFile(folder + "/" + Capabilities._getConfigFile(),
			function (err, contents)
			{
				var ret = {};
				if (err || !contents)
				{
					console.log("Could not get config from %s! err: %s", identifier, err);
				}
				else
				{
					ret = JSON.parse(contents);
				}
				callBack(ret);
			}
		);
	},

	getRepoSpace: function()
	{
		return this.mSpaceAvailable;
	},

	getConfig: function(gameOrigin, name, callback, failEarly)
	{// callback = function (config, err)
		// XHR
		var XHR = require('NGCore/Client/Network/XHR').XHR;
		var Util = require('NGCore/Client/Network/Util').Util;
		
		var httpStatus = 0;
		
		Util.OperationWithRetries(function(failCb)
		{
			var req = new XHR();
			req.onreadystatechange = function()
			{
				if(req.readyState == 4)
				{
					httpStatus = req.status;
					if(httpStatus == 200)
					{
						// Succes.
						callback(req.responseText);
					}
					else if(httpStatus == 404)
					{
						// File not on server, so load from the regular location
						console.log("no configuration file found at %s, using root server", gameOrigin + name);
						callback( "{}" );
					}
					else
					{
						//Error! Retry
						failCb();
					}
				}
			};

			req.open('GET', gameOrigin + name + Util.getCacheBustingString(), true);
			req.send();
		}, function()
		{
			callback(null, true, httpStatus);
		}, failEarly);
	},

	// gameOrigin: url to folder holding webgame.ngmanifest
	// doneCB = function(totalBytes, error)
	updateGame: function(gameOrigin, id, doneCB, failEarly, failAllowed)
	{
		// console.log ( "LGL.updateGame url = " + gameOrigin );
		// console.log ( "LGL.updateGame boot game = " + Capabilities.getBootGame() );
		
		var re = new RegExp(".*" + Capabilities.getBootGame());
		var match = gameOrigin.match(re);
		
		if (match) 
			this._firstBootGameLaunch = false;
			
		// console.log ( "_LocalGameList.updateGame updating game." );

		// Normalize URL
		var Util = require('NGCore/Client/Network/Util').Util;
		gameOrigin = Util.NormalizeUrl(gameOrigin);
		var name = toMD5(gameOrigin);
		this.mLoadingGames[gameOrigin] = {id: id};

		console.log(gameOrigin + " toMD5: " + name);

		// Get device-specific manifest directory
		var buildPath = {"Android" : "android", "iPhone OS" : "ios", "flash" : ""};
		// Get Device capabilities platformOs
		var caps = require('NGCore/Client/Core/Capabilities').Capabilities;
		var build = "/" + buildPath[caps.getPlatformOS()];

		this._setProgress(0);

		var curContUrl = "";
		var configFile = toMD5(gameOrigin) + "/" + caps._getConfigFile();
		
		// This is guaranteed to be synchronous, so will always occur before the callback for subsequent operations.
		this.mFile.readFile(configFile,
			function(err, data)
			{
				if (data)
				{
					var obj = JSON.parse(data);
					curContUrl = obj.contentUrl;
				}
			}
		);

		this.getConfig(gameOrigin + build, "/" + caps._getConfigFile(),
		(function(config, error, status)
		{
			if (error)
			{
				doneCB(0, error);
				delete this.mLoadingGames[gameOrigin];
			}
			else
			{
				this._setProgress(0.1);

				// Read config
				var parsedConfig = JSON.parse(config);
				if(!parsedConfig.contentUrl)
				{
					parsedConfig.contentUrl = gameOrigin + build;
				}
				else if (parsedConfig.contentUrl == curContUrl)
				{
					// no need to update.
					this._setProgress( 1.0 );
					this._setStage(this.ProgressStage.Regular);
					this.mFile.writeFile(configFile, JSON.stringify(parsedConfig),
						function(err) {console.log(err); } );
					doneCB(0);
					delete this.mLoadingGames[gameOrigin];
					return;
				}

				this._callDownloadManifest(parsedConfig, gameOrigin, name, failEarly, failAllowed, (function(bytes, error)
				{
					this._setProgress( 1.0 );
					this._nextStage();

					if (! error) {
						var that = this;
						this._reloadGameList({name:name, url:gameOrigin}, function()
						{
							if (doneCB && (typeof doneCB == 'function')) {
								doneCB(bytes, error);
								delete that.mLoadingGames[gameOrigin];
							}
						});
					} else {
						doneCB(bytes, error);
						delete this.mLoadingGames[gameOrigin];
					}
				}).bind(this));
			}
		}).bind(this), failEarly);
	},

	_allowBGUpdatesRecv: function( cmd )
	{
		var o = {};
		this._allowBGUpdatesRecvGen(cmd, o);
		this._pauseOrResumeAll(o.allow);
	},

	_pauseOrResumeAll: function(resume)
	{
		for (i in this.mLoadingGames)
		{
			if (resume)
			{
				console.log("Resuming download of " + i);
				this.resumeUpdate(i);
			}
			else
			{
				console.log("Pausing download of " + i);
				this.pauseUpdate(i);
			}
		}
	},

	pauseUpdate: function(url)
	{
		if (this.mLoadingGames[url])
		{
			if(this.mLoadingGames[url].dlman)
			{
				this.mLoadingGames[url].dlman.pause();
				this.mLoadingGames[url].userPause = true;
			}
		}
	},

	_pauseUpdateRecv: function(cmd)
	{
		var o = {};
		this._pauseUpdateRecvGen(cmd, o);
		this.pauseUpdate(o.url);
	},

	resumeUpdate: function(url)
	{
		if (this.mLoadingGames[url])
		{
			if(this.mLoadingGames[url].dlman)
			{
				this.mLoadingGames[url].dlman.resume();
				this.mLoadingGames[url].userPause = false;
			}
		}
	},

	_resumeUpdateRecv: function(cmd)
	{
		var o = {};
		this._resumeUpdateRecvGen(cmd, o);
		this.resumeUpdate(o.url);
	},

	cancelUpdate: function(url)
	{
		if (this.mLoadingGames[url])
		{
			if (this.mLoadingGames[url].dlman) {
                this.mLoadingGames[url].dlman.abort();
            }
			delete this.mLoadingGames[url];

			//Cancel the keep alive request as well
			var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;

            this.identification_key = 'manifest_download';
            LifecycleEmitter.cancelEngineKeepAlive(this);
		}
	},

	_cancelUpdateRecv: function(cmd)
	{
		var o = {};
		this._cancelUpdateRecvGen(cmd, o);
		this.cancelUpdate(o.url);
	},

	_setProgress: function (progress) {
		if(progress > 1) progress = 1;
		if(progress < 0) progress = 0;
		progress = progress*this._progressRange + this._progressMin;
		this._setUpdateProgressSendGen(progress);
	},

	listenToProgress: function (listener)
	{
		this._privListener = listener;
	},

	_updateProgress: function(url, prog, total, err)
	{
		//console.log("Updating progress for: %s, %d, %d " + err, url, prog, total);
		if (this._privListener)
			this._privListener(url, prog, total, err);

		if (this.mLoadingGames[url] && this.mLoadingGames[url].id >=0)
			this._updateProgressSendGen(url,prog,total,err);
	},

	// doneCB = function(totalBytes, error)
	_callDownloadManifest: function (config, gameOrigin, name, failEarly, failAllowed, doneCB)
	{
		var contentUrl = config.contentUrl;
		var reportTotalBytes = 0;
		var self = this;
		var Downloader = require('NGCore/Client/Network/DownloadManifest').DownloadManifest;
		
		var manifestName = require('NGCore/Client/Core/_int_LGL')._int_LGL.getManifestName(config);

		// Do download
		(function doDownload()
		{
			var dler = new Downloader();
			dler.mLocalGameList = self;
			var firstProgress = true;
            var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;
            this.identification_key = 'manifest_download';
            NgLogD("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++Manifest Download Request Keep Engine Alive");
            LifecycleEmitter.requestEngineKeepAlive(this);
			// Only allow this on iOS
			config.omitJsUpdate = config.omitJsUpdate && (Capabilities.getPlatformOS() == "iPhone OS");
			dler._setConfig(config);
			dler.start(contentUrl, name, {'webgame.ngmanifest':manifestName}, function(bytesDownloaded, bytesTotal)
			{
				if(firstProgress)
				{
					// First progress callback is made when manifest is downloaded.
					firstProgress = false;
					self._setProgress(0.2);
					reportTotalBytes = bytesTotal;
				}
				else
				{
					self._setProgress(0.3 + 0.6 * (bytesDownloaded / bytesTotal));
				}

				// update LGL
				self._updateProgress(gameOrigin, bytesDownloaded, bytesTotal);
			}, function(error, manifest, wasCached)
			{
				if (failAllowed)
				{
					if (doneCB)
					{
						doneCB(reportTotalBytes, error);
					}
				}
				else if(error)
				{
					NgLogE("Error: " + error);
					// update LGL
					self._updateProgress(gameOrigin, 0, 0, error);
					doneCB(0, error);
				}
				else
				{
					if (doneCB)
					{
						doneCB(reportTotalBytes);
					}
				}

                this.identification_key = 'manifest_download';
                LifecycleEmitter.cancelEngineKeepAlive(this);
			}, false, failEarly);
			self.mLoadingGames[gameOrigin].dlman = dler;
		})();
	},

	freeSpace: function(space, cb)
	{
		this.mRequiredAvailableSpace = space;
		this.mSpaceFreeCallbacks.push(
			(function()
			{
				if (this.mRequiredAvailableSpace > this.mSpaceAvailable)
				{
					if (this._privListener)
					{
						this._privListener("", 0, 0, "SD card is full");
					}
					else
					{
						console.log("Warning!! Mobage is not handling SD card full error!");
						// This is Preservation of ancient code which has and will likely never execute
						var checkAgain = function()
						{
							if (this.mRequiredAvailableSpace > this.mSpaceAvailable)
							{
								this.pruneGames(1);
								this.mSpaceFreeCallbacks.push(checkAgain);
							}
							else
							{
								cb();
							}
						};
						// Is a redundant check on space, but looks better/is simpler/won't ever be used anyhow
						checkAgain();
					}
				}
				else
				{
					cb();
				}
			}).bind(this)
		);

		this._getRepoSpaceSendGen();
	},

	pruneGames: function(number)
	{
		var self = this;

		// Function to put oldest games on top of the stack
		var sort = function (l, r)
		{
			return r.lastRun - l.lastRun;
		};

		this.mGameStore.getItem(this.mActiveGameKey,
			function(error, value)
			{
				var list = JSON.parse(value);
				list.sort(sort);
				while (number-- && (list.length - 1))
				{
					var game = list.pop();

					// Do not delete the currently loading game
					if (!(game.name in self.mLoadingGames))
					{
						// delete game
						self.deleteGameFiles(game.name);
					}
					else
					{
						list.push(game);
					}
				}

				// Save the data
				self.mGameStore.setItem(self.mActiveGameKey, JSON.stringify(list));
			}, true
		);
	},

	deleteGame: function (url, callBack)
	{
		var Util = require('NGCore/Client/Network/Util').Util;
		var norm = Util.NormalizeUrl(url);
		var mdFive = toMD5(norm);

		this.deleteGameFiles(mdFive);
		this._deleteGameFromStorage(mdFive, callBack);
	},

	// Delete the KeyValueCache.local of the given game
	deleteGameKeyValue: function(mdFive)
	{
		var kvm = require('NGCore/Client/Storage').KeyValueCache;
		kvm.global(mdFive).clear();
	},

	deleteGameFiles: function(game)
	{
		var self = this;
		self.mFile.deleteFile( game , 
			function(err)
				{
					if(err == "" )
						NgLogI('Deleted');
					else
						NgLogD("Could not delete game");

					self._getRepoSpaceSendGen();
				});
	},

	getGameList: function()
	{
		return this.mGameList;
	},

	clearWatch: function()
	{
		var fs = require('NGCore/Client/Storage/FileSystem').FileSystem;
		fs.deleteFile(".watch");
	},

	/**
	 * @private
	 */
	_reloadGameList: function(newItem, cb)
	{
		this.mGameStore.getItem(this.mActiveGameKey,
			(function(error, value)
			{
				var list;
				if (value)
					list = JSON.parse(value);
				else
					list = [];

				if (newItem)
				{
					var bNew = true;
					for (var i in list)
					{
						if (list[i].name == newItem.name)
						{
							bNew = false;
							newItem.lastRun = list[i].lastRun;
							list[i] = newItem;
							break;
						}
					}

					if (bNew)
					{
						list.push(newItem);
					}
					this.mGameStore.setItem(this.mActiveGameKey, JSON.stringify(list));
				}

				this.mGameList = list;

				if (typeof cb == 'function')
					cb();
			}).bind(this),
			true
		);
	},

	_getRunningGame: function(callBack)
	{
		// Function to put oldest games on top of the stack
		var sort = function (l, r)
		{
			return r.lastRun - l.lastRun;
		};

		this._reloadGameList(false, (function(cb)
		{
			var list = this.mGameList;
			list.sort(sort);
			var current = null;
			var len = list.length;
			for (var i = 0; i < len; ++i)
			{
				if (list[i].lastRun)
				{
					current = list[i];
					break;
				}
			}
			if (current && current.url)
				cb(current.url);
		}).bind(this, callBack));
	},

	/** @private */
	_pausingGame: function()
	{
		// true to resume download when pausing a game
		this._pauseOrResumeAll(true);
	},

	/** @private */
	_resumingGame: function()
	{
		// Check if the current game allows downloading
		this._getRunningGame((function(game)
		{
			this.getGameConfig(game, (function(config)
			{
				if (config.noBackgroundUpdates)
				{
					// false to pause download when resuming a game
					this._pauseOrResumeAll(false);
				}
			}).bind(this));
		}).bind(this));
	},

	setSplashVisible: function( visible )
	{
		this._setSplashVisibleSendGen(visible);
	},

	setProgressText: function( text )
	{
		this._setProgressTextSendGen(text);
	},

	updateAvailable: function(game, doneCB, errorCB)
	{
		var _int_LGL = require('NGCore/Client/Core/_int_LGL')._int_LGL;
		_int_LGL.updateAvailable(game, doneCB, errorCB);
	},

	/*
	 * Set the exception handler. Default is undefined.
	 * @param {Function} the function that handles the exception occurred in the Game proc. signature: function(exceptionString)
	 */
	setExceptionHandler: function(func)
	{
		this._exceptionHandler = func;
	},

	_exceptionForwardedRecv: function( cmd )
	{
		var obj = {};
		this._exceptionForwardedRecvGen(cmd, obj);
		var exception = JSON.parse(obj.exceptionString);
		
		if (this._exceptionHandler)
			this._exceptionHandler(exception);
		else
			NgLogException(exception);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/NativeAppLaunch'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/NativeAppLaunch'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/NativeAppLaunch'] = exports; // @deprecated
var NativeAppLaunch;

exports.NativeAppLaunch = NativeAppLaunch;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/NgPipe'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/NgPipe'] || {}; $MODULE_REGISTRY['NGCore/Shared/NgPipe'] = exports; var Class = require('NGCore/Shared/Class').Class;
var NgPipesRemote = require('NGCore/Shared/NgPipesRemote').NgPipesRemote;
var hex_sha1 = require('NGCore/Shared/Lib/sha1').hex_sha1;
var __hasProp = Object.prototype.hasOwnProperty;
var CapabilitiesReq = require('NGCore/Client/Core/Capabilities');

/*
The NgPipes object
*/

NgPipe = Class.subclass({
    classname: "NgPipe",
    initialize: function(options) {
        options = options || {};
		/*
		 * Note that this require statement cannot be put at the top level
		 * because it will cause code to fail to execute.  It's an intricacy
		 * in our require system.
		 */
		this._socAnalytics = require('NGCore/Client/Social').Social.Common.Analytics;
        this._meta = options.meta || {};
        this._queue = null;
        this._isSendQueued = false;
        this._sendDelay = options.sendDelay || 5000;
        this._meta = options.meta || {};
        this._seqStart = options.seqStart || new Date().getTime();
        this._playerState = options.playerState || null;
        this._seqNumber = options.seqNumber || 0;
        this._allowedLargeValue = {
            msg: 1024 * 5,
            err: 1024 * 5,
            sid: 64,
            udid: 64
        };

        this._sendToRemote = true;
        this._globalKey = '__NgPipeStorage';
        var self = this;
        var cb = function(error,value, key) {
            var new_queue = [];
            if (!error) {
                try {
                    new_queue = JSON.parse(value);
                } catch(e) {
                    new_queue = [];
                }
            }

            if (self._queue) {
                new_queue = self._queue.concat(new_queue);
            }

            self._setQueue(new_queue);
            if (self._queue.length > 0 ){
                self._drainQueue();
            }
        };
        this._locListener = null;
        this._location = null;
        Storage.KeyValueCache.global(this._globalKey).getItem(this._globalKey, cb);
        var starting_queue = [].concat(options.queue || []);
        this._queue = starting_queue;
        this._sessionEnded = false;
        this._capAlphaNumStringKeys = ['afam', 'asku', 'srcty', 'evcl', 'evid', 'pltfmsku','carr','srv'];
        this.sessionStartEvent();
        this._tagQa();
        this._hookLifetime();
        this._hookGeo();
        return true;
    },

    close: function() {
        this._drainQueue();
        return true;
    },

    enable: function() {
        this._sendToRemote = true;
    },

    disable: function() {
        this._sendToRemote = false;
    },

    setRemoteUrl: function(url) {
        NgPipesRemote.setUrl(url);
    },

    playerEvent: function(eventId, evcl, change, playerState) {
        var e;
        evcl || (evcl = "PLST");
        e = {
            change: change,
            srcty: 'GC',
            evid: eventId,
            evcl: evcl,
            plst: this._getPlayerStateDiff(playerState || this._playerState)
        };
        this._queueMessage(e);
        this._setCurrentPlayerState(playerState);
        return e;
    },
    gameEvent: function(eventId, payload, playerState) {
        var e;
        e = {
            evid: eventId,
            evpl: payload,
            srcty: 'GC',
            evcl: 'GAME'
        };

        if (playerState) {
          e.plst = this._getPlayerStateDiff(playerState || this._playerState);
        }
        this._queueMessage(e);
        return e;
    },
    gameOpsEvent: function(eventId, payload) {
        var e;
        e = {
            evid: eventId,
            evpl: payload,
            srcty: 'GC',
            evcl: 'GAMEOPS'
        };
        this._queueMessage(e);
        return e;
    },
    revenueEvent: function(eventId, payload) {
        var e;
        e = {
            evcl: 'REV',
            evid: eventId,
            srcty: 'PC',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    uiEvent: function(eventId, payload) {
        var e;
        e = {
            evcl: 'UI',
            srcty: 'GC',
            evid: eventId,
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    funnelEvent: function(eventId, payload, playerState) {
        var e;
        e = {
            evcl: 'FUNNEL',
            srcty: 'GC',
            evid: eventId,
            evpl: payload
        };

        if (playerState) {
          e.plst = this._getPlayerStateDiff(playerState || this._playerState);
          this._setCurrentPlayerState(playerState);
        }
        this._queueMessage(e);
        return e;
    },
    plusEvent: function(eventId, payload) {
        var e;
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            evid: eventId,
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    plusUIEvent: function(eventId, payload) {
        var e = {
            evcl: 'PLUSUI',
            srcty: 'PC',
            evid: eventId,
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    navigationEvent: function(fromScreen, toScreen, buttonID){
        var payload = {};
        payload.fro = fromScreen;
        payload.to  = toScreen;
        if(buttonID){
            payload.btnid = buttonID;
        }

        return this.plusUIEvent("NAV", payload);
    },
    sessionEndEvent: function() {
        if (!(this._sessionEnded)) {
            var e;
            var Capabilities = CapabilitiesReq.Capabilities;

            e = {
                evid:  'SFN',
                evcl:  'PLUS',
                srcty: 'PC',
                hwty:  Capabilities.getDeviceName(), // cat ro.product.manufacturer, ro.product.brandh, ro.product.model
                hwrev: Capabilities.getPlatformHW(), // cat ro.revision + ro.build.date.utc
                osrev: ""+  Capabilities.getPlatformOS() + " " + Capabilities.getPlatformOSVersion(), // ro.build.fingerprint
                lang: Capabilities.getLanguage()
            };

            e = this._queueMessage(e);
            this._sessionEnded = true;
            return e;
        }
        return null;
    },
    sessionStartEvent: function() {
        var e;
        var Capabilities = CapabilitiesReq.Capabilities;

        e = {
            evid:  'SST',
            evcl:  'PLUS',
            srcty: 'PC',
            hwty:  Capabilities.getDeviceName(), // cat ro.product.manufacturer, ro.product.brandh, ro.product.model
            hwrev: Capabilities.getPlatformHW(), // cat ro.revision + ro.build.date.utc
            osrev: ""+  Capabilities.getPlatformOS() + " " + Capabilities.getPlatformOSVersion(), // ro.build.fingerprint
            lang: Capabilities.getLanguage()
        };



        e = this._queueMessage(e);
        return e;
    },
    socialEvent: function(eventId, friendId,  payload) {
        var e;
        e = {
            evcl: 'SOCL',
            srcty: 'GC',
            frid: friendId,
            evid: eventId,
            evpl: payload
        };
        return this._queueMessage(e);
    },
    initPlayerState: function(inState) {
        this._setCurrentPlayerState(inState);
        return true;
    },

    updatePlayerState: function(newState) {
        this._setCurrentPlayerState(newState);
        return true;
    },

    //params for internal IAP events:

    //promo campaign unique identifier
    //promoid (String)

    //price of virtual good
    //price (Float)

    //currency used. Defaults to USD
    //cur (String)

    //user's moba balance after purchase
    //mobabalance (Integer)

    //unique identifier for purchase
    //orderid (String)

    //a string identifier for an item, e.g. "IceCastle"
    //sku (String)

    //the value of the item in moba
    //mobaprice (Float)

    //the quantity of item being purchased
    //itemamt (Float)

    //a text description of the item.
    //desc (String)

    //a message displayed to the user when the debit or credit occurs
    //dispmsg (String)

    //the name of the item, as displayed to the user
    //dispname (String)

    //the Mobage ID for the product.
    //productid (Integer)

    //dynamic data accepts a custom object with any params not included above
    //dynamicdata (Object)

    reportAdShow : function(adid) {
        return this.revenueEvent('ADSHOW',{'adid':adid});      
    },

    reportAdClick : function(adid) {
        return this.revenueEvent('ADCLCK',{'adid':adid});    
    },

    reportPromoShow : function(promoid) {
        return this.revenueEvent('PROMOSHOW',{'promoid':promoid});    
    },

    reportPromoClick : function(promoid) {
        return this.revenueEvent('PROMOCLCK',{'promoid':promoid});    
    },

    reportPromoRedeem : function(promoid) {
        return this.revenueEvent('PROMOREDM',{'promoid':promoid});    
    },

    //user clicks on money sku
    reportMoneyIAPIntent : function(sku,item_amt,price,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPINTENT', evpl);
    },

    //user cancels a money sku transaction
    reportMoneyIAPCancel : function(sku,item_amt,price,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPCANCEL', evpl);
    },

    //money sku transaction is successful; orderid required
    reportMoneyIAPSuccess : function(sku,item_amt,price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            orderid : orderid,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPSUCCESS',evpl);
    },

    //money iap purchase fails after being authorized by user; orderid optional if available, pass in null otherwise
    reportMoneyIAPFail : function(sku,item_amt,price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        orderid ? evpl.orderid = orderid : "";
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPFAIL', evpl);
    },

    //user opens money IAP store
    reportMoneyIAPShow : function() {
        return this.revenueEvent('IAPSHOW',{});
    },

    //user opens moba IAP store
    reportMobaIAPShow : function() {
        return this.revenueEvent('MOBAIAPSHOW',{});
    },

    //user clicks on a moba sku
    reportMobaIAPIntent : function(sku,moba_price,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPINTENT', evpl);
    },

    //user cancels moba sku transaction
    reportMobaIAPCancel : function(sku,moba_price,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPCANCEL', evpl);
    },

    //moba sku transaction is successful. orderid required. 
    reportMobaIAPSuccess : function(sku,moba_price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            orderid : orderid,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPSUCCESS', evpl);
    },

    //moba sku purchase fails after being authorized by user. orderid optional if available, pass in null otherwise
    reportMobaIAPFail : function(sku,moba_price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        orderid ? evpl.orderid = orderid : '';
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPFAIL', evpl);
    },

    /**
    * Report us scraping a facebook user's profile - ext_id is the user's facebook ID.
    *
    */
    reportFacebookScrape : function(ext_id, dynamicdata) {
        var e;
        var evpl={};
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            extid: ext_id,
            evid: 'FBSCRAPE',
            evpl: evpl
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * Report us scraping a user's contact list - ext_id is the user's facebook ID.
    *
    */
    reportContactScrape : function(dynamicdata) {
        var e;
        var evpl={};
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            evid: 'CONTACTSCRAPE',
            evpl: evpl
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * Report a user posting to another user's wall.
    *
    */
    reportWallPost : function(friendId, payload) {
        var e;
        e = {
            evcl: 'SOCL',
            srcty: 'PC',
            frid: friendId,
            evid: 'WALLPOST',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * Report a user downloading a game from a specific section in the store.
    * @param {String} game is the asku for the game being downloaded.
    * @param {String} section is the name of the section that the user downloaded from:
    *   AllGames, FeaturedGames, MyProfile, FriendsLastPlayedGame, FriendsPlayingGame
    * @param {String} slot is the order of the game in the section (if applicable)
    */
    reportDownload : function(game, section, slot) {
        var payload = {};
        payload.game = game;
        payload.section = section;
        payload.slot = slot;
        var e;
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            evid: 'DOWNLOAD',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * add internal tag to a user.
    */
    addTag : function(tagName) {
        var payload = {};
        payload.tag = tagName;
        var e;
        e = {
            evcl: 'PLUS',
            evid: 'TAG', 
            srcty: 'PC',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },

    getSeqNumber: function() {
        this._seqNumber += 1;
        return this._seqNumber;
    },

    getQueueCount: function() {
        return this._queue.length;
    },

    getSendDelay: function() {
        return this._sendDelay;
    },

    setSendDelay: function(val) {
        return (this._sendDelay = val);
    },

    setMeta: function(key, value) {
        if (!value) {
            value = key;
            return (this._meta = value);
        } else {
            return (this._meta[key] = value);
        }
    },

    getMeta: function(key) {
        if (key) {
            return this._meta[key];
        } else {
            return this._meta;
        }
    },

    _queueMessage: function(msg) {
        if (!msg) {
            return false;
        }

        var self = this;

        //This sets metas that don't change often
        this._setUnsetMetaKeys();

        // The rest of these function set properties that 
        msg = this._mergeMeta(msg);
        msg = this._addSeqDetails(msg);
        msg = this._addGeo(msg);
        msg = this._addEvts(msg);
        msg = this._addGameSku(msg);
        msg = this._addGameRel(msg);
        msg = this._addCarrier(msg);
        msg = this._addService(msg);
        msg = this._addPlatformVersion(msg);
        msg = this._addUserId(msg);
        msg = this._addUserName(msg);
        msg = this._normalizeValues(msg);
        var queue = this._getQueue();
        queue.push(msg);
        this._setQueue(queue);

        if (!this._isSendQueued) {
            setTimeout(function() {
                self._isSendQueued = false;
                return self._drainQueue();
            }, self._sendDelay);
        }
        return msg;
    },
    _tagQa: function() {
        var fs = require('NGCore/Client/Storage/FileSystem').FileSystem;
        var self = this;
        fs.readFile('QA',function(err,data) {
            if (!err) {
                self.addTag("NGMOCOQA");
            }
        });
    },
    _hookGeo: function() {
        var Social = require('NGCore/Client/Social').Social;
        if(Social.US){
            var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
            var Device = require('NGCore/Client/Device').Device, self = this;
            var LocationListener = MessageListener.subclass({
                initialize: function() {
                    Device.LocationEmitter.addListener(this, this.onUpdate, false);
                },
                onUpdate: function(location) {
                    self._location = location;
                    Device.LocationEmitter.removeListener(this);
                    self._locListener = null;
                }
            });
            this._locListener = new LocationListener();
        }
    },
    _hookLifetime: function() {
        var self = this;
        var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
        var Device = require('NGCore/Client/Device').Device;
        var ListenerClass =  MessageListener.subclass({
            initialize: function() {
                Device.LifecycleEmitter.addListener(this, this.onLifecycleUpdate);
            },
            onLifecycleUpdate: function(event) {
                switch (event) {
                case Device.LifecycleEmitter.Event.Suspend:
                case Device.LifecycleEmitter.Event.Terminate:
                    self.sessionEndEvent();
					self._drainQueue();
                    break;
                case Device.LifecycleEmitter.Event.Resume:
                default:
                    self.initialize();
                    break;
                }
            }
        });
        if (!this._listener) {
            this._listener = new ListenerClass();
        }
    },
    /**
    * Game Service running inside privileged interpreter may use this method
    * to change the Social Analytic object to be used.  Please see MOBWEST-2300
	* for details
	*
    * @private
    */
	_setSocialAnalytics: function(obj) {
		this._socAnalytics = obj;
	},
    _setUnsetMetaKeys: function() {
        var Capabilities = CapabilitiesReq.Capabilities, udid;
        if ((!this.getMeta('udid')) && (udid = Capabilities.getUniqueId() )) {
            this.setMeta('udid', udid);
        }

        if (!this.getMeta('sid')) {
            var sid = ''+ hex_sha1(this._seqStart+ (this.getMeta('udid')|| "UNKNOWN"));
            this.setMeta('sid', sid);
        }

        if (!this.getMeta('pltfmsku')) {
            var platRegex = /android/;

            var plat = Capabilities.getPlatformOS();
            if (plat) {
                plat = plat.toLowerCase();
                if (plat.match(platRegex) ) {
                    plat = "android";
                } else if ("flash" === plat ) {
                    plat = "flash";
                } else {
                    plat = "ios";
                }
                this.setMeta( 'pltfmsku', plat);
            }
        }

        if (!this.getMeta('apiver')) {
            this.setMeta('apiver', 5);
        }
        return true;
    },

    _getPlayerStateDiff: function(newState) {
        var delta_sign, delta_value, diff, key, value;
        diff = {};
        if (!this._playerState) {
            this._setCurrentPlayerState(newState);
        }
        for (key in newState) {
            if (!__hasProp.call(newState, key)) continue;
            value = newState[key];
            if (typeof value === 'number') {
                delta_value = (value - this._playerState[key]) || 0;
                if (delta_value < 0) {
                    delta_sign = '-';
                }
                if (delta_value >= 0) {
                    delta_sign = '+';
                }
                diff[key] = "" + delta_sign + "," + Math.abs(delta_value) + "," + (this._playerState[key]);
            } else if (typeof value === 'string') {
                diff[key] = value;
            }
        }
        return diff;
    },

    _setCurrentPlayerState: function(pst) {
        var key, value;
        this._playerState = {};
        for (key in pst) {
            if (!__hasProp.call(pst, key)) continue;
            value = pst[key];
            this._playerState[key] = value;
        }
        return true;
    },

    _addEvts: function(msg) {
      var d = new Date(); 
      msg.evts =  d.getTime();
      return msg;
    },
    _addGeo: function(msg) {
        var loc_point;

        if (this._location && (loc_point = this._location.getPosition())  && !isNaN(loc_point.getX()) && !isNaN(loc_point.getY())) {
            msg.geo = "" + loc_point.getX() + "," + loc_point.getY();
        }
        return msg;
    },
    _addCarrier: function(msg) {
        var Capabilities = CapabilitiesReq.Capabilities;
        var carr = Capabilities.getCarrier();
        if (carr) {
            msg.carr = carr;
        }
        return msg;
    },
    _addService: function(msg) {
        var Analytics = this._socAnalytics;
        msg.srvc = Analytics.getServiceId();
        return msg;
    },
    _addPlatformVersion: function(msg) {
        var Analytics = this._socAnalytics;
        msg.pver = Analytics.getPlatformVersion();
        return msg;

    },
    _addSeqDetails: function(msg) {
        this._seqNum += 1;
        msg.seq = this.getSeqNumber();
        msg.seqdt = new Date().getTime() - this._seqStart;
        return msg;
    },
    _addUserId: function(msg) {
      var Analytics = this._socAnalytics;
      var uid = Analytics.getUserId();
      if (uid) {
        msg.uid = uid;
      }
      return msg;
    },
    _addUserName: function(msg) {
      var Analytics = this._socAnalytics;
      var un = Analytics.getUsername();
      if (un) {
        msg.plus = un;
      }
      return msg;
    },
    _addGameSku: function(msg) {
        var app_key = (Capabilities.getConfigs() || {} )["appId"];
        if ( app_key ) {
            msg.asku = app_key;
        }
        return msg;
    },
    _addGameRel: function(msg) {
        var arel = Capabilities.getAppReleaseVersion();
        if (arel) {
          msg.arel = arel;
        }
        return msg;
    },
    _normalizeValues: function(msg) {
        var key, value;
        for (key in msg) {
            if (!__hasProp.call(msg, key)) continue;
            value = msg[key];
            if (typeof value === 'string') {
                value = this._normalizeString(key, value);
            } else if (typeof value === 'object') {
                value = this._normalizeValues(value);
            }
            msg[key] = value;
        }
        return msg;
    },

    _normalizeString: function(key, value) {
        value = value.substring(0, this._allowedLargeValue[key] || 32);
        if (-1 !== this._capAlphaNumStringKeys.indexOf(key)) {
            value = value.toUpperCase().replace(/[^\w]+/g, "").replace("_", "");
        }
        return value;
    },

    _mergeMeta: function(msg) {
        var _ref, _ref2, key, new_msg, value;
        new_msg = {};
        for (key in msg) {
            if (!__hasProp.call(msg, key)) continue;
            value = msg[key];
            new_msg[key] = value;
        }
        for (key in _ref = this._meta) {
            if (!__hasProp.call(_ref, key)) continue;
            value = _ref[key];
            (_ref2 = new_msg[key]) ? _ref2 : new_msg[key] = value;
        }
        return new_msg;
    },

    _drainQueue: function() {
        var cb, self, toDrain;
        toDrain = this._getQueue();
        this._setQueue([]);
        self = this;

        if (! this._sendToRemote)
            return true;

        cb = function(state, not_sent) {
            if (state === NgPipesRemote.possibleStates.error) {
                self._queueMany(not_sent);
                self._sendDelay = self._sendDelay * 2;
            } else if (state === NgPipesRemote.possibleStates.finished ) {
                self._sendDelay = 5000;
            }
            return true;
        };
        NgPipesRemote.clearQueue(toDrain, cb);
        toDrain = null; // explicit clear to keep memory down
        return true;
    },

    _queueMany: function(msg_arr) {
        var _i, _len, msg, self = this;
        this._setQueue( (this._getQueue() || [] ).concat(msg_arr) );
        if (this._isSendQueued) {
          this._isSendQueued = true;
          setTimeout(function() {
              self._isSendQueued = false;
              return self._drainQueue();
          }, self._sendDelay);
        }

        return true;
    },
    _setQueue: function(new_queue) {
        this._queue = new_queue;
        Storage.KeyValueCache.global(this._globalKey).setItem(this._globalKey, JSON.stringify(this._queue));
        return true;
    },
    _getQueue: function() {
        return this._queue;

    }
});

exports.NgPipe = NgPipe;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/NgPipesRemote'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/NgPipesRemote'] || {}; $MODULE_REGISTRY['NGCore/Shared/NgPipesRemote'] = exports; var Network = require('NGCore/Client/Network').Network;

NgPipesRemote = {
  listeners: [],
  debug: false,

  possibleStates: {
    unknown: {},
    finished: {},
    error: {}
  }
};

NgPipesRemote.addListener = function(listner) {
  this.listeners.push(listner);
  return true;
};

NgPipesRemote.clearQueue = function(queue, callback) {

  if (!queue) {
    return false;
  }

  if (!this.getUrl()) {
    if (callback) {
      callback(NgPipesRemote.possibleStates.finished, []);
    }
    return false;
  }
	var copy_array = queue.slice(0, queue.length);

	var _j, _len2, data;
  while (copy_array && copy_array.length > 0) {
    var to_send = copy_array.slice(0, 10);
    copy_array = copy_array.slice(10);
    data = "";

    for (_j = 0, _len2 = to_send.length; _j < _len2; _j++) {
      data += JSON.stringify(to_send[_j]);
      if (_j+1 < _len2) {
         data += "\r\n";
      } //if len
    } //for

    if (data) {
      NgPipesRemote._makeRequest(data, to_send, callback);
    } //if data
  }//while

};

NgPipesRemote._makeRequest = function(json_data, objs, callback) {
  var request = new Network.XHR(), url = this.getUrl();
  if (this.debug) {
    NgPipesRemote._debugOutput(json_data);
  }

	var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;
	LifecycleEmitter.requestEngineKeepAlive(objs);
  request.onreadystatechange = function() {
    var status = null;
    try {
      if (this.readyState === 4) {
		LifecycleEmitter.cancelEngineKeepAlive(objs);
        status = NgPipesRemote._handleResponse(request.responseText);
      } else {
        status = NgPipesRemote.possibleStates.unknown;
      }
    } catch (ex) {
      status = NgPipesRemote.possibleStates.error;
      NgLogException(ex);
    }

    if (callback) {
      callback(status, objs);
    }

    NgPipesRemote._notifyListeners(status);
    return true;
  };

  request.open("POST", url, true);

  request.setRequestHeader("X-Ngpipes-Api", "1.0");
  request.setRequestHeader("Content-Type", "application/json+batch");
  request.setRequestHeader("If-None-Match", "0");

  request.send(json_data);

  NgPipesRemote._notifyListeners('started');
  return true;
};
NgPipesRemote.setUrl = function(url) {
    this.url = url;
};
NgPipesRemote.getUrl = function() {
    if (this.url)
        return this.url;
    var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
    var url = null;
    
    if (Capabilities) {
      //Get the url from the configuration.json
      url = (Capabilities.getConfigs() || {} )["analyticsServer"] || null;
      if (url) {
        url = "https://"+url+"/pipes/r.2/bulk_record_stats";
        if (this.debug) {
          NgLogD("Pipes URL => " + url );
        }
      }
    }
    return url;
};


NgPipesRemote._handleResponse = function(respText) {
  var respObj, result;
  result = NgPipesRemote.possibleStates.unknown;
  if (respText && respText.length > 0) {
    try {
    respObj = JSON.parse(respText);
    } catch (e) {
      //Clean up after ourselves.
      respObj = null;
    }
	if (respObj  && (respObj.success !== null && respObj.success !== undefined ) && respObj.success) {
      if (this.debug) {
        NgLogD("[NgPipesRemote] Got Success" );
      }
      result = NgPipesRemote.possibleStates.finished;
    } else {
      result = NgPipesRemote.possibleStates.error;
    }
  } else {
      if (this.debug) {
        NgLogD('[NgPipesRemote] ERROR posting');
      }

    result = NgPipesRemote.possibleStates.error;
  }
  return result;
};

NgPipesRemote._debugOutput = function(str) {
  var _i, _len, _result, msg, msgs;
  msgs = str.split("\r\n");
  for (_i = 0, _len = msgs.length; _i < _len; _i++) {
    msg = msgs[_i];
    NgLogD("[NgPipesRemote] Message sent: " + msg);
  }
  return false;
};

NgPipesRemote._notifyListeners = function(state) {
  var _i, _len, _ref, l;
  for (_i = 0, _len = (_ref = this.listeners).length; _i < _len; _i++) {
    l = _ref[_i];
    l(state);
  }
  return true;
};

exports.NgPipesRemote = NgPipesRemote;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/sha1'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/sha1'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/sha1'] = exports; /*
 * @description
 * A JavaScript implementation of the Secure Hash Algorithm, SHA-1, as defined
 * in FIPS PUB 180-1
 * Version 2.1a Copyright Paul Johnston 2000 - 2002.
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for details.
 * @namespace
 * @name sha1
 */

/*
 * Configurable variables. You may need to tweak these to be compatible with
 * the server-side, but the defaults work in most cases.
 */
var hexcase = 0;  /* hex output format. 0 - lowercase; 1 - uppercase        */
var b64pad  = ""; /* base-64 pad character. "=" for strict RFC compliance   */
var chrsz   = 8;  /* bits per input character. 8 - ASCII; 16 - Unicode      */

/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */
function safe_add(x, y)
{
  var lsw = (x & 0xFFFF) + (y & 0xFFFF);
  var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
  return (msw << 16) | (lsw & 0xFFFF);
}

/*
 * Bitwise rotate a 32-bit number to the left.
 */
function rol(num, cnt)
{
  return (num << cnt) | (num >>> (32 - cnt));
}

/*
 * Perform the appropriate triplet combination function for the current
 * iteration
 */
function sha1_ft(t, b, c, d)
{
  if(t < 20) { return (b & c) | ((~b) & d); }
  if(t < 40) { return b ^ c ^ d; }
  if(t < 60) { return (b & c) | (b & d) | (c & d); }
  return b ^ c ^ d;
}

/*
 * Determine the appropriate additive constant for the current iteration
 */
function sha1_kt(t)
{
  return (t < 20) ?  1518500249 : (t < 40) ?  1859775393 :
         (t < 60) ? -1894007588 : -899497514;
}

/*
 * Calculate the SHA-1 of an array of big-endian words, and a bit length
 */
function core_sha1(x, len)
{
  /* append padding */
  x[len >> 5] |= 0x80 << (24 - len % 32);
  x[((len + 64 >> 9) << 4) + 15] = len;

  var w = Array(80);
  var a =  1732584193;
  var b = -271733879;
  var c = -1732584194;
  var d =  271733878;
  var e = -1009589776;

  for(var i = 0; i < x.length; i += 16)
  {
    var olda = a;
    var oldb = b;
    var oldc = c;
    var oldd = d;
    var olde = e;

    for(var j = 0; j < 80; j++)
    {
      if(j < 16) { w[j] = x[i + j]; }
      else {
		w[j] = rol(w[j-3] ^ w[j-8] ^ w[j-14] ^ w[j-16], 1);
	  }
      var t = safe_add(safe_add(rol(a, 5), sha1_ft(j, b, c, d)),
                       safe_add(safe_add(e, w[j]), sha1_kt(j)));
      e = d;
      d = c;
      c = rol(b, 30);
      b = a;
      a = t;
    }

    a = safe_add(a, olda);
    b = safe_add(b, oldb);
    c = safe_add(c, oldc);
    d = safe_add(d, oldd);
    e = safe_add(e, olde);
  }
  return Array(a, b, c, d, e);

}

/*
 * Convert an 8-bit or 16-bit string to an array of big-endian words
 * In 8-bit function, characters >255 have their hi-byte silently ignored.
 */
function str2binb(str)
{
  var bin = Array();
  var mask = (1 << chrsz) - 1;
  for(var i = 0; i < str.length * chrsz; i += chrsz) {
    bin[i>>5] |= (str.charCodeAt(i / chrsz) & mask) << (32 - chrsz - i%32);
  }
  return bin;
}

/**
 * @description
 * Call the <code>core_hmac_sha1()</code> function to calculate the HMAC-SHA1 of a key and some data.
 * A JavaScript implementation of the Secure Hash Algorithm, SHA-1, as defined
 * in FIPS PUB 180-1
 * Version 2.1a Copyright Paul Johnston 2000 - 2002.
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See <a href="http://pajhome.org.uk/crypt/md5">this</a> or <a href="http://www.itl.nist.gov/fipspubs/fip180-1.htm">NIST</a> for details.
 * @namespace
 * @name core_hmac_sha1
 * @function
 * @param key The key to use with sha1.
 * @param data The data to hash.
 * @return A sha1 hash of the data and key.
 * @example
 * var key = "12345"
 * var data = "The data I would like to hash."
 * core_hmac_sha1(key, data);
 */
function core_hmac_sha1(key, data)
{
  var bkey = str2binb(key);
  if(bkey.length > 16) {
	bkey = core_sha1(bkey, key.length * chrsz);
  }

  var ipad = Array(16), opad = Array(16);
  for(var i = 0; i < 16; i++)
  {
    ipad[i] = bkey[i] ^ 0x36363636;
    opad[i] = bkey[i] ^ 0x5C5C5C5C;
  }

  var hash = core_sha1(ipad.concat(str2binb(data)), 512 + data.length * chrsz);
  return core_sha1(opad.concat(hash), 512 + 160);
}

/*
 * Convert an array of big-endian words to a string
 */
function binb2str(bin)
{
  var str = "";
  var mask = (1 << chrsz) - 1;
  for(var i = 0; i < bin.length * 32; i += chrsz) {
    str += String.fromCharCode((bin[i>>5] >>> (32 - chrsz - i%32)) & mask);
  }
  return str;
}

/*
 * Convert an array of big-endian words to a hex string.
 */
function binb2hex(binarray)
{
  var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
  var str = "";
  for(var i = 0; i < binarray.length * 4; i++)
  {
    str += hex_tab.charAt((binarray[i>>2] >> ((3 - i%4)*8+4)) & 0xF) +
           hex_tab.charAt((binarray[i>>2] >> ((3 - i%4)*8  )) & 0xF);
  }
  return str;
}

/*
 * Convert an array of big-endian words to a base-64 string
 */
function binb2b64(binarray)
{
  var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
  var str = "";
  for(var i = 0; i < binarray.length * 4; i += 3)
  {
    var triplet = (((binarray[i   >> 2] >> 8 * (3 -  i   %4)) & 0xFF) << 16) |
                  (((binarray[i+1 >> 2] >> 8 * (3 - (i+1)%4)) & 0xFF) << 8 ) |
                   ((binarray[i+2 >> 2] >> 8 * (3 - (i+2)%4)) & 0xFF);
    for(var j = 0; j < 4; j++)
    {
      if(i * 8 + j * 6 > binarray.length * 32){
		str += b64pad;
	  } else {
		str += tab.charAt((triplet >> 6*(3-j)) & 0x3F);
	  }
    }
  }
  return str;
}

/*
 * These are the functions you'll usually want to call
 * They take string arguments and return either hex or base-64 encoded strings
 */
function hex_sha1(s){return binb2hex(core_sha1(str2binb(s),s.length * chrsz));}
function b64_sha1(s){return binb2b64(core_sha1(str2binb(s),s.length * chrsz));}
function str_sha1(s){return binb2str(core_sha1(str2binb(s),s.length * chrsz));}
function str_hmac_sha1(key, data){ return binb2str(core_hmac_sha1(key, data));}
function hex_hmac_sha1(key, data){ return binb2hex(core_hmac_sha1(key, data));}
function b64_hmac_sha1(key, data, padChar){
	if ((typeof padChar != "undefined") && padChar) {
        b64pad = padChar;
	}
	return binb2b64(core_hmac_sha1(key, data));
}

/*
 * Perform a simple self-test to see if the VM is working
 */
function sha1_vm_test()
{
  return hex_sha1("abc") == "a9993e364706816aba3e25717850c26c9cd0d89d";
}

// Exports for node.js
if((typeof exports != "undefined") && exports)
{
	exports.b64_hmac_sha1 = b64_hmac_sha1;
	exports.hex_sha1 = hex_sha1;
	exports.b64_sha1 = b64_sha1;
}
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social'] || {}; $MODULE_REGISTRY['NGCore/Client/Social'] = exports; /**
 * Public API for GameService
 * 
 * Access this file as NGCore/Client/Social.js
 */

// Note the proper require path for our public interface files is: "./Social/US/[filename]"

/** @namespace
 * @name Social
 * @description
 * The <code>Social</code> namespace provides interfaces for the Mobage Social APIs.
 */
exports.Social = {
};

/** @namespace
 * @name Social.Common
 * @description
 * The <code>Social.Common</code> namespace provides interfaces for functionality common to submodules for Japan (JP), the United States (US), 
 * and future submodules. The common features include Auth, People, Appdata, Blacklist, Profanity and Service. Service APIs can be both common
 * or native, and include the Community button, the Balance button, the Friend Picker, the User Finder, and the User Profile.
 */
exports.Social.Common = {
	Appdata: require('NGCore/Client/Social/US/Common/Appdata').Appdata,
	Auth: require('NGCore/Client/Social/US/Common/Auth').Auth,
	Blacklist: require('NGCore/Client/Social/US/Common/Blacklist').Blacklist,
	Config: require('NGCore/Client/Social/US/Common/Config').Config,
	People: require('NGCore/Client/Social/US/Common/People').People,
	Profanity: require('NGCore/Client/Social/US/Common/Profanity').Profanity,
	Request: require('NGCore/Client/Social/US/Common/Request').Request,
	Service: require('NGCore/Client/Social/US/Common/Service').Service,
  Analytics: require('NGCore/Client/Social/US/Common/Analytics').Analytics
};

/** @namespace
 * @name Social.US
 * @description
 * The <code>Social.US</code> namespace provides interfaces for the United States (US) submodule. 
 * The features include User, Game, Leaderboard, Score, Ordered List, and AppData.
 */
exports.Social.US = {
	// Data Models
	DataModel: require('NGCore/Client/Social/US/Models/DataModel').DataModel,
	User: require('NGCore/Client/Social/US/Models/User').User,
	Game: require('NGCore/Client/Social/US/Models/Game').Game,
	Leaderboard: require('NGCore/Client/Social/US/Models/Leaderboard').Leaderboard,
	Score: require('NGCore/Client/Social/US/Models/Score').Score,
	
	AppData: require('NGCore/Client/Social/US/Models/AppData').AppData,
	
	// Data Cache
	Cache: require('NGCore/Client/Social/US/Models/Cache').Cache,

	// Data APIs
	Session: require('NGCore/Client/Social/US/Data/Session').Session,
	Dispatcher: require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher
};

/** @namespace
 * @name Social.US.Service
 * @description
 * Service APIs include the Community button, the Balance button, the Friend Picker, the User Finder, and the User Profile.
 */
exports.Social.US.Service = {
	Friends: require('NGCore/Client/Social/US/Service/Friends').Friends,
	Profile: require('NGCore/Client/Social/US/Service/Profile').Profile,
	ButtonOverlays: require('NGCore/Client/Social/US/Service/ButtonOverlays').ButtonOverlays,
	GameLaunchPayload: require('NGCore/Client/Social/US/Service/GameLaunchPayload').GameLaunchPayload
};

/** @namespace
 * @name Bank
 * @description
 * The <code>Bank</code> namespace provides interfaces for the Mobage Bank APIs.
 */
exports.Bank = require('NGCore/Client/Social/US/Service/Bank').Bank;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Storage/FileSystem'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Storage/FileSystem'] || {}; $MODULE_REGISTRY['NGCore/Client/Storage/FileSystem'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class FileSystem
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Class = require('NGCore/Client/Core/Class').Class;

////////////////////////////////////////////////////////////////////////////////

exports.FileSystem = Class.singleton(
/** @lends Storage.FileSystem.prototype */
{
	classname: 'FileSystem',
	
	/**
	 * @class The <code>FileSystem</code> class constructs a singleton object that controls file manipulation tasks: reading, writing, deleting, or decompressing a file.
	 * 
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		/** @private */
		this.readRequests = {};
		/** @private */
		this.writeRequests = {};
		/** @private */
		this.cbIdCounter = 1;
		
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/**
	 * Read a file into memory from local storage.
	 * @example FileSys.readFile(SomeFile, true, function(err, data){...}
	 * @param {String} fname The name of the file to read into memory.
	 * @param {Boolean} [binary=false] Set as <code>true</code> if <code>readFile()</code> shouuld conduct a binary read.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file read operation fails.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	readFile: function( fname, binary, cb )
	{
		this.readFileIn(this.Store.Local, fname, binary, cb);
	},

	/**
	 * @private
	 *	read a file from a common store on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location to read from
	 *	@param {fname} The name of the file to be read
	 *	@param {cb} The callback function to be called
	 *	@param {binary} binary mode or not
     *  @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	readFileIn: function( store, fname, binary, cb )
	{
		var cbId = 0;

		if(typeof(binary) == 'function')
		{
			cb = binary;
			binary = false;
		}
		binary = binary || false;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.readRequests[ cbId ] = cb;
		}
		this._readFileSendGen(cbId,store,fname,binary);
	},

	/**
	 * Write a file to local storage.
	 * @example FileSys.writeFile(SomeFile, someData, true, (function(){...});
	 * @param {String} fname The name of the file to write into storage.
	 * @param {Binary, String} data The data to write to the file.
	 * @param {Boolean} [binary=false] Set as <code>true</code> if <code>writeFile()</code> should conduct a binary write.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file write operation fails.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	writeFile: function( fname, data, binary, cb )
	{
		this.writeFileIn(this.Store.Local, fname, data, binary, cb);
	},

	/**
	 * @private
	 *	write a file to a common store on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location to write to
	 *	@param {fname} The name of the file to be written
	 *	@param {cb} The callback function to be called after completion
	 *	@param {binary} binary mode or not
     *  @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	writeFileIn: function( store, fname, data, binary, cb )
	{
		var cbId = 0;

		if(typeof(binary) == 'function')
		{
			cb = binary;
			binary = false;
		}
		binary = binary || false;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.writeRequests[ cbId ] = cb;
		}

		this._writeFileSendGen(cbId,store,fname,data,binary);
	},

	/**
	 * Delete a file from local storage.
	 * @example FileSys.deleteFile(SomeFile,function(err, data){});
	 * @param {String} fname The name of the file to delete.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file delete operation fails.
     * @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	deleteFile: function ( fname, cb )
	{
		this.deleteFileIn(this.Store.Local, fname, cb);
	},

	/**
	 * @private
	 *	delete a file from a common store on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location path
	 *	@param {fname} The name of the file to be deleted
	 *	@param {cb} The callback function to be called
     *  @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	deleteFileIn: function ( store, fname, cb )
	{
		var cbId = 0;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.writeRequests[ cbId ] = cb;
		}
		this._deleteFileSendGen(cbId,store,fname);
	},
	
	/**
	 * Decompress a zipfile.
	 * @example FileSys.readFile(SomeFile, ./some/path/to/destination/, true, function(err, data){...}
	 * @param {String} fname The name of the zipfile to decompress.
	 * @param {String} destination The directory path where the contents of the decompressed file are written.
	 * @param {Boolean} [returnFiles] Set as <code>true</code> if <code>decompressFile()</code> should return a list of files contained in the zipfile specified by the <code>fname</code> parameter.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file decompress operation fails.
     * @status iOS, Android
	 */
	decompressFile: function( fname, destination, returnFiles, cb )
	{
		this.decompressFileIn(this.Store.Local, fname, destination, returnFiles, cb);
	},
	
	/**
	 * @private
	 *	decompress a file to a shared location on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location path
	 *	@param {fname} The name of the file to be read
	 *	@param {cb} The callback function to be called
	 *	@param {destination} destination location to unzip files to
	 *	@param {returnFiles} true/false if true it returns a json object with a list of each file, its MD5 hash and its size
     *  @status iOS, Android    
	 */
	decompressFileIn: function( store, fname, destination, returnFiles, cb )
	{
		var cbId = 0;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.writeRequests[ cbId ] = cb;
		}
		this._decompressFileSendGen(cbId,store,fname,destination,returnFiles);
	},
	
	/**
	 * @private
	 */
	_readFileCbRecv: function( cmd ) 
	{
		var msg = {};
		if(!this._readFileCbRecvGen(cmd, msg))
			return;
			
		var cbId = msg[ "callbackId" ];
		var data = msg[ "data" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			NgLogE ( "FileSystem.onReadFile: No cbId" );
			return;
		}
		
		var cb = this.readRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem.onReadFile: No registered cb found..cbId is :" + cbId );
			return;
		}
		
		delete this.readRequests[ cbId ];
		cb ( err, data );
	},
	
	/**
	 * @private
	 */
	_writeFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._writeFileCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg[ "callbackId" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
			
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}

		delete this.writeRequests[ cbId ];
		cb ( err );
	},
	
	/**
	 * @private
	 */
	_deleteFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._deleteFileCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg[ "callbackId" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}
		
		delete this.writeRequests[ cbId ];
		cb ( err );
	},
	
	/**
	 * @private
	 */
	_decompressFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._decompressFileCbRecvGen(cmd, msg))
			return;
			
		var cbId = msg[ "callbackId" ];
		var files = msg[ "files" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}
		
		try
		{
			files = JSON.parse(files);
		}
		catch(e)
		{
			NgLogE ( "FileSystem command : Could not parse response :" + files );
			err = "Could not parse files";
		}
		
		delete this.writeRequests[ cbId ];
		cb ( err, files );
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	Store:
	{ 
		/** /tmp */
		Temp: 0,
		/** local sandbox */
		Local: 1,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 338
	// Method create = -1
	// Method readFile = 2
	// Method writeFile = 3
	// Method deleteFile = 4
	// Method decompressFile = 5
	// Method readFileCb = 6
	// Method writeFileCb = 7
	// Method deleteFileCb = 8
	// Method decompressFileCb = 9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 6:
					instance._readFileCbRecv( cmd );
					break;
				case 7:
					instance._writeFileCbRecv( cmd );
					break;
				case 8:
					instance._deleteFileCbRecv( cmd );
					break;
				case 9:
					instance._decompressFileCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in FileSystem._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in FileSystem._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[338] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_readFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_writeFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_deleteFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_decompressFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "files" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "files" ] === undefined )
		{
			NgLogE("Could not parse files in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":338,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_readFileSendGen: function( callbackId, storeId, filename, binary )
	{
		Core.Proc.appendToCommandString( ":338,2," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename ) + "," + ( binary ? 1 : 0 )  );
	},
	
	/** @private */
	_writeFileSendGen: function( callbackId, storeId, filename, data, binary )
	{
		Core.Proc.appendToCommandString( ":338,3," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( data ) + "," + ( binary ? 1 : 0 )  );
	},
	
	/** @private */
	_deleteFileSendGen: function( callbackId, storeId, filename )
	{
		Core.Proc.appendToCommandString( ":338,4," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename )  );
	},
	
	/** @private */
	_decompressFileSendGen: function( callbackId, storeId, filename, destination, returnFiles )
	{
		Core.Proc.appendToCommandString( ":338,5," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( destination ) + "," + ( returnFiles ? 1 : 0 )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// readFile: function( callbackId, storeId, filename, binary ) {}
	
	// writeFile: function( callbackId, storeId, filename, data, binary ) {}
	
	// deleteFile: function( callbackId, storeId, filename ) {}
	
	// decompressFile: function( callbackId, storeId, filename, destination, returnFiles ) {}
	
	// _readFileCbRecv: function( cmd ) {}
	// _writeFileCbRecv: function( cmd ) {}
	// _deleteFileCbRecv: function( cmd ) {}
	// _decompressFileCbRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network'] || {}; $MODULE_REGISTRY['NGCore/Client/Network'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Network
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////
/**
 * @name Network
 * @namespace
 * <p>Classes and objects contained by the Network module.</p>
 * @description <p>The Network module is a collection of classes that support manipulation of network flow.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 *<ul>
 *<li><code>{@link Network.DownloadFile}</code>: Construct objects that conduct a file download.</li>
 *<li><code>{@link Network.DownloadManifest}</code>: Construct objects that keep manifests up-to-date.</li>
 *<li><code>{@link Network.XHR}</code>: Construct XmlHttpRequest objects.</li>
 *</ul>
 */
exports.Network = {};

exports.Network.__defineGetter__("XHR", function() {
	delete this.XHR;
	return this.XHR = require('NGCore/Client/Network/XHR').XHR;
});
exports.Network.__defineGetter__("DownloadFile", function() {
	delete this.DownloadFile;
	return this.DownloadFile = require('NGCore/Client/Network/DownloadFile').DownloadFile;
});
exports.Network.__defineGetter__("DownloadManifest", function() {
	delete this.DownloadManifest;
	return this.DownloadManifest = require('NGCore/Client/Network/DownloadManifest').DownloadManifest;
});
exports.Network.__defineGetter__("Util", function() {
	delete this.Util;
	return this.Util = require('NGCore/Client/Network/Util').Util;
});
exports.Network.__defineGetter__("_int_Util", function() {
	delete this._int_Util;
	return this._int_Util = require('NGCore/Client/Network/_int_Util')._int_Util;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/LifecycleEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/LifecycleEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/LifecycleEmitter'] = exports; var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Proc = require('NGCore/Client/Core/Proc').Proc;

exports.LifecycleEmitter = MessageEmitter.singleton(
/** @lends Device.LifecycleEmitter.prototype */
{
	classname: 'LifecycleEmitter',
		
	/**
	 * @class The <code>LifecycleEmitter</code> class constructs a singleton object that emits <code><a href="Device.LifecycleEmitter.html#Event">Event</a></code> 
	 * objects when device lifecycle events occur.
	 * Applications can respond to these events by notifying external sources. For example,
	 * an application can respond to a <code>Terminate</code> event by writing an analytics log.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		/** @private */
		this.identificationCache = {};
		this.numEngineRequests = 0;
	},
	
	_lifecycleEventRecv: function( cmd )
	{
		var msg = {};
		if(!this._lifecycleEventRecvGen(cmd, msg))
			return;
			
		this.emit(msg.event);
		//Cascade the original message back out to native for forwarding
		//	to the next interpreter in the chain.
		this._lifecycleEventSendGen(msg.event);
	},

	/** @private */
	$exitProcess: function()
	{
		this._exitProcessSendGen();
	},
	
	/** @private */
	$_bgMe: function()
	{
		this.__bgMeSendGen();
	},

	/** @private */
	$pauseGame: function()
	{
		NgLogD("+++++++++++++++++++++++++++++++++++++++++Pausing Game");
		this._pauseGameSendGen();
		var _lgl = require('NGCore/Client/Core/_LocalGameList')._LocalGameList;
		_lgl._pausingGame();
	},

	/** @private */
	$resumeGame: function()
	{
		NgLogD("+++++++++++++++++++++++++++++++++++++++++Resuming Game");
		this._resumeGameSendGen();
		var _lgl = require('NGCore/Client/Core/_LocalGameList')._LocalGameList;
		_lgl._resumingGame();
	},

	requestEngineKeepAlive: function(obj)
	{
		var key = obj;
		if (obj.identification_key !== undefined)
		{
			key = obj.identification_key;
		}

		{
			//Store identification key and increment request to engine
			this.identificationCache[key] = true;
			++this.numEngineRequests;
			this.incrementEngineAlive();
		}
	},
	
	cancelEngineKeepAlive: function(obj)
	{
		var key = obj;
		if (obj.identification_key !== undefined)
		{
			key = obj.identification_key;
		}

		{
			if (this.identificationCache[key])
			{
				//Store identification key and increment request to engine
				delete this.identificationCache[key];
				--this.numEngineRequests;
				this.decrementEngineAlive();
			}else{
				NgLogD("Identification Key not found");
			}
		}
	},

	incrementEngineAlive: function()
	{
		this._incrementEngineAliveSendGen();
	},
	
	decrementEngineAlive: function()
	{
		this._decrementEngineAliveSendGen();
	},
	
	cancelAllEngineRequests: function()
	{
		this._cancelAllEngineRequestsSendGen();
	},

	_killGameProc: function( )
	{
		this.__killGameProcSendGen();
	},

// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration values for lifecycle events.
	 * @fieldOf Device.LifecycleEmitter.prototype
	 */
	Event:
	{ 
		/** Application is being suspended. */
		Suspend: 0,
		/** Application is being resumed. */
		Resume: 1,
		/** Application is being terminated. */
		Terminate: 2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 334
	// Method create = -1
	// Method lifecycleEvent = 2
	// Method exitProcess = -3
	// Method pauseGame = -4
	// Method resumeGame = -5
	// Method incrementEngineAlive = 6
	// Method decrementEngineAlive = 7
	// Method cancelAllEngineRequests = 8
	// Method _killGameProc = -9
	// Method _bgMe = -10
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._lifecycleEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LifecycleEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LifecycleEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[334] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_lifecycleEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in LifecycleEmitter.lifecycleEvent from command: " + cmd );
			return false;
		}
		
		obj[ "event" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "event" ] === undefined )
		{
			NgLogE("Could not parse event in LifecycleEmitter.lifecycleEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":334,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_lifecycleEventSendGen: function( event )
	{
		Core.Proc.appendToCommandString( ":334,2," + this.__objectRegistryId + "," + event  );
	},
	
	/** @private */
	$_exitProcessSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -3  );
	},
	
	/** @private */
	$_pauseGameSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -4  );
	},
	
	/** @private */
	$_resumeGameSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -5  );
	},
	
	/** @private */
	_incrementEngineAliveSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334,6," + this.__objectRegistryId );
	},
	
	/** @private */
	_decrementEngineAliveSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334,7," + this.__objectRegistryId );
	},
	
	/** @private */
	_cancelAllEngineRequestsSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334,8," + this.__objectRegistryId );
	},
	
	/** @private */
	$__killGameProcSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -9  );
	},
	
	/** @private */
	$__bgMeSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -10  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _lifecycleEventRecv: function( cmd ) {}
	// lifecycleEvent: function( event ) {}
	
	// $exitProcess: function(  ) {}
	
	// $pauseGame: function(  ) {}
	
	// $resumeGame: function(  ) {}
	
	// incrementEngineAlive: function(  ) {}
	
	// decrementEngineAlive: function(  ) {}
	
	// cancelAllEngineRequests: function(  ) {}
	
	// $_killGameProc: function(  ) {}
	
	// $_bgMe: function(  ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/XHR'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/XHR'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/XHR'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class XHR
// XMLHttpRequest implementation
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Util = require('NGCore/Client/Network/Util').Util;
var Caps = require('NGCore/Client/Core/Capabilities').Capabilities;

////////////////////////////////////////////////////////////////////////////////

var Header = function (item, content)
{
	this.item = item;
	this.content = content;
};
var headerEx = /(.*?): (.*)/;

/**
 * Constants
 */
var State =
{
	UNSENT: 0,
	OPENED: 1,
	HEADERS_RECEIVED: 2,
	LOADING: 3,
	DONE: 4
};

// ///////////// Begin HTTP req'd methods of testing! //////
var methods =
[
	"OPTIONS",
	"GET",
	"HEAD",
	"POST",
	"PUT",
	"DELETE",
	"TRACE",
	"CONNECT"
];

var unsecureMethods = ["CONNECT", "TRACE", "TRACK"];

var checkMethod = function(method)
{
	if(!method) return "GET";

	method = method.toString();

	if (method in unsecureMethods)
	{
		throw "SECURITY_ERROR " + method + " not allowed.";
	}
	if (method.toUpperCase() in methods)
	{
		return method.toUpperCase();
	}
	return method;
};

// ////////////////////////// End! /////////////////////

////////////////////////////////////////////////////////////////////////////////

exports.XHR = Class.subclass(
/** @lends Network.XHR.prototype */
{
	classname: 'XHR',
	
	/**
	 * @class The <code>XHR</code> class constructs <code>XmlHttpRequest</code> objects. Applications can use these objects to
	 * send HTTP or HTTPS requests directly to a web server and load the server response data directly back into a script.
	 * @constructs The default constructor. 
	 * @see <a href="http://www.w3.org/TR/XMLHttpRequest/">Official W3C XmlHttpRequest specification</a>
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this.request;
		this.respHeaders = {};

		this.settings = {};
		this.headers = [];

		// State-associated flags
		this.sendFlag = false;
		this.errorFlag = false;
		
		// Status & response
		this.readyState = State.UNSENT;
		this.responseText = null;
		this.responseXML = null;
		this.status = 0;
		this.statusText = "";
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 340
	// Method create = -1
	// Method destroy = 2
	// Method sendStatus = 3
	// Method sendHeaders = 4
	// Method sendData = 5
	// Method onFinish = 6
	// Method start = 7
	// Method header = 8
	// Method setComposition = 9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._sendStatusRecv( cmd );
					break;
				case 4:
					instance._sendHeadersRecv( cmd );
					break;
				case 5:
					instance._sendDataRecv( cmd );
					break;
				case 6:
					instance._onFinishRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in XHR._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in XHR._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[340] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_sendStatusRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.sendStatus from command: " + cmd );
			return false;
		}
		
		obj[ "statNum" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "statNum" ] === undefined )
		{
			NgLogE("Could not parse statNum in XHR.sendStatus from command: " + cmd );
			return false;
		}
		
		obj[ "statStr" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "statStr" ] === undefined )
		{
			NgLogE("Could not parse statStr in XHR.sendStatus from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_sendHeadersRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.sendHeaders from command: " + cmd );
			return false;
		}
		
		obj[ "headers" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "headers" ] === undefined )
		{
			NgLogE("Could not parse headers in XHR.sendHeaders from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_sendDataRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.sendData from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in XHR.sendData from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onFinishRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.onFinish from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseBool( cmd[ 0 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in XHR.onFinish from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":340,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":340,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_startSendGen: function( method, url, data, headers )
	{
		Core.Proc.appendToCommandString( ":340,7," + this.__objectRegistryId + "," + Core.Base64.encode( method ) + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( data ) + "," + headers  );
	},
	
	/** @private */
	_headerSendGen: function( item, content )
	{
		Core.Proc.appendToCommandString( "," + Core.Base64.encode( item ) + "," + Core.Base64.encode( content )  );
	},
	
	/** @private */
	_setCompositionSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":340,9," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// _sendStatusRecv: function( cmd ) {}
	// _sendHeadersRecv: function( cmd ) {}
	// _sendDataRecv: function( cmd ) {}
	// _onFinishRecv: function( cmd ) {}
	// start: function( method, url, data, headers ) {}
	
	// header: function( item, content ) {}
	
	// setComposition: function(  ) {}
	

// {{/Wg Generated Code}}

// API
	/**
	 * Initialize a request for this <code>XHR</code>.
	 *
	 * <b>Note:</b> Calling <code>open()</code> will wipe all request headers. You must set them after making this call.
	 *
	 * @param {String}
	 *            method The request method 
	 * 		(<code>GET</code>, <code>POST</code>, <code>OPTIONS</code>, <code>HEAD</code>,  
	 *		<code>PUT</code>, <code>DELETE</code>, <code>TRACE</code>, <code>CONNECT</code>)
	 * @param {String}
	 *            url The request URL.
	 * @param {Boolean}
	 *            [async=true] Returns <code>true</code> if the request is synchronous. Returns <code>false</code> in all other cases.<br><br> 
	 * 		<b>Note:</b> Currently not implemented.
	 * @param {String}
	 *            [user] Username for basic authentication.<br><br> 
	 *		<b>Note:</b> Currently not implemented.
	 * @param {String}
	 *            [password] Password for basic authentication.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	open: function(method, url, async, user, password)
	{
		url = url.split(' ').join('%20');
		this.settings =
		{
			"method": checkMethod(method),
			"url": Util.buildRelativeUrl(url),
			"async": async,
			"user": user,
			"password": password
		};

		// Check URL and set XHR flag appropriately
// 		var localServer = Caps.getServer();
// 		if (localServer == url.substr(0, localServer.length) && Caps.getPlatformOS() == "Android")
// 		{
// 			this.NXS = true;
// 		}

		if (this.me && this.sendFlag)
		{
			http.abort(this.me);
		}
		this.reset();
		this.setState(State.OPENED);
	},

	/**
	* @ private
	* Send a request initialized by the <code>open()</code> method. 
	* @param {Array} [composition] Array of strings and file names to be composed into the body.<br><br>
	* <b>Note:</b> This parameter is ignored if <code>readyState</code> is set as <code>GET</code> or <code>HEAD</code>.
	* @throws {INVALID_STATE_ERR} If <code>readyState</code> is set as anything other than <code>OPENED</code> or if the <code>send()</code> flag is true.
	* @see Network.XHR#open
	* @status iOS, Android
	*/

	sendComposition: function(comp)
	{
		// ex: [{"str":"string to send"},{"file":"path/to/file.bin"},{"str":"more goods"}]
		this.composing = true;
		this.send(JSON.stringify(comp));
	},

	/**
	* Send a request initialized by the <code>open()</code> method.
	* @param {String} [data] The request entity body.<br><br>
	* <b>Note:</b> This parameter is ignored if <code>readyState</code> is set as <code>GET</code> or <code>HEAD</code>.
	* @throws {INVALID_STATE_ERR} If <code>readyState</code> is set as anything other than <code>OPENED</code> or if the <code>send()</code> flag is true.
	* @see Network.XHR#open
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	send: function(data)
	{
		if (this.readyState != State.OPENED || this.sendFlag)
		{
			throw "INVALID_STATE_ERR: " + (this.sendFlag ? "Already sending" : "in state " + this.readyState);
		}
		this.sendFlag = true;

		if (data && this.settings.method != "GET" && this.settings.method != "HEAD")
		{
			// TODO http://www.w3.org/TR/XMLHttpRequest/#the-send-method step 3
		}

		this.errorFlag = false;

		// Set content length header
		if (this.settings.method == "GET" || this.settings.method == "HEAD")
		{
			data = null;
		}
		else if (data)
		{
			var bFound = false;
			for (var i in this.headers)
			{
				if (this.headers[i].item == "Content-Type")
				{
					bFound = true;
					break;
				}
			}
			if (!bFound)
			{
				this.setRequestHeader("Content-Type", "text/plain;charset=UTF-8");
			}
		}

		this.responseText = "";

		// Send data to the server
		if (!data)
		{
			data = "";
		}

		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

/* Not supporting NXS. Could remove it, but maybe we will support it one day */
		if (this.NXS)
		{
			this.me = http.create(this);
			for (var i in this.headers)
			{
				var h = this.headers[i];
				http.addHeader(this.me, h.item + ": " + h.content);
			}
			http.send(this.me, this.settings.method, this.settings.url, data);
		}
		else
		{
			if (this.composing)
				this._setCompositionSendGen();

			this._startSendGen(this.settings.method, this.settings.url, data, this.headers.length);
			for (var i in this.headers)
			{
				var obj = this.headers[i];
				this._headerSendGen(obj.item, obj.content);
			}
		}
	}, // this.send() 

	/**
	 * Cancel any existing or pending network activity for this <code>XHR</code>. 
	 * This method is invoked using the specification outlined by W3C.
	 * @see <a href="http://www.w3.org/TR/XMLHttpRequest/#the-abort-method">W3C specification outline for <code>abort()</code></a>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	abort: function()
	{
		this.responseText = null;
		this.errorFlag = true;
		this.headers = [];

		if (this.sendFlag)
		{
			if (this.NXS)
			{
				http.abort(this.me);
			}

			if (this.readyState != State.DONE)
			{
				this.sendFlag = false;
				this.setState(State.DONE);
			}
		}
		this.readyState = State.UNSENT;
	},

	/**
	 * Retrieve a header from the server response.
	 *
	 * @param {String}
	 *            header Name of header to retrieve.
	 * @returns {String} Text of the header or <code>null</code> if text does not exist.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getResponseHeader: function(header)
	{
		if (this.readyState > State.OPENED)
		{
			return this.respHeaders[header.toLowerCase()];
		}
		return null;
	},

	/**
	 * Nonstandard: Retrieve the key-value map of all response headers.
	 *
	 * @return {Object} A key-value map as an object.
     * @status iOS, Android, Test, iOSTested, AndroidTested
     */
	getUnflattenedResponseHeaders: function()
	{
		return this.respHeaders;
	},

	/**
	 * Retrieve all the response headers from a request.
	 * This method is invoked using the specification outlined by W3C.
	 * @return {String} All the response headers from a request.
	 * @see <a href="http://www.w3.org/TR/XMLHttpRequest/#the-getallresponseheaders-method">W3C specification outline for <code>getAllResponseHeaders()</code>.</a>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getAllResponseHeaders: function()
	{
		if (this.readyState < State.HEADERS_RECEIVED || this.errorFlag)
		{
			return "";
		}

		var result = "";
		for (var i in this.respHeaders)
		{
			result += i + ": " + this.respHeaders[i] + "\r\n";
		}
		return result.substr(0, result.length - 2);
	},

	/**
	 * Set a header for the request.
	 *
	 * @param {String}
	 *            header The name of the header.
	 * @param {String}
	 *            value The value of the header.
	 * @see Network.XHR#getRequestHeader
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setRequestHeader: function(header, value)
	{
		this.headers.push(new Header(header, value));
	},

	/**
	 * Retrieve a header from the request.
	 *
	 * @param {String} header The name of the header.
	 * @return {String} The value of the header.
	 * @see Network.XHR#setRequestHeader
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getRequestHeader: function(header)
	{
		var ret = null;
		for (var i in this.headers)
		{
			if (this.headers[i].item == header)
			{
				ret = this.headers[i].content;
				break;
			}
		}
		return ret;
	},

// Receivers
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onStatus: function ( num, str)
	{
		this.status = num;
		this.statusText = str;
	},

	_sendStatusRecv: function( cmd )
	{
		var obj = {};
		this._sendStatusRecvGen(cmd, obj);
		this.onStatus(obj.statNum, obj.statStr);
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onHeaders: function(str)
	{
		var lines = str.split('\n');
		lines.pop();
		for (var i in lines)
		{
			var match = headerEx.exec(lines[i]);
			if (match)
				this.respHeaders[match[1].toLowerCase()] = match[2];
		}
		this.setState(State.HEADERS_RECEIVED);
	},

	_sendHeadersRecv: function( cmd )
	{
		var obj = {};
		this._sendHeadersRecvGen(cmd, obj);
		this.onHeaders(obj.headers);
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onData: function(data)
	{
		this.responseText += data;
		this.setState(State.LOADING);
	},

	_sendDataRecv: function( cmd )
	{
		var obj = {};
		this._sendDataRecvGen(cmd, obj);
		this.onData(obj.data);
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onFinish: function (err)
	{
		this.sendFlag = false;
		if (err)
		{
			this.responseText = null;
			this.error = "Network Error";
			this.errorFlag = true;
			this.status = 0;
		}
		this.setState(State.DONE);
	},

	_onFinishRecv: function( cmd )
	{
		var obj = {};
		this._onFinishRecvGen(cmd, obj);
		this.onFinish(obj.error);
	},

// Internal methods
	/**
	 * Reset all fields from a request. This call sets <code>readyState</code> to <code>UNSENT</code> 
	 * and the response properties to <code>null</code>.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	reset: function()
	{
		this.headers = [];
		this.readyState = State.UNSENT;
		this.responseText = null;
		this.responseXML = null;
		this.composing = false;
	},
	/**
	 * Change the value of <code>readyState</code> and call <code>onreadystatechange()</code>.
	 *
	 * @param {Number}
	 *            state The new value for <code>readyState</code>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setState: function(state)
	{
		this.readyState = state;
		if (state == State.DONE)
		{
			this._destroySendGen();
			ObjectRegistry.unregister(this);
		}
		if (typeof this.onreadystatechange != 'undefined')
		{
			try
			{
				this.onreadystatechange();
			}
			catch (e)
			{
				NgLogException(e);
			}
		}
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/DownloadFile'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/DownloadFile'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/DownloadFile'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class DownloadFile
// Downloads a file to the sandbox
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Class = require('NGCore/Client/Core/Class').Class;

////////////////////////////////////////////////////////////////////////////////

exports.DownloadFile = Class.subclass(
/** @lends Network.DownloadFile.prototype */
{
	classname: 'DownloadFile',
	/**
	* @class The <code>DownloadFile</code> class constructs objects that conduct a file download through an HTTP request.
	* @constructs The default constructor. 
	* @augments Core.Class
	*/
	initialize: function() {},

	/**
	  * Initiate a file download.
	  * @example var url = 'http://url/to/stuff/
	  * new Network.DownloadFile).start(filename, 'GET', url, [], (function(status, md5)
	  * @param {String} filename A local and relative path for storing the downloaded data.
	  * @param {String} method The HTTP method to use.  For example, <code>GET</code> or <code>POST</code>.
	  * @param {String} url The URL of the downloaded file.
	  * @param {Object} [headers] A dictionary that maps header names to header values.
	  * @param {Function} [callback] A callback function for notification
	  * of when the download completes. The signature for the callback is equivalent
	  * to:<br><br>
	  * <pre>function(statusCode,fileSignature)</pre><br>
	  * The <code>fileSignature</code> is currently the
	  * md5 checksum of the file.
	  * @type void
      * @status iOS, Android, Test, iOSTested, AndroidTested
	  */
	start: function(filename, method, url, headers, callback)
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		url = url.split(' ').join('%20');
		// Check headers
		if (!(headers instanceof Array))
		{
			NgLogE('Improper headers sent('+headers+'). Need an array, ex: ["Content-Easter: egg"]');
			headers = [];
		}

		// Send the goods
		this.__sendSendGen( filename, method, url, headers.length );

		// Send headers
		for (var i in headers)
		{
			this.__headerSendGen(headers[i].item, headers[i].content);
		}

		// Save the callback
		this.mCB = callback
	},

	abort: function()
	{
		this._destroySendGen();
		ObjectRegistry.unregister(this);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 341
	// Method create = -1
	// Method destroy = 2
	// Method _send = 3
	// Method _header = 4
	// Method finish = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 5:
					instance._finishRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in DownloadFile._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in DownloadFile._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[341] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_finishRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in DownloadFile.finish from command: " + cmd );
			return false;
		}
		
		obj[ "status" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "status" ] === undefined )
		{
			NgLogE("Could not parse status in DownloadFile.finish from command: " + cmd );
			return false;
		}
		
		obj[ "signature" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "signature" ] === undefined )
		{
			NgLogE("Could not parse signature in DownloadFile.finish from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":341,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":341,2," + this.__objectRegistryId );
	},
	
	/** @private */
	__sendSendGen: function( fileName, method, url, headers )
	{
		Core.Proc.appendToCommandString( ":341,3," + this.__objectRegistryId + "," + Core.Base64.encode( fileName ) + "," + Core.Base64.encode( method ) + "," + Core.Base64.encode( url ) + "," + headers  );
	},
	
	/** @private */
	__headerSendGen: function( item, content )
	{
		Core.Proc.appendToCommandString( "," + Core.Base64.encode( item ) + "," + Core.Base64.encode( content )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// _send: function( fileName, method, url, headers ) {}
	
	// _header: function( item, content ) {}
	
	// _finishRecv: function( cmd ) {}

// {{/Wg Generated Code}}
	
	_finishRecv: function( cmd )
	{
		this._destroySendGen();
		
		var obj = {};
		this._finishRecvGen(cmd, obj);

		if (this.mCB)
			this.mCB(obj.status, obj.signature);

		ObjectRegistry.unregister(this);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/Util'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/Util'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/Util'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Utilities for Network
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Caps = require('NGCore/Client/Core/Capabilities').Capabilities;
var Time = require('NGCore/Client/Core/Time').Time;
var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;

////////////////////////////////////////////////////////////////////////////////

var urlPathServerSplit = /^(https?:\/\/)?([^\/]*)(.*[^\/])?.?/i;

var Util = exports.Util =
{
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	NormalizeUrl: function(url, keepTrailingSlash)
	{
		url = Util.buildRelativeUrl(url);

		// Now split it into parts and make server bits lower case
		var parsed = url.match(urlPathServerSplit);
		if (parsed && parsed[1])
		{
			// absolute path!
			url = parsed[1].toLowerCase() + parsed[2].toLowerCase() + (parsed[3] ? parsed[3] : "");
		}
		else
		{
			// Direct server, no path
			url = url.toLowerCase();
		}
		return url;
	},

	buildRelativeUrl: function(url)
	{
		if (!url.match(/^(https?:\/\/)/))
		{
			// If the path is relative, then we append our server to the beginning of it
			if (url.charAt(0) == '/' || !url.length)
			{
				url = Caps.getServer() + url;
			}
			else
			{
				url = Caps.getServer() + "/" + Caps.getGame() + "/" + url;
			}
		}

		return url;
	},

	RetrySchedule: function(initialRetry, maxDuration)
	{
		var count = Math.floor(Math.log(maxDuration / initialRetry));
		var schedule = [initialRetry];
		for(var i=0; i < count + 1; ++i)
		{
			initialRetry *= 2;
			schedule.push(initialRetry);
		}
		return schedule;
	},
	
	OperationWithRetries: function(operationCb, failureCb, failEarly)
	{
		var abortAttempts;
		var abortTime;
		var abortTimeAttempts;
		
		if(failEarly)
		{
			abortAttempts = 3;
			abortTime = 10000;
			abortTimeAttempts = 1;
		}
		else
		{
			abortAttempts = Infinity;
			abortTime = 30000;
			abortTimeAttempts = 6;
		}
		
		// console.log('retry config abortAttempts:', abortAttempts, 'abortTime', abortTime, 'abortTimeAttempts', abortTimeAttempts);
		
		abortTime = Core.Time.getRealTime() + abortTime;
		var timeout = 250;
		var attemptCount = 1;
		
		var failed = false;
		var armed = true;
		
		var failureParam = function()
		{
			if(failed) return;
			
			if(!armed)
			{
				console.log('OperationWithRetries: failureParam called when not armed');
				return;
			}
			armed = false;
			
			if(attemptCount >= abortAttempts)
			{
				console.log('OperationWithRetries: too many retry attempts');
				var failed = true;
				failureCb();
				return;
			}
			
			if(Core.Time.getRealTime() >= abortTime && attemptCount >= abortTimeAttempts)
			{
				console.log('OperationWithRetries: retries took too long');
				console.log('OperationWithRetries: abortTime:', abortTime, 'realTime:', Core.Time.getRealTime());
				console.log('OperationWithRetries: attemptCount:', attemptCount, 'abortTimeAttempts:', abortTimeAttempts);
				var failed = true;
				failureCb();
				return;
			}
			
			console.log('OperationWithRetries: Failure, will retry in ' + timeout + 'ms');
			setTimeout(function()
			{
				if(failed) return;
				armed = true;
				operationCb(failureParam, abortParam);
			}, timeout);
			
			attemptCount += 1;
			timeout *= 2;
		};
		
		var abortParam = function()
		{
			var failed = true;
			failureCb();
		};
		
		operationCb(failureParam, abortParam);
		
		return abortParam;
	},
	
	showFatalErrorDialog: function(status)
	{
		// Set up info dialog
		var myAlert = new AlertDialog();
		myAlert.setTitle(Core.Localization.getString("Network failure"));
		myAlert.setChoices([Core.Localization.getString("Exit")]);

		myAlert.onchoice =
		function(ret)
		{
			myAlert.hide();
			LifecycleEmitter.exitProcess();
		};
		
		// TODO: Move this list somewhere localizable
		var commonErrors = {
			'302': "File location has changed (302)",
			'400': "Bad request to server (400)",
			'401': "Authorization failed (401)",
			'403': "Server permissions error (403)",
			'404': "Resource not found (404)",
			'408': "Request timed out (408)",
			'500': "Internal server error (500)",
			'501': "Cannot process request (501)",
			'502': "Bad Gateway (502)",
			'503': "Service overloaded / down for maintenance (503)",
			'504': "Timeout at intervening gateway (504)"
		};
		myAlert.setText( Core.Localization.getString( commonErrors[status] || "This application requires a working data connection." ) );
		myAlert.show();
	},

	showSimpleNetworkError: function(status)
	{
		// Set up info dialog
		var myAlert = new AlertDialog();
		myAlert.setTitle(Core.Localization.getString("Network failure"));
		myAlert.setChoices([Core.Localization.getString("OK")]);

		myAlert.onchoice =
		function(ret)
		{
			myAlert.hide();
		};

		// TODO: Move this list somewhere localizable
		var commonErrors = {
			'302': " File location has changed (302)",
			'400': " Bad request to server (400)",
			'401': " Authorization failed (401)",
			'403': " Server permissions error (403)",
			'404': " Resource not found (404)",
			'408': " Request timed out (408)",
			'500': " Internal server error (500)",
			'501': " Cannot process request (501)",
			'502': " Bad Gateway (502)",
			'503': " Service overloaded / down for maintenance (503)",
			'504': " Timeout at intervening gateway (504)"
		};
		var message = "Cannot download game without network connection.";
		if (commonErrors[status])
		{
			message += commonErrors[status];
		}
		myAlert.setText( Core.Localization.getString( message ) );
		myAlert.show();
	},
	
	getCacheBustingString: function()
	{
		return '?t=' + (new Date()).getTime();
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/_int_Util'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/_int_Util'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/_int_Util'] = exports; ///////////////////////////////////////////////////////////////////////////////
// Class _int_Util
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Class = require('NGCore/Client/Core/Class').Class;
////////////////////////////////////////////////////////////////////////////////

exports._int_Util = Class.singleton(
/** @lends Network._int_Util.prototype */
{
	classname: '_int_Util',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this._callbackID = 0;
		this._callbacks = [];

		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	ProcID:
	{ 
		/** High privilege proc */
		Persist: -1,
		/** Low priv */
		Game: -2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 350
	// Method create = -1
	// Method destroy = 2
	// Method sign = 3
	// Method signCallback = 4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 4:
					instance._signCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in _int_Util._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in _int_Util._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[350] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_signCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in _int_Util.signCallback from command: " + cmd );
			return false;
		}
		
		obj[ "signature" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "signature" ] === undefined )
		{
			NgLogE("Could not parse signature in _int_Util.signCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in _int_Util.signCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":350,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":350,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_signSendGen: function( baseString, callbackID, environment )
	{
		Core.Proc.appendToCommandString( ":350,3," + this.__objectRegistryId + "," + Core.Base64.encode( baseString ) + "," + callbackID + "," + Core.Base64.encode( environment )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// sign: function( baseString, callbackID, environment ) {}
	
	// _signCallbackRecv: function( cmd ) {}

// {{/Wg Generated Code}}

	sign: function( baseString, environment, callback) {
		this._callbacks[this._callbackID] = callback;
		this._signSendGen(baseString,this._callbackID, environment);
		this._callbackID++;
	},
	_signCallbackRecv: function( cmd ) {
		var msg = {};
		if (! this._signCallbackRecvGen(cmd, msg)) {
			return;
		}
		var func = this._callbacks[parseInt(msg.callbackID)];
		if (func) {
			func(msg.signature);
		}
	}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/MessageEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/MessageEmitter'] || {}; $MODULE_REGISTRY['NGCore/Shared/MessageEmitter'] = exports; var Class = require('NGCore/Shared/Class').Class;
var MessageListener = require('NGCore/Shared/MessageListener').MessageListener;

exports.MessageEmitter = Class.subclass(
/** @lends Core.MessageEmitter.prototype */
{
	classname: 'MessageEmitter',
	
	/**
	 * @status iOS, Android, Flash
	 * @class The <code>MessageEmitter</code> class constructs emitter objects that send messages to registered <code>{@link Core.MessageListener}</code> objects. 
	 * When a defined condition triggers an emitter, all registered listener objects are in turn triggered.
	 * <br><br>
	 * Emitter objects support two communication modes: emit and chain. When emitting, each listener is called in turn.
	 * When chaining, each listener can halt the propagation of a message to 
	 * other listeners by returning <code>true</code> from their callback.
	 * <br><br>
	 * Each listener can include an optional priority ranking. Priority determines the order
	 * in which an emitter calls each listener. 
	 * If two listener objects are registered with the same priority, the emitter calls them in the order they were registered. 
	 * The default priority is <code>0</code>. 
	 * <br><br>
	 * <b>Note:</b> Do not instantiate this class directly. Use classes derived from <code>MessageEmitter</code> for instantiation. This includes:
	 * <div class="ul">
	 * <li>{@link Core.Localization}</li>
	 * <li>{@link Core.UpdateEmitter}</li>
	 * <li>{@link Device.KeyEmitter}</li>
	 * <li>{@link Device.LifecycleEmitter}</li>
	 * <li>{@link Device.LocationEmitter}</li>
	 * <li>{@link Device.MemoryEmitter}</li>
	 * <li>{@link Device.MotionEmitter}</li>
	 * <li>{@link Device.NetworkEmitter}</li>
	 * <li>{@link Device.OrientationEmitter}</li>
	 * <li>{@link Device.ShakeEmitter}</li>
	 * </div>
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this._messageListenersCount = 0;
		this._messageListenerRecords = [];
		this._messageDeferredWork = [];
		this._messageShouldDefer = false;
	},
	
	/**
	 * Unregister all <code>MessageListener</code> objects from this <code>MessageEmitter</code>.<br><br>
	 * <b>Note:</b> Do not use the emitter after calling this.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function($super)
	{
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._destroyActual.bind(this, $super));
		}
		else
		{
			this._destroyActual($super);
		}
	},
	
	_destroyActual: function(superDestroy)
	{
		// Unregister all listeners.
		var records = this._messageListenerRecords;
		while(records.length)
		{
			this.removeListener(records[0].l);
		}
		
		if(superDestroy)
			superDestroy();
	},
	
	/**
	 * Retrieve the number of <code>MessageListener</code> objects registered with this <code>MessageEmitter</code>.
	 * @returns {Number} The current number of <code>MessageListener</code> objects.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getListenerCount: function()
	{
		return this._messageListenersCount;
	},
	
	/**
	 * Add a <code>MessageListener</code> to this <code>MessageEmitter</code>. When an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.
	 * <br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter one time.<br><br>
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 *
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @throws {MessageEmitter.addListener: listener is already listening} Calling <code>addListener()</code> multiple times on the same emitter
	 * with the same listener.
	 * @throws {MessageEmitter.addListener: listener must be instances of MessageListener} Listener is not an instance of <code>MessageListener</code>.
	 * @see Core.MessageEmitter#removeListener,
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	addListener: function(listener, func, priority)
	{
		if(!listener instanceof MessageListener)
			throw new Error('MessageEmitter.addListener: listener must be instances of MessageListener');
			
		if(!listener._startListeningEmitter(this))
			throw new Error('MessageEmitter.addListener: listener is already listening');
			
		if(!priority)
		{
			priority = 0;
		}
		
		this._messageListenersCount++;	
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._addListenerActual.bind(this, listener, func, priority));
		}
		else
		{
			this._addListenerActual(listener, func, priority);
		}
	},
	
	_addListenerActual: function(listener, func, priority)
	{
		//  The priority for default value is <code>0</code>
		if ((typeof priority) == 'undefined') {
			priority = 0;
		}
		// TODO Replace with binary search.
		var records = this._messageListenerRecords;
		var len = records.length;
		for(var i=0; i < len; ++i)
		{
			if(records[i].p <= priority)
				break;
		}
		records.splice(i, 0, {l: listener, f: func, p: priority});
	},
	
	/**
	 * Remove a <code>MessageListener</code> from this <code>MessageEmitter</code>.<br><br> 
	 * The following code examples illustrate different call styles for <code>removeListener</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 *
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener was removed. Returns <code>false</code> if the registered listener is not found 
	 * or is not registered with this emitter.
	 * @throws {MessageEmitter.removeListener: listener is not listening} Specified listener is not currently registered
	 * with this <code>MessageEmitter</code>.
	 * @see Core.MessageEmitter#addListener
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	removeListener: function(listener)
	{
		if(!listener._stopListeningEmitter(this))
			//throw new Error('MessageEmitter.removeListner: listener is not listening');
			return false;
		
		this._messageListenersCount--;
		if(this._messageShouldDefer)
		{
			// TODO Replace with binary search.
			var records = this._messageListenerRecords;
			var len = records.length;
			for(var i=0; i < len; ++i)
			{
				var record = records[i];
				if(record.l == listener)
				{
					record.f = null;
					break;
				}
			}
			
			this._messageDeferredWork.push(this._removeListenerActual.bind(this, listener));
		}
		else
		{
			this._removeListenerActual(listener);
		}
		
		return true;
	},
	
	_removeListenerActual: function(listener)
	{
		// TODO Replace with binary search.
		var records = this._messageListenerRecords;
		var len = records.length;
		for(var i=0; i < len; ++i)
		{
			var record = records[i];
			if(record.l == listener)
			{
				records.splice(i, 1);
				break;
			}
		}
	},
	
	/**
	 * Send a message to every registered <code>MessageListener</code>. This emitter will trigger all listeners
	 * in descending order based on the listener priority. All listener callback functions are generated
	 * with parameters passed to <code>emit()</code>.
	 * @param {Parameters} parameters Parameters to pass in the generated callback funtion.
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	emit: function(params)
	{
		var handled = false;
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._emitActual.bind(this, arguments, false));
		}
		else
		{
			handled = this._emitActual(arguments, true);
		}
		return handled;
	},
	
	_emitActual: function(params, executeDeferred)
	{
		this._messageShouldDefer = true;
		
		var records = this._messageListenerRecords;
		var len = records.length;
		var handled = false;
		for(var i=0; i < len; ++i)
		{
			var record = records[i];
			if(!record.f) continue;
			
			if(record.f.apply(record.l, params))
				handled = true;
		}

		if(!handled)
		{
			//NgLogD("No listeners handling emitted key");
		}
		
		this._messageShouldDefer = false;
		
		if(this._messageDeferredWork.length && executeDeferred)
		{
			this._executeDeferred();
		}

		return handled;
	},
	
	/**
	 * Send a message to every registered <code>MessageListener</code> through a chain of command. 
	 * This emitter will trigger all listeners in descending order based on the listener priority.
	 * All listener callback functions are generated with parameters passed to <code>chain()</code>.	 
	 * <br><br>
	 * Unlike <code>emit()</code>, <code>chain()</code> allows a <code>MessageListener</code> to halt propagation of a message 
	 * to other listener objects by returning <code>true</code> for the callback function.
	 * This is useful for things like touch event handling. A <code>MessageListener</code> can respond to a touch event
	 * by returning <code>true</code>, masking the touch event from other listener objects.
	 *
	 * @param {Parameters} parameters Parameters to pass in the generated callback funtion.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener responded. Returns <code>false</code> in all other cases.
	 * <br><br>
	 * <b>Note:</b> If the application calls <code>chain()</code> recursively from
	 * within a message handler callback, it will always return <code>undefined</code>
	 * regardless of if a <code>MessageListener</code> responds or not.
	 * @see Core.MessageEmitter#emit
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	chain: function(params)
	{
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._chainActual.bind(this, arguments, false));
			return undefined;
		}
		else
		{
			return this._chainActual(arguments, true);
		}
	},
	
	_chainActual: function(params, executeDeferred)
	{
		var result = false;
		this._messageShouldDefer = true;
		
		var records = this._messageListenerRecords;
		var len = records.length;
		for(var i=0; i < len; ++i)
		{
			var record = records[i];
			if(!record.f) continue;
			
			if(record.f.apply(record.l, params))
			{
				result = true;
				break;
			}
		}
		
		this._messageShouldDefer = false;
		
		if(this._messageDeferredWork.length && executeDeferred)
		{
			this._executeDeferred();
		}
		
		return result;
	},
	
	_executeDeferred: function()
	{
		// NOTE: Don't factor out deferred.length. Deferred work can add more deferred work.
		var deferred = this._messageDeferredWork;
		for(var i=0; i < deferred.length; ++i)
		{
			deferred[i]();
		}
		this._messageDeferredWork = [];
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/MessageListener'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/MessageListener'] || {}; $MODULE_REGISTRY['NGCore/Shared/MessageListener'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.MessageListener = Class.subclass(
/** @lends Core.MessageListener.prototype */
{
	classname: 'MessageListener',
	
	/**
	 * @class The <code>MessageListener</code> class is a base class for constructing objects that listen for notifications from emitters 
	 * (see <code>{@link Core.MessageEmitter}</code>). Objects of this type are registered with emitters.
	 * When <code>{@link Core.MessageEmitter#emit}</code> or <code>{@link Core.MessageEmitter#chain}</code> is called on an emitter
	 * all registered listeners will generate a callback function.
	 * <br><br>
	 * Applications must unregister listener objects when they are no longer required in one of three ways: 
	 * <div class="ul"><font size="3">
	 * <li>Calling <code>{@link Core.MessageEmitter#removeListener}</code> on the <code>MessageEmitter</code>.</li>
	 * <li>Calling <code>{@link Core.MessageEmitter#destroy}</code> on the <code>MessageEmitter</code>.</li>
	 * <li>Calling <code>{@link Core.MessageListener#destroy}</code> on the <code>MessageListener</code></li>
	 * </font></div><br>
	 * <font size="3"><b>Note:</b> Applications should not attempt to register a listener with an emitter more than once. Registering a listener with an emitter
	 * multiple times results in exceptions. </font>
	 * @example
	 * var MyListener = Core.MessageListener.subclass(
	 * {
	 *     myCallback: function(verb, value)
	 *     {
	 *         console.log('MyListener.myCallback(' + verb + ', ' + value + ')');
	 *     },
	 * }
	 * var listener = new MyListener();
	 * emitter.addListener(listener, listener.myCallback);
	 * emitter.emit('fun', 5);
	 * @constructs The default constructor.
	 * @augments Core.Class
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._messageEmitters = [];
	},
	
	/**
	 * Unregister this <code>MessageListener</code> from all emitters.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		// Unregister from all emitters.
		var emitters = this._messageEmitters;
		while(emitters.length)
			emitters[0].removeListener(this);
	},
	
	// Called by MessageEmitter when this receiver starts listening.
	_startListeningEmitter: function(emitter)
	{
		var emitters = this._messageEmitters;
		var index = emitters.indexOf(emitter);
		if(index !== -1)
			return false;
		
		emitters.push(emitter);
		return true;
	},
	
	// Called by MessageEmitter when this receiver stops listening.
	_stopListeningEmitter: function(emitter)
	{
		var emitters = this._messageEmitters;
		var index = emitters.indexOf(emitter);
		if(index === -1)
			return false;
		
		emitters.splice(index, 1);
		return true;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/_int_LGL'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/_int_LGL'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/_int_LGL'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class _int_LGL
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var Base64 = require('NGCore/Client/Core/Base64').Base64;
var toMD5 = require('NGCore/Client/Core/toMD5').toMD5;

////////////////////////////////////////////////////////////////////////////////
function getCorrectedPlatformOS() {
	var os = Capabilities.getPlatformOS();
	switch (os) {
		case 'Android': return 'android';
		case 'iPhone OS': return 'ios';
	}
	return os;
};

function expandTexName(name)
{
	var list =
	{
		"pvr": "GL_IMG_texture_compression_pvrtc",
		"atc": "GL_AMD_compressed_ATC_texture",
		"etc1": "GL_OES_compressed_ETC1_RGB8_texture",
		"3dc": "GL_AMD_compressed_3DC_texture"
	};

	return list[name] || name;
};

var overridePropertyEvaluators = {
	isMatch: function(condition, value) {
		// Return true if the condition holds for the provided value
		// condition may be prefixed with an operator, so we extract it.
		var symbol;
		switch (condition.charAt(0)) {
		case '>':
			symbol = (condition.charAt(1) == '=') ? '>=' : '>';
			break;
		case '<':
			symbol = (condition.charAt(1) == '=') ? '<=' : '<';
			break;
		}
		// Consume any characters we detected, then set the default operation (equals)
		if (symbol) {
			condition = condition.slice(symbol.length);
		} else symbol = '=';

		if (condition == value) {
			return (symbol == '=' || symbol == '<=' || symbol == '>=');
		} else if (condition < value) {
			return (symbol == '<' || symbol == '<=');
		} else {
			return (symbol == '>' || symbol == '>=');
		}
	},

	isVersionMatch: function(condition, value) {
		// Return true if the condition holds for the provided value
		// condition may be prefixed with an operator, so we extract it.
		var symbol;
		if (condition.length > 0) switch (condition.charAt(0)) {
		case '>':
			symbol = (condition.charAt(1) == '=') ? '>=' : '>';
			break;
		case '<':
			symbol = (condition.charAt(1) == '=') ? '<=' : '<';
			break;
		case '=':
			symbol = (condition.charAt(1) == '=') ? '==' : '=';
			break;
		}
		// Consume any characters we detected, or set the default operation (equals)
		if (symbol) {
			condition = condition.slice(symbol.length);
		} else symbol = '=';

		var condition = condition.split('.');
		var value = value.split('.');

		var l = Math.max(condition.length, value.length);

		for (var i = 0; i < l; i++) {
			var ci = '0.' + (condition[i] || 0);
			var vi = '0.' + (value[i] || 0);
			if (ci == vi) continue;
			if (ci < vi) {
				return (symbol == '<' || symbol == '<=');
			} else {
				return (symbol == '>' || symbol == '>=');
			}
		}
		return true;
	},

	'sdkVersion': function(v) {
		return this.isVersionMatch('' + v, Capabilities.getSDKVersion());
	},

	'binaryVersion': function(v) {
		return this.isVersionMatch('' + v, Capabilities.getBinaryVersion());
	},

	'platformOS': function(v) {
		return v == getCorrectedPlatformOS();
	},

	'platformOSVersion': function(v) {
		return this.isVersionMatch('' + v, Capabilities.getPlatformOSVersion());
	},

	'platformHW': function(v) {
		return v == Capabilities.getPlatformHW();
	},

	'physicalMem': function(v) {
		return this.isMatch(v, Capabilities.getPhysicalMem());
	},

	'physicalCpus': function(v) {
		return this.isMatch(v, Capabilities.getPhysicalCpus());
	},

	'activeCpus': function(v) {
		return this.isMatch(v, Capabilities.getActiveCpus());
	},

	'language': function(v) {
		return v == Capabilities.getLanguage();
	},

	'textureMatch': "none",
	'textureCompression': function(v) {
		var matched = Capabilities.getOglExtensions().indexOf(expandTexName(v)) > -1;
		if (matched) this.textureMatch = v;
		return matched;
	},

	'screenWidth': function(v) {
		return this.isMatch(v, Capabilities.getScreenWidth());
	},

	'screenHeight': function(v) {
		return this.isMatch(v, Capabilities.getScreenHeight());
	},

	'screenResolution': function(v) {
		return v == (Capabilities.getScreenWidth() + 'x' + Capabilities.getScreenHeight());
	},

	'screenUnits': function(v) {
		return this.isMatch(v, Capabilities.getScreenUnits());
	},

	'screenPixelUnits': function(v) {
		return this.isMatch(v, Capabilities.getScreenPixelUnits());
	},

	'maxTextureSize': function(v) {
		return this.isMatch(v, Capabilities.getMaxTextureSize());
	},
	
	'reset': function(v) {
		this.textureMatch = "none";
	}
};

var _int_LGL = Class.singleton(
/** @lends Core._int_LGL.prototype */
{
	classname: '_int_LGL',

	launch: function(url, proc)
	{
		var Util = require('NGCore/Client/Network/Util').Util;
		// Default to game proc. Games should actually not be aware of the third option,
		//	as they cannot use it anyway.
		if (!proc)
			proc = _int_LGL.ProcID.Game;

		url = Util.NormalizeUrl(url);

//		console.log("launching game url " + url);

		var run = (function()
		{
			gNgShutdownPending = true;
			this._launchSendGen(url,proc);
		}).bind(this);

		if (proc == _int_LGL.ProcID.Game)
		{
			this.updateGameUse(url, run);
		}
		else
		{
			run();
		}
	},

	updateAvailable: function(game, doneCB, errorCB)
	{
		// Normalize URL
		var url = game;
		if (! url.match(/^\//) && !url.match(/https?:\/\//))
			url = '/' + url;

		var caps = require('NGCore/Client/Core/Capabilities').Capabilities;

		// If we are testing ourselves, we don't to md5 our url
		var name = "";
		if (caps.getUrl() != game)
		{
			var Util = require('NGCore/Client/Network/Util').Util;
			url = Util.NormalizeUrl(url);
			name = toMD5(url);
		}

		// Get device-specific manifest directory
		var buildPath = {"Android" : "android", "iPhone OS" : "ios", "flash" : ""};
		// Get Device capabilities platformOs
		var build = "/" + buildPath[caps.getPlatformOS()];

		var DownloadManifest = require('NGCore/Client/Network/DownloadManifest').DownloadManifest;
		var dm = new DownloadManifest();

		dm.isUpdated(url + build, name, false, doneCB, errorCB);
	},

// Utility (non-generated) functionality
	updateGameUse: function(game, doneCB)
	{
		var name = toMD5(game);
		var self = this;
		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		this.mGameStore = KeyValueCache.global("Core.GameList");
		this.mActiveGameKey = "activeGames";

		// Get our list of games
		this.mGameStore.getItem(this.mActiveGameKey,
			function(error, value)
			{
				var list;
				if (value)
					list = JSON.parse(value);
				else
					list = [];

				var item;
				for (var i in list)
				{
					if (list[i].name == name)
					{
						item = list[i];
						break;
					}
				}

				if (!item)
				{
					item = {"name": name};
					list.push(item);
				}

				item.lastRun = (new Date()).getTime();
				item.url = game;

 				self.mGameStore.setItem(self.mActiveGameKey, JSON.stringify(list));

                LocalGameList.updateGameList(list);
 				doneCB();
			}, true
		);
	},
	
	getManifestName: function(config) {
		var manifestName = 'webgame.ngmanifest';

		if (config && config.manifestOverrides) {
			try {
				var overrides = config.manifestOverrides;

				for (var i = 0; i < overrides.length; i++) {
					var override = overrides[i];
					if (override && override.criteria) {
						// Clear any matched values...
						overridePropertyEvaluators.reset();

						var criteria = override.criteria;
						var overrideMatched = true;
						for (var key in criteria) {
							if (!criteria.hasOwnProperty(key)) continue;
							var value = criteria[key];

							var evaluator = overridePropertyEvaluators[key];
							if (typeof evaluator != 'function') {
								console.log("ERROR! Undefined criterion " + key + " in configuration.json");
								overrideMatched = false;
								break;
							}

							var criterionMatched = false;
							if (value instanceof Array) {
								for (vi = 0; vi < value.length; vi++) {
									criterionMatched |= evaluator.call(overridePropertyEvaluators, value[vi]);
									if (criterionMatched) break;
								}
							} else {
								criterionMatched = evaluator(value);
							}

							if (!criterionMatched) {
								overrideMatched = false;
								break;
							}
						}

						// At this point, the override has matched. Figure out its name and return the value.
						if (overrideMatched) {
							console.log("MATCHED Override: " + JSON.stringify(override));

							// Format the override manifest name:
							var format = override.manifest.slice(0);
							for (var fi = 1; fi < format.length; fi++) {
								var key = format[fi];
								switch (key) {
								case 'textureCompression':
									format[fi] = overridePropertyEvaluators.textureMatch;
									break;
								case 'platformOS':
									format[fi] = getCorrectedPlatformOS();
									break;
								default:
									// Look up the named property on Capabilities.
									var cap = Capabilities['get' + key.charAt(0).toUpperCase() + key.slice(1)]();
									format[fi] = cap.replace(' ', '_');
								}
							}

							return require('NGCore/Shared/Lib/sprintf').sprintf(format);
						} else {
							console.log("DID NOT MATCH Override: " + JSON.stringify(override));
						}
					}
				}
			} catch (e) {
				console.log("ERROR! Exception occurred in manifest overrides: " + e);
			}
		}

		return manifestName;
	},

// {{?Wg Generated Code}}
	
	// Enums.
	ProcID:
	{ 
		/** High privilege proc */
		Persist: -1,
		/** Low priv */
		Game: -2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 342
	// Method launch = -1
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in _int_LGL._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in _int_LGL._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[342] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_launchSendGen: function( url, proc )
	{
		Proc.appendToCommandString( ":342,-1," + Base64.encode( url ) + "," + proc  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $launch: function( url, proc ) {}
	

// {{/Wg Generated Code}}

});

exports._int_LGL = _int_LGL;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/md5'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/md5'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/md5'] = exports; /*
 * A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
 * Digest Algorithm, as defined in RFC 1321.
 * Version 2.2 Copyright (C) Paul Johnston 1999 - 2009
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for more info.
 */

/*
 * Calculate the MD5 of a raw string
 */
function rstr_md5(s)
{
  return binl2rstr(binl_md5(rstr2binl(s), s.length * 8));
}

/*
 * Convert a raw string to a hex string
 */
function rstr2hex(input)
{
  var hex_tab = "0123456789abcdef";
  var output = "";
  var x;
  for(var i = 0; i < input.length; i++)
  {
    x = input.charCodeAt(i);
    output += hex_tab.charAt((x >>> 4) & 0x0F)
           +  hex_tab.charAt( x        & 0x0F);
  }
  return output;
}

/*
 * Encode a string as utf-8.
 * For efficiency, this assumes the input is valid utf-16.
 */
function str2rstr_utf8(input)
{
  var output = "";
  var i = -1;
  var x, y;

  while(++i < input.length)
  {
    /* Decode utf-16 surrogate pairs */
    x = input.charCodeAt(i);
    y = i + 1 < input.length ? input.charCodeAt(i + 1) : 0;
    if(0xD800 <= x && x <= 0xDBFF && 0xDC00 <= y && y <= 0xDFFF)
    {
      x = 0x10000 + ((x & 0x03FF) << 10) + (y & 0x03FF);
      i++;
    }

    /* Encode output as utf-8 */
    if(x <= 0x7F)
      output += String.fromCharCode(x);
    else if(x <= 0x7FF)
      output += String.fromCharCode(0xC0 | ((x >>> 6 ) & 0x1F),
                                    0x80 | ( x         & 0x3F));
    else if(x <= 0xFFFF)
      output += String.fromCharCode(0xE0 | ((x >>> 12) & 0x0F),
                                    0x80 | ((x >>> 6 ) & 0x3F),
                                    0x80 | ( x         & 0x3F));
    else if(x <= 0x1FFFFF)
      output += String.fromCharCode(0xF0 | ((x >>> 18) & 0x07),
                                    0x80 | ((x >>> 12) & 0x3F),
                                    0x80 | ((x >>> 6 ) & 0x3F),
                                    0x80 | ( x         & 0x3F));
  }
  return output;
}

/*
 * Convert a raw string to an array of little-endian words
 * Characters >255 have their high-byte silently ignored.
 */
function rstr2binl(input)
{
  var output = Array(input.length >> 2);
  for(var i = 0; i < output.length; i++)
    output[i] = 0;
  for(var i = 0; i < input.length * 8; i += 8)
    output[i>>5] |= (input.charCodeAt(i / 8) & 0xFF) << (i%32);
  return output;
}

/*
 * Convert an array of little-endian words to a string
 */
function binl2rstr(input)
{
  var output = "";
  for(var i = 0; i < input.length * 32; i += 8)
    output += String.fromCharCode((input[i>>5] >>> (i % 32)) & 0xFF);
  return output;
}

/*
 * Calculate the MD5 of an array of little-endian words, and a bit length.
 */
function binl_md5(x, len)
{
  /* append padding */
  x[len >> 5] |= 0x80 << ((len) % 32);
  x[(((len + 64) >>> 9) << 4) + 14] = len;

  var a =  1732584193;
  var b = -271733879;
  var c = -1732584194;
  var d =  271733878;

  for(var i = 0; i < x.length; i += 16)
  {
    var olda = a;
    var oldb = b;
    var oldc = c;
    var oldd = d;

    a = md5_ff(a, b, c, d, x[i+ 0], 7 , -680876936);
    d = md5_ff(d, a, b, c, x[i+ 1], 12, -389564586);
    c = md5_ff(c, d, a, b, x[i+ 2], 17,  606105819);
    b = md5_ff(b, c, d, a, x[i+ 3], 22, -1044525330);
    a = md5_ff(a, b, c, d, x[i+ 4], 7 , -176418897);
    d = md5_ff(d, a, b, c, x[i+ 5], 12,  1200080426);
    c = md5_ff(c, d, a, b, x[i+ 6], 17, -1473231341);
    b = md5_ff(b, c, d, a, x[i+ 7], 22, -45705983);
    a = md5_ff(a, b, c, d, x[i+ 8], 7 ,  1770035416);
    d = md5_ff(d, a, b, c, x[i+ 9], 12, -1958414417);
    c = md5_ff(c, d, a, b, x[i+10], 17, -42063);
    b = md5_ff(b, c, d, a, x[i+11], 22, -1990404162);
    a = md5_ff(a, b, c, d, x[i+12], 7 ,  1804603682);
    d = md5_ff(d, a, b, c, x[i+13], 12, -40341101);
    c = md5_ff(c, d, a, b, x[i+14], 17, -1502002290);
    b = md5_ff(b, c, d, a, x[i+15], 22,  1236535329);

    a = md5_gg(a, b, c, d, x[i+ 1], 5 , -165796510);
    d = md5_gg(d, a, b, c, x[i+ 6], 9 , -1069501632);
    c = md5_gg(c, d, a, b, x[i+11], 14,  643717713);
    b = md5_gg(b, c, d, a, x[i+ 0], 20, -373897302);
    a = md5_gg(a, b, c, d, x[i+ 5], 5 , -701558691);
    d = md5_gg(d, a, b, c, x[i+10], 9 ,  38016083);
    c = md5_gg(c, d, a, b, x[i+15], 14, -660478335);
    b = md5_gg(b, c, d, a, x[i+ 4], 20, -405537848);
    a = md5_gg(a, b, c, d, x[i+ 9], 5 ,  568446438);
    d = md5_gg(d, a, b, c, x[i+14], 9 , -1019803690);
    c = md5_gg(c, d, a, b, x[i+ 3], 14, -187363961);
    b = md5_gg(b, c, d, a, x[i+ 8], 20,  1163531501);
    a = md5_gg(a, b, c, d, x[i+13], 5 , -1444681467);
    d = md5_gg(d, a, b, c, x[i+ 2], 9 , -51403784);
    c = md5_gg(c, d, a, b, x[i+ 7], 14,  1735328473);
    b = md5_gg(b, c, d, a, x[i+12], 20, -1926607734);

    a = md5_hh(a, b, c, d, x[i+ 5], 4 , -378558);
    d = md5_hh(d, a, b, c, x[i+ 8], 11, -2022574463);
    c = md5_hh(c, d, a, b, x[i+11], 16,  1839030562);
    b = md5_hh(b, c, d, a, x[i+14], 23, -35309556);
    a = md5_hh(a, b, c, d, x[i+ 1], 4 , -1530992060);
    d = md5_hh(d, a, b, c, x[i+ 4], 11,  1272893353);
    c = md5_hh(c, d, a, b, x[i+ 7], 16, -155497632);
    b = md5_hh(b, c, d, a, x[i+10], 23, -1094730640);
    a = md5_hh(a, b, c, d, x[i+13], 4 ,  681279174);
    d = md5_hh(d, a, b, c, x[i+ 0], 11, -358537222);
    c = md5_hh(c, d, a, b, x[i+ 3], 16, -722521979);
    b = md5_hh(b, c, d, a, x[i+ 6], 23,  76029189);
    a = md5_hh(a, b, c, d, x[i+ 9], 4 , -640364487);
    d = md5_hh(d, a, b, c, x[i+12], 11, -421815835);
    c = md5_hh(c, d, a, b, x[i+15], 16,  530742520);
    b = md5_hh(b, c, d, a, x[i+ 2], 23, -995338651);

    a = md5_ii(a, b, c, d, x[i+ 0], 6 , -198630844);
    d = md5_ii(d, a, b, c, x[i+ 7], 10,  1126891415);
    c = md5_ii(c, d, a, b, x[i+14], 15, -1416354905);
    b = md5_ii(b, c, d, a, x[i+ 5], 21, -57434055);
    a = md5_ii(a, b, c, d, x[i+12], 6 ,  1700485571);
    d = md5_ii(d, a, b, c, x[i+ 3], 10, -1894986606);
    c = md5_ii(c, d, a, b, x[i+10], 15, -1051523);
    b = md5_ii(b, c, d, a, x[i+ 1], 21, -2054922799);
    a = md5_ii(a, b, c, d, x[i+ 8], 6 ,  1873313359);
    d = md5_ii(d, a, b, c, x[i+15], 10, -30611744);
    c = md5_ii(c, d, a, b, x[i+ 6], 15, -1560198380);
    b = md5_ii(b, c, d, a, x[i+13], 21,  1309151649);
    a = md5_ii(a, b, c, d, x[i+ 4], 6 , -145523070);
    d = md5_ii(d, a, b, c, x[i+11], 10, -1120210379);
    c = md5_ii(c, d, a, b, x[i+ 2], 15,  718787259);
    b = md5_ii(b, c, d, a, x[i+ 9], 21, -343485551);

    a = safe_add(a, olda);
    b = safe_add(b, oldb);
    c = safe_add(c, oldc);
    d = safe_add(d, oldd);
  }
  return Array(a, b, c, d);
}

/*
 * These functions implement the four basic operations the algorithm uses.
 */
function md5_cmn(q, a, b, x, s, t)
{
  return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s),b);
}
function md5_ff(a, b, c, d, x, s, t)
{
  return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
}
function md5_gg(a, b, c, d, x, s, t)
{
  return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
}
function md5_hh(a, b, c, d, x, s, t)
{
  return md5_cmn(b ^ c ^ d, a, b, x, s, t);
}
function md5_ii(a, b, c, d, x, s, t)
{
  return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
}

/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */
function safe_add(x, y)
{
  var lsw = (x & 0xFFFF) + (y & 0xFFFF);
  var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
  return (msw << 16) | (lsw & 0xFFFF);
}

/*
 * Bitwise rotate a 32-bit number to the left.
 */
function bit_rol(num, cnt)
{
  return (num << cnt) | (num >>> (32 - cnt));
}

var toMD5 = function(s) { return rstr2hex(rstr_md5(str2rstr_utf8(s))); }

/*
 * Perform a simple self-test to see if the VM is working
 */
function md5_vm_test()
{
  return toMD5("abc").toLowerCase() == "900150983cd24fb0d6963f7d28e17f72";
}

exports.toMD5 = toMD5;
exports.testMD5 = md5_vm_test;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Storage/KeyValue'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Storage/KeyValue'] || {}; $MODULE_REGISTRY['NGCore/Client/Storage/KeyValue'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class KeyValue
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

function KeyValueCache() {
};
exports.KeyValueCache = KeyValueCache;
/** @private */
KeyValueCache.lruMeanCacheSize = 100;
/** @private */
KeyValueCache.instanceMap = {};
//TODO: rename this later
var StorageGlobalScopes = [];

KeyValueCache.optimizeCaches = function() 
{
	for (var storeKey in KeyValueCache.instanceMap) {
		if(KeyValueCache.instanceMap.hasOwnProperty(storeKey)) {
			KeyValueCache.instanceMap[storeKey].optimize();
		}
	}
};

KeyValueCache.lowMemoryWarning = function() 
{
	for (var storeKey in KeyValueCache.instanceMap) {
		if(KeyValueCache.instanceMap.hasOwnProperty(storeKey)) {
			var instance = KeyValueCache.instanceMap[storeKey];
			instance.data = {};

			//Purge entries in callbacks
			var newCallbacks = {};
			newCallbacks.uidGenerator = instance.callbacks.uidGenerator;
			for(var cbId in instance.callbacks)
			{
				if(instance.callbacks.hasOwnProperty(cbId)) {
					if(instance.callbacks[cbId]) {
						newCallbacks = instance.callbacks[cbId];
					}
				}
			}
			instance.callbacks = newCallbacks;
		}
	}
};

KeyValueCache.init = function()
{
	KeyValueCache.local = new Storage.KeyValue();
	KeyValueCache.local.registerForKey("local");
};

/**
 * @static Scopes this <code>KeyValueCache</code> object as global. A globally scoped KeyValueCache object can be used by multiple applications for the same data. 
 * @param {String} globalKey The store key for the <code>KeyValueCache</code> object.
 */
KeyValueCache.global = function(globalKey)
{
	if(StorageGlobalScopes[globalKey])
	{
		return StorageGlobalScopes[globalKey];
	}

	//Miss Global Table Cache.
	var scope = new Storage.KeyValue();
	scope.registerForKey(globalKey);
	StorageGlobalScopes[globalKey] = scope;
	return scope;
};

exports.KeyValue = Core.Class.subclass(
/** @lends Storage.KeyValue.prototype */
{
	classname: "KeyValue",
	/**
	 * @class The <code>KeyValue</code> class constructs objects that allow you to manage application key/value pairs in a datastore.
	 * <div class="ul">
	 * <li>Call <code>KeyValueCache.local()</code> to access the <code>local</code> datastore for your application.</li>
	 * <li>Call <code>KeyValueCache.global(globalKey)</code> to access a globally scoped datastore. Multiple applications can use a globally scoped
	 * datastore for the same data. The <code>globalKey</code> parameter is a string that uniquely identifies the datastore.</li>
	 * </div>
	 *
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		/** @private */
		this.initialized = false;
		/** @private */
		this.origin = null;
		/** @private */
		this.callbacks = {};
		/** @private */
		this.callbacks.uidGenerator = 0;
		/** @private */
		this.local = false;
		/** @private */
		this.lruCacheShrinkCounter = 0;
	
		/** @private */
		this.data = {};
		/** @private */
		this.usage = {};
		
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
    /*
	 * @private
	 * Call <code>registerForKey()</code> to access a datastore identified by the value of the <code>storeKey</code> parameter.
	 * @param {String} storeKey The unique identifier of the datastore.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	registerForKey: function(storeKey) 
	{
		this.origin = storeKey;
		KeyValueCache.instanceMap[storeKey] = this;

		//Push this instance across the native bridge
		this._registerCommandSendGen(this.origin,KeyValueCache.lruMeanCacheSize);
		
		return this;
	},
	/**
	 * Pass the value associated with the key to the callback function.
	 * @param {String} key The key that is associated with the value to pass to the callback function.
	 * @param {Function} callbackFunc The callback function that uses the value associated with the key.
	 * @param {Boolean} [ignoreCache=false] Set <code>ignoreCache</code> to <code>true</code> to force a read from storage.
	 * @example KeyValue.getItem(SomeKey, function(err){...})
     * @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	getItem: function(key,callbackFunc,ignoreCache /*defaults to false*/)
	{
		if(!ignoreCache)
		{
			if(this.data[key]) {
				callbackFunc(null,this.data[key],key);
				this.usage[key]++;
				return;
			}
			else
			{
				NgLogD("Value not found in cache for..falling back to native");
			}
		}

		//Generate unused callbackEntry
		var callbackId = this.callbacks.uidGenerator++;

		if(!!!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._getItemSendGen(this.origin,callbackId,key);
	},
	
	/**
	 * Associate a value with a key.
	 * @param {String} key The key to associate with the value.
	 * @param {String} value The value to associate with the key.
	 * @param {Function} [callbackFunc] A callback function with an error parameter. The error parameter is null when the <code>setItem()</code> function completes successfully.
	 * @example KeyValue.setItem(someKey, someValue, function(err){...})
     * @status iOS, Android, Test, iOSTested, AndroidTested          
	 */
	setItem: function(key,value,callbackFunc)
	{
		var value = value;
		this.data[key] = value;

		var callbackId = this.callbacks.uidGenerator++;
		if(!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._setItemSendGen(this.origin,callbackId,key,value);
	},
	
	/**
	 * Remove the value that is associated with a key.
	 * @param {String} key The key that is associated with the value to remove.
	 * @param {Function} [callbackFunc] A callback function with an error parameter. The error parameter is null when the <code>removeItem()</code> function completes successfully.
	 * @example KeyValue.removeItem(someKey, function(err){...})
     * @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	removeItem: function(key,callbackFunc)
	{
		var callbackId = this.callbacks.uidGenerator++;
		if(!!!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._removeItemSendGen(this.origin,callbackId,key);
	},

	/**
	 *  @private
	 * 	clear all key/value pairs stored within this store
	 *  @param {callbackFunc} The callback function to be called
     *  @status iOS, Android, Test, iOSTested, AndroidTested          
	 */
	clear: function(callbackFunc)
	{
		var callbackId = this.callbacks.uidGenerator++;
		if(!!!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._clearSendGen(this.origin,callbackId);
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	enforceLRUCacheSize: function()
	{
		NgLogD("Enforcing KeyValue Cache Size");
		var tmp = [];
		for (var k in this.data) {
			if (this.data.hasOwnProperty(k)) {
				tmp.push(k);
			}
		}
		var usage = this.usage;
		tmp.sort(function(a,b) {
			var p1 = usage[a];
			if (!p1) {
				p1 = 0;
			}

			var p2 = usage[b];
			if (!p2) {
				p2 = 0;
			}

			if (p1 == p2) { return 0; }
			return p1 < p2 ? 1 : -1;
		});

		var oldData = this.data;
		this.data = {};
		//Copy over the lruMeanCache(number) most used entries
		var stopPoint = KeyValueCache.lruMeanCacheSize;
		for (var i = 0; i < stopPoint && i < tmp.length; i++)
		{
			if(!oldData[tmp[i]]) {
				//Case cache didn't contain that key at this point in time
				stopPoint++;
			}
			else {
				this.data[tmp[i]] = oldData[tmp[i]];
			}
		}
	},
	
	_getInstanceRecv : function(cmd)
	{
		var msg = {};
		if(!this._getInstanceRecvGen(cmd, msg))
			return;
			
		var storeKey = msg["storeKey"];

		var instance = KeyValueCache.instanceMap[storeKey];
		//NgLogD("Storage.getInstanceForCommand Found instance for key [" + storeKey + "]: " + instance + " (" + command + ")");
		return instance;
	},
	
	_registerCommandCbRecv : function(cmd)
	{		
		var msg = {};
		if(!this._registerCommandCbRecvGen(cmd, msg))
			return;
		
		//NgLogD("Storage registerCallback: "+command+"\n");
		if(msg["error"]){
			console.log("Storage: Error registering for KeyValue location '"+msg["error"]+"'");
			if(!this.initialized) {
				delete StorageGlobalScopes[msg["originalStoreKey"]];
			}
			return;
		}

		if(this.origin == "local") {
			this.local = true;
			StorageGlobalScopes[this.origin] = this;
		}

		this.origin = msg["storeKey"];
		this.initialized = true;
		
		for(var i=0; i < msg.preloadDataCount; ++i)
		{
			var preload = {};
			if(!this._preloadDataRecvGen(cmd, preload))
				return;
			
			this.data[preload.key] = preload.value;
		}
	},
	
	_getItemCommandCbRecv : function(cmd)
	{
		var msg = {};
		if(!this._getItemCommandCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];
		var key = msg["key"];
		var value = msg["value"];
		if (error) {
			value = null;
		}

		this.data[key] = value;
		if(!this.usage[key]) {
			this.usage[key] = 1;
		} else {
			this.usage[key]++;
		}

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			cb(error,value,key);
			this.callbacks[cbId] = null;
		}

		if(((this.lruCacheShrinkCounter++) % KeyValueCache.lruMeanCacheSize) === 0) {
			this.enforceLRUCacheSize();
		}
		return this;
	},
	
	_setItemCommandCbRecv : function(cmd)
	{
		var msg = {};
		if(!this._setItemCommandCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];
		var key = msg["key"];

		if(!this.usage[key]) {
			this.usage[key] = 1;
		} else {
			this.usage[key]++;
		}
		
		//NgLogD("Storage.setItemCommand Found instance for key [" + key + "]: " + " (" + cbId + ")");

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			//NgLogD("Storage.setItemCommand Found callback");
			cb(error,key);
			this.callbacks[cbId] = null;
		}
		if(((this.lruCacheShrinkCounter++) % KeyValueCache.lruMeanCacheSize) === 0) {
			this.enforceLRUCacheSize();
		}
	},
	
	_removeItemCbRecv : function(cmd)
	{
		var msg = {};
		if(!this._removeItemCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];
		var key = msg["key"];
		delete this.usage[key];
		delete this.data[key];

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			cb(error,key);
			this.callbacks[cbId] = null;
		}
	},
	
	_clearCommandCbRecv : function(cmd)
	{
		var msg ={};
		if(!this._clearCommandCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];

		this.data = {};
		this.usage = {};

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			cb(error,this.origin);
			this.callbacks[cbId] = null;
		}

	},

	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for response types.
	 * @namespace
	 */
	Responses:
	{ 
		/** Register Storage */
		Register: 0,
		/** Get Item */
		GetItem: 1,
		/** Set Item */
		SetItem: 2,
		/** Remove Item */
		RemoveItem: 3,
		/** Clear All */
		Clear: 4,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 339
	// Method create = -1
	// Method destroy = 2
	// Method registerCommand = 3
	// Method getItem = 4
	// Method setItem = 5
	// Method removeItem = 6
	// Method clear = 7
	// Method getInstance = 8
	// Method registerCommandCb = 9
	// Method preloadData = 10
	// Method getItemCommandCb = 11
	// Method setItemCommandCb = 12
	// Method removeItemCb = 13
	// Method clearCommandCb = 14
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 8:
					instance._getInstanceRecv( cmd );
					break;
				case 9:
					instance._registerCommandCbRecv( cmd );
					break;
				case 10:
					instance._preloadDataRecv( cmd );
					break;
				case 11:
					instance._getItemCommandCbRecv( cmd );
					break;
				case 12:
					instance._setItemCommandCbRecv( cmd );
					break;
				case 13:
					instance._removeItemCbRecv( cmd );
					break;
				case 14:
					instance._clearCommandCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in KeyValue._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in KeyValue._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[339] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_getInstanceRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_registerCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 5 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "originalStoreKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "originalStoreKey" ] === undefined )
		{
			NgLogE("Could not parse originalStoreKey in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "preloadDataCount" ] = Core.Proc.parseInt( cmd[ 4 ] );
		if( obj[ "preloadDataCount" ] === undefined )
		{
			NgLogE("Could not parse preloadDataCount in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 5);
		return true;
	},
	
	/** @private */
	_preloadDataRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 2 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.preloadData from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.preloadData from command: " + cmd );
			return false;
		}
		
		obj[ "value" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "value" ] === undefined )
		{
			NgLogE("Could not parse value in KeyValue.preloadData from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 2);
		return true;
	},
	
	/** @private */
	_getItemCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 6 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 4 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "value" ] = Core.Proc.parseString( cmd[ 5 ] );
		if( obj[ "value" ] === undefined )
		{
			NgLogE("Could not parse value in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_setItemCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 6 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 4 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "value" ] = Core.Proc.parseString( cmd[ 5 ] );
		if( obj[ "value" ] === undefined )
		{
			NgLogE("Could not parse value in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_removeItemCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 5 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 4 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_clearCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 4 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":339,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":339,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_registerCommandSendGen: function( storeKey, lruMeanCacheSize )
	{
		Core.Proc.appendToCommandString( ":339,3," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + lruMeanCacheSize  );
	},
	
	/** @private */
	_getItemSendGen: function( storeKey, callbackId, key )
	{
		Core.Proc.appendToCommandString( ":339,4," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + callbackId + "," + Core.Base64.encode( key )  );
	},
	
	/** @private */
	_setItemSendGen: function( storeKey, callbackId, key, value )
	{
		Core.Proc.appendToCommandString( ":339,5," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + callbackId + "," + Core.Base64.encode( key ) + "," + Core.Base64.encode( value )  );
	},
	
	/** @private */
	_removeItemSendGen: function( storeKey, callbackId, key )
	{
		Core.Proc.appendToCommandString( ":339,6," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + callbackId + "," + Core.Base64.encode( key )  );
	},
	
	/** @private */
	_clearSendGen: function( storeKey, callbackId )
	{
		Core.Proc.appendToCommandString( ":339,7," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + callbackId  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// registerCommand: function( storeKey, lruMeanCacheSize ) {}
	
	// getItem: function( storeKey, callbackId, key ) {}
	
	// setItem: function( storeKey, callbackId, key, value ) {}
	
	// removeItem: function( storeKey, callbackId, key ) {}
	
	// clear: function( storeKey, callbackId ) {}
	
	// _getInstanceRecv: function( cmd ) {}
	// _registerCommandCbRecv: function( cmd ) {}
	// _preloadDataRecv: function( cmd ) {}
	// _getItemCommandCbRecv: function( cmd ) {}
	// _setItemCommandCbRecv: function( cmd ) {}
	// _removeItemCbRecv: function( cmd ) {}
	// _clearCommandCbRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/sprintf'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/sprintf'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/sprintf'] = exports; /**
sprintf() for JavaScript 0.6

Copyright (c) Alexandru Marasteanu <alexaholic [at) gmail (dot] com>
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of sprintf() for JavaScript nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL Alexandru Marasteanu BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


Changelog:
2007.04.03 - 0.1:
 - initial release
2007.09.11 - 0.2:
 - feature: added argument swapping
2007.09.17 - 0.3:
 - bug fix: no longer throws exception on empty paramenters (Hans Pufal)
2007.10.21 - 0.4:
 - unit test and patch (David Baird)
2010.05.09 - 0.5:
 - bug fix: 0 is now preceeded with a + sign
 - bug fix: the sign was not at the right position on padded results (Kamal Abdali)
 - switched from GPL to BSD license
2010.05.22 - 0.6:
 - reverted to 0.4 and fixed the bug regarding the sign of the number 0
 Note:
 Thanks to Raphael Pigulla <raph (at] n3rd [dot) org> (http://www.n3rd.org/)
 who warned me about a bug in 0.5, I discovered that the last update was
 a regress. I appologize for that.
**/



exports.sprintf = function() {
	str_repeat = function(i, m) {
		for (var o = []; m > 0; o[--m] = i);
		return o.join('');
	};

	var params = new Array();
	var outputArray = false;
	var paramsConsumed = 1;
	if (typeof(arguments[0]) == 'object' && arguments[0].length) {
		outputArray = true;
		for (var i = 0; i < arguments[0].length; ++i) {
			params[i] = arguments[0][i];
		}
	} else {
		for (var i = 0; i < arguments.length; ++i) {
			params[i] = arguments[i];
		}
	}

	var i = 0, a, f = params[i++], o = [], m, p, c, x, s = '';
	while (f) {
		if (m = /^[^\x25]+/.exec(f)) {
			o.push(m[0]);
		}
		else if (m = /^\x25{2}/.exec(f)) {
			o.push('%');
		}
		else if (m = /^\x25(?:(\d+)\$)?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-fosuxX])/.exec(f)) {
			if (((a = params[m[1] || i++]) == null) || (a == undefined)) {
				throw('Too few arguments.');
			}
			if (/[^s]/.test(m[7]) && (typeof(a) != 'number')) {
				throw('Expecting number but found ' + typeof(a));
			}
			switch (m[7]) {
				case 'b': a = a.toString(2); break;
				case 'c': a = String.fromCharCode(a); break;
				case 'd': a = parseInt(a); break;
				case 'e': a = m[6] ? a.toExponential(m[6]) : a.toExponential(); break;
				case 'f': a = m[6] ? parseFloat(a).toFixed(m[6]) : parseFloat(a); break;
				case 'o': a = a.toString(8); break;
				case 's': a = ((a = String(a)) && m[6] ? a.substring(0, m[6]) : a); break;
				case 'u': a = Math.abs(a); break;
				case 'x': a = a.toString(16); break;
				case 'X': a = a.toString(16).toUpperCase(); break;
			}
			a = (/[def]/.test(m[7]) && m[2] && a >= 0 ? '+'+ a : a);
			c = m[3] ? m[3] == '0' ? '0' : m[3].charAt(1) : ' ';
			x = m[5] - String(a).length - s.length;
			p = m[5] ? str_repeat(c, x) : '';
			o.push(s + (m[4] ? a + p : p + a));
			if (outputArray) ++paramsConsumed;
		}
		else {
			throw('Huh ?!');
		}
		f = f.substring(m[0].length);
	}
	if (outputArray && paramsConsumed > 0) {
		arguments[0].splice(0, paramsConsumed);
	}
	return o.join('');
};

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/LocationEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/LocationEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/LocationEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class LocationEmitter
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.LocationEmitter = Core.MessageEmitter.singleton(
/** @lends Device.LocationEmitter.prototype */
{
	classname: 'LocationEmitter',

	Accuracy:
	{
		LOW:    0, // less power consumption. equivalent to "3km"  in iOS
		MEDIUM: 1, // equivalent to "100m" in iOS
		HIGH:   2  // most accurate, high power consumption. equivalent to "Best" in iOS
	},

	Elements:
	{
		LATITUDE:  1,
		LONGITUDE: 2,
		ALTITUDE:  4,
		HEADING:   8  // equivalent to "bearing" in Android
	},

	/**
	 * @class The <code>LocationEmitter</code> class constructs a singleton object that emits <a href="Device.LocationEmitter.Location.html">Location</a> objects.<br><br>
     * @constructs The default constructor. 
 	 * @see Device.LocationEmitter.Location
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._lastLocation = undefined;
		this._forceListeners = [];
	},

	/**
	 * @param {LocationEmitter#Accuracy} Accuracy accuracy of updates. The default value is HIGH.
	 * @param {Number} elements OR-ed <code>LocationEmitter.Elements</code>. Example: LATITUDE | LONGITUDE. The default value is LATITUDE | LONGITUDE | ALTITUDE | HEADING (i.e. listens to all elements).
	 * @status
	 */
	setProperties: function(accuracy, elements)
	{
		if (! accuracy) accuracy = this.Accuracy.HIGH;
		if (! elements) elements = this.Elements.LATITUDE | this.Elements.LONGITUDE | this.Elements.ALTITUDE | this.Elements.HEADING;
		this.accuracy = accuracy;
		this.elements = elements;
		this._setPropertiesSendGen(accuracy,elements);
	},

	/**
	 * Add a <code>MessageListener</code> to this emitter. When an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.
	 * <br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter one time.<br><br>
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @throws {MessageEmitter.addListener: listener is already listening} Calling <code>addListener()</code> multiple times on the same emitter
	 * with the same listener.
	 * @throws {MessageEmitter.addListener: listener must be instances of MessageListener} Listener is not an instance of <code>MessageListener</code>.
	 * @see Device.LocationEmitter#removeListener,
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	addListener: function($super, listener, func, forceStart, priority) {
		if(forceStart == undefined)
		{
			this._startUpdatingSendGen(true);
			this._forceListeners.push(listener);
		}
		else
		{
			this._startUpdatingSendGen(forceStart);
			if(forceStart == true)
				this._forceListeners.push(listener);
		}

		$super(listener, func, priority);
	},
	
	/**
	 * Remove a <code>MessageListener</code> from this emitter.<br><br> 
	 * The following code examples illustrate different call styles for <code>removeListener()</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener was removed. Returns <code>false</code> if the registered listener is not found 
	 * or is not registered with this emitter.
	 * @throws {MessageEmitter.removeListener: listener is not listening} Specified listener is not currently registered
	 * with this emitter.
	 * @see Device.LocationEmitter#addListener
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	removeListener: function($super, listener) {
		$super(listener);

		var index = this._forceListeners.indexOf(listener);
		if(index != -1)
		{
			this._forceListeners.splice(index,1);
			if(this._forceListeners.length == 0)
				this._stopUpdatingSendGen();
		}
	},
    
	/**
	 * Retrieve the last location returned by this <code>LocationEmitter</code>.
	 * @returns {Device.LocationEmitter.Location} The last location returned.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getLastLocation: function()
	{
		if(this._lastLocation == undefined || !this._lastLocation.getPosition()) return undefined;
		
		return this._lastLocation;
	},
	
    _locationUpdatedRecv: function( cmd ) {
		var msg = {};
		if (!this._locationUpdatedRecvGen(cmd, msg))
		    return;
		
		if (((this.elements & this.Elements.LATITUDE) == 0)  &&
			((this.elements & this.Elements.LONGITUDE) == 0) &&
			((this.Elements & this.Elements.ALTITUDE) == 0))
			return;

		this._lastLocation = new this.Location(
			new Core.Point(msg["latitude"], msg["longitude"]),
			msg["altitude"],
			undefined,
			msg["accuracy"],
			msg["timestamp"]);

		this.emit(this._lastLocation);
    },
	
	_headingUpdatedRecv: function( cmd ) 
	{
		var msg = {};
		if (!this._headingUpdatedRecvGen(cmd, msg))
			return;
			
		if ((this.elements & this.Elements.HEADING) == 0)
			return;

		this._lastLocation = new this.Location(
			this._lastLocation ? this._lastLocation.getPosition() : undefined,
			this._lastLocation ? this._lastLocation.getAltitude() : undefined,
			msg['magneticHeading'],
			this._lastLocation ? this._lastLocation.getAccuracy() : undefined,
			msg['timestamp']);
		
		if(msg['magneticHeading']) {
			this.emit(this._lastLocation);
		}
	},
	
	Location: Core.Class.subclass(
	/** @lends Device.LocationEmitter.Location.prototype */
	{
		classname: 'Location',
		
		/**
		 * @class <code>Location</code> constructs objects that encapsulate the location of a device.
		 * <code>Location</code> objects contain spatial components, like position and heading information, and a timestamp that indicates when a location is measured.
		 * 
		 * @constructs The default constructor. 
		 * @param {Core.Point} position The latitude / longitude of the device.
		 * @param {Number} altitude The altitude of the device.
		 * @param {Number} heading The heading of the device.
		 * @param {Number} accuracy The accuracy of the measurement.
		 * @param {Number} timestamp The timestamp when the location was measured.
		 * @augments Core.Class
		 */
		initialize: function(position, altitude, heading, accuracy, timestamp)
		{
			this._position = position;
			this._altitude = altitude;
			this._accuracy = accuracy;
			this._heading = heading;
			this._timestamp = timestamp;
		},
		
		/**
		 * Return the position of this <code>Location</code> as latitude / longitude.
		 * @returns {Core.Point} The current latitude / longitude.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getPosition: function()
		{
			return this._position;
		},
		
		/**
		 * Return the altitude of this <code>Location</code> in feet (ft).
		 * @returns {Number} The current altitude.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getAltitude: function()
		{
			return this._altitude;
		},
		
		/**
		 * Return the heading of this <code>Location</code> in degrees east of north.
		 * @returns {Number} The current heading.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getHeading: function()
		{
			return this._heading;
		},
		
		/**
		 * Return the accuracy of the measurement for this <code>Location</code>.
		 * @returns {Number} The current location accuracy.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getAccuracy: function()
		{
			return this._accuracy;
		},
		
		/**
		 * Return the timestamp when this measurement was taken.
		 * Expressed in milliseconds since Epoch (Unix time).
		 * @returns {Number} The timestamp of the measurement.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getTimestamp: function()
		{
			return this._timestamp;
		},
	}),
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 333
	// Method create = -1
	// Method destroy = 2
	// Method startUpdatingLocation = 3
	// Method stopUpdatingLocation = 4
	// Method locationUpdated = 5
	// Method startUpdatingHeading = 6
	// Method stopUpdatingHeading = 7
	// Method headingUpdated = 8
	// Method setProperties = 9
	// Method startUpdating = 10
	// Method stopUpdating = 11
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 5:
					instance._locationUpdatedRecv( cmd );
					break;
				case 8:
					instance._headingUpdatedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LocationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LocationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[333] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_locationUpdatedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 5 )
		{
			NgLogE("Could not parse due to wrong argument count in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "timestamp" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "timestamp" ] === undefined )
		{
			NgLogE("Could not parse timestamp in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "latitude" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "latitude" ] === undefined )
		{
			NgLogE("Could not parse latitude in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "longitude" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "longitude" ] === undefined )
		{
			NgLogE("Could not parse longitude in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "altitude" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "altitude" ] === undefined )
		{
			NgLogE("Could not parse altitude in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "accuracy" ] = Core.Proc.parseFloat( cmd[ 4 ] );
		if( obj[ "accuracy" ] === undefined )
		{
			NgLogE("Could not parse accuracy in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_headingUpdatedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 4 )
		{
			NgLogE("Could not parse due to wrong argument count in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "timestamp" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "timestamp" ] === undefined )
		{
			NgLogE("Could not parse timestamp in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "magneticHeading" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "magneticHeading" ] === undefined )
		{
			NgLogE("Could not parse magneticHeading in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "trueHeading" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "trueHeading" ] === undefined )
		{
			NgLogE("Could not parse trueHeading in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "accuracy" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "accuracy" ] === undefined )
		{
			NgLogE("Could not parse accuracy in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":333,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":333,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_startUpdatingLocationSendGen: function( accuracy, distanceFilter )
	{
		Core.Proc.appendToCommandString( ":333,3," + this.__objectRegistryId + "," + accuracy + "," + distanceFilter  );
	},
	
	/** @private */
	_stopUpdatingLocationSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":333,4," + this.__objectRegistryId );
	},
	
	/** @private */
	_locationUpdatedSendGen: function( timestamp, latitude, longitude, altitude, accuracy )
	{
		Core.Proc.appendToCommandString( ":333,5," + this.__objectRegistryId + "," + timestamp + "," + latitude + "," + longitude + "," + altitude + "," + accuracy  );
	},
	
	/** @private */
	_startUpdatingHeadingSendGen: function( orientation, angularFilter )
	{
		Core.Proc.appendToCommandString( ":333,6," + this.__objectRegistryId + "," + orientation + "," + angularFilter  );
	},
	
	/** @private */
	_stopUpdatingHeadingSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":333,7," + this.__objectRegistryId );
	},
	
	/** @private */
	_headingUpdatedSendGen: function( timestamp, magneticHeading, trueHeading, accuracy )
	{
		Core.Proc.appendToCommandString( ":333,8," + this.__objectRegistryId + "," + timestamp + "," + magneticHeading + "," + trueHeading + "," + accuracy  );
	},
	
	/** @private */
	_setPropertiesSendGen: function( accuracy, elements )
	{
		Core.Proc.appendToCommandString( ":333,9," + this.__objectRegistryId + "," + accuracy + "," + elements  );
	},
	
	/** @private */
	_startUpdatingSendGen: function( force )
	{
		Core.Proc.appendToCommandString( ":333,10," + this.__objectRegistryId + "," + ( force ? 1 : 0 )  );
	},
	
	/** @private */
	_stopUpdatingSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":333,11," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// startUpdatingLocation: function( accuracy, distanceFilter ) {}
	
	// stopUpdatingLocation: function(  ) {}
	
	// _locationUpdatedRecv: function( cmd ) {}
	// locationUpdated: function( timestamp, latitude, longitude, altitude, accuracy ) {}
	
	// startUpdatingHeading: function( orientation, angularFilter ) {}
	
	// stopUpdatingHeading: function(  ) {}
	
	// _headingUpdatedRecv: function( cmd ) {}
	// headingUpdated: function( timestamp, magneticHeading, trueHeading, accuracy ) {}
	
	// setProperties: function( accuracy, elements ) {}
	
	// startUpdating: function( force ) {}
	
	// stopUpdating: function(  ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/MemoryEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/MemoryEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/MemoryEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.MemoryEmitter = Core.MessageEmitter.singleton(
/** @lends Device.MemoryEmitter.prototype */
{
	classname: 'MemoryEmitter',
		
	/**
	 * @class The <code>MemoryEmitter</code> class constructs a singleton object that emits messages
	 * when a low memory warning is received from the system.
	 * Applications can respond by releasing unused objects, allowing the system to re-allocate free memory.
	 * Failure to respond to low memory warnings may result in application 
	 * termination by the operating system.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	_memoryEventRecv: function( cmd ) 
	{
		this.emit();
		
		//Cascade the original message back out to native for forwarding
		this._memoryEventSendGen();
	},
													  
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 331
	// Method create = -1
	// Method memoryEvent = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._memoryEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in MemoryEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in MemoryEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[331] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_memoryEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in MemoryEmitter.memoryEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":331,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_memoryEventSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":331,2," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _memoryEventRecv: function( cmd ) {}
	// memoryEvent: function(  ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/MotionEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/MotionEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/MotionEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.MotionEmitter = Core.MessageEmitter.singleton(
/** @lends Device.MotionEmitter.prototype */
{
	classname: 'MotionEmitter',
	
	/**
	 * @class The <code>MotionEmitter</code> class constructs a singleton object that tracks device movement through 3D space. 
	 * These objects emit <a href="Device.MotionEmitter.Motion.html">Motion</a> objects that retrieve spatial data for a given component from the device.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @see Device.MotionEmitter.Motion
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this._lastAccel = null;
		this._lastGyro  = null;
		this._lastCompass = null;
	},

	Motion: Core.Class.subclass(
	/** @lends Device.MotionEmitter.Motion.prototype */
	{
		classname: 'Motion',
		
		/**
		 * @class A <code>Motion</code> object is what <code>MotionEmitter</code> uses to capture device movement through 3D space.
		 * These objects retrieve data from device components on how a device responds to 
		 * physical movement, as reported by the accelerometer, gyroscope and compass instruments.
		 * @constructs The default constructor. 
		 * @param {Array (Number)} accel The accelerometer data.
		 * @param {Array (Number)} gyro The gyroscope data.
		 * @param {Array (Number)} compass The compass data.
		 * @see Device.MotionEmitter
		 * @augments Core.Class
		 */
		initialize: function(accel, gyro, compass)
		{
			this._accel = accel;
			this._gyro  = gyro;
			this._compass = compass;
		},
		
		/**
		 * Retrieve accelerometer data from the device. If the device contains an accelerometer,
		 * calling <code>getAccelData()</code> returns an array of three floating point values. In all other cases,
		 * calling <code>getAccelData()</code> returns <code>undefined</code>.
		 * <b>Note:</b> Use a <code>{@link Core.Capabilities</code> object 
		 * to programmatically check a device for a accelerometer. 
		 * @returns {Array (Number)} The accelerometer data for the device.
		 * @see Core.Capabilities#getHasAccel
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getAccelData: function()
		{
			return this._accel;
		},
		
		/**
		 * Retrieve gyroscope data from the device. If the device contains a gyroscope,
		 * this call returns an array of three floating point values. In all other cases,
		 * this call returns <code>undefined</code>. <br><br>
		 * <b>Note:</b> Use a <code>{@link Core.Capabilities</code> object 
		 * to programmatically check a device for a gyroscope. 
		 * @returns {Array (Number)} The gyroscope data for the device.
		 * @see Core.Capabilities#getHasGyro
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getGyroData: function()
		{
			return this._gyro;
		},
		
		/**
		 * Retrieve compass data from the device. If the device contains a magnetic compass,
		 * this call returns an array of three floating point values. In all other cases,
		 * this call returns <code>undefined</code>.<br><br>
		 * <b>Note:</b> Use a <code>Capabilities</code> object to programmatically check a device for a compass. 
		 * @returns {Array (Number)} The compass data for the device.
		 * @see Core.Capabilities#getHasCompass
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getCompassData: function()
		{
			return this._compass;
		},
	}),

	/**
	 * Construct a <code>MessageListener</code> object and register it with this <code>MotionEmitter</code> object. If an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.<br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter once.
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 *
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 *
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	addListener: function($super, listener, func, priority)
	{
		if (this.getListenerCount() == 0) {
			// start the Accelerometer if this is the first listener
			this._startMotionSendGen();
		}

		$super(listener, func, priority);
	},

	/**
	 * Remove a <code>MessageListener</code> object from this <code>MotionEmitter</code> object. 
	 * The following code examples illustrate different call styles for <code>removeListener()</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.	 
	 * @returns {Boolean} Returns <code>true</code> when the registered listener was removed. Returns <code>false</code> in all other cases.
	 * @see Core.MessageEmitter#addListener
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	removeListener: function($super, listener)
	{
		$super(listener);

		if (this.getListenerCount() == 0) {
			// stop the Accelerometer if this is the last listener
			this._stopMotionSendGen();
		}
	},

	_emitMotion: function()
	{
		var motion = new Device.MotionEmitter.Motion(this._lastAccel, this._lastGyro, this._lastCompass);
		this.emit(motion);
	},

	_accelChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._accelChangedRecvGen(cmd, msg))
			return;

		this._lastAccel = msg;
		this._emitMotion();
		
		//Cascade the original message back out to native for forwarding
		this._accelChangedSendGen(msg.x, msg.y, msg.z);
	},

	_gyroChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._gyroChangedRecvGen(cmd, msg))
			return;

		this._lastGyro = msg;
		this._emitMotion();
		
		//Cascade the original message back out to native for forwarding
		this._gyroChangedSendGen(msg.x, msg.y, msg.z);
	},
	
	_magneticChangedRecv: function( cmd ) 
	{
		var msg = {};
		if(!this._magneticChangedRecvGen(cmd, msg))
			return;
		
 		this._lastCompass = msg;
		this._emitMotion();
		
		//Cascade the original message back out to native for forwarding
		this._magneticChangedSendGen(msg.x, msg.y, msg.z);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 330
	// Method create = -1
	// Method accelChanged = 2
	// Method gyroChanged = 3
	// Method magneticChanged = 4
	// Method startMotion = 5
	// Method stopMotion = 6
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._accelChangedRecv( cmd );
					break;
				case 3:
					instance._gyroChangedRecv( cmd );
					break;
				case 4:
					instance._magneticChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in MotionEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in MotionEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[330] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_accelChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		obj[ "z" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "z" ] === undefined )
		{
			NgLogE("Could not parse z in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_gyroChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		obj[ "z" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "z" ] === undefined )
		{
			NgLogE("Could not parse z in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_magneticChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		obj[ "z" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "z" ] === undefined )
		{
			NgLogE("Could not parse z in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":330,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_accelChangedSendGen: function( x, y, z )
	{
		Core.Proc.appendToCommandString( ":330,2," + this.__objectRegistryId + "," + x + "," + y + "," + z  );
	},
	
	/** @private */
	_gyroChangedSendGen: function( x, y, z )
	{
		Core.Proc.appendToCommandString( ":330,3," + this.__objectRegistryId + "," + x + "," + y + "," + z  );
	},
	
	/** @private */
	_magneticChangedSendGen: function( x, y, z )
	{
		Core.Proc.appendToCommandString( ":330,4," + this.__objectRegistryId + "," + x + "," + y + "," + z  );
	},
	
	/** @private */
	_startMotionSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":330,5," + this.__objectRegistryId );
	},
	
	/** @private */
	_stopMotionSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":330,6," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _accelChangedRecv: function( cmd ) {}
	// accelChanged: function( x, y, z ) {}
	
	// _gyroChangedRecv: function( cmd ) {}
	// gyroChanged: function( x, y, z ) {}
	
	// _magneticChangedRecv: function( cmd ) {}
	// magneticChanged: function( x, y, z ) {}
	
	// startMotion: function(  ) {}
	
	// stopMotion: function(  ) {}
	

// {{/Wg Generated Code}} }}}

});
// vim:set fdm=marker noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/NetworkEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/NetworkEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/NetworkEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.NetworkEmitter = Core.MessageEmitter.singleton(
/** @lends Device.NetworkEmitter.prototype */
{
	classname: 'NetworkEmitter',
	
	/**
	 * @class The <code>NetworkEmitter</code> class constructs a singleton object that tracks network connectivity status for a device.
	 * These objects emit a <a href="Device.NetworkEmitter.html#Status">Status</a> object when a change to device network connectivity status occurs.
	 * A change in network status is defined as:
	 * <div class="ul"><font size="3">
	 * <li>The device loses access to a network.</li>
	 * <li>The device gains access to a network.</li>
	 * <li>The device switches between cellular and Wi-Fi network access.</li>
	 * </font></div><br>
	 * <p><b>Note:</b> Applications should never directly allocate a singleton.</p>
	 * @constructs The default constructor. 
	 * @see Device.NetworkEmitter#Status
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this._lastStatus = null;
	},

	/**
	 * Retrieve the network status of the device.
	 * @returns {Device.NetworkEmitter#Status} The current device network status.
	 * @status iOS, Android, Test
	 */
	getLastStatus: function()
	{
		return this._lastStatus;
	},

	/** 
	 * Enumeration values for device network status.
	 * @fieldOf Device.NetworkEmitter.prototype
	 */
	Status:
	{
		/** 
		* <code>0</code> = No network connectivity. 
		* @fieldOf Device.NetworkEmitter.prototype
		* @constant
		*/
		None: 0,
		
		/** 
		* <code>1</code> = Cellular network connectivity. 
		* @fieldOf Device.NetworkEmitter.prototype
		* @constant
		*/
		Cellular: 1,
		
		/** 
		* <code>2</code> = Wi-Fi network connectivity. 
		* @fieldOf Device.NetworkEmitter.prototype
		* @constant
		*/
		Wifi: 2,
	},

	_statusChangedRecv: function( cmd )
	{
		var msg = {};
		if (!this._statusChangedRecvGen(cmd, msg))
		    return;

		this._lastStatus = msg['status'];
		this.emit(this._lastStatus);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 336
	// Method create = -1
	// Method statusChanged = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._statusChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in NetworkEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in NetworkEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[336] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_statusChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in NetworkEmitter.statusChanged from command: " + cmd );
			return false;
		}
		
		obj[ "status" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "status" ] === undefined )
		{
			NgLogE("Could not parse status in NetworkEmitter.statusChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":336,-1," + __objectRegistryId  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _statusChangedRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/OrientationEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/OrientationEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/OrientationEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class OrientationEmitter
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.OrientationEmitter = Core.MessageEmitter.singleton(
/** @lends Device.OrientationEmitter.prototype */
{
	classname: 'OrientationEmitter',
		
	/**
	 * @class <code>OrientationEmitter</code> constructs a singleton object that tracks the physical orientation of the device.
	 * These objects emit an <code><a href="Device.OrientationEmitter.html#Orientation">Orientation</a></code> object when a change in device orientation occurs.<br><br>
	 * Rotating the device does not necessarily rotate the 
	 * interface presented to the user. Applications must
	 * explicitly call <code><a href="Device.OrientationEmitter.html#setInterfaceOrientation">setInterfaceOrientation()</a></code> to rotate the interface.
	 * This allows an application to selectively choose a supported device orientation.
	 * For example, an application can observe orientation change events and change the interface orientation only if the application suppoorts it.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 	 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this._lastDeviceOrientation    = this.Orientation.Portrait;
		this._lastInterfaceOrientation = this.Orientation.Portrait;
	},
	
	/**
	 * Retrieve the device orientation.
	 * @returns {Device.OrientationEmitter#Orientation} The current device orienation.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getDeviceOrientation: function()
	{
		return this._lastDeviceOrientation;
	},
	
	/**
	 * Retrieve the interface orientation. Initially, this is the same
	 * as the device orientation.
	 * @returns {Device.OrientationEmitter#Orientation} The current interface orientation.
	 * @see Device.OrientationEmitter#setInterfaceOrientation
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getInterfaceOrientation: function()
	{
		return this._lastInterfaceOrientation;
	},
	
	/**
	 * Set the interface orientation.
	 * @example var orientation = new Device.OrientationEmitter(Device.OrientationEmitter.Orientation.Portrait, true);
	 * @param {Device.OrientationEmitter#Orientation} orientation The new device orientation.
	 * @param {Boolean} [animated] Set as <code>true</code> to render the orientation change with an animated effect.
	 * @see Device.OrientationEmitter#getInterfaceOrientation
	 * @status iOS, Test
	 */
	setInterfaceOrientation: function(orientation, animated)
	{
		if (orientation != this._lastInterfaceOrientation)
		{
			NgLogD("setInterfaceOrientation to " + orientation);
			this._setInterfaceOrientationSendGen(orientation,animated);
			this._lastInterfaceOrientation = orientation;
		}
	},
	
	/**
	 * Enumeration for device orientation.
	 * @fieldOf Device.OrientationEmitter.prototype
	 */
	Orientation:
	{ 
		/** 
		* Portrait orientation. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		Portrait: 0,
		/** 
		* Portrait orientation, but rotated 180 degrees. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		PortraitUpsideDown: 1,
		/** 
		* Landscape orientation with the top of the device to the left. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		LandscapeLeft: 2,
		/** 
		* Landscape orientation with the top of the device to the right. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		LandscapeRight: 3,
		/** 
		* Oriented with the face of the device up. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		FaceUp: 4,
		/** 
		* Oriented with the face of the device down. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		FaceDown: 5,
	},

	/**
	 * Enumeration for orientation type.
	 * It can be used to identify which event happens.
	 * @filedOf Device.OrientationEmitter.prototype
	 */
	OrientationType:
	{
		/**
		* Device orientation has changed.
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		Device: 0,
		/**
		* Interface orientation has changed.
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		Interface: 1
	},

	_orientationChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._orientationChangedRecvGen(cmd, msg))
			return;
 
 		this._lastDeviceOrientation = msg['orientation'];
		this.emit({type: this.OrientationType.Device, orientation:msg['orientation']});
		
		//Cascade the original message back out to native for forwarding
		this._orientationChangedSendGen(msg.orientation);
	},
	
	_interfaceOrientationChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._interfaceOrientationChangedRecvGen(cmd, msg))
			return;
 
 		this._lastInterfaceOrientation = msg['orientation'];
		this.emit({type: this.OrientationType.Interface, orientation:msg['orientation']});
		
		//Cascade the original message back out to native for forwarding
		this._interfaceOrientationChangedSendGen(msg.orientation);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 335
	// Method create = -1
	// Method orientationChanged = 2
	// Method setInterfaceOrientation = 3
	// Method interfaceOrientationChanged = 4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._orientationChangedRecv( cmd );
					break;
				case 4:
					instance._interfaceOrientationChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in OrientationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in OrientationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[335] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_orientationChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in OrientationEmitter.orientationChanged from command: " + cmd );
			return false;
		}
		
		obj[ "orientation" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "orientation" ] === undefined )
		{
			NgLogE("Could not parse orientation in OrientationEmitter.orientationChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_interfaceOrientationChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in OrientationEmitter.interfaceOrientationChanged from command: " + cmd );
			return false;
		}
		
		obj[ "orientation" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "orientation" ] === undefined )
		{
			NgLogE("Could not parse orientation in OrientationEmitter.interfaceOrientationChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":335,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_orientationChangedSendGen: function( orientation )
	{
		Core.Proc.appendToCommandString( ":335,2," + this.__objectRegistryId + "," + orientation  );
	},
	
	/** @private */
	_setInterfaceOrientationSendGen: function( orientation, animated )
	{
		Core.Proc.appendToCommandString( ":335,3," + this.__objectRegistryId + "," + orientation + "," + ( animated ? 1 : 0 )  );
	},
	
	/** @private */
	_interfaceOrientationChangedSendGen: function( orientation )
	{
		Core.Proc.appendToCommandString( ":335,4," + this.__objectRegistryId + "," + orientation  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _orientationChangedRecv: function( cmd ) {}
	// orientationChanged: function( orientation ) {}
	
	// setInterfaceOrientation: function( orientation, animated ) {}
	
	// _interfaceOrientationChangedRecv: function( cmd ) {}
	// interfaceOrientationChanged: function( orientation ) {}
	

// {{/Wg Generated Code}} }}}

});
// vim:set fdm=marker noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/ShakeEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/ShakeEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/ShakeEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;
var MotionEmitter = require('NGCore/Client/Device/MotionEmitter').MotionEmitter;

var ProxyListener = Core.MessageListener.subclass(
{
	onUpdate: function() {}
});

exports.ShakeEmitter = Core.MessageEmitter.singleton(
/** @lends Device.ShakeEmitter.prototype */
{
	classname: 'ShakeEmitter',
		
	/**
	 * @class The <code>ShakeEmitter</code> class constructs a singleton object that tracks when users physically shake the device. 
	 * These objects emit messages when the device recognizes a shake gesture.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android
	 */
	
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._proxyListener = new ProxyListener();
		
	},
	
	/**
	 * Add a <code>MessageListener</code> to this emitter. When an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.
	 * <br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter one time.<br><br>
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @throws {MessageEmitter.addListener: listener is already listening} Calling <code>addListener()</code> multiple times on the same emitter
	 * with the same listener.
	 * @throws {MessageEmitter.addListener: listener must be instances of MessageListener} Listener is not an instance of <code>MessageListener</code>.
	 * @see Device.ShakeEmitter#removeListener,
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	addListener: function($super, listener, func, priority)
	{
		if (this.getListenerCount() == 0) {
			MotionEmitter.addListener(this._proxyListener, function(){});
		}

		$super(listener, func, priority);
	},
	
	/**
	 * Remove a <code>MessageListener</code> from this emitter.<br><br> 
	 * The following code examples illustrate different call styles for <code>removeListener()</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener was removed. Returns <code>false</code> if the registered listener is not found 
	 * or is not registered with this emitter.
	 * @throws {MessageEmitter.removeListener: listener is not listening} Specified listener is not currently registered
	 * with this emitter.
	 * @see Device.ShakeEmitter#addListener
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	removeListener: function($super, listener)
	{
		$super(listener);

		if (this.getListenerCount() == 0) {
			MotionEmitter.removeListener(this._proxyListener);
		}
	},
	
	_shakeRecv: function( cmd )
	{
		this.emit();
		
		//Cascade the original message back out to native for forwarding
		this._shakeSendGen();
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 332
	// Method create = -1
	// Method shake = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._shakeRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in ShakeEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in ShakeEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[332] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_shakeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in ShakeEmitter.shake from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":332,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_shakeSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":332,2," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _shakeRecv: function( cmd ) {}
	// shake: function(  ) {}
	

// {{/Wg Generated Code}}	

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/KeyEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/KeyEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/KeyEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;
var UI = require('NGCore/Client/UI').UI;

////////////////////////////////////////////////////////////////////////////////

// Private Class Statics
var keyCodeReverseMap = null;

exports.KeyEmitter = Core.MessageEmitter.singleton(
/** @lends Device.KeyEmitter.prototype */
{
	classname: 'KeyEmitter',

	/**
	 * @class The <code>KeyEmitter</code> class constructs a singleton object that emits a <code><a href="Device.KeyEmitter.KeyEvent.html">KeyEvent</a></code> object 
	 * when the user presses or releases a device hardware key.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @require Device
	 * @example
	 *
	 * var KeyListener = Core.MessageListener.subclass({
	 *   onUpdate: function(keyEvent) {
	 *     // back to the launcher when the back button is pressed
	 *     if (keyEvent.code === Device.KeyEmitter.Keycode.back) {
	 *        this.destroy();
	 *        LGL.runUpdatedGame('/Samples/Launcher');
	 *        return;
	 *     }
	 *
	 *     var text = '';
	 *     switch (keyEvent.type) {
	 *        case Device.KeyEmitter.EventType.onDown:
	 *           text += 'onDown :'
	 *           break;
	 *        case Device.KeyEmitter.EventType.onUp:
	 *           text += 'onUp :'
	 *           break;
	 *     }
	 *
	 *     text += Device.KeyEmitter.keyCodeToSymbol(keyEvent.code);
	 *     console.log(text);
	 *   }
	 * };
	 *
	 * var keyListener = new KeyListener();
	 * Device.KeyEmitter.addListener(keyListener, keyListener.onUpdate);
	 *
	 * @status Android, Test, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/**
	 * Convert a keycode into the equivalent human-readable symbol. The keycode to convert is passed in as a parameter.
	 * The following code example illustrates how to convert a keycode into a human-readable symbol.
	 * @param {String} keyCode The keycode to convert.
	 * @static
	 *
	 * @example
	 *   var symbol = Device.KeyEmitter.keyCodeToSymbol(0x1d);
	 *   // symbol => 'a'
	 *
	 * @status
	 */
	keyCodeToSymbol: function(keyCode)
	{
		if (!keyCodeReverseMap) {
			keyCodeReverseMap = {};
			for (var codename in this.Keycode) {
				keyCodeReverseMap[this.Keycode[codename]] = codename;
			}
		}
		return keyCodeReverseMap[keyCode] || '';
	},

	KeyEvent: Core.Class.subclass(
	/** @lends Device.KeyEmitter.KeyEvent.prototype */
	{
		classname: 'KeyEvent',

		/**
		 * @class <code>KeyEvent</code> constructs objects that contain the parcel of a keyboard event. 
		 * The keycode of the key that triggered the event is passed in as a parameter.
		 * @constructs The default constructor. 
		 * @augments Core.Class
		 * @param {Device.KeyEmitter.EventType} type The type of the keyboard event.
		 * @param {Integer} modifiers the bit-and of {@link Device.KeyEmitter#Modifier} combination.
		 * @param {Device.KeyEmitter.Keycode} code The actual keycode.
		 */
		initialize: function(type, modifiers, code)
		{
			this.type      = type;
			this.modifiers = modifiers;
			this.code      = code;
		}
	}),

	_onKeyEventRecv: function( cmd )
	{
		var msg = {};
		if(!this._onKeyEventRecvGen(cmd, msg))
			return;

		var keyEvent = new Device.KeyEmitter.KeyEvent(msg.type, msg.modifiers, msg.code);
		
		if(!this.chain(keyEvent)) {
			//Noone handled this keyEvent. Cascade the original back out to native for forwarding
			//	to the next interpreter in the chain.
			this._onKeyEventSendGen(msg.type, msg.modifiers, msg.code);
		}
	},

// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Event type Enums.
	 * Currently we only have onUp and onDown events.
	 *
	 * @namespace
	 * */
	EventType:
	{ 
		/** the key is hooked up. */
		onUp: 0,
		/** the key is pressed down. */
		onDown: 1,
	},
	
	/** 
	 * Enums for modifiers that are being pressed.
	 * They are passed as bit-and-ed.
	 *
	 * @namespace
	 * @example
	 *
	 * var keyEvent; // emitted from KeyEmitter
	 * if (keyEvent.modifiers & Device.KeyEmitter.Modifier.ALT && 
	 *     keyEvent.modifiers & Device.KeyEmitter.Modifier.SHIFT)
	 *    console.log("ALT+SHIFT");
	 * */
	Modifier:
	{ 
		/** no modifiers */
		NONE: 0,
		/** SYMBOL modifier */
		SYMBOL: 1 << 0,
		/** ALT modifier */
		ALT: 1 << 1,
		/** ALT_LEFT modifier */
		ALT_LEFT: 1 << 2,
		/** ALT_RIGHT modifier */
		ALT_RIGHT: 1 << 3,
		/** SHIFT modifier */
		SHIFT: 1 << 4,
		/** SHIFT_LEFT modifier */
		SHIFT_LEFT: 1 << 5,
		/** SHIFT_RIGHT modifier */
		SHIFT_RIGHT: 1 << 6,
	},
	
	/** 
	 * Keycode Enums.
	 * Define bunch of key codes.
	 * @namespace
	 * */
	Keycode:
	{ 
		/** * */
		a: 0x1d,
		/** * */
		b: 0x1e,
		/** * */
		c: 0x1f,
		/** * */
		d: 0x20,
		/** * */
		e: 0x21,
		/** * */
		f: 0x22,
		/** * */
		g: 0x23,
		/** * */
		h: 0x24,
		/** * */
		i: 0x25,
		/** * */
		j: 0x26,
		/** * */
		k: 0x27,
		/** * */
		l: 0x28,
		/** * */
		m: 0x29,
		/** * */
		n: 0x2a,
		/** * */
		o: 0x2b,
		/** * */
		p: 0x2c,
		/** * */
		q: 0x2d,
		/** * */
		r: 0x2e,
		/** * */
		s: 0x2f,
		/** * */
		t: 0x30,
		/** * */
		u: 0x31,
		/** * */
		v: 0x32,
		/** * */
		w: 0x33,
		/** * */
		x: 0x34,
		/** * */
		y: 0x35,
		/** * */
		z: 0x36,
		/** TBD */
		up: 0x13,
		/** TBD */
		down: 0x14,
		/** TBD */
		left: 0x15,
		/** TBD */
		right: 0x16,
		/** * */
		enter: 0x42,
		/** * */
		backspace: 0x43,
		/** * */
		back: 0x04,
		/** backunhandled: 0x54, Special KeyCode to tell MobageService that the back was unhandled by the game, after the service declined first dibs. Stole MAX_KEYCODE (deprecated constant). */
		backunhandled: 0x54,
		/** * */
		menu: 0x52,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 343
	// Method create = -1
	// Method onKeyEvent = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._onKeyEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in KeyEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in KeyEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[343] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onKeyEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		obj[ "type" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "type" ] === undefined )
		{
			NgLogE("Could not parse type in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		obj[ "modifiers" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "modifiers" ] === undefined )
		{
			NgLogE("Could not parse modifiers in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		obj[ "code" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "code" ] === undefined )
		{
			NgLogE("Could not parse code in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":343,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_onKeyEventSendGen: function( type, modifiers, code )
	{
		Core.Proc.appendToCommandString( ":343,2," + this.__objectRegistryId + "," + type + "," + modifiers + "," + code  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _onKeyEventRecv: function( cmd ) {}
	// onKeyEvent: function( type, modifiers, code ) {}
	

// {{/Wg Generated Code}}

});
// vim:set fdm=marker noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_PushNotificationEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_PushNotificationEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_PushNotificationEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

/*
	NOTE: 	THIS IS FOR INTERNAL USE ONLY AND WILL BE DEPRECATED IN THE FUTURE.
			DO NOT USE IT IN ANY OF YOUR CODE.
*/

exports.PushNotificationEmitter = Core.MessageEmitter.singleton(
/** @lends Device.PushNotificationEmitter.prototype */
{
	classname: 'PushNotificationEmitter',
		
	/**
	 * @class Emits when native code recieves a push notification
	 * @constructs The default constructor.
	 * @augments Core.MessageEmitter
	 */
	
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	_onPushNotificationRecv: function( cmd )
	{
		var msg = {};
		if (!this._onPushNotificationRecvGen(cmd, msg))
			return;
			
		this._lastMsgPayload = msg.msgPayload;
		
		if(!this.chain(msg.msgPayload))	{
			//Noone handled this keyEvent. Cascade the original back out to native for forwarding
			//	to the next interpreter in the chain.
			this._onPushNotificationSendGen(msg.msgPayload);
		}
		
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 345
	// Method create = -1
	// Method onPushNotification = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._onPushNotificationRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in PushNotificationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in PushNotificationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[345] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onPushNotificationRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in PushNotificationEmitter.onPushNotification from command: " + cmd );
			return false;
		}
		
		obj[ "msgPayload" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "msgPayload" ] === undefined )
		{
			NgLogE("Could not parse msgPayload in PushNotificationEmitter.onPushNotification from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":345,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_onPushNotificationSendGen: function( msgPayload )
	{
		Core.Proc.appendToCommandString( ":345,2," + this.__objectRegistryId + "," + Core.Base64.encode( msgPayload )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _onPushNotificationRecv: function( cmd ) {}
	// onPushNotification: function( msgPayload ) {}
	

// {{/Wg Generated Code}}	

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_InAppPurchaseEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchaseEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchaseEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class InAppPurchaseEmitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.InAppPurchaseEmitter = Core.MessageEmitter.singleton(
/** @lends Device.InAppPurchaseEmitter.prototype */
{
	classname: 'InAppPurchaseEmitter',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	_onPurchaseEventRecv: function( cmd ) {
		var msg = {};
		if (!this._onPurchaseEventRecvGen(cmd, msg))
			return;
		if(!this.chain(msg.err, msg.data, msg.verificationToken))	{
			//Noone handled this keyEvent. Cascade the original back out to native for forwarding
			//	to the next interpreter in the chain.
			this._onPurchaseEventSendGen(msg.err, msg.data, msg.verificationToken);
		}
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 347
	// Method create = -1
	// Method onPurchaseEvent = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._onPurchaseEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in InAppPurchaseEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in InAppPurchaseEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[347] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onPurchaseEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		obj[ "err" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "err" ] === undefined )
		{
			NgLogE("Could not parse err in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		obj[ "verificationToken" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "verificationToken" ] === undefined )
		{
			NgLogE("Could not parse verificationToken in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":347,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_onPurchaseEventSendGen: function( err, data, verificationToken )
	{
		Core.Proc.appendToCommandString( ":347,2," + this.__objectRegistryId + "," + Core.Base64.encode( err ) + "," + Core.Base64.encode( data ) + "," + Core.Base64.encode( verificationToken )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _onPurchaseEventRecv: function( cmd ) {}
	// onPurchaseEvent: function( err, data, verificationToken ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_InAppPurchase'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchase'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchase'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class InAppPurchase
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var DeviceReq = require('NGCore/Client/Device');
var Localization = require('NGCore/Client/Core/Localization').Localization;

////////////////////////////////////////////////////////////////////////////////

exports.InAppPurchase = Class.singleton(
/** @lends Device.InAppPurchase.prototype */
{
	classname: 'InAppPurchase',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	initService: function(ordercb, donecb) {
		if ((!this._isIOS()) && (!this._isAndroid())) {
			NgLogE("ERROR: Neither Android nor iOS platform, IAP will not work");
			donecb();
			return;
		}
		if (!this._iapInited) {
			var IAPListener = Core.MessageListener.subclass({
				onPurchaseEvent: this._iapCallback.bind(this)
			});
			// Register for Android / iOS IAP callbacks the same way
			this.listener = new IAPListener();
	        DeviceReq.Device.InAppPurchaseEmitter.addListener(
				this.listener, this.listener.onPurchaseEvent);
	    	// listener will be called when purchase state changes
		}
		this._initDonecb = donecb;
		this._initOrdercb = ordercb;
		if (this._isAndroid()) {
			this._iapCallback('morenonces', '', '');
			/*
			 * Gets persisted unfulfilled orders, calls back ordercb for each
			 * unfulfilled order.
			 */
			var self = this;
			Storage.KeyValueCache.local.getItem(this._IAB_ORPHANED,
			function(err, currorders) {
	   			if (currorders && (currorders.length > 0)) {
					var orders = JSON.parse(currorders);
   					// _restoreOrders eventually calls _initService when fully
					// done.
					self._restoreOrders(orders);
				} else {
					self._initService();
				}
			});
		} else {
			// _isIOS - call _initService directly.  It will call back with
			// orphaned order if any.
			this._initService();
		}
	},

	launchPurchaseView: function(productID, quantity, purchasecb, failcb, cancelcb) {
		if (!this._iapInited) {
			NgLogE("ERROR: function initService must be called and its donecb " +
			"called back, before launchPurchaseView may be used.");
			failcb(false, "failed:initservice_not_done");
			return;
		}

		this._currentOrderProductID = productID;

		this._currentOrderCancelcb = cancelcb;
		this._currentOrderFailcb = failcb;
		this._currentOrderPurchasecb = purchasecb;

		// Android IAB currently only supports quantity of 1
		if (quantity !== 1 && this._isAndroid()) {
			failcb(false, "failed:unsupported_quantity");
			return;
		}

		// Place progress dialog underneath the IAB view first
        if(this._isIOS()) {
	        this._currentOrderProgressDialog = (new UI.ProgressDialog()).retain();
	        this._currentOrderProgressDialog.setText(Localization.getString("Processing Order"));
        } else if(!this._isIOS()) {
	        this._currentOrderProgressDialog = (new UI.AlertDialog()).retain();
	        this._currentOrderProgressDialog.setTitle(Localization.getString("Processing Order"));
            // todo: localization???
            this._currentOrderProgressDialog.setText(
                "Your order is being processed. You will receive a confirmation momentarily.");
            this._currentOrderProgressDialog.setChoices(["OK"]);
            this._currentOrderProgressDialog.onchoice = function(event) {
                this._currentOrderProgressDialog.release();
                this._currentOrderProgressDialog = null;
            };
        }

	    this._currentOrderProgressDialog.show();

		if (this._isIOS() || this._isAndroid()) {
	        DeviceReq.Device.InAppPurchase._requestPurchase(productID, quantity);
			// Note that _iapCallback will call the *cb callback function(s)
			return;
		}
	    this._currentOrderProgressDialog.hide();
        this._currentOrderProgressDialog.release();
	    this._currentOrderProgressDialog = undefined;
		NgLogE('launchPurchaseView failed: only Android and iOS platforms are currently supported.');
		failcb(false, "failed:unsupported_platform");
		return;
	},

	pushSingleNonce: function(nonce){
		var noncePool = [];
		noncePool.push(nonce);
		this._fillIABNoncePool(JSON.stringify(noncePool));
	},

	/**
	 * get a product information specified by productId.
	 * @param {String} productId the product ID registered at iTunes connect.
	 * @param {Function} callback called back when it gets a response. The signature for the callback is equivalent to:<br><br>
	 * <pre>function(productData, err)</pre><br>
	 * The <code>productData</code> is an product information like "JPY,115.000000".
	 * When something bad happenes, <code>err</code> is set to the error message. Otherwise, err will be null or undefined.
	 * @status iOS, iOSTested
	 */
	getProductInformation: function(productId, callback) {
		this._getProductInformationCB = callback;
		this._getProductInformationSendGen(productId);
	},

	/*
	 * For Google IAB, these constants come from
	 * Consts.java in IAB sample code
	 *
	 *	public enum PurchaseState {
     *   PURCHASED,   // User was charged for the order. -- 0
     *   CANCELED,    // The charge failed on the server. -- 1
	 *   REFUNDED;    // User received a refund for the order. -- 2
	 */
	_IAB_PURCHASED: 0,
	_IAB_CANCELED: 1,
	_IAB_REFUNDED: 2,
	_IAB_ORPHANED: "com.ngmoco.in_app_purchase.iab_orphaned_orders",

	_capIsAndroid: undefined,
	_capIsIOS: undefined,

	// at most one outstanding order is supported
	_currentOrderCancelcb : undefined,
	_currentOrderFailcb : undefined,
	_currentOrderProductID : undefined,
	_currentOrderProgressDialog : undefined,
	_currentOrderPurchasecb : undefined,

	_initDonecb : undefined,
	_initOrdercb : undefined,
	_iapInited: false,

	_generateIABNonce: function(){
		var timestamp = new Date().getTime();
		var random = Math.floor(Math.random() * 1000);
		var nonce = (timestamp * 1000) + random;
		NgLogD("Generated nonce: " + nonce);
		return nonce;
	},

	_iapCallback: function( err, data, verificationToken ) {
		if (err == 'morenonces') {
			var count = 10;
			var noncePool = [];
			while(noncePool.length < count){
				noncePool.push(this._generateIABNonce());
			}
			this._fillIABNoncePool(JSON.stringify(noncePool));
			return true;
		}
		if ((err == 'initdone') || (err == 'initcheckdone')) {
			if (typeof this._initDonecb == 'function') {
				this._iapInited = true;
				this._initDonecb();
				this._initDonecb = undefined;
				this._initOrdercb = undefined;
			} else {
				NgLogW("WARN: " + err + " callback with empty donecb");
			}
	        // at most one listener gets iap events
	        return true;
		}
		if (err == 'getProductInformationDone') {
			if (data && data.length > 0) {
				var datajsonp = JSON.parse(data);
				this._getProductInformationCB(datajsonp.productId);
			} else {
				this._getProductInformationCB('', "no information on this product");
			}
			this._getProductInformationCB = undefined;
			return true;
		}
		var orderId = undefined;
		var prodId = "";
	    var firstOrder = undefined;
	    var datajson = undefined;
		if (data && data.length > 0) {
		    datajson = JSON.parse(data);
		    if ((typeof datajson.orders == 'undefined') ||
		        (datajson.orders.length <= 0)) {
		        // callback with no orders, try to get prodId
			    if (typeof datajson.productId != 'undefined') {
					prodId = datajson.productId.toUpperCase();
				}
		    } else {
 				if (this._isAndroid() &&
				 	(typeof this._currentOrderProgressDialog == 'undefined')) {
						// this callback comes in 'out of band', when user did
						// not attempt a purchase.  This happens on Android
						// when async callbacks are not confirmed due to
						// connectivity issue.  This callback is persisted for
						// the next 'initService' call to pick up. Only
						// successful orders will be used in callbacks.
						// Failed order and refunds are ignored.
						//
						// Note also that Android IAB could callback with
						// duplicate order numbers.  In other words, the same
						// order number could come back twice in 2 different
						// callbacks.  There is no code on client to detect
						// such duplicate.  It is up to the server to detect
						// orders which have already been fulfilled.
						//
						var successOrders = this._filterSuccessOrders(datajson, verificationToken);
						if (successOrders.length > 0) {
							this._persistOrphanedOrders(successOrders);
						}
						return true;
				} else if (datajson.orders.length === 1) {
					// on iOS, and in common cases on Android, there is at
					// most one order
				    firstOrder = datajson.orders[0];
					prodId = firstOrder.productId.toUpperCase();
					orderId = firstOrder.orderId;
				} else {
					var successOrders2 = this._filterSuccessOrders(datajson, verificationToken);
					// on Android, get the first match.  Then add any orphaned
					// orders to existing list of persisted
					// orders.  These will be processed during next initService
					if (successOrders2.length > 0) {
					    firstOrder = successOrders2.shift();
						prodId = firstOrder.productId.toUpperCase();
						orderId = firstOrder.orderId;
						if (successOrders2.length > 0) {
							this._persistOrphanedOrders(successOrders2);
						}
					}
				}
			}
		}
		if (this._currentOrderProductID != prodId) {
			NgLogW("iapCallback: product id mismatch in callback.  Req: '" +
					this._currentOrderProductID + "' CB:'" + prodId + "'");
		}
		if ((err && (err.length > 0)) || (firstOrder && firstOrder.purchaseState &&
			(firstOrder.purchaseState !== this._IAB_PURCHASED))) {
			if (firstOrder && firstOrder.purchaseState &&
				(firstOrder.purchaseState === this._IAB_REFUNDED)) {
				// refunds are generated 'out of the blue' by merchant and is
				// not part of normal flow.  Hence it is ignored.  Code now
				// continues to wait for actual purchase callback
				NgLogD("iapCallback: ignoring refunded order: " +
						JSON.stringify(firstOrder));
				return true;
			}
			if (typeof this._currentOrderProgressDialog != 'undefined') {
				this._currentOrderProgressDialog.hide();
                this._currentOrderProgressDialog.release();
				this._currentOrderProgressDialog = undefined;
			}

			if (err == 'cancelled') {
				if ((typeof this._currentOrderCancelcb) == 'function') {
					this._currentOrderCancelcb();
					this._currentOrderCancelcb = undefined;
				}
			} else {
				if (err) {
					NgLogD("DEBUG: iapCallback: got error: " + err);
				} else {
					// _IAB_CANCELED
					NgLogD("DEBUG: iapCallback: got canceled purchaseState.");
				}
				if ((typeof this._currentOrderFailcb) == 'function') {
					this._currentOrderFailcb(false, err);
					this._currentOrderFailcb = undefined;
				}
			}

	        // at most one listener gets iap events
	        return true;
	    }
		if (typeof firstOrder == 'undefined') {
			// there was no (non-refunded) order in callback
			return true;
		}
	    var nextcb2 = function(cbIsDone) {
			if (typeof this._currentOrderProgressDialog != 'undefined') {
				this._currentOrderProgressDialog.hide();
		        this._currentOrderProgressDialog.release();
				this._currentOrderProgressDialog = undefined;
			}
		    if (cbIsDone !== false) {
				return;
			}
			// Currently, fail if the first try is not done, no retry
			if ((typeof this._currentOrderFailcb) == 'function') {
				this._currentOrderFailcb(true, "failed:no_more_retry");
				this._currentOrderFailcb = undefined;
			}
	    };
		if ((typeof this._currentOrderPurchasecb) == 'function') {
			var receipt = verificationToken;
			if (this._isAndroid()) {
				// on Android, both the data and signature are required
				// for verification
				var receiptj = {
					data: data,
					signature: verificationToken
				};
				receipt = JSON.stringify(receiptj);
			}
		    this._currentOrderPurchasecb(prodId, orderId, receipt, firstOrder, nextcb2.bind(this));
			this._currentOrderPurchasecb = undefined;
		} else if ((!this._iapInited) && ((typeof this._initOrdercb) ==
		 			'function')) {
			var initcb2 = function(){
				// Do nothing on iOS as Store Observer simply emits
				// asychronously until done.
			};
			// part of initService flow
		    this._initOrdercb(prodId, orderId, verificationToken, firstOrder,
			initcb2);
		}
        // at most one listener gets iap events
        return true;
    },

	_isAndroid: function() {
		if (typeof this._capIsAndroid != 'undefined') {
			return this._capIsAndroid;
		}
		// Find out from capabilities
	    var capabilities = Core.Capabilities;
	    if ((typeof capabilities.getPlatformOS() != "undefined") &&
	        (capabilities.getPlatformOS().toLowerCase() == 'android')) {
	        this._capIsAndroid = true;
	    } else {
	        this._capIsAndroid = false;
		}
		return this._capIsAndroid;
	},

	_isIOS: function() {
		if (typeof this._capIsIOS != 'undefined') {
			return this._capIsIOS;
		}
		// Find out from capabilities
	    var capabilities = Core.Capabilities;
	    if ((typeof capabilities.getPlatformOS() != "undefined") &&
	        (capabilities.getPlatformOS().toLowerCase() == 'iphone os')) {
	        this._capIsIOS = true;
	    } else {
	        this._capIsIOS = false;
		}
		return this._capIsIOS;
	},

	_fillIABNoncePool: function(nonces) {
		this._fillIABNoncePoolSendGen(nonces);
	},
	_filterSuccessOrders: function(datajson, verificationToken) {
		var successOrders = [];
		for (var kdx in datajson.orders) {
			if ((datajson.orders[kdx].purchaseState) &&
				(datajson.orders[kdx].purchaseState ===
					this._IAB_PURCHASED)) {
				var theorder = datajson.orders[kdx];
				theorder.verificationToken = verificationToken;
				successOrders.push(theorder);
			}
		}
		return successOrders;
	},
	_persistOrphanedOrders: function(successOrders) {
		// add orders to existing list of persisted orders
		Storage.KeyValueCache.local.getItem(this._IAB_ORPHANED,
			(function(err, currorders){
				if (currorders && (currorders.length > 0)) {
					var orderlist = JSON.parse(currorders);
					for (var idx in orderlist) {
						successOrders.push(orderlist[idx]);
					}
				}
			    Storage.KeyValueCache.local.setItem(this._IAB_ORPHANED,
					JSON.stringify(successOrders), function(){
					NgLogD("Orphaned orders added to persistent store: " + JSON.stringify(successOrders));
			    });
			}).bind(this));
	},
	_initService: function() {
		this._initServiceSendGen();
	},

	_requestPurchase: function( sku, quantity ) {
		this._requestPurchaseSendGen(sku, quantity);
	},

	/*
	 * Given unfulfilled orders, calls back ordercb for each unfulfilled order.
	 * Resets persisted store using removeItem when done, then call
	 * _initService to continue init process.
	 */
	_restoreOrders: function(orders) {
		var self = this;
		if (orders.length <= 0) {
			// No more unfulfilled orders
			Storage.KeyValueCache.local.removeItem(this._IAB_ORPHANED,
			function() {
				self._initService();
			});
			return;
		}
		var order = orders.pop();
		var cb = function() {
			self._restoreOrders(orders);
		};
		// part of initService flow
		this._initOrdercb(order.productId.toUpperCase(), order.orderId, order.verificationToken, order, cb.bind(this));
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 348
	// Method create = -1
	// Method initService = 2
	// Method requestPurchase = 3
	// Method fillIABNoncePool = 4
	// Method getProductInformation = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in InAppPurchase._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in InAppPurchase._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[348] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":348,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_initServiceSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":348,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_requestPurchaseSendGen: function( sku, quantity )
	{
		Core.Proc.appendToCommandString( ":348,3," + this.__objectRegistryId + "," + Core.Base64.encode( sku ) + "," + quantity  );
	},
	
	/** @private */
	_fillIABNoncePoolSendGen: function( nonces )
	{
		Core.Proc.appendToCommandString( ":348,4," + this.__objectRegistryId + "," + Core.Base64.encode( nonces )  );
	},
	
	/** @private */
	_getProductInformationSendGen: function( productId )
	{
		Core.Proc.appendToCommandString( ":348,5," + this.__objectRegistryId + "," + Core.Base64.encode( productId )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// initService: function(  ) {}
	
	// requestPurchase: function( sku, quantity ) {}
	
	// fillIABNoncePool: function( nonces ) {}
	
	// getProductInformation: function( productId ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/IPCEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/IPCEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/IPCEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class IPCEmitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;
var Class          = require('NGCore/Client/Core/Class').Class;
var Proc           = require('NGCore/Client/Core/Proc').Proc;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Base64         = require('NGCore/Client/Core/Base64').Base64;
var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var DownloadFile   = require('NGCore/Client/Network/DownloadFile').DownloadFile;
var Util           = require('NGCore/Client/Network/Util').Util;
var FileSystem     = require('NGCore/Client/Storage/FileSystem').FileSystem;

////////////////////////////////////////////////////////////////////////////////

exports.IPCEmitter = MessageEmitter.singleton(
/** @lends Device.IPCEmitter.prototype */
{

	classname: 'IPCEmitter',

	/**
	 * @class The IPCEmitter class constructs a singleton object that handles Inter-Process Communication. 
	 * These objects emit events when a specified application is launched from within another application.
	 * @constructs The default constructor.
	 * @augments Core.MessageEmitter
	 */
	initialize: function()
	{
		console.log('IPCEmitter.initialize');
		this._callbackID = 0;
		this._callbacks = [];
		
		this._shouldEmitIntents = false;

		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/**
	 * Check whether the host OS can launch the provided URL asynchronously.
	 * @example var appToLaunch = 'mobage//auth?packageName=xxx.xxx&className=xxx.xxx';
	 * Device.IPCEmitter.canLaunch(appToLaunch, function(canLaunch) {
	 * 	if (canLaunch) {
	 * 		console.log('launching... ' + canLaunch);
	 * 		Device.IPCEmitter.launch(appToLaunch, function(error) {
	 * 			label.setText('failed in launching the URL:' + appToLaunch);
	 * 		});
	 * 	} else {
	 * 		label.setText('cannot launch the URL:' + appToLaunch);
	 * 	}
	 * });
	 * @param {String} url A URL to test
	 * @param {Function} callback A callback function that passes a Boolean value when a result is returned. 
	 * If the URL is OK to launch, the callback returns <code>true</code>.
	 * @status
	 */
	canLaunch: function(url, callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._canLaunchSendGen(url,this._callbackID);
		this._callbackID++;
	},

	/**
	 * Request that the host OS launch the provided URL.
	 * @example var appToLaunch = 'mobage//auth?packageName=xxx.xxx&className=xxx.xxx'
	 * Device.IPCEmitter.launch(appToLaunch, function(error) {
	 * 	label.setText('failed in  launching the URL:' + appToLaunch);
	 * });
	 * @param {String} url A URL to launch
	 * @param {Function} errCallback A callback function that passes an error object when an error occurs. 
	 * If the URL is successfully launched, no callback. Otherwise, the callback returns an error.
	 */
	launch: function(url, callback)
	{
		 this._callbacks[this._callbackID] = callback;
		 this._launchSendGen(url,this._callbackID);
		 this._callbackID++;
	},

	launchIntent: function( intent, extras )
	{
		this._launchIntentSendGen(intent,extras);
	},
	
	launchService: function( intent, extras, packageName )
	{
		//This function originally did not take a "packageName" parameter, it was part of the extrasObj.
		//The separate parameter is added to make it a bit more clear that it is necessary to pass in a packageName.
		//Not sure it's going to help though, because we're trying to preserve backwards compatibility here.
		if (typeof(packageName) == "string")
		{
			var extrasObj;
			if (typeof(extras) == "string")
			{
				extrasObj = JSON.parse(extras);
			}
			else
			{
				extrasObj = {};
			}
			extrasObj["packageName"] = packageName;
			extras = JSON.stringify(extrasObj);
		}
		this._launchServiceSendGen(intent,extras);
	},

	/**
	 * Launch a Single Sign-on URL.
	 * @example var appToLaunch = 'mobage//auth?packageName=xxx.xxx&className=xxx.xxx';
	 * Device.IPCEmitter.launchForSSO(appToLaunch, function(error) {
	 * 	label.setText('failed in  launching the URL:' + appToLaunch);
	 * });
	 * @param {String} url The URL to launch. The URL must include the following as part of the query string: packageName=xxxx&className=yyyy.
	 * @param {Function} callback The callback function. 
	 * @status
	 */
	launchForSSO: function(url, callback)
	{
		url += '&sso_auth';
		this.launch(url, callback);
	},

	/**
	 * Return an array of signatures for the packageName.
	 * @param {String} packageName packageName is like "com.ngmoco.gamejs"
	 * @param {Function} callback callback function signature: function(signatures) { }
	 * @status Android
	 */
	getAppSignatures: function(packageName, callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._getAppSignaturesSendGen(packageName,this._callbackID);
		this._callbackID++;
	},

	/**
	 * Return the package name that invokes this ngCore app.
	 * @param {Function} callback The current callback function. Below is the callback signature. 
	 * @example function(packageName) { }
	 * @status Android
	 */
	getCallingPackage: function(callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._getCallingPackageSendGen(this._callbackID);
		this._callbackID++;
	},
	
	/**
	 * Return whether the service .
	 * @param {Function} callback The current callback function. Below is the callback signature. 
	 * @example function(packageName) { }
	 * @status Android
	 */
	getIsServiceRunning: function(serviceEnum, callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._getIsServiceRunningSendGen(serviceEnum, this._callbackID);
		this._callbackID++;
	},


	app: function()
	{
		return this._app;
	},

	App: Class.subclass(
	/** @lends Device.IPCEmitter.App.prototype */
	{
		classname: 'App',

		/**
		 * @class Information about the app.
		 */
		initialize: function(sourceAppID, intentURL)
		{
			this._sourceAppID   = sourceAppID;
			this._intentURL     = intentURL;
		},

		/**
		 * information for checking if application has launched or resumed with custom URL scheme.
		 * @type String
		 */
		getID: function()
		{
			return this._sourceAppID;
		},

		/**
		 * Returns the URL used to launch this app, or an empty string if not launched via URL
		 * @type String
		 */
		getURL: function()
		{
			return this._intentURL;
		}
	}),

	Intent: Class.subclass(
	/** @lends Device.IPCEmitter.App.prototype */
	{
		classname: 'Intent',

		/**
		 * @class Information about the app.
		 */
		initialize: function(action, extras)
		{
			this._action   = action;
			this._extras   = extras;
		},

		/**
		 * information for checking if application has launched or resumed with custom URL scheme.
		 * @type String
		 */
		getAction: function()
		{
			return this._action;
		},

		/**
		 * Returns the URL used to launch this app, or an empty string if not launched via URL
		 * @type String
		 */
		getExtras: function()
		{
			return this._extras;
		}
	}),

	/**
	 * Create home screen shortcut icon.
	 * @param {String} name Displayed shortcut name
	 * @param {String} url Invoked url when icon clicked. 
	 * @param {String} icon_path Local file path that stores icon file.
	 * @status Android
	 */
	createShortcut: function( name, url, icon_path )
	{
		this._createShortcutSendGen(name, url, icon_path);
	},

	/**
	 * Create home screen shortcut icon with downloading its image.
	 * @param {String} name Displayed shortcut name.
	 * @param {String} url Invoked url when icon clicked. 
	 * @param {String} icon_url Icon image url.
	 * @param {Function} callback Callback function that passes a Boolean value whether download succeed. Below is the callback signature.
	 * @example function(hasDownloadError) { }
	 * @status Android
	 */
	createShortcutByIconUrl: function( name, url, icon_url, callback )
	{
                NgLogD("createShortcutByIconUrl called", name, url, icon_url);

                var df = new DownloadFile();
                var filename = 'shortcut_icon_image'+(new Date().getTime());
                var self = this;
                NgLogD("Icon download begin");
		Util.OperationWithRetries(function(failCb, abortCb) {
			df.start(filename, 'GET', icon_url, [], function( statusCode, fileSignature ) {
				NgLogD("Icon download finished status="+statusCode);
				if(statusCode == 200) {
					self.createShortcut( name, url, filename );
					FileSystem.deleteFile( filename, function() {
						if(callback)
							callback(false);
					});
				}
				else if(statusCode == 404)
				{
					NgLogE("Unable download icon file: icon_url="+icon_url+", status="+statusCode);
					abortCb();
				}
				else
				{
					NgLogE("Unable download icon file: icon_url="+icon_url+", status="+statusCode);
					failCb();
				}
			});
		},
		function() {
			NgLogE("Unable download icon file");
			if(callback)
				callback(true);
		}, 
		true);
	},

	// ------------------------------------------------------------------
	// private
	//

	/**
	 * invoked from native when the app is resumed back from other app.
	 */
	_onResumedFromOthers: function (url, sourceAppID)
	{
		this._app = new Device.IPCEmitter.App(sourceAppID, url);
		this.emit(this._app);

		//Cascade the original message back out to native for forwarding
		this._onResumeFromOthersSendGen(url, sourceAppID);
	},
	
	// Should only be called by privileged callers
	_setEmitIntents: function ( emit ) {
		this._shouldEmitIntents = Boolean(emit);
	},

	_onIntentReceived: function (action, extras)
	{
		console.log("On IntentReceived: " + action + " / " + JSON.stringify(extras));
		if (this._shouldEmitIntents) {
			this.emit( new exports.IPCEmitter.Intent(action, extras) );
		}
	},

	// private
	_canLaunchCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._canLaunchCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.canLaunch);
		}
	},

	_onResumeFromOthersRecv: function(cmd)
	{
		var msg = {};
		if (! this._onResumeFromOthersRecvGen(cmd, msg))
			return;

		this._onResumedFromOthers(msg.url, msg.sourceAppID);
	},

	_launchFailedRecv: function( cmd )
	{
		var msg = {};
		if (! this._launchFailedRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.canLaunch);
		}
	},

	_getAppSignaturesCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._getAppSignaturesCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.signatures.split(','));
		}
	},

	_getCallingPackageCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._getCallingPackageCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.packageName);
		}
	},
	
	
	_getIsServiceRunningCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._getIsServiceRunningCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.running);
		}
	},
	
	_onIntentReceivedRecv: function( cmd )
	{
		var msg = {};
		if (! this._onIntentReceivedRecvGen(cmd, msg))
			return;
		
		this._onIntentReceived( msg.action, JSON.parse(msg.extras, 10) );
	},

// {{?Wg Generated Code}}
	
	// Enums.
	/** 
			* Enumeration for services whose status may be queried.
			* @namespace
			 */
	Service:
	{ 
		/** * */
		SystemDownloadProvider: 1,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 349
	// Method create = -1
	// Method canLaunch = 2
	// Method launch = 3
	// Method onResumeFromOthers = 4
	// Method launchFailed = 5
	// Method canLaunchCallback = 6
	// Method getAppSignatures = 7
	// Method getAppSignaturesCallback = 8
	// Method getCallingPackage = 9
	// Method getCallingPackageCallback = 10
	// Method launchIntent = 11
	// Method launchService = 12
	// Method onIntentReceived = 13
	// Method getIsServiceRunning = 14
	// Method getIsServiceRunningCallback = 15
	// Method createShortcut = 16
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 4:
					instance._onResumeFromOthersRecv( cmd );
					break;
				case 5:
					instance._launchFailedRecv( cmd );
					break;
				case 6:
					instance._canLaunchCallbackRecv( cmd );
					break;
				case 8:
					instance._getAppSignaturesCallbackRecv( cmd );
					break;
				case 10:
					instance._getCallingPackageCallbackRecv( cmd );
					break;
				case 13:
					instance._onIntentReceivedRecv( cmd );
					break;
				case 15:
					instance._getIsServiceRunningCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in IPCEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in IPCEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[349] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onResumeFromOthersRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.onResumeFromOthers from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in IPCEmitter.onResumeFromOthers from command: " + cmd );
			return false;
		}
		
		obj[ "sourceAppID" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "sourceAppID" ] === undefined )
		{
			NgLogE("Could not parse sourceAppID in IPCEmitter.onResumeFromOthers from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_launchFailedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.launchFailed from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in IPCEmitter.launchFailed from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.launchFailed from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_canLaunchCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.canLaunchCallback from command: " + cmd );
			return false;
		}
		
		obj[ "canLaunch" ] = Core.Proc.parseBool( cmd[ 0 ] );
		if( obj[ "canLaunch" ] === undefined )
		{
			NgLogE("Could not parse canLaunch in IPCEmitter.canLaunchCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.canLaunchCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_getAppSignaturesCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.getAppSignaturesCallback from command: " + cmd );
			return false;
		}
		
		obj[ "signatures" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "signatures" ] === undefined )
		{
			NgLogE("Could not parse signatures in IPCEmitter.getAppSignaturesCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.getAppSignaturesCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_getCallingPackageCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.getCallingPackageCallback from command: " + cmd );
			return false;
		}
		
		obj[ "packageName" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "packageName" ] === undefined )
		{
			NgLogE("Could not parse packageName in IPCEmitter.getCallingPackageCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.getCallingPackageCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onIntentReceivedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.onIntentReceived from command: " + cmd );
			return false;
		}
		
		obj[ "action" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "action" ] === undefined )
		{
			NgLogE("Could not parse action in IPCEmitter.onIntentReceived from command: " + cmd );
			return false;
		}
		
		obj[ "extras" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "extras" ] === undefined )
		{
			NgLogE("Could not parse extras in IPCEmitter.onIntentReceived from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_getIsServiceRunningCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.getIsServiceRunningCallback from command: " + cmd );
			return false;
		}
		
		obj[ "running" ] = Core.Proc.parseBool( cmd[ 0 ] );
		if( obj[ "running" ] === undefined )
		{
			NgLogE("Could not parse running in IPCEmitter.getIsServiceRunningCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.getIsServiceRunningCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":349,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_canLaunchSendGen: function( url, callbackID )
	{
		Core.Proc.appendToCommandString( ":349,2," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + callbackID  );
	},
	
	/** @private */
	_launchSendGen: function( url, callbackID )
	{
		Core.Proc.appendToCommandString( ":349,3," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + callbackID  );
	},
	
	/** @private */
	_onResumeFromOthersSendGen: function( url, sourceAppID )
	{
		Core.Proc.appendToCommandString( ":349,4," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( sourceAppID )  );
	},
	
	/** @private */
	_getAppSignaturesSendGen: function( packageName, callbackID )
	{
		Core.Proc.appendToCommandString( ":349,7," + this.__objectRegistryId + "," + Core.Base64.encode( packageName ) + "," + callbackID  );
	},
	
	/** @private */
	_getCallingPackageSendGen: function( callbackID )
	{
		Core.Proc.appendToCommandString( ":349,9," + this.__objectRegistryId + "," + callbackID  );
	},
	
	/** @private */
	_launchIntentSendGen: function( intent, extras )
	{
		Core.Proc.appendToCommandString( ":349,11," + this.__objectRegistryId + "," + Core.Base64.encode( intent ) + "," + Core.Base64.encode( extras )  );
	},
	
	/** @private */
	_launchServiceSendGen: function( intent, extras )
	{
		Core.Proc.appendToCommandString( ":349,12," + this.__objectRegistryId + "," + Core.Base64.encode( intent ) + "," + Core.Base64.encode( extras )  );
	},
	
	/** @private */
	_getIsServiceRunningSendGen: function( serviceEnum, callbackID )
	{
		Core.Proc.appendToCommandString( ":349,14," + this.__objectRegistryId + "," + serviceEnum + "," + callbackID  );
	},
	
	/** @private */
	_createShortcutSendGen: function( name, url, icon_path )
	{
		Core.Proc.appendToCommandString( ":349,16," + this.__objectRegistryId + "," + Core.Base64.encode( name ) + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( icon_path )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// canLaunch: function( url, callbackID ) {}
	
	// launch: function( url, callbackID ) {}
	
	// _onResumeFromOthersRecv: function( cmd ) {}
	// onResumeFromOthers: function( url, sourceAppID ) {}
	
	// _launchFailedRecv: function( cmd ) {}
	// _canLaunchCallbackRecv: function( cmd ) {}
	// getAppSignatures: function( packageName, callbackID ) {}
	
	// _getAppSignaturesCallbackRecv: function( cmd ) {}
	// getCallingPackage: function( callbackID ) {}
	
	// _getCallingPackageCallbackRecv: function( cmd ) {}
	// launchIntent: function( intent, extras ) {}
	
	// launchService: function( intent, extras ) {}
	
	// _onIntentReceivedRecv: function( cmd ) {}
	// getIsServiceRunning: function( serviceEnum, callbackID ) {}
	
	// _getIsServiceRunningCallbackRecv: function( cmd ) {}
	// createShortcut: function( name, url, icon_path ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/LayoutEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/LayoutEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/LayoutEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class LayoutEmitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.LayoutEmitter = Core.MessageEmitter.singleton(
/** @lends Device.LayoutEmitter.prototype */
{
	classname: 'LayoutEmitter',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	_layoutChangedRecv: function( cmd ) 
	{
		var msg = {};
		if(!this._layoutChangedRecvGen(cmd, msg))
			return;

 		this._width = msg['width'];
 		this._height = msg['height'];
 		//NgLogD("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++JS received width as :"+ this._width + " and height as :" + this._height); 
		this.emit(msg);
		this._layoutChangedSendGen(msg.width, msg.height);
	},
	
	$getWidth: function()
	{
		return this._width;
	},
	
	$getHeight: function()
	{
		return this._height;
	},
	
	/**
	 * @private
	 */
	setWidthAndHeight: function(width, height) {
		//NgLogD("---------------------------------Setting width and height for LayoutEmitter directly from native ......... width is " + width + " and height is " + height );
		this._width = width;
		this._width = height;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 352
	// Method create = -1
	// Method layoutChanged = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._layoutChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LayoutEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LayoutEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[352] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_layoutChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in LayoutEmitter.layoutChanged from command: " + cmd );
			return false;
		}
		
		obj[ "width" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "width" ] === undefined )
		{
			NgLogE("Could not parse width in LayoutEmitter.layoutChanged from command: " + cmd );
			return false;
		}
		
		obj[ "height" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "height" ] === undefined )
		{
			NgLogE("Could not parse height in LayoutEmitter.layoutChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":352,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_layoutChangedSendGen: function( width, height )
	{
		Core.Proc.appendToCommandString( ":352,2," + this.__objectRegistryId + "," + width + "," + height  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _layoutChangedRecv: function( cmd ) {}
	// layoutChanged: function( width, height ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Appdata'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Appdata'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Appdata'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class 
 * @name Social.Common.Appdata
 * @description
 * Mobage provides a common API for application data, which you can use for both Japan and the US. 
 * <code>Appdata</code> is consistent with the Open Social <code>osapi.appdata</code> interface, 
 * and enables the application to store name/value pairs for arbitrary application data.
 * To add or update application data, call <code>updateEntries()</code>. To retrieve entries, call <code>getEntries()</code>. 
 * To delete entries, call <code>deleteEntries()</code>.
 * @see Social.US.AppData for additional Mobage persistence facilities.
 * @see Storage.KeyValue for additional ngCore persistence facilities.
 * @see Storage.FileSystem for additional ngCore persistence facilities.
 */
exports.Appdata = {
		
	/**
	 * Retrieves a hash of one or more key/value pairs.
	 * If the <code>keys</code> parameter is <code>null</code>, <code>undefined</code> or an empty array, <code>getEntries()</code> 
	 * returns all key/value pairs to the callback function.
	 *
	 * @name Social.Common.Appdata.getEntries
	 * @function
	 * @public
	 * 
	 * @param {Array} keys Set as an array of key names. For example, <code>['key1', 'key2']</code>.
	 * @param {Function} callback Retrieves a hash of key/value pairs. If an error occurs, retursn an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var entries = {"key1": "value1", "key2": "value2"};
     * ...
     * function(error, entries){
     * &nbsp;&nbsp;   if (error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;   } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var retrievedEntries = entries;
     * &nbsp;&nbsp;   }
	 * }
	 * </pre>
	 * @see Social.Common.Appdata.updateEntries
	 * @example 
	 * Appdata.getEntries(['key1', 'key2'], callback );
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	getEntries: function(keys, callback) {
		var cmd = {apiURL:"Common.Appdata.getEntries", keys:keys, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
	},
	
	/**
	 * Inserts or updates the submitted key/value pairs. 
	 * <b>Note:</b> Limited to 30 key/value pairs per user, per game. 
	 * Maximum key name limited to 32 bytes. Maximum value limited to 1,024 bytes.
     * To use key/value pairs without the foregoing constraints, use <code>Storage.KeyValue</code>
     * in ngCore.
	 *
	 * @name Social.Common.Appdata.updateEntries
	 * @function
	 * @public
	 * 
	 * @param {Hash} entries Takes a hash of key/value pairs. For example, <code>{"favoriteMovie": "Pulp Fiction", "petName": "Rover"}</code>.
	 * @param {Function} callback Retrieves the updated entries. If an error occurs, returns an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var entries = {"favoriteMovie": "Pulp Fiction", "petName": "Rover"};
     * ...
     * function(error, entries){
     * &nbsp;&nbsp;   if (error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;   } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var updatedEntries = entries;
     * &nbsp;&nbsp;   }
	 * }
	 * </pre>
	 * @see Social.Common.Appdata.getEntries
	 * @example
	 * Appdata.updateEntries(
	 *              {   'favoriteMovie':'Pulp Fiction',    
	 *                  'petName':'Rover' }, 
	 *              callback );
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     * @see Social.US.AppData for additional Mobage persistence facilities.
     * @see Storage.KeyValue for additional ngCore persistence facilities.
     * @see Storage.FileSystem for additional ngCore persistence facilities.
	 */		
	updateEntries: function(entries, callback) {
		if(entries) {
			var cmd = {apiURL:"Common.Appdata.updateEntries", entries:entries, callbackFunc:callback};
			GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
		} else {
			if(typeof callback === 'function') {
				callback({ 
						errorCode: 400,
						description: "Entries to update are a required parameter"
					}, null);
			}
		}
	},
	
	
	/**
	 * Deletes one or more key/value pairs.
	 *
	 * @name Social.Common.Appdata.deleteEntries
	 * @function
	 * @public
	 * 
	 * @param {Array} keys Takes an array of key names. For example, <code>['petName']</code>. 
     * If <code>null</code>, the return object in the callback is not defined.
	 * @param {Function} callback  Retrieves a hash of the deleted entries. If an error occurs, returns an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var keys = {"petName"};
     * ...
     * function(error, keys){
     * &nbsp;&nbsp;   if (error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;   } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var deletedKeys = keys;
     * &nbsp;&nbsp;   }
	 * }
	 * </pre>
	 * @example
	 * Appdata.deleteEntries(['petName'], callback );
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	deleteEntries: function(keys, callback) {
		if(keys && keys.length > 0) {
			var cmd = {apiURL:"Common.Appdata.deleteEntries", keys:keys, callbackFunc:callback};
			GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
		} else {
			if(typeof callback === 'function') {
				callback({ 
						errorCode: 400,
						description: "Keys to delete are a required parameter"
					}, null);
			}
		}
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Auth'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Auth'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Auth'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class
 * @name Social.Common.Auth
 * @description
 * Retrieves a verification code.
 * Games call <code>Auth.authorizeToken()</code> if the game server is using the Mobage REST API.
 * For more information, refer to the Mobage RESTful API Conventions section of the developer's guide.
 */
exports.Auth = {
		
		
	/**
	 * Authorizes a temporary credential and returns a verification code.
	 *
	 * 
	 * @name Social.Common.Auth.authorizeToken
	 * @function
	 * @public
	 *
	 * @param {String} token The temporary credential identifier. 
	 * @param {Function} callback The callback function that handles the verification code and errors.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 *  <pre class="code">
     *  var verifier = "jklmnop";
	 *  function(error, verifier){
     *  &nbsp;&nbsp; if (error){
	 *  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 *  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 *  &nbsp;&nbsp; } else {
     *  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var verificationCode = verifier;    
     *  &nbsp;&nbsp; }
     *  }
	 * </pre>
	 * @example
	 * var token = "abcdefghi";
     * ...
	 * Social.Common.Auth.authorizeToken (token, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	authorizeToken: function(token, callback) {
		var cmd = {apiURL:"Common.Auth.authorizeToken", token:token, callbackFunc: callback };
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
		//callback(error, verifier)
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Blacklist'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Blacklist'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Blacklist'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class 
 * @name Social.Common.Blacklist
 * @description
 * Provides an interface for checking the user's blacklist.
 */
exports.Blacklist = {

	/**
	 * Retrieves the target user ID from the specified user's blacklist.
	 * This call passes a user ID and a target user ID to determine if the specified target user is blacklisted. 
	 * If the target user ID parameter is <code>null</code>, this call retrieves the entire blacklist. The callback function also receives the total number of 
	 * target user IDs, the starting index, and the number of target IDs returned for paging the results.
	 *
	 * @name Social.Common.Blacklist.checkBlacklist
	 * @function
	 * @public
	 *
	 * @param {String} userId The user ID for the user who owns the blacklist. 
	 * @param {String} targetUserId The target user ID to check in the blacklist. <br/>If <code>null</code>, it checks the entire blacklist.
	 * @param {Hash} opt Takes a hash containing the start index and count for pagination. <br/>E.g., <code>{'start': 1, 'count': 100}</code> 
     * Requires start index and count. The minimum start index is 1. 
     * If <code>null</code>, undefined or an empty array, the start index is 1 and the count is 50.
	 * @param {Function} callback Retrieves an array of user IDs found in the blacklist. Otherwise, it retrieves an empty array.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var listedUsers = ['user1', 'user2'];
     * ...
     * function(error, listedUsers, result)
	 * &nbsp;&nbsp;		{
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var blackListedUsers = listedUsers;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var total = result.total;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var start = result.start;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var count = result.count;
  	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var errorCode = error.errorCode;
  	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var errorDesc = error.description;
  	 * &nbsp;&nbsp;	}
  	 * </pre>
  	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */			
	checkBlacklist: function(userId, targetUserId, opt, callback) {
		var cmd = {apiURL:"Common.Blacklist.checkBlacklist", userId:userId, targetUserId:targetUserId, opt:opt, callbackFunc: function(error, args) {
			callback(error, args.users, args.result);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Config'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Config'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Config'] = exports; var Session = require('NGCore/Client/Social/US/Data/Session').Session;

/**
 * @class 
 * @name Social.Common.Config
 * @description
 * Mobage provides a common API to determine if the server is a sandbox server or a production server. 
 */
exports.Config = {

    /**
    * Returns whether the server is a sandbox server or a production server. 
    * Returns "unknown" if it cannot retrieve the current session
    * or if the server mode is not "sandbox" or "production."
    * 
    * @name Social.Common.Config.getServerEnvironment
    * @public
    * @function
    * @returns {String} "sandbox," "production" or "unknown."
    * @see Social.US.Session.serverModes
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
	getServerEnvironment: function(){
		var session = Session.getCurrentSession();
		if(!session){
			return "unknown";
		}
		
		var serverMode = Session.getCurrentSession().serverMode();
		if(serverMode == Session.serverModes.production){
			return "production";
		}else if(serverMode == Session.serverModes.sandbox){
			return "sandbox";
		}else{
			return "unknown";
		}
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/People'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/People'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/People'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class 
 * @name Social.Common.People
 * @description
 * The social API for returning user objects with their social graphs. The user object
 * retrieved varies from platform to platform. US platform required fields are <code>id</code>, <code>displayName</code>, <code>hasApp</code> 
 * and <code>thumbnailUrl</code> of the <code>Person</code> data type.
 */
exports.People = {
	
	/**
	 * Retrieves fields for the specified user from the <code>Person</code> data type. The specified user corresponds to the user ID parameter.
	 * Below are the fields returned by this call:
	 * <ul>
	 * <li><code>id</code></li>
	 * <li><code>displayName</code></li>
	 * <li><code>hasApp</code></li>
	 * <li><code>thumbnailUrl</code></li>
	 * </ul>
	 * Use the <code>fields</code> parameter to retrieve non-required fields of the <code>Person</code> data type.
	 *
	 * @name Social.Common.People.getUser
	 * @function 
	 * @public 
	 *
	 * @param {String} userId The user ID of the user to retrieve.
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the response to the callback. 
     * <br/>For example, <code>['nickname','aboutMe']</code>. If <code>null</code>, <code>undefined</code> or an empty array, this call only retrieves the required fields.
	 * @param {Function} callback Retrieves the user specified by the <code>userId</code> parameter. If an error occurs, returns an error code and error description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, user){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedUser = user;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getCurrentUser
	 * @example
	 * var recordID = 2;
	 *
	 * Social.Common.People.getUser(recordID, 
	 *                              ['id','nickname','aboutMe'], 
	 *                              callback
	 *		});
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */						
	getUser: function(userId, fields, callback) {
		var cmd = {apiURL:"Common.People.getUser", userId:userId, fields:fields, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Retrieves an array of users.
	 * Takes one or more user IDs and retrieves an array of users with the callback. 
	 * Retrieves up to 100 users, with no guarantee of retrieving the user array 
	 * in the order specified.
	 * Retrieves the <code>id</code>, <code>displayName</code>, <code>hasApp</code> 
	 * and <code>thumbnailUrl</code> fields of the <code>Person</code> data type for each user.
	 * To retrieve non-required fields of the <code>Person</code> data type, specify the non-required fields 
	 * desired in the <code>fields</code> parameter.
	 *	 
	 * @name Social.Common.People.getUsers
	 * @function 
	 * @public
	 * 
	 * @param {Array} userIds An array of user IDs of the users to retrieve. Minimum array size is 1, and maximum is 100.
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the callback. <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/>If <code>null</code>, <code>undefined</code> or an empty array, it retrieves only the required fields.
	 * @param {Function} callback Retrieves an array of users specified by the <code>userIds</code> parameter and/or an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, users){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedUsers = users;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getUser
	 * @example
	 * People.getUsers([1,2,3],null, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */				
	getUsers: function(userIds, fields, callback) {
		var cmd = {apiURL:"Common.People.getUsers", userIds:userIds, fields:fields, callbackFunc:function(errors, args) {
			callback(errors, args.users, args.results);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	
	/**
	 * Retrieves fields for the current user from the <code>Person</code> data type. Below are the fields returned by this call:
	 * <ul>
	 * <li><code>id</code></code>
	 * <li><code>displayName</code></li>
	 * <li><code>hasApp</code></li>
	 * <li><code>thumbnailUrl</code></li>
	 * </ul>
	 *
	 * @name Social.Common.People.getCurrentUser
	 * @function
	 * @public
	 *
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the callback. <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/>If <code>null</code>, <code>undefined</code> or an empty array, this call only retrieves the required fields.
	 * @param {Function} callback Retrieves the current user. If an error occurs, returns an error code and error description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, user){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var currentUser = user;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getUser
	 * @example
	 * People.getCurrentUser(null, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */				
	getCurrentUser: function(fields, callback) {
		var cmd = {apiURL:"Common.People.getCurrentUser", fields:fields, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	
	/**
	 * Retrieves fields for friends of a specified user. Below are the fields returned by this call:
	 * <ul>
	 * <li><code>id</code></li>
	 * <li><code>displayName</code></li>
	 * <li><code>hasApp</code></li> 
	 * <li><code>thumbnailUrl</code></li>
	 * </ul>
	 *
	 * @name Social.Common.People.getFriends
	 * @function
	 * @public
	 * 
	 * @param {String} userId The user ID of the user whose friends are retrieved by the callback function. 
	 * @param {Array} [fields] An array of non-required fields of the <code>Person</code> data type to include in the response to the callback. 
     * <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/> If <code>null</code>, <code>undefined</code> or an empty array, this call only retrieves the required fields.
	 * @param {Hash} [opt] A hash containing the start index and count for pagination. <br/>For example, <code>{'start': 1, 'count': 100}</code> 
	 * @param {Function} callback Retrieves the friends of the given user. If an error occurs, returns an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, friends){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedFriends = friends;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getFriendsWithGame
	 * @example
	 * People.getFriends(4, null, {'start': 2}, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */					
	getFriends: function(userId, fields, opt, callback) {
		var cmd = {apiURL:"Common.People.getFriends", userId:userId, fields:fields, opt:opt, callbackFunc: function(errors, args) {
			callback(errors, args.users, args.results);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	
	/**
	 * Retrieves a list of the user's friends playing the current game.
	 *
	 * @name Social.Common.People.getFriendsWithGame
	 * @function
	 * @public
	 *
	 * @param {String} userId The user ID of the person whose friends play the current game.
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the response to the callback. 
     * <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/> If <code>null</code>, <code>undefined</code> or an empty array, this call retrieves only the required fields.
	 * @param {Hash} opt A hash containing the start index and count for pagination. <br/>For example, <code>{'start': 1, 'count': 100}</code> 
	 * @param {Function} callback Retrieves the friends of the specified user. If an error occurs, returns an error code and error description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, friends){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedFriends = friends;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getFriends
	 * @example 
	 * People.getFriendsWithGame(4, null, null, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */						
	getFriendsWithGame: function(userId, fields, opt, callback) {
		var cmd = {apiURL:"Common.People.getFriendsWithGame", userId:userId, fields:fields, opt:opt, callbackFunc: function(errors, args) {
			callback(errors, args.users, args.results);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
	
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Profanity'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Profanity'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Profanity'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');	

/**
 * @class 
 * @name Social.Common.Profanity
 * @description
 * Provides an interface to check games for profanity.
 */
exports.Profanity = {
	
	/**
	 * Checks a text string to determine if it contains profanity.
	 * This call only conducts a check and does not attempt to cleanup the string.<br><br>
	 * <b>Note:</b> The server handles locale and language automatically.
	 *
	 * @name Social.Common.Profanity.checkProfanity
	 * @function
	 * @public
	 * 
	 * @param {String} text The string to check for profanity.
	 * @param {Function} callback Retrieves any profane words or phrases in the text parameter. 
     * The result of checking is either <code>true</code> or <code>false</code>. If the result is <code>false</code>, the text string contains profanity. 
     	 * If an error occurs, returns an error code and error description to the callback.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class='code'>function(error, args){
     * &nbsp;&nbsp; if(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;} else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var profanity = args.profanity;
     * &nbsp;&nbsp;}
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	checkProfanity: function(text, callback) {
		var cmd = {apiURL:"Common.Profanity.checkProfanity", text:text, callbackFunc:function(error, args) {
			callback(error, args.profanity);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
	}	
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Request'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Request'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Request'] = exports; var Class = require('NGCore/Client/Core/Class').Class;


//Don't need to document
exports.Request = Class.subclass({
	execute: function(callback) {
		// [call US function here]	
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Service'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Service'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Service'] = exports; var UI = require('NGCore/Client/UI').UI;

var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

var ButtonOverlays = require('NGCore/Client/Social/US/Service/ButtonOverlays').ButtonOverlays;
var Friends = require('NGCore/Client/Social/US/Service/Friends').Friends;
var Profile = require('NGCore/Client/Social/US/Service/Profile').Profile;
var User    = require('NGCore/Client/Social/US/Models/User').User;

/**
 * @class 
 * @name Social.Common.Service
 * @description
 * This interface provides the following social game services: <br/>
 * <div class="ul">
 * <li>Balance Button</li>
 * <li>Community Button</li>
 * <li>Friend Picker</li>
 * <li>User Finder</li>
 * <li>User Profile</li>
 * </div>
 */
exports.Service = {

	
	/**
	* Opens the user finder screen.
	* The user finder provides a way for users to find other users using the following filters:
	* <ul>
	* <li>Suggested Friends</li>
	* <li>Contacts</li> 
	* <li>Requests</li>
	* <li>Search</li>
	* </ul>
	*
	* @name Social.Common.Service.openUserFinder 
	* @function
	* @public
	* @status iOS, Android, Test, iOSTested, AndroidTested
    */		
	openUserFinder: function() {
		Friends.showFindFriends(undefined);
	},

	
	/**
	* Opens the friend picker.
	*
	* @name Social.Common.Service.openFriendPicker 
	* @function
	* @public 
	* 
	* @param {Number} maxFriendsToSelect The maximum number of friends the user may select.
	* @param {Function} callback The callback function called after the view closes. Returns an array of friends.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, friendUserIds){
	* 	&nbsp;&nbsp;&nbsp;if (error){
	* 	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  		var errorCode = error.errorCode;
	*   &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  		var errorDesc = error.description;
	* 	&nbsp;&nbsp;&nbsp;} else {
	*   &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  		var pickedFriends = friendUserIds;
	*   &nbsp;&nbsp;&nbsp;  	}
	*   &nbsp;&nbsp;  }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	openFriendPicker: function(maxFriendsToSelect, callback) {
		Friends.showFriendPicker(maxFriendsToSelect, function(err, friends){
			var userIDs = [];
			friends = friends || [];
			for(var idx = 0; idx < friends.length; idx++){
				userIDs.push(friends[idx].recordID);
			}
			callback( userIDs );
		});
	},

	
	/**
	* Opens the specified profile page.
	*
	* @name Social.Common.Service.openUserProfile 
	* @function
	* @public 
	* 
	* @param {String} userId The user ID or gamer name of the profile page to open.
	* @param {Function} callback The callback function if there is an error with the user ID or gamer name.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	openUserProfile: function(userId, callback) {
		if(typeof userId == "string"){
			// if the userId string contains no non-numeral characters:
			//   parse it into a number
			// else null it out, because it's not a valid userId
			if(userId.match(/[^0-9]/) === null){
				userId = parseInt(userId, 10);
			}else{
				userId = null;
			}
		}
		
		if( !userId ){
			callback({errorCode: 400, description: "userid is invalid"});
		}
		else{
			User.getUserWithID(userId, function(err, user){
				if(err){
					if( err==="Sorry, we can't find anyone with that name." ){
						callback({errorCode: 404, description: err});
					} else {
						callback({errorCode: 500, description: err});
					}
				}else if(!user){
					callback({errorCode: 404, description: "User not found"});
				}else{
					Profile.showUserProfile(user, undefined);
				}
			});
	}
	},


	/**
	* Displays the <b>Mobage Community</b> button.
	*	
	* @name Social.Common.Service.showCommunityButton
	* @function
	* @public 
	* 
	* @param {exports.Gravity} gravity Displays the button in the specified corner. 
    * <b>Note:</b> Only supported for the US. Japan uses the top-left corner only.
	* @param {String} theme Displays the theme for the button (for example, "default", "dark", "light"). 
    * <b>Note:</b> Only supported for Japan. You can specify <code>null</code> for the US region.
	* @param {Function} callback The callback function if there is an error related
    * to <code>gravity</code> or <code>theme</code> usage.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @see exports.Gravity
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/           
	showCommunityButton: function(gravity, theme, callback) {
		ButtonOverlays.showCommunityButton(gravity, callback);
	},

	/**
	* Hides the <b>Mobage Community</b> button.
	*
	* @name Social.Common.Service.hideCommunityButton
	* @function
	* @public 
	*	
	* @param {Function} callback The callback function if there is an error hiding the button.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/		
	hideCommunityButton: function(callback) {
		ButtonOverlays.hideCommunityButton(callback);
	},

	
	/**
	* A message emitter object for adding a message emitter when inviting a user.
	*
	* @name Social.Common.Service.invitedUserEmitter
	* @field
	* @public
	* @example 
	* Social.Common.Service. ...
	* ... invitedUserEmitter.addListener(
	*			new Core.MessageListener(), 
	*			function(userId){
	*				NgLogD("New Emitter! " + userId);
	*			}
	*		);
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	invitedUserEmitter : new MessageEmitter(),

	
	/**
	 * Shows the balance button where the <code>rect</code> parameter 
	 * determines the size and position of the button.
     * The minimum size of the button is:<br/>
     * <ul>
     * <li>10% of height in Landscape, and the absolute minimum size is 150 x 50.</li>
     * <li>6% of height in Portrait, and the absolute minimum size is 150 x 50.</li>
     	 * </ul>
	 *
	 * @name Social.Common.Service.showBalanceButton
	 * @function
	 * @public
	 *	 
	 * @param {UI.ViewGeometry.Rect} rect Determines the size and position of the balance button.
	 * @param {Function} callback The callback function if there is an error with the <code>rect</code> parameter.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
	 * </pre>
	 * @see UI.ViewGeometry.Rect
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	showBalanceButton: function(rect, callback) {		
		ButtonOverlays.showBalanceButton(rect, callback);
	},
	
	/**
	 * Hides the balance button.	
	 * @name Social.Common.Service.hideBalanceButton
	 * @function
	 * @public 
	 * 
	 * @param {Function} callback The callback function called after the view closes.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
     * </pre>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	hideBalanceButton: function(callback) {
		ButtonOverlays.hideBalanceButton(callback);
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Analytics'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Analytics'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Analytics'] = exports; var SessionReq = require('NGCore/Client/Social/US/Data/Session');

/**
 * @private
 * @name Social.Common.Analytics
 * @description Private interface for analytics data
 *
 * TODO: These should be going into the priv interpreter. But need to check with Japan.
 */
exports.Analytics = {
  getUserId: function() {
	var cur_sess =	this._getSession(), cur_u = null;
	if (cur_sess) {
	  cur_u = (cur_sess.user() || {}).recordID;
	}
	return cur_u;
  },
  getUsername: function() {
	var cur_sess =	this._getSession(), cur_u = null;
	if (cur_sess) {
	  cur_u = (cur_sess.user() || {}).gamertag;
	}
	return cur_u;
  },
  getPlatformVersion: function() {
	var cur_sess =	this._getSession(), cur_pver = null;
	if (cur_sess) {
	  cur_pver = cur_sess.platformVersion();
	}
	return cur_pver;
  },
  getServiceId: function() { 
	return "US"; 
  },
  _getSession: function() {
	return SessionReq.Session.getCurrentSession();
  }
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/DataModel'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/DataModel'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/DataModel'] = exports; var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var SocialR = require('NGCore/Client/Social');
var SessionR        = require('NGCore/Client/Social/US/Data/Session');
var DispatcherR     = require('NGCore/Client/Social/US/Data/Dispatcher');

/**
 * <code>DataModel</code> constructs objects that emit messages when properties of an object change, and provides automatic caching,
 * serialization and deserialization between interpreters. 
 * <br/><br/>
 * <b>Note:</b> Do not instantiate this class directly. Use classes derived from <code>DataModel</code> for instantiation. These include:
 * <div class="ul">
 * <li>{@link Social.US.User}</li>
 * <li>{@link Social.US.AppData}</li>
 * <li>{@link Social.US.Game}</li>
 * <li>{@link Social.US.Score}</li>
 * <li>{@link Social.US.Leaderboard}</li>
 * </div>
 * @class 
 * @name Social.US.DataModel
 */
var DataModel = exports.DataModel = MessageEmitter.subclass({
		
	/**
	 * The default constructor.
	 * @constructs
	 * @private
	 */		
	initialize: function(recordID){
		this.recordID = recordID;

		this._cache();
	},
	beginChanges: function(){
		DispatcherR.Dispatcher.beginBatching();
	},
	endChanges: function(){
		DispatcherR.Dispatcher.endBatching();
	},
	_classname: function(){
		var classname = this.classname;
		return classname;
	},
	_cache: function(){
		if(!this._dataCache){
			var session = SessionR.Session.getCurrentSession();
			if(session){
				var cache = session.dataCache();
				if(cache){
					cache.addObject(this);
					this._dataCache = cache;
				}
			}
		}
		return this._dataCache;
	},
	$_serializedDataModel: function(obj){
		if(obj instanceof(DataModel)){
			obj = {
				classname: obj.classname,
				recordID:  obj.recordID
			};
		}
		return obj;
	},
	$_deserializedDataModel: function(value, cache){
		if(value && value.hasOwnProperty && value.hasOwnProperty("classname") && value.hasOwnProperty("recordID")){
			var theClassname = value.classname;
			var theClass = SocialR.Social.US[theClassname];
			var theRecordID = value.recordID;
			if(theClass && theRecordID){
				var theInstance = cache.getObjectWithRecordID(theClassname, theRecordID);
				if(!theInstance){
					theInstance = new theClass(theRecordID);
				}
				
				theInstance._deserializeFromHash(value.data);
				cache.addObject(theInstance);
    
				value = theInstance;
			}
		}
		return value;
	},
	_serializedHash: function(full){
		var theClass = this.constructor;
		var hash = {classname: theClass.classname, recordID: this.recordID};
		if(full === false){
			return hash; // if it's undefined, assume we want all the data
		}
		
		hash.data = {};
		
		var properties = this.constructor.properties || [];
		for(var idx = 0; idx < properties.length; idx++){
			var propertyName = properties[idx];
			var propertyValue = this[propertyName];

			if(propertyValue instanceof(Array)){
				for(var propertyIndex = 0; propertyIndex < propertyValue.length; propertyIndex++){
					propertyValue[propertyIndex] = DataModel._serializedDataModel(propertyValue[propertyIndex]);
				}
			}else{
				propertyValue = DataModel._serializedDataModel(propertyValue);
			}
			
			hash.data[propertyName] = propertyValue;
		}
		
		return hash;
	},
	_deserializeFromHash: function(data){
		if(!data){
			NgLogD("No public hash data for " + this.classname + " " + this.recordID);
			return;
		}
		
		var cache = this._cache();
		for(var key in data){
			var value = data[key];
			if(value instanceof(Array)){
				for(var propertyIndex = 0; propertyIndex < value.length; propertyIndex++){
					value[propertyIndex] = DataModel._deserializedDataModel(value[propertyIndex], cache);
				}
			}else{
				value = DataModel._deserializedDataModel(value, cache);
			}
			this[key] = value;
		}
	}
});

DataModel._oldSubclass = DataModel.subclass;
DataModel.subclass = function(contents){
	var theClass = DataModel._oldSubclass(contents);
	var properties = contents.properties || [];
	for(var idx = 0; idx < properties.length; idx++){
		var propertyName = properties[idx];
		
		(function(name){
			theClass.prototype.__defineSetter__(name, function(value){
				this["___" + name] = value;
				
				var msg = {};
				msg[""+name] = value;
				
				this.emit(msg);
			});
			theClass.prototype.__defineGetter__(name, function(value){
				return this["___" + name];
			});
		})(propertyName);
	}
	return theClass;
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/User'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/User'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/User'] = exports; var DataModelR  = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher  = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;
var OrderedList = require('NGCore/Client/Social/US/Models/OrderedList').OrderedList;
var Social      = require('NGCore/Client/Social').Social;

/**
* <code>User</code> constructs objects that provide a service interface for the current user. 
* <code>User</code> objects enable the current user to retrieve:
* <div class="ul">
* <li>user details</li>
* <li>a list of friends</li>
* <li>games</li>
* </div>
* @class
* @name Social.US.User
* @augments Social.US.DataModel
*/
var User = exports.User = DataModelR.DataModel.subclass({
		
    /**
    * @constructs
    * @ignore
    */
	classname: "User",

	 /**
	 * The user's gamer tag. Read-only.
	 * @name Social.US.User.gamertag
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The user's avatar ID. Read-only.
	 * @name Social.US.User.avatarId
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's motto. Read-only.
	 * @name Social.US.User.motto
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The relation to this user. Read-only.
	 * @name Social.US.User.relation
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Sparse limits attributes in search results. Read-only.
	 * @name Social.US.User.sparse
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The user's photo ID. Read-only.
	 * @name Social.US.User.photoId
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's email address. Read-only.
	 * @name Social.US.User.emailAddress
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A hash of the user's email address. Read-only.
	 * @name Social.US.User.emailHash
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The user's phone number. Read-only.
	 * @name Social.US.User.phoneNumber
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */


	 /**
	 * The user's password. Read-only.
	 * @name Social.US.User.password
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The user's first name. Read-only.
	 * @name Social.US.User.firstName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */


	 /**
	 * The user's last name. Read-only.
	 * @name Social.US.User.lastName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * Whether to hide the user's full name. Read-only.
	 * @name Social.US.User.hideFullName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * Whether the user is age restricted. Read-only.
	 * @name Social.US.User.ageRestricted
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Whether the relationship to the user is new. Read-only.
	 * @name Social.US.User.isNewRelationship
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Whether the user is a mutual friend. Read-only.
	 * @name Social.US.User.isMutualFriend
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Whether the user shows his/her presence. Read-only.
	 * @name Social.US.User.showsPresence
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * Whether the user only shows friend notifications. Read-only.
	 * @name Social.US.User.setOnlyShowFriendNotifications
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	 

	 /**
	 * The user's capabilities. Read-only.
	 * @name Social.US.User.capabilities
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's gamer score. Read-only.
	 * @name Social.US.User.gamerscore
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	 

	 /**
	 * The user's gamer level. Read-only.
	 * @name Social.US.User.gamerLevel
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	 

	 /**
	 * The user's gamer level name. Read-only.
	 * @name Social.US.User.gamerLevelName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The gamer level score. Read-only.
	 * @name Social.US.User.gamerLevelScore
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The gamer score for the next level. Read-only.
	 * @name Social.US.User.gamerNextLevelScore
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's games. Read-only.
	 * @name Social.US.User.games
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	properties: [
		// public
		"gamertag",
		"avatarId",
		"motto",
		"relation",
		"sparse",
		"photoId",
		"emailHash",
		"ageRestricted",
		"isMutualFriend",
		
		// private
		"phoneNumber",
		"password",
		"firstName",
		"lastName",
		"hideFullName",
		"emailAddress",
		"isNewRelationship",
		"showsPresence",
		"onlyShowFriendNotifications",
		"capabilities",
		"gamerscore",
		"gamerLevel",
		"gamerLevelName",
		"gamerLevelScore",
		"gamerNextLevelScore",
		"games"
	],
	
	/**
	 * @constructs The default constructor constructs <code>User</code> objects.
	 * @name Social.US.User.initialize 
	 * @private
	 */
	initialize: function($super, recordID){
		$super(recordID);
		NgLogD("User Public! " + recordID + " " + this.recordID);
	},
	
	
	/**
	* Adds a user to the buddies list and ensures the added user is not on the blocked users list.
	* @name Social.US.User.addBuddy
	* @function
	* @private
	*
	* @param {Social.US.User} buddy The user to add to the buddies list. If not a user, the callback error is "No user."
	* @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var buddyData = data;
    * &nbsp;&nbsp;  }
	* }
	* </pre>	
	*/	
	addBuddy: function(buddy, cb){
		Dispatcher.callMethodOnRemoteObject(this, "addBuddy", [buddy, cb]);
	},
	
	
	/**
	* Removes a user from the buddies list.
	* @name Social.US.User.removeBuddy
	* @function
	* @private
	*
	* @param {User} buddy The user to remove from the buddies list. If not a user, the callback error is "No user."
	* @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var buddyData = data;
    * &nbsp;&nbsp;  }
	* }
	* </pre>
	*/		
	removeBuddy: function(buddy, cb){
		Dispatcher.callMethodOnRemoteObject(this, "deleteBuddy", [buddy, cb]);
	},
	
	
	/**
	* Retrieves a user object with all of the this user's details.
	*
	* @name Social.US.User.getUserDetails
	* @function
	* @public
	* 
	* @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, user){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var userWithDetails = user;
    * &nbsp;&nbsp;  }
	* }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/			
	getUserDetails: function(cb){
		Dispatcher.callMethodOnRemoteObject(this, "getUserDetails", [cb]);		
	},
	
	/**
	* Retrieves an ordered list of the user's friend requests on Mobage.
	* @name Social.US.User.getMobageFriendRequestLists
	* @function
	* @public
	*
	* @return {Social.US.OrderedList} A list of the user's friend requests.
    * @example
    * var myMobageFriendRequests = userA.getMobageFriendRequestsList();
    * @see Social.US.OrderedList for more information on iterating over the Mobage Friend Requests list.
	*/			
	getMobageFriendRequestsList: function(){
		return OrderedList.getObjectPublicInterface(this, "getInvitesList", "_followersListInterface");
	},
	
	/**
	* Returns the user's friends list on Mobage.
	* @name Social.US.User.getMobageFriendsList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The user's friend list on Mobage.
    * @example
    * var myMobageFriendsList = userA.getMobageFriendsList();
    * @see Social.US.OrderedList for more information on iterating over the Mobage friends list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	getMobageFriendsList: function(){
		return OrderedList.getObjectPublicInterface(this, "getFriendsList", "_friendsListInterface");
	},
	
	/**
	* Returns the user's blocked user list.
	* @name Social.US.User.getMobageBlockedUserList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The user's blocked user list on Mobage.
	* @see Social.US.OrderedList
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	getMobageBlockedUserList: function(){
		return OrderedList.getObjectPublicInterface(this, "getBlockedUserList", "_enemyListInterface");
	},
	
	/**
	* Returns the user's games list.
	* @name Social.US.User.getOwnedGamesList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The user's Mobage game list.
    * @example
    * var myGamesList = userA.getOwnedGamesList();
    * @see Social.US.OrderedList for more information on iterating over the games list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
	*/			
	getOwnedGamesList: function(){
		return OrderedList.getObjectPublicInterface(this, "getOwnedGamesList", "_ownedGamesListInterface");
	},
	
	/**
	* Returns the list of "featured" users.
	* @name Social.US.User.getFeaturedUsersList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The list of "featured" users.
    * @example
    * var mobageFeaturedUsers = userA.getFeaturedUsersList();
    * @see Social.US.OrderedList for more information on iterating over the Mobage Featured Users list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
	*/	
	getFeaturedUsersList: function(){
		return OrderedList.getObjectPublicInterface(this, "getFeaturedUsersList", "_featuredUsersListInterface");
	},

	/**
	* Invites the user to the current game.
	* @name Social.US.User.inviteToCurrentGame
	* @public
	* @function
	* 
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	inviteToCurrentGame: function(cb){
		var user = this;
		Dispatcher.callMethodOnRemoteObject(this, "inviteToCurrentGame", [function(err){
			if(!err){
				Social.Common.Service.invitedUserEmitter.emit({userId: user.recordID});
				Social.US.Service.Friends.invitedUserEmitter.emit({user: user});
			}
			cb.apply(this, Array.apply(null, arguments));
		}]);		
	},
	
	/**
	 * Send a Push notification to this user through the GameService back end.
	 * @name Social.US.User.sendNotificationToUser
	 * @public
	 * @function
	 *
	 * @param {Alert Text} alertText The displayed message when the push is received.
	 * @param {Badge ID} badgeId Badge displayed on the push.
	 * @param {Sound} sound Sound played when push is received.
	 * @param {Extra Data} extraData Additional payload.
	 *
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	sendNotificationToUser: function(alertText, badgeId, sound, extraData) {
		Dispatcher.callMethodOnRemoteObject(this, "sendNotificationToUser", [alertText, badgeId, sound, extraData]);
	},

    /**
    * Adds a user to the current user's friend list for the current game. Implies a one-directional relationship or "follower" model.
    * Takes an optional group parameter to add the user to a particular group. Current user can only 
    * add the user to one group. If the current user adds the user to a second group in the friend list, 
    * the user is moved from the first group.
    *
    * A group is an arbitrary classification of friends. The <code>group</code> parameter is a string, which 
    * takes the name of the group. You may allow users to manage their own groups, create game-level groups, 
    * or omit groups altogether. A user may only reside in one group of another user's friend list.<br><br>
    * <b>Note:</b> This is part of the Game Graph API. 
    *
    * @example
    * //Retrieve a user and set up a follower relationship.
    * var userA = Social.US.User; 
    * Social.US.User.getUserWithGamertag("chuck", function(error, user){
    *   if(!user) {
    *       var errorCode = error.errorCode;
    *       var errorDesc = error.description;
    *   } else {
    *        userA = user;
    *   }
    * });
    * var userB = Social.US.Session.getCurrentSession().user();
    * userB.addFriend(userA, callback);
    * //...
    * @example
    * //To make the relationship bi-directional, 
    * //you must make the same call for the other user.
    * userA.addFriend(userB, callback);
    *
    * @name Social.US.User.addFriend
    * @public
    * @function
    *
    * @param user The user to add to the current user's friend list. If <code>null</code>, <code>undefined</code> or not a 
    * <code>Social.US.User</code> object, the callback error is "No user."
    * @param {String} [group] An optional parameter for adding the friend into a group within the friend list.
    * @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var appData = data;
    * &nbsp;&nbsp;  }
	* } </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
    */	
	addFriend: function(user, group, cb){
		if(typeof arguments[1] == "function" && !arguments[2]){
			cb = arguments[1];
			group = undefined;
		}
		Dispatcher.callMethodOnRemoteObject(this, "addGameFriend", [user, group, cb]);
	},

    /**
    * Removes a user from the current user's friend list for the current game.<br><br>
    * Does not require a group parameter, friends are only associated to one group in a friend list.
    * @name Social.US.User.removeFriend
    * @public
    * @function
    *
    * @param {Social.US.User} user The user to remove from the current user's friend list. If <code>null</code>, <code>undefined</code> or not a 
    * <code>Social.US.User</code> object, the callback error is "No user."
    * @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var appData = data;
    * &nbsp;&nbsp;  }
	* } </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
    */		
	removeFriend: function(user, cb){
		Dispatcher.callMethodOnRemoteObject(this, "removeGameFriend", [user, cb]);
	},
	
	report: function(reason, cb){
		Dispatcher.callMethodOnRemoteObject(this, "report", [reason, cb]);
	},

    /**
    * Returns the user's friend list for the current game. If you specify the <code>group</code>
    * parameter, this call only returns friends within the group.<br><br>
    * <b>Note:</b> This is part of the Game Graph API.
    * @name Social.US.User.getFriendsList
    * @public
    * @function
    *
    * @param {String} group If specified, returns only friends in the group.
    * @return {Social.US.OrderedList} The user's friend list for the current game.
    * @example
    * var myFriendsList = userA.getFriendsList ("Best Buddies");
    * @see Social.US.OrderedList for more information on iterating over the friends list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */	
	getFriendsList: function(group){
		return OrderedList.getObjectPublicInterface(this, "getGameFriendsList", (group ? ("_gameFriendsList-friends-" + group ) : "_gameFriendsList-friends"), "friends", group);
	},


    /**
    * Returns the user's mutual friends.
    * Mutual friends result when two users add each other to their respective friend list.<br><br>
    * <b>Note:</b> This is part of the game graph API.
    * @name Social.US.User.getMutualFriendsList
    * @public
    * @function
    *
    * @param {String} group The group within the friend list. If specified, returns only mutual friends within the group.
    * @return {Social.US.OrderedList} The user's mutual friend list.
    * @example
    * userA.addFriend(userB);
    * userB.addFriend(userA);
    * var myMutualFriends = userA.getMutualFriendsList();
    * //userA appears in userB's mutual friends list, 
    * //because they are in each other's friend lists.
    * @see Social.US.OrderedList for more information on iterating over the mutual friends list.
    * @status iOS, Android, Test, iOSTested, AndroidTested    
    */	
	getMutualFriendsList: function(group){
		return OrderedList.getObjectPublicInterface(this, "getGameFriendsList", (group ? ("_gameFriendsList-mutual-" + group) : "_gameFriendsList-mutual"), "mutual", group);
	},


    /**
    * Returns the user's friend requests list. If the <code>group</code> parameter is specified, returns
    * only friends within the group.
    * @name Social.US.User.getFriendRequestsList
    * @public
    * @function
    *
    * @param {String} group The group within the friend request list.
    * @return {Social.US.OrderedList} The user's friend requests list.
    * @example
    * var myFriendRequestsList = userA.getFriendRequestsList ();
    * @see Social.US.OrderedList for more information on iterating over the friend requests list. 
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */	
	getFriendRequestsList: function(group){
		return OrderedList.getObjectPublicInterface(this, "getGameFriendsList", (group ? ("_gameFriendsList-invitation-" + group) : "_gameFriendsList-invitation"), "invitation", group);
	},

	/**
	* Updates the email address for the current user.
	* @name Social.US.User.setEmailAddress
	* @function
	* @private
	*
	* @param {String} newAddress The email address for the current user.
	* @param {Function} cb The callback function if an error occurs (for example, invalid email address format).
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setEmailAddress:function(newAddress,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setEmailAddress", [newAddress, cb]);
	},
	
	/**
	* Sets whether the current user will receive notifications from other Mobage users or just from Mobage friends.
	* @name Social.US.User.setOnlyShowFriendNotifications
	* @function
	* @private
	*
	* @param {Boolean} isFriendsOnly Set to <code>true</code> if the current user will only receive notifications from Mobage users who are also Mobage friends. 
    * If set to <code>false</code>, the user receives notifications from all Mobage users. 
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setOnlyShowFriendNotifications:function(isFriendsOnly,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setOnlyShowFriendNotifications", [isFriendsOnly, cb]);
	},
	
	/**
	* Sets whether the current user will receive game news and updates from Mobage.
	* @name Social.US.User.setOptsIn
	* @function
	* @private
	*
	* @param {Boolean} optIn Set to <code>true</code> if the current user will receive news and updates from Mobage. 
    * If set to <code>false</code>, the user will not receive news or updates from Mobage. 
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	setOptsIn:function(optIn,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setOptsIn", [optIn, cb]);
	},

	/**
	* Sets a motto for the current user. In other words, the user's "about me" text string.
	* @name Social.US.User.setMotto
	* @function
	* @private
	*
	* @param {String} motto The motto for the current user.
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setMotto:function(motto,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setMotto", [motto, cb]);
	},
	
	/**
	* Updates the first name for the current user.
	* @name Social.US.User.setFirstName
	* @function
	* @private
	*
	* @param {String} firstName The first name for the current user.
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setFirstName:function(firstName,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setFirstName", [firstName, cb]);
	},
	
	/**
	* Updates the last name for the current user.
	* @name Social.US.User.setLastName
	* @function
	* @private
	*
	* @param {String} lastName The last name for the current user.
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	setLastName:function(lastName,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setLastName", [lastName, cb]);
	},
	

	/**
	* Sets a password for the current user.
	* @name Social.US.User.setPassword
	* @function
	* @private
	*
	* @param {String} password The password for the current user.
    * @param {String} confirmation The password confirmation for the current user.
	* @param {Function} cb The callback function if an error occurs. For example, password does not meet requirements; password and confirmation do not match, and so on.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	setPassword:function(password,confirmation, cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setPassword", [password, confirmation, cb]);
	},

	/**
	* Sets whether the target user is in the logged-in user's blocked user list.
	* @name Social.US.User.setBlocked
	* @function
	* @private
	*
	* @param {Social.US.User} user The user that is the subject of blocking or unblocking.
    * @param {Boolean} blocked Whether the current user blocks the specified user. If <code>true</code>, the specified user is blocked.
    	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setBlocked:function(blocked, cb){
		Dispatcher.callMethodOnRemoteObject(this, "setBlocked", [blocked, cb]);
	},
	
	/**
	 * Gets the origin of the user's registration.
	 * Mobage records the origin of a user's registration. The "origin" may be the name of an alliance partner.
	 * The origin is typically used as a means of tracking revenue sharing events, such as the promotional activity 
	 * of an alliance partner that attracts new users to Mobage and thereby entitles the alliance partner 
	 * to share in revenue generated by the application.  
	 *
	 * @name Social.US.User.getOriginOfRegistration
	 * @private
	 * @static
	 * @function
	 *
	 * @param {Function} cb The callback function returns the origin of registration, or an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, originOfRegistration){
	 *     if(!originOfRegistration) {
	 *          var errorCode = error.errorCode;
	 *          var errorDesc = error.description;
	 *     } else {
	 *          var origin = originOfRegistration;
	 *     }
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getOriginOfRegistration: function(cb) {
		Dispatcher.callMethodOnRemoteObject(this, "getOriginOfRegistration", [cb]);
	}
});

User.GamertagKey = "gamertag";
User.AvatarKey = "badge_id";
User.MottoKey = "motto";
User.RelationKey = "relation";
User.FirstNameKey = "first_name";
User.LastNameKey = "last_name";
User.BirthdateKey = "birth_date";
User.GenderKey = "gender";
User.PrivacyKey = "fullname_privacy";
User.PhotoKey = "photo_url";
User.EmailAddressKey = "email";
User.EmailHashKey = "email_hash";
User.PhoneNumberKey = "phone_number";
User.AgeRangeKey = "age_restricted";
User.SpamKey = "opt_in";

User.PasswordKey = "password";
User.PasswordConfirmKey = "password_confirmation";
User.GamesKey = "games";
User.CapabilitiesKey = "capabilities";
User.NewBuddyKey = "new_buddy";
User.IsMutualFriendKey = "mutual_friends";
User.HidePresenceKey = "hide_presence";
User.OnlyShowFriendNotificationsKey = "friend_only_notification";

User.GamerScoreKey = "gamerscore";
User.LevelNumberKey = "level_position";
User.LevelNameKey = "level_name";
User.CurrentLevelScoreKey = "level_points";
User.NextLevelScoreKey = "level_next_points";

// properties that are not returned in sparse search results
User.NonSparseKeys = [User.PhotoKey, User.EmailAddressKey,
User.EmailHashKey, User.PhoneNumberKey, User.PasswordKey,
User.FirstNameKey, User.LastNameKey, User.PrivacyKey,
User.NewBuddyKey, User.CapabilitiesKey, User.HidePresenceKey,
User.OnlyShowFriendNotificationsKey, User.GamerScoreKey,
User.LevelNumberKey, User.LevelNameKey, User.CurrentLevelScoreKey,
User.NextLevelScoreKey, User.GamesKey];


/**
* Retrieves the user corresponding to the <code>userID</code> parameter.
* @name Social.US.User.getUserWithID
* @public
* @static
* @function
* 
* @param {String} userID The ID for the user.
* @param {Function} cb The callback function if an error occurs.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error, user){
* &nbsp;&nbsp;  if(!user) {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
* &nbsp;&nbsp;  } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var userWithID = user;
* &nbsp;&nbsp;  }
* }
* </pre>
* @status iOS, Android, Test, iOSTested, AndroidTested
*/	
User.getUserWithID = function(userID, cb){
	Dispatcher.callClassMethodOnRemoteObject(User, "getUserWithID", [userID, cb]);
};

/**
* Retrieves the user corresponding to the <code>gamertag</code> parameter.
* @name Social.US.User.getUserWithGamertag
* @public
* @static
* @function
* 
* @param {String} gamertag The user's gamertag.
* @param {Function} cb The callback function if an error occurs.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error, user){
* &nbsp;&nbsp;  if(!user) {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
* &nbsp;&nbsp;  } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var userWithGamertag = user;
* &nbsp;&nbsp;  }
* }
* </pre>
* @status iOS, Android, Test, iOSTested, AndroidTested
*/	
User.getUserWithGamertag = function(gamertag, cb){
	Dispatcher.callClassMethodOnRemoteObject(User, "getUserWithGamertag", [gamertag, cb]);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Game'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Game'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Game'] = exports; var DataModelR = require('NGCore/Client/Social/US/Models/DataModel');
var OrderedList = require('NGCore/Client/Social/US/Models/OrderedList').OrderedList;
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * <code>Game</code> objects identify a game and its properties.
 * Game properties include: 
 * <div class="ul">
 * <li><code>name</code></li>
 * <li><code>publisher</code></li>
 * <li><code>category</code></li>
 * <li><code>featured</code></li>
 * <li><code>numberOfLeaderboards</code></li> 
 * <li><code>numberOfAchievements</code></li>
 * <li><code>masterProductID</code></li>
 * <li><code>iconURL</code></li>
 * <li><code>AppStoreURL</code></li>
 * <li><code>feedURL</code></li>
 * <li><code>catalogURL</code></li>
 * </div>
 * <code>Game</code> objects provide static functions to return all games in a catalog or games associated to a user profile.
 * 
 * @class 
 * @name Social.US.Game
 * @augments Social.US.DataModel
 */
var Game = exports.Game = DataModelR.DataModel.subclass({
	classname: "Game",
	
	
	 //Game is a subclass of data model, and the getter/setter methods are generated by defineSetterCallbacks. The following
	 //comments document the generated methods.
	 /**
	 * The game name. Read-only.
	 * @name Social.US.Game.name
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The publisher name. Read-only.
	 * @name Social.US.Game.publisher
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The game category name. Read-only.
	 * @name Social.US.Game.category
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * Whether the game is featured. Read-only.
	 * @name Social.US.Game.featured
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The number of leaderboards for the game. Read-only.
	 * @name Social.US.Game.numberOfLeaderboards
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The number of achievements. Read-only.
	 * @name Social.US.Game.numberOfAchievements
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The master product ID. Read-only.
	 * @name Social.US.Game.masterProductID
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A URL to the icon for a game. Read-only.
	 * @name Social.US.Game.iconURL
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A URL to the store or marketplace for a game. Read-only.
	 * @name Social.US.Game.appStoreURL
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A URL to the RSS feed for a game. Read-only.
	 * @name Social.US.Game.feedURL
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * Sets a catalog URL for the catalog of game items. Read-only.
	 * @name Social.US.Game.catalogURL
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	properties: [
		// public
		"name",
		"publisher",
		"category",
		"numberOfLeaderboards",
		"iconURL",
		
		// private
		"numberOfAchievements",
		"featured",
		"masterProductID",
		"appStoreURL",
		"feedURL",
		"catalogURL",
		"description",
		"phone_screenshot_urls",
		"ngcore_url"
	]
});

/**
 * Returns an ordered list interface to the Mobage game catalog.
 * 
 * @name Social.US.Game.getAllGamesList
 * @function
 * @private 
 * @static
 *
 * @returns {Social.US.OrderedList} An ordered list interface to the catalog of games.
 * @see Social.US.OrderedList
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Game.getAllGamesList = function(){
		
	return OrderedList.getClassPublicInterface(Game, "getAllGamesList", "_allGamesInterface");
};

/**
 * Returns the current game. 
 *
 * @name Social.US.Game.getCurrentGame
 * @function
 * @public 
 * @static
 *
 * @param {Function} cb The callback function returns the current game or an error code and description.
 * <br/> 
 * <b>Callback Example:</b><br/>
 * <pre class="code">function(error, game){
 * &nbsp;&nbsp; if(!game){
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
 * &nbsp;&nbsp;} else {
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var currentGame = game;
 * &nbsp;&nbsp;}
 * }
 * </pre>
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Game.getCurrentGame = function(cb){
	Dispatcher.callClassMethodOnRemoteObject(Game, "getCurrentGame", [cb]);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Leaderboard'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Leaderboard'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Leaderboard'] = exports; var DataModelR = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;
var OrderedList = require('NGCore/Client/Social/US/Models/OrderedList').OrderedList;

/**
 * <code>Leaderboard</code> objects enable the current user to get friend scores, top scores, and submit a score.
 * To return a leaderboard, you must set up at least one leaderboard for your game in the Mobabe Sandbox or Production environment.
 * @class 
 * @name Social.US.Leaderboard
 * @augments Social.US.DataModel
 */
var Leaderboard = exports.Leaderboard = DataModelR.DataModel.subclass({

	 
	classname: "Leaderboard",
	properties: [
	"level",
	"title",
	"game",
	"iconURL"
	],

	
	/** 
	 * @constructs Constructs a <code>Leaderboard</code> object identified by the record ID. 
	 * @private
	 *
	 * @param {Type} $super A reference to the DataModel superclass.
	 * @param {String} recordId The record ID of the object.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	initialize: function($super, recordID){
		$super(recordID);
		NgLogD("Leaderboard Public! " + recordID + " " + this.recordID);
	},
	
	
	/**
	* Submits a score to the leaderboard.
	*
	* @name Social.US.Leaderboard.submitScore
	* @function
	* @public
	*
	* @param {Numeric} points The score points. If <code>null</code> or <code>undefined</code>, the callback error is "No score."
	* @param {Function} cb The callback function.
	* <br/> 
    * <b>Callback Example:</b><br/>
    * <pre class='code'>function(error, score){
    * &nbsp;&nbsp;  if(error) {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var setScore = score;
    * }
    * </pre>
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
	submitScore: function(points, cb){
		Dispatcher.callMethodOnRemoteObject(this, "submitScoreWithPoints", [points, cb]);
	},	
	
	/**
	* Returns an <code>OrderedList</code> with the user's score and the highest scores.
	* 
	* @name Social.US.Leaderboard.getTopScoresList
	* @function
	* @public
	*
	* @return {Social.US.OrderedList} The list of highest scores.
	* @see Social.US.OrderedList
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/		
	getTopScoresList: function(){
		return OrderedList.getObjectPublicInterface(this, "getTopScoresList", "_leaderboardTopScoresInterface");
	},
	
	/**
	* Returns an <code>OrderedList</code> of scores for the user's friends.
	* 
	* @name Social.US.Leaderboard.getFriendsScoresList
	* @function
	* @public
	*
	* @return {Social.US.OrderedList} The list of scores for the user's friends.
	* @see Social.US.OrderedList
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/		
	getFriendsScoresList: function(){
		return OrderedList.getObjectPublicInterface(this, "getFriendsScoresList", "_leaderboardFriendsScoresInterface");
	}

	 /**
	 * The user's level in the game. Read-only.
	 * @name Social.US.Leaderboard.level
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The leaderboard title. Read-only.
	 * @name Social.US.Leaderboard.title
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The game name. Read-only.
	 * @name Social.US.Leaderboard.game
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * A URL to the leaderboard icon. Read-only.
	 * @name Social.US.Leaderboard.iconURL
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
		 
});

/**
* Returns the leaderboard(s) for the current game.
* To return a leaderboard, you must set up at least one leaderboard for your game in the Mobabe Sandbox or Production environment.
*
* @name Social.US.Leaderboard.getLeaderboards
* @function
* @public
* @static
*
* @param cb Retrieves the leaderboard(s) for the current game. If an error occurs, returns an error code and error description.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class='code'>function(error, leaderboards){
*     if(error) {
*          var errorCode = error.errorCode;
*          var errorDesc = error.description;
*     } else {
*          var retrievedLeaderboards = leaderboards;
* }
* </pre>
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
Leaderboard.getLeaderboards = function(cb){
	Dispatcher.callClassMethodOnRemoteObject(Leaderboard, "getLeaderboards", [cb]);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Score'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Score'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Score'] = exports; var DataModel 	  = require('NGCore/Client/Social/US/Models/DataModel').DataModel;

/**
 * <code>Score</code> constructs objects that reflect a user's score for the current game.
 * @class 
 * @name Social.US.Score
 * @augments Social.US.DataModel
 */
var Score = exports.Score = DataModel.subclass({
	
    classname: "Score",
    	
	 /**
	 * A user's score. Read-only.
	 * @name Social.US.Score.score
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The score as formatted for display. Read-only.
	 * @name Social.US.Score.displayScore
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	
	 /**
	 * The user's rank. Read-only.
	 * @name Social.US.Score.rank
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	
	 /**
	 * The user's level in the current game. Read-only.
	 * @name Social.US.Score.level
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
    
	 /**
	 * A <code>Social.US.User</code> reference to the user associated to the score. Read-only.
	 * @name Social.US.Score.user
	 * @field
	 * @public
     * @see Social.US.User
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */    
	 
    properties: [
	"points",
	"displayScore",
	"rank",
	"level",
	"user"
	]
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/AppData'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/AppData'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/AppData'] = exports; var DataModelReq = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * <code>AppData</code> constructs objects that get and set a user's properties, 
 * and provides permissions for sharing the user's properties with other users.
 * @class 
 * @name Social.US.AppData
 * @see Social.Common.Appdata for additional Mobage persistence facilities;
 * @see Storage.KeyValue for additional ngCore persistence facilities; and,
 * @see Storage.FileSystem for additional ngCore persistence facilities. 
 */
var AppData = exports.AppData = DataModelReq.DataModel.subclass({
		
	classname: "AppData",
	properties: [
		"data",
		"key",
		"user",
		"permissions"
	],
	
	/**
	 * The application data for the user. Limited to 1024 bytes.
	 * 
	 * @name Social.US.AppData.data
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	/**
	 * The key describing the application data. Limited to 32 bytes.
	 * 
	 * @name Social.US.AppData.key
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	/**
	 * The name of the user who owns the data.
	 * 
	 * @name Social.US.AppData.name
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	/**
	 * The permissions for the application data.<br/><br/>
	 * <code>Private</code>: only the user can read and write the user data.<br/>
	 * <code>FriendsReadOnly</code>: friends can read the user data, but cannot write it.<br/>
	 * <code>PublicReadOnly</code>: all users can read the user data, but cannot write it.     
	 * 
	 * @name Social.US.AppData.permissions
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	
	
    /**
     * The default constructor.
     * @constructs 
     * @name Social.US.AppData.initialize
     * @private
     *
     * @param recordID A unique ID for the <code>AppData</code> object.
     *
     * @augments Social.US.DataModel
     * @status iOS, Android, Test, iOSTested, AndroidTested
     */	
    initialize: function($super, recordID) {
        $super(recordID);
    }
});

/**
* Takes a user reference and returns key/value pairs of the user for the current game.
* @name Social.US.AppData.getKeysForUser
* @function
* @public
* @static
*
* @param {Social.US.User} user A reference to the user.
* @param {Function} callback The callback function returns key/value pairs for the user and/or and error code and description.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">var entries = {"key1": "value1", "key2": "value2"};
* ...
* function(error, entries){
* &nbsp;&nbsp;   if (error){
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
* &nbsp;&nbsp;   } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var retrievedEntries = entries;
* &nbsp;&nbsp;   }
* }
* </pre>
* @example
* var user = Social.US.Session.getCurrentSession().user();
* var AppData = Social.US.AppData;
* var retrievedEntries = null;
* AppData.getKeysForUser(user, function(error, entries){
*				retrievedEntries = entries;
*			});
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
AppData.getKeysForUser = function(user, cb){
	Dispatcher.callClassMethodOnRemoteObject(AppData, "getKeysForUser", [user, cb]);
};

/**
* Takes a user, a key (the name of the key for a name/value pair) and returns the key/value pair for the user for the current game.
* @name Social.US.AppData.getDataForUserWithKey
* @function
* @public
* @static
*
* @param {Social.US.User} user A reference to the user.
* @param {String} key The name of the key.
* @param {Function} callback Retrieves the key/value pair for the user and/or an error code and description.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error, response){
* &nbsp;&nbsp;   if (error){
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
* &nbsp;&nbsp;   } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var fetchedData = response.data;
* &nbsp;&nbsp;   }
* }
* </pre>
* @example
* var user = Social.US.Session.getCurrentSession().user();
* var AData = Social.US.AppData;
* var errorCode = null;
* var errorDesc = null;
* var fetchedData = null;
* AData.getDataForUserWithKey( user, 
*                              key, 
*                              function(error, response){
*                                   errorCode = error.errorCode;
*                                   errorDesc = error.description;
*                                   fetchedData = response.data;
*                              }
*                            );
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
AppData.getDataForUserWithKey = function(user, key, cb){
	Dispatcher.callClassMethodOnRemoteObject(AppData, "getDataForUserWithKey", [user, key, cb]);
};


/**
* Takes data, a user, a key (the name of the key for a name/value pair) and permissions for the data and sets the application data for the user.
* <b>Note:</b> Limited to 30 key/value pairs per user, per game. 
* Maximum key name limited to 32 bytes. Maximum value limited to 1,024 bytes.
* To use key/value pairs without the foregoing constraints, use <code>Storage.KeyValue</code>
* in ngCore.
* @name Social.US.AppData.setDataForUserWithKeyAndPermissions
* @function
* @public
* @static 
*
* @param {String} data The data to set.
* @param {Social.US.User} user A reference to the user.
* @param {String} key The name of the key.
* @param {Social.US.AppData.Permissions} permission The permissions for the data.
* @param {Function} cb The callback function if there is an error with the parameters.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error){
* &nbsp;&nbsp;  if(!response) {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
* &nbsp;&nbsp;   } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var responseValues = response;
* &nbsp;&nbsp;   }
* }
* </pre>
* @example
* var user = Social.US.Session.getCurrentSession().user();
* var data = "some data";
* var key = "some key";
* var errorCode = null;
* var errorDesc = null;
* var result = null; 
*
* var AData = Social.US.AppData;
* 
* AData.setDataForUserWithKeyAndPermissions(data, 
*                                           user, 
*                                           key, 
*                                           AppData.Permissions.Private, 
*                                           function(error, response){
*                                             errorCode = error.errorCode;
*                                             errorDesc = error.description;
*                                             result = response;
*                                           }
*                                         );
* @status iOS, Android, Test, iOSTested, AndroidTested
* @see Social.US.AppData.Permissions for permission settings;
* @see Social.Common.Appdata for additional Mobage persistence facilities;
* @see Storage.KeyValue for additional ngCore persistence facilities; and,
* @see Storage.FileSystem for additional ngCore persistence facilities.
*/
AppData.setDataForUserWithKeyAndPermissions = function(data, user, key, permissions, cb){
	Dispatcher.callClassMethodOnRemoteObject(AppData, "setDataForUserWithKeyAndPermissions", [data, user, key, permissions, cb]);
};



/**
* Defines permissions for viewing user data.<br/><br/>
* <code>Private</code>: only the user can read and write the user data.<br/>
* <code>FriendsReadOnly</code>: friends can read the user data, but cannot write it.<br/>
* <code>PublicReadOnly</code>: all users can read the user data, but cannot write it. 
* @name Social.US.AppData.Permissions
* @field
* @public
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
AppData.Permissions = {
	Private: 0,
	FriendsReadOnly: 1,
	PublicReadOnly: 2
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Cache'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Cache'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Cache'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var SocialR = require('NGCore/Client/Social');

/**
 * <code>Cache</code> provides caching for a user's objects residing in the local interpreter.
 * @class 
 * @name Social.US.Cache
 * @private
 */
var Cache = exports.Cache = Class.subclass({


	classname: "Cache",
	inMemoryObjects: {},
	caches: {},
	
	/**
	 * Initializes a cache object upon instantiation. 
	 * @name Social.US.Cache.initialize
	 * @constructs
	 * @private
	 */			
	initialize: function(){
	},

	
	/**
	* Takes a classname and a unique record ID and returns the object or <code>null</code> if it doesn't find the object.
	*
	* @name Social.US.Cache.getObjectWithRecordID
	* @function
	* @private
	*
	* @param {String} classname The name of the class.
	* @param {Number} recordID The object ID.
	*
	* @return Returns the object corresponding to the <code>recordID</code> parameter or <code>null</code> if it doesn't find the object.
	*/
	getObjectWithRecordID: function(classname, recordID){
		var category = this.inMemoryObjects[classname];
		if(category){
			return category[recordID] || null;
		}else{
			return null;
		}
	},
	
	/**
	* Takes an object and adds it to the cache.
	* <code>addObject()</code> takes an object, ensures that it is not already in the cache, and adds it to the cache.
	*
	* @name Social.US.Cache.addObject
	* @function
	* @private
	*	
	* @param {Object} obj The object to add to the cache.
	* @return Returns the record ID of the object added to the cache.
	*/	
	addObject: function(obj){
		var classname = obj._classname();
		var category = this.inMemoryObjects[classname];
		if(!category){
			category = {};
			this.inMemoryObjects[classname] = category;
		}

		var object = category[obj.recordID];
		if(object){
			return object;
		}else{
			category[obj.recordID] = obj;
			return obj;
		}
	},
	
	/**
	* Takes an object reference and removes the object from the cache.
	* 
	* @name Social.US.Cache.removeObject
	* @function
	* @private
	*	
	* @param {Object} obj The object to remove from the cache.
	*/	
	removeObject: function(obj){
		var classname = obj._classname();
		var category = this.inMemoryObjects[classname];
		if(category){
			delete category[obj.recordID]; // ZOMG THE DELETE OPERATOR
		}
	},
	
	/**
	* Takes an object reference and returns whether the object is in the cache.
	* 
	* @name Social.US.Cache.isObjectCached
	* @function
	* @private
	*	
	* @param {Object} obj The object to select in the cache.
	*
	* @return Returns <code>true</true> if the object is in the cache; otherwise, it returns <code>false</code>.
	*/		
	isObjectCached: function(obj){
		var classname = obj._classname();
		var category = this.inMemoryObjects[classname];
		return (category && (category[obj.recordID] == obj));
	},
	
	
	saveCache: function(){
		
	},
	
	
	loadCache: function(){
		
	},
	
	/**
	* Takes a JSON array of objects and loads them into the cache.
	*
	* @name Social.US.Cache.loadCacheFromJSONArray
	* @function
	* @private
	*
	* @param {JSON} jsonArray The JSON object array to load into the cache.
	* @param {function} cb <code>loadCacheFromJSONArray()</code> takes an optional callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
	*/			
	loadCacheFromJSONArray: function(jsonArray, cb){
		var objects = [];
        
		for(var idx = 0; idx < jsonArray.length; idx++){
			var hash = jsonArray[idx];
			if(hash && hash.hasOwnProperty("classname") && hash.hasOwnProperty("recordID")){
				var theClassname = hash.classname;
				var theClass = SocialR.Social.US[theClassname];
				var theRecordID = hash.recordID;
				if(theClass && theRecordID){
					var theInstance = this.getObjectWithRecordID(theClassname, theRecordID);
					if(!theInstance){
						theInstance = new theClass(theRecordID, {});
					}
        
					theInstance._deserializeFromHash(hash);
					this.addObject(theInstance);
				}
			}
		}
        
		cb(null, this);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Data/Session'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Session'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Session'] = exports; var CoreReq = require('NGCore/Client/Core');
//var UserReq = require('../Models/User');
var MessageEmitterReq = require('NGCore/Client/Core/MessageEmitter');
var CacheReq = require('NGCore/Client/Social/US/Models/Cache');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * <code>Session</code> manages a user's game sessions.
 * @class 
 * @name Social.US.Session
 */
var Session = exports.Session = MessageEmitterReq.MessageEmitter.subclass({
		
	classname: "Session",
	
	/**
	 * Constructs a session object.
	 * @name Social.US.Session.initialize
	 * @private
	 * @constructs 
	 */	
	initialize: function(gameData){
		if(gameData){
			this._loadSessionData(gameData);
		}
	},
	
	/**
	 * Loads the user's game data into the current session.
	 *
	 * @name Social.US.Session._loadSessionData
	 * @function
	 * @private
	 *
	 * @param {Type} gameData Takes game data and loads it into the current session.
	 */		
	_loadSessionData: function(gameData){
		this._appKey = gameData.appId || this._appKey || null;
		this._appVersion = gameData.appVersion || this._appVersion || null;
		this._platformVersion = gameData.platformVersion || this._platformVersion || "1.0";
		this._serverMode = gameData.serverMode || this._serverMode || null;

		this._user = (gameData.userID ? this.dataCache().getObjectWithRecordID("User", gameData.userID) : null);		
		this.emit({user: this._user});
	},
	
	/**
	 * Returns the cache for the current session. If a session cache does not exist, this call creates a new cache, loads it and returns it.
	 *
	 * @name Social.US.Session.dataCache
	 * @function
	 * @private
	 *
	 * @return {Social.US.Cache} The cache for the current session.
	 */			
	dataCache: function(){
		if(!this._cache){
			this._cache = new CacheReq.Cache();
			this._cache.loadCache(function(err){
				NgLogD("Loaded cache: " + err);
			});
		}
		return this._cache;
	},
	
	
	/**
	 * Returns the user for this session.
	 *
	 * @name Social.US.Session.user
	 * @function
	 * @public
	 *
	 * @return {Social.US.User} The user for the current session.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */					
	user: function(){
		return this._user;
	},
	
	

	// data you probably don't need
	/**
	 * Returns the name of the game for this session.
	 *
	 * @name Social.US.Session.appKey
	 * @function
	 * @public
	 *
	 * @return {String} The application name.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */						
	appKey: function(){
		return this._appKey;
	},
	
	/**
	 * Returns the version of the game for this session.	 
	 *
	 * @name Social.US.Session.appVersion
	 * @function
	 * @public
	 *
	 * @return {String} The application version.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	appVersion: function(){
		return this._appVersion;
	},
	
	/**
	 * Returns the server mode of the game for this session.
	 *
	 * @name Social.US.Session.serverMode
	 * @function
	 * @public
	 *
	 * @return {String} The server mode.
	 * <b>Note:</b> Valid settings for the server mode include:<br/>
	 * <ul>
	 * <li>staging</li>
	 * <li>integration</li>
	 * <li>sandbox</li>
	 * <li>production</li>
	 * <li>unknown</li>
	 * </ul>
	 * @see Social.US.Session.serverModes
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	serverMode: function(){
		return this._serverMode;
	},
	
	/**
	 * Returns the platform version of the game for this session.
	 *
	 * @name Social.US.Session.platformVersion
	 * @function
	 * @public
	 *
	 * @return {String} The platform version.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	platformVersion: function(){
		return this._platformVersion;
	},
	

	/**
	 * Takes a consumer key and retrieves the session tokens for the the consumer key.
	 *
	 * @name Social.US.Session.getSessionTokensForConsumerKey
	 * @function
	 * @public
	 * 
     * @param {String} consumerKey The consumer key.
	 * @param {Function} cb A callback that retrieves the session tokens for the consumer key. If an error occurs, returns an error code 
	 * and error description.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	getSessionTokensForConsumerKey: function(consumerKey, cb){
		Dispatcher.callClassMethodOnRemoteObject("Session", ["getCurrentSession", "getSessionTokensForConsumerKey"], [[], [consumerKey, cb]]);
	}
});


/**
 * The session modes for the server. Session modes include:
 * <ul>
 * <li><code>staging</code></li>
 * <li><code>integration</code></li>
 * <li><code>sandbox</code></li>
 * <li><code>production</code></li>
 * <li><code>unknown</code></li>
 * </ul>
 * @name Social.US.Session.serverModes
 * @field
 * @public
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Session.serverModes = {
	staging: "staging",
	integration: "integration",
	partner: "sandbox",
	sandbox: "sandbox",
	production: "production",
	unknown: "unknown"
};

/**
 * Returns the current session.  
 * @name Social.US.Session.getCurrentSession
 * @function
 * @public 
 * @static
 *
 * @return {Social.US.Session} The current session.
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */	
Session.getCurrentSession = function(){
	return Session._currentSession;
};



Session._emitter = null;

/**
 * Adds a listener to the current session.
 *
 * @name Social.US.Session.addCurrentSessionListener
 * @function
 * @public
 * @static
 *  
 * @param {Core.MessageListener }listener The listener to add to the current session.
 * @param {Function} callback The callback function.
 * @param priority The priority for this <code>MessageListener</code>.
 *
 * @see Core.MessageListener
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Session.addCurrentSessionListener = function(listener, callback, priority){	
	if(!Session._emitter){
		Session._emitter = new MessageEmitterReq.MessageEmitter();
	}
	
	Session._emitter.addListener(listener, callback, priority);
};

/**
 * Removes the listener from the current session.
 *
 * @name Social.US.Session.removeCurrentSessionListener 
 * @function
 * @public 
 * @static
 *
 * @param {Core.MessageListener} listener The listener for the current session.
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Session.removeCurrentSessionListener = function(listener){
	if(Session._emitter){
		Session._emitter.removeListener(listener);
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Data/Dispatcher'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Dispatcher'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Dispatcher'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var Core = require('NGCore/Client/Core').Core;
var CacheR = require('NGCore/Client/Social/US/Models/Cache');

var SocialR = require('NGCore/Client/Social');
var SessionR = require('NGCore/Client/Social/US/Data/Session');

/**
 * <code>Dispatcher</code> objects know about <code>DataModel</code> objects and can "push" <code>DataModel</code> objects between interpreters.
 * <code>Dispatcher</code> objects can find classes and specific instances of objects, and may invoke their functions.
 * <code>Dispatcher</code> objects also provide a series of convenience functions to facilitate communication between interpreters.
 * @class 
 * @name Social.US.Dispatcher
 * @private
 */
var Dispatcher = exports.Dispatcher = {
				
	classname: "Dispatcher",
	callbackUIDCounter: 0,
	callbacks: {
		"-2": {},
		"-1": {}
	},
	
	/**
	 * Returns the data cache for the current session.
	 * @name Social.US.Dispatcher.cache
	 * @function
	 * @private
	 *
	 * @return {Social.US.Cache} The data cache for the current session.
	 * @see Social.US.Cache
	 */		
	cache: function(){		
		try {		
			return SessionR.Session.getCurrentSession().dataCache();
		}
		catch (err) {
			NgLogD("Mobage/Dispatcher/cache-Warning: cannot get cache. NOTE: This may be expected behavior if early on in initialization. Err=" 
				+ err);

			return null;
		}
	},
	
	
	/**
	 * Gets the current session and loads session data.
	 * If there is no current session, <code>receiveSession()</code> creates a new session.
	 *	 
	 * @name Social.US.Dispatcher.receiveSession
	 * @function
	 * @private
	 *
	 * @param {Type} command Takes a command, which may include the platform version, server mode, application name and application version. 
	 */		
	receiveSession: function(command){		
		var session = SessionR.Session.getCurrentSession();
		if(!session){
			session = new SessionR.Session();
			SessionR.Session._currentSession = session;
		}
		
		var userData = command.data.userData;
		if(userData){
			// the User object will be cached implicitly, then loaded in _loadSessionData
			Dispatcher.receiveObject({data: userData});
		}
		
		session._loadSessionData(command.data);
		
		if(SessionR.Session._emitter){
			SessionR.Session._emitter.emit({session: session});
		}
	},
	
	// DataModel communication
	/**
	 * Finds a particular instance of an object in the local interpreter and calls a method on the object.
	 *	 
	 * @name Social.US.Dispatcher.callMethodOnLocalObject
	 * @function
	 * @private
	 *
	 * @param {Command} command Takes a command object that identifies the class name of the object, 
     * its record ID, the method name to call, and any parameters for the method.
	 * The command object takes an optional callback and <code>callMethodOnLocalObject()</code> returns returns the result 
     * and/or any error code and description to the callback function.
	 */		
	callMethodOnLocalObject: function(command){		
		var recordID = command.recordID;
		var classname = command.classname;
		
		var object = Dispatcher.cache().getObjectWithRecordID(classname, recordID);
		if(object){
			var methodName = command.methodName;

			var error = false;
			var args;
			var retVal;
			if(methodName instanceof Array) {
				var methodOwner = object;
				for(var idx = 0; idx < methodName.length; idx++) {
					if(typeof methodOwner[methodName[idx]] == "function") {
						args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments[idx] || []);
						retVal = methodOwner[methodName[idx]].apply(methodOwner, args);
						methodOwner = retVal;						
					}
					else {
						error = true;
						break;
					}
				}
			}
			else {
				if(typeof object[methodName] == "function") {
					args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments || []);
					retVal = object[methodName].apply(object, args);
				}
				else {
					error = true;
				}
			}
			
			if(error) {
				NgLogD("ERROR: Invalid methods for calling on local object: " + command.recordID + " " + methodName);
			}
			else if(command.callback){
				var callback = Dispatcher.convertFunctionFromJSON({callbackUID: command.callback});
				if(callback){
					callback(retVal);
				}
			}
		}
	},
	
	
	/**
	 * Finds a particular instance of an object in a remote interpreter and calls a method on the remote object.
	 *	 
	 * @name Social.US.Dispatcher.callMethodOnRemoteObject
 	 * @function
 	 * @private
 	 *
	 * @param {Number} object The object reference (i.e., typically the keyword 'this').
	 * @param {String} method The method name to call.
	 * @param {Array} args An array of parameters for the method, including other <code>DataModel</code> objects or functions.
	 * @param {Function} cb Returns the result and/or any error code and description to the callback function.
	 *
	 * <b>Note:</b> If the target method wants a callback as one/more of its arguments, supply it as an element in the argument array, <b>NOT</b> as the fourth parameter.
	 */			
	callMethodOnRemoteObject: function(object, method, args, cb){		
		if(!object || !method){
			NgLogD("Public.Dispatcher.callMethodOnRemoteObject - bailing");
			if(cb){
				cb();
			}
			return;
		}

		args = Dispatcher.convertArgumentsArrayToJSON(args || []);
		
		var cmd = {
			apiURL: "US.Dispatcher.callMethodOnLocalObject",
			recordID: object.recordID,
			classname: object._classname(),
			methodName: method,
			arguments: args,
			callback: Dispatcher.convertFunctionToJSON(cb)
		};
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Calls a static method on a class in the local interpreter.
	 *	 
	 * @name Social.US.Dispatcher.callClassMethodOnLocalObject	
	 * @function
	 * @private
	 *
	 * @param {Command} command Takes a command object that identifies the class name of the object, the method name to call, and any parameters for the method.
	 * The command parameter takes an optional callback function and <code>callMethodOnLocalObject()</code> returns returns the result and/or any error code and description to the callback function.
	 */		
	callClassMethodOnLocalObject: function(command){		
		Dispatcher.beginBatching();
		
		var classname = command.classname;
		var methodName = command.methodName;
		if(classname && methodName){
			var theClass = SocialR.Social.US[classname];
			if(!theClass){
				theClass = SocialR.Social.US.Service[classname];
			}
			
			if(theClass){
				var error = false;
				var args;
				var retVal;
				if(methodName instanceof Array) {
					var methodOwner = theClass;
					for(var idx = 0; idx < methodName.length; idx++) {
						if(typeof methodOwner[methodName[idx]] == "function") {
							args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments[idx] || []);
							retVal = methodOwner[methodName[idx]].apply(methodOwner, args);
							methodOwner = retVal;						
						}
						else {
							error = true;
							break;
						}
					}
				}
				else {
					if(typeof theClass[methodName] == "function") {
						args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments || []);
						retVal = theClass[methodName].apply(theClass, args);
					}
					else {
						error = true;
					}
				}
				
				if(error) {
					NgLogD("ERROR: Invalid methods for calling on local Class: " + classname + " " + methodName);
				}
				else if(command.callback){
					var callback = Dispatcher.convertFunctionFromJSON({callbackUID: command.callback});
					if(callback){
						callback(retVal);
					}
				}				
			}
		}
		
		Dispatcher.endBatching();
	},

	/**
	 * Calls a static method on a class in a remote interpreter.
	 *	 
	 * @name Social.US.Dispatcher.callClassMethodOnRemoteObject
	 * @function
	 * @private
	 *
	 * @param {String} theClass The name of the class.
	 * @param {String} method The method name to call.
	 * @param {Array} args An array of parameters for the method.
	 * @param {Function} cb <code>callClassMethodOnRemoteObject()</code> returns returns the result and/or any error code and description to the callback function.
	 * 
	 */			
	callClassMethodOnRemoteObject: function(theClass, methodName, args, cb){		
		if(!theClass || !methodName){
			NgLogD("Public.Dispatcher.callClassMethodOnRemoteObject - bailing");
			if(cb){
				cb();
			}
			return;
		}

		args = Dispatcher.convertArgumentsArrayToJSON(args || []);
		
		var cmd = {
			apiURL: "US.Dispatcher.callClassMethodOnLocalObject",
			classname: (theClass.classname ? theClass.classname : theClass),
			methodName: methodName,
			arguments: args,
			callback: (cb ? Dispatcher.convertFunctionToJSON(cb) : null)
		};
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},


	// callback communication

	/**
  	 * Takes a callback and sends it to a remote interpreter.
	 *	 
	 * @name Social.US.Dispatcher.sendCallbackToRemote
	 * @function
	 * @private
	 *
	 * @param {String} callbackUID The user ID of the user receiving the callback.
	 * @param {Array} args An array of parameters for the callback function.
	 */		
	sendCallbackToRemote: function(callbackUID, args){		
		args = Dispatcher.convertArgumentsArrayToJSON(args || []);
		
		var cmd = {
			apiURL: "US.Dispatcher.receiveCallbackFromRemote",
			callbackUID: callbackUID,
			arguments: args,
			zone: GSGlobals.getRouterInstance().zone
		};

		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Receives a callback from a remote interpreter and provides the arguments to the local callback function.
	 *	 
	 * @name Social.US.Dispatcher.receiveCallbackFromRemote
	 * @function
	 * @private
	 *
	 * @param {Type} command A JSON object containing the user ID of the user receiving the callback and the callback arguments array.
	 */			
	receiveCallbackFromRemote: function(command){
		var callback = Dispatcher.callbacks[GSGlobals.getRouterInstance().zone][command.callbackUID]; //Dispatcher.convertFunctionFromJSON(command);
		if(!callback){
			return;
		}

		var args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments || []);
		
		callback.apply(callback, args);
	},
	

	// convenience functions to facilitate communication of all objects
	
	/**
	 * Parses a JSON array of function parameters and returns an array of function parameters.
	 *	 
	 * @name Social.US.Dispatcher.convertArgumentsArrayFromJSON
	 * @function
	 * @private
	 * 
	 * @param {Array} args An array of function parameters in JSON format.
	 * @return {Array} Returns an array of function parameters.
	 */	
	convertArgumentsArrayFromJSON: function(args){		
		var newArgs = [];
		for(var idx=0; idx < args.length; idx++){
			var arg = args[idx];
			
			if(arg && ((arg.recordID && arg.classname) || arg instanceof Array)){
				newArgs[idx] = Dispatcher.convertModelObjectFromJSON(arg);
			}else if(arg && arg.callbackUID){
				newArgs[idx] = Dispatcher.convertFunctionFromJSON(arg);
			}else{
				newArgs[idx] = arg;
			}
		}
		return newArgs;
	},

	/**
	 * Parses an array of function parameters and returns the array in JSON format.	 
	 * @name Social.US.Dispatcher.convertArgumentsArrayToJSON
	 * @function
	 * @private
	 *
	 * @param {Array} args An array of function parameters.
	 * 
	 * @returns {JSON} An array of function parameters in JSON format.
	 */
	convertArgumentsArrayToJSON: function(args){		
		var newArgs = [];
		for(var idx=0; idx < args.length; idx++){
			var arg = args[idx];
			if(arg && (arg.recordID && arg._classname && typeof arg._classname == "function" && arg._classname())){
				Dispatcher.sendObjectImmediately(arg);

				arg = Dispatcher.convertModelObjectToJSON(arg);
				newArgs[idx] = arg;
			}else if(arg && arg instanceof Array){
				arg = Dispatcher.convertArgumentsArrayToJSON(arg);
				newArgs[idx] = arg;
			}else if(arg && typeof arg == "function"){
				newArgs[idx] = Dispatcher.convertFunctionToJSON(arg);
			}else{
				newArgs[idx] = arg;
			}
		}
		return newArgs;
	},

	// convenience functions to facilitate communication of DataModel objects
	
	/**
	 * Takes a <code>DataModel</code> object and returns the object in JSON format.
	 *	 
	 * @name Social.US.Dispatcher.convertModelObjectToJSON
	 * @function
	 * @private
	 * 
	 * @param {Social.Models.DataModel} object A reference to a <code>DataModel</code> object (i.e., typically a subclass of <code>Models.DataModel</code>).
	 *
	 * @return {JSON} A <code>DataModel</code> object in JSON format.
	 */		
	convertModelObjectToJSON: function(object){		
		if(object && object.recordID && object._classname()){
			object = {
				classname: object._classname(),
				recordID:  object.recordID
			};
		}
		return object;
	},


	/**
	 * Takes a <code>DataModel</code> object in JSON format and returns the object.
	 *	 
	 * @name Social.US.Dispatcher.convertModelObjectFromJSON
 	 * @function
 	 * @private
 	 *
	 * @param {JSON} json A <code>DataModel</code> object in JSON format.
	 * 
	 * @return {Social.US.DataModel} A <code>DataModel</code> object.
	 */		
	convertModelObjectFromJSON: function(json){		
		var object = json;
		if(json.recordID && json.classname){
			var obj = Dispatcher.cache().getObjectWithRecordID(json.classname, json.recordID);
			if(obj){
				object = obj;
				if(json.data){
					object._deserializeFromHash(json.data);
				}
			}
		}else if(json instanceof Array){
			for(var idx=0; idx < json.length; idx++){
				var arg = json[idx];
				json[idx] = Dispatcher.convertModelObjectFromJSON(arg);
			}
		}
		return object;
	},

	// convenience functions to facilitate communication of functions
	
	/**
	 * Takes a function and returns the function in JSON format.
	 *	 
	 * @name Social.US.Dispatcher.convertFunctionToJSON
	 * @function
	 * @private	 
	 * 
	 * @param {function} The function to conver to JSON format.
	 * 
	 * @return {JSON} Returns a function in JSON format.
	 */		
	convertFunctionToJSON: function(fn){		
		if(fn && typeof fn == "function"){
			
			var callbackUID = ++Dispatcher.callbackUIDCounter;
			var zone = GSGlobals.getRouterInstance().zone;
			Dispatcher.callbacks[zone][callbackUID] = fn;

			fn = {
				callbackUID: callbackUID,
				zone: zone
			};
		}
		return fn;
	},


	
	/**
 	 * Takes a function expressed in JSON format and returns the function.
	 * @name Social.US.Dispatcher.convertFunctionFromJSON
	 * @function
	 * @private
	 * 
	 * @param {JSON} A function in JSON format.
	 * 
	 * @return {Function} Returns a function.
	 */	
	convertFunctionFromJSON: function(json){		
		var fn = json;
		var callbackUID = fn.callbackUID;
		var zone = fn.zone;
		
		if(callbackUID){
			var callback = Dispatcher.callbacks[zone][callbackUID];
			if(callback){
				fn = callback;
				delete Dispatcher.callbacks[zone][callbackUID];
			}else{
				fn = Dispatcher.generateCallbackForUID(callbackUID);
			}
		}
		return fn;
	},


	
	/**
	 * Takes a user ID and sends the callback to the remote interpreter.
	 *
	 * @name Social.US.Dispatcher.generateCallbackForUID
	 * @function
	 * @private
	 *	 
	 * @param {Number} The user ID.
	 * @return {Function} Returns a callback to the remote interpreter.
	 */	
	generateCallbackForUID: function(uid){		
		if(uid.callbackUID){
			uid = uid.callbackUID;
		}
		
		return function(){
			Dispatcher.sendCallbackToRemote(uid, arguments);
		};
	},
	
	
	// object sending and batching
	_batchCount: 0,
	_queuedObjects: [],
	
	/**
	 * <code>beginBatching()</code> increments the batch count.
	 * 
	 * @name Social.US.Dispatcher.
	 * @function
	 * @private
	 */	
	beginBatching: function(){		
		++Dispatcher._batchCount;
	},

	/**
	 * Decrements the batch count.
	 * Decrements the batch count and sends any objects remaining in the queue immediately.
	 *
	 * @name Social.US.Dispatcher.endBatching
	 * @function
	 * @private
	 */	
	endBatching: function(){		
		if((--Dispatcher._batchCount) === 0){
			for(var objKey in Dispatcher._queuedObjects){
				var obj = Dispatcher._queuedObjects[objKey];
				Dispatcher._queuedObjects[objKey] = undefined;
				Dispatcher.sendObjectImmediately(obj);
			}
		}
	},

	/**
	 * Takes an object and adds it to a queue, which pushes the object to the remote interpreter.
	 *
	 * @name Social.US.Dispatcher.sendObject
	 * @function
	 * @private
	 */
	sendObject: function(obj){		
		if(Dispatcher._queuedObjects.indexOf(obj) == -1){
			Dispatcher.beginBatching();
			
			var key = "" + obj.classname + "---" + obj.recordID;
			Dispatcher._queuedObjects[key] = obj;
			
			Dispatcher.endBatching();
		}
	},

	/**
	 * Takes an object and pushes it to the remote interpreter immediately (i.e., bypassing the queue).
	 *
	 * @name Social.US.Dispatcher.sendObjectImmediately
	 * @function
	 * @private
	 */
	sendObjectImmediately: function(obj){		
		if(!obj){
			return;
		}
		
		var cmd = {
			apiURL: "US.Dispatcher.receiveObject",
			data:   obj._serializedHash()
		};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Receives a serialized object from the remote interpreter, retrieves the local version of the same object from the cache, and deserializes the received object to the local object.
	 * If there is no local version of the received object, <code>receiveObject()</code> creates a local version and adds it to the cache; then, it deserializes the received object to the newly created local object.
	 *
	 * @name Social.US.Dispatcher.receiveObject
	 * @function
	 * @private
	 */
	receiveObject: function(command){		
		var data = command.data;
		var theRecordID  = data.recordID;
		var theClassname = data.classname;
		var theData      = data.data;
		
		if(theRecordID && theClassname && Dispatcher.cache()){
			var obj = Dispatcher.cache().getObjectWithRecordID(theClassname, theRecordID);
			if(!obj){
				var theClass = SocialR.Social.US[theClassname];
				obj = new theClass(theRecordID);
				
				Dispatcher.cache().addObject(obj);
			}

			// TODO disable emitting somehow
			if(theData){
				obj._deserializeFromHash(theData);
			}
		}
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Friends'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Friends'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Friends'] = exports; var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

var DataModelR = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * @class 
 * @name Social.US.Service.Friends
 */
var Friends = exports.Friends = DataModelR.DataModel.subclass({
    classname: "Friends"
});

/**
 * Opens the "Find Friends" view.
 *
 * @name Social.US.Service.Friends.showFindFriends
 * @function
 * @public
 * @static
 *
 * @param selectedTab Takes an optional tab reference.
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */		
Friends.showFindFriends = function(selectedTab) {
		NgLogD("Public call showFindFriends");
	
		var cmd = {
			apiURL:"US.Service.Friends.showFindFriends"
		};
		
		if(selectedTab){
			cmd.data.tab = selectedTab;
		}
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
};

/**
 * Opens the "Friend Picker" view.
 * 
 * @name Social.US.Service.Friends.openFriendPicker
 * @function
 * @public 
 * @static
 * 
 * @param maxFriendsToPick The maximum number of friends to pick. <code>0</code> for unlimited.
 * @param {Function} callback Retrieves an array of picked users.
 * 
 * <br/> 
 * <b>Callback Example:</b><br/>
 * <pre class="code">function(error, pickedUsers){
 * &nbsp;&nbsp; if(error){
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
 * &nbsp;&nbsp; } else {
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var users = pickedUsers;
 * &nbsp;&nbsp;}
 * }
 * </pre>
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */		
Friends.showFriendPicker = function(maxFriendsToPick, callback) { 
    Dispatcher.callClassMethodOnRemoteObject(Friends, "showFriendPicker", [maxFriendsToPick, callback]);
};

/**
* <code>Social.US.Service.Friends</code> has an invited user message emitter. 
* To add a message listener to the message emitter, see the example below.
*
* @name Social.US.Service.Friends.invitedUserEmitter
* @field
* @public
* @example
* 
* Social.US.Service.Friends.invitedUserEmitter.addListener(
*				new Core.MessageListener(), 
*				function(user){ 
*				// do sth. w/ User object 
*				}
* Social.US.Service.Friends.invitedUserEmitter.emit({user: user});
* @see Core.MessageListener
* @see Core.MessageEmitter
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
Friends.invitedUserEmitter = new MessageEmitter();; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Profile'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Profile'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Profile'] = exports; var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class
 * @name Social.US.Service.Profile
 */

exports.Profile = {
	
	/**
	 * Shows the user profile of the user specified by the <code>userOrGamertag</code> parameter.
	 * 
	 * @name Social.US.Service.Profile.showUserProfile
	 * @function
	 * @public
	 * 
	 * @param userOrGamertag Identifies the user or gamertag corresponding to the user profile.
	 * @param tab Specifies the name of the tab to show when the UI opens. If <code>null</code>, it opens the default tab.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */			
	showUserProfile:function(userOrUserGamertag,tab){		
		var cmd = {
			apiURL:"US.Service.Profile.showUserProfile", 
			data:{
				user:userOrUserGamertag
			}
		};
		if(tab){cmd.tab = tab;}
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/ButtonOverlays'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/ButtonOverlays'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/ButtonOverlays'] = exports; var UI = require('NGCore/Client/UI').UI;

var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

var Friends = require('NGCore/Client/Social/US/Service/Friends').Friends;
var Profile = require('NGCore/Client/Social/US/Service/Profile').Profile;
var User    = require('NGCore/Client/Social/US/Models/User').User;

/**
 * @class 
 * @name Social.US.Service.ButtonOverlays
 */
exports.ButtonOverlays = {
	/**
	* Displays the "Mobage Community" button.
	*	
	* @name Social.US.Service.ButtonOverlays.showCommunityButton
	* @function
	* @public 
	* 
	* @param {exports.Gravity} gravity Displays the button in the specified corner.
	* @param {Function} callback The callback function if there is an error related to <code>gravity</code> or <code>theme</code> usage.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @see exports.Gravity
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/   
	showCommunityButton: function(gravity, callback) {
		NgLogD("Public - showCommunityButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.showCommunityButton"
		};
		
		cmd["gravity"] = gravity;
		
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	* Hides the "Mobage Community" button.
	*
	* @name Social.US.Service.ButtonOverlays.hideCommunityButton
	* @function
	* @public 
	*	
	* @param {Function} callback The callback function if there is an error hiding the button.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/	
	hideCommunityButton: function(callback) {
		NgLogD("Public - hideCommunityButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.hideCommunityButton"
		};
		
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Shows the balance button.
	 * Shows the balance button where the <code>rect</code> parameter 
	 * determines the size and position of the button.
	 *
	 * @name Social.US.Service.ButtonOverlays.showBalanceButton
	 * @function
	 * @public
	 *	 
	 * @param {UI.ViewGeometry.Rect} rect Determines the size and position of the balance button.
	 * @param {Function} callback The callback function if there is an error with the <code>rect</code> parameter.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
	 * </pre>
	 * @see UI.ViewGeometry.Rect
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	showBalanceButton: function(rect, callback) {
		NgLogD("Public - showBalanceButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.showBalanceButton"
		};
		
		if (rect != undefined) {
			cmd["rect"] = rect;
		} else {
			cmd["rect"] = new UI.ViewGeometry.Rect(50, 50, 0, 0);
		}
		
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
	
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Hides the balance button.	
	 * @name Social.US.Service.ButtonOverlays.hideBalanceButton
	 * @function
	 * @public 
	 * 
	 * @param {Function} callback The callback function called after the view closes.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	hideBalanceButton: function(callback) {
		NgLogD("Public - hideBalanceButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.hideBalanceButton"
		};

		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
	
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/GameLaunchPayload'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/GameLaunchPayload'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/GameLaunchPayload'] = exports; var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

/**
* Provides an interface for retrieving a game's last payload from the game service. The game
* payload is returned as a string.
* @name Social.US.GameLaunchPayload
*/

var GameLaunchPayload = exports.GameLaunchPayload = {


	/**
	 * @name Social.US.GameLaunchPayload.getLastPayload
	 * @function
	 * @public
	 * 
	 * @param {Function} callback Retrieves the last payload generated by the game client from the game service 
     * as a string (e.g., JSON) and/or any error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, payload){
     *      if(error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     *      } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var pl = payload;     
     *      }
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */
	getLastPayload:function(callback)
	{
        if(callback != undefined && typeof callback == "function")
		{
			var cmd = {
				apiURL:"US.Service.GameLaunchPayload.getLastPayload"
			};

            cmd["callbackFunc"] = callback;

			GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
		}
	},
	
	// private, automatically called when new payload arrives. Do not call.
	onGameLaunchPayload:function(data)
	{
		this.newGamePayloadEmitter.emit(data);
	}
};

GameLaunchPayload.newGamePayloadEmitter = new MessageEmitter();; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Bank'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Bank'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Bank'] = exports; // Bank Public Interface
var RouterInited 	= require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals 		= require('NGCore/Client/Social/_Internal/GSGlobals');
var UI 				= require('NGCore/Client/UI').UI;

/**
* @ignore
* @private
*/
exports.Bank = {
};


/**
 * @class 
 * @name Bank.Debit
 * @description
 * Bank.Debit is an interface for in-game item purchasing. A transaction begins with a call to <code>createTransaction()</code>, which presents
 * a user interface to the user. If the user follows through with a purchase, the <code>transaction.state</code> property changes from 
 * <code>new</code> to <code>authorized</code>. Once <code>createTransaction()</code> executes its callback, the game may call 
 * <code>openTransaction()</code>, which changes the state from <code>authorized</code> to <code>open</code> and puts funds into escrow. 
 * At this point, the game/game server should deliver the purchased items. Once the items have been delivered, the game should call   
 * <code>closeTransaction()</code>. If there is a problem at any point in the transaction lifecycle, call <code>cancelTransaction()</code>,
 * which sets the <code>transactionState</code> property to <code>canceled</code> and restores funds from escrow back to the user.
 */
exports.Bank.Debit = {
	
		
	/**
	 * Creates a transaction. Initially, it sets the <code>transaction.state</code> to <code>new</code>.
     * Mobage presents a dialog that prompts the user to confirm the transaction. 
	 * If the user decides not to proceed with the transaction, the callback error returns as "usercanceled."
	 * In the client-only flow, this call checks inventory and sets the state to <code>authorized</code>.
	 * 
	 * @name Bank.Debit.createTransaction
	 * @function
	 * @public
	 * 
	 * @param {Array} billingItems The billing items for the transaction. <br/><b>Note:</b> The array is limited to one item for this release.
     * <br/><b>Array Example:</b><br/>
     * <pre class="code"> var billingItems = [{
     *     "item": {
     *           "id": "iceCastle",
     *          },
     *     "quantity": 1
     *    },
     *    {
     *     "item": {
     *           "id": "cobbleStoneRoad",
     *          },
     *     "quantity": 3
     *    } 
     * ];
     * </pre>
	 * @param {String} comment A comment about the transaction.
	 * @param {Function} callback Retrieves the transaction details and/or any error code and description.
	 * <br/> 
     * <b>Callback Example:</b><br/>
	 * <pre class="code">var createTxCallback = function (error, transaction){
	 *     if (error === 'usercanceled'){
     *         var userCanceledDlg = new UI.AlertDialog();
     *         userCanceledDlg.setTitle("Cancel Transaction");
     *         userCanceledDlg.setText("User canceled transaction.");
     *         userCanceledDlg.setChoices([('OK')]);
     *         userCanceledDlg.show();
     *     } else if(error){
     *         var errorCode = error.errorCode;
     *         var errorDesc = error.description;
     *         Bank.Debit.cancelTransaction(transaction.id);
     *     } else {
     *         txId = transaction.id;
     *         Bank.Debit.openTransaction(txId, openTxCallback)
     * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */				
    createTransaction: function(billingItems, comment, callback) {
		NgLogD("Public call createTransaction");
		
		
	var data = {
	    billingItems: billingItems,
	    comment: comment
	};
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.createTransaction",
			data: data
		};

		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}    
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Places funds into escrow and begins processing the transaction. 
	 * Indicates the game server needs to deliver the purchased item.
	 * The <code>transaction.state</code> transitions from <code>authorized</code> to <code>open</code>.
	 *
	 * @name Bank.Debit.openTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or any error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var openTxCallback = function (error, transaction){
	 *      if (error){
	 *          var errorCode = error.errorCode;
     *          var errorDesc = error.errorDescription;
     *          Bank.Debit.cancelTransaction( transaction.id, 
     *                                        cancelTxCallback );
     *      } else {
     *          var txId = transaction.id;
     *          var txState = transaction.state;
     *          var txComment = transaction.comment;
     *          //You are responsible for delivering items to the client.
     *          MyGameTxClass.deliverItems(transaction.items);
     *          //If you do not close the tx, you do not get paid.
     *          Bank.Debit.closeTransaction( transaction.id, 
     *                                       closeTxCallback );
     *      }	
     * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */
	openTransaction: function(transactionId, callback) {
		NgLogD("Public call openTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.openTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Continues processing a transaction.
	 * Checks the inventory to verify the item is valid, available, and so on. After verification, the <code>transaction.state</code> chranges from <code>new</code> to <code>authorized</code>,
	 * and funds are placed in escrow. The <code>transaction.state</code> transitions from <code>authorized</code> to <code>open</code>, which 
	 * indicates the game server needs to deliver the purchased item. 
	 * 	 
	 *
	 * @name Bank.Debit.continueTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or any error code and description.
	 * <br/>
     * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, transaction){
     *      if(error) {
	 *           var errorCode = error.errorCode;
	 *           var errorDesc = error.description;
     *           Bank.Debit.cancelTransaction( transaction.id, 
     *                                         cancelTxCallback );
     *      } else {
     *           var tx = transaction;
     *           Bank.Debit.openTransaction( transaction.id, 
     *                                       openTxCallback );
     *      }
	 * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
    continueTransaction: function(transactionId, callback) {
		NgLogD("Public call continueTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.continueTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	

    /**
     * Cancels the transaction. The transaction was canceled or the purchased item was not delivered and the game
     * needs to return the user's funds. The <code>transaction.state</code> transitions to <code>canceled</code>.
     *
     * @name Bank.Debit.cancelTransaction
     * @function
     * @public 
     * 
     * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
     * @param {Function} callback Retrieves the transaction ID and/or an error code and description.
     * <br/>
     * <b>Callback Example:</b><br/>
	 * <pre class="code">var cancelTxCallback = function (error, transaction){
     *     if (error){
     *        var errorCode = error.errorCode;
     *        var errorDesc = error.errorDescription;
     *        NgLogD('Time to freak out!: ' + errorCode+ ': ' + errorDesc);
     *     } else {
     *        var txId = transaction.id;
     *        var txState = transaction.state;
     *        var txComment = transaction.comment;
     *        if (txState === 'canceled'){
     *          NgLogD('Sniff, sniff... Whaaaaahhhh!!!');
     *        }	
	 *     }	
     * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */
    cancelTransaction: function(transactionId, callback) {
		NgLogD("Public call cancelTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.cancelTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
    },


	/**
	 * Closes the transaction. The virtual item was delivered.
	 * The <code>transaction.state</code> transitions from <code>open</code> to <code>closed</code>.
	 *
	 * @name Bank.Debit.closeTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var closeTxCallback = function (error, transaction){
     *     if (error){
     *          var errorCode = error.errorCode;
     *          var errorDesc = error.errorDescription;
     *          NgLogD('Oh my goodness! A transaction error: ' +
     *                  errorCode + ': ' + errorDesc);
     *          Bank.Debit.cancelTransaction( transaction.id, 
     *                                        cancelTxCallback );
	 *     } else {
     *          var txId = transaction.id;
     *          var txState = transaction.state;
     *          var txComment = transaction.comment;
     *          if (txState === 'closed'){
     *              NgLogD('I'm rich! I'm rich!');
     *          }	
     *     }	
     * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	closeTransaction: function(transactionId, callback) {
		NgLogD("Public call closeTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.closeTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Retrieves the transaction corresponding to the given transaction ID parameter.
	 *
	 * @name Bank.Debit.getTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, transaction){
     *      if(error) {
	 *            var errorCode = error.errorCode;
	 *            var errorDesc = error.description;
     *      } else {
     *            var tx = transaction;     
     *      }
	 *   }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getTransaction: function(transactionId, callback) {
		NgLogD("Public call getTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.getTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Retrieves the user's transactions where the state is <code>new</code>, <code>authorized</code> or <code>open</code>.
     * See the Game Service Programming Guide for details.
	 *
	 * @name Bank.Debit.getPendingTransactions
	 * @function
	 * @public
	 * 
	 * @param {Function} callback Retrieves the user's pending transactions and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, transaction){
     *      if(error) {
	 *         var errorCode = error.errorCode;
	 *         var errorDesc = error.description;
     *      } else {
     *         var tx = transaction;     
     *      }
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPendingTransactions: function(callback) {
		NgLogD("Public call getPendingTransactions");

		var cmd = {
			apiURL:"US.Service.Banking.Purchase.getPendingTransactions",
			data:{}
		};

		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = function(err, data) {
				callback(err.error, data.openTransactions);
			};
		}

	    GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	_getCallBackFunc : function(callback) {
			return function(err, data) {
				if(err) {
					callback(err, undefined);
				} else {
					callback(err, data.transaction);					
				}
			};
	}
};

/**
 * @class 
 * @name Bank.Inventory
 * @description
 * Provides an interface to retrieve items from inventory. The Mobage platform
 * server is responsible for managing item inventory in games.
 */
exports.Bank.Inventory = {


	/**
	 * Retrieves the item identified by its product ID from inventory on the Mobage platform server.
	 *
	 * @name Bank.Inventory.getItem
	 * @function
	 * @public
	 * 
	 * @param {Number} itemId The product ID for the item.
     * @param {Function} callback Retrieves the item from inventory on the Mobage platform server and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var item = {
     *      "id" : "XXXXXXXXX",
     *      "name" : "Tractor",
     *      "price" : 350,
     *      "description" : "Tractor conveys huge amount of equipment.",
     *      "imageUrl" : "http://someurl.com"
     * }
     *function(error, item){
     *      if(error) {
	 *         var errorCode = error.errorCode;
	 *         var errorDesc = error.description;
     *      } else {
     *         var itemData = item;
     *      }
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */    
    getItem: function(itemId,callback) {
	NgLogD("Public call Inventory getItem");

	var data = {
	    itemId: itemId
	};

	var cmd = {
	    apiURL:"US.Service.Banking.Purchase.getItem",
	    data:data
	};

	if (callback != undefined && typeof callback == "function") {
	    cmd["callbackFunc"] =  function(err, data) {
		if(err) {
		    callback(err, undefined);
		} else {
		    callback(err, data.item);					
		}
	    };
	}

	GSGlobals.getRouterInstance().sendCommandToGameService(cmd);

    }


};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/GSGlobals'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSGlobals'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSGlobals'] = exports; /**
 * Annoyingly necessary file to break circular dependencies.
 */
var theRouter = null;
exports.setRouterInstance = function(router){
	theRouter = router;
};
exports.getRouterInstance = function(){
	return theRouter;
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/RouterInit'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/RouterInit'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/RouterInit'] = exports; var Router = require('NGCore/Client/Social/_Internal/_Router').Router;
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

//Generate 1 instance of our router now and treat as the global instance!
GSGlobals.setRouterInstance(new Router());; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/_Router'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/_Router'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/_Router'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Router INTERNAL ROUTING CLASS
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Shared/Class').Class;
var Core = require('NGCore/Client/Core').Core;
var GSCommand = require('NGCore/Client/Social/_Internal/GSCommand');
var Public = require('NGCore/Client/Social').Social;

////////////////////////////////////////////////////////////////////////////////
var RouterVerbose = false;

exports.Router = Class.subclass(
/** @lends GameService.Router.prototype */
{
	classname: 'Router',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	/** Member var to help shortcircuit uneccessary bounces out to native. */
	zone:-2,
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
			* Zone for this Router Singleton (per-process)
			* @private */
	Zone:
	{ 
		/** Public Zone */
		Public: -2,
		/** GameService Zone */
		GameService: -1,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 346
	// Method create = -1
	// Method sendToOtherProcess = 2
	// Method onCreate = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._sendToOtherProcessRecv( cmd );
					break;
				case 3:
					instance._onCreateRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Router._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Router._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[346] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_sendToOtherProcessRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Router.sendToOtherProcess from command: " + cmd );
			return false;
		}
		
		obj[ "gsCommand" ] = Core.Proc.parseJSONString( cmd[ 0 ] );
		if( obj[ "gsCommand" ] === undefined )
		{
			NgLogE("Could not parse gsCommand in Router.sendToOtherProcess from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onCreateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Router.onCreate from command: " + cmd );
			return false;
		}
		
		obj[ "zone" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "zone" ] === undefined )
		{
			NgLogE("Could not parse zone in Router.onCreate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":346,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_sendToOtherProcessSendGen: function( gsCommand )
	{
		Core.Proc.appendToCommandString( ":346,2," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( gsCommand ) )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _sendToOtherProcessRecv: function( cmd ) {}
	// sendToOtherProcess: function( gsCommand ) {}
	
	// _onCreateRecv: function( cmd ) {}

// {{/Wg Generated Code}}
	_onCreateRecv:function(cmd) {
		if (!this._onCreateRecvGen(cmd,this)){
			return;
		}
		NgLogD("_Router/_onCreateRecv: "+this.zone);
		//We already stored the zone directly in ourselves (by passing in 'this').
	},
	_sendToOtherProcessRecv: function( cmd )
	{
		var decodedCommand = {};
		if(!this._sendToOtherProcessRecvGen(cmd,decodedCommand)){
			NgLogE("Decode of data for router, failed.");
			return;
		}
		
		var commandObject = decodedCommand["gsCommand"];
		
		//Incoming commands all get executed immediately.
		if(this.zone == this.Zone.Public) {
			if(RouterVerbose) {
				NgLogD("_Router/_sendToOtherProcessRecv - in public");
			}
			
			this.dispatchGameCommand(commandObject);
		}
		else if(this.zone == this.Zone.GameService) {
			if(RouterVerbose) {
				NgLogD("_Router/ _sendToOtherProcessRecv - in privileged");
			}
			
			// Dispatch Immediately, because we are in the right interpreter
			this.dispatchGameServiceCommand(commandObject);
		}
		else {
			NgLogE("Unknown Command Zone for the GameService Router.");
			// Assume public
			this.dispatchGameCommand(commandObject);
		}
	},
 	sendToOtherProcess: function( gsCommand ) 
	{
		var jsonCommand = GSCommand.makeSafe(gsCommand);
		if(!jsonCommand) {
			NgLogD("Couldn't prep GSCommand message for sending!");
			return;
		}
		
		if(RouterVerbose) {
			NgLogD("_Router.js/sendToOtherProcess: " + JSON.stringify(jsonCommand));
		}
		
		this._sendToOtherProcessSendGen(jsonCommand);
	},
	sendCommandToGameService:function(gsCommand) 
	{		
		if(this.zone == this.Zone.Public) {
			if(RouterVerbose) {
				NgLogD("_Router: sendCommandToGameService - in public");
			}
			
			// In the Public Interface, this is an alias for sendToOtherProcess
			this.sendToOtherProcess(gsCommand);
		}
		else if(this.zone == this.Zone.GameService) {
			if(RouterVerbose) {
				NgLogD("_Router: sendCommandToGameService - in privileged");
			}
			
			// Dispatch Immediately, because we are in the right interpreter
			this.dispatchGameServiceCommand(gsCommand);
		}
		else {
			NgLogE("Unknown Command Zone for the GameService Router.");
			// Assume public
			this.sendToOtherProcess(gsCommand);
		}
	},
	sendCommandToGame:function(gsCommand)
	{
		if(this.zone == this.Zone.GameService) {
			// In the GameService Interface, this is an alias for sendToOtherProcess
			this.sendToOtherProcess(gsCommand);
		}
		else if(this.zone == this.Zone.Public) {
			// Dispatch Immediately, because we are in the right interpreter
			this.dispatchGameCommand(gsCommand);
		}
		else {
			NgLogE("Unknown Command Zone for the GameService Router.");
			// Assume Privileged
			this.sendToOtherProcess(gsCommand);
		}
	},
	dispatchGameCommand:function(jsonCommand) 
	{
		var tCommand = GSCommand.makeExecutable(jsonCommand);
		//For the time being we expect this to almost always be callbacks
		if(tCommand && tCommand.hasOwnProperty("callbackFunc")) {	
			if( typeof tCommand["callbackFunc"] == "function" ) {
				var args = null;
				var error = null;
				if(tCommand.hasOwnProperty("error")) {
					error = tCommand["error"];
				}
				if(tCommand.hasOwnProperty("callbackData")) {
					args = tCommand["callbackData"];
				}

				//Time to execute the callback function!
				tCommand["callbackFunc"](error,args);
			}
		}
		else if(tCommand) {
			// Case there was no callbackFunc this is odd!!
			var apiURL = null;
			if(tCommand && tCommand.hasOwnProperty("apiURL") ) {
				apiURL = tCommand["apiURL"];

				var apiPieces = apiURL.split(".");
				var curPackage = Public;

				for ( var i = 0; i < apiPieces.length; i++ )
				{
					if(curPackage.hasOwnProperty(apiPieces[i])) {
						curPackage = curPackage[apiPieces[i]];
					}
					else {
						//Total Fail
						NgLogE("Cannot find namespace " + apiURL + " in GameService");
						curPackage = null;
						break;
					}
				}

				if(curPackage && typeof curPackage == "function" ) {			
					curPackage(tCommand);

					return; //done dispatching!
				}else{
					NgLogE("GameService Public cannot dispatch game command " + JSON.stringify(tCommand));
				}
			}
		}
	},
	dispatchGameServiceCommand:function(jsonCommand) 
	{
		//Don't decode the callbackId into a func when on a different interpreter!
		var apiURL = null;
		if(jsonCommand && jsonCommand.hasOwnProperty("apiURL") ) {
			apiURL = jsonCommand["apiURL"];

			var apiPieces = apiURL.split(".");
			var curPackage = require('NGCore/Client/Social/_Internal/Privileged').Social;

			for ( var i = 0; i < apiPieces.length; i++ )
			{
				if(curPackage.hasOwnProperty(apiPieces[i])) {
					curPackage = curPackage[apiPieces[i]];
				}
				else {
					//Total Fail
					NgLogE("Cannot find namespace " + apiURL + " in GameService");
					curPackage = null;
					break;
				}
			}

			if(curPackage && typeof curPackage == "function" ) {			
				curPackage(jsonCommand);

				return; //done dispatching!
			}
		}
		else {
			NgLogE("Someone called GameService without the proper parameters.\n");
		}
	},
	setVerboseLogging:function(useVerbose)
	{
		RouterVerbose = useVerbose;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/GSCommand'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSCommand'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSCommand'] = exports; /**
 * GSCommand.js
 * GameService Command Helper
 *
 * @summary Converts hashes for sending across the interpreter bounds, specifically:
 *		- Takes a hash with a callbackFunc
 * 			- Takes callbackFunc and converts to callbackId
 *		- Takes a hash with a callbackId
 *			- Takes the callbackId and looks up a callbackFunc from the local cache
 */
 
var GameServiceCommandCallbackStore = {};
GameServiceCommandCallbackStore.uidGenerator = 0;

/* @private */
var storeCallbackIdForFunc = function(callbackFunc) {
	var uid = GameServiceCommandCallbackStore.uidGenerator++;
	GameServiceCommandCallbackStore[uid] = callbackFunc;
	return uid;
};
/* @private */
var extractFuncForCallbackId = function(callbackId) {
	if(GameServiceCommandCallbackStore.hasOwnProperty(callbackId)){
		var callbackFunc = GameServiceCommandCallbackStore[callbackId];
		delete GameServiceCommandCallbackStore[callbackId];
		return callbackFunc;
	}
	return null;
};

var blindConvert = function(hash) {
	if ( typeof hash == "object" ) {
		// Case we have a hash
		if ( hash.hasOwnProperty("callbackFunc") ) {
			//	with a callback func to convert
			hash["callbackId"] = storeCallbackIdForFunc(hash["callbackFunc"]);
			
			delete hash["callbackFunc"];
		}
		else if (hash.hasOwnProperty("callbackId")) {
			hash["callbackFunc"] = extractFuncForCallbackId(hash["callbackId"]);
			delete hash["callbackId"];
		}
		return hash;
	}
	
	NgLogD("Error: invalid or non-object passed to gsCmdConvert.");
	return null;
};
exports.makeSafe = function(hash) {
	if (hash && typeof hash == "object" && hash.hasOwnProperty("callbackFunc"))
	{
		return blindConvert(hash);
	}
	return hash;
};
exports.makeExecutable = function(hash) {
	if (hash && typeof hash == "object" && hash.hasOwnProperty("callbackId"))
	{
		return blindConvert(hash);
	}
	return hash;
};

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/Privileged'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/Privileged'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/Privileged'] = exports; /**
 * Privileged API for GameService (Public Stub)
 * 
 * Access this file as NGCore/Client/Social.js
 */
exports.Social = {
	// stubbed out for the SDK
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/OrderedList'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/OrderedList'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/OrderedList'] = exports; var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * @class 
 * @name Social.US.OrderedList
 * @description
 * Do not instantiate <code>OrderedList</code> objects directly. This description is for information purposes only. 
 * <code>DataModel</code> subclasses that return <code>OrderedList</code> interfaces include:<br/><br/>
 * <div class="ul">
 * <li>{@link Social.US.User}</li>
 * <li>{@link Social.US.Leaderboard}</li>
 * </div><br/>
 * Some <code>DataModel</code> subclasses can return an <code>OrderedList</code>,
 * which is an interface for iterating over a range of values. You determine the iteration range by
 * selecting one of three common functions: <br/><br/>
 * <div class="ul">
 * <li><code>forAll(iterCb, doneCb):</code> Iterates over all values.</li>
 * <li><code>forRange(start, count, iterCb, doneCb):</code> Iterates from the starting index to the count.</li>
 * <li><code>forItem(index, iterCb, doneCb):</code> Iterates over a particular item given by its index.</li>
 * </div>
 * Each of the functions calls an iteration callback (iterCb) for every available item. 
 * When the function iterates over all items or an error occurs, it calls the done callback (doneCb). You <b>MUST</b> provide both callbacks.
 * <br/><br/>
 * <b>Note:</b> The <code>OrderedList</code> interface invokes an iterator on the server. Do NOT assume it will execute your callback functions immediately.
 *
 * @example
 * //NOTE: You MUST provide both callback functions.
 * userBuddiesList.forAll( 
 *      function(error, details){//per item cb body}, 
 *      function(error, details){//done cb body}
 * );
 *
 * @example
 * //Callback examples
 * var done = false;
 * var err = null;
 *
 * currentUser.getFriendsList().forAll(
 *          function(continueCb, user, index){
 *				if(user == otherUser){
 *					foundBuddy = true;
 *					continueCb(false);
 *				}else{
 *					continueCb(true);
 *				}
 *			}, 
 *          function(error){
 *                  if (!error){
 *                      done = true;
 *                   } else {
 *                      err = error;
 *                   }
 *          }
 * );
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
var OrderedList = {

    /**
    * Returns a public interface for an object.
    * 
    * To expose a privelegee ordered list of a <code>DataModel</code> object in the public interface, 
    * add a function to the object of the corresponding <code>DataModel</code>
    * subclass in the public interface.
    * @example
    * getFollowersList: function(cb){
 	* 	return OrderedList.getObjectPublicInterface(this, "getFollowersList", "_followersListInterface");
	* },
    *
    * @name Social.US.OrderedList.getObjectPublicInterface
    * @function    
    * @private
    *
    * @param {Object} ownerObject The object that will "own" the public interface.
    * @param {Function} getListFn The function that returns a list of values to the <code>OrderedList</code>.
    * @param interfaceName The name of the interface.
    *
    * @return {Social.US.OrderedList} The public interface.
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
    getObjectPublicInterface: function(ownerObject, getListFn, interfaceName) {
		if(ownerObject[interfaceName]) {
			return ownerObject[interfaceName];
		}
		
		var args = Array.apply(null, arguments);
		if(args && args.length > 3){
			args.splice(0, 3);
		}else{
			args = [];
		}
		
		var newInterface = {
			forAll: function(perItemCb, doneCb) {
				Dispatcher.callMethodOnRemoteObject(ownerObject, [getListFn, "forAll"], [args,[perItemCb, doneCb]]);		
			},
			forRange: function(start, count, perItemCb, doneCb) {
				Dispatcher.callMethodOnRemoteObject(ownerObject, [getListFn, "forRange"], [args,[start, count, perItemCb, doneCb]]);
			},
			forItem: function(index, perItemCb, doneCb) {
				Dispatcher.callMethodOnRemoteObject(ownerObject, [getListFn, "forItem"], [args,[index, perItemCb, doneCb]]);
			}
		};
		
		ownerObject[interfaceName] = newInterface;
		
		return newInterface;
	},

    /**
    * Returns a public interface for a class.
    * To expose a priveleged ordered list of a <code>DataModel</code> subclass in the public interface, 
    * add a function to the subclass of the corresponding <code>DataModel</code>
    * subclass in the public interface.
    * @example
    * getFollowersList: function(cb){
 	* 	return OrderedList.getClassPublicInterface(this, "getFollowersList", "_followersListInterface");
	* },    
    *
    * @name Social.US.OrderedList.getClassPublicInterface
    * @function
    * @private
    *
    * @param {Object} owner The owner of the the public interface.
    * @param {Function} getListFn The function to call on each iteration.
    * @param interfaceName The name of the interface.
    * 
    * @return {Social.US.OrderedList} The public interface.
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
    getClassPublicInterface: function(owner, getListFn, interfaceName) {
		if(owner[interfaceName]) {
			return owner[interfaceName];
		}
		
		var newInterface = {
			forAll: function(perItemCb, doneCb) {
				Dispatcher.callClassMethodOnRemoteObject(owner, [getListFn, "forAll"], [[],[perItemCb, doneCb]]);
			},
			forRange: function(start, count, perItemCb, doneCb) {
				Dispatcher.callClassMethodOnRemoteObject(owner, [getListFn, "forRange"], [[],[start, count, perItemCb, doneCb]]);
			},
			forItem: function(index, perItemCb, doneCb) {
				Dispatcher.callClassMethodOnRemoteObject(owner, [getListFn, "forItem"], [[],[index, perItemCb, doneCb]]);
			}
		};
		
		owner[interfaceName] = newInterface;
		
		return newInterface;
	}
};

exports.OrderedList = OrderedList;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Color'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Color'] || {}; $MODULE_REGISTRY['NGCore/Shared/Color'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Color = Class.subclass(
/** @lends Core.Color.prototype */
{
	classname: 'Color',
	
	/**
	 * @class The <code>Color</code> class constructs objects that control the RGB components of a device. 
	 * RGB is a color model used for rendering objects on-screen and is derived 
	 * from the three primary colors used in the model: red, green, and blue.
	 * Each value ranges from <code>(0-1)</code> and determines the color saturation level.	 
	 * @constructs The default constructor.<br><br>
	 * <b>Example:</b> The following code examples illustrate different call styles for <code>Color</code> objects.<br><br>
	 * A new color with all components set to one (1 = white).
	 * <pre class="code">var style1 = new Core.Color();</pre>
	 *
	 * Copy an existing color.
	 * <pre class="code">var style2 = new Core.Color(style1);</pre>
	 *
	 * Specify all three components.
	 * <pre class="code">var style3 = new Core.Color(1.0, 1.0, 1.0);</pre>
	 *
	 * Specify the color as solid blue.
	 * <pre class="code">var style4 = new Core.Color([0, 0, 1.0]);</pre>
	 *
	 * Specify the color as solid red.
	 * <pre class="code">var style5 = new Core.Color([1.0, 0, 0]);</pre>
	 * 
	 * Specify the color as a dark shade of red.
	 * <pre class="code">var style6 = new Core.Color([.5, 0, 0]);'</pre>
	 * @augments Core.Class
	 * @param {Number} [red=1] The red component.
	 * @param {Number} [green=1] The green component.
	 * @param {Number} [blue=1] The blue component.
	 * @throws {Wrong number of arguments for a Color} Number of parameters passed by this call is invalid.
	 */
	initialize: function(red, green, blue)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._red = 1.0;
				this._green = 1.0;
				this._blue = 1.0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._red = 1.0;
					this._green = 1.0;
					this._blue = 1.0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (color)
					this._red = rhs.getRed();
					this._green = rhs.getGreen();
					this._blue = rhs.getBlue();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._red = 1.0;
							this._green = 1.0;
							this._blue = 1.0;
							break;
						case 1:
							// ([color])
							rhs = rhs[0];
							this._red = rhs.getRed();
							this._green = rhs.getGreen();
							this._blue = rhs.getBlue();
							break;
						case 3:
							// ([red, green, blue])
							this._red = rhs[0];
							this._green = rhs[1];
							this._blue = rhs[2];
							break;
						default:
							throw new Error('Wrong number of arguments for a Color');
					}
				}
				break;
			case 3:
				// (red, gree, blue)
				this._red = arguments[0];
				this._green = arguments[1];
				this._blue = arguments[2];
				break;
			default:
				throw new Error('Wrong number of arguments for a Color');
		}
		return this;
	},
	
	/**
	 * Set the saturation level for all three color components.
	 * @example Core.Color.setAll(0.5, 0.5, 1.0);
	 * @param {Number} [red=1] The red component.
	 * @param {Number} [green=1] The green component.
	 * @param {Number} [blue=1] The blue component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color for a full list of supported calling styles.
	 */
	setAll: function(red, green, blue)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Retrieve the saturation level for the red component of this <code>Color</code>.
	 * @returns {Number} The current saturation level for the red component.
	 */
	getRed: function()
	{
		return this._red;
	},
	
	/**
	 * Retrieve the saturation level for the green component of this <code>Color</code>.
	 * @returns {Number} The current saturation level for the green component.
	 */
	getGreen: function()
	{
		return this._green;
	},
	
	/**
	 * Retrieve the saturation level for the blue component of this <code>Color</code>.
	 * @returns {Number} The current saturation level for the blue component.
	 */
	getBlue: function()
	{
		return this._blue;
	},
	
	/**
	 * Set the saturation level for the red component of this <code>Color</code>.
	 * @example Core.Color.setRed(0.7);
	 * @param {Number} red The new saturation level for the red component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color#getRed
	 */
	setRed: function(red)
	{
		this._red = red;
		return this;
	},
	
	/**
	 * Set the saturation level for the green component of this <code>Color</code>.
	 * @example Core.Color.setGreen(0.3);
	 * @param {Number} green The new saturation level for the green component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color#getGreen
	 */
	setGreen: function(green)
	{
		this._green = green;
		return this;
	},
	
	/**
	 * Set the saturation level for the blue component of this <code>Color</code>.
	 * @example Core.Color.setBlue(1.0);
	 * @param {Number} blue The new saturation level for the blue component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color#getBlue
	 */
	setBlue: function(blue)
	{
		this._blue = blue;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Vector'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Vector'] || {}; $MODULE_REGISTRY['NGCore/Shared/Vector'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Vector = Class.subclass(
/** @lends Core.Vector.prototype */
{
	classname: 'Vector',
	
	/**
	 * @class The <code>Vector</code> class constructs objects that define vector point values for the <i>x</i> and <i>y</i> components. 
	 * Supported values range between <code>(0-1)</code>.
	 * @constructs The default constructor. <br><br>
	 * The following code examples illustrate a variety of different calling styles for <code>Vector</code> objects.<br><br>
	 * All components are set to zero.
	 * <pre class="code">var style1 = new Core.Vector();</pre>
	 *
	 * Copy an existing vector.
	 * <pre class="code">var style2 = new Core.Vector(style1);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style3 = new Core.Vector(1.0, 1.0);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style4 = new Core.Vector([1.0, 1.0]);</pre>
	 * @augments Core.Class
	 * @param {Number} [x=0] The <i>x</i> component.
	 * @param {Number} [y=0] The <i>y</i> component.
	 * @throws {Wrong number of arguments for a Vector} Number of parameters passed by this call is invalid.
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._x = 0;
				this._y = 0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._x = 0;
					this._y = 0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (vector)
					this._x = rhs.getX();
					this._y = rhs.getY();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._x = 0;
							this._y = 0;
							break;
						case 1:
							// ([vector])
							rhs = rhs[0];
							this._x = rhs.getX();
							this._y = rhs.getY();
							break;
						case 2:
							// ([x, y])
							this._x = rhs[0];
							this._y = rhs[1];
							break;
						default:
							throw new Error('Wrong number of arguments for a Vector');
					}
				}
				break;
			case 2:
				// (x, y)
				this._x = arguments[0];
				this._y = arguments[1];
				break;
			default:
				throw new Error('Wrong number of arguments for a Vector');
		}
	},
	
	/**
	 * Set the value of both components for this <code>Vector</code>. 
	 * @param {Number} [x=0] The new <i>x</i> coordinate.
	 * @param {Number} [y=0] The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Vector for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function()
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate this <code>Vector</code>.
	 * @returns {Core.Vector} A new vector with identical coordinates to the duplicated vector.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the value of the <i>x</i> component for this <code>Vector</code>.
	 * @returns {Number} The current <i>x</i> coordinate.
	 * @see Core.Vector#setX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getX: function()
	{
		return this._x;
	},
	
	/**
	 * Set the value of the <i>x</i> component for this <code>Vector</code>.
	 * @param {Number} <i>x</i> The new <i>x</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Vector#getX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setX: function(x)
	{
		this._x = x;
		return this;
	},
	
	/**
	 * Retrieve the value of the <i>y</i> component for this <code>Vector</code>.
	 * @returns {Number} The current <i>y</i> coordinate.
	 * @see Core.Vector#setY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getY: function()
	{
		return this._y;
	},
	
	/**
	 * Set the value of the <i>y</i> component for this <code>Vector</code>.
	 * @param {Number} <i>y</i> The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Vector#getY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setY: function(y)
	{
		this._y = y;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Point'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Point'] || {}; $MODULE_REGISTRY['NGCore/Shared/Point'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Point = Class.subclass(
/** @lends Core.Point.prototype */
{
	classname: 'Point',
	
	/**
	 * @class The <code>Point</code> class defines a 2D point coordinate (<i>x</i> and <i>y</i>). 
	 * @status iOS, Android, Flash, Test
	 * @constructs The default constructor. <br><br>
	 * <b>Example:</b>The following code examples illustrate a variety of different calling styles for <code>Point</code> objects.<br><br>
	 * All components are set to zero.
	 * <pre class="code">var style1 = new Core.Point();</pre>
	 *
	 * Copy an existing point.
	 * <pre class="code">var style2 = new Core.Point(style1);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style3 = new Core.Point(1.0, 1.0);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style4 = new Core.Point([1.0, 1.0]);</pre>
	 * @augments Core.Class
	 * @param {Number} [x=0] The <i>x</i> coordinate.
	 * @param {Number} [y=0] The <i>y</i> coordinate.
	 * @throws {Wrong number of arguments for a Point} Number of parameters passed by this call is invalid.
	 */
	initialize: function(x, y)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._x = 0;
				this._y = 0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._x = 0;
					this._y = 0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (point)
					this._x = rhs.getX();
					this._y = rhs.getY();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._x = 0;
							this._y = 0;
							break;
						case 1:
							// ([point])
							rhs = rhs[0];
							this._x = rhs.getX();
							this._y = rhs.getY();
							break;
						case 2:
							// ([x, y])
							this._x = rhs[0];
							this._y = rhs[1];
							break;
						default:
							throw new Error('Wrong number of arguments for a Point');
					}
				}
				break;
			case 2:
				// (x, y)
				this._x = arguments[0];
				this._y = arguments[1];
				break;
			default:
				throw new Error('Wrong number of arguments for a Point');
		}
	},
	
	/**
	 * Set the value of both the <i>x</i> and <i>y</i> components. 
	 * @param {Number} [<i>x</i>=0] The new <i>x</i> coordinate.
	 * @param {Number} [<i>y</i>=0] The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Point for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function(x, y)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate this <code>Point</code>.
	 * @returns {Core.Point} A new point with identical <i>x</i> and <i>y</i> coordinates to the cloned point.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the value of the <i>x</i> component of this <code>Point</code>.
	 * @returns {Number} The current <i>x</i> coordinate.
	 * @see Core.Point#setX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getX: function()
	{
		return this._x;
	},
	
	/**
	 * Set the value of the <i>x</i> component for this <code>Point</code>.
	 * @param {Number} <i>x</i> The new <i>x</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Point#getX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setX: function(x)
	{
		this._x = x;
		return this;
	},
	
	/**
	 * Retrieve the value of the <i>y</i> component of this <code>Point</code>.
	 * @returns {Number} The current <i>y</i> coordinate.
	 * @see Core.Point#setY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getY: function()
	{
		return this._y;
	},
	
	/**
	 * Set the value of the <i>y</i> component for this <code>Point</code>.
	 * @param {Number} <i>y</i> The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Point#getY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setY: function(y)
	{
		this._y = y;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Size'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Size'] || {}; $MODULE_REGISTRY['NGCore/Shared/Size'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Size = Class.subclass(
/** @lends Core.Size.prototype */
{
	classname: 'Size',
	
	/**
	 * @class The <code>Size</code> class constructs objects that define size values for the <i>height</i> and <i>width</i> components. 
	 * @status iOS, Android, Flash
	 * Supported values range between <code>(0-1)</code>.
	 * @constructs The default constructor. <br><br>
	 * The following code examples illustrate a variety of different calling styles for <code>Size</code> objects.<br><br>
	 * Set both component values to 0.
	 * <pre class="code">var style1 = new Core.Size();</pre>
	 *
	 * Copy an existing size.
	 * <pre class="code">var style2 = new Core.Size(style1);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style3 = new Core.Size(1.0, 1.0);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style4 = new Core.Size([1.0, 1.0]);</pre>
	 * @augments Core.Class
	 * @param {Number} [width=0] The <i>width</i> component.
	 * @param {Number} [height=0] The <i>height</i> component.
	 */
	initialize: function(width, height)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._width = 0;
				this._height = 0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._width = 0;
					this._height = 0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (size)
					this._width = rhs.getWidth();
					this._height = rhs.getHeight();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._width = 0;
							this._height = 0;
							break;
						case 1:
							// ([size])
							rhs = rhs[0];
							this._width = rhs.getWidth();
							this._height = rhs.getHeight();
							break;
						case 2:
							// ([x, y])
							this._width = rhs[0];
							this._height = rhs[1];
							break;
						default:
							throw new Error('Wrong number of arguments for a Size');
					}
				}
				break;
			case 2:
				// (x, y)
				this._width = arguments[0];
				this._height = arguments[1];
				break;
			default:
				throw new Error('Wrong number of arguments for a Size');
		}
	},
	
	/**
	 * Set the value of all components for this <code>Size</code>. 
	 * @param {Number} [width=0] The new <i>width</i>.
	 * @param {Number} [height=0] The new <i>height</i>.
	 * @throws {Wrong number of arguments for a Size} Number of parameters passed by this call is invalid.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Size for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function(width, height)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate this <code>Size</code>.
	 * @returns {Core.Size} A new size with identical <i>height</i> and <i>width</i> components.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the value of the <i>width</i> component for this <code>Size</code>.
	 * @returns {Number} The current <i>width</i>.
	 * @see Core.Size#setWidth
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getWidth: function()
	{
		return this._width;
	},
	
	/**
	 * Set the value of the <i>width</i> component for this <code>Size</code>.
	 * @param {Number} width The new <i>width</i>.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Size#getWidth
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setWidth: function(width)
	{
		this._width = width;
		return this;
	},
	
	/**
	 * Retrieve the value of the <i>height</i> component for this <code>Size</code>.
	 * @returns {Number} The current <i>height</i>.
	 * @see Core.Size#setHeight
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHeight: function()
	{
		return this._height;
	},
	
	/**
	 * Set the value of the <i>height</i> component for this <code>Size</code>.
	 * @param {Number} height The new <i>height</i>.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Size#getHeight
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setHeight: function(height)
	{
		this._height = height;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Rect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Rect'] || {}; $MODULE_REGISTRY['NGCore/Shared/Rect'] = exports; var Class = require('NGCore/Shared/Class').Class;
var Point = require('NGCore/Shared/Point').Point;
var Size = require('NGCore/Shared/Size').Size;

exports.Rect = Class.subclass(
/** @lends Core.Rect.prototype */
{
	classname: 'Rect',
	
	/**
	 * @class The <code>Rect</code> class constructs a rectangle object that is derived from two values: a point of origin  
	 * and a size.	 
	 * @status iOS, Android, Flash
	 * @constructs The default constructor. <br><br>
	 * The following code examples illustrate a variety of different calling styles for <code>Rect</code> objects.<br><br>
	 * All components set to zero.
	 * <pre class="code">var style1 = new Core.Rect();</pre>
	 *
	 * Copy an existing <code>rect</code>.
	 * <pre class="code">var style2 = new Core.Rect(style1);</pre>
	 *
	 * Specify a point and size.
	 * <pre class="code">var style3 = new Core.Rect(new Core.Point(), new Core.Size());</pre>
	 *
	 * Specify four components.
	 * <pre class="code">var style4 = new Core.Rect(0, 0, 100, 100);</pre>
	 * @augments Core.Class
	 * @param {Core.Point} [origin=0] The rectangle point of origin.
	 * @param {Core.Size} [size=0] The rectangle size.
	 * @throws {Wrong number of arguments for a Rect} Number of parameters passed by this call is invalid.
	 */
	initialize: function(origin, size)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._origin = new Point();
				this._size = new Size();
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._origin = new Point();
					this._size = new Size();
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (rect)
					this._origin = new Point(rhs.getOrigin());
					this._size = new Size(rhs.getSize());
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._origin = new Point();
							this._size = new Size();
							break;
						case 1:
							// ([rect])
							rhs = rhs[0];
							this._origin = new Point(rhs.getOrigin());
							this._size = new Size(rhs.getSize());
							break;
						case 2:
							// ([point, size])
							// ([[x, y], [width, height]])
							this._origin = new Point(rhs[0]);
							this._size = new Size(rhs[1]);
							break;
						case 4:
							// ([x, y, width, height])
							this._origin = new Point(rhs[0], rhs[1]);
							this._size = new Size(rhs[2], rhs[3]);
							break;
						default:
							throw new Error('Wrong number of arguments for a Rect');
					}
				}
				break;
			case 2:
				// (point, size)
				this._origin = new Point(arguments[0]);
				this._size = new Size(arguments[1]);
				break;
			case 4:
				// (x, y, width, height)
				this._origin = new Point(arguments[0], arguments[1]);
				this._size = new Size(arguments[2], arguments[3]);
				break;
			default:
				throw new Error('Wrong number of arguments for a Rect');
		}
	},
	
	/**
	 * Set the value of all components for this <code>rect</code>. 
	 * @param {Core.Point} [origin=0] The new point of origin.
	 * @param {Core.Size} [size=0] The new rectangle size.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function(origin, size)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate the point of origin of this <code>rect</code>.
	 * @returns {Core.Point} A new rectangle with an identical origin and size.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the point of origin for this <code>rect</code>.
	 * @returns {Core.Point} The current point of origin.
	 * @see Core.Rect#setOrigin
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getOrigin: function()
	{
		return this._origin;
	},
	
	/**
	 * Set the point of origin for this <code>rect</code>.
	 * @param {Core.Point} origin The new point of origin.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#getOrigin
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setOrigin: function(origin)
	{
		this._origin.setAll(origin);
		return this;
	},
	
	/**
	 * Change the point of origin so that the center of this <code>rect</code> is at the specified location.
	 * @param {Core.Point} origin The new point of origin that results in a rectangle with a center position at the specified location.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#setSizeCentered,
	 * @see Core.Rect#setOrigin
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setOriginCentered: function(origin)
	{
		origin = new Core.Point(origin);
		this._origin.setX(origin.getX() - this._size.getWidth()/2);
		this._origin.setY(origin.getY() - this._size.getHeight()/2);
		return this;
	},
	
	/**
	 * Retrieve the size of this <code>rect</code>.
	 * @returns {Core.Size} The current rectangle size.
	 * @see Core.Rect#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSize: function()
	{
		return this._size;
	},
	
	/**
	 * Set the size of this <code>rect</code>.
	 * @param {Core.Size} size The new rectangle size.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#getSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSize: function(size)
	{
		this._size.setAll(size);
		return this;
	},
	
	/**
	 * Set the size of this <code>rect</code> and preserve the current center position.
	 * @param {Core.Size} size The new rectangle size that retains the current center position.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#setOriginCentered,
	 * @see Core.Rect#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSizeCentered: function(size)
	{
		var oldWidth = this._size.getWidth();
		var oldHeight = this._size.getHeight();
		
		this._size.setAll(size);

		this._origin.setX(this._origin.getX() + oldWidth/2 - this._size.getWidth()/2);
		this._origin.setY(this._origin.getY() + oldHeight/2 - this._size.getHeight()/2);
		return this;
	},
	
	/**
	 * Retrieve the minimum value for <i>x</i>. This is represented by the left coordinate.
	 * @returns {Number} The current minimum value of  the <i>x</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMinX: function()
	{
		return this._origin.getX();
	},
	
	/**
	 * Retrieve the average of the minimum and maximum <i>x</i> values. This is the middle coordinate.
	 * @returns {Number} The current average of the minimum and maximum <i>x</i> coordinate values. 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMidX: function()
	{
		return this._origin.getX() +  this._size.getWidth()/2;
	},
	
	/**
	 * Retrieve the maximum value for <i>x</i>. This is the right coordinate.
	 * @returns {Number} The current maximum value of the <i>x</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMaxX: function()
	{
		return this._origin.getX() + this._size.getWidth();
	},
	
	/**
	 * Retrieve the minimum value for <i>y</i>. This is the top coordinate.
	 * @returns {Number} The current minimum value of the <i>y</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMinY: function()
	{
		return this._origin.getY();
	},
	
	/**
	 * Retrieve the average of the minimum and maximum <i>y</i> values. This is the middle coordinate.
	 * @returns {Number} The current average of the minimum and maximum <i>y</i> coordinate values.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMidY: function()
	{
		return this._origin.getY() + this._size.getHeight()/2;
	},
	
	/**
	 * Retrieve the maximum value for <i>y</i>. This is the bottom coordinate.
	 * @returns {Number} The current maximum value of the <i>y</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMaxY: function()
	{
		return this._origin.getY() + this._size.getHeight();
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/AbstractView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/AbstractView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/AbstractView'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Rect = require('NGCore/Client/UI/ViewGeometry').Rect;

var AbstractView = exports.AbstractView = Element.subclass(
/** @lends UI.AbstractView.prototype */
{
	'type':'<com.ngmoco.view.abstract>',
	/**
	* @class The <code>AbstractView</code> class is a base class for derived classes that handle and manage application views.<br><br>
	* <b>Caution!:</b> This base class is not exported in the UI module. Do not access it or subclass it at runtime. 
	* Derived classes from <code>AbstractView</code> include:
	* <div class="ul">
	 * <li>{@link UI.Button}</li>
	 * <li>{@link UI.CellView}</li>
	 * <li>{@link UI.CheckBox}</li>
	 * <li>{@link UI.CheckoutView}</li>
	 * <li>{@link UI.DocumentView}</li>
	 * <li>{@link UI.EditText}</li>
	 * <li>{@link UI.GLView}</li>
	 * <li>{@link UI.Image}</li>
	 * <li>{@link UI.Label}</li>
	 * <li>{@link UI.Spinner}</li>
	 * <li>{@link UI.View}</li>
	 * <li>{@link UI.WebView}</li>
	 * </div>
	* @constructs The default constructor.
	* @augments UI.Element
	* @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	* @param {String} properties Object properties.
	*/
	initialize: function($super, properties) {
		if (AbstractView._init) AbstractView._init();
		
		this._assignedVisible = true;
		$super(properties);
	},
	
	/** @private */
	destroy: function($super){
		this.removeFromParent();
		$super();
	},
	
	/**
	 * @function 
	 * @description Retrieve the parent node for this view.
	 * @returns Returns the parent if this view is a child of another element. Otherwise, returns undefined.
	 * @see UI.AbstractView#addToParent,
	 * @see UI.AbstractView#removeFromParent
	 */    
	getParent: function(){
		return this._parent;
	},
    
	/**
	 * Add a node at the specified index to the specified parent node.
	 * @example var myParent = new UI.View({
	 * 	...
	 * });
	 * var childNode = new UI.View({
	 *	...
	 * });
	 * ...
	 * childNode.addToParent(myParent); 
	 * @function
	 * @param {Object} parentNode The parent node.
	 * @param {Number} [index] The parent node index location.
	 * @see UI.AbstractView#getParent,
	 * @see UI.AbstractView#removeFromParent
	 */    
	addToParent: function(parentNode, index){
		parentNode.addChild(this, index);
	},
    
	/**
	 * Remove a node from the parent node.
	 * @example childNode.removeFromParent(myParent);
	 * @function 
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see UI.AbstractView#getParent,
	 * @see UI.AbstractView#addToParent
	 */    
	removeFromParent: function(){
		if (this._parent && !this._parent._destroyed) {
			this._parent.removeChild(this);
			this._parent = null;
		}
		return this;
	},
	
	
	/**
	 * Add a new view state.
	 * @function 
	 * @example this.addState(UI.State.Disabled);
	 * @param {UI.State} flags View state flags supported by the new view state.
	 * @see UI.AbstractView#getState,
	 * @see UI.AbstractView#setState,
	 * @see UI.AbstractView#clearState
	 */  
	addState: function(flags) {
		this.setState(this._state | flags);
	},
	
	/**
	 * Clear the view state and set view state flags to the default value.
	 * @function 
	 * @example this.clearState(UI.State.Disabled);
	 * @param {UI.State} flags
	 * @see UI.AbstractView#getState,
	 * @see UI.AbstractView#setState,
	 * @see UI.AbstractView#addState
	 */  
	clearState: function(flags) {
		this.setState(this._state & ~flags);
	},
    
	/**
	 * Retrieve the root node for this object.
	 * @function 
	 * @returns Returns the root node if this is a child node. Otherwise, returns undefined.
	 */
	getRoot: function() {
		return this._parent ? this._parent.getRoot() : undefined;
	},
    

	/** @protected */
	_setVisible: function(makeVisible) {
		var willBeVisible = makeVisible && this._assignedVisible && this._parent && this._parent._visible;
		if (this._visible != willBeVisible) {
			this._visible = willBeVisible;
			var fn = (makeVisible ? this.getOnAppear() : this.getOnDisappear());
			if (typeof fn == 'function') fn.call(this);
		}
	}
});

// Properties
AbstractView._init = function() {
	delete AbstractView._init;
	if (Element._init) Element._init();
	
	var getVisible = function() {
		return this._visible;
	};
	var setVisible = function(makeVisible) {
		this._assignedVisible = makeVisible;
		Commands.setIsVisible.call(this, makeVisible);
		this._setVisible(makeVisible);
	};
	/**
	 * @name UI.AbstractView#setVisible
	 * @description Set the visibility for this object.
	 * @example SomeView = new UI.View();
	 * ...
	 * SomeView.setVisible(true);
	 * @function 
	 * @param {boolean} makeVisible Set as <code>true</code> if this object is visible.
	 * @see UI.AbstractView#getVisible
	 */
	/**
	 * @name UI.AbstractView#getVisible
	 * @description Retrieve the state of visibility for this object.
	 * @function
	 * @returns {boolean} Returns <code>true</code> if this object is visible.
	 * @see UI.AbstractView#setVisible
	 */
	AbstractView.registerAccessors('visible', getVisible, setVisible);
	
	/**
	 * @name UI.AbstractView#setBackgroundColor
	 * @description Set the value for the <code>backgroundColor</code> property. This property defines the color of the background for an object when rendered.
	 * @example SomeView = new UI.View();
	 * ...
	 * SomeView.setBackgroundColor("FF000000");
	 * @param {String} backgroundColor The new background color.
	 * @see UI.AbstractView#getBackgroundColor
	 * @type Color
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getBackgroundColor
	 * @description Retrieve the value of the <code>backgroundColor</code> property.
	 * @returns {String} The current background color.
	 * @see UI.AbstractView#setBackgroundColor
	 * @function
	 */
	AbstractView.synthesizeProperty('backgroundColor', Commands.setBackgroundColor);
	/**
	 * @name UI.AbstractView#setEnabled
	 * @description Set the value for the <code>enabled</code> property. This property defines an object as active or inactive.
	 * @param {Boolean} enabled Set as <code>true</code> if this view state is enabled.
	 * @see UI.AbstractView#getEnabled
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getEnabled
	 * @description Retrieve the value of the <code>enabled</code> property. 
	 * @returns {Boolean} Returns <code>true</code> if this view state is enabled.
	 * @see UI.AbstractView#setEnabled
	 * @function
	 */
	
	AbstractView.synthesizeProperty('enabled', function(enable) {
		this[ (enable ? 'clearState' : 'setState') ](Commands.State.Disabled);
	});
	/**
	 * @name UI.AbstractView#setState
	 * @description Set the value for the <code>state</code> property. This property defines the view state for an object.
	 * @example cellView.setState(UI.State.Normal);
	 * @param {Number} state The new view state.
	 * @see UI.AbstractView#getState
	 * @type State
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getState
	 * @description Retrieve the value of the <code>state</code> property.
	 * @returns {Number} The current view state.
	 * @see UI.AbstractView#setState
	 * @function
	 */
	AbstractView.synthesizeProperty('state', Commands.setState);

	
	/**
	 * @name UI.AbstractView#getFrame
	 * @description Retrieve the value of the <code>frame</code> property.
	 * @param {Number, Array (Number)} frame Individual components or a component array (<i>x</i>,<i>y</i>,<i>w</i>,<i>h</i>).
	 * @see UI.AbstractView#setFrame
	 * @function
	 */
	var getFrame = function() {
		return this._frame;
	};
	/**
	 * @name UI.AbstractView#setFrame
	 * @function 
	 * @description Set the value of the <code>frame</code> property. This property defines the size of <code>frame</code> objects.
	 * @example var back = new UI.Button();
	 * ...
	 * back.setFrame([10, 10, 64, 64]);
	 * @param {Number, Array (Number), Object} arg0 This parameter will pass in values in one of three ways:
	 * <div class="ul">
	 * <li>Four float values (<i>x</i>, <i>y</i>, <i>w</i>, <i>h</i>).</li>
	 * <li>Single array containing the above four values.</li>
	 * <li>A rect specifying the frame (see <code>{@link UI.ViewGeometry.Rect}</code>).</li>
	 * </div>
	 * @see UI.AbstractView#getFrame
	 * @function
	 */
	var setFrame = function(arg0) {
		if( arg0 instanceof Rect ){
			this._frame = arg0.array();
		}
		else if( arg0 instanceof Array ){
			this._frame = arg0;
		}
		else {
			this._frame = Array.prototype.slice.call(arguments);
		}
		Commands.setFrame.apply(this, this._frame);
	};
	AbstractView.registerAccessors('frame', getFrame, setFrame);

	/**
	 * @name UI.AbstractView#setGradient
	 * @description Set the value of the <code>gradient</code> property for a view state. This property defines an image gradient for the object when rendered.
	 * @example label.setGradient({
	 *	corners: '11 11 11 11',
	 *	gradient: ['FFFF8000 0.0', 'FF703300 1.0']
	 * }, UI.State.Selected);
	 * @param {Object} gradient The new gradient. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.AbstractView#getGradient
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getGradient
	 * @description Retrieve the value of the <code>gradient</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current gradient.
	 * @see UI.AbstractView#setGradient
	 * @function	
	 */
	AbstractView.synthesizePropertyWithState('gradient', Commands.setGradient);	
	/**
	 * @name UI.AbstractView#setBlockTouchEvents
	 * @description Set the value of the <code>blockTouchEvents</code> property.
	 * @param {Object} blockTouchEvents The new value for <code>blockTouchEvents</code>.
	 * @see UI.View#getBlockTouchEvents
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getBlockTouchEvents
	 * @description Retrieve the value of the <code>blockTouchEvents</code> property.
	 * @returns {Object} The current value of <code>blockTouchEvents</code>.
	 * @see UI.View#setBlockTouchEvents
	 * @function
	 */
	AbstractView.synthesizeProperty('touchable', Commands.setTouchable);
	/**
	 * @name UI.AbstractView#setAlpha
	 * @function
	 * @description Set the value of the <code>alpha</code> property. This property defines the level of alpha composting for a specified object when rendered.
	 * @example this._node.setAlpha(1);
	 * @param {Number} decimal Alpha value ranging between <code>(0.0-1.0)</code>.
	 * @see UI.AbstractView#getAlpha
	 * @type Float
	 * @status iOS
	 */
	/**
	 * @name UI.AbstractView#getAlpha
	 * @function
	 * @description Retrieve the value of the <code>alpha</code> property.
	 * @returns {Number} Alpha value ranging between </code>(0.0-1.0)</code>.
	 * @see UI.AbstractView#setAlpha
	 * @type Float
	 * @status
	 */
	AbstractView.synthesizeProperty('alpha', Commands.setAlpha);




	// Event Handlers
	/**
	 * @name UI.AbstractView#setOnAppear
	 * @description Set a function to call when the <code>appear</code> event occurs.
	 * @param {Function} appearCallback The new callback function. <br><br><b>Note:</b> The <code>appear</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onAppear.appear = true; 
	 * };
	 * @see UI.AbstractView#event:getOnAppear
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnAppear
	 * @description Retrieve the function to call when the <code>appear</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnAppear
	 * @event
	 */
	AbstractView.registerEventType('appear');
	/**
	 * @name UI.AbstractView#setOnDisappear
	 * @description Set a function to call when the <code>disappear</code> event occurs.
	 * @param {Function} disappearCallback The new callback function. <br><br><b>Note:</b> The <code>disappear</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onDisappear.disappear = true; 
	 * };
	 * @see UI.AbstractView#event:getOnDisappear
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnDisappear
	 * @description Retrieve a function to call when the <code>disappear</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnDisappear
	 * @event
	 */
	AbstractView.registerEventType('disappear');
	/**
	 * @name UI.AbstractView#setOnClick
	 * @description Set a function to call when the <code>click</code> event occurs.
	 * @param {Function} clickCallback The new callback function. <br><br><b>Note:</b> The <code>click</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onClick.clicked = true; 
	 * };
	 * @see UI.AbstractView#event:getOnClick
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnClick
	 * @description Retrieve a function to call when the <code>click</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnClick
	 * @event
	 */
	AbstractView.registerEventType('click');
	/**
	 * @name UI.AbstractView#setOnSwipe
	 * @description Set a function to call when a <code>swipe</code> event occurs. 
	 * This is when the user swipes a finger across this view, similar to how a user indicatea a "delete row"
	 * request on a table view.  The function gets the <code>UI.Commands.SwipeDirection</code> from 
	 * the first <code>parameter.direction</code>.  
	 * @example
	 * view.setOnSwipe( function(params) { 
	 *	NgLogD("swipe code "+params.direction) 
	 *   } 
	 * );
	 * @param {Function} clickCallback The new callback function. <br><br><b>Note:</b> The <code>swipe</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.AbstractView#event:getOnSwipe
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnSwipe
	 * @description Retrieve a function to call when the <code>swipe</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnSwipe
	 * @event
	 */
	AbstractView.registerEventType('swipe');
	/**
	 * @name UI.AbstractView#setOnLongPress
	 * @description Set a function to call when a user taps and holds on a view. 
	 * @param {Function} clickCallback The new callback function. <br><br><b>Note:</b> The event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onLongPress.longpress = true; 
	 * };
	 * @see UI.AbstractView#event:getOnLongPress
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnLongPress
	 * @description Retrieve a function to call when a <code>tap and hold</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnLongPress
	 * @event
	 */
	AbstractView.registerEventType('longPress');

	/** @private NOT IMPLEMENTED */
	/*
		AbstractView.registerEventType('touchdown');
		AbstractView.registerEventType('touchup');
		AbstractView.registerEventType('touchmove');
		AbstractView.registerEventType('touchcancel');
	*/
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/WindowLayer'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/WindowLayer'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/WindowLayer'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var ViewParent = require('NGCore/Client/UI/ViewParent').ViewParent;
var Commands = require('NGCore/Client/UI/Commands').Commands;

/** @private
 * 	This ENTIRE CLASS is private.
 */
var WindowLayer = exports.WindowLayer = Element.subclass( {
	'type':'windowlayer',
	initialize: function($super, props) {
		if (WindowLayer.init) WindowLayer.init();
		$super(props);
		if (WindowLayer._init) WindowLayer._init();
		ViewParent.initialize.call(this);
		this._visible = true;
	},
	getRoot: function(){
		return this;
	},
	getParent: function(){
		return undefined;
	},
	
	getChildCount: ViewParent.getChildCount,
	getChildren: ViewParent.getChildren,
	addChild: ViewParent.addChild,
	removeChild: ViewParent.removeChild
});

WindowLayer.init = function() {
	delete WindowLayer._init;
	if (Element._init) Element._init();
	
	WindowLayer.synthesizeProperty('level', Commands.setIntValue);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ViewParent'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ViewParent'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ViewParent'] = exports; var Commands = require('NGCore/Client/UI/Commands').Commands;
var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;

// CAREFUL! THIS IS NOT A CLASS!
exports.ViewParent = {
	initialize : function() {
		this._children = [];
	},

	getChildCount : function() {
		return this._children.length;
	},

	getChildren : function() {
		return this._children.slice();
	},

	addChild : function(childNode,index) {
		if (childNode === this) throw new Error("Cannot add " + childNode + " as a child of itself!");
		if (childNode instanceof AbstractView) {
			if (childNode._parent) childNode.removeFromParent();

			if (index === 0 || index > 0) {
				index = +index;
				this._children.splice(index, 0, childNode);
			} else {
				index = -1;
				this._children.push(childNode);
			}

			// Must populate parent before setting visibility
			childNode._parent = this;
			childNode._setVisible(this._visible);

			Commands.addSubview.call(this, childNode.__objectRegistryId, index);

		} else throw new Error(this.type + ".addChild: " + childNode + " is not a view!");
		return this;
	},

	removeChild : function(childNode) {
		if (childNode instanceof AbstractView) {
			if (childNode._parent == this) {
				childNode._setVisible(false);

				// Remove this node from parent's child list
				var nodeIndex = this._children.indexOf(childNode);
				if (nodeIndex != -1) {
					this._children.splice(nodeIndex, 1);
				}
			}
			// Clear parent value
			childNode._parent = undefined;

			// Remove from the parent at the system level
			Commands.removeFromSuperview.call(childNode);
		} else throw {message: this.type + ".removeChild: " + childNode + " is not a view!"};
		return childNode;
	}

};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2'] = exports; /**
 * <p>Classes and objects contained by the GL2 module.</p>
 * @name GL2
 * @namespace
 * @description <p>The GL2 module is a collection of classes that support manipulation of visual effects and frameworks in an application.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 * <li><code>{@link GL2.Animation}</code>: Control animations in applications.</li>
 * <li><code>{@link GL2.Node}</code>: Control positionable screen elements.</li>
 * <li><code>{@link GL2.Primitive}</code>: Control the drawing of arbitrary vertex-based geometry.</li>
 * <li><code>{@link GL2.Root}</code>: A singleton that acts as a proxy object for the GLView node hierarchy 
 * (<code>Root</code> is the root element of the node hierarchy for GL2View).</li>
 * <li><code>{@link GL2.Sprite}</code>: Control resources for and use of application sprites.</li>
 * <li><code>{@link GL2.Text}</code>: Control resources for and use of application text.</li>
 * <li><code>{@link GL2.Touch}</code>: Control objects that track touch events for a device.</li>
 * <li><code>{@link GL2.TouchTarget}</code>: Control objects that support physical touch events on a device.</li>
 * <li><code>{@link GL2.RenderTarget}</code>: Render GL2 Nodes into a texture, which can then be attached to a GL.Animation</li>
 * </ul>
 * Games must instantiate a {@link UI.GLView} object, set the active state to <code>true</code> and wait for the callback before instantiating any objects in the GL2 class.
 */
exports.GL2 = {};

exports.GL2.__defineGetter__("Animation", function() {
	delete this.Animation;
	return this.Animation = require('NGCore/Client/GL2/Animation').Animation;
});
exports.GL2.__defineGetter__("Node", function() {
	delete this.Node;
	return this.Node = require('NGCore/Client/GL2/Node').Node;
});
exports.GL2.__defineGetter__("Primitive", function() {
	delete this.Primitive;
	return this.Primitive = require('NGCore/Client/GL2/Primitive').Primitive;
});
exports.GL2.__defineGetter__("Touch", function() {
	delete this.Touch;
	return this.Touch = require('NGCore/Client/GL2/Touch').Touch;
});
exports.GL2.__defineGetter__("TouchTarget", function() {
	delete this.TouchTarget;
	return this.TouchTarget = require('NGCore/Client/GL2/TouchTarget').TouchTarget;
});
exports.GL2.__defineGetter__("Root", function() {
	delete this.Root;
	return this.Root = require('NGCore/Client/GL2/Root').Root;
});
exports.GL2.__defineGetter__("Sprite", function() {
	delete this.Sprite;
	return this.Sprite = require('NGCore/Client/GL2/Sprite').Sprite;
});
exports.GL2.__defineGetter__("Text", function() {
	delete this.Text;
	return this.Text = require('NGCore/Client/GL2/Text').Text;
});
exports.GL2.__defineGetter__("RenderTarget", function() {
	delete this.RenderTarget;
	return this.RenderTarget = require('NGCore/Client/GL2/RenderTarget').RenderTarget;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/util/Vector'] = function(){var exports = $MODULE_REGISTRY['Code/util/Vector'] || {}; $MODULE_REGISTRY['Code/util/Vector'] = exports; var Core = require('NGCore/Client/Core').Core;

var exports = {};


var Vector2 = Core.Class.subclass({
	initialize: function(){
		this.x = arguments[0] || 0;
		this.y = arguments[1] || 0;
	},
	
	length: function(){
		return Math.sqrt(this.x * this.x + this.y * this.y);
	},
	
	lengthSqrd: function(){
		return this.x * this.x + this.y * this.y;
	},	
	
	$add: function(v1, v2){
		return new Vector2(v1.x + v2.x, v1.y + v2.y);
	},
	
	$subtract: function(v1, v2)
	{
		return new Vector2(v1.x - v2.x, v1.y - v2.y);
	},
	
	$multiply: function(v1, v2){
		return new Vector2(v1.x * v2.x, v1.y * v2.y);
		
	},
	
	$divide: function(v1, v2){
		return new Vector2(v1.x / v2.x, v1.y / v2.y);
	},
	
	$scale: function(v1, s){
		return new Vector2(v1.x * s, v1.y * s);
	},
	
	normalize: function(){
		var tempVec = Vector2.scale(this, 1 / this.length());
		this.x = tempVec.x;
		this.y = tempVec.y;
	},
	
	$normalized: function() {
		return Vector2.scale(this, 1 / this.length());
	},
	
	toLength: function(l){
		this.normalize();
		
		var tempVec = Vector2.scale(this, l);
		this.x = tempVec.x;
		this.y = tempVec.y;
		
	},
	
	clone: function() {
		return new Vector2(this.x, this.y);
	},
	
	rotated: function(angle){
		return new Vector2(this.x * Math.cos(angle) - this.y * Math.sin(angle), this.y * Math.cos(angle) + this.x * Math.sin(angle));
	},

	$isEqual: function(v1, v2)
	{
		return (v1.x == v2.x && v1.y == v2.y);
	},
	
	$dot: function(v1, v2)
	{
		return (v1.x * v2.x + v1.y * v2.y);
	},
	
	$angle: function(v1, v2){
		return (Math.acos(Vector2.dot(v1.normalized(), v2.normalized())));
	},
	
	getEuler: function()
	{
		return Math.acos(Vector2.dot(this.normalized(), new Vector2(1, 0))) * (this.y < 0 ? -1 : 1);
	},
	
	$getNegativeRotation: function(v)
	{
		return -Math.acos(Vector2.dot(v.normalized(), new Vector2(1, 0))) * (v.y < 0 ? -1 : 1);
	},
	
});

var Vector3 = Core.Class.subclass({
	initialize: function(){
		this.x = arguments[0] || 0;
		this.y = arguments[1] || 0;
		this.z = arguments[2] || 0;
	},
	
	$add: function(v1, v2){
		return new Vector3(v1.x + v2.x, v1.y + v2.y, v1.z + v2.z);
	},
	
	$subtract: function(v1, v2){
		return new Vector3(v1.x - v2.x, v1.y - v2.y, v1.z - v2.z);
	},
	
	$multiply: function(v1, v2)
	{
		return new Vector3(v1.x * v2.x, v1.y * v2.y, v1.z * v2.z);
	},
	
	$divide: function(v1, v2){
		return new Vector3(v1.x / v2.x, v1.y / v2.y, v1.z, v3.z);
	},
	
	$scale: function(v1, s)
	{
		return new Vector3(v1.x * s, v1.y * s, v1.z * s);
	},
	
	clone: function() {
		return new Vector3(this.x, this.y, this.z);
	},
	
	$isEqual: function(v1, v2)
	{
		return (v1.x == v2.x && v1.y == v2.y && v1.z == v2.z);
	},
	
	length: function()
	{
		return Math.sqrt(this.x * this.x + this.y * this.y + this.z * this.z);	
	},
	
	lengthSqrd:function()
	{
		return this.x * this.x + this.y * this.y + this.z * this.z;
	},
	
	normalized: function() 
	{
		return Vector3.scale(this, 1 / this.length());
	},
	
	normalize: function(){
		var tempVec = Vector3.scale(this, 1 / this.length());
		this.x = tempVec.x;
		this.y = tempVec.y;
		this.z = tempVec.z;
	},
	
	toLength: function(l){
		var tempVec = Vector3.scale(this.normalized(), l);
		this.x = tempVec.x;d
		this.y = tempVec.y;
		this.z = tempVec.z;
		
	},
	
	$dot: function(v1, v2)
	{
		return v1.x * v2.x + v1.y * v2.y + v1.z * v2.z;
	},
	
	$cross: function(v1, v2){
		return new Vector3(v1.y * v2.z - v1.z * v2.y, v1.z * v2.x - v1.x * v2.z, v1.x * v2.y - v1.y * v2.x);
	},
	
	$rotate: function(v, axis, angle){
		var Z = axis.normalized();
		var Y = Vector3.cross(Z, v).normalized();
		var X = Vector3.cross(Y, Z).normalized();
		
		var l = Vector3.dot(v, X);
		var temp = Vector3.scale(Vector3.scale(X, Math.cos(angle)) + Vector3.scale(Y * Math.sin(angle)), l);
		var temp2 = Vector3.dot(Z, v);
		temp2 = Vector3.multiply(Z, temp2);
		return Vector3.add(temp1, temp2);
		
	},
	
});

var constant = Core.Class.subclass({
	$degrees: function(r){
		return r * 180 / Math.PI;
	},
	
	$radians: function(d) {
		return d * Math.PI / 180;
	},
});

exports.Vector2 = Vector2;
exports.Vector3 = Vector3;
exports.constant = constant;
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Level'] = function(){var exports = $MODULE_REGISTRY['Code/Level'] || {}; $MODULE_REGISTRY['Code/Level'] = exports; var Core = require('NGCore/Client/Core').Core;
var Device = require('NGCore/Client/Device').Device;
var GL2 = require('NGCore/Client/GL2').GL2;
var Physics2 = require('NGCore/Client/Physics2').Physics2;
var Storage = require('NGCore/Client/Storage').Storage;

var Cannon = require('Code/Cannon').Cannon;
var GameConstants = require('Code/GameConstants').GameConstants;
var Ragdoll = require('Code/Ragdoll').Ragdoll;
var Spring = require('Code/Spring').Spring;
var Target = require('Code/Target').Target;
var Vector2 = require('Code/util/Vector').Vector2;
var Vector3 = require('Code/util/Vector').Vector3;
var JSON = require('Code/util/json2').JSON;
var SaveData = require('Code/util/SaveData').SaveData;
var Updaters = require('Code/Updaters').Updaters;
var BFAudio = require('Code/util/BFAudio').BFAudio;
var AnimatedSprite = require('Code/AnimatedSprite').AnimatedSprite;

var exports = {};

var self;

var LevelState = {
	LOAD: 1,
	FALL_IN: 2,
	FALL_OUT: 3,
	PLAY: 4,
	
}

var Level = Core.MessageListener.subclass({
	initialize: function(){
		this.m_json;
		this.m_cannon;
		this.m_current_touch_id;
		this.m_node = new GL2.Node();
		this.m_reset_button;
		this.m_menu_button;
		this.m_fall_in_time = 0;
		this.m_won = false;
		this.m_last_fire_time = 0;
		this.m_toppest_object;
		this.m_emitter;
		this.m_current_shots = 0;
		this.m_best = 0;
		this.m_total_updates = 0;
		this.m_updates = 0;
		this.m_update_times = new Array();
		this.m_update_times.push(0);
		this.m_update_times.push(0);
		this.m_update_times.push(0);
		this.m_update_times.push(0);
		this.m_update_times.push(0);
		this.m_update_times.push(0);
		GL2.Root.addChild(this.m_node);
		
		
		
		// bg
		this.m_background = new GL2.Sprite();
		this.m_background.setImage("Content/paper_background.png", [GameConstants.SCREEN_HEIGHT, GameConstants.SCREEN_WIDTH], [0, 0]);
		this.m_node.addChild(this.m_background);
		
		// set up the physics world
		this.m_world = new Physics2.World();
		//this.m_world.setGravity(new Core.Vector(0, 500 / (GameConstants.BOX2D_SCALE * GameConstants.TIME_SCALE * GameConstants.TIME_SCALE)));
		this.m_world.setGravity(new Core.Vector(0, 1 * GameConstants.ORIGINAL_WIDTH / GameConstants.BOX2D_SCALE));
		console.log("Gravity is now: " + this.m_world.getGravity().getY());
		this.m_world.setTimeScale(GameConstants.TIME_SCALE);
		if (GameConstants.SIMULATE_SHIT_DEVICE) {
			this.m_world.setVelocityIterations(1);
			this.m_world.setPositionIterations(1);
		}
		console.log("pos iter: " + this.m_world.getPositionIterations());
		console.log("velo iter: " + this.m_world.getVelocityIterations());
		if (GameConstants.DEBUG) {
			this.m_world.setDebugDrawFlags(Physics2.World.DebugDrawFlags.Shapes | Physics2.World.DebugDrawFlags.Joints);
			this.m_world.setDebugDrawGL2Node(this.m_node);
			
			this.m_fps = new GL2.Text();
			this.m_fps.setText(0.00);
			this.m_node.addChild(this.m_fps);
			this.m_fps.setPosition(430 * GameConstants.HEIGHT_SCALE, 25 * GameConstants.WIDTH_SCALE);
			this.m_fps.setColor(0, 0, 0);
			this.m_fps.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
			
			
			this.m_error_log = new GL2.Text();
			this.m_error_log.setPosition(GameConstants.SCREEN_HEIGHT / 2, GameConstants.SCREEN_WIDTH / 2);
			this.m_error_log.setColor(0, 0, 0);
			this.m_node.addChild(this.m_error_log);
			
			//this.createStiffnessUI();
		}
		this.m_ragdolls = new Array();
		for (var idx = 0; idx < GameConstants.MAX_DOLLS; idx++) {
			var temp_doll = new Ragdoll(new Vector2(-1000, -1000), this.m_world, this.m_node, 0);
			this.m_ragdolls.push(temp_doll);
		}
		this.m_static_objects = new Array();
		this.m_dynamic_objects = new Array();
		this.m_targets = new Array();
		this.m_all_objects = new Array();
		this.m_joints = new Array();
		this.m_generics = new Array();
		this.m_springs = new Array();
		
		this.m_emitter = new Core.MessageEmitter();
		
		this.m_old_crosshair = new GL2.Sprite();
		this.m_old_crosshair.setImage("Content/crosshair.png", [96 * GameConstants.HEIGHT_SCALE, 96 * GameConstants.WIDTH_SCALE]);
		this.m_old_crosshair.setColor(0.5, 0.5, 0.5);
		this.m_old_crosshair.setPosition(-1000, -1000); // set to an invalid pos, this will be fixed when it's actually needed
		this.m_node.addChild(this.m_old_crosshair);
		
		this.m_current_crosshair = new GL2.Sprite();
		this.m_current_crosshair.setImage("Content/crosshair.png", [96 * GameConstants.HEIGHT_SCALE, 96 * GameConstants.WIDTH_SCALE]);
		this.m_current_crosshair.setPosition(-1000, -1000); // set to an invalid pos, this will be fixed when it's actually needed
		this.m_node.addChild(this.m_current_crosshair);
		
		// Create Touch Target
		
		this.m_touch_target = new GL2.TouchTarget();
		this.m_touch_target.setSize([GameConstants.SCREEN_HEIGHT, GameConstants.SCREEN_WIDTH]);
		this.m_touch_target.getTouchEmitter().addListener(this, this.onTouch);
		this.m_touch_target.setDepth(2);
		this.m_node.addChild(this.m_touch_target);
		
		this.m_hud_node = new GL2.Node();
		this.m_hud_node.setPosition(GameConstants.SCREEN_HEIGHT / 2, 0);
		this.m_current_text = new GL2.Text();
		this.m_current_text.setColor(0, 0, 0);
		this.m_current_text.setPosition(GameConstants.SCREEN_HEIGHT * 0.25, 0);
		this.m_current_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		this.m_current_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		this.m_current_text.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
		this.m_current_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Right);
		this.m_current_text.setVerticalAlign(GL2.Text.VerticalAlign.Top);
		this.m_current_text.setAnchor([1, 0.5]);
		this.m_hud_node.addChild(this.m_current_text);
		
		this.m_best_text = new GL2.Text();
		this.m_best_text.setColor(0, 0, 0);
		this.m_best_text.setPosition(GameConstants.SCREEN_HEIGHT * 0.49, 0);
		this.m_best_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		this.m_best_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		this.m_best_text.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
		this.m_best_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Right);
		this.m_best_text.setVerticalAlign(GL2.Text.VerticalAlign.Top);
		this.m_best_text.setAnchor([1, 0.5]);
		this.m_hud_node.addChild(this.m_best_text);
		
		this.m_name_text = new GL2.Text();
		this.m_name_text.setColor(0, 0, 0);
		this.m_name_text.setPosition(GameConstants.SCREEN_HEIGHT * -0.5 + 10 * GameConstants.HEIGHT_SCALE, 0);
		this.m_name_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		this.m_name_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		this.m_name_text.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
		this.m_name_text.setAnchor(0, 0.5);
		this.m_name_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		this.m_name_text.setVerticalAlign(GL2.Text.VerticalAlign.Top);
		
		this.m_hud_node.addChild(this.m_name_text);
		
		this.m_smoke_effect = new AnimatedSprite("Content/smoke.png", 5, 1, 25, 136 * GameConstants.WIDTH_SCALE, 136 * GameConstants.HEIGHT_SCALE);
		this.m_smoke_effect.setColor(0, 0, 0);
		this.m_smoke_effect.pause();
		this.m_smoke_effect.gotoFrame(4);
		
		this.m_node.addChild(this.m_hud_node);
		this.updateHud();
		
		// Create Update Loop
		
		Core.UpdateEmitter.addListener(this, this.onUpdate);
		
		// Orientation Handler
		
		// 6/16/11 - Disabled because some devices don't support LandscapeRight.  it is forced earlier to LandscapeLeft
		//Device.OrientationEmitter.addListener(this, this.onOrientate);
		
		// Collision Handler
		this.m_world.getContactEmitter().addListener(this, this.onContact);
		
		self = this;
		
		this.m_state = LevelState.LOAD;
		console.log("init finished");
	},
	
	destroy: function(){
		// TODO: do this
		Core.UpdateEmitter.removeListener(this, this.onUpdate);
		this.destroyCurrentLevel();
		this.m_world.destroy();
		this.m_name_text.destroy();
		this.m_best_text.destroy();
		this.m_current_text.destroy();
		this.m_current_crosshair.destroy();
		this.m_old_crosshair.destroy();
		this.m_touch_target.destroy();
		this.m_emitter.destroy();
		if (this.m_fps) {
			this.m_fps.destroy();
		}
		if (this.m_error_log) {
			this.m_error_log.destroy();
		}
		this.m_background.destroy();
		this.m_hud_node.destroy();
		GL2.Root.removeChild(this.m_node);
		this.m_node.destroy();
		for (var idx = 0; idx < this.m_frame_parts.length; idx++) {
			this.m_frame_parts[idx].destroy();
		}
		this.m_smoke_effect.destroy();
	},
	
	spawnRagdoll: function(x, y, rot, v) {
		if (this.m_ragdolls.length >= GameConstants.MAX_DOLLS) {
			var temp = this.m_ragdolls.shift();
			temp.setVelocity(v);
			temp.setPosition(new Vector2(x, y), rot);
			this.m_ragdolls.push(temp);
			console.log("Old");
		}
		else {
			var new_doll = new Ragdoll(new Vector2(x, y), this.m_world, this.m_node, rot);
			this.m_ragdolls.push(new_doll);
			new_doll.setVelocity(v);
			console.log("New");
		}
		
	},
	
	updateHud: function() {
		this.m_current_text.setText("Score: " + (this.m_current_shots != 0 ? this.m_current_shots : "-"));
		this.m_best_text.setText("Best: " + (this.m_best != 0 ? this.m_best : "-"));
		//console.log("Timestep: " + this.m_world.getTimeStep());
		if (this.m_frame) {
			var now = new Date().getTime();
			var elapsed = now - this.m_frame_start;
			var phase_time = 750;
			if (elapsed < phase_time) {
				this.m_frame.setAlpha(elapsed / phase_time);
			}
			else if (elapsed >= phase_time && elapsed <= phase_time * 2) {
				this.m_frame.setAlpha(1);
			}
			else if (elapsed > phase_time * 2) {
				this.m_frame.setAlpha(1 - ((elapsed - phase_time * 2) / phase_time));
			}
			else if(elapsed > phase_time * 3) {
				this.m_node.removeChild(this.m_frame);
				this.destroyFrame();
			}
			else {
				this.m_frame.setAlpha(0);
			}
		}
		if (this.m_blink_reset && !this.m_won) {
			var elapsed = new Date().getTime() - this.m_blink_reset_time;
			elapsed = elapsed % 1500;
			if (elapsed > 750) {
				this.m_reset_button.sprite.setAlpha((elapsed - 750) / 750);
			}
			else {
				this.m_reset_button.sprite.setAlpha(1 - ((elapsed) / 750));
			}
			
		}
	},
	
	addListener: function(obj, func) {
		this.m_emitter.addListener(obj, func);
	},
	
	fireRagdoll: function(pos) {		
		if (this.m_state == LevelState.PLAY) {
			var p = new Vector2(pos.getX() / (GameConstants.HEIGHT_SCALE * GameConstants.BOX2D_SCALE), pos.getY() / (GameConstants.WIDTH_SCALE * GameConstants.BOX2D_SCALE));
			var v = Vector2.subtract(p, Vector2.scale(this.m_cannon.getPosition(), 1 / GameConstants.BOX2D_SCALE));
			//console.log("V: " + v.x + ", " + v.y);
			var rad = v.getEuler();
			var degrees = rad * 360 / (2 * Math.PI);
			
			var base = new Vector2(0, -1).rotated(this.m_cannon.getBaseRotation() * Math.PI / 180);
			var angle = Vector2.angle(base, v);
			angle = (angle * 360) / (2 * Math.PI);
			if (angle > this.m_cannon.getCutoffAngle()) {
				angle = this.m_cannon.getCutoffAngle();
			}
			var cross = Vector3.cross(new Vector3(base.x, base.y, 0), new Vector3(v.x, v.y, 0));
			if (cross.z < 0) {
				angle *= -1;
			}
			var ragdoll_velocity = Vector2.scale(v, 2);
			var cap = 3 * GameConstants.ORIGINAL_WIDTH / GameConstants.BOX2D_SCALE;
			console.log("Velo: " + ragdoll_velocity.length());
			if (ragdoll_velocity.length() > cap) {
				console.log("Capping?");
				ragdoll_velocity.toLength(cap);
			}
			
			ragdoll_velocity = new Vector2(0, -ragdoll_velocity.length()).rotated(angle * Math.PI / 180).rotated(this.m_cannon.getBaseRotation() * Math.PI / 180);
			var offset = new Vector2(0, -this.m_cannon.getSize()).rotated(angle * Math.PI / 180).rotated(this.m_cannon.getBaseRotation() * Math.PI / 180);
			//v.toLength(this.m_cannon.getSize());
			var loc = Vector2.add(this.m_cannon.getPosition(), offset);
			this.spawnRagdoll(loc.x, loc.y, angle + this.m_cannon.getBaseRotation(), ragdoll_velocity);
			
			var recoil_force = Vector2.scale(ragdoll_velocity, -0.01 / this.m_world.getTimeStep());
			//recoil_force = Vector2.scale(recoil_force, -0.01);
			this.m_cannon.applyImpulse(recoil_force);
			
			this.m_current_shots++;
			
			loc = Vector2.add(this.m_cannon.getPosition(), new Vector2(0, -this.m_cannon.getSmokeOffset()).rotated(angle * Math.PI / 180).rotated(this.m_cannon.getBaseRotation() * Math.PI / 180));
			this.m_cannon.setRotation(angle - 90 + this.m_cannon.getBaseRotation());
			
			this.m_smoke_effect.setRotation(this.m_cannon.getRotation());
			this.m_smoke_effect.setPosition(loc.x * GameConstants.HEIGHT_SCALE, loc.y * GameConstants.WIDTH_SCALE);
			this.m_smoke_effect.playOnce(this.m_node);
			
			BFAudio.playSound("CANNON");
		}
	},
	
	setCrosshair: function(pos) {
		this.m_current_crosshair.setPosition(pos);
		// find the distance between the touch and the cannon;
		var distance = Vector2.subtract(new Vector2(pos.getX(), pos.getY()), this.m_cannon.getPosition()).length();
		var max_distance = GameConstants.SCREEN_HEIGHT;
		var r = distance / max_distance;
		var b = 1 - r;
		this.m_current_crosshair.setColor(r, 0, b);
		
		var v = new Vector2(pos.getX() / GameConstants.HEIGHT_SCALE, pos.getY() / GameConstants.WIDTH_SCALE);
		v = Vector2.subtract(v, this.m_cannon.getPosition());
		var rad = v.getEuler();
		var degrees = (rad * 360) / (2 * Math.PI);
		
		this.m_cannon.setRotation(degrees);
		
	},
	
	onTouch: function(touch_event){
		// TODO: do this0p
		switch (touch_event.getAction()) {
			case (GL2.Touch.Action.Start):{
				if (!this.m_current_touch_id && !touch_event.getIsInside(this.m_reset_button.target) && !touch_event.getIsInside(this.m_menu_button.target)) {
					// store the ID to force single touch.
					this.m_current_touch_id = touch_event.getId();
					this.setCrosshair(touch_event.getPosition());
					return true;
				}
				break;
			}
			case (GL2.Touch.Action.End):{
				this.m_current_touch_id = null;
				if (Core.Time.getFrameTime() - this.m_last_fire_time > GameConstants.RAGDOLL_FIRE_DELAY) {
					this.setCrosshair(touch_event.getPosition());
					this.m_old_crosshair.setPosition(this.m_current_crosshair.getPosition());
					this.m_current_crosshair.setPosition(-1000, -1000);
					//this.fireRagdoll(new Core.Point(310, 21));
					this.fireRagdoll(touch_event.getPosition());
					this.m_last_fire_time = Core.Time.getFrameTime();
				}
				break;
			}
			case (GL2.Touch.Action.Move):{
				this.setCrosshair(touch_event.getPosition());
				break;
			}
		}
	},
	
	onUpdate: function(delta){
		// TODO: handle it!
		var startTime = new Date().getTime();
		var nextStart;
		switch (this.m_state) {
			case LevelState.FALL_IN:{
				this.fallIn(delta);
				break;
			}
		}
		
		if (!GameConstants.GL_DRAW) {
			var temp_pos;
			var temp_object;
			var length = this.m_all_objects.length;
			//nextStart = new Date().getTime();
			if (this.m_state == LevelState.PLAY) {
				for (var idx = 0; idx < length; idx++) {
					if (this.m_all_objects[idx].updater) {
						this.m_all_objects[idx].updater(this.m_all_objects[idx], delta);
					}
				}
			}
			//this.m_update_times[0] += (new Date().getTime() - nextStart);
			
			//nextStart = new Date().getTime();
			length = this.m_dynamic_objects.length;
			for (var idx = 0; idx < length; idx++) {
				temp_object = this.m_dynamic_objects[idx];
				temp_pos = temp_object.body.getPosition();
				temp_object.sprite.setPosition(temp_pos.getX() * GameConstants.BOX2D_HEIGHT_SCALE, temp_pos.getY() * GameConstants.BOX2D_WIDTH_SCALE);
				temp_object.sprite.setRotation(temp_object.body.getRotation() + temp_object.json.rot);
			}
			//this.m_update_times[1] += (new Date().getTime() - nextStart);
			//nextStart = new Date().getTime();
			for (var idx = 0; idx < this.m_targets.length; idx++) {
				this.m_targets[idx].update();
				if (!this.m_blink_reset && this.m_targets[idx].isOffScreen()) {
					this.m_blink_reset = true;
					this.m_blink_reset_time = new Date().getTime();
				}
			}
			if (this.m_cannon) {
				this.m_cannon.update();
				if (!this.m_blink_reset && this.m_cannon.isOffScreen()) {
					this.m_blink_reset = true;
					this.m_blink_reset_time = new Date().getTime();
				}
			}
			//this.m_update_times[2] += (new Date().getTime() - nextStart);
			//nextStart = new Date().getTime();
			
			for (var idx = 0; idx < this.m_ragdolls.length; idx++) {
				this.m_ragdolls[idx].update();
			}
			//this.m_update_times[3] += (new Date().getTime() - nextStart);
			//nextStart = new Date().getTime();
			for (var idx = 0; idx < this.m_springs.length; idx++) {
				this.m_springs[idx].update();
			}
			//this.m_update_times[4] += (new Date().getTime() - nextStart);
			if (this.m_state == LevelState.FALL_OUT) {
				for (var idx = 0; idx < this.m_static_objects.length; idx++) {
					temp_object = this.m_static_objects[idx];
					if (temp_object.body && temp_object.sprite) {
						temp_pos = temp_object.body.getPosition();
						temp_object.sprite.setPosition(temp_pos.getX() * GameConstants.BOX2D_HEIGHT_SCALE, temp_pos.getY() * GameConstants.BOX2D_WIDTH_SCALE);
						temp_object.sprite.setRotation(temp_object.body.getRotation() + temp_object.json.rot);
					}
				}
				
				// check the position of the toppest object to see if we're done falling out
				//if (this.m_toppest_object.body.getPosition().getY() > GameConstants.SCREEN_HEIGHT / GameConstants.BOX2D_SCALE * 2) {
				if(new Date().getTime() - this.m_fallout_start > 3000) {
					console.log("WINNING");
					// TODO: LoadNextLevel
					this.m_state = LevelState.LOAD;
					this.m_emitter.emit(["GETNEXT", this.m_level_no]);
				}
			}
		}
		if (GameConstants.DEBUG) {
			var tempString = (this.m_fps.getText() * 0.9 + (100 / delta)).toFixed(2);
			this.m_fps.setText(tempString);
		}
		//nextStart = new Date().getTime();
		this.updateHud();
		//this.m_update_times[5] += (new Date().getTime() - nextStart);
		//var elapsed = new Date().getTime() - startTime;
		//this.m_updates++;
		//this.m_total_updates += elapsed;
		//console.log("Update took: " + elapsed);
		//console.log("Here's my delta: " + delta);
		//console.log("Old timestep: " + this.m_world.getTimeStep());
		//this.m_world.setTimeStep(delta / 1000);
		//console.log("New timestep: " + this.m_world.getTimeStep());
		
	},
	
	onOrientate: function(e) {
		if (Device.OrientationEmitter.getDeviceOrientation() == Device.OrientationEmitter.Orientation.LandscapeLeft || Device.OrientationEmitter.getDeviceOrientation() == Device.OrientationEmitter.Orientation.LandscapeRight) {
			//Device.OrientationEmitter.setInterfaceOrientation(Device.OrientationEmitter.getDeviceOrientation(), true);
		}
	},
	
	fallIn: function(delta) {
		this.m_fall_in_time += delta;
		var i = this.m_fall_in_time / GameConstants.FALL_IN_TIME;
		if (i >= 1) {
			i = 1;
			this.m_state = LevelState.PLAY;
			
			for (var idx = 0; idx < this.m_dynamic_objects.length; idx++) {
				//	temp_object.startY = (y + GameConstants.FALL_IN_OFFSET) * GameConstants.WIDTH_SCALE / GameConstants.BOX2D_SCALE;
				
				this.m_dynamic_objects[idx].body.setPosition(this.m_dynamic_objects[idx].x, (GameConstants.ORIGINAL_WIDTH - this.m_dynamic_objects[idx].json.pos.y) / GameConstants.BOX2D_SCALE);
				
			}
			
			for (var idx = 0; idx < this.m_static_objects.length; idx++) {
				if (this.m_static_objects.json != null) {
					this.m_static_objects[idx].body.setPosition(this.m_static_objects[idx].x, (GameConstants.ORIGINAL_WIDTH - this.m_static_objects[idx].json.pos.y) / GameConstants.BOX2D_SCALE);
				}
				else {
					// the planes around the area don't have jsons so use the less precise method
					this.m_static_objects[idx].body.setPosition(this.m_static_objects[idx].x, this.m_static_objects[idx].startY - (GameConstants.FALL_IN_OFFSET / GameConstants.BOX2D_SCALE) * i);
				
				}
				if (this.m_static_objects[idx].sprite && !GameConstants.GL_DRAW) {
					this.m_static_objects[idx].sprite.setPosition(this.m_static_objects[idx].body.getPosition().getX() * GameConstants.HEIGHT_SCALE * GameConstants.BOX2D_SCALE, this.m_static_objects[idx].body.getPosition().getY() * GameConstants.WIDTH_SCALE * GameConstants.BOX2D_SCALE);
				}
			}
			
			for (var idx = 0; idx < this.m_targets.length; idx++) {
				this.m_targets[idx].setPosition(this.m_targets[idx].getPosition().x / GameConstants.BOX2D_SCALE, (GameConstants.ORIGINAL_WIDTH - this.m_targets[idx].json.pos.y) / GameConstants.BOX2D_SCALE);
			}
			
			this.m_cannon.setPosition(this.m_cannon.getPosition().x / GameConstants.BOX2D_SCALE, (GameConstants.ORIGINAL_WIDTH - this.m_cannon.json.pos.y) / GameConstants.BOX2D_SCALE);
			
			this.m_world.setTimeScale(GameConstants.TIME_SCALE);
			this.processJoints();
		}
		else {
			for (var idx = 0; idx < this.m_dynamic_objects.length; idx++) {
				//	temp_object.startY = (y + GameConstants.FALL_IN_OFFSET) * GameConstants.WIDTH_SCALE / GameConstants.BOX2D_SCALE;
				
				this.m_dynamic_objects[idx].body.setPosition(this.m_dynamic_objects[idx].x, this.m_dynamic_objects[idx].startY - (GameConstants.FALL_IN_OFFSET / GameConstants.BOX2D_SCALE) * i);
			}
			
			for (var idx = 0; idx < this.m_static_objects.length; idx++) {
				this.m_static_objects[idx].body.setPosition(this.m_static_objects[idx].x, this.m_static_objects[idx].startY - (GameConstants.FALL_IN_OFFSET / GameConstants.BOX2D_SCALE) * i);
				if (this.m_static_objects[idx].sprite && !GameConstants.GL_DRAW) {
					this.m_static_objects[idx].sprite.setPosition(this.m_static_objects[idx].body.getPosition().getX() * GameConstants.HEIGHT_SCALE * GameConstants.BOX2D_SCALE, this.m_static_objects[idx].body.getPosition().getY() * GameConstants.WIDTH_SCALE * GameConstants.BOX2D_SCALE);
				}
			}
			
			for (var idx = 0; idx < this.m_targets.length; idx++) {
				this.m_targets[idx].setPosition(this.m_targets[idx].getPosition().x / GameConstants.BOX2D_SCALE, this.m_targets[idx].getStartY() - (GameConstants.FALL_IN_OFFSET / GameConstants.BOX2D_SCALE) * i);
			}
			
			this.m_cannon.setPosition(this.m_cannon.getPosition().x / GameConstants.BOX2D_SCALE, this.m_cannon.getStartY() - (GameConstants.FALL_IN_OFFSET / GameConstants.BOX2D_SCALE) * i);
		}
	},
	
	onContact: function(contact_event) {
		var target;
		for (var idx2 = 0; idx2 < this.m_targets.length; idx2++) {
			target = this.m_targets[idx2];
			if (target.isContactShape(contact_event.getShapeA())) {
				for (var idx = 0; idx < GameConstants.MAX_DOLLS; idx++) {
					if (this.m_ragdolls[idx] != null) {
						if (this.m_ragdolls[idx].isContactShape(contact_event.getShapeB())) {
							this.targetHit();
							return;
						}
					}
					else {
						break;
					}
				}
			}
			else if (target.isContactShape(contact_event.getShapeB())) {
				for (var idx = 0; idx < GameConstants.MAX_DOLLS; idx++) {
					if (this.m_ragdolls[idx] != null) {
						if (this.m_ragdolls[idx].isContactShape(contact_event.getShapeA())) {
							this.targetHit();
							return;
						}
					}
					else {
						break;
					}
				}
			}
		}
	},
	
	setAdViewing: function() {
		Core.UpdateEmitter.removeListener(this, this.onUpdate);
		this.m_touch_target.getTouchEmitter().removeListener(this, this.onTouch);
		
	},
	
	targetHit: function() {
		//this.destroyCurrentLevel();
		if (!this.m_won) {
			this.m_state = LevelState.FALL_OUT;
			this.m_fallout_start = new Date().getTime();
			for (var idx = 0; idx < this.m_all_objects.length; idx++) {
				if (this.m_all_objects[idx].body) {
					this.m_all_objects[idx].body.setType(Physics2.Body.Type.Dynamic);
					this.m_all_objects[idx].body.setIsSynchronized(true);
				}
			}
			for (var idx = 0; idx < this.m_springs.length; idx++) {
				this.m_springs[idx].fallOut();
			}
			var previousBest = SaveData.getValue(this.m_json.name + "_BEST", 0);
			console.log("Previous Best WAS: " + previousBest);
			if (previousBest > this.m_current_shots || previousBest == 0) {
				SaveData.updateValue(this.m_json.name + "_BEST", this.m_current_shots);
				var totalScore = SaveData.getValue("TOTALSCORE", 0);
				totalScore -= previousBest;
				totalScore += this.m_current_shots;
				this.m_best = this.m_current_shots;
				SaveData.updateValue("TOTALSCORE", totalScore);
			}
			if (previousBest == 0) {
				var levelsBeat = SaveData.getValue("LEVELSBEATEN", 0);
				++levelsBeat;
				SaveData.updateValue("LEVELSBEATEN", levelsBeat);
			}
			
			this.m_won = true;
			BFAudio.playSound("TARGET");
			console.log("Average update in ms: " + (this.m_total_updates / this.m_updates));
			console.log("Update functions averaged: " + (this.m_update_times[0] / this.m_updates));
			console.log("drawing averaged: " + (this.m_update_times[1] / this.m_updates));
			console.log("blinky checks averaged: " + (this.m_update_times[2] / this.m_updates));
			console.log("dolls averaged: " + (this.m_update_times[3] / this.m_updates));
			console.log("springs averaged: " + (this.m_update_times[4] / this.m_updates));
			console.log("hud averaged: " + (this.m_update_times[5] / this.m_updates));
		}
	},
	
	destroyCurrentLevel: function(){
		// TODO: BOoom;
		var temp_object;
		// Joint destroying doesn't seem to work quite right.  I think they're cleaned up by destroying the related bodies anyways.
		/*for (var idx = 0; idx < this.m_joints.length; idx++) {
			this.m_joints[idx].destroy();
		}*/
		for (var idx = 0; idx < GameConstants.MAX_DOLLS && idx < this.m_ragdolls.length; idx++) {
			this.m_ragdolls[idx].destroy();
		}
		this.m_ragdolls = new Array();
		for(var idx = 0; idx < this.m_dynamic_objects.length; idx++){
			temp_object = this.m_dynamic_objects[idx];
			temp_object.body.destroy();
			temp_object.sprite.destroy();
			temp_object.shape.destroy();
		}
		this.m_dynamic_objects = new Array();
		
		for (var idx = 0; idx < this.m_static_objects.length; idx++) {
			temp_object = this.m_static_objects[idx];
			temp_object.body.destroy();
			if (temp_object.sprite) {
				temp_object.sprite.destroy();
			}
			if (temp_object.shape) {
				temp_object.shape.destroy();
			}
		}
		
		this.m_static_objects = new Array();
		
		for (var idx = 0; idx < this.m_targets.length; idx++) {
			this.m_targets[idx].destroy();
		}
		for (var idx = 0; idx < this.m_springs.length; idx++) {
			this.m_springs[idx].destroy();
		}
		this.m_targets = new Array();
		if (this.m_cannon) {
			this.m_cannon.destroy();
		}
		this.m_reset_button.sprite.destroy();
		this.m_reset_button.target.destroy();
		this.m_menu_button.target.destroy();
		this.m_menu_button.sprite.destroy();
		
		for (var idx = 0; idx < this.m_generics.length; idx++) {
			this.m_generics[idx].destroy();
		}
		
	},
	
	resetLevel: function() {
		//var temp_joints = new Array();
		
		if (this.m_state == LevelState.PLAY || this.m_state == LevelState.FALL_OUT) {
			this.m_won = false;
			for (var idx = 0; idx < this.m_joints.length; idx++) {
				// destroy all joints
				this.m_joints[idx].destroy();
			}
			this.m_joints = new Array();
			
			var count = 0;
			var target_count = 0;
			
			for (var idx = 0; idx < GameConstants.MAX_DOLLS; idx++) {
				//this.m_ragdolls[idx].setPosition(new Vector2(-1000, -1000), 0);
				this.m_ragdolls[idx].reset(idx);
			}
			for (var idx = 0; idx < this.m_all_objects.length; idx++) {
				var temp_object = this.m_all_objects[idx];
				if (temp_object.json != null) {
					switch (temp_object.json.type) {
						case ("Joint"):
						case ("Box"):{
							this.resetObject(temp_object.json, this.m_all_objects[idx]);
							//count++;
							break;
						}
						case ("Circle"):{
							if (temp_object.isTarget) {
								this.m_all_objects[idx].getBody().setType(Physics2.Body.Type.Static);
								this.m_all_objects[idx].getBody().setPosition(temp_object.json.pos.x / GameConstants.BOX2D_SCALE, (GameConstants.ORIGINAL_WIDTH - temp_object.json.pos.y) / GameConstants.BOX2D_SCALE);
								this.m_all_objects[idx].getBody().setRotation(0);
								this.m_all_objects[idx].getBody().setLinearVelocity(0, 0);
								this.m_all_objects[idx].getBody().setType(temp_object.json.density != 0 ? Physics2.Body.Type.Dynamic : Physics2.Body.Type.Static);
								this.m_all_objects[idx].getShape().setDensity(temp_object.json.density);
								this.m_all_objects[idx].getBody().setAngularVelocity(0);
							//target_count++;
							//count++;
							}
							else {
								this.resetObject(temp_object.json, this.m_all_objects[idx]);
								count++;
							}
							break;
						}
						case ("Cannon"):{
							this.m_cannon.reset();
							//count++;
							break;
						}
						case ("Spring"):{
							this.m_all_objects[idx].reset();
							break;
						}
						case (ObjectType.PLANE):{
							this.resetPlane(this.m_all_objects[idx]);
							break;
						}
					}
				}
			}
			
			this.m_blink_reset = false;
			this.m_reset_button.sprite.setAlpha(1);
			this.processJoints();
			this.m_state = LevelState.PLAY;
			this.m_current_shots = 0;
		}
	},
	
	resetPlane: function(obj) {
		obj.body.setType(Physics2.Body.Type.Static);
		obj.body.setPosition(obj.json.pos.x / GameConstants.BOX2D_SCALE, (GameConstants.ORIGINAL_WIDTH - obj.json.pos.y) / GameConstants.BOX2D_SCALE);
		obj.body.setRotation(0);
	},
	
	resetObject: function(json, temp_object) {
		// set to static to kill the movement
		temp_object.body.setType(Physics2.Body.Type.Static);
		temp_object.body.setPosition(json.pos.x / GameConstants.BOX2D_SCALE, (GameConstants.ORIGINAL_WIDTH - json.pos.y) / GameConstants.BOX2D_SCALE);
		temp_object.body.setRotation(0);
		temp_object.body.setLinearVelocity(0, 0);
		temp_object.body.setAngularVelocity(0);
		temp_object.body.setType(json.density != 0 ? Physics2.Body.Type.Dynamic : Physics2.Body.Type.Static);
		if (temp_object.shape) {
			temp_object.shape.setDensity(json.density);
		}
		if (temp_object.sprite) {
			temp_object.sprite.setPosition(temp_object.body.getPosition().getX() * GameConstants.BOX2D_SCALE * GameConstants.HEIGHT_SCALE, temp_object.body.getPosition().getY() * GameConstants.BOX2D_SCALE * GameConstants.WIDTH_SCALE);
			temp_object.sprite.setRotation(temp_object.body.getRotation() + json.rot);
		}
		
		// reset to dynamic
	},
	
	onTouchMenu: function(touch_event) {
		// TODO: menuize
		switch (touch_event.getAction()) {
			case (GL2.Touch.Action.Start):{
				if (!this.m_won && !this.m_current_touch_id) {
					this.m_current_touch_id = touch_event.getId();
					this.m_menu_button.sprite.setColor(0.5, 0.5, 0.5);
					return true;
				}
				break;
			}
			case (GL2.Touch.Action.End):{
				this.m_menu_button.sprite.setColor(this.m_menu_button.json.color.r, this.m_menu_button.json.color.g, this.m_menu_button.json.color.b);
				if (touch_event.getIsInside(this.m_menu_button.target)) {
					BFAudio.playSound("CLICK");
					this.m_emitter.emit("MENU");
					
				}
				this.m_current_touch_id = null;
				break;
			}
		}
	},
	
	onTouchReset: function(touch_event) {
		switch (touch_event.getAction()) {
			case (GL2.Touch.Action.Start):{
				if (!this.m_current_touch_id) {
					this.m_current_touch_id = touch_event.getId();
					this.m_reset_button.sprite.setColor(0.5, 0.5, 0.5);
					return true;	
				}
				break;
			}
			case (GL2.Touch.Action.End):{
				this.m_reset_button.sprite.setColor(this.m_reset_button.json.color.r, this.m_reset_button.json.color.g, this.m_reset_button.json.color.b);
				if (touch_event.getIsInside(this.m_reset_button.target)) {
					this.resetLevel();
					BFAudio.playSound("CLICK");
				}
				this.m_current_touch_id = null;
				break;
			}
		}
	},
	
	loadNewLevel: function(json_path, level_no){
		// TODO: get that shiz
		this.m_level_no = level_no;
		Storage.FileSystem.readFile(json_path, false, levelLoadCallback);
	},
	
	processJSON: function(new_json){
		var errors = "";
		var temp1;
		var temp2;
		this.m_json = new_json;
		var processUpdates = new Array();
		
		if (this.m_json.plane_top) {
			this.createPlane(GameConstants.ORIGINAL_HEIGHT / 2, -5, GameConstants.ORIGINAL_HEIGHT, 10);
		}
		if (this.m_json.plane_bottom) {
			this.createPlane(GameConstants.ORIGINAL_HEIGHT / 2, GameConstants.ORIGINAL_WIDTH + 5, GameConstants.ORIGINAL_HEIGHT, 10);
		}
		if (this.m_json.plane_left) {
			this.createPlane(-5, GameConstants.ORIGINAL_WIDTH / 2, 10, GameConstants.ORIGINAL_WIDTH);
		}
		if (this.m_json.plane_right) {
			this.createPlane(GameConstants.ORIGINAL_HEIGHT + 5, GameConstants.ORIGINAL_WIDTH / 2, 10, GameConstants.ORIGINAL_WIDTH);
		}
		
		for (var idx = 0; idx < this.m_json.objects.length; idx++) {
			var temp_object = this.m_json.objects[idx];
			var created_object = null;
			temp_object.density = temp_object.density / GameConstants.DENSITY_SCALE;
			console.log(temp_object.name);
			switch (temp_object.type) {
				case (ObjectType.BOX):
				{
					//created_object = this.createBox(temp_object.pos.x, GameConstants.ORIGINAL_WIDTH - temp_object.pos.y, temp_object.scale.x, temp_object.scale.y, temp_object.density != 0 ? Physics2.Body.Type.Dynamic : Physics2.Body.Type.Static, temp_object.texture);
					created_object = this.createBox(temp_object);
					break;
				}
				case (ObjectType.CIRCLE):{
					if (temp_object.isTarget) {
						
						created_object = this.createTarget(temp_object);
					}
					else {
						//created_object = this.createCircle(temp_object.pos.x, GameConstants.ORIGINAL_WIDTH - temp_object.pos.y, temp_object.scale.x / 2, temp_object.density != 0 ? Physics2.Body.Type.Dynamic : Physics2.Body.Type.Static, temp_object.texture);
						created_object = this.createCircle(temp_object);
					}
					break;
				}
				case (ObjectType.CANNON):{
					created_object = this.createCannon(temp_object);
					break;
				}
				case (ObjectType.BUTTON):{
					this.createButton(temp_object);
					break;
				}
				case (ObjectType.GENERIC):{
					created_object = this.createGeneric(temp_object);
					break;
				}
				case (ObjectType.JOINT):{
					created_object = this.createJointObject(temp_object);
					
					break;
				}
				case (ObjectType.SPRING):{
					created_object = this.createSpring(temp_object);
					break;
				}
				default:
				{
					errors += "\n Unkown Object Type: " + temp_object.type;
					break;
				}
			}
			
			if (temp_object.name == "cannon") {
				console.log("Hi");
				console.log(created_object);
				console.log(created_object.json);
				console.log(created_object.json.hasUpdate);
			}
			if (created_object) {
				if (created_object.json.hasUpdate != "" && created_object.json.hasUpdate != "function updateObject() end") {
					console.log("push");
					processUpdates.push(created_object);
					//errors += "\n object \"" + created_object.json.name + "\" has update function";
				}
				
				
				if (created_object.json.collision != 65535) {
					//errors += "\n object \"" + created_object.json.name + "\" has non standard collision";
				}
			}
			
		}
		for (var idx = 0; idx < processUpdates.length; idx++) {
			if (!Updaters.checkForUpdateFunction(processUpdates[idx], this.m_json.name, this.m_all_objects)) {
				errors += "\n object \"" + processUpdates[idx].json.name + "\" has unimplemented update function";
			}
		}
		
		this.m_world.setTimeScale(0);
		this.m_fall_in_time = 0;
		this.m_current_shots = 0;
		if (this.m_json.hud_bottom) {
			this.m_hud_node.setPosition(GameConstants.SCREEN_HEIGHT / 2, GameConstants.SCREEN_WIDTH - 10 * GameConstants.WIDTH_SCALE);
			this.m_emitter.emit("BUTTONTOP");
		}
		else {
			this.m_hud_node.setPosition(GameConstants.SCREEN_HEIGHT / 2, 10 * GameConstants.WIDTH_SCALE);
			this.m_emitter.emit("BUTTONBOTTOM");
		}
		
		this.m_best = SaveData.getValue(this.m_json.name + "_BEST", 0);
		this.m_name_text.setText(this.m_level_no + ") " + this.m_json.name);
		this.updateHud();
		this.m_state = LevelState.FALL_IN; 
		
		if (GameConstants.DEBUG) {
			this.m_error_log.setText(errors);
			console.log(errors);
			
		}
		this.createFrame(this.m_json.name);
	},
	
	createFrame: function(name) {
		var frame_node = new GL2.Node();
		var left_frame = new GL2.Sprite();
		this.m_frame_parts = new Array();
		left_frame.setImage("Content/frame_left.png", [32 * GameConstants.HEIGHT_SCALE, 64 * GameConstants.WIDTH_SCALE]);
		left_frame.setPosition(((-name.length / 2 - 1) * 16) * GameConstants.HEIGHT_SCALE, 0);
		this.m_frame_parts.push(left_frame);
		frame_node.addChild(left_frame);
		
		var right_frame = new GL2.Sprite();
		right_frame.setImage("Content/frame_right.png", [32 * GameConstants.HEIGHT_SCALE, 64 * GameConstants.WIDTH_SCALE]);
		right_frame.setPosition(((name.length / 2 + 1) * 16) * GameConstants.HEIGHT_SCALE, 0);
		this.m_frame_parts.push(right_frame);
		frame_node.addChild(right_frame);
		
		for (var idx = 0; idx < name.length; idx++) {
			var temp_frame = new GL2.Sprite();
			temp_frame.setImage("Content/frame_center.png", [16 * GameConstants.HEIGHT_SCALE, 64 * GameConstants.WIDTH_SCALE]);
			temp_frame.setPosition((idx + 0.5 - name.length / 2) * 16 * GameConstants.HEIGHT_SCALE, 0);
			frame_node.addChild(temp_frame);
			this.m_frame_parts.push(temp_frame);
		}
		
		var frame_text = new GL2.Text();
		frame_text.setText(name);
		frame_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		frame_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		frame_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
		frame_text.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
		frame_text.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
		frame_node.addChild(frame_text);
		this.m_frame_parts.push(frame_text);
		
		frame_node.setPosition(GameConstants.SCREEN_HEIGHT / 2, GameConstants.SCREEN_WIDTH / 2);
		frame_node.setAlpha(0);
		this.m_frame = frame_node;
		this.m_frame_start = new Date().getTime();
		this.m_node.addChild(frame_node);
		this.m_frame_parts.push(frame_node);
	},
	
	destroyFrame: function() {
		if (this.m_frame_parts) {
			for (var idx = 0; idx < this.m_frame_parts.length; idx++) {
				this.m_frame_parts[idx].destroy();
			}
			this.m_frame_parts = null;
		}
	},
	
	processJoints: function() {
		var errors = "";
		if (this.m_json.parents != null) {
			// process joints.
			for (var idx = 0; idx < this.m_json.parents.length; idx++) {
				var temp_object = this.m_json.parents[idx];
				var a = temp_object.a;
				var b = temp_object.b;
				var object_a = null;
				var object_b = null;
				
				// find these first 2 objects.
				for (var idx2 = 0; idx2 < this.m_all_objects.length; idx2++) {
					if (this.m_all_objects[idx2].json == null) {
						continue;
					}
					if (this.m_all_objects[idx2].json.name == a) {
						object_a = this.m_all_objects[idx2];
					}
					if (this.m_all_objects[idx2].json.name == b) {
						object_b = this.m_all_objects[idx2];
					}
				}
				if (b == "NULL" && object_a != null) {
					// create a new body...
					object_b = this.createFakeBodyForJoint(object_a, object_a.json.jointType);
				}
				if (object_a != null && object_b != null) {
					var joint_type = object_a.json.jointType;
					// hack.  If we're using a joint anchor object use a hinge.
					if (object_a.json.type == ObjectType.JOINT) {
						joint_type = JointType.HINGE;
					}
					else if (object_a.json.type == ObjectType.SPRING) {
						// likewise, springs use springs (yo dawg)
						joint_type = JointType.SPRING;	
					}
					var temp_joint;
					if (object_a.json.type == ObjectType.CANNON) {
						object_a.jointParent = object_b;
					}
					else if (object_b.json.type == ObjectType.CANNON) {
						object_b.jointParent = object_a;	
					}
					switch (joint_type) {
						case (JointType.NONE):{
							// NO JOINT
							errors += "\n + Invalid Joint Type Found?";
							break;
						}
						case (JointType.SPRING):{
							this.createSpringJoint(object_a, object_b);
							break;
						}
						case (JointType.HINGE):{
							// HINGE
							this.createHingeJoint(object_a, object_b);
							break;
						}
						case (JointType.FIXED):{
							this.createFixedJoint(object_a, object_b);
							break;
						}
						case (JointType.DISTANCE):{
							this.createDistanceJoint(object_a, object_b);
							break;
						}
						default:{
							errors += "\n + Found unknown joint type: " + joint_type;
							break;
						}
					}
				}
			}
		}
		console.log("Errors in processJoints was: " + errors);
	},
	
	createFakeBodyForJoint: function(child_object, type) {
		// calculate the location;
		//var pos = child_object.json.jointAnchor;
		var pos = new Vector2(child_object.json.jointAnchor.x, child_object.json.jointAnchor.y);
		pos.y = (GameConstants.ORIGINAL_WIDTH - pos.y) / GameConstants.BOX2D_SCALE;
		pos.x = pos.x / GameConstants.BOX2D_SCALE;
		
		var body = new Physics2.Body();
		body.setType(Physics2.Body.Type.Static);
		body.setPosition(pos.x, pos.y);
		console.log("fake body at : " + pos.x + ", " + pos.y);
		var some_object = new Object();
		some_object.body = body;
		some_object.json = new Object();
		some_object.json.jointAnchor = child_object.json.jointAnchor;
		some_object.json.pos = child_object.json.jointAnchor;
		this.m_world.addBody(body);
		some_object.json.name = "null";
		
		// HACK TO MAKE INVISIBLE SPRINGS WORK.  ZORRO LEVEL
		if (type == JointType.SPRING) {
			some_object.json.type = ObjectType.SPRING;
			some_object.json.scale = new Object();
			some_object.json.scale.x = 0;
			some_object.json.scale.y = 0;
			some_object = this.createSpring(some_object.json);
		}
		else {
			this.m_all_objects.push(some_object);
		}
		
		
		return some_object;
		
	},
	
	createHingeJoint: function(object_a, object_b) {
		var temp_joint = new Physics2.RevoluteJoint();
		
		// get the relative position of joint_point and object_a
		var joint_point = this.getJointPoint(object_a);
		
		var anchor_a = this.getJointAnchor(object_a, joint_point);
		
		var anchor_b = this.getJointAnchor(object_b, joint_point);
		
		// and the relative anchor for object_b
		temp_joint.setLocalAnchorA(anchor_a);
		temp_joint.setLocalAnchorB(anchor_b);
		temp_joint.setBodyA(object_a.body);
		temp_joint.setBodyB(object_b.body);
		//temp_joint.setCollideConnected(true);
		
		// HACK:  If object_a is a cannon.  Contrain rotation. because it's dumb
		/*if (object_a.json.type == ObjectType.CANNON) {
			temp_joint.setEnableLimit(true);
			temp_joint.setLowerRotation(0);
			temp_joint.setUpperRotation(0);
		}*/
		
		
		if (object_a.json.jointVelocity != 0) {
			console.log("SEtting velocity!");
			temp_joint.setEnableMotor(true);
			temp_joint.setMotorSpeed(object_a.json.jointVelocity);
			temp_joint.setMaxMotorTorque(Math.abs(object_a.json.jointVelocity * object_a.json.jointMaximumForce));
			console.log("speed is: " + temp_joint.getMotorSpeed());
			//temp_joint.setLocalAnchorA(new Core.Point(0, 0));
			//temp_joint.setLocalAnchorB(new Core.Point(0, 0));
			//temp_joint.setMaxMotorTorque(object_a.json.jointMaximumForce);
			//temp_joint.setMotorSpeed(-2);
			
		}
		
		this.m_joints.push(temp_joint);
		object_a.joint = temp_joint;
	},
	
	createDistanceJoint: function(object_a, object_b) {
		var temp_joint = new Physics2.DistanceJoint();
		temp_joint.setBodyA(object_a.body);
		temp_joint.setBodyB(object_b.body);
		temp_joint.setCollideConnected(true);
		
		var pos_a = object_a.body.getPosition();
		var pos_b = object_b.body.getPosition();
		var l = Math.sqrt(Math.pow((pos_a.getX() - pos_b.getX()), 2) + Math.pow((pos_a.getY() - pos_b.getY()), 2));
		temp_joint.setLength(l);
		
		this.m_joints.push(temp_joint);
	},
	
	createPlane: function(x, y, width, height) {
		var temp = this.createBasePhysics(x, y, width, height, Physics2.Body.Type.Static);
		var shape = new Physics2.BoxShape();
		shape.setSize(width / GameConstants.BOX2D_SCALE, height / GameConstants.BOX2D_SCALE);
		temp.body.addShape(shape);
		var json = new Object();
		json.pos = new Object();
		json.pos.x = x;
		json.pos.y = GameConstants.ORIGINAL_WIDTH - y;
		json.type = ObjectType.PLANE;
		temp.json = json;
		return temp;
	},
	
	createFixedJoint: function(object_a, object_b) {
		var v1;
		var v2;
		var j;
		var mid_x = (object_a.body.getPosition().getX() + object_b.body.getPosition().getX()) / 2;
		var mid_y = (object_a.body.getPosition().getY() + object_b.body.getPosition().getY()) / 2;
		var v_mid = new Vector2(mid_x, mid_y);
		v1 = Vector2.subtract(v_mid, new Vector2(object_a.body.getPosition().getX(), object_a.body.getPosition().getY()));
		v2 = Vector2.subtract(v_mid, new Vector2(object_b.body.getPosition().getX(), object_b.body.getPosition().getY()));
		
		j = new Physics2.WeldJoint();
		//j.setReferenceRotation(-object_a.body.getRotation());
		//j.setLocalAnchorA(new Core.Point(v1.x, v1.y));
		//j.setLocalAnchorB(new Core.Point(v2.x, v2.y));
		j.setLocalAnchorB(new Core.Point(0, 0));
		v2 = Vector2.subtract(new Vector2(object_b.body.getPosition().getX(), object_b.body.getPosition().getY()), new Vector2(object_a.body.getPosition().getX(), object_a.body.getPosition().getY()));
		j.setLocalAnchorA(new Core.Point(v2.x, v2.y));
		j.setBodyA(object_a.body);
		j.setBodyB(object_b.body);
			
		this.m_joints.push(j);
	},
	
	toRads: function(d) {
		return d * Math.PI / 180;
	},
	
	createSpringJoint: function(object_a, object_b) {
		var spring_obj = object_a.json.type == ObjectType.SPRING ? object_a : object_b;
		var other_obj = object_a.json.type == ObjectType.SPRING ? object_b : object_a;
		var ref_obj = object_a.json.jointType != JointType.NONE ? object_a : object_b;
		var joint_point = this.getJointPoint(object_b);
		var anchor_spring = this.getJointAnchor(spring_obj, joint_point);
		var anchor_other = this.getJointAnchor(other_obj, joint_point);
		spring_obj.attachBody(other_obj, anchor_spring, anchor_other);
	},	
	
	getJointPoint: function(object_a){
		var joint_point = new Core.Point(); 
		joint_point.setX((object_a.json.jointAnchor.x) / GameConstants.BOX2D_SCALE);
		console.log(object_a.json.jointAnchor.y);
		joint_point.setY((GameConstants.ORIGINAL_WIDTH - object_a.json.jointAnchor.y) / GameConstants.BOX2D_SCALE);
		//console.log("Joint Anchor!: " + joint_point.getX() + ", " + joint_point.getY());
		//console.log("object_a.json.name: " + object_a.json.name);
		return joint_point;
	},
	
	getJointAnchor: function(object, joint_point) {
		var anchor = new Core.Point();
		anchor.setX(joint_point.getX() - (object.json.pos.x / GameConstants.BOX2D_SCALE));
		anchor.setY(joint_point.getY() - ((GameConstants.ORIGINAL_WIDTH - object.json.pos.y) / GameConstants.BOX2D_SCALE));
		return anchor;
	},
	
	createButton: function(json_object) {
		var temp_object = new Object();
		
		var sprite = new GL2.Sprite();
		sprite.setImage(json_object.texture, [json_object.scale.x * GameConstants.HEIGHT_SCALE, json_object.scale.y * GameConstants.WIDTH_SCALE]);
		sprite.setPosition(json_object.pos.x * GameConstants.HEIGHT_SCALE, (GameConstants.ORIGINAL_WIDTH - json_object.pos.y) * GameConstants.WIDTH_SCALE);
		this.m_node.addChild(sprite);
		sprite.setColor(json_object.color.r, json_object.color.g, json_object.color.b);
		
		var touch_target = new GL2.TouchTarget();
		touch_target.setSize((json_object.scale.x + 20) * GameConstants.HEIGHT_SCALE, (json_object.scale.y + 20) * GameConstants.WIDTH_SCALE);
		touch_target.setPosition(json_object.pos.x * GameConstants.HEIGHT_SCALE, (GameConstants.ORIGINAL_WIDTH - json_object.pos.y) * GameConstants.WIDTH_SCALE);
		this.m_node.addChild(touch_target);
		temp_object.target = touch_target;
		touch_target.setAnchor(0.5, 0.5);
		
		touch_target.setDepth(10);
		
		temp_object.sprite = sprite;
		temp_object.json = json_object;
		if (json_object.name == "1") {
			// reset button
			touch_target.getTouchEmitter().addListener(this, this.onTouchReset);
			this.m_reset_button = temp_object;
		}
		else if (json_object.name == "2") {
			touch_target.getTouchEmitter().addListener(this, this.onTouchMenu);
			this.m_menu_button = temp_object;
		}
	},
	
	createGeneric: function(json_object) {
		var temp_object = new GL2.Sprite();
		temp_object.setPosition(json_object.pos.x * GameConstants.HEIGHT_SCALE, (GameConstants.ORIGINAL_WIDTH - json_object.pos.y) * GameConstants.WIDTH_SCALE);
		temp_object.setImage(json_object.texture.replace(" ", "_"), [json_object.scale.x * GameConstants.HEIGHT_SCALE, json_object.scale.y * GameConstants.WIDTH_SCALE]);
		temp_object.setColor(json_object.color.r, json_object.color.g, json_object.color.b);
		temp_object.setAlpha(json_object.color.a);
		temp_object.setRotation(json_object.rot);
		temp_object.json = json_object;
		this.m_generics.push(temp_object);
		this.m_node.addChild(temp_object);
		
		return temp_object;
	},
	
	getNode: function() {
		return this.m_node;
	},
	
	createCannon: function(json_object) {
		this.m_cannon = new Cannon(new Vector2(json_object.pos.x, GameConstants.ORIGINAL_WIDTH - json_object.pos.y), this.m_world, this.m_node, json_object.density != 0 ? Physics2.Body.Type.Dynamic : Physics2.Body.Type.Static, json_object.scale.x, json_object.scale.y, json_object.rot, json_object.density);
		this.m_all_objects.push(this.m_cannon);
		this.m_cannon.json = json_object;
		this.m_cannon.setRotationConstraint(json_object.cannonCutoffAngle);
		this.m_cannon.setFriction(json_object.friction * GameConstants.FRICTION_SCALE);
		this.m_cannon.setColor(json_object.color.r, json_object.color.g, json_object.color.b);
		this.m_cannon.getShape().setMaskBits(json_object.collision);
		this.m_cannon.getShape().setCategoryBits(json_object.collision);
		return this.m_cannon;
	},	
	
	createTarget: function(json_object) {
		var temp_object = new Target(new Vector2(json_object.pos.x, GameConstants.ORIGINAL_WIDTH - json_object.pos.y), this.m_world, this.m_node, json_object.scale.x / 2, json_object.density != 0 ? Physics2.Body.Type.Dynamic : Physics2.Body.Type.Static);
		temp_object.setColor(json_object.color.r, json_object.color.g, json_object.color.b, json_object.color.a);
		temp_object.getShape().setFriction(json_object.friction * GameConstants.FRICTION_SCALE);
		temp_object.getShape().setDensity(json_object.density);
		temp_object.getShape().setMaskBits(json_object.collision);
		temp_object.getShape().setCategoryBits(json_object.collision);
		temp_object.setRotation(json_object.rot);
		this.m_targets.push(temp_object);
		this.m_all_objects.push(temp_object);
		temp_object.json = json_object;
		
		return temp_object;
		
	},
	
	createSpring: function(json_object) {
		var new_spring = new Spring(json_object, this.m_world, this.m_node);
		this.m_all_objects.push(new_spring);
		this.m_springs.push(new_spring);
		return new_spring;
	},
	
	createCircle: function(json_object) {
		var temp_object = this.createBasePhysics(json_object.pos.x, GameConstants.ORIGINAL_WIDTH - json_object.pos.y, json_object.scale.x, json_object.scale.y, json_object.density != 0 ? Physics2.Body.Type.Dynamic : Physics2.Body.Type.Static, json_object.texture);
		var shape = new Physics2.CircleShape();
		shape.setRadius(json_object.scale.x / (2 * GameConstants.BOX2D_SCALE));
		temp_object.body.addShape(shape);
		temp_object.shape = shape;
		//temp_object.body.setRotation(json_object.rot);
		if (temp_object.sprite) {
			temp_object.sprite.setColor(json_object.color.r, json_object.color.g, json_object.color.b);
			temp_object.sprite.setAlpha(json_object.color.a);
			temp_object.sprite.setRotation(json_object.rot);
		}
		temp_object.shape.setFriction(json_object.friction * GameConstants.FRICTION_SCALE);
		temp_object.shape.setDensity(json_object.density * temp_object.shape.getRadius() * 4 / 3);
		temp_object.shape.setRestitution(0);
		temp_object.json = json_object;
		temp_object.shape.setMaskBits(json_object.collision);
		temp_object.shape.setCategoryBits(json_object.collision);
		return temp_object;
	},
	
	createJointObject: function(json_object) {
		// current assumption, joint objects always static bodies.
		var temp_object = this.createBasePhysics(json_object.pos.x, GameConstants.ORIGINAL_WIDTH - json_object.pos.y, json_object.scale.x, json_object.scale.y, Physics2.Body.Type.Static, json_object.texture);
		if (temp_object.sprite) {
			temp_object.sprite.setColor(json_object.color.r, json_object.color.g, json_object.color.b);
			temp_object.sprite.setAlpha(json_object.color.a);
		}
		temp_object.json = json_object;
		return temp_object;
	},
	
	createBox: function(json_object) {
		var temp_object = this.createBasePhysics(json_object.pos.x, GameConstants.ORIGINAL_WIDTH - json_object.pos.y, json_object.scale.x, json_object.scale.y, json_object.density != 0 ? Physics2.Body.Type.Dynamic : Physics2.Body.Type.Static, json_object.texture);
		
		var shape = new Physics2.BoxShape();
		shape.setSize(json_object.scale.x / GameConstants.BOX2D_SCALE, json_object.scale.y / GameConstants.BOX2D_SCALE);
		temp_object.shape = shape;
		temp_object.shape.setRotation(json_object.rot);
		if (temp_object.sprite) {
			temp_object.sprite.setColor(json_object.color.r, json_object.color.g, json_object.color.b);
			temp_object.sprite.setAlpha(json_object.color.a);
			temp_object.sprite.setRotation(json_object.rot);
		}
		temp_object.shape.setFriction(json_object.friction * GameConstants.FRICTION_SCALE);
		temp_object.shape.setDensity(json_object.density);
		temp_object.shape.setRestitution(0);
		console.log("Density of " + json_object.name + "is " + temp_object.shape.getDensity());
		temp_object.shape.setMaskBits(json_object.collision);
		temp_object.shape.setCategoryBits(json_object.collision);
		temp_object.body.addShape(shape);
		
		temp_object.json = json_object;
		return temp_object;
	},
	
	createBasePhysics: function(x, y, width, height, type, sprite_loc){
		var body;
		var sprite;
		
		var temp_object = new Object();
		body = new Physics2.Body();
		body.setPosition(x / GameConstants.BOX2D_SCALE, y * GameConstants.WIDTH_SCALE / GameConstants.BOX2D_SCALE);
		body.setType(type);
		body.setContactFlags(Physics2.Body.ContactFlags.None);
		temp_object.startY = (y + GameConstants.FALL_IN_OFFSET) / GameConstants.BOX2D_SCALE;
		this.m_world.addBody(body);
		temp_object.x = x / GameConstants.BOX2D_SCALE;
		temp_object.body = body;
		
		if (sprite_loc) {
			sprite_loc = sprite_loc.replace(/ /g, "_");
			sprite = new GL2.Sprite();
			sprite.setImage(sprite_loc, [width * GameConstants.HEIGHT_SCALE, height * GameConstants.WIDTH_SCALE]);
			sprite.setPosition(x, y);
			
			this.m_node.addChild(sprite);
			temp_object.sprite = sprite;
			if (GameConstants.GL_DRAW) {
				body.setGL2Node(sprite);
			}
		}
		
		if (type == Physics2.Body.Type.Static) {
			temp_object.body.setIsSynchronized(false);
			this.m_static_objects.push(temp_object);
		}
		else if (type == Physics2.Body.Type.Dynamic) {
			if (sprite) {
				if (!GameConstants.GL_DRAW) {
					temp_object.body.setIsSynchronized(true);
				}
				this.m_dynamic_objects.push(temp_object);
			}
			else {
				this.m_static_objects.push(temp_object);
				temp_object.body.setIsSynchronized(false);
			}
		}
		this.m_all_objects.push(temp_object);
		if (!this.m_toppest_object || temp_object.body.getPosition().getY() < this.m_toppest_object.body.getPosition().getY()) {
			this.m_toppest_object = temp_object;
		}
		//temp_object.body.setIsSleepingAllowed(false);
		return temp_object;
	},
	
	createStiffnessUI: function(){
		var up1 = new GL2.Sprite();
		up1.setImage("/Content/blue_arrow.png", [16, 16]);
		
		var node = new GL2.Node();
		up1.setPosition(0, 0);
		up1.setRotation(-90);
		node.addChild(up1);
		
		var text1 = new GL2.Text();
		text1.setText("0.5");
		text1.setPosition(20, 0);
		text1.setColor(0, 0, 0);
		node.addChild(text1);
		
		var down1 = new GL2.Sprite();
		down1.setImage("/Content/blue_arrow.png", [16, 16]);
		down1.setRotation(90);
		down1.setPosition(50, 0);
		node.addChild(down1);
		
		var up2 = new GL2.Sprite();
		up2.setImage("/Content/blue_arrow.png", [16, 16]);
		up2.setRotation(-90);
		up2.setPosition(0, 50);
		node.addChild(up2);
		
		var text2 = new GL2.Text();
		text2.setText("0.5");
		text2.setPosition(20, 50);
		text2.setColor(0, 0, 0);
		
		node.addChild(text2);
		
		var down2 = new GL2.Sprite();
		down2.setImage("/Content/blue_arrow.png", [16, 16]);
		down2.setRotation(90);
		down2.setPosition(50, 50);
		node.addChild(down2);
		
		this.m_node.addChild(node);
		
		
		this.m_debug_node = node;
		this.m_damp_text = text1;
		this.m_freq_text = text2;
		
		var touch1 = new GL2.TouchTarget();
		touch1.getTouchEmitter().addListener(this, this.dampUp);
		touch1.setPosition(0, 0);
		touch1.setAnchor(0.5, 0.5);
		touch1.setSize(32, 32);
		node.addChild(touch1);
		
		var touch2 = new GL2.TouchTarget();
		touch2.getTouchEmitter().addListener(this, this.dampDown);
		touch2.setPosition(50, 0);
		touch2.setAnchor(0.5, 0.5);
		touch2.setSize(32, 32);
		node.addChild(touch2);
		
		var touch3 = new GL2.TouchTarget();
		touch3.getTouchEmitter().addListener(this, this.freqUp);
		touch3.setPosition(0, 50);
		touch3.setAnchor(0.5, 0.5);
		touch3.setSize(32, 32);
		node.addChild(touch3);
		
		var touch4 = new GL2.TouchTarget();
		touch4.getTouchEmitter().addListener(this, this.freqDown);
		touch4.setPosition(50, 50);
		touch4.setAnchor(0.5, 0.5);
		touch4.setSize(32, 32);
		node.addChild(touch4);
		
		this.m_cur_damp = 0.5;
		this.m_cur_freq = 1.2;
		this.m_damp_change = 0.05;
		this.m_freq_change = 0.1;
		text1.setText(this.m_cur_damp);
		text2.setText(this.m_cur_freq);
		node.setDepth(2000);
		
		node.setPosition(100, 150);
	},
	
	dampUp: function(){
		this.m_cur_damp += this.m_damp_change;
		this.m_damp_text.setText(this.m_cur_damp);
		for (var idx = 0; idx < this.m_springs.length; idx++) {
			this.m_springs[idx].setDamping(this.m_cur_damp);
		}
	},
	
	dampDown: function(){
		this.m_cur_damp -= this.m_damp_change;
		this.m_damp_text.setText(this.m_cur_damp);
		for (var idx = 0; idx < this.m_springs.length; idx++) {
			this.m_springs[idx].setDamping(this.m_cur_damp);
		}
	},
	
	freqUp: function(){
		this.m_cur_freq += this.m_freq_change;
		this.m_freq_text.setText(this.m_cur_freq);
		for (var idx = 0; idx < this.m_springs.length; idx++) {
			this.m_springs[idx].setFreq(this.m_cur_freq);
		}
	},
	
	freqDown: function(){
		this.m_cur_freq -= this.m_freq_change;
		this.m_freq_text.setText(this.m_cur_freq);
		for (var idx = 0; idx < this.m_springs.length; idx++) {
			this.m_springs[idx].setFreq(this.m_cur_freq);
		}
	},
});

function levelLoadCallback(){
	if (arguments[1]) {
		self.processJSON(JSON.parse(arguments[1]));
	}
	else {
		// TODO: handle error
	}
}

var ObjectType = {
	CANNON: "Cannon",
	CIRCLE: "Circle",
	BOX: "Box",
	BUTTON: "Button",
	GENERIC: "Generic",
	JOINT: "Joint",
	SPRING: "Spring",
	PLANE: "Plane",
	
}

var JointType = {
	NONE: 0,
	SPRING: 1,
	HINGE: 2,
	FIXED: 3,
	DISTANCE: 4,
}

exports.Level = Level;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Ragdoll'] = function(){var exports = $MODULE_REGISTRY['Code/Ragdoll'] || {}; $MODULE_REGISTRY['Code/Ragdoll'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var Physics2 = require('NGCore/Client/Physics2').Physics2;

var GameConstants = require('Code/GameConstants').GameConstants;
var Vector2 = require('Code/util/Vector').Vector2;

var exports = {};

var torso_offset = new Vector2(0, -9);
var head_offset = new Vector2(0, -21.6);
var left_arm_offset = new Vector2(-5.4, -12.6);
var left_hand_offset = new Vector2(-5.4, -5.4);
var right_arm_offset = new Vector2(5.4, -12.6);
var right_hand_offset = new Vector2(5.4, -5.4);
var left_leg_offset = new Vector2(-1.8, 3.6);
var left_foot_offset = new Vector2(-1.8, 10.8);
var right_leg_offset = new Vector2(1.8, 3.6);
var right_foot_offset = new Vector2(1.8, 10.8);

var pi = Math.PI;
var pi2 = Math.PI / 2;
var pi3 = Math.PI / 3;

var Ragdoll = Core.Class.subclass({
	initialize: function(pos, world, root_node, rot){
				
		this.m_world = world;
		this.m_root_node = root_node;
		
		var rad = rot * 2 * Math.PI / 360;
		this.m_body = new Appendage(this.m_world, this.m_root_node, "Content/body.png", Vector2.add(pos, torso_offset.rotated(rad)), new Vector2(8, 16), new Vector2(5.4, 14.4), 1);
		this.m_body.getBody().setRotation(rot);
		
		//this.m_head = new Head(this.m_world, this.m_root_node, "Content/head.png", Vector2.add(pos, head_offset.rotated(rad)), 6, 3.6);
		this.m_head = new Appendage(this.m_world, this.m_root_node, "Content/head.png", Vector2.add(pos, head_offset.rotated(rad)), new Vector2(12, 12), new Vector2(7.2, 7.2), 0.5);
		this.m_head.getBody().setRotation(rot);
		//this.m_head.getBody().setIsBullet(true);
		
		this.m_left_arm = new Appendage(this.m_world, this.m_root_node, "Content/arm_leg_peice.png", Vector2.add(pos, left_arm_offset.rotated(rad)), new Vector2(4, 8), new Vector2(3.24, 6.84), 5 / 9);
		this.m_left_arm.getBody().setRotation(rot);
		
		this.m_left_hand = new Appendage(this.m_world, this.m_root_node, "Content/arm_leg_peice.png", Vector2.add(pos, left_hand_offset.rotated(rad)), new Vector2(4, 8), new Vector2(3.24, 6.84), 5 / 9);
		this.m_left_hand.getBody().setRotation(rot);
		
		this.m_right_arm = new Appendage(this.m_world, this.m_root_node, "Content/arm_leg_peice.png", Vector2.add(pos, right_arm_offset.rotated(rad)), new Vector2(4, 8), new Vector2(3.24, 6.84), 5 / 9);
		this.m_right_arm.getBody().setRotation(rot);
		
		this.m_right_hand = new Appendage(this.m_world, this.m_root_node, "Content/arm_leg_peice.png", Vector2.add(pos, right_hand_offset.rotated(rad)), new Vector2(4, 8), new Vector2(3.24, 6.84), 5 / 9);
		this.m_right_hand.getBody().setRotation(rot);
		
		this.m_left_leg = new Appendage(this.m_world, this.m_root_node, "Content/arm_leg_peice.png", Vector2.add(pos, left_leg_offset.rotated(rad)), new Vector2(4, 8), new Vector2(3.24, 6.84), 5 / 9);
		this.m_left_leg.getBody().setRotation(rot);
		
		this.m_left_foot = new Appendage(this.m_world, this.m_root_node, "Content/arm_leg_peice.png", Vector2.add(pos, left_foot_offset.rotated(rad)), new Vector2(4, 8), new Vector2(3.24, 6.84), 5 / 9);
		this.m_left_foot.getBody().setRotation(rot);
		
		this.m_right_leg = new Appendage(this.m_world, this.m_root_node, "Content/arm_leg_peice.png", Vector2.add(pos, right_leg_offset.rotated(rad)), new Vector2(4, 8), new Vector2(3.24, 6.84), 5 / 9);
		this.m_right_leg.getBody().setRotation(rot);
		
		this.m_right_foot = new Appendage(this.m_world, this.m_root_node, "Content/arm_leg_peice.png", Vector2.add(pos, right_foot_offset.rotated(rad)), new Vector2(4, 8), new Vector2(3.24, 6.84), 5 / 9);
		this.m_right_foot.getBody().setRotation(rot);
	
		this.createJoints();
		
		this.m_added = true;
	},
	
	createJoints: function() {
		
		this.m_neck = new Physics2.RevoluteJoint();
		//this.m_neck.setLocalAnchorA(0 / GameConstants.BOX2D_SCALE, -8.5 / GameConstants.BOX2D_SCALE);
		//this.m_neck.setLocalAnchorB(0 / GameConstants.BOX2D_SCALE, 6 / GameConstants.BOX2D_SCALE);
		this.m_neck.setLocalAnchorA(0 / GameConstants.BOX2D_SCALE, -7.056 / GameConstants.BOX2D_SCALE);
		this.m_neck.setLocalAnchorB(0 / GameConstants.BOX2D_SCALE, 3.744 / GameConstants.BOX2D_SCALE);
		this.m_neck.setBodyA(this.m_body.getBody());
		this.m_neck.setBodyB(this.m_head.getBody());
		this.m_neck.setCollideConnected(false);
		this.m_neck.setEnableLimit(true);
		this.m_neck.setLowerRotation(this.toDegs(-pi3));
		this.m_neck.setUpperRotation(this.toDegs(pi3));
		
		this.m_left_shoulder = new Physics2.RevoluteJoint();
		//this.m_left_shoulder.setLocalAnchorA(-4.5 / GameConstants.BOX2D_SCALE, -8.5 / GameConstants.BOX2D_SCALE);
		//this.m_left_shoulder.setLocalAnchorB(2 / GameConstants.BOX2D_SCALE, -4 / GameConstants.BOX2D_SCALE);
		this.m_left_shoulder.setLocalAnchorA(-1.89 / GameConstants.BOX2D_SCALE, -7.056 / GameConstants.BOX2D_SCALE);
		this.m_left_shoulder.setLocalAnchorB(2.43 / GameConstants.BOX2D_SCALE, -3.456 / GameConstants.BOX2D_SCALE);
		this.m_left_shoulder.setBodyA(this.m_body.getBody());
		this.m_left_shoulder.setBodyB(this.m_left_arm.getBody());
		this.m_left_shoulder.setEnableLimit(true);
		this.m_left_shoulder.setLowerRotation(this.toDegs(0));
		this.m_left_shoulder.setUpperRotation(this.toDegs(pi * 0.9));
		this.m_left_shoulder.setCollideConnected(false);
		
		this.m_left_elbow = new Physics2.RevoluteJoint();
		this.m_left_elbow.setLocalAnchorA(0 / GameConstants.BOX2D_SCALE, 4 / GameConstants.BOX2D_SCALE);
		this.m_left_elbow.setLocalAnchorB(0 / GameConstants.BOX2D_SCALE, -4 / GameConstants.BOX2D_SCALE);
		//this.m_left_elbow.setLocalAnchorA(-0.486 / GameConstants.BOX2D_SCALE, 0.972 / GameConstants.BOX2D_SCALE);
		//this.m_left_elbow.setLocalAnchorB(-0.486 / GameConstants.BOX2D_SCALE, -4.392 / GameConstants.BOX2D_SCALE);
		this.m_left_elbow.setBodyA(this.m_left_arm.getBody());
		this.m_left_elbow.setBodyB(this.m_left_hand.getBody());
		this.m_left_elbow.setEnableLimit(true);
		this.m_left_elbow.setLowerRotation(this.toDegs(-pi2));
		this.m_left_elbow.setUpperRotation(this.toDegs(0));
		this.m_left_elbow.setCollideConnected(false);
		
		this.m_right_shoulder = new Physics2.RevoluteJoint();
		//this.m_right_shoulder.setLocalAnchorA(4.5 / GameConstants.BOX2D_SCALE, -8.5 / GameConstants.BOX2D_SCALE);
		//this.m_right_shoulder.setLocalAnchorB(-2 / GameConstants.BOX2D_SCALE, -4 / GameConstants.BOX2D_SCALE);
		this.m_right_shoulder.setLocalAnchorA(1.89 / GameConstants.BOX2D_SCALE, -7.056 / GameConstants.BOX2D_SCALE);
		this.m_right_shoulder.setLocalAnchorB(-2.43 / GameConstants.BOX2D_SCALE, -3.456 / GameConstants.BOX2D_SCALE);
		this.m_right_shoulder.setBodyA(this.m_body.getBody());
		this.m_right_shoulder.setBodyB(this.m_right_arm.getBody());
		this.m_right_shoulder.setEnableLimit(true);
		this.m_right_shoulder.setLowerRotation(this.toDegs(-pi * 0.9));
		this.m_right_shoulder.setUpperRotation(this.toDegs(0));
		this.m_right_shoulder.setCollideConnected(false);
		
		this.m_right_elbow = new Physics2.RevoluteJoint();
		this.m_right_elbow.setLocalAnchorA(0 / GameConstants.BOX2D_SCALE, 4 / GameConstants.BOX2D_SCALE);
		this.m_right_elbow.setLocalAnchorB(0 / GameConstants.BOX2D_SCALE, -4 / GameConstants.BOX2D_SCALE);
		this.m_right_elbow.setBodyA(this.m_right_arm.getBody());
		this.m_right_elbow.setBodyB(this.m_right_hand.getBody());
		this.m_right_elbow.setEnableLimit(true);
		this.m_right_elbow.setLowerRotation(this.toDegs(0));
		this.m_right_elbow.setUpperRotation(this.toDegs(pi2));
		this.m_right_elbow.setCollideConnected(false);
		
		this.m_left_waist = new Physics2.RevoluteJoint();
		//this.m_left_waist.setLocalAnchorA(-2.5 / GameConstants.BOX2D_SCALE, 8.5 / GameConstants.BOX2D_SCALE);
		//this.m_left_waist.setLocalAnchorB(0 / GameConstants.BOX2D_SCALE, -4 / GameConstants.BOX2D_SCALE);
		this.m_left_waist.setLocalAnchorA(-1.27 / GameConstants.BOX2D_SCALE, 5.76 / GameConstants.BOX2D_SCALE);
		this.m_left_waist.setLocalAnchorB(0 / GameConstants.BOX2D_SCALE, -4.86 / GameConstants.BOX2D_SCALE);
		this.m_left_waist.setBodyA(this.m_body.getBody());
		this.m_left_waist.setBodyB(this.m_left_leg.getBody());
		this.m_left_waist.setEnableLimit(true);
		this.m_left_waist.setLowerRotation(this.toDegs(0));
		this.m_left_waist.setUpperRotation(this.toDegs(pi2));
		this.m_left_waist.setCollideConnected(false);
		
		this.m_left_knee = new Physics2.RevoluteJoint();
		this.m_left_knee.setLocalAnchorA(0 / GameConstants.BOX2D_SCALE, 4 / GameConstants.BOX2D_SCALE);
		this.m_left_knee.setLocalAnchorB(0 / GameConstants.BOX2D_SCALE, -4 / GameConstants.BOX2D_SCALE);
		this.m_left_knee.setBodyA(this.m_left_leg.getBody());
		this.m_left_knee.setBodyB(this.m_left_foot.getBody());
		this.m_left_knee.setEnableLimit(true);
		this.m_left_knee.setLowerRotation(this.toDegs(-pi2));
		this.m_left_knee.setUpperRotation(this.toDegs(pi2));
		this.m_left_knee.setCollideConnected(false);
		
		this.m_right_waist = new Physics2.RevoluteJoint();
		//this.m_right_waist.setLocalAnchorA(2.5 / GameConstants.BOX2D_SCALE, 8.5 / GameConstants.BOX2D_SCALE);
		//this.m_right_waist.setLocalAnchorB(0 / GameConstants.BOX2D_SCALE, -4 / GameConstants.BOX2D_SCALE);
		this.m_right_waist.setLocalAnchorA(1.27 / GameConstants.BOX2D_SCALE, 5.76 / GameConstants.BOX2D_SCALE);
		this.m_right_waist.setLocalAnchorB(0 / GameConstants.BOX2D_SCALE, -4.86 / GameConstants.BOX2D_SCALE);
		this.m_right_waist.setBodyA(this.m_body.getBody());
		this.m_right_waist.setBodyB(this.m_right_leg.getBody());
		this.m_right_waist.setEnableLimit(true);
		this.m_right_waist.setLowerRotation(this.toDegs(-pi2));
		this.m_right_waist.setUpperRotation(this.toDegs(0));
		this.m_right_waist.setCollideConnected(false);
		
		this.m_right_knee = new Physics2.RevoluteJoint();
		this.m_right_knee.setLocalAnchorA(0 / GameConstants.BOX2D_SCALE, 4 / GameConstants.BOX2D_SCALE);
		this.m_right_knee.setLocalAnchorB(0 / GameConstants.BOX2D_SCALE, -4 / GameConstants.BOX2D_SCALE);
		this.m_right_knee.setBodyA(this.m_right_leg.getBody());
		this.m_right_knee.setBodyB(this.m_right_foot.getBody());
		this.m_right_knee.setEnableLimit(true);
		this.m_right_knee.setLowerRotation(this.toDegs(-pi2));
		this.m_right_knee.setUpperRotation(this.toDegs(pi2));
		this.m_right_knee.setCollideConnected(false);
		
	},
	
	toDegs: function(rads) {
		return (rads * 180 / Math.PI)
	},
	
	destroy: function() {
		/*
		this.m_neck.destroy();
		this.m_left_shoulder.destroy();
		this.m_left_elbow.destroy();
		this.m_right_shoulder.destroy();
		this.m_right_elbow.destroy();
		this.m_left_waist.destroy();
		this.m_left_knee.destroy();
		this.m_right_waist.destroy();
		this.m_right_knee.destroy();*/
		
		this.m_body.destroy();
		this.m_head.destroy();
		this.m_left_arm.destroy();
		this.m_left_hand.destroy();
		this.m_right_arm.destroy();
		this.m_right_hand.destroy();
		this.m_left_leg.destroy();
		this.m_left_foot.destroy();
		this.m_right_leg.destroy();
		this.m_right_foot.destroy();
		
	},
	
	isActive: function() {
		return this.m_added;
	},
	
	update: function() {
		if (this.m_body.getBody().getPosition().getY() < (Core.Capabilities.getScreenWidth() + 10) / GameConstants.BOX2D_SCALE) {
			this.m_head.updateSprite();
			this.m_body.updateSprite();
			this.m_left_arm.updateSprite();
			this.m_left_hand.updateSprite();
			this.m_right_arm.updateSprite();
			this.m_right_hand.updateSprite();
			this.m_left_leg.updateSprite();
			this.m_left_foot.updateSprite();
			this.m_right_leg.updateSprite();
			this.m_right_foot.updateSprite();
			//console.log((this.m_head.getBody().getLinearVelocity().getX() == this.m_body.getBody().getLinearVelocity().getX() && this.m_body.getBody().getLinearVelocity().getY() == this.m_head.getBody().getLinearVelocity().getY()));
			//console.log("head @: " + this.m_head.getBody().getLinearVelocity().getX() + this.m_head.getBody().getLinearVelocity().getY());
			//console.log("body @: " + this.m_body.getBody().getLinearVelocity().getX() + this.m_body.getBody().getLinearVelocity().getY());
			//console.log("Head @: " + this.m_head.getBody().getPosition().getX() + ", " + this.m_head.getBody().getPosition().getY());
			//console.log("Body @: " + this.m_body.getBody().getPosition().getX() + ", " + this.m_body.getBody().getPosition().getY());
		}
		else {
			if (this.m_world && this.m_added) {
				this.m_world.removeBody(this.m_head.getBody());
				this.m_world.removeBody(this.m_left_arm.getBody());
				this.m_world.removeBody(this.m_left_hand.getBody());
				this.m_world.removeBody(this.m_right_arm.getBody());
				this.m_world.removeBody(this.m_right_hand.getBody());
				this.m_world.removeBody(this.m_left_leg.getBody());
				this.m_world.removeBody(this.m_left_foot.getBody());
				this.m_world.removeBody(this.m_right_leg.getBody());
				this.m_world.removeBody(this.m_right_foot.getBody());
				this.m_world.removeBody(this.m_body.getBody());
				this.m_added = false;
			}
		}
		var v = this.m_head.getBody().getLinearVelocity();
		/*if (new Vector2(v.getX(), v.getY()).length() > 10) {
			this.m_head.getBody().setIsBullet(true);
			this.m_body.getBody().setIsBullet(true);
			this.m_left_arm.getBody().setIsBullet(true);
			this.m_left_hand.getBody().setIsBullet(true);
			this.m_right_arm.getBody().setIsBullet(true);
			this.m_right_hand.getBody().setIsBullet(true);
			this.m_left_leg.getBody().setIsBullet(true);
			this.m_left_foot.getBody().setIsBullet(true);
			this.m_right_leg.getBody().setIsBullet(true);
			this.m_right_foot.getBody().setIsBullet(true);
		}
		else {
			this.m_head.getBody().setIsBullet(false);
			this.m_body.getBody().setIsBullet(false);
			this.m_left_arm.getBody().setIsBullet(false);
			this.m_left_hand.getBody().setIsBullet(false);
			this.m_right_arm.getBody().setIsBullet(false);
			this.m_right_hand.getBody().setIsBullet(false);
			this.m_left_leg.getBody().setIsBullet(false);
			this.m_left_foot.getBody().setIsBullet(false);
			this.m_right_leg.getBody().setIsBullet(false);
			this.m_right_foot.getBody().setIsBullet(false);
		}*/
		
	},
	
	reset: function(idx) {
		
		this.m_body.getBody().setPosition(-1000, 1000 + idx * 100);
		this.m_left_arm.getBody().setPosition(-1000, 1000 + idx * 100);
		this.m_head.getBody().setPosition(-1000, 1000 + idx * 100);
		this.m_left_hand.getBody().setPosition(-1000, 1000 + idx * 100);
		this.m_right_arm.getBody().setPosition(-1000, 1000 + idx * 100);
		this.m_right_hand.getBody().setPosition(-1000, 1000) + idx * 100;
		this.m_left_leg.getBody().setPosition(-1000, 1000 + idx * 100);
		this.m_left_foot.getBody().setPosition(-1000, 1000 + idx * 100);
		this.m_right_leg.getBody().setPosition(-1000, 1000 + idx * 100);
		this.m_right_foot.getBody().setPosition(-1000, 1000 + idx * 100);
		
		this.m_head.updateSprite();
		this.m_body.updateSprite();
		this.m_left_arm.updateSprite();
		this.m_left_hand.updateSprite();
		this.m_right_arm.updateSprite();
		this.m_right_hand.updateSprite();
		this.m_left_leg.updateSprite();
		this.m_left_foot.updateSprite();
		this.m_right_leg.updateSprite();
		this.m_right_foot.updateSprite();
		
		this.update();
	},
	
	setVelocity: function(){
		var x;
		var y;
		if (arguments.length == 1) {
			x = arguments[0].x;
			y = arguments[0].y;
		}
		else {
			x = arguments[0];
			y = arguments[1];
		}
		//x = x / GameConstants.BOX2D_SCALE;
		//y = y / GameConstants.BOX2D_SCALE;
		console.log("Firing ragdoll with x: " + x + " and y: " + y);
		this.m_head.setLinearVelocity(x, y);
		this.m_body.setLinearVelocity(x, y);
		this.m_left_leg.setLinearVelocity(x, y);
		this.m_left_foot.setLinearVelocity(x, y);
		this.m_right_leg.setLinearVelocity(x, y);
		this.m_right_foot.setLinearVelocity(x, y);
		this.m_left_arm.setLinearVelocity(x, y);
		this.m_left_hand.setLinearVelocity(x, y);
		this.m_right_arm.setLinearVelocity(x, y);
		this.m_right_hand.setLinearVelocity(x, y);
	},
	
	getVelocity: function() {
		return this.m_body.getBody().getLinearVelocity();
	},
	
	setDensity: function(d) {
		this.m_body.setDensity(d);
		this.m_head.setDensity(d);
		this.m_left_arm.setDensity(d);
		this.m_left_hand.setDensity(d);
		this.m_right_arm.setDensity(d);
		this.m_right_hand.setDensity(d);
		this.m_left_leg.setDensity(d);
		this.m_left_foot.setDensity(d);
		this.m_right_leg.setDensity(d);
		this.m_right_foot.setDensity(d);
	},
	
	setPosition: function(pos, rot) {
		if (this.m_added) {
			console.log("Killing old joints");
			this.m_neck.destroy();
			this.m_left_shoulder.destroy();
			this.m_right_shoulder.destroy();
			this.m_left_elbow.destroy();
			this.m_right_elbow.destroy();
			this.m_left_waist.destroy();
			this.m_right_waist.destroy();
			this.m_left_knee.destroy();
			this.m_right_knee.destroy();
		}
		
		var rad = rot * 2 * Math.PI / 360;
		
		this.m_body.getBody().setRotation(rot);
		this.m_head.getBody().setRotation(rot);
		this.m_left_arm.getBody().setRotation(rot);
		this.m_left_hand.getBody().setRotation(rot);
		this.m_right_arm.getBody().setRotation(rot);
		this.m_right_hand.getBody().setRotation(rot);
		this.m_left_leg.getBody().setRotation(rot);
		this.m_right_leg.getBody().setRotation(rot);
		this.m_left_foot.getBody().setRotation(rot);
		this.m_right_foot.getBody().setRotation(rot);
		
		this.m_body.setPosition(Vector2.add(pos, torso_offset.rotated(rad)));
		this.m_head.setPosition(Vector2.add(pos, head_offset.rotated(rad)));
		this.m_left_arm.setPosition(Vector2.add(pos, left_arm_offset.rotated(rad)));
		this.m_left_hand.setPosition(Vector2.add(pos, left_hand_offset.rotated(rad)));
		this.m_right_arm.setPosition(Vector2.add(pos, right_arm_offset.rotated(rad)));
		this.m_right_hand.setPosition(Vector2.add(pos, right_hand_offset.rotated(rad)));
		this.m_left_leg.setPosition(Vector2.add(pos, left_leg_offset.rotated(rad)));
		this.m_left_foot.setPosition(Vector2.add(pos, left_foot_offset.rotated(rad)));
		this.m_right_leg.setPosition(Vector2.add(pos, right_leg_offset.rotated(rad)));
		this.m_right_foot.setPosition(Vector2.add(pos, right_foot_offset.rotated(rad)));
		
		this.m_world.addBody(this.m_body.getBody());
		this.m_world.addBody(this.m_head.getBody());
		this.m_world.addBody(this.m_left_arm.getBody());
		this.m_world.addBody(this.m_left_hand.getBody());
		this.m_world.addBody(this.m_right_arm.getBody());
		this.m_world.addBody(this.m_right_hand.getBody());
		this.m_world.addBody(this.m_left_leg.getBody());
		this.m_world.addBody(this.m_left_foot.getBody());
		this.m_world.addBody(this.m_right_leg.getBody());
		this.m_world.addBody(this.m_right_foot.getBody());
		
		this.m_added = true;
		
		this.createJoints();
		
		/*this.m_neck.setBodyA(this.m_body.getBody());
		this.m_neck.setBodyB(this.m_head.getBody());
		this.m_left_shoulder.setBodyA(this.m_body.getBody());
		this.m_left_shoulder.setBodyB(this.m_left_arm.getBody());
		this.m_left_elbow.setBodyA(this.m_left_arm.getBody());
		this.m_left_elbow.setBodyB(this.m_left_hand.getBody());
		this.m_right_shoulder.setBodyA(this.m_body.getBody());
		this.m_right_shoulder.setBodyB(this.m_right_arm.getBody());
		this.m_right_elbow.setBodyA(this.m_right_arm.getBody());
		this.m_right_elbow.setBodyB(this.m_right_hand.getBody());
		this.m_left_waist.setBodyA(this.m_body.getBody());
		this.m_left_waist.setBodyB(this.m_left_leg.getBody());
		this.m_left_knee.setBodyA(this.m_left_leg.getBody());
		this.m_left_knee.setBodyB(this.m_left_foot.getBody());
		this.m_right_waist.setBodyA(this.m_body.getBody());
		this.m_right_waist.setBodyB(this.m_right_leg.getBody());
		this.m_right_knee.setBodyA(this.m_right_leg.getBody());
		this.m_right_knee.setBodyB(this.m_right_foot.getBody());*/
		
		
	},
	
	isContactShape: function(shape_in_question){
		return (this.m_body.isContactShape(shape_in_question) ||
			this.m_left_arm.isContactShape(shape_in_question) ||
			this.m_left_hand.isContactShape(shape_in_question) ||
			this.m_right_arm.isContactShape(shape_in_question) ||
			this.m_right_hand.isContactShape(shape_in_question) ||
			this.m_left_leg.isContactShape(shape_in_question) ||
			this.m_left_foot.isContactShape(shape_in_question) ||
			this.m_right_leg.isContactShape(shape_in_question) ||
			this.m_right_foot.isContactShape(shape_in_question) ||
			this.m_head.isContactShape(shape_in_question));
	}
	
});

var Appendage = Core.Class.subclass({
	initialize: function(world, root_node, image, pos, visable_size, size, density){
		this.m_body;
		this.m_sprite;
		this.m_shape;
		
		this.m_body = new Physics2.Body();
		this.m_body.setType(Physics2.Body.Type.Dynamic);
		this.m_body.setPosition(pos.x / GameConstants.BOX2D_SCALE, pos.y / GameConstants.BOX2D_SCALE);
		if (!GameConstants.GL_DRAW) {
			this.m_body.setIsSynchronized(true);
		}
		this.m_shape = new Physics2.BoxShape();
		this.m_shape.setSize(size.x / GameConstants.BOX2D_SCALE, size.y / GameConstants.BOX2D_SCALE);
		this.m_body.addShape(this.m_shape);
		this.m_shape.setDensity(density);
		
		this.m_sprite = new GL2.Sprite();
		this.m_sprite.setImage(image, [visable_size.x * GameConstants.HEIGHT_SCALE, visable_size.y * GameConstants.WIDTH_SCALE]);
		this.m_sprite.setColor(0, 0, 1);
		this.m_body.setContactFlags(Physics2.Body.ContactFlags.Begin);
		
		// HACK, set arms/legs to not intercollide, make everything else do it
		
		if (image != "Content/head.png" && image != "Content/body.png") {
			this.m_shape.setGroupIndex(-8);
		}
		this.m_shape.setMaskBits(65535);
		this.m_shape.setCategoryBits(65535);
		
		root_node.addChild(this.m_sprite);		
		if (GameConstants.GL_DRAW) {
			this.m_body.setGL2Node(this.m_sprite);
		}
		world.addBody(this.m_body);
		this.m_body.setIsBullet(true);
		//this.updateSprite();
				
	},
	
	destroy: function() {
		this.m_body.destroy();
		this.m_sprite.destroy();
		this.m_shape.destroy();
	},
	
	setDensity: function(d) {
		this.m_shape.setDensity(d);
	},
	
	isContactShape: function(shape_in_question) {
		return(shape_in_question == this.m_shape);
	},
	
	getSprite: function(){
		return this.m_sprite;
	},
	
	getBody: function(){
		return this.m_body;
	},
	
	setLinearVelocity: function(x, y){
		this.m_body.setLinearVelocity(x, y);
	},
	
	updateSprite: function() {
		//if (!GameConstants.GL_DRAW) {
			var temp_pos = this.m_body.getPosition();
			this.m_sprite.setPosition(temp_pos.getX() * GameConstants.BOX2D_HEIGHT_SCALE, temp_pos.getY() * GameConstants.BOX2D_WIDTH_SCALE);
			this.m_sprite.setRotation(this.m_body.getRotation());
		//}
	},
	
	setPosition: function(pos){
		this.m_body.setPosition(pos.x / GameConstants.BOX2D_SCALE, pos.y / GameConstants.BOX2D_SCALE);
	},
	
});

exports.Ragdoll = Ragdoll;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Target'] = function(){var exports = $MODULE_REGISTRY['Code/Target'] || {}; $MODULE_REGISTRY['Code/Target'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var Physics2 = require('NGCore/Client/Physics2').Physics2;

var GameConstants = require('Code/GameConstants').GameConstants;
var Vector2 = require('Code/util/Vector').Vector2;

var exports = {};

var Target = Core.Class.subclass({
	initialize: function(pos, world, root_node, rad, type){
		
		this.m_body;
		this.m_shape;
		this.m_sprite;
		
		this.m_body = new Physics2.Body();
		this.m_body.setType(type);
		this.m_body.setPosition(pos.x / GameConstants.BOX2D_SCALE, pos.y / GameConstants.BOX2D_SCALE);
		this.m_body.setContactFlags(Physics2.Body.ContactFlags.Begin);
		this.m_startY = (pos.y + GameConstants.FALL_IN_OFFSET) / GameConstants.BOX2D_SCALE;
		
		if (!GameConstants.GL_DRAW) {
			this.m_body.setIsSynchronized(true);
		}
		
		this.m_shape = new Physics2.CircleShape();
		this.m_shape.setRadius(rad / GameConstants.BOX2D_SCALE);
		this.m_shape.setDensity(1 / GameConstants.DENSITY_SCALE);
		this.m_body.addShape(this.m_shape);
		
		this.m_sprite = new GL2.Sprite();
		this.m_sprite.setImage("Content/target.png", [rad * 2 * GameConstants.HEIGHT_SCALE, rad * 2 * GameConstants.WIDTH_SCALE]);
		
		root_node.addChild(this.m_sprite);
		 
		if (GameConstants.GL_DRAW) {
			this.m_body.setGL2Node(this.m_sprite);
		}
		 
		world.addBody(this.m_body);
		
		this.body = this.m_body;
	},
	
	destroy: function(){
		this.m_body.destroy();
		this.m_shape.destroy();
		this.m_sprite.destroy();
	},
	
	getShape: function() {
		return this.m_shape;
	},
	
	getBody: function() {
		return this.m_body;	
	},
	
	setRotation: function(rot) {
		this.m_body.setRotation(rot);
		this.m_sprite.setRotation(rot);
	},
	
	setPosition: function(x, y){
		this.m_body.setPosition(x, y);
	},
	
	getStartY: function() {
		return this.m_startY;
	},
	
	getPosition: function(){
		return Vector2.scale(new Vector2(this.m_body.getPosition().getX(), this.m_body.getPosition().getY()), GameConstants.BOX2D_SCALE);
	},
	
	setColor: function(r, g, b, a) {
		this.m_sprite.setColor(r, g, b);
		this.m_sprite.setAlpha(a);
	},
	
	isContactShape: function(shape_in_question){
		return(shape_in_question == this.m_shape);
	},
	
	update: function(){
		var temp_pos = this.m_body.getPosition();
		this.m_sprite.setPosition(temp_pos.getX() * GameConstants.BOX2D_HEIGHT_SCALE, temp_pos.getY() * GameConstants.BOX2D_WIDTH_SCALE);
		this.m_sprite.setRotation(this.m_body.getRotation());
	},
	
	getSprite: function(){
		return this.m_sprite;
	},
	
	isOffScreen: function(){
		return (this.m_body.getPosition().getY() * GameConstants.BOX2D_WIDTH_SCALE > Core.Capabilities.getScreenHeight() + 100) 
			
	},
});

exports.Target = Target;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cannon'] = function(){var exports = $MODULE_REGISTRY['Code/Cannon'] || {}; $MODULE_REGISTRY['Code/Cannon'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var Physics2 = require('NGCore/Client/Physics2').Physics2;

var exports = {};

var Cannon = Core.Class.subclass({
	initialize: function(pos, world, root_node, type, width, height, initial_rot, density){
		this.m_base_body;
		this.m_base_shape;
		this.m_base_sprite;
		this.m_shooter_sprite;
		this.m_launch_distance;
		this.m_node;
		
		this.m_startY = (pos.y + GameConstants.FALL_IN_OFFSET) / GameConstants.BOX2D_SCALE;
		
		this.m_base_body = new Physics2.Body();
		this.m_base_body.setPosition(pos.x / GameConstants.BOX2D_SCALE, pos.y / GameConstants.BOX2D_SCALE);
		this.m_base_body.setType(type);
		
		this.m_base_body.setIsSynchronized(true);
		this.m_base_body.setRotation(initial_rot);
		
		this.m_node = new GL2.Node();
		
		this.m_base_sprite = new GL2.Sprite();
		this.m_base_sprite.setImage("Content/cannon_base.png", [width * GameConstants.HEIGHT_SCALE, height * GameConstants.WIDTH_SCALE]);
		this.m_base_sprite.setColor(0, 0, 0);
		this.m_base_sprite.setRotation(initial_rot);
		this.m_node.addChild(this.m_base_sprite);
		this.m_shooter_sprite = new GL2.Sprite();
		this.m_shooter_sprite.setImage("Content/cannon_shooter.png", [width * GameConstants.HEIGHT_SCALE, height * GameConstants.WIDTH_SCALE]);
		this.m_node.addChild(this.m_shooter_sprite);
		this.m_shooter_sprite.setColor(0, 0, 0);
		
		root_node.addChild(this.m_node);
		
		//this.m_base_shape = new Physics2.BoxShape();
		//this.m_base_shape.setSize(width * GameConstants.HEIGHT_SCALE / GameConstants.BOX2D_SCALE, height * GameConstants.WIDTH_SCALE / GameConstants.BOX2D_SCALE);
		this.m_base_shape = new Physics2.CircleShape();
		this.m_base_shape.setRadius((width / 2) / GameConstants.BOX2D_SCALE);
		this.m_base_body.addShape(this.m_base_shape);
		this.m_base_shape.setDensity(density * 2 * (width / GameConstants.BOX2D_SCALE) / 3);
		this.m_base_shape.setRestitution(0);

		this.m_rotation_constraint = 0;

		world.addBody(this.m_base_body);
		
		if (GameConstants.GL_DRAW) {
			this.m_base_body.setGL2Node(this.m_node);
		}
		
		//this.m_launch_distance = 40; 
		this.m_launch_distance = width + 5;
		this.m_base_shape.setGroupIndex(-2);
		console.log("Cannon Created with size: " + width + " and launch offset of: " + this.m_launch_distance);
		console.log("Density: " + this.m_base_shape.getDensity());
		this.body = this.m_base_body;
		
	},
	
	getSmokeOffset: function() {
		var r = this.m_base_shape.getRadius() * GameConstants.BOX2D_SCALE * GameConstants.WIDTH_SCALE / 2;
		return 0;
	},
	
	getShape: function() {
		return this.m_base_shape;
	},
	
	reset: function() {
		
		this.m_base_body.setPosition(this.json.pos.x / GameConstants.BOX2D_SCALE, (GameConstants.ORIGINAL_WIDTH - this.json.pos.y) / GameConstants.BOX2D_SCALE);
		this.m_base_body.setRotation(this.json.rot);
		this.m_base_body.setLinearVelocity(new Core.Vector(0, 0));
		this.m_base_body.setAngularVelocity(0);
		this.m_base_shape.setDensity(this.json.density);
		this.m_base_body.setType(this.json.density == 0 ? Physics2.Body.Type.Static : Physics2.Body.Type.Dynamic);
	},
	
	destroy: function() {
		try {
			this.m_base_body.destroy();
			this.m_base_shape.destroy();
			this.m_base_sprite.destroy();
			this.m_shooter_sprite.destroy();
			this.m_node.destroy();
		} 
		catch (e) {
			console.log("Cannon destroy caught: " + e);
		}
	},
	
	setJointParent: function(body) {
		this.m_joint_parent = body;
	},
	
	setRotationConstraint: function(i) {
		this.m_rotation_constraint = i;
	},
	
	getCutoffAngle: function(i) {
		return this.m_rotation_constraint;
	},
	
	setColor: function(r, g, b) {
		this.m_base_sprite.setColor(r, g, b);
		this.m_shooter_sprite.setColor(r, g, b);
	},
	
	update: function() {
		var temp_pos = this.m_base_body.getPosition();
		this.m_base_sprite.setPosition(temp_pos.getX() * GameConstants.HEIGHT_SCALE * GameConstants.BOX2D_SCALE, temp_pos.getY() * GameConstants.WIDTH_SCALE * GameConstants.BOX2D_SCALE);
		//this.m_base_sprite.setRotation(this.m_base_body.getRotation());
		var temp_rot = this.json.rot;
		if (this.jointParent && this.jointParent.body && this.jointParent.json && this.jointParent.json.rot) {
			temp_rot += this.jointParent.body.getRotation() + this.jointParent.json.rot;
			
		}
		this.m_base_sprite.setRotation(temp_rot);
		this.m_shooter_sprite.setPosition(this.m_base_sprite.getPosition());
	},
	
	setRotation: function(rot){
		
		this.m_shooter_sprite.setRotation(rot);
	},
	
	setDensity: function(d) {
			this.m_base_shape.setDensity(d);
	},
	
	setPosition: function(x, y){
		this.m_base_body.setPosition(x, y);
	},
	
	getStartY: function() {
		return this.m_startY;
	},
	
	applyImpulse: function(v) {
		//v = v.scale(v, 1 / GameConstants.BOX2D_SCALE);
		console.log("recoil: " + v.x + ", " + v.y);
		//this.m_base_body.applyLinearImpulse(new Core.Vector(v.x, v.y), new Core.Point(0, 0));
		this.m_base_body.applyLinearImpulse(new Core.Vector(v.x, v.y), this.m_base_body.getPosition());
	},
	
	getPosition: function(){
		return Vector2.scale(new Vector2(this.m_base_body.getPosition().getX(), this.m_base_body.getPosition().getY()), GameConstants.BOX2D_SCALE);
	},
	
	getRotation: function(){
		return this.m_shooter_sprite.getRotation();
	},
	
	getBaseRotation: function() {
		return this.m_base_sprite.getRotation();
	},
	
	getSize: function(){
		return this.m_launch_distance;
	},
	
	setFriction: function(f){
		this.m_base_shape.setFriction(f);
	},
	
	isOffScreen: function(){
		return (this.m_base_body.getPosition().getY() * GameConstants.BOX2D_SCALE * GameConstants.WIDTH_SCALE > Core.Capabilities.getScreenHeight() + 100) 
			
	},
});

exports.Cannon = Cannon;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GameConstants'] = function(){var exports = $MODULE_REGISTRY['Code/GameConstants'] || {}; $MODULE_REGISTRY['Code/GameConstants'] = exports; var Core = require('NGCore/Client/Core').Core;
var Storage = require('NGCore/Client/Storage').Storage;

var exports = {};

var GameConstants = {
	WIDTH_SCALE: 1.0,
	HEIGHT_SCALE: 1.0,
	ORIGINAL_WIDTH: 320,
	ORIGINAL_HEIGHT: 480,
	BOX2D_SCALE: 40.0,
	MAX_DOLLS: 5,
	DEBUG: false,
	TIME_SCALE: 1,
	GL_DRAW: false,
	FALL_IN_OFFSET: -520,
	FALL_IN_TIME: 1500,
	RECOIL_SCALE: 0.1,
	DENSITY_SCALE: 1,
	RAGDOLL_FIRE_DELAY: 200,
	LEVEL_JSON_PATH: "Content/Levels/",
	FRICTION_SCALE: 0.5,
	PURE_DEBUG: false,
	AD_ID: "188EE3F9-93F7-428E-AA72-7D4F01CD9ADC", 
	LEVELS_BEFORE_ADS: 3, 
	TOTAL_LEVELS: 102,
	SIMULATE_SHIT_DEVICE: false,
	ENABLE_FPS: false,
	ENABLE_TTV: false,
	LEVELS_ABLE_TO_SKIP: 5,
	BOX2D_HEIGHT_SCALE: 1,
	BOX2D_WIDTH_SCALE: 1,
	NUM_TUTORIAL_LEVELS: 10,
	SCREEN_HEIGHT: 480,
	SCREEN_WIDTH: 320,
	LEVELS_BEFORE_RATE: 15,
	TIMES_TO_PROMPT_FOR_RATE: 3,
	RATE_TITLE: "Rate us!",
	RATE_TEXT: "Please give us 5 Stars and tell us what you think.",
	RATE_OPTION_YES: "Sounds great",
	RATE_OPTION_NO: "No thanks",
}

var LocalizedStrings;

exports.GameConstants = GameConstants;
exports.LocalizedStrings = LocalizedStrings;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/LevelSelect'] = function(){var exports = $MODULE_REGISTRY['Code/LevelSelect'] || {}; $MODULE_REGISTRY['Code/LevelSelect'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var UI = require('NGCore/Client/UI').UI;

var GameConstants = require('Code/GameConstants').GameConstants;
var Scroller = require('Code/UI/Scroller').Scroller;

var exports = {};

var item_height = 56 * GameConstants.WIDTH_SCALE;
var move_limit = item_height;

var LevelSelect = Core.MessageListener.subclass({
	initialize: function(json){
		this.m_back_button = new GL2.Sprite();
		this.m_level_json = json;
		this.m_targets = new Array();
		this.m_bests = new Array();
		this.m_level_names = new Array();
		this.m_last_pos;
		this.m_current_amount_moved;
		this.m_current_id = null;
		this.m_active = true;
		this.m_levels_skipped = 0;
		
		this.m_levels = new Array();
		this.m_node = new GL2.Node();
		
		this.m_bg = new GL2.Sprite();
		this.m_bg.setImage("Content/Default.png", [GameConstants.SCREEN_HEIGHT, GameConstants.SCREEN_WIDTH]);
		this.m_bg.setPosition(GameConstants.SCREEN_HEIGHT / 2, GameConstants.SCREEN_WIDTH / 2);
		this.m_node.addChild(this.m_bg);

		this.m_scroll = new Scroller(GameConstants.SCREEN_HEIGHT, GameConstants.SCREEN_WIDTH);
		this.m_scroll.setPosition(GameConstants.SCREEN_HEIGHT / 2, GameConstants.SCREEN_WIDTH / 2 + 56 * GameConstants.WIDTH_SCALE);
		this.m_node.addChild(this.m_scroll.getNode());
		
		this.m_emitter = new Core.MessageEmitter();
		
		this.loadLevels();
		
		this.createMenuBar();
		
		this.checkSkippedLevels();
	},
	
	destroy: function(){
		// TOOD: destroy
	},
	
	createMenuBar: function() {
		var black_bar = new GL2.Sprite();
		black_bar.setImage("Content/Ad_Coverup.png", [GameConstants.SCREEN_HEIGHT, 56 * GameConstants.WIDTH_SCALE], [0, 0]);
		this.m_node.addChild(black_bar);
		
		var back_text = new GL2.Text();
		back_text.setText("Back");
		back_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		back_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		back_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		back_text.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
		back_text.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
		back_text.setColor(1, 1, 1);
		back_text.setAnchor(0, 0.5);
		back_text.setPosition(5 * GameConstants.HEIGHT_SCALE, 28 * GameConstants.WIDTH_SCALE);
		this.m_node.addChild(back_text);
		this.m_back_text = back_text;
		
		var back_target = new GL2.TouchTarget();
		back_target.setSize(100 * GameConstants.HEIGHT_SCALE, 56 * GameConstants.WIDTH_SCALE);
		back_target.setAnchor(0, 0);
		back_target.getTouchEmitter().addListener(this, this.onBackTouch);
		this.m_node.addChild(back_target);
		this.m_back_target = back_target;
		
		var level_text = new GL2.Text();
		level_text.setText("Levels");
		level_text.setFontSize(24);
		level_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		level_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		level_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
		level_text.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
		level_text.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
		level_text.setColor(1, 1, 1);
		level_text.setAnchor(0.5, 0.5);
		level_text.setPosition(GameConstants.SCREEN_HEIGHT / 3, 28 * GameConstants.WIDTH_SCALE);
		this.m_node.addChild(level_text);
		
		var best = new GL2.Text();
		best.setText("Best Scores");
		best.setFontLocation(GL2.Text.FontLocation.Manifest);
		best.setFontFamily("Content/Fonts/CarbonType.ttf");
		best.setHorizontalAlign(GL2.Text.HorizontalAlign.Right);
		best.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
		best.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
		best.setColor(1, 1, 1);
		best.setAnchor(1, 0.5);
		best.setPosition(GameConstants.SCREEN_HEIGHT - (5 * GameConstants.HEIGHT_SCALE), 28 * GameConstants.WIDTH_SCALE);
		this.m_node.addChild(best);
	},
	
	onBackTouch: function(touch_event) {
		switch (touch_event.getAction()) {
			case (GL2.Touch.Action.Start):{
				if (this.m_current_id == null) {
					this.m_current_id = touch_event.getId();
					this.m_scroll.m_current_touch_id = this.m_current_id;
					this.m_back_text.setColor(0.5, 0.5, 0.5);
					return true;
				}
				break;
			}
			case (GL2.Touch.Action.End):{
				this.m_current_id = null;
				this.m_back_text.setColor(1, 1, 1);
				this.m_scroll.m_current_touch_id = null;
				if (touch_event.getIsInside(this.m_back_target)) {
					this.goBack();
				}
				break;
			}
		}
	},
	
	goBack: function() {
		this.m_emitter.emit(["MENU"]);
	},
	
	addListener: function(obj, func) {
		this.m_emitter.addListener(obj, func);
	},
	
	getNode: function() {
		return this.m_node;
	},
	
	loadLevels: function() {
		this.m_levels = new Array();
		for(var idx = 0; idx < this.m_level_json.levels.length; idx++){
			this.createLevelElement(idx + 1, this.m_level_json.levels[idx].name, idx);
			/*var temp = new GL2.Sprite();
			temp.setImage("Content/levels_list_bkgr.png", [480 * GameConstants.HEIGHT_SCALE, 56 * GameConstants.WIDTH_SCALE]);
			this.m_scroll.addChild(temp, 0, idx * 56 * GameConstants.HEIGHT_SCALE, 56 * GameConstants.WIDTH_SCALE);
			temp = new GL2.Text();
			temp.setText((idx + 1) +  ":  " + this.m_level_json.levels[idx].name);
			console.log(temp.getText());
			temp.setText(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
			temp.setFontLocation(GL2.Text.FontLocation.Manifest);
			temp.setFontFamily("Content/Fonts/CarbonType.ttf");
			temp.setColor(0, 0, 0);
			this.m_scroll.addChild(temp, 0, idx * 56 * GameConstants.HEIGHT_SCALE, 56 * GameConstants.WIDTH_SCALE);
			temp = new GL2.TouchTarget();
			temp.setSize(480 * GameConstants.HEIGHT_SCALE, 56 * GameConstants.WIDTH_SCALE);
			//temp.setPosition(-240, idx * 56 - 28);
			temp.getTouchEmitter().addListener(this, this.onTouch);
			this.m_touch = temp;
			this.m_scroll.addNonvisibleChild(temp, -240 * GameConstants.HEIGHT_SCALE, idx * (56 - 28) * GameConstants.WIDTH_SCALE);
			this.m_targets.push(temp);*/
		}
	},
	
	createLevelElement: function(level_no, level_name, idx) {
		var bg = new GL2.Sprite();
		bg.setImage("Content/levels_list_bkgr.png", [GameConstants.SCREEN_HEIGHT, 56 * GameConstants.WIDTH_SCALE]);
		
		var level_text = new GL2.Text();
		level_text.setColor(0, 0, 0);
		level_text.setText(level_no + ")");
		level_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		level_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		level_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		level_text.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
		level_text.setAnchor(0, 0.5);
		level_text.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
		
		var level_name_text = new GL2.Text();
		level_name_text.setColor(0, 0, 1);
		level_name_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		level_name_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		level_name_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		level_name_text.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
		level_name_text.setAnchor(0, 0.5);
		level_name_text.setText(level_name);
		level_name_text.setSize(level_name.length * 10 * GameConstants.HEIGHT_SCALE, 56 * GameConstants.WIDTH_SCALE);
		level_name_text.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
		
		this.m_level_names.push(level_name_text);
		
		var best_score_text = new GL2.Text();
		best_score_text.setColor(0, 0, 0);
		best_score_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		best_score_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		best_score_text.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
		
		this.m_bests.push(best_score_text);
		
		var temp_score = SaveData.getValue(level_name + "_BEST", "0");
		
		var target = new GL2.TouchTarget();
		target.setSize(level_name.length * 15 * GameConstants.HEIGHT_SCALE, 56 * GameConstants.WIDTH_SCALE);
		target.getTouchEmitter().addListener(this, this.onTouch);
		
		this.m_targets.push(target);
		
		best_score_text.setText(temp_score != "0" ? temp_score : "-");
		best_score_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
		best_score_text.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
		
		this.m_scroll.addChild(bg, 0, 56 * GameConstants.WIDTH_SCALE * idx, 56 * GameConstants.WIDTH_SCALE);
		this.m_scroll.addChild(level_text, 10 * GameConstants.HEIGHT_SCALE - GameConstants.SCREEN_HEIGHT / 2, 56 * GameConstants.WIDTH_SCALE * idx, 56 * GameConstants.WIDTH_SCALE);
		this.m_scroll.addChild(level_name_text, 75 * GameConstants.HEIGHT_SCALE - GameConstants.SCREEN_HEIGHT / 2, 56 * GameConstants.WIDTH_SCALE * idx, 56 * GameConstants.WIDTH_SCALE);
		this.m_scroll.addChild(best_score_text, GameConstants.SCREEN_HEIGHT - (50 * GameConstants.HEIGHT_SCALE) - GameConstants.SCREEN_HEIGHT / 2, 56 * GameConstants.WIDTH_SCALE * idx, 56 * GameConstants.WIDTH_SCALE);
		this.m_scroll.addNonvisibleChild(target, 75 * GameConstants.HEIGHT_SCALE - GameConstants.SCREEN_HEIGHT / 2, 56 * GameConstants.WIDTH_SCALE * idx - 28);
		
		var temp = new Object();
		temp.bg = bg;
		temp.level_text = level_text;
		temp.level_name_text = level_name_text;
		temp.best_score_text = best_score_text;
		temp.target = target;
		
		this.m_levels.push(temp);
	},
	
	checkSkippedLevels: function() {
		this.m_levels_skipped = 0;
		for (var idx = 0; idx < this.m_levels.length; idx++) {
			
			var temp_obj = this.m_levels[idx];
			var temp_score = temp_obj.best_score_text.getText();
			if (this.m_levels_skipped < GameConstants.LEVELS_ABLE_TO_SKIP || temp_score != "-") {
				temp_obj.isEnabled = true;
				temp_obj.level_text.setColor(0, 0, 0);
				temp_obj.level_name_text.setColor(0, 0, 1);
				temp_obj.best_score_text.setColor(0, 0, 0);
			}
			else {
				temp_obj.isEnabled = false;
				temp_obj.level_text.setColor(0.5, 0.5, 0.5);
				temp_obj.level_name_text.setColor(0.5, 0.5, 0.5);
				temp_obj.best_score_text.setColor(0.5, 0.5, 0.5);
			}
			if (temp_score == "-") {
				this.m_levels_skipped++;			
			}
		}
	},
	
	onTouch: function(touch_event){
		if (this.m_current_id == null || touch_event.getId() == this.m_current_id) {
			this.m_scroll.onTouch(touch_event);
		}
		switch (touch_event.getAction()) {
			case (GL2.Touch.Action.Start):{
				if (this.m_active == true  && this.m_current_id == null) {
					for (var idx = 0; idx < this.m_targets.length; idx++) {
						if (touch_event.getIsInside(this.m_targets[idx])) {
							this.m_current_target = idx;
							this.m_current_amount_moved = 0;
							this.m_last_pos = touch_event.getPosition();
							if (this.m_levels[idx].isEnabled) {
								this.m_level_names[idx].setColor(0.5, 0.5, 0.5);
							}
							
							break;
						}	
					}
					this.m_current_id = touch_event.getId();
					return true;
				}
			}
			case (GL2.Touch.Action.End):{
				if (this.m_current_id == touch_event.getId()) {
					if (this.m_current_amount_moved < move_limit && touch_event.getIsInside(this.m_targets[this.m_current_target]) && this.m_levels[this.m_current_target].isEnabled) {
						console.log("LOAD LEVEL: " + this.m_level_json.levels[this.m_current_target].name);
						this.m_emitter.emit([this.m_level_json.levels[this.m_current_target].file, this.m_current_target + 1]);
						this.m_active = false;
					//this.m_touch.getTouchEmitter().removeListener(this, this.onTouch);
					}
					this.m_current_id = null;
					if (this.m_levels[this.m_current_target].isEnabled) {
						this.m_level_names[this.m_current_target].setColor(0, 0, 1);
					}
				}
				break;
			}
			case (GL2.Touch.Action.Move):{
				this.m_current_amount_moved += Math.abs(touch_event.getPosition().getY() - this.m_last_pos.getY());
				if (this.m_current_amount_moved > move_limit && this.m_levels[this.m_current_target].isEnabled) {
					this.m_level_names[this.m_current_target].setColor(0, 0, 1);
				}
				break;
			}
		}
		this.m_last_pos = touch_event.getPosition();
	},
	
	setActive: function() {
		this.m_active = true;	
	},
	
	updateBestScore: function(idx) {
		var temp_score = SaveData.getValue(this.m_level_json.levels[idx].name + "_BEST", "0");
		this.m_bests[idx].setText(temp_score != "0" ? temp_score : "-");
		
		
		this.checkSkippedLevels();
	},
	
	getLevelData: function(level_no){
		if (level_no < this.m_level_json.levels.length + 1) {
			this.m_emitter.emit([this.m_level_json.levels[level_no - 1].file, level_no]);
		}
		else {
			var levelsBeat = SaveData.getValue("LEVELSBEATEN", 0);
			if (levelsBeat == this.m_level_json.levels.length) {
				this.m_emitter.emit(["KILLSCREEN"]);
			// they beat the game.
			}
			else {
				this.m_emitter.emit(["LEVELSELECT"]);
			}
		}
	},
	

	
});


exports.LevelSelect = LevelSelect;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/util/SaveData'] = function(){var exports = $MODULE_REGISTRY['Code/util/SaveData'] || {}; $MODULE_REGISTRY['Code/util/SaveData'] = exports; var Core = require('NGCore/Client/Core').Core;
var Storage = require('NGCore/Client/Storage').Storage;

var exports = {};

var m_emitter = new Core.MessageEmitter();
var m_data = new Array();

var saveData = Core.Class.singleton({
	initialize: function(){
		this.save_file_name = "/Save/data.sav";
		this.getFile();
	},
	
	loadData: function(){
		if (arguments[1] != "") {
			var split_data = arguments[1].split('|');
			var num_pairs = split_data.length / 2;
			for (var idx = 0; idx < num_pairs; idx++) {
				m_data[split_data[idx * 2]] = split_data[idx * 2 + 1];
			}
			m_emitter.emit("LOADED");
		}
		else {
			//this.createFile();
		}
	},
	
	addListener: function(listen_object, listen_function) {
		m_emitter.addListener(listen_object, listen_function);	
	},
	
	removeMenuListener: function(listen_object, listen_function) {
		m_emitter.removeListener(listen_object, listen_function);	
	},
	
	forceInit: function() {
		console.log("Forcing SaveData Initialization");
	},
	
	createFile: function(){
		Storage.FileSystem.writeFile(this.save_file_name, "created|1", false, this.getfile);
	},
	
	getFile: function(){
		Storage.FileSystem.readFile(this.save_file_name, false, this.loadData);
	},
	
	saveFile: function(){
		var count = 0;
		var temp_string = "";
		for (var key in m_data) {
			if (count > 0) {
				temp_string += '|';
			}
			temp_string += key + '|' + m_data[key];
			count++;
		}
		Storage.FileSystem.writeFile(this.save_file_name, temp_string);
	},
	
	getValue: function(key){ // , default_value
		if (m_data[key] == null && arguments[1] != null) {
			this.updateValue(key, arguments[1]);
		}
		return (m_data[key]);
	},
	
	updateValue: function(key, value){
		m_data[key] = value;
		this.saveFile();
	},	
	
});

exports.SaveData = saveData;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/KillScreen'] = function(){var exports = $MODULE_REGISTRY['Code/KillScreen'] || {}; $MODULE_REGISTRY['Code/KillScreen'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;

var LeaderboardHandler = require('Code/util/Leaderboards').LeaderboardHandler;
var SaveData = require('Code/util/SaveData').SaveData;

var exports = {};

var self;

var KillScreen = Core.MessageListener.subclass({
	initialize: function(){
		this.m_current_touch_id = null;
		
		this.m_background = new GL2.Sprite();
		this.m_background.setImage("Content/paper_background.png", [GameConstants.SCREEN_HEIGHT, GameConstants.SCREEN_WIDTH]);
		this.m_background.setPosition(GameConstants.SCREEN_HEIGHT / 2, GameConstants.SCREEN_WIDTH / 2);
		
		this.m_node = new GL2.Node();
		
		this.m_graveyard_node = new GL2.Node();
		this.m_score_node = new GL2.Node();
		
		this.m_score_node.addChild(this.m_background);
		
		this.m_graveyard = new GL2.Sprite();
		this.m_graveyard.setImage("Content/graveyard.png", [GameConstants.SCREEN_HEIGHT, GameConstants.SCREEN_WIDTH]);
		this.m_graveyard.setPosition(GameConstants.SCREEN_HEIGHT / 2, GameConstants.SCREEN_WIDTH / 2);
		this.m_graveyard_node.addChild(this.m_graveyard);
		
		this.m_back_target = new GL2.TouchTarget();
		this.m_back_target.setSize(GameConstants.SCREEN_HEIGHT, GameConstants.SCREEN_WIDTH);
		this.m_back_target.setAnchor(0.5, 0.5);
		this.m_back_target.setPosition(GameConstants.SCREEN_HEIGHT / 2, GameConstants.SCREEN_WIDTH / 2);
		this.m_back_target.getTouchEmitter().addListener(this, this.onBackTouch);
		this.m_graveyard_node.addChild(this.m_back_target);
		
		this.m_dead_doll_text = new GL2.Text();
		this.m_dead_doll_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		this.m_dead_doll_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		this.m_dead_doll_text.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
		this.m_dead_doll_text.setAnchor(0.5, 0.5);
		this.m_dead_doll_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
		this.m_dead_doll_text.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
		this.m_dead_doll_text.setColor(0, 0, 0);
		this.m_dead_doll_text.setPosition(282 * GameConstants.HEIGHT_SCALE, 210 * GameConstants.WIDTH_SCALE);
		this.m_graveyard_node.addChild(this.m_dead_doll_text);
		
		this.updateDollText();
		
		this.m_scores_img = new GL2.Sprite();
		this.m_scores_img.setImage("Content/highscores_hover.png", [94 * GameConstants.HEIGHT_SCALE, 80 * GameConstants.WIDTH_SCALE]);
		this.m_scores_img.setPosition(447 * GameConstants.HEIGHT_SCALE, 205 * GameConstants.WIDTH_SCALE);
		this.m_graveyard_node.addChild(this.m_scores_img);
		this.m_scores_img.setColor(0, 0, 0);
		
		this.m_scores_target = new GL2.TouchTarget();
		this.m_scores_target.setPosition(this.m_scores_img.getPosition());
		this.m_scores_target.setSize([95 * GameConstants.HEIGHT_SCALE, 80 * GameConstants.WIDTH_SCALE]);
		this.m_scores_target.getTouchEmitter().addListener(this, this.onScoresTouch);
		this.m_scores_target.setAnchor([0.5, 0.5]);
		this.m_graveyard_node.addChild(this.m_scores_target);
		
		this.m_submit_img = new GL2.Sprite();
		this.m_submit_img.setImage("Content/submit_hover.png", [92 * GameConstants.HEIGHT_SCALE, 62 * GameConstants.WIDTH_SCALE]);
		this.m_submit_img.setPosition(92 * GameConstants.HEIGHT_SCALE, 172 * GameConstants.WIDTH_SCALE);
		this.m_graveyard_node.addChild(this.m_submit_img);
		this.m_submit_img.setColor(0, 0, 0);
		
		this.m_submit_target = new GL2.TouchTarget();
		this.m_submit_target.setPosition(this.m_submit_img.getPosition());
		this.m_submit_target.setSize(92 * GameConstants.HEIGHT_SCALE, 62 * GameConstants.WIDTH_SCALE);
		this.m_submit_target.getTouchEmitter().addListener(this, this.onSubmitTouch);
		this.m_submit_target.setAnchor([0.5, 0.5]);
		this.m_graveyard_node.addChild(this.m_submit_target);
		
		this.m_score_text = new GL2.Text();
		this.m_score_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
		this.m_score_text.setVerticalAlign(GL2.Text.VerticalAlign.Top);
		this.m_score_text.setColor(0, 0, 0);
		this.m_score_text.setPosition(GameConstants.SCREEN_HEIGHT / 2, 0);
		this.m_score_text.setAnchor(0.5, 0);
		this.m_score_text.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
		this.m_score_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		this.m_score_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		this.m_score_node.addChild(this.m_score_text);
		
		this.m_back_text = new GL2.Text();
		this.m_back_text.setText("Back");
		this.m_back_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Left)
		this.m_back_text.setVerticalAlign(GL2.Text.VerticalAlign.Top);
		this.m_back_text.setColor(0, 0, 1);
		this.m_back_text.setPosition(10, 10);
		this.m_back_text.setAnchor(0, 0);
		this.m_back_text.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
		this.m_back_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		this.m_back_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		this.m_score_node.addChild(this.m_back_text);
		
		this.m_back_target = new GL2.TouchTarget();
		this.m_back_target.setSize(70 * GameConstants.HEIGHT_SCALE, 50 * GameConstants.WIDTH_SCALE);
		this.m_back_target.setAnchor(0, 0);
		this.m_back_target.setPosition(0, 0);
		this.m_back_target.getTouchEmitter().addListener(this, this.onScoreBackTouch);
		this.m_score_node.addChild(this.m_back_target);
		
		this.m_emitter = new Core.MessageEmitter();
		
		self = this;
		
		this.m_node.addChild(this.m_graveyard_node);
	},
	
	updateDollText: function() {
		var total_score = SaveData.getValue("TOTALSCORE", 0);
		this.m_dead_doll_text.setText(total_score + "\nRagdolls");
	},
	
	destroy: function(){
	
	},
	
	getNode: function(){
		return this.m_node;
	},
	
	onScoresTouch: function(touch_event){
		switch (touch_event.getAction()) {
			case (GL2.Touch.Action.Start):{
				if (this.m_current_touch_id == null) {
					this.m_scores_img.setColor(0.5, 0.5, 0.5);
					this.m_current_touch_id = touch_event.getId();
					return true;
				}
				break;
			}
			case (GL2.Touch.Action.End):{
				if (this.m_current_touch_id == touch_event.getId()) {
					this.m_current_touch_id = null;
					this.m_scores_img.setColor(0, 0, 0);
					if (touch_event.getIsInside(this.m_scores_target)) {
						this.loadLeaderboard();
					}
				}
				break;
			}
		}
	},
	
	onSubmitTouch: function(touch_event){
		switch (touch_event.getAction()) {
			case (GL2.Touch.Action.Start):{
				if (this.m_current_touch_id == null) {
					this.m_submit_img.setColor(0.5, 0.5, 0.5);
					this.m_current_touch_id = touch_event.getId();
					return true;
				}
				break;
			}
			case (GL2.Touch.Action.End):{
				if (this.m_current_touch_id == touch_event.getId()) {
					this.m_current_touch_id = null;
					this.m_submit_img.setColor(0, 0, 0);
					if (touch_event.getIsInside(this.m_submit_target)) {
						this.submitScore();
					}
				}
			}
		}
	},
	
	onScoreBackTouch: function(touch_event) {
		switch (touch_event.getAction()) {
			case (GL2.Touch.Action.Start):{
				if (this.m_current_touch_id == null) {
					this.m_back_text.setColor(0.5, 0.5, 0.5);
					this.m_current_touch_id = touch_event.getId();
					return true;
				}
				break;
			}
			case (GL2.Touch.Action.End):{
				if (this.m_current_touch_id == touch_event.getId()) {
					this.m_current_touch_id = null;
					this.m_back_text.setColor(0, 0, 1);
					if (touch_event.getIsInside(this.m_back_target)) {
						this.backToGY();
					}
				}
			}
		}
	},
	
	loadLeaderboard: function(){
		LeaderboardHandler.getScoresByLevel(0, leaderboardLoaded);
	},
	
	submitScore: function() {
		// TODO: Verify that they have completed all the levels;
		
		var total_score = SaveData.getValue("TOTALSCORE");
		if (!LeaderboardHandler.submitScore(total_score, 0, scoreSubmitted)) {
			console.log("ERRRRRRROOOOOORRRR");
		}
	},
	
	leaderboardCallback: function(args){
		var scores = LeaderboardHandler.getCurrentScores();
		var user_score = LeaderboardHandler.getCurrentUserScore();
		var user_rank = LeaderboardHandler.getCurrentUserRank();
		var temp_text = "TOP SCORES:\n";
		for (var idx = 0; idx < scores.length && idx < 11; idx++) {
			temp_text += "\n";
			temp_text += scores[idx].rank + ": " + scores[idx].user.gamertag + ": " + scores[idx].displayScore;
		}
		
		if (user_rank != -1) {
			temp_text += "\n\nYour Rank: " + user_rank + "\nYour Score: " + user_score;
		}
		
		this.m_score_text.setText(temp_text);
		
		this.m_node.removeChild(this.m_graveyard_node);
		this.m_node.addChild(this.m_score_node);
		
	},
	
	submitCallback: function(args){
		this.loadLeaderboard();
		
	},
	
	onBackTouch: function(touch_event){
		switch(touch_event.getAction())
		{
			case (GL2.Touch.Action.Start):{
				if (touch_event.getIsInside(this.m_submit_target) == false && touch_event.getIsInside(this.m_scores_target) == false && this.m_current_touch_id == null) {
					this.m_current_touch_id = touch_event.getId();
					return true;
				}
			}
			case (GL2.Touch.Action.End):{
				if (!touch_event.getIsInside(this.m_submit_target) && !touch_event.getIsInside(this.m_scores_target)) {
					this.m_current_touch_id = null;
					this.returnToMenu();
					break;
				}
			}
		}	
	},
	
	returnToMenu: function(){
		this.m_emitter.emit("MENU");
	},
	
	backKeyHandler: function(){
		if (this.m_graveyard_node.getParent() == null && this.m_score_node.getParent() != null) {
			this.backToGY();
		}
		else {
			this.returnToMenu();
		}
	},
	
	backToGY: function(){
		if (this.m_score_node.getParent() != null) {
			this.m_score_node.getParent().removeChild(this.m_score_node);
		}
		this.m_node.addChild(this.m_graveyard_node);
	},
	
	addListener: function(obj, func){
		this.m_emitter.addListener(obj, func);
	},
});

function leaderboardLoaded(){
	self.leaderboardCallback(arguments);
}

function scoreSubmitted(){
	self.submitCallback(arguments);
}
exports.KillScreen = KillScreen;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/util/Leaderboards'] = function(){var exports = $MODULE_REGISTRY['Code/util/Leaderboards'] || {}; $MODULE_REGISTRY['Code/util/Leaderboards'] = exports; var Core = require('NGCore/Client/Core').Core;
var Social = require('NGCore/Client/Social').Social;

var exports = {};

var session;
var user;
var logged_in = false;
var boards = new Array();

var LeaderboardHandler = Core.Class.singleton({
	initialize: function(){
		// we can now assume you are logged in because it is forced through mobage. yay?
		this.m_current_scores;
		this.m_current_cb;
		try {
			session = Social.US.Session.getCurrentSession();
			user = session.user();
			logged_in = true;
			Social.US.Leaderboard.getLeaderboards(getBoardsCallback);
		}
		catch(e)
		{
			console.log("User was not logged in prior to launch");
			logged_in = false;
		}
	},
	
	isLoggedIn: function(){
		return logged_in;
	},
	
	getLeaderboardByLevel: function(requestedLevel){
		for (var idx = 0; idx < boards.length; idx++) {
			if (boards[idx].level == requestedLevel) {
				return boards[idx];
			}
		}
		return null;
	},
	
	submitScore: function(score, levelID, callback){
		if (user != null) {
			var tempBoard = this.getLeaderboardByLevel(levelID);
			if (tempBoard != null) {
				tempBoard.submitScore(score, callback);
				return true;
			}
			else {
				console.log("no board");
				return false;
			}
			
		}
		else {
			console.log("no user");
			return false;
		}
	},
	
	getScoresByLevel: function(id,cb){
		var board = this.getLeaderboardByLevel(id);
		if (board != null) {
			var args = board.getTopScoresList();
			this.m_current_scores = new Array();
			this.m_current_level_name = board.title;
			this.m_current_cb = cb;
			this.m_current_user_score = -1;
			this.m_current_user_rank = -1;
			args.forAll(processScores, scoreProcessingDone);
		}
		else {
			console.log("Leaderboard not found for ID: " + id);
		}
	},
	
	getCurrentScores: function(){
		return this.m_current_scores;
	},
	
	getCurrentLevelName: function(){
		return this.m_current_level_name;
	},
	
	getCurrentUserScore: function(){
		return this.m_current_user_score;
	},
	
	getCurrentUserRank: function(){
		return this.m_current_user_rank;
	},
	
	setCurrentUserRank: function(i) {
		this.m_current_user_rank = i;
	},
	
	setCurrentUserScore: function(i) {
		this.m_current_user_score = i;
	}, 
});

function processScores(continueCB, score){
	LeaderboardHandler.m_current_scores.push(score);
	var gamertag = score.user.gamertag;
	if (user != null && gamertag == user.gamertag) {
		LeaderboardHandler.setCurrentUserScore(score.displayScore);
		LeaderboardHandler.setCurrentUserRank(score.rank);
	}
	continueCB(true);
}

function scoreProcessingDone(){
	LeaderboardHandler.m_current_cb(LeaderboardHandler.m_current_scores, LeaderboardHandler.m_current_level_name);
	
}

function getBoardsCallback(){
	if (!arguments[0]) {
		for (var idx = 0; idx < arguments[1].length; idx++) {
			boards[idx] = arguments[1][idx];
		}
	}
	else {
		console.log("Error getting leaderboards");
	}
}

exports.LeaderboardHandler = LeaderboardHandler;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/util/json2'] = function(){var exports = $MODULE_REGISTRY['Code/util/json2'] || {}; $MODULE_REGISTRY['Code/util/json2'] = exports; /*
    http://www.JSON.org/json2.js
    2011-02-23

    Public Domain.

    NO WARRANTY EXPRESSED OR IMPLIED. USE AT YOUR OWN RISK.

    See http://www.JSON.org/js.html


    This code should be minified before deployment.
    See http://javascript.crockford.com/jsmin.html

    USE YOUR OWN COPY. IT IS EXTREMELY UNWISE TO LOAD CODE FROM SERVERS YOU DO
    NOT CONTROL.


    This file creates a global JSON object containing two methods: stringify
    and parse.

        JSON.stringify(value, replacer, space)
            value       any JavaScript value, usually an object or array.

            replacer    an optional parameter that determines how object
                        values are stringified for objects. It can be a
                        function or an array of strings.

            space       an optional parameter that specifies the indentation
                        of nested structures. If it is omitted, the text will
                        be packed without extra whitespace. If it is a number,
                        it will specify the number of spaces to indent at each
                        level. If it is a string (such as '\t' or '&nbsp;'),
                        it contains the characters used to indent at each level.

            This method produces a JSON text from a JavaScript value.

            When an object value is found, if the object contains a toJSON
            method, its toJSON method will be called and the result will be
            stringified. A toJSON method does not serialize: it returns the
            value represented by the name/value pair that should be serialized,
            or undefined if nothing should be serialized. The toJSON method
            will be passed the key associated with the value, and this will be
            bound to the value

            For example, this would serialize Dates as ISO strings.

                Date.prototype.toJSON = function (key) {
                    function f(n) {
                        // Format integers to have at least two digits.
                        return n < 10 ? '0' + n : n;
                    }

                    return this.getUTCFullYear()   + '-' +
                         f(this.getUTCMonth() + 1) + '-' +
                         f(this.getUTCDate())      + 'T' +
                         f(this.getUTCHours())     + ':' +
                         f(this.getUTCMinutes())   + ':' +
                         f(this.getUTCSeconds())   + 'Z';
                };

            You can provide an optional replacer method. It will be passed the
            key and value of each member, with this bound to the containing
            object. The value that is returned from your method will be
            serialized. If your method returns undefined, then the member will
            be excluded from the serialization.

            If the replacer parameter is an array of strings, then it will be
            used to select the members to be serialized. It filters the results
            such that only members with keys listed in the replacer array are
            stringified.

            Values that do not have JSON representations, such as undefined or
            functions, will not be serialized. Such values in objects will be
            dropped; in arrays they will be replaced with null. You can use
            a replacer function to replace those with JSON values.
            JSON.stringify(undefined) returns undefined.

            The optional space parameter produces a stringification of the
            value that is filled with line breaks and indentation to make it
            easier to read.

            If the space parameter is a non-empty string, then that string will
            be used for indentation. If the space parameter is a number, then
            the indentation will be that many spaces.

            Example:

            text = JSON.stringify(['e', {pluribus: 'unum'}]);
            // text is '["e",{"pluribus":"unum"}]'


            text = JSON.stringify(['e', {pluribus: 'unum'}], null, '\t');
            // text is '[\n\t"e",\n\t{\n\t\t"pluribus": "unum"\n\t}\n]'

            text = JSON.stringify([new Date()], function (key, value) {
                return this[key] instanceof Date ?
                    'Date(' + this[key] + ')' : value;
            });
            // text is '["Date(---current time---)"]'


        JSON.parse(text, reviver)
            This method parses a JSON text to produce an object or array.
            It can throw a SyntaxError exception.

            The optional reviver parameter is a function that can filter and
            transform the results. It receives each of the keys and values,
            and its return value is used instead of the original value.
            If it returns what it received, then the structure is not modified.
            If it returns undefined then the member is deleted.

            Example:

            // Parse the text. Values that look like ISO date strings will
            // be converted to Date objects.

            myData = JSON.parse(text, function (key, value) {
                var a;
                if (typeof value === 'string') {
                    a =
/^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2}(?:\.\d*)?)Z$/.exec(value);
                    if (a) {
                        return new Date(Date.UTC(+a[1], +a[2] - 1, +a[3], +a[4],
                            +a[5], +a[6]));
                    }
                }
                return value;
            });

            myData = JSON.parse('["Date(09/09/2001)"]', function (key, value) {
                var d;
                if (typeof value === 'string' &&
                        value.slice(0, 5) === 'Date(' &&
                        value.slice(-1) === ')') {
                    d = new Date(value.slice(5, -1));
                    if (d) {
                        return d;
                    }
                }
                return value;
            });


    This is a reference implementation. You are free to copy, modify, or
    redistribute.
*/

/*jslint evil: true, strict: false, regexp: false */

/*members "", "\b", "\t", "\n", "\f", "\r", "\"", JSON, "\\", apply,
    call, charCodeAt, getUTCDate, getUTCFullYear, getUTCHours,
    getUTCMinutes, getUTCMonth, getUTCSeconds, hasOwnProperty, join,
    lastIndex, length, parse, prototype, push, replace, slice, stringify,
    test, toJSON, toString, valueOf
*/


// Create a JSON object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.

var exports = {};

var JSON;
if (!JSON) {
    JSON = {};
}

(function () {
    "use strict";

    function f(n) {
        // Format integers to have at least two digits.
        return n < 10 ? '0' + n : n;
    }

    if (typeof Date.prototype.toJSON !== 'function') {

        Date.prototype.toJSON = function (key) {

            return isFinite(this.valueOf()) ?
                this.getUTCFullYear()     + '-' +
                f(this.getUTCMonth() + 1) + '-' +
                f(this.getUTCDate())      + 'T' +
                f(this.getUTCHours())     + ':' +
                f(this.getUTCMinutes())   + ':' +
                f(this.getUTCSeconds())   + 'Z' : null;
        };

        String.prototype.toJSON      =
            Number.prototype.toJSON  =
            Boolean.prototype.toJSON = function (key) {
                return this.valueOf();
            };
    }

    var cx = /[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        escapable = /[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        gap,
        indent,
        meta = {    // table of character substitutions
            '\b': '\\b',
            '\t': '\\t',
            '\n': '\\n',
            '\f': '\\f',
            '\r': '\\r',
            '"' : '\\"',
            '\\': '\\\\'
        },
        rep;


    function quote(string) {

// If the string contains no control characters, no quote characters, and no
// backslash characters, then we can safely slap some quotes around it.
// Otherwise we must also replace the offending characters with safe escape
// sequences.

        escapable.lastIndex = 0;
        return escapable.test(string) ? '"' + string.replace(escapable, function (a) {
            var c = meta[a];
            return typeof c === 'string' ? c :
                '\\u' + ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
        }) + '"' : '"' + string + '"';
    }


    function str(key, holder) {

// Produce a string from holder[key].

        var i,          // The loop counter.
            k,          // The member key.
            v,          // The member value.
            length,
            mind = gap,
            partial,
            value = holder[key];

// If the value has a toJSON method, call it to obtain a replacement value.

        if (value && typeof value === 'object' &&
                typeof value.toJSON === 'function') {
            value = value.toJSON(key);
        }

// If we were called with a replacer function, then call the replacer to
// obtain a replacement value.

        if (typeof rep === 'function') {
            value = rep.call(holder, key, value);
        }

// What happens next depends on the value's type.

        switch (typeof value) {
        case 'string':
            return quote(value);

        case 'number':

// JSON numbers must be finite. Encode non-finite numbers as null.

            return isFinite(value) ? String(value) : 'null';

        case 'boolean':
        case 'null':

// If the value is a boolean or null, convert it to a string. Note:
// typeof null does not produce 'null'. The case is included here in
// the remote chance that this gets fixed someday.

            return String(value);

// If the type is 'object', we might be dealing with an object or an array or
// null.

        case 'object':

// Due to a specification blunder in ECMAScript, typeof null is 'object',
// so watch out for that case.

            if (!value) {
                return 'null';
            }

// Make an array to hold the partial results of stringifying this object value.

            gap += indent;
            partial = [];

// Is the value an array?

            if (Object.prototype.toString.apply(value) === '[object Array]') {

// The value is an array. Stringify every element. Use null as a placeholder
// for non-JSON values.

                length = value.length;
                for (i = 0; i < length; i += 1) {
                    partial[i] = str(i, value) || 'null';
                }

// Join all of the elements together, separated with commas, and wrap them in
// brackets.

                v = partial.length === 0 ? '[]' : gap ?
                    '[\n' + gap + partial.join(',\n' + gap) + '\n' + mind + ']' :
                    '[' + partial.join(',') + ']';
                gap = mind;
                return v;
            }

// If the replacer is an array, use it to select the members to be stringified.

            if (rep && typeof rep === 'object') {
                length = rep.length;
                for (i = 0; i < length; i += 1) {
                    if (typeof rep[i] === 'string') {
                        k = rep[i];
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? ': ' : ':') + v);
                        }
                    }
                }
            } else {

// Otherwise, iterate through all of the keys in the object.

                for (k in value) {
                    if (Object.prototype.hasOwnProperty.call(value, k)) {
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? ': ' : ':') + v);
                        }
                    }
                }
            }

// Join all of the member texts together, separated with commas,
// and wrap them in braces.

            v = partial.length === 0 ? '{}' : gap ?
                '{\n' + gap + partial.join(',\n' + gap) + '\n' + mind + '}' :
                '{' + partial.join(',') + '}';
            gap = mind;
            return v;
        }
    }

// If the JSON object does not yet have a stringify method, give it one.

    if (typeof JSON.stringify !== 'function') {
        JSON.stringify = function (value, replacer, space) {

// The stringify method takes a value and an optional replacer, and an optional
// space parameter, and returns a JSON text. The replacer can be a function
// that can replace values, or an array of strings that will select the keys.
// A default replacer method can be provided. Use of the space parameter can
// produce text that is more easily readable.

            var i;
            gap = '';
            indent = '';

// If the space parameter is a number, make an indent string containing that
// many spaces.

            if (typeof space === 'number') {
                for (i = 0; i < space; i += 1) {
                    indent += ' ';
                }

// If the space parameter is a string, it will be used as the indent string.

            } else if (typeof space === 'string') {
                indent = space;
            }

// If there is a replacer, it must be a function or an array.
// Otherwise, throw an error.

            rep = replacer;
            if (replacer && typeof replacer !== 'function' &&
                    (typeof replacer !== 'object' ||
                    typeof replacer.length !== 'number')) {
                throw new Error('JSON.stringify');
            }

// Make a fake root object containing our value under the key of ''.
// Return the result of stringifying the value.

            return str('', {'': value});
        };
    }


// If the JSON object does not yet have a parse method, give it one.

    if (typeof JSON.parse !== 'function') {
        JSON.parse = function (text, reviver) {

// The parse method takes a text and an optional reviver function, and returns
// a JavaScript value if the text is a valid JSON text.

            var j;

            function walk(holder, key) {

// The walk method is used to recursively walk the resulting structure so
// that modifications can be made.

                var k, v, value = holder[key];
                if (value && typeof value === 'object') {
                    for (k in value) {
                        if (Object.prototype.hasOwnProperty.call(value, k)) {
                            v = walk(value, k);
                            if (v !== undefined) {
                                value[k] = v;
                            } else {
                                delete value[k];
                            }
                        }
                    }
                }
                return reviver.call(holder, key, value);
            }


// Parsing happens in four stages. In the first stage, we replace certain
// Unicode characters with escape sequences. JavaScript handles many characters
// incorrectly, either silently deleting them, or treating them as line endings.

            text = String(text);
            cx.lastIndex = 0;
            if (cx.test(text)) {
                text = text.replace(cx, function (a) {
                    return '\\u' +
                        ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
                });
            }

// In the second stage, we run the text against regular expressions that look
// for non-JSON patterns. We are especially concerned with '()' and 'new'
// because they can cause invocation, and '=' because it can cause mutation.
// But just to be safe, we want to reject all unexpected forms.

// We split the second stage into 4 regexp operations in order to work around
// crippling inefficiencies in IE's and Safari's regexp engines. First we
// replace the JSON backslash pairs with '@' (a non-JSON character). Second, we
// replace all simple value tokens with ']' characters. Third, we delete all
// open brackets that follow a colon or comma or that begin the text. Finally,
// we look to see that the remaining characters are only whitespace or ']' or
// ',' or ':' or '{' or '}'. If that is so, then the text is safe for eval.

            if (/^[\],:{}\s]*$/
                    .test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g, '@')
                        .replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']')
                        .replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {

// In the third stage we use the eval function to compile the text into a
// JavaScript structure. The '{' operator is subject to a syntactic ambiguity
// in JavaScript: it can begin a block or an object literal. We wrap the text
// in parens to eliminate the ambiguity.

                j = eval('(' + text + ')');

// In the optional fourth stage, we recursively walk the new structure, passing
// each name/value pair to a reviver function for possible transformation.

                return typeof reviver === 'function' ?
                    walk({'': j}, '') : j;
            }

// If the text is not JSON parseable, then a SyntaxError is thrown.

            throw new SyntaxError('JSON.parse');
        };
    }
}());

exports.JSON = JSON;
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/util/AdManager'] = function(){var exports = $MODULE_REGISTRY['Code/util/AdManager'] || {}; $MODULE_REGISTRY['Code/util/AdManager'] = exports; var Core = require('NGCore/Client/Core').Core;
var UI = require('NGCore/Client/UI').UI;
var BannerAdView = require('NGCore/Client/Mobclix/AdView').AdView_320x50;
var BigAdView = require('NGCore/Client/Mobclix/AdView').AdView_300x250;
var Mobclix = require('NGCore/Client/Mobclix').Mobclix;
var Social = require('NGCore/Client/Social').Social;

var GameConstants = require('Code/GameConstants').GameConstants;

var exports = {};

function loadFail(view, code, message){
	self.loadFailedHandler(view, code, message);
}

function fattyCloseClick(args){
	self.closeFattyAd();
}

var AdManager = Core.Class.subclass({
	initialize: function(){
		Mobclix.startWithApplicationId(GameConstants.AD_ID);
		this.m_is_xoom = false;
		this.m_close_callback;
		//this.m_banner = new BannerAdView();
		this.m_fatty = new BigAdView();
		this.m_fatty.getAd();
		this.m_fatty.setOnFailedToLoad(loadFail);
		
		this.m_interstitial_background = new UI.Image();
		this.m_interstitial_background.setImage("Content/Ad_Coverup.png");
		this.m_interstitial_background.setFrame(0, 0, Core.Capabilities.getScreenHeight(), Core.Capabilities.getScreenWidth());
		this.m_interstitial_background.setImageFit(UI.FitMode.Stretch);
		this.m_interstitial_background.setAlpha(0.7);
		
		this.m_interstitial_close = new UI.Button();
		this.m_interstitial_close.setText("X");
		this.m_interstitial_close.setFrame(Core.Capabilities.getScreenHeight() / 2 + 225, Core.Capabilities.getScreenWidth() / 2 - 175, 50 * GameConstants.HEIGHT_SCALE, 50 * GameConstants.WIDTH_SCALE);
		this.m_interstitial_close.setTextColor("FFFFFF");
		this.m_interstitial_close.setTextSize(20 * GameConstants.HEIGHT_SCALE);
		this.m_interstitial_close.setOnClick(fattyCloseClick);
		this.m_interstitial_close.setBackgroundColor("AB0000");
		
		//var frame = this.m_banner.getFrame();
		
		if (Core.Capabilities.getDeviceName() == "Xoom") {
			this.m_is_xoom = true;
		}
		
		//frame[0] = GameConstants.SCREEN_WIDTH / 2 - frame[2] / 2;
		
		//this.m_banner.setFrame(frame);
		
		self = this;
		
		//this.moveAdToBottom();
		//UI.Window.document.addChild(this.m_banner);
	},
	
	setInterstitialCloseCallback: function(func) {
		this.m_close_callback = func;
	}, 
	
	loadFailedHandler: function(view, code, message) {
		console.log("Error recieved, hiding ad for now");
		console.log(view);
		console.log(code);
		console.log(message);
		this.closeFattyAd();
	},
	
	closeFattyAd: function() {
		if (this.m_fatty.getParent() != null) {
			UI.Window.document.removeChild(this.m_fatty);
			UI.Window.document.removeChild(this.m_interstitial_background);
			UI.Window.document.removeChild(this.m_interstitial_close);
			this.m_fatty.getAd();
			this.m_fatty.pauseAdAutoRefresh();
			if (this.m_close_callback != null) {
				this.m_close_callback();
			}
			
		}
	},
	
	isAdShown: function() {
		return this.m_fatty.getParent() != null;
	},
	
	moveAdToBottom: function(){
		//var frame = this.m_banner.getFrame();
		//frame[1] = Core.Capabilities.getScreenHeight() - frame[3];
		//frame[1] = UI.Window.outerHeight - frame[3];
		/*if (this.m_is_xoom) {
			frame[1] = Core.Capabilities.getScreenHeight() - frame[3] - Core.Capabilities.getStatusBarHeight() * 2; 
		}*/
		//this.m_banner.setFrame(frame);
		//this.m_banner.getAd();
		Social.US.Service.ButtonOverlays.showCommunityButton([1, 0]);
	},
	
	showInterstitial: function() {
		var frame = this.m_fatty.getFrame();
		frame[0] = UI.Window.outerHeight / 2- frame[2] / 2;
		frame[1] = UI.Window.outerWidth / 2 - frame[3] / 2;
		this.m_fatty.setFrame(frame);
		this.m_interstitial_close.setFrame(frame[0] + frame[2], frame[1], 50 * GameConstants.HEIGHT_SCALE, 50 * GameConstants.WIDTH_SCALE);
		UI.Window.document.addChild(this.m_interstitial_background);
		UI.Window.document.addChild(this.m_fatty);
		UI.Window.document.addChild(this.m_interstitial_close);
		//this.m_fatty.getAd();
	},
	
	moveAdToTop: function(){
		//var frame = this.m_banner.getFrame();
		//frame[1] = 0;
		//this.m_banner.setFrame(frame);
		//this.m_banner.getAd();
		Social.US.Service.ButtonOverlays.showCommunityButton([0, 1]);
	},
	
	showBannerAd: function() {
		/*if (this.m_banner.getParent() == null) {
			UI.Window.document.addChild(this.m_banner);
		}*/
	},
	
	hideBannerAd: function() {
		/*if (this.m_banner.getParent() != null) {
			UI.Window.document.removeChild(this.m_banner);
			
		}*/
	},
	
	showBigAd: function(){
		UI.Window.document.addChild(this.m_fatty);
		//this.m_fatty.getAd();
	},
	
	hideBigAd: function(){
		UI.Window.document.removeChild(this.m_fatty);
		this.m_fatty.pauseAds();
	},
	
	putMobageButtonBottom: function(){
		Social.US.Service.ButtonOverlays.showCommunityButton([1, 1]);
	},
	
	putMobageButtonTop: function(){
		Social.US.Service.ButtonOverlays.showCommunityButton([1, 0]);
	},
});

exports.AdManager = AdManager;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/util/BFAudio'] = function(){var exports = $MODULE_REGISTRY['Code/util/BFAudio'] || {}; $MODULE_REGISTRY['Code/util/BFAudio'] = exports; var Audio = require('NGCore/Client/Audio').Audio;
var Core = require('NGCore/Client/Core').Core;

var SaveData = require('Code/util/SaveData').SaveData;

var exports = {};

var BFAudio = Core.Class.singleton( {
	initialize: function(){
		this.m_sound_muted = SaveData.getValue("sound_on", "1") == "0";
		this.m_music_muted = SaveData.getValue("music_on", "1") == "0";
		
		// load all the effects;
		this.m_cannon_sound = new Audio.ActiveEffect(new Audio.Effect("Content/Sounds/Cannon.ogg"));
		this.m_chimes_sound = new Audio.ActiveEffect(new Audio.Effect("Content/Sounds/Chimes.ogg"));
		this.m_click_sound = new Audio.ActiveEffect(new Audio.Effect("Content/Sounds/Click.ogg"));
		this.setMusic("Content/Sounds/MountainKing.ogg");
	}, // init
	
	setMusic: function(newMusic) {
		Audio.Music.setPath(newMusic);
		if (this.m_music_muted == false) {
			Audio.Music.play();
		}
	}, // setMusic
	
	startMusic: function() {
		if (this.m_music_muted == false) {
			console.log("starting music");
			Audio.Music.play();
		}
	}, // startMusic
	
	stopMusic: function() {
		console.log("Stopping Music");
		Audio.Music.stop();	
	}, // stopMusic
	
	playSound: function(sound) {
		var play_me = null;
		switch (sound) {
			case ("CANNON"):{
				play_me = this.m_cannon_sound;
				break;
			}
			case ("CLICK"):{
				play_me = this.m_click_sound;
				break;
			}
			case ("TARGET"):{
				play_me = this.m_chimes_sound;
				break;
			}
		}
		if (!this.m_sound_muted && play_me != null) {
			console.log("PLAAAAAAAAAY");
			console.log(play_me.getVolume());
			play_me.stop();
			play_me.play();
		} // if
	}, // playSound
	
	toggleSound: function(){
		this.m_sound_muted = !this.m_sound_muted;
		SaveData.updateValue("sound_on", this.m_sound_muted ? "0" : "1");
	},
	
	toggleMusic: function(){
		this.m_music_muted = !this.m_music_muted;
		if (this.m_music_muted) {
			this.stopMusic();
		}
		else {
			this.startMusic();
		}
		SaveData.updateValue("music_on", this.m_music_muted ? "0" : "1");
	},
	
	getSoundMuted: function(){
		return this.m_sound_muted;
	},
	
	getMusicMuted: function() {
		return this.m_music_muted;
	},
});

exports.BFAudio = BFAudio;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Menu'] = function(){var exports = $MODULE_REGISTRY['Code/Menu'] || {}; $MODULE_REGISTRY['Code/Menu'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var UI = require('NGCore/Client/UI').UI;

var GameConstants = require('Code/GameConstants').GameConstants;

var BFAudio = require('Code/util/BFAudio').BFAudio;
var SaveData = require('Code/util/SaveData').SaveData;

var exports = {};

var xLoc = 80 * GameConstants.HEIGHT_SCALE;
var yLoc = 25 * GameConstants.WIDTH_SCALE;
var ySpacing = 65 * GameConstants.WIDTH_SCALE;

var self;

var Menu = Core.MessageListener.subclass({
	initialize: function(){
		this.m_node = new GL2.Node();
		this.m_main_node = new GL2.Node();
		
		xLoc = 80 * GameConstants.HEIGHT_SCALE;
		yLoc = 25 * GameConstants.WIDTH_SCALE;
		ySpacing = 65 * GameConstants.WIDTH_SCALE;
		
		this.m_current_touch_id = null;
		
		this.m_emitter = new Core.MessageEmitter();
		
		this.m_background = new GL2.Sprite();
		this.m_background.setImage("Content/paper_background.png", [GameConstants.SCREEN_HEIGHT, GameConstants.SCREEN_WIDTH]);
		this.m_background.setPosition(GameConstants.SCREEN_HEIGHT / 2, GameConstants.SCREEN_WIDTH / 2);
		this.m_node.addChild(this.m_background);
		
		this.m_title_text = new GL2.Text();
		this.m_title_text.setText("Ragdoll Blaster");
		this.m_title_text.setColor(0, 0, 0);
		this.m_title_text.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
		this.m_title_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		this.m_title_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		this.m_title_text.setPosition(GameConstants.SCREEN_HEIGHT / 2, 10 * GameConstants.WIDTH_SCALE);
		this.m_title_text.setAnchor(0.5, 0);
		this.m_title_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
		this.m_title_text.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
		this.m_title_text.setFontSize(25);
		this.m_main_node.addChild(this.m_title_text);
		
		this.m_select_text = new GL2.Text();
		this.m_select_text.setText("LEVEL SELECT");
		this.m_select_text.setColor(0, 0, 1);
		this.m_select_text.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
		this.m_select_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		this.m_select_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		this.m_select_text.setPosition(xLoc, yLoc + ySpacing);
		this.m_select_text.setFontSize(20);
		this.m_select_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		this.m_select_text.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
		this.m_select_text.setAnchor(0, 0.5);
		this.m_main_node.addChild(this.m_select_text);
		
		this.m_options_text = new GL2.Text();
		this.m_options_text.setText("OPTIONS");
		this.m_options_text.setColor(0, 0, 1);
		this.m_options_text.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
		this.m_options_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		this.m_options_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		this.m_options_text.setPosition(xLoc, yLoc + ySpacing * 2);
		this.m_options_text.setFontSize(20);
		this.m_options_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		this.m_options_text.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
		this.m_options_text.setAnchor(0, 0.5);
		this.m_main_node.addChild(this.m_options_text);
		
		this.m_about_text = new GL2.Text();
		this.m_about_text.setText("ABOUT");
		this.m_about_text.setColor(0, 0, 1);
		this.m_about_text.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
		this.m_about_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		this.m_about_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		this.m_about_text.setPosition(xLoc, yLoc + ySpacing * 3);
		this.m_about_text.setFontSize(20);
		this.m_about_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		this.m_about_text.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
		this.m_about_text.setAnchor(0, 0.5);
		this.m_main_node.addChild(this.m_about_text);
		
		this.m_score_text = new GL2.Text();
		this.m_score_text.setText("TOTAL SCORE");
		this.m_score_text.setColor(0, 0, 1);
		this.m_score_text.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
		this.m_score_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		this.m_score_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		this.m_score_text.setPosition(xLoc, yLoc + ySpacing * 4);
		this.m_score_text.setFontSize(20);
		this.m_score_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		this.m_score_text.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
		this.m_score_text.setAnchor(0, 0.5);
		
		this.m_select_target = new GL2.TouchTarget();
		this.m_select_target.setAnchor(0, 0.5);
		this.m_select_target.setSize(190 * GameConstants.HEIGHT_SCALE, 50 * GameConstants.WIDTH_SCALE);
		this.m_select_target.setPosition(this.m_select_text.getPosition().getX() - (10 * GameConstants.HEIGHT_SCALE), this.m_select_text.getPosition().getY());
		this.m_select_target.getTouchEmitter().addListener(this, this.onSelectTouch);
		this.m_main_node.addChild(this.m_select_target);
		
		this.m_options_target = new GL2.TouchTarget();
		this.m_options_target.setAnchor(0, 0.5);
		this.m_options_target.setSize(120 * GameConstants.HEIGHT_SCALE, 50 * GameConstants.WIDTH_SCALE);
		this.m_options_target.setPosition(this.m_options_text.getPosition().getX() - (10 * GameConstants.HEIGHT_SCALE), this.m_options_text.getPosition().getY());
		this.m_options_target.getTouchEmitter().addListener(this, this.onOptionsTouch);
		this.m_main_node.addChild(this.m_options_target);
		
		this.m_about_target = new GL2.TouchTarget();
		this.m_about_target.setAnchor(0, 0.5);
		this.m_about_target.setSize(90 * GameConstants.HEIGHT_SCALE, 50 * GameConstants.WIDTH_SCALE);
		this.m_about_target.setPosition(this.m_about_text.getPosition().getX() - (10 * GameConstants.HEIGHT_SCALE), this.m_about_text.getPosition().getY());
		this.m_about_target.getTouchEmitter().addListener(this, this.onAboutTouch);
		this.m_main_node.addChild(this.m_about_target);
		
		this.m_scores_target = new GL2.TouchTarget();
		this.m_scores_target.setAnchor(0, 0.5);
		this.m_scores_target.setSize(190 * GameConstants.HEIGHT_SCALE, 50 * GameConstants.WIDTH_SCALE);
		this.m_scores_target.setPosition(this.m_score_text.getPosition().getX() - (10 * GameConstants.HEIGHT_SCALE), this.m_score_text.getPosition().getY());
		this.m_scores_target.getTouchEmitter().addListener(this, this.onScoresTouch);
		
		if (GameConstants.ENABLE_FPS) {
			this.m_leak_text = new GL2.Text();
			this.m_leak_text.setText("LEAK CHECK");
			this.m_leak_text.setColor(0, 0, 1);
			this.m_leak_text.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
			this.m_leak_text.setFontLocation(GL2.Text.FontLocation.Manifest);
			this.m_leak_text.setFontFamily("Content/Fonts/CarbonType.ttf");
			this.m_leak_text.setPosition(xLoc, yLoc + ySpacing * 4);
			this.m_leak_text.setFontSize(20);
			this.m_leak_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
			this.m_leak_text.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
			this.m_leak_text.setAnchor(0, 0.5);
			
			this.m_leak_target = new GL2.TouchTarget();
			this.m_leak_target.setAnchor(0, 0.5);
			this.m_leak_target.setSize(190 * GameConstants.HEIGHT_SCALE, 50 * GameConstants.WIDTH_SCALE);
			this.m_leak_target.setPosition(this.m_leak_text.getPosition().getX() - (10 * GameConstants.HEIGHT_SCALE), this.m_leak_text.getPosition().getY());
			this.m_leak_target.getTouchEmitter().addListener(this, this.onLeakTouch);
			
			this.m_node.addChild(this.m_leak_target);
			this.m_node.addChild(this.m_leak_text);
		}
		
		this.checkToShowScores();
		this.createOptionsScreen();
		this.createAboutScreen();
		
		this.m_node.addChild(this.m_main_node);
		
		self = this;
	},
	
	destroy: function(){
		// TODO: destructor
	},	
	
	getNode: function(){
		return this.m_node;
	},
	
	createOptionsScreen: function() {
		this.m_options_node = new GL2.Node();
		
		this.m_music_text = new GL2.Text();
		this.m_music_text.setText("Enable Music:");
		this.m_music_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		this.m_music_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		this.m_music_text.setPosition(xLoc, yLoc + ySpacing * 2);
		this.m_music_text.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
		this.m_music_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		this.m_music_text.setFontSize(25);
		this.m_music_text.setColor(0, 0, 1);
		this.m_music_text.setAnchor(0, 0.5);
		this.m_options_node.addChild(this.m_music_text);
		
		this.m_sound_text = new GL2.Text();
		this.m_sound_text.setText("Enable Sound:");
		this.m_sound_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		this.m_sound_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		this.m_sound_text.setPosition(xLoc, yLoc + ySpacing * 3);
		this.m_sound_text.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
		this.m_sound_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		this.m_sound_text.setFontSize(25);
		this.m_sound_text.setColor(0, 0, 1);
		this.m_sound_text.setAnchor(0, 0.5);
		this.m_options_node.addChild(this.m_sound_text);
		
		this.m_music_checkbox = new UI.CheckBox();
		this.m_music_checkbox.setFrame(xLoc + (200 * GameConstants.HEIGHT_SCALE), yLoc + ySpacing * 2 - (20 * GameConstants.WIDTH_SCALE), 40 * GameConstants.HEIGHT_SCALE, 40 * GameConstants.WIDTH_SCALE);
		this.m_music_checkbox.setOnClick(musicCheckboxClicked);
		this.m_music_checkbox.setChecked(!BFAudio.getMusicMuted());
			
		this.m_sound_checkbox = new UI.CheckBox();
		this.m_sound_checkbox.setFrame(xLoc + (200 * GameConstants.HEIGHT_SCALE), yLoc + ySpacing * 3 - (20 * GameConstants.WIDTH_SCALE), 40 * GameConstants.HEIGHT_SCALE, 40 * GameConstants.WIDTH_SCALE);
		this.m_sound_checkbox.setOnClick(soundCheckboxClicked);
		this.m_sound_checkbox.setChecked(!BFAudio.getSoundMuted());
		
		this.m_back_text = new GL2.Text();
		this.m_back_text.setText("Back");
		this.m_back_text.setHorizontalAlign(GL2.Text.HorizontalAlign.Left)
		this.m_back_text.setVerticalAlign(GL2.Text.VerticalAlign.Top);
		this.m_back_text.setColor(0, 0, 1);
		this.m_back_text.setPosition(10, 10);
		this.m_back_text.setAnchor(0, 0);
		this.m_back_text.setScale(GameConstants.HEIGHT_SCALE, GameConstants.WIDTH_SCALE);
		this.m_back_text.setFontLocation(GL2.Text.FontLocation.Manifest);
		this.m_back_text.setFontFamily("Content/Fonts/CarbonType.ttf");
		this.m_options_node.addChild(this.m_back_text);
		
		this.m_back_target = new GL2.TouchTarget();
		this.m_back_target.setSize(70 * GameConstants.HEIGHT_SCALE, 50 * GameConstants.WIDTH_SCALE);
		this.m_back_target.setAnchor(0, 0);
		this.m_back_target.setPosition(0, 0);
		this.m_back_target.getTouchEmitter().addListener(this, this.onBackTouch);
		this.m_options_node.addChild(this.m_back_target);
	},
	
	createAboutScreen: function() {
		this.m_about_node = new GL2.Node();
		
		this.m_about_img = new GL2.Sprite();
		this.m_about_img.setImage("Content/about_screen.png", [GameConstants.SCREEN_HEIGHT, GameConstants.SCREEN_WIDTH]);
		this.m_about_img.setPosition(GameConstants.SCREEN_HEIGHT / 2, GameConstants.SCREEN_WIDTH / 2);
		this.m_about_node.addChild(this.m_about_img);
		
		this.m_site_img = new GL2.Sprite();
		this.m_site_img.setImage("Content/website.png", [250 * GameConstants.HEIGHT_SCALE, 20 * GameConstants.WIDTH_SCALE]);
		this.m_site_img.setPosition(375 * GameConstants.HEIGHT_SCALE, 121 * GameConstants.WIDTH_SCALE);
		this.m_about_node.addChild(this.m_site_img);
		
		this.m_support_img = new GL2.Sprite();
		this.m_support_img.setImage("Content/support.png", [380 * GameConstants.HEIGHT_SCALE, 20 * GameConstants.WIDTH_SCALE]);
		this.m_support_img.setPosition(280 * GameConstants.HEIGHT_SCALE, 211 * GameConstants.WIDTH_SCALE);
		this.m_about_node.addChild(this.m_support_img);
	},
	
	onMusicCheckboxClicked: function() {
		BFAudio.toggleMusic();
		BFAudio.playSound("CLICK");
	},
	
	onSoundCheckboxClicked: function() {
		BFAudio.toggleSound();
		BFAudio.playSound("CLICK");
	},
	
	addListener: function(obj, func) {
		this.m_emitter.addListener(obj, func);
	},
	
	checkToShowScores: function(){
		if (SaveData.getValue("LEVELSBEATEN", "0") >= GameConstants.TOTAL_LEVELS && !GameConstants.ENABLE_FPS) {
			this.m_main_node.addChild(this.m_score_text);
			this.m_main_node.addChild(this.m_scores_target);
		}
	},
	
	onSelectTouch: function(touch_event){
		switch (touch_event.getAction()) {
			case (GL2.Touch.Action.Start):{
				if (this.m_current_touch_id == null) {
					this.m_current_touch_id = touch_event.getId();
					this.m_select_text.setColor(0.5, 0.5, 0.5);
					return true;
				}
				break;
			}
			case (GL2.Touch.Action.End):{
				if (touch_event.getIsInside(this.m_select_target)) {
					this.goToLevelSelect();
				}
				this.m_select_text.setColor(0, 0, 1);
				this.m_current_touch_id = null;
				break;
			}
		}
	},
	
	onBackTouch: function(touch_event) {
		switch (touch_event.getAction()) {
			case (GL2.Touch.Action.Start):{
				if (this.m_current_touch_id == null) {
					this.m_back_text.setColor(0.5, 0.5, 0.5);
					this.m_current_touch_id = touch_event.getId();
					return true;
				}
				break;
			}
			case (GL2.Touch.Action.End):{
				if (this.m_current_touch_id == touch_event.getId()) {
					this.m_current_touch_id = null;
					this.m_back_text.setColor(0, 0, 1);
					if (touch_event.getIsInside(this.m_back_target)) {
						if (this.m_options_node.getParent() != null) {
							this.fromOptionsToMenu();
						}
						else {
							this.fromAboutToMenu();
						}
					}
				}
			}
		}
	},
		
	onOptionsTouch: function(touch_event){
		switch (touch_event.getAction()) {
			case (GL2.Touch.Action.Start):{
				if (this.m_current_touch_id == null) {
					this.m_current_touch_id = touch_event.getId();
					this.m_options_text.setColor(0.5, 0.5, 0.5);
					return true;
				}
				break;
			}
			case (GL2.Touch.Action.End):{
				if (touch_event.getIsInside(this.m_options_target)) {
					this.goToOptions();
				}
				this.m_options_text.setColor(0, 0, 1);
				this.m_current_touch_id = null;
				break;
			}
		}
	},
		
	onAboutTouch: function(touch_event){
		switch (touch_event.getAction()) {
			case (GL2.Touch.Action.Start):{
				if (this.m_current_touch_id == null) {
					this.m_current_touch_id = touch_event.getId();
					this.m_about_text.setColor(0.5, 0.5, 0.5);
					return true;
				}
				break;
			}
			case (GL2.Touch.Action.End):{
				if (touch_event.getIsInside(this.m_about_target)) {
					this.goToAbout();
				}
				this.m_about_text.setColor(0, 0, 1);
				this.m_current_touch_id = null;
				break;
			}
		}
	},
		
	onScoresTouch: function(touch_event){
		switch (touch_event.getAction()) {
			case (GL2.Touch.Action.Start):{
				if (this.m_current_touch_id == null) {
					this.m_current_touch_id = touch_event.getId();
					this.m_score_text.setColor(0.5, 0.5, 0.5);
					return true;
				}
				break;
			}
			case (GL2.Touch.Action.End):{
				if (touch_event.getIsInside(this.m_scores_target)) {
					this.goToScores();
				}
				this.m_score_text.setColor(0, 0, 1);
				this.m_current_touch_id = null;
				break;
			}
		}
		
		
	},	
	
	onLeakTouch: function(touch_event) {
		switch (touch_event.getAction()) {
			case (GL2.Touch.Action.Start):{
				if (this.m_current_touch_id == null) {
					this.m_current_touch_id = touch_event.getId();
					this.m_leak_text.setColor(0.5, 0.5, 0.5);
					return true;
				}
				break;
			}
			case (GL2.Touch.Action.End):{
				this.runLeakCheck();
				this.m_leak_text.setColor(0, 0, 1);
				this.m_current_touch_id = null;
				break;
			}
		}
	},
	
	goToLevelSelect: function(){
		this.m_emitter.emit("LEVELSELECT");
	},
	
	goToOptions: function(){
		this.m_node.removeChild(this.m_main_node);
		this.m_node.addChild(this.m_options_node);
		UI.Window.document.addChild(this.m_music_checkbox);
		UI.Window.document.addChild(this.m_sound_checkbox);
		this.m_options_node.addChild(this.m_back_target);
		this.m_options_node.addChild(this.m_back_text);
	},
	
	fromOptionsToMenu: function() {
		this.m_node.addChild(this.m_main_node);
		this.m_node.removeChild(this.m_options_node);
		UI.Window.document.removeChild(this.m_music_checkbox);
		UI.Window.document.removeChild(this.m_sound_checkbox);
	},
	
	fromAboutToMenu: function() {
		this.m_node.addChild(this.m_main_node);
		this.m_node.removeChild(this.m_about_node);	
	},
	
	goToAbout: function(){
		this.m_node.removeChild(this.m_main_node);
		this.m_node.addChild(this.m_about_node);
		this.m_about_node.addChild(this.m_back_target);
		this.m_about_node.addChild(this.m_back_text);
	},
	
	goToScores: function(){
		this.m_emitter.emit("KILLSCREEN");
	},
	
	runLeakCheck: function(){
		console.log("POR QUE MARIA");
		this.m_emitter.emit("LEAKCHECK");
	},
	
	backKeyHandler: function(){
		if (this.m_about_node.getParent() != null) {
			this.fromAboutToMenu();
			return true;
		}
		else if (this.m_options_node.getParent() != null) {
			this.fromOptionsToMenu();
			return true;
		}
		return false;
	},

});

function musicCheckboxClicked(){
	self.onMusicCheckboxClicked();
}

function soundCheckboxClicked(){
	self.onSoundCheckboxClicked();
}

exports.Menu = Menu;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/util/FPS'] = function(){var exports = $MODULE_REGISTRY['Code/util/FPS'] || {}; $MODULE_REGISTRY['Code/util/FPS'] = exports; var Core = require('NGCore/Client/Core').Core;
var UI = require('NGCore/Client/UI').UI;

var FPS = exports.FPS = Core.MessageListener.singleton({
	initialize: function() {
		this._fcount = 0;
		this._fduration = 0;
		this._fdurationMax = 0;
		this._fdurationMin = Number.MAX_VALUE;
		
		this._finterval = 30 * 5;
		
		// Subscribe to per frame updates.
		Core.UpdateEmitter.addListener(this, this.onUpdate);
		
		// After a timeout, place a button. The timeout is to allow interface orienation to stabalize.
		this.button = new UI.Button({
			normalGradient: { gradient: ['FFF0 0.0', 'FFA0 1.0'], 'corners': '5', 'outerLine': 'FF00 5.0' },
			highlightedGradient: { gradient: ['FF80 0.0', 'FFC0 1.0'], 'corners': '5', 'outerLine': 'FF00 5.0' }
		});
		setTimeout(function() {
		
			var w = 240;
			var h = 80;
			this.button.setFrame([UI.Window.getWidth()/2 - w/2, UI.Window.getHeight() - h * 2, w, h]);
			UI.Window.document.addChild(this.button);
			this.updateButton();
		}.bind(this), 1000);
	},
	
	updateButton: function() {
		if(this.leakCheck) {
			this.button.onclick = this.stop.bind(this)
			this.button.setTextColor('FFFF0000');
			this.button.setText('stop leakcheck');
		} else {
			this.button.onclick = this.start.bind(this)
			this.button.setTextColor('FFFF');
			this.button.setText('start leakcheck');
		}
	},
	
	start: function() {
		console.log('/// Starting leakcheck');
		this.leakCheck = true;
		this.startTime = new Date().getTime();
		this.updateButton();
		this.stacks = [];
	},
	
	stop: function() {
		this.leakCheck = false;
		this.updateButton();
		
		function formatTime(t) {
			return '' + Math.round((t - FPS.startTime) / 100) / 10 + 's';
		}
		
		// output and reset.
		console.log('/// Leaked', this.stacks.length, 'objects in', formatTime(new Date().getTime()));
		for(var i=0; i < this.stacks.length; ++i) {
			try {
				var s = this.stacks[i];
				console.log('/// Leaked', s.type, 'at', formatTime(s.time));
				if(!s.exception || !s.exception.stack)
					console.log('///   - Stacktrace unavailable');
				
				var stack = s.exception.stack.split('\n    ').slice(2);
				for(var j=0; j < stack.length; ++j)
					console.log('///   -', stack[j]);
			} catch(e) {
				console.log('///   - Out of memory, stack trace lost');
			}
		}
	},
	
	trackObj: function(obj, type, exception) {
		// Check if this has already been registered.
		var s = this.stacks;
		for(var i=0; i < s.length; ++i) {
			if(s.obj === obj) return;
		}
		
		this.stacks.push({obj: obj, type: type, exception: exception, time: new Date().getTime()});
	},
	
	untrackObj: function(obj) {
		var s = this.stacks;
		for(var i=0; i < s.length; ++i) {
			if(s[i].obj !== obj) continue;
			s.splice(i, 1);
			return;
		}
	},
	
	onUpdate: function(frameDelta) {
		// add frame data
		this._fduration += frameDelta;
		this._fcount++;
		this._fdurationMax = Math.max(this._fdurationMax,frameDelta);
		this._fdurationMin = Math.min(this._fdurationMin,frameDelta);
		
		// If over our threshold, report and reset.
		if (this._fcount > this._finterval) {
			// Calculate average of frame samples.
			var average = this._fduration / this._fcount;
			
			// Output average.
			console.log('///FPS avg: %d, max: %d, min: %d; Instances nodes: %d, sprite: %d, anims: %d, texts: %d', Math.round(1000 / average), Math.round(1000 / this._fdurationMin), Math.round(1000 / this._fdurationMax),
					GL2.Node.getLiveInstances(), GL2.Sprite.getLiveInstances(), GL2.Animation.getLiveInstances(), GL2.Text.getLiveInstances());
			
			// Reset sample data
			this._fcount = 0;
			this._fduration = 0;
			this._fdurationMax = 0;
			this._fdurationMin = Number.MAX_VALUE;
		}
	}
});

//Node
var nodesLiveInstances = 0;
GL2.Node.getLiveInstances = function () {
	return nodesLiveInstances;
};

var __GL2Nodeinitialize = GL2.Node.prototype.initialize;
GL2.Node.prototype.initialize = function () {
	if(FPS.leakCheck) { try { throw new Error(); } catch(e) { FPS.trackObj(this, 'Node', e) } }
	nodesLiveInstances++;
	__GL2Nodeinitialize.apply(this,arguments);
};

var __GL2Nodedestroy = GL2.Node.prototype.destroy;
GL2.Node.prototype.destroy = function () {
	if(FPS.leakCheck) { FPS.untrackObj(this) }
	nodesLiveInstances--;
	__GL2Nodedestroy.apply(this,arguments);
};

//Sprites
spritesLiveInstances = 0;
GL2.Sprite.getLiveInstances = function () {
	return spritesLiveInstances;
};

var __GL2Spriteinitialize = GL2.Sprite.prototype.initialize;
GL2.Sprite.prototype.initialize = function () {
	if(FPS.leakCheck) { try { throw new Error(); } catch(e) { FPS.trackObj(this, 'Sprite', e) } }
	spritesLiveInstances++;
	__GL2Spriteinitialize.apply(this,arguments);
};

var __GL2Spritedestroy = GL2.Sprite.prototype.destroy;
GL2.Sprite.prototype.destroy = function () {
	if(FPS.leakCheck) { FPS.untrackObj(this) }
	spritesLiveInstances--;
	__GL2Spritedestroy.apply(this,arguments);
};


//Texts
textsLiveInstances = 0;
GL2.Text.getLiveInstances = function () {
	return textsLiveInstances;
};

var __GL2Textinitialize = GL2.Text.prototype.initialize;
GL2.Text.prototype.initialize = function () {
	if(FPS.leakCheck) { try { throw new Error(); } catch(e) { FPS.trackObj(this, 'Text', e) } }
	textsLiveInstances++;
	__GL2Textinitialize.apply(this,arguments);
};

var __GL2Textdestroy = GL2.Text.prototype.destroy;
GL2.Text.prototype.destroy = function () {
	if(FPS.leakCheck) { FPS.untrackObj(this) }
	textsLiveInstances--;
	__GL2Textdestroy.apply(this,arguments);
};

//Animations
animsliveInstances = 0;
GL2.Animation.getLiveInstances = function () {
	return animsliveInstances;
};

var __GL2Animationinitialize = GL2.Animation.prototype.initialize;
GL2.Animation.prototype.initialize = function () {
	if(FPS.leakCheck) { try { throw new Error(); } catch(e) { FPS.trackObj(this, 'Animation', e) } }
	animsliveInstances++;
	__GL2Animationinitialize.apply(this,arguments);
};

var __GL2Animationdestroy = GL2.Animation.prototype.destroy;
GL2.Animation.prototype.destroy = function () {
	if(FPS.leakCheck) { FPS.untrackObj(this) }
	animsliveInstances--;
	__GL2Animationdestroy.apply(this,arguments);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/util/TouchTargetVisualizer'] = function(){var exports = $MODULE_REGISTRY['Code/util/TouchTargetVisualizer'] || {}; $MODULE_REGISTRY['Code/util/TouchTargetVisualizer'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;

var TouchTargetVisualizer = exports.TouchTargetVisualizer = Core.Class.singleton({
	initialize: function() {
		(function() {
			var oldInitialize = GL2.TouchTarget.prototype.initialize;
			GL2.TouchTarget.prototype.initialize = function() {
				oldInitialize.apply(this, arguments);
				this._anchor = new Core.Point(0, 0);
			}
		})();
		
		GL2.TouchTarget.prototype._showVisualization = function() {
			if(this._visualization) return;
			this._visualization = new GL2.Primitive();
			this._visualization.setType(GL2.Primitive.Type.TriangleStrip);
			this._visualization.pushVertex(new GL2.Primitive.Vertex([0, 0]));
			this._visualization.pushVertex(new GL2.Primitive.Vertex([1, 0]));
			this._visualization.pushVertex(new GL2.Primitive.Vertex([0, 1]));
			this._visualization.pushVertex(new GL2.Primitive.Vertex([1, 1]));
			this._visualization.setAlpha(0.5);
			this._visualization.setDepth(Infinity);
			this._visualization.setColor(Math.random(), Math.random(), Math.random());
			this.addChild(this._visualization);
			this._correctVisualization();
		}
		
		GL2.TouchTarget.prototype._hideVisualization = function() {
			if(!this._visualization) return;
			this._visualization.destroy();
			delete this._visualization;
		}
		
		GL2.TouchTarget.prototype._correctVisualization = function() {
			var s = this.getSize();
			var a = this.getAnchor();
			
			this._visualization.setScale(s.getWidth(), s.getHeight());
			this._visualization.setPosition(-a.getX() * s.getWidth(), -a.getY() * s.getHeight());
		}
		
		this.show();
	},
	
	show: function() {
		if(this.showing) return;
		this.showing = true;
		
		TouchTargetVisualizer.oldInitialize = GL2.TouchTarget.prototype.initialize;
		GL2.TouchTarget.prototype.initialize = function() {
			TouchTargetVisualizer.oldInitialize.apply(this, arguments);
			this._showVisualization();
		}
		
		TouchTargetVisualizer.oldDestroy = GL2.TouchTarget.prototype.destroy;
		GL2.TouchTarget.prototype.destroy = function() {
			TouchTargetVisualizer.oldDestroy.apply(this, arguments);
			this._hideVisualization();
		}
		
		TouchTargetVisualizer.oldSetAnchor = GL2.TouchTarget.prototype.setAnchor;
		GL2.TouchTarget.prototype.setAnchor = function() {
			TouchTargetVisualizer.oldSetAnchor.apply(this, arguments);
			this._correctVisualization();
		}
		
		TouchTargetVisualizer.oldSetSize = GL2.TouchTarget.prototype.setSize;
		GL2.TouchTarget.prototype.setSize = function() {
			TouchTargetVisualizer.oldSetSize.apply(this, arguments);
			this._correctVisualization();
		}
		
		var objs = Core.ObjectRegistry._objects;
		for(var i in objs) {
			if(!objs.hasOwnProperty(i)) continue;
			if(!(objs[i] instanceof GL2.TouchTarget)) continue;
			objs[i]._showVisualization();
		}
	},
	
	hide: function() {
		if(!this.showing) return;
		this.showing = false;
		
		GL2.TouchTarget.prototype.initialize = TouchTargetVisualizer.oldInitialize;
		GL2.TouchTarget.prototype.destroy = TouchTargetVisualizer.oldDestroy;
		GL2.TouchTarget.prototype.setAnchor = TouchTargetVisualizer.oldSetAnchor;
		GL2.TouchTarget.prototype.setSize = TouchTargetVisualizer.oldSetSize;
		
		var objs = Core.ObjectRegistry._objects;
		for(var i in objs) {
			if(!objs.hasOwnProperty(i)) continue;
			if(!(objs[i] instanceof GL2.TouchTarget)) continue;
			objs[i]._hideVisualization();
		}
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Animation'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Animation'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Animation'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Animation = Core.Class.subclass(
/** @lends GL2.Animation.prototype */
{
	classname: 'Animation',
    
	/**
	 * @class The <code>Animation</code> class constructs objects that define application animations. Animations aggregate and control 
	 * the instantiation of <code>Frame</code> objects for manipulation of <code>{@link GL2.Sprite}</code> and
	 * <code>{@link GL2.Primitive}</code> objects. Each <code>Frame</code> object defines a duration and an image display area. 
	 * <code>Frame</code> objects also include a pre-transform 
	 * offset that define the rotation and scale of sprite images. 
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
    initialize: function()
    {
		Core.ObjectRegistry.register(this);
		
        this._wrapMode = this.WrapMode.WrapNone;
        this._blendEnabled = true;
        this._blendMode = this.BlendMode.Alpha;
        this._filteringEnabled = true;
		this._loopingEnabled = true;
		this._totalDuration = 0;
		this._frames = [];
		
		this._createSendGen(this.__objectRegistryId);
    },

	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Retrieve the specified texture wrap mode for this <code>Animation</code>.
	 * @returns {GL2.Animation#WrapMode} The current texture wrap mode.
	 * @see GL2.Animation#setWrapMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getWrapMode: function()
	{
		return this._wrapMode;
	},
	
	/**
	 * Retrieve the alpha blending state for this <code>Animation</code>.
	 * @returns {Boolean} Returns <code>true</code> if alpha blending is enabled. Returns <code>false</code> in all other cases.
	 * @see GL2.Animation#setBlendEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBlendEnabled: function()
	{
		return this._blendEnabled;
	},
	
	/**
	 * Retrieve the filtering state for this <code>Animation</code>. 
	 * @returns {Boolean} Returns <code>true</code> if filtering is enabled. Returns <code>false</code> in all other cases.
	 * @see GL2.Animation#setFilteringEnabled
	 */
	getFilteringEnabled: function()
	{
		return this._filteringEnabled;
	},
	
	/**
	 * Retrieve the looping state of this <code>Animation</code>.
	 * @returns {Boolean} Returns <code>true</code> if looping is enabled. Returns <code>false</code> in all other cases.
	 * @see GL2.Animation#setLoopingEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLoopingEnabled: function()
	{
		return this._loopingEnabled;
	},
	
	/**
	 * Retrieve the total duration of this <code>Animation</code> in milliseconds.
	 * @returns {Number} The current duration. 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTotalDuration: function()
	{
		return this._totalDuration;
	},
	
	/**
	 * Retrieve the total number of frames in this <code>Animation</code>.
	 * @returns {Number} The current number of frames. 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrameCount: function()
	{
		return this._frames.length;
	},
	
	/**
	 * Retrieve a frame at the specified index for this <code>Animation</code>.
	 * @param {Number} index The specified index.
	 * @returns {GL2.Animation.Frame} The current frame at the specified index.
	 * @see GL2.Animation#setFrame
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrame: function(index)
	{
		return this._frames[index];
	},
    
    /**
	 * Apply a wrap mode to frame textures for this <code>Animation</code>.
	 * @param {GL2.Animation#WrapMode} [wrapMode=0] The new texture wrap mode.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getWrapMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */						
    setWrapMode: function(wrapMode)
	{
		this._wrapMode = wrapMode;
		
		this._setWrapModeSendGen(wrapMode);
		
		return this;
	},
    
    /**
	 * Set the alpha blending state for this <code>Animation</code>. 
	 * <br><br>
	 * <b>Note:</b> You can improve performance for animations with completely opaque frames by disabling alpha blending.
	 * @param {Boolean} [blendEnabled=true] Set as <code>true</code> to enable alpha blending.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getBlendEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setBlendEnabled: function(blendEnabled)
	{
		this._blendEnabled = blendEnabled;
		
		this._setBlendEnabledSendGen(blendEnabled);
		
		return this;
	},
	
	/**
	 * Set the alpha blend mode.
	 * @see GL2.Animation#setBlendEnabled
	 * @status Android,AndroidTested
	 */
	setBlendMode: function(blendMode)
	{
		this._blendMode = blendMode;
		
		this._setBlendModeSendGen(blendMode);
		
		return this;
	},
	
	getBlendMode: function()
	{
		return this._blendMode;
	},
	
    /**
	 * Set the filtering state for this <code>Animation</code>.
	 * <br><br>
	 * @param {Boolean} [filteringEnabled=false] Set as <code>true</code> to enable filtering. 
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getFilteringEnabled
	 */
    setFilteringEnabled: function(filteringEnabled)
	{
		this._filteringEnabled = filteringEnabled;
		
		this._setFilteringEnabledSendGen(filteringEnabled);
		
		return this;
	},
    
    /**
	 * Set the looping state for this <code>Animation</code>.
	 * @param {Boolean} [loopingEnabled=false] Set as <code>true</code> to enable animation looping.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getLoopingEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setLoopingEnabled: function(loopingEnabled)
	{
		this._loopingEnabled = loopingEnabled;
		
		this._setLoopingEnabledSendGen(loopingEnabled);
		
		return this;
	},
    
    /**
	 * Add a frame to the end of this <code>Animation</code>.<br><br>
	 * <pre class="code"><font size="2">var animation = new GL2.Animation();
	 * animation.pushFrame(new GL2.Animation.Frame('Content/tank.png', 50, [64, 64], [0.5, 0.5], [0/5, 0, 1/5, 1]));</font></pre>
	 * Calling <code>pushFrame()</code> is equivalent to calling <code>spliceFrames()</code> in the following way: 
	 * <pre class="code"><font size="2">animation.spliceFrames(animation.getFrameCount(), 0, frame);</font></pre>
	 * @param {GL2.Animation.Frame} frame The frame to add.
	 * @see GL2.Animation#spliceFrames
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    pushFrame: function(frame)
	{
		return this.spliceFrames(this._frames.length, 0, frame);
	},
    
    /**
	 * Replace the frame at index <i>i</i>.<br><br>
	 * Calling <code>setFrame()</code> is equivalent to calling <code>spliceFrames()</code> in the following way: 
	 * @example animation.spliceFrames(i, 1, frame)
	 * @param {Number} i Index of the frame to replace.
	 * @param {GL2.Animation.Frame} frame The frame to insert.
	 * @see GL2.Animation#getFrame,
	 * @see GL2.Animation#spliceFrames
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setFrame: function(i, frame)
	{
		return this.spliceFrames(i, 1, frame);
	},
    
    /**
	 * Remove a specific number of frames from this <code>Animation</code> and replace them with specified frames.
	 * <br><br>
	 * <b>Note:</b> This method accepts multiple parameters. The third parameter and beyond define all
	 * <code>Frames</code> to use for replacement.<br><br>
	 * The following example passes in three frames to a <code>spliceFrames()</code> call.
	 * @example animation.spliceFrames(0, 0, frame1, frame2, frame3).
	 * @param {Number} start The index of the first frame to remove.
	 * @param {Number} len The total number of frames to remove.
	 * @param {GL2.Animation.Frame} frames The frames to insert. 
	 * <br><br>
	 * <b>Note:</b> This parameter accepts multiple values.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    spliceFrames: function(start, len, frames)
	{
		var i;
		var frameCount = arguments.length-2;
		var frame;

		// Determine if we should use the v2 version of the messsage, which supports renderTargets.
		// This is so that new javaScript that doesn't use renderTargets will still work with an old binary.
		var useV2 = false;
		for (i = 0; i < frameCount; ++i) {
			frame = arguments[i+2];
			if (frame.getImage().classname === 'RenderTarget')
				useV2 = true;
		}

		// Decrement from total duration.
		for (var i=start; i < start + len; ++i) {
			this._totalDuration -= this._frames[i].getDuration();
		}
		
		this._frames.splice.apply(this._frames, arguments);

		if (useV2) {
			this._spliceFrames2SendGen(start, len, frameCount);
		} else {
			this._spliceFramesSendGen(start, len, frameCount);
		}
		
		for (i = 0; i < frameCount; ++i)
		{
			frame = arguments[i+2];
			var duration = frame.getDuration();
			var size = frame.getSize();
			var anchor = frame.getAnchor();
			var uvs = frame.getUVs();
			var uvOrigin = uvs.getOrigin();
			var uvSize = uvs.getSize();
			var image = frame.getImage();

			// if image is a renderTarget
			var renderTargetID = 0;
			if (image.classname === 'RenderTarget') {
				renderTargetID = image.__objectRegistryId;
				image = '';
			}

			if (useV2) {
				this._frame2SendGen(image,
									renderTargetID,
									duration,
									size.getWidth(),
									size.getHeight(),
									anchor.getX(),
									anchor.getY(),
									uvOrigin.getX(),
									uvOrigin.getY(),
									uvSize.getWidth(),
									uvSize.getHeight());
			} else {
				this._frameSendGen(image,
								   duration,
								   size.getWidth(),
								   size.getHeight(),
								   anchor.getX(),
								   anchor.getY(),
								   uvOrigin.getX(),
								   uvOrigin.getY(),
								   uvSize.getWidth(),
								   uvSize.getHeight());
			}
			this._totalDuration += duration;
		}
		
		return this;
	},
	
	$Frame: Core.Class.subclass(
	/** @lends GL2.Animation.Frame.prototype */
	{
		classname: 'Frame',
		
		/**
		 * @class <code>Frame</code> objects define a path to an image and any properties that support the image as
		 * a single frame in an animation.
		 * @constructs The default constructor. 
		 * @param {String|GL2.RenderTarget} image The directory path to an image, or an instance of GL2.RenderTarget.
		 * @param {Number} duration The time duration of the frame in milliseconds.
		 * @param {Core.Size} size The size of the frame in pixels.
		 * @param {Core.Point} anchor The offset within the frame used for scaling and rotation.
		 * @param {Core.Rect} uvs The image region to use for the frame. The default value is <code>[0,0,1,1]</code> (the entire image) 
		 * with a start coordinate of <code>(0,0)</code> and a size of <code>(1,1)</code>.<br><br> 
		 * <b>Example:</b> To select the lower left region of an image with nine distinct frames (three horizontally, three vertically), 
		 * you would specify <code>[0, 0.66, 0.33, 0.33]</code>. The start coordinate is <code>(0, 0.66)</code>, 
		 * which is the left edge of the image and 2/3rds down. 
		 * The size is <code>(0.33, 0.33)</code> which is a third of the image in each <i>x</i> and <i>y</i> direction.
		 * @see GL2.Animation
		 * @default [0,0,1,1] (the entire image)
		 * @augments Core.Class
		 */
		initialize: function(image, duration, size, anchor, uvs)
		{
			this._image     = image;
			this._duration  = duration || 0;
			this._size   = new Core.Size(size);
			
			if(anchor)
				this._anchor = new Core.Point(anchor);
			else
				this._anchor = new Core.Point(0.5, 0.5);
			
			if(uvs)
				this._uvs = new Core.Rect(uvs);
			else
				this._uvs = new Core.Rect(0, 0, 1, 1);
		},

		/**
		 * Retrieve the image directory path or the renderTarget referenced by this <code>Frame</code>.
		 * @returns {String|GL2.RenderTarget} The current directory path to the image, or a GL2.RenderTarget instance.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getImage:    function()
		{
			return this._image;
		},
		
		/**
		 * Retrieve time duration in milliseconds for this <code>Frame</code>.
		 * @returns {Number} The current time duration for the frame.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getDuration:  function()
		{
			return this._duration;
		},

		/**
		 * Retrieve the pixel size of this <code>Frame</code>.
		 * @returns {Core.Size} The current frame size in pixels.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getSize:    function()
		{
			return this._size;
		},

		/**
		 * Retrieve the offset used for scaling and rotation from within this <code>Frame</code>.
		 * @returns {Core.Point} The current frame offset.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getAnchor:  function()
		{
			return this._anchor;
		},

		/**
		 * Retrieve the texture rectangle for this <code>Frame</code> in UV coordinates.
		 * @returns {Core.Rect} The current UV bounds of the frame within the texture.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getUVs:    function()
		{
			return this._uvs;
		},
	}),
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for UV wrapping modes.
	 * @namespace
	 */
	WrapMode:
	{ 
		/** Clamp in both U and V. */
		WrapNone: 0,
		/** Wrap in U, clamp in V. */
		WrapU: 1,
		/** Wrap in V, clamp in U. */
		WrapV: 2,
		/** Wrap in both U and V. */
		WrapUV: 3,
	},
	
	/** 
	 * Enumeration for Blend modes.
	 * @namespace
	 */
	BlendMode:
	{ 
		/** blend func: (src alpha, 1 - src alpha). */
		Alpha: 1,
		/** blend func: (src alpha, 1). */
		Add: 2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 306
	// Method create = -1
	// Method destroy = 2
	// Method setWrapMode = 3
	// Method setBlendEnabled = 4
	// Method setLoopingEnabled = 5
	// Method spliceFrames = 6
	// Method frame = 7
	// Method setFilteringEnabled = 8
	// Method spliceFrames2 = 9
	// Method frame2 = 10
	// Method setBlendMode = 11
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Animation._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Animation._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[306] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":306,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":306,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setWrapModeSendGen: function( wrapMode )
	{
		Core.Proc.appendToCommandString( ":306,3," + this.__objectRegistryId + "," + wrapMode  );
	},
	
	/** @private */
	_setBlendEnabledSendGen: function( blendEnabled )
	{
		Core.Proc.appendToCommandString( ":306,4," + this.__objectRegistryId + "," + ( blendEnabled ? 1 : 0 )  );
	},
	
	/** @private */
	_setLoopingEnabledSendGen: function( loopingEnabled )
	{
		Core.Proc.appendToCommandString( ":306,5," + this.__objectRegistryId + "," + ( loopingEnabled ? 1 : 0 )  );
	},
	
	/** @private */
	_spliceFramesSendGen: function( start, len, frameCount )
	{
		Core.Proc.appendToCommandString( ":306,6," + this.__objectRegistryId + "," + start + "," + len + "," + frameCount  );
	},
	
	/** @private */
	_frameSendGen: function( image, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV )
	{
		Core.Proc.appendToCommandString( "," + Core.Base64.encode( image ) + "," + duration + "," + width + "," + height + "," + anchorX + "," + anchorY + "," + startU + "," + startV + "," + sizeU + "," + sizeV  );
	},
	
	/** @private */
	_setFilteringEnabledSendGen: function( filteringEnabled )
	{
		Core.Proc.appendToCommandString( ":306,8," + this.__objectRegistryId + "," + ( filteringEnabled ? 1 : 0 )  );
	},
	
	/** @private */
	_spliceFrames2SendGen: function( start, len, frameCount )
	{
		Core.Proc.appendToCommandString( ":306,9," + this.__objectRegistryId + "," + start + "," + len + "," + frameCount  );
	},
	
	/** @private */
	_frame2SendGen: function( image, renderTargetID, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV )
	{
		Core.Proc.appendToCommandString( "," + Core.Base64.encode( image ) + "," + renderTargetID + "," + duration + "," + width + "," + height + "," + anchorX + "," + anchorY + "," + startU + "," + startV + "," + sizeU + "," + sizeV  );
	},
	
	/** @private */
	_setBlendModeSendGen: function( blendMode )
	{
		Core.Proc.appendToCommandString( ":306,11," + this.__objectRegistryId + "," + blendMode  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setWrapMode: function( wrapMode ) {}
	
	// setBlendEnabled: function( blendEnabled ) {}
	
	// setLoopingEnabled: function( loopingEnabled ) {}
	
	// spliceFrames: function( start, len, frameCount ) {}
	
	// frame: function( image, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV ) {}
	
	// setFilteringEnabled: function( filteringEnabled ) {}
	
	// spliceFrames2: function( start, len, frameCount ) {}
	
	// frame2: function( image, renderTargetID, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV ) {}
	
	// setBlendMode: function( blendMode ) {}
	

// {{/Wg Generated Code}}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Node'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Node'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Node'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Node = Core.Class.subclass(
/** @lends GL2.Node.prototype */
{
	classname: 'Node',
	
	/**
	 * @class The <code>Node</code> class constructs base class objects that contain positionable elements in the GL2 module. 
	 * Applications can use <code>Node</code> objects for grouping and organizing the scene graph. 
	 * <p>
	 * Inside the <code>{@link UI.GLView}</code> class, positionable elements are organized into a node hierarchy. This data
	 * structure is analgous to a scene graph or a node tree. Child nodes inherit data for
	 * transform, visibility, and depth from the parent on a conditional basis. Most drawable attributes for nodes, such as size and color, are specified in 
	 * derived classes. 
	 *</p><p>
	 * All derived GL2 classes from <code>Node</code> are native-backed proxies including <code>Node</code>.
	 * When a <code>Node</code> is instantiated on the Javascript side, a C++ object
	 * is instantiated and managed for the user on the native backend. This condition means the application
	 * must explicity destroy any <code>Node</code> that is no longer used.
	 *</p><p>
	 * A <code>Node</code> can exist independent of the scene, but it will only receive draw or touch updates
	 * when it is attached to the root tree.
	 *</p>
	 *<div class="ul">
	 * <li>Add a node as a child to the root of the scene with <code>{@link GL2.Root#addChild}</code>.</li> 
	 * <li>Add a node as a child to another node with <code>{@link GL2.Node#addChild}</code>.</li>
	 * <li>Remove a node from the root of the scene with <code>{@link GL2.Root#removeChild}.</code></li>
	 * <li>Remove a child node from a parent node with <code>{@link GL2.Node#removeChild}</code>.</li> 
	 *</div><br>
	 * <p>
	 * Call <code><a href="GL2.Node.html#destroy">destroy()</a></code> to automatically remove a node from the parent node.
	 * As previously noted, nodes are supported by a native object on the backend. Maintaining a 
	 * node reference outside of the scene instead of calling <code>destroy()</code> and recreating a new node is a recommended best practice.
	 *</p><p>
	 * Absolute positioning of a single node is determined by the following properties in the defined order:
	 *</p>
	 *<div class="ol">
	 * <li>Scale (two-component [x,y] multiple)</li>
	 * <li>Rotation (degrees about z-axis)</li>
	 * <li>Position (two-component translation)</li>
	 *</div><br>
	 * <p>
	 * Each of these properties is applied to the node relative to the parent node. The final transform
	 * for any given node is the concatenation of each transform in the node graph ancestry. The
	 * root ancestor is fixed to the view and composes the scene so that <code>(0,0)</code> is in the upper
	 * left corner. The first anchored
	 * offset to rotate and scale around is not specified because nodes do not inherently contain a size <code>(see {@link GL2.Animation.Frame#getAnchor}</code>). 
	 *</p><p>
	 * The <code>Depth</code> property of a <code>Node</code> object determines that <code>Node</code> sort order when traversing the scene graph.
	 * Depth is roughly equivalent to z-order or index. Each node is sorted among siblings by
	 * <code>Depth</code>, starting with the lowest depth node and sorting in ascending order.
	 *</p><p>
	 * By default, <code>Nodes</code> are grouped 
	 * with their siblings (not interleaved with cousins) and sorted relative to their parent 
	 * as if the parent depth value was <code>0</code>. However, you can modify this behavior for specific use cases 
	 * with <code><a href="GL2.Node.html#setChildrenDepthGrouped">setChildrenDepthGrouped()</a></code>. 
	 *</p><p>
	 * The node depth (order) in the scene graph will dictate the drawing order and determines what the final frame will look like.
	 * When drawing, <code>GL2.Node</code> utilizes the painter's algorithm.
	 * This means lower depth nodes are obscured by higher depth nodes.
	 * Touch priority occurs in reverse order to drawing order. Touches travel through the scene from higher depth to lower depth nodes 
	 * (front of scene earlier to back of scene later).
	 *</p><p>
	 * As a base class, a <code>Node</code> is not drawable but does maintain <code>Color</code> and <code>Alpha</code>
	 * attributes (see <code><a href="GL2.Node.html#getColor">getColor()</a></code> and <code><a href="GL2.Node.html#getAlpha">getAlpha()</a></code>). 
	 * Child nodes that contain drawable derived classes from 
	 * <code>Node</code> inherit these attributes.
	 * As a result, setting the <code>Color</code> for a parent node affects the color of every child node through multiplication
	 * of color components.</p>
	 * <p>Classes derived from Node include:</p>
	 * <div class="ul">
	 * <li>{@link GL2.Primitive}</li>
	 * <li>{@link GL2.Sprite}</li>
	 * <li>{@link GL2.Text}</li>
	 * </div>
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
    initialize: function()
    {
		Core.ObjectRegistry.register(this);
        this._parent = null;
        this._position = new Core.Point();
        this._scale = new Core.Vector(1, 1);
        this._color = new Core.Color(1, 1, 1);
        this._alpha = 1;
        this._rotation = 0;
        this._depth = 0;
        this._visible = true;
        this._touchable = true;
		
        this._childrenDepthGrouped = true;
        this._children = [];
		
		this._createSendGen(this.__objectRegistryId);
    },

	/**
	 * The default destructor. Calling <code>destroy()</code> removes the node from the parent, which releases the
	 * native object on the backend. 
	 * <br><br>
	 * <b>Note:</b> Applications must call this explicitly for nodes that are no longer
	 * used.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		children = this._children;
		while(children.length)
		{
			this.removeChild(children[0]);
		}
			
		if(this._parent)
		{
			this._parent.removeChild(this);
		}
		
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},

	/**
	 * Retrieve the position of this <code>Node</code>.
	 * @returns {Core.Vector} The current node position relative to the parent.
	 * @see GL2.Node#setPosition
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPosition: function()
	{
		return this._position;
	},
	
	/**
	 * Retrieve the <i>width</i> and <i>height</i> scale multiple of this <code>Node</code>. 
	 * The default scale <code>[1,1]</code> will not modify the resulting transform.
	 * @returns {Core.Vector} The current scale multiple (<i>width</i> and <i>height</i>).
	 * @see GL2.Node#setScale
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getScale: function()
	{
		return this._scale;
	},

	/**
	 * Retrieve the <code>Color</code> component of this <code>Node</code>. Values for <code>Color</code> are based on the RGB color model. 
	 * When drawing, the values for <code>Color</code> are multiplied by the value of each drawable pixel. Child nodes will multiply
	 * the values for <code>Color</code> by the parent composite color before drawing. 
	 * @returns {Core.Color} The current value of all three color components (red, green, blue).
	 *<br><br>
	 * <b>Note:</b> The default RGB triplet <code>[1,1,1]</code> does not produce a color change.
	 * @see Core.Color, 
	 * @see GL2.Node#setColor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getColor: function()
	{
		return this._color;
	},

	/**
	 * Retrieve the <cod>alpha</code> components of this <code>Node</code>.
	 * @returns {Number} The new alpha blending state across the open interval ranging between <code>(0-1)</code>. 
	 * (0 = completely transparent, 1 = completely opaque). Expressed as a float.
	 * @see GL2.Node#setAlpha
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAlpha: function()
	{
		return this._alpha;
	},

	/**
	 * Retrieve the <code>rotation</code> component for this <code>Node</code>.
	 * The default value is 0 degrees about the z-axis.
	 * @returns {Number} The current degree of rotation. Expressed as a float.
	 * @see GL2.Node#setRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getRotation: function()
	{
		return this._rotation;
	},

	/**
	 * Retrieve the <code>depth</code> component for this <code>Node</code>.
	 * The default value is <code>0</code>.
	 * Applications will sort nodes with identical depth values by the last 
	 * time the node was attached to the root node graph.
	 * @returns {Number} The current node depth level (z-order). Expressed as a float.
	 * @see GL2.Root and 
	 * @see GL2.Node#setDepth
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getDepth: function()
	{
		return this._depth;
	},

	/**
	 * Retrieve the <code>visible</code> component for this <code>Node</code>.
	 * This component defines visibility of the node.
	 * The default value is <code>true</code>.<br><br>
	 * <b>Note:</b> A node can inherit the value of this component from parent nodes in the scene graph.
	 * @returns {Boolean} Returns <code>true</code> if the node is visible. Returns <code>false</code> in all other cases.
	 * @see GL2.Node#setVisible
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVisible: function()
	{
		return this._visible;
	},

	/**
	 * Retrieve the <code>touchable</code> component for this <code>Node</code>.
	 * This component defines touch-support for a node.
	 * The default value is <code>true</code>.<br><br>
	 * <b>Note:</b> A node can inherit "not touchable" from parent nodes in the scene graph.
	 * @returns {Boolean} Returns <code>true</code> if a node is touchable. Returns <code>false</code> in all other cases.
	 * @see GL2.Node#setTouchable
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTouchable: function()
	{
		return this._touchable;
	},
	

	/**
	 * Retrieve <code>childrenDepthGrouped</code> component of this <code>Node</code>.
	 * The default value is <code>true</code>.
	 * When <code>childrenDepthGrouped</code> is <code>false</code>, child nodes sort amongst (interleave 
	 * with) the children of the nearest depthgrouped ancestor.
	 * @returns {Boolean} Returns as <code>true</code> if sorting with ancestor siblings. Returns as <code>false</code> if sorting only with siblings in the graph.
	 * @see GL2.Node#setChildrenDepthGrouped
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getChildrenDepthGrouped: function()
	{
		return this._childrenDepthGrouped;
	},
	
	/**
	 * Retrieve the parent node for this <code>Node</code>.
	 * @returns {GL2.Node} The current parent node.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getParent: function()
	{
		return this._parent;
	},

	/**
	 * Retrieve a copy of the child array for this <code>Node</code>.
	 * @returns {Array GL2.Node} The current list of child nodes.
	 * @status 
	 */
	getChildren: function()
	{
		return this._children.slice();
	},
	
    /**
	 * Set the <code>translation</code> component of the transform for this <code>Node</code>.
	 * You can define the parameter value as a vector or two floats.<br><br>
	 * <b>Note:</b> An application can use this property to translate a group of nodes by
	 * translating the parent. Child nodes inherit this property from the parent node.<br/><br/>
	 * The following code examples illustrate different call styles for <code>setPosition()</code>.<br><br>
	 * 
	 * @example
	 * node.setPosition(new Core.Vector(50, 100));
	 *
	 * @example
	 * node.setPosition(50, 100);
	 * 
	 * @param {Core.Vector} position The new node position relative to the parent.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getPosition,
	 * @see Core.Vector
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setPosition: function(position)
	{
		var p = this._position;
		p.setAll.apply(p, arguments);
		this._setPositionSendGen(p.getX(),p.getY());
		return this;
	},
	
    /**
	 * Set the <i>x</i> and <i>y</i> scale of the transform for this <code>Node</code>.<br><br>
	 * <b>Note:</b> This property affects the coordinate system of child nodes and scales drawing for
	 * derived classes like <code>Sprite</code>, <code>Text</code>, and <code>Primitive</code>.
	 * <br><br>
	 * The following code examples illustrate different call styles for <code>setScale()</code>.<br><br>
	 * 
	 * @example
	 * node.setScale(new Core.Vector(2, 0.5));
	 *
	 * @example
	 * node.setScale(2, 0.5);
	 * 
	 * @param {Core.Vector} scale The new scale multiple (<i>width</i> and <i>height</i>). You can define the parameter value as a vector or two floats.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getScale, 
	 * @see GL2.Primitive, 
	 * @see GL2.Sprite, 
	 * @see GL2.Text
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setScale: function(scale)
	{
		var s = this._scale;
		s.setAll.apply(s, arguments);
		this._setScaleSendGen(s.getX(),s.getY());
		return this;
	},
	/**
	 * Set the color for the specified entity. Call this method either by reference to a single vector object  
	 * or by defining three float parameters.
	 * Every color pixel value for the entity is multiplied by the value of the parameter before drawing.
	 * <br><br>
	 * <b>Example:</b> If you specify an entity to draw an orange pixel <code>(1.0, 0.5, 0)</code>,
	 * but the entity color is purple <code>(0.5, 0, 1.0)</code>, the resulting pixel color is
	 * <code>(0.5, 0, 0)</code>, which is dark red. The application conducts this efficiently for each pixel in the
	 * entity.<br><br>
	 * The following code examples illustrate different call styles for <code>setColor()</code>.<br><br>
	 * 
	 * @example
	 * node.setColor(new Core.Color(1.0, 0.5, 0));
	 *
	 * @example
	 * node.setColor(1.0, 0.5, 0);
	 * 
	 * @param {Core.Color} color Pixel color value to muliply by the entity color value.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color, 
	 * @see GL2.Node#getColor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setColor: function(color)
	{
		var c = this._color;
		c.setAll.apply(c, arguments);
		this._setColorSendGen(c.getRed(),c.getGreen(),c.getBlue());
		return this;
	},
    /**
	 * Set the alpha blending state for the entity.
	 * Each pixel of the entity blends with the underlying surface. This occurs in proportion to the alpha blending state of the entity.
	 * The application must set the parameter value within the open interval <code>[0, 1]</code>.
	 * <br><br>
	 * <b>Example:</b> Drawing a red entity with an alpha of <code>0.5</code> over a white background results in a light pink entity. 
	 * Drawing an orange pixel <code>(1.0, 0.5, 0)</code> with an alpha of <code>0.66</code> over
	 * a light blue surface <code>(0.0, 1.0, 1.0)</code>, results in a light brown pixel:
	 * @example (1.0, 0.5, 0) * 0.66 + (0.0, 1.0, 1.0) * 0.34 = (0.6, 0.67, 0.34)
	 * @param {Number} alpha The new alpha blending state for the entity ranging between <code>(0-1)</code> 
	 * (0 = completely transparent, 1 = completely opaque). Expressed as a float.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getAlpha
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setAlpha: function(alpha)
	{
		this._alpha = alpha;
		this._setAlphaSendGen(alpha);
		return this;
	},
	
    /**
	 * Set the transform rotation (in degrees) for this <code>Node</code>.<br><br> 	 
	 * <b>Note:</b> This property affects the coordinate system of child nodes and rotates drawing for
	 * derived classes like <code>Sprite</code>, <code>Text</code>, and <code>Primitive</code>.
	 * <br><br>
	 * The following code examples illustrate different call styles for <code>setRotation()</code>.<br><br>
	 * 
	 * Rotate entity 90 degrees.
	 * <pre class="code">node.setRotation(90);</pre> 
	 * Restore entity to original orientation.
	 * <pre class="code">node.setRotation(0);</pre>
	 * Convert radians to degrees.
	 * <pre class="code">var radians = 0.785;
	 * var degrees = radians * Math.PI / 180;</pre>
	 * Convert degrees to radians.
	 * <pre class="code">var degrees = 90;
	 * var radians = degrees * 180 / Math.PI;</pre>
	 *
	 * @param {Number} rotation The new rotation of the entity relative to the parent (in degrees). Expressed as a float.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getRotation, 
	 * @see GL2.Primitive, 
	 * @see GL2.Sprite, 
	 * @see GL2.Text
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setRotation: function(rotation)
	{
		this._rotation = rotation;
		this._setRotationSendGen(rotation);
		return this;
	},
	
    /**
	 * Set the <code>depth</code> component for this <code>Node</code>.
	 * This property affects how a node is sorted when the scene is traversed. Different depth-levels affect
	 * both drawing order (back to front, low to high) and touch priority (front to back,
	 * high to low).<br><br>
	 * <b>Note:</b> Use <code>{@link GL2.Node#setChildrenDepthGrouped}</code> to set how a node will sort with siblings.
	 * @example node.setDepth(20);
	 * @param {Number} depth The new depth for the entity (z-order). Expressed as a float.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getChildrenDepthGrouped, 
	 * @see GL2.Node#setChildrenDepthGrouped
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setDepth: function(depth)
	{
		if(this._depth != depth)
		{
			this._depth = depth;
			this._setDepthSendGen(depth);
		}
		return this;
	},
	
    /**
	 * Set the <code>visible</code> component for this <code>Node</code>.
	 * This component defines visibility of the node.
	 * The default value is <code>true</code>.<br><br>
	 * <b>Note:</b> A node can inherit the value of this component from parent nodes in the scene graph.
	 * @example node.setVisible(true);
	 * @param {Boolean} [visible=true] Set as <code>true</code> if a node is visible.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getVisible
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setVisible: function(visible)
	{
		if(this._visible != visible)
		{
			this._visible = visible;
			this._setVisibleSendGen(visible);
		}
		return this;
	},
	
    /**
	 * Set this <code>Node</code> to support touches.
	 * The <code>touchable</code> property is Boolean and defines a node as supporting touch input.
	 * A node can inherit the value of <code>touchable</code> from parent nodes in the scene graph.<br><br> 
	 * <b>Caution!</b> Instantiating touchable <code>GL2.Node</code> objects will impact performance 
	 * much more than instantiating <code>GL2.Node</code> objects that do not support touch input. If
	 * a node does not need to support touch input, set <code>touchable</code> to <code>false</code>.
	 * @example node.setTouchable(false);
	 * @param {boolean} [touchable=true] Set as <code>true</code> if this node supports touch input.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getTouchahble
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setTouchable: function(touchable)
	{
		this._touchable = touchable;
		this._setTouchableSendGen(touchable);
		return this;
	},
    
	/**
	 * Set whether to sort child nodes adjacent to this <code>Node</code>.
	 * When <code>childrenDepthGrouped</code> is <code>false</code>, the child nodes interleave 
	 * with the children of the nearest similarly grouped ancestor. Applications can use this to sort a distant node
	 * on an independent branch of the graph in close proximity.<br/><br/>
	 * <b>Example:</b> You have multiple group nodes containing a character sprite and a 
	 * shadow sprite. By setting all the shadow sprites to a <code>depth</code> of <code>1</code>, all character sprites to
	 * a <code>depth</code> of <code>2</code>, and setting <code>childrenDepthGrouped</code> to <code>false</code> for each group node, all character sprites will 
	 * sort above shadows when drawn.<br><br>
     * Look at the following structure of nodes.
     * If <code>childrenDepthGrouped</code> is <code>true</code> for the group, the primitive will
     * draw above both the sprite and the text. However, if <code>false</code>,
     * the primitive will draw after the sprite but before the text.
     * <pre class="code">
     * Root
     * +-- Group (depth = 0)
     * |   +-- Sprite (depth = 10)
     * |   +-- Text (depth = -10)
     * |
     * +-- Primitive (depth = 5)
     * </pre>
	 * @param {Boolean} childrenDepthGrouped Set as <code>true</code> to sort with ancestor siblings. Set as <code>false</code> to sort only with siblings in the graph.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getChildrenDepthGrouped
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setChildrenDepthGrouped: function(childrenDepthGrouped)
	{
		if(this._childrenDepthGrouped != childrenDepthGrouped)
		{
			this._childrenDepthGrouped = childrenDepthGrouped;
			this._setChildrenDepthGroupedSendGen(childrenDepthGrouped);
		}
		return this;
	},
	
	/**
	 * Add a node as a child to this <code>Node</code>.
	 * @example node.addChild(this.mySprite);
	 * @param {GL2.Node} child The child node to add.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#removeChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	addChild: function(child)
	{
		// Add to children list.
		this._children.push(child);
		
		// Tell child.
		child._didAddToParent(this);
		
		this._addChildSendGen(Core.ObjectRegistry.objectToId(child));
		
		return this;
	},
	
	/**
	 * Remove a specified child node and its subtree from this <code>Node</code>.
	 * @example node.removeChild(this.mySprite);
	 * @param {String} child The child node to remove from the current entity.
	 * @throws {removeChild called for a node that is not a child} Specified node is not a child node.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#addChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	removeChild: function(child)
	{
		// Tell child.
		child._willRemoveFromParent();
		
		// Remove from children list.
		var index = this._children.indexOf(child);
		if(index == -1)
			throw new Error('removeChild called for a node that is not a child');
		this._children.splice(index, 1);
		
		this._removeChildSendGen(Core.ObjectRegistry.objectToId(child));
		
		return this;
	},
	
	/**
	 * Convert the relative location of a scene to the local coordinate space for this <code>Node</code>.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {Core.Vector} location The relative location for a scene.
	 * @see GL2.Node#localToScreen
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	screenToLocal: function(location)
	{
		var parent = this._parent;
		if(!parent)
			return undefined;
			
		location = parent.screenToLocal(location);
		if(!location)
			return undefined;
		
		var x = location.getX();
		var y = location.getY();
		
		// Undo translation.
		var p = this._position;
		x -= p.getX();
		y -= p.getY();
		
		// Undo rotation.
		var r = this._rotation * Math.PI / 180;
		var cosr = Math.cos(r);
		var sinr = Math.sin(r);
		var tx = cosr*x + sinr*y;
		var ty = -sinr*x + cosr*y;
		x = tx;
		y = ty;
		
		// Undo scale.
		var s = this._scale;
		x /= s.getX();
		y /= s.getY();
		
		return new Core.Point(x, y);
	},
	
	/**
	 * Convert a location within the local coordinate space for this <code>Node</code> to a location within the screen coordinate
	 * space.
	 * @param {Core.Vector} location A location in the local transform for this <code>Node</code>.
	 * @see GL2.Node#screenToLocal
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	localToScreen: function(location)
	{
		var x = location.getX();
		var y = location.getY();
		
		// Undo scale.
		var s = this._scale;
		x *= s.getX();
		y *= s.getY();
		
		// Undo rotation.
		var r = -this._rotation * Math.PI / 180;
		var cosr = Math.cos(r);
		var sinr = Math.sin(r);
		var tx = cosr*x + sinr*y;
		var ty = -sinr*x + cosr*y;
		x = tx;
		y = ty;
		
		// Undo translation.
		var p = this._position;
		x += p.getX();
		y += p.getY();
		
		var parent = this._parent;
		if(!parent)
			return undefined;
		
		location = parent.localToScreen(new Core.Point(x, y));
		if(!location)
			return undefined;
		return location;
	},
	
	_didAddToParent: function(parent)
	{
		if(this._parent)
			this._parent.removeChild(this);
		
		this._parent = parent;
	},
	
	_willRemoveFromParent: function()
	{
		this._parent = null;
	},
	
	_synchronizeNodeRecv: function( cmd )
	{
		var msg = {};
		if(!this._synchronizeNodeRecvGen(cmd, msg))
			return;
		this._position.setAll(msg.x, msg.y);
		this._rotation = msg.rotation;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 307
	// Method create = -1
	// Method destroy = 2
	// Method setPosition = 3
	// Method setScale = 4
	// Method setColor = 5
	// Method setAlpha = 6
	// Method setRotation = 7
	// Method setDepth = 8
	// Method setVisible = 9
	// Method setTouchable = 10
	// Method setChildrenDepthGrouped = 11
	// Method addChild = 12
	// Method removeChild = 13
	// Method synchronizeNode = 14
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 14:
					instance._synchronizeNodeRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Node._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Node._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[307] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_synchronizeNodeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		obj[ "rotation" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "rotation" ] === undefined )
		{
			NgLogE("Could not parse rotation in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":307,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":307,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setPositionSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":307,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setScaleSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":307,4," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setColorSendGen: function( red, green, blue )
	{
		Core.Proc.appendToCommandString( ":307,5," + this.__objectRegistryId + "," + red + "," + green + "," + blue  );
	},
	
	/** @private */
	_setAlphaSendGen: function( alpha )
	{
		Core.Proc.appendToCommandString( ":307,6," + this.__objectRegistryId + "," + alpha  );
	},
	
	/** @private */
	_setRotationSendGen: function( rotation )
	{
		Core.Proc.appendToCommandString( ":307,7," + this.__objectRegistryId + "," + rotation  );
	},
	
	/** @private */
	_setDepthSendGen: function( depth )
	{
		Core.Proc.appendToCommandString( ":307,8," + this.__objectRegistryId + "," + depth  );
	},
	
	/** @private */
	_setVisibleSendGen: function( visible )
	{
		Core.Proc.appendToCommandString( ":307,9," + this.__objectRegistryId + "," + ( visible ? 1 : 0 )  );
	},
	
	/** @private */
	_setTouchableSendGen: function( touchable )
	{
		Core.Proc.appendToCommandString( ":307,10," + this.__objectRegistryId + "," + ( touchable ? 1 : 0 )  );
	},
	
	/** @private */
	_setChildrenDepthGroupedSendGen: function( childrenDepthGrouped )
	{
		Core.Proc.appendToCommandString( ":307,11," + this.__objectRegistryId + "," + ( childrenDepthGrouped ? 1 : 0 )  );
	},
	
	/** @private */
	_addChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":307,12," + this.__objectRegistryId + "," + child  );
	},
	
	/** @private */
	_removeChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":307,13," + this.__objectRegistryId + "," + child  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPosition: function( x, y ) {}
	
	// setScale: function( x, y ) {}
	
	// setColor: function( red, green, blue ) {}
	
	// setAlpha: function( alpha ) {}
	
	// setRotation: function( rotation ) {}
	
	// setDepth: function( depth ) {}
	
	// setVisible: function( visible ) {}
	
	// setTouchable: function( touchable ) {}
	
	// setChildrenDepthGrouped: function( childrenDepthGrouped ) {}
	
	// addChild: function( child ) {}
	
	// removeChild: function( child ) {}
	
	// _synchronizeNodeRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Primitive'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Primitive'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Primitive'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Animation = require('NGCore/Client/GL2/Animation').Animation;
var Core = require('NGCore/Client/Core').Core;

exports.Primitive = Node.subclass(
/** @lends GL2.Primitive.prototype */
{
	classname: 'Primitive',
    
	/**
	 * @class The <code>Primitive</code> class constructs objects that draw arbitrary vertex-based geometry.
	 * These objects provide a means of drawing raw 2D <a href="GL2.Primitive.Vertex.html">vertex</a> data as polygons to a <code>{@link UI.View}</code>. Data is
	 * provided by users as a vertex list. 
	 * @constructs The default constructor. 
	 * @augments GL2.Node
	 */
    initialize: function()
    {
        this._animation = null;
		this._ownsAnimation = false;
		
		this._animationCompleteEmitter = new Core.MessageEmitter();
        this._type = this.Type.Triangles;
        this._vertexes = [];
    },

	/**
	 * The default destructor.
	 * This call cleans up any attached <code>Animation</code> and <code>AnimationCompleteEmitter</code>.
	 * @see GL2.Animation
	 * @status iOS, Android, Flash
	 */
	destroy: function()
	{
		this._tryDestroyAnimation();
		this._animationCompleteEmitter.destroy();
	},
	
	/**
	 * Retrieve the number of listed vertices in the geometry of this <code>Primitive</code>.
	 * @returns {Number} The current number of vertices.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVertexCount: function()
	{
		return this._vertexes.length;
	},
	
	/**
	 * Retrieve a single vertex from the vertex list of this <code>Primitive</code>.
	 * @param {Number} index The vertex list offset to retrieve.
	 * @returns {GL2.Primitive.Vertex} The current vertex at the specified index in the vertex list.
	 * @see GL2.Primitive#setVertex
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVertex: function(index)
	{
		return this._vertexes[index];
	},
	
	/**
	 * Retrieve the GL draw mode for this <code>Primitive</code>.
	 * @returns {GL2.Primitive#Type} The current draw mode.
	 * @see GL2.Primitive#setType
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getType: function()
	{
		return this._type;
	},
	
	/**
	 * Retrieve the current <code>Texture Animation</code> object of this <code>Primitive</code>.
	 * @returns {GL2.Animation} The current animation.
	 * @see GL2.Primitive#setAnimation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnimation: function()
	{
		if(this._ownsAnimation) return null;
		
		return this._animation;
	},
	
	/**
	 * Retrieve the complete message emitter for the current animation.
	 * @returns {Core.MessageEmitter} The emitter for the current texture animation.
	 * @see GL2.Animation,  
	 * @see Core.MessageEmitter
	 * @status iOS, Android, Flash
	 */
	getAnimationCompleteEmitter: function()
	{
		return this._animationCompleteEmitter;
	},
    
	/**
	 * Begin playing the specified animation.
	 * Any animation that is not set to loop will trigger the animation complete callback when done.
	 * @example primitive.setAnimation(myAnimation, 30);
	 * @param {GL2.Animation} animation The current animation.
	 * @param {Number} [startTime=0] The starting point of the animation. Expressed as a float.<br><br>
	 * <b>Example:</b> If <code>setAnimation()</code> is called with a <code>startTime</code> equal to half the total duration of the animation, 
	 * playback begins half way through the animation.
	 * @see GL2.Primitive#getAnimation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setAnimation: function(animation, startTime)
	{
		this._tryDestroyAnimation();
		this._animation = animation;
		
		this._setAnimationSendGen( Core.ObjectRegistry.objectToId(animation), startTime || 0 );
	},
    
    /**
	 * Set a static image as the current animation for this <code>Primitive</code>.
	 * This method instantiates a single frame animation of infinite duration using the
	 * specified image. If the primitive is playing another animation at the time of this call, 
	 * the new animation will take priority over the primitive.
	 * The previous animation will stop and the complete emitter will not respond. 
	 * This is because the animation did not technically complete a full playback cycle. <br><br>
	 * You can define optional parameters for the size, anchor, and UV coordinates of the specified image. 
	 * @example primitive.setImage('./Content/blank.png', [480, 320], [0, 0]);
	 * @param {String} image The directory path to an image referenced by a frame.
	 * @param {Core.Size} [size] The size of the image to display in pixels.
	 * @param {Core.Point} [anchor] The anchor coordinates that indicate the image center in the animation.
	 * @param {Core.Rect} [uvs] The UV coordinates used to specify the subset of an image.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation, 
	 * @see GL2.Animation.Frame
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setImage: function(image, size, anchor, uvs)
	{
		this._tryDestroyAnimation();
		
		// Create a single frame animation.
		var args = Array.prototype.slice.call(arguments, 0);
		args.splice(1, 0, 0); // Insert a duration of zero into our arguments.
		var frame = new Animation.Frame();
		frame.constructor.apply(frame, args);
		var animation = new Animation();
		animation.pushFrame(frame);
		
		this._animation = animation;
		this._ownsAnimation = true;
		
		this._setAnimationSendGen(Core.ObjectRegistry.objectToId(animation),0);
		
		return this;
	},
    
    /**
	 * Set the type of geometry on display for this <code>Primitive</code>.
	 * @example primitive.setType(GL2.Primitive.Type.TriangleFan);
	 * @param {GL2.Primitive#Type} type The new GL draw mode.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setType: function(type)
	{
		this._type = type;
		
		this._setTypeSendGen(type);
		
		return this;
	},
    
    /**
     * Add a vertex to the end of the vertex list for this <code>Primitive</code>.<br>
     * <pre class="code"><font size="2">primitive.pushVertex(new Core.Point(w*2/10, h*5/6));</font></pre><br>
     * Calling <code>pushVertex()</code> is equivalent to calling <code>spliceVertexes()</code> in the following way:
     * <pre class="code"><font size="2">primitive.spliceVertexes(primitive.getVertexCount(), 0, vertex);</font></pre>
     * @param {GL2.Primitive.Vertex} vertex The vertex to add.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    pushVertex: function(vertex)
	{
		return this.spliceVertexes(this._vertexes.length, 0, vertex);
	},
    
    /**
	 * Set the vertex at index <i>i</i> for this <code>Primitive</code>.
	 * Calling <code>setVertex()</code> is equivalent to calling <code>spliceVertexes()</code> in the following way:
	 * @example primitive.spliceVertexes(i, 1, vertex)
	 * @param {Number} <i>i</i> The index in the vertex list to set.
	 * @param {GL2.Primitive.Vertex} vertex The new vertex.
	 * @see GL2.Primitive#getVertex
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setVertex: function(i, vertex)
	{
		return this.spliceVertexes(i, 1, vertex);
	},
    
    /**
	 * Replace <code>len</code> vertices, starting at position <code>start</code>, with specified vertices.<br><br>
	 * The following are examples of different call styles for <code>spliceVertexes</code>.<br><br>
	 * Splice a simple textureless quad into the vertex list.
	 * <pre class="code"><font size="2">var c = new Core.Color([1,1,1]);
	 * var w = 100;
	 * var h = 100;
	 * var v = new Array();
	 * v.push(new GL2.Primitive.Vertex([0,0],[0,0],c));
	 * v.push(new GL2.Primitive.Vertex([w,0],[0,0],c));
	 * v.push(new GL2.Primitive.Vertex([w,h],[0,0],c));
	 * v.push(new GL2.Primitive.Vertex([0,h],[0,0],c));</font></pre>
	 * Insert four vertices at position 0 in the vertex list.
	 * <pre class="code"><font size="2">myPrimitive.spliceVertexes.apply(myPrimitive, ([0,0]).concat(v));
	 * myPrimitive.setType(GL2.Primitive.Type.TriangleFan);</font></pre>
	 * @param {Number} start The index from which to remove vertices in the vertex list.
	 * @param {Number} len The number of vertices to replace.
	 * @param {GL2.Primitive.Vertex} vertexes A list of vertices to insert at the start location.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    spliceVertexes: function(start, len, vertexes)
	{
		this._vertexes.splice.apply(this._vertexes, arguments);
		
		var vertexCount = arguments.length-2;
		this._spliceVertexesSendGen(start,len,vertexCount);
		
		for(var i=0; i < vertexCount; ++i)
		{
			var vertex = arguments[i+2];
			var position = vertex.getPosition();
			var uv = vertex.getUV();
			var color = vertex.getColor();
			this._vertexSendGen(
				position.getX(),
				position.getY(),
				uv.getX(),
				uv.getY(),
				color.getRed(),
				color.getGreen(),
				color.getBlue()
			);
		}
		
		return this;
	},

	$Vertex: Core.Class.subclass(
	/** @lends GL2.Primitive.Vertex.prototype */
	{
		classname: 'Vertex',
		
		/**
		 * @class <code>Vertex</code> objects specify location, texture coordinates, and color data
		 * for GL primitive geometry.
		 * @constructs The default constructor. 
		 * @param {Core.Vector|float[2]} position A location.
		 * @param {Core.Vector|float[2]} uv A texture coordinate.
		 * @param {Core.Color|float[3]} color An RGB color triplet.
		 * @see GL2.Primitive
		 * @augments Core.Class
		 */
		initialize: function(position, uv, color)
		{
			this._position = new Core.Point(position);
			this._uv = new Core.Point(uv);
			this._color = new Core.Color(color);
		},
		
		/**
		 * Retrieve the location of this <code>Vertex</code>.
		 * @returns {Core.Vector} The current <i>x</i>,<i>y</i> coordinates for the vertex.
    	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getPosition: function()
		{
			return this._position;
		},
		
		/**
		 * Retrieve the texture coordinates of this <code>Vertex</code>.
		 * @returns {Core.Vector} The current <i>x</i>,<i>y</i> coordinates for the texture.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getUV: function()
		{
			return this._uv;
		},
		
		/**
		 * Retrieve the color of this <code>Vertex</code>.
		 * @returns {Core.Color} The current vertex color as a RGB triplet.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getColor: function()
		{
			return this._color;
		},
	}),
	
	_tryDestroyAnimation: function()
	{
		if(this._ownsAnimation)
		{
			// Set our animation to NULL to unlink ourselves from the animation on the backend
			// or else trying to destory the animation will fail because we are still using it.
			this._setAnimationSendGen(0,0);
		
			this._animation.destroy();
			this._animation = null;
			this._ownsAnimation = false;
		}
		this._animation = null;
		this._image = null;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for primitive types.
	 * @namespace
	 */
	Type:
	{ 
		/** Every three vertices define a unique triangle. */
		Triangles: 0,
		/** Every vertex defines a triangle with the 2 preceding vertices. */
		TriangleStrip: 1,
		/** Every vertex defines a triangle with the first vertex and the previous vertex. */
		TriangleFan: 2,
		/** Every vertex pair defines a line segment. */
		LineList: 3,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 308
	// Method create = -1
	// Method spliceVertexes = 2
	// Method vertex = 3
	// Method setType = 4
	// Method setAnimation = 5
	// Method animationComplete = 6
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 6:
					instance._animationCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Primitive._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Primitive._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[308] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_animationCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Primitive.animationComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":308,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_spliceVertexesSendGen: function( start, len, vertexCount )
	{
		Core.Proc.appendToCommandString( ":308,2," + this.__objectRegistryId + "," + start + "," + len + "," + vertexCount  );
	},
	
	/** @private */
	_vertexSendGen: function( x, y, u, v, red, green, blue )
	{
		Core.Proc.appendToCommandString( "," + x + "," + y + "," + u + "," + v + "," + red + "," + green + "," + blue  );
	},
	
	/** @private */
	_setTypeSendGen: function( type )
	{
		Core.Proc.appendToCommandString( ":308,4," + this.__objectRegistryId + "," + type  );
	},
	
	/** @private */
	_setAnimationSendGen: function( animation, startTime )
	{
		Core.Proc.appendToCommandString( ":308,5," + this.__objectRegistryId + "," + animation + "," + startTime  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// spliceVertexes: function( start, len, vertexCount ) {}
	
	// vertex: function( x, y, u, v, red, green, blue ) {}
	
	// setType: function( type ) {}
	
	// setAnimation: function( animation, startTime ) {}
	
	// _animationCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Touch'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Touch'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Touch'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Touch = Core.Class.subclass(
/** @lends GL2.Touch.prototype */
{
	classname: 'Touch',
	
	/**
	 * @class The <code>Touch</code> class constructs objects that identify and track the life cycle of unique touch events in the system.
	 * @constructs These objects are constructed by the system.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this._id = 0;
		this._action = {};
		this._position = new Core.Point();
		this._targetIds = null;
	},
	
	/**
	 * Retrieve a list of every <code>TouchTarget</code> object in which this <code>Touch</code> object resides and is marked as touchable.
	 * @returns {GL2.TouchTarget} A prioritized list of every <code>TouchTarget</code> for this <code>Touch</code>.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTouchTargets: function()
	{
		var ids = this._targetIds;
		var result = [];
		for(var i in ids)
		{
			var t = Core.ObjectRegistry.idToObject(i);
			if(t) result.push(t);
		}
		return result;
	},
	
	/**
	 * Retrieve whether or not this <code>Touch</code> object resides in the specified <code>TouchTarget</code>.
	 * @param {GL2.TouchTarget} touchTarget The <code>TouchTarget</code> to test against.
	 * @returns {Boolean} Returns <code>true</code> when this <code>Touch</code> resides in the <code>TouchTarget</code>.
	 * @status iOS, Android, Flash
	 */
	getIsInside: function(touchTarget)
	{
		// Check if the object's id is in the touchtargets map
		return ( Core.ObjectRegistry.objectToId(touchTarget) in this._targetIds);
	},
	
	/**
	 * Retrieve the location of this <code>Touch</code> object in the global coordinate space.
	 * @returns {Core.Vector} The global coordinates of the <code>Touch</code> location.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPosition: function()
	{
		return this._position;
	},
	
	/**
	 * Retrieve the ID of this <code>Touch</code> object.
	 * <b>Note:</b> When using this ID as a key, append it to a string so that you can use
	 * it to key an associative array. Otherwise, you will end up with a very large array.
	 * @returns {Number} The current <code>Touch</code> ID.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getId: function()
	{
		return this._id;
	},
	
	/**
	 * Retrieve the phase of this <code>touch</code> event.
	 * Use this method from your listener callback.
	 * The following is an example of a <code>touch</code> event handler for a button.
	 * @example
	 * onTouch: function(touch)
	 * {
	 * 	//getAction() informs us of the type of event being handled.
	 * 	//  In order to get Action.Move and Action.End, we need to return true from Action.Start.
	 * 	switch(touch.getAction())
	 * 	{
	 * 		case touch.Action.Start:
	 * 			//Change the color of our Rectangle
	 * 			this.button.setColor(Defaults.onColor);
	 * 			
	 * 			//Return true here if you want to capture this event for its lifetime.
	 * 			//  returning false will let other, lower priority handlers capture the
	 * 			//  event. In that case we would not want to react to the Action.Start since
	 * 			//  we would not get subsequent Action.End or Action.Move.
	 * 			return true;
	 * 			
	 * 		case touch.Action.End:
	 * 			//Reset the color of our Rectangle
	 * 			this.button.setColor(Defaults.offColor);
	 * 			
	 * 			//We do not need to return anything in Action.End or Action.Move.
	 * 			break;
	 * 		case touch.Action.Move:
	 * 			//The touch object allows us to retrieve metadata about the event.
	 * 			//  If the touch has left our bounds, getIsInside() will return false.
	 * 			if(!touch.getIsInside(this._target))
	 * 			{
	 * 				//If the active touch is outside, reset our Rectangle color.
	 * 				this.button.setColor(Defaults.offColor);
	 * 			}
	 * 			else
	 * 			{
	 * 				//If the active touch is inside, set our Rectangle color to on.
	 * 				this.button.setColor(Defaults.onColor);
	 * 			}
	 * 			break;
	 * 	}
	 * }
	 * @returns {GL2.Touch#Action} The current <code>touch</code> event phase.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAction: function()
	{
		return this._action;
	},
	
	_setId: function(id)
	{
		this._id = id;
	},
	
	_setAction: function(action)
	{
		this._action = action;
	},
	
	_setPosition: function(position)
	{
		this._position.setAll(arguments);
	},
	
	_setTargetIds: function(targetIds)
	{
		// We transfer the array of numeric target IDs into a
		// map so we can support getIsInside call which uses 'in'.
		this._targetIds = {};
		for(var i in targetIds)
			this._targetIds[targetIds[i]] = null;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for touch action.
	 * @namespace
	 */
	Action:
	{ 
		/** Finger began touching screen. */
		Start: 0,
		/** Finger stopped touching screen. */
		End: 1,
		/** Finger moved where it is touching the screen. */
		Move: 2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 312
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Touch._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Touch._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[312] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	// This class is expected to implement the following methods outside of
	// the generated block:

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/TouchTarget'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/TouchTarget'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/TouchTarget'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Sprite = require('NGCore/Client/GL2/Sprite').Sprite;
var Core = require('NGCore/Client/Core').Core;

exports.TouchTarget = Node.subclass(
/** @lends GL2.TouchTarget.prototype */
{
	classname: 'TouchTarget',
    
	/**
	 * @class <code>TouchTarget</code> class constructs objects that provide applications access to touch events.
	 *<br><br>
	 * A <code>TouchTarget</code> is a node with added size and offset attributes that define a
	 * rectangular area as active. Any <a href"GL2.Touch.html">touch</a> that falls within the active area is broadcast
	 * to the <code>TouchTarget</code> where a <code>MessageListener</code> can respond 
	 * to the event. Attach a listener by calling <code><a href="GL2.TouchTarget.html#getTouchEmitter">getTouchEmitter()</a></code>
	 * to retrieve the emitter.
	 *<br><br>
	 * A <code>TouchTarget</code> is created with a <code>0</code> size and a center offset anchor point <code>(0.5,0.5)</code>.
	 * Set these two properties to define a usable area that supports touch events. Generally,
	 * you set these two values as identical to the values for <code><a href="GL2.Sprite.html">sprite</a></code>, <code><a href="GL2.Text.html">text</a></code>, 
	 * or <code><a href="GL2.Primitive.html">primitive</a></code> and add
	 * the <code>TouchTarget</code> as a child of that visible node with a position of <code>0</code>. The <code>TouchTarget</code> 
	 * inherits the transform for the visible node. 
	 * <br><br>
	 * <b>Note:</b> A <code>TouchTarget</code> is not part of the drawing scene traversal and activates regardless of node
	 * visibility or parent visibility. 
	 * Disable touch support for a node by calling <code><a href="GL2.Node.html#setTouchable">setTouchable()</a></code>.
	 * @constructs The default constructor.
	 * @augments GL2.Node
	 */
    initialize: function()
    {
		this._size = new Core.Size();
		this._anchor = new Core.Point(0, 0);
		this._touchEmitter = new Core.MessageEmitter();
    },
    
	/**
	 * Destroy this instance and release resources on the backend that are associated with this <code>TouchTarget</code> object.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Return the point size of the <code>TouchTarget</code> area.
	 * @returns {Core.Size} The current size of the <code>TouchTarget</code> area.
	 * @see GL2.TouchTarget#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSize: function()
	{
		return this._size;
	},
	
	/**
	 * Return the offset values used for scaling and rotating the <code>TouchTarget</code> area.
	 * @returns {Core.Point} The current offset of the target area.
	 * @see GL2.TouchTarget#setAnchor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnchor: function()
	{
		return this._anchor;
	},
	
	/**
	 * Return the touch emitter for this <code>TouchTarget</code>.
	 * The emitter fires when a captured <code>touch</code> event changes phases. For the initial touch down
	 * phase, this emitter fires when the <code>touch</code> event occurs within the defined touch area. After returning <code>true</code> from
	 * the initial <code>touch</code> event, the emitter fires regardless of where the <code>touch</code> event occurs.<br><br>	 
	 * The following example creates a new <code>TouchTarget</code> in the upper left corner of the scene. 
	 * The listener instance handles the <code>touch</code> events in the <code>onTouch()</code> function.
	 * @example
	 * var target = new GL2.TouchTarget();
	 * target.setAnchor([50,50]);
	 * target.setSize([100,100]);
	 * target.setPosition([50,50]);
	 * 
	 * target.getTouchEmitter().addListener(this, this.onTouch);
	 * 
	 * GL2.Root.addChild(target);
	 * @return {Core.MessageEmitter} The touch emitter for this touch area.
	 * @see GL2.Touch#getAction
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTouchEmitter: function()
	{
		return this._touchEmitter;
	},
	
    /**
	 * Set the size of this <code>TouchTarget</code> (<i>width</i> and <i>height</i>).
	 * @example this.t = new GL2.TouchTarget();
	 * this.t.setSize(Core.Capabilities.getScreenHeight(), Core.Capabilities.getScreenHeight());
	 * @param {Core.Size} size The new size of the <code>TouchTarget</code> area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSize: function(size)
	{
		var s = this._size;
		s.setAll.apply(s, arguments);

		this._setSizeSendGen(s.getWidth(),s.getHeight());
		
		return this;
	},
	
    /**
	 * Set the anchor point used to rotate and scale the <code>TouchTarget</code> area.
	 * @example this.t = new GL2.TouchTarget();
	 * this.t.setAnchor(0, 0);
	 * @param {Core.Point} anchor The new anchor point for the <code>TouchTarget</code> area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAnchor: function(anchor)
	{
		var a = this._anchor;
		a.setAll.apply(a, arguments);
		
		this._setAnchorSendGen(a.getX(),a.getY());
		
		return this;
	},
	
	/**
	 * Translate a global scene location to the local coordinate space.
	 * Use this method when determining <code>touchMoved</code> offsets.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash
	 */
	screenToLocal: function($super, location)
	{
		location = $super(location);
		if(!location)
			return undefined;
		
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() + a.getX() * s.getWidth());
		location.setY(location.getY() + a.getY() * s.getHeight());
		return location;
	},
	
	/**
	 * Translate a location in the local coordinate space to the global scene coordinate space.
	 * Use this method for translating between local coordinate spaces.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash
	 */
	localToScreen: function($super, location)
	{
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() - a.getX() * s.getWidth());
		location.setY(location.getY() - a.getY() * s.getHeight());
		
		location = $super(location);
		if(!location)
			return undefined;
		return location;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 313
	// Method create = -1
	// Method setSize = 2
	// Method setAnchor = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in TouchTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in TouchTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[313] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":313,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_setSizeSendGen: function( width, height )
	{
		Core.Proc.appendToCommandString( ":313,2," + this.__objectRegistryId + "," + width + "," + height  );
	},
	
	/** @private */
	_setAnchorSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":313,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setSize: function( width, height ) {}
	
	// setAnchor: function( x, y ) {}
	

// {{/Wg Generated Code}}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Root'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Root'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Root'] = exports; var Core = require('NGCore/Client/Core').Core;
var Touch = require('NGCore/Client/GL2/Touch').Touch;

exports.Root = Core.Class.singleton(
/** @lends GL2.Root.prototype */
{
	classname: 'Root',
	
	/**
	 * @class The <code>Root</code> class constructs a singleton object that serves as the proxy object for the {@link UI.GLView} node hierarchy.
	 * <code>Root</code> is the root element of the node hierarchy (also known as a scene graph) for <code>GLView</code>.
	 * The <code>Root</code> transform is composed at the upper left corner of the view with a descending <i>y</i> axis.<br><br>
	 * Adding a node to the <code>Root</code> ensures applications include it when determining drawing and touch events.
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		
		this._children = [];
		
		this._createSendGen(this.__objectRegistryId);
		
		this._touchTracking = {};
	},
	
	/**
	 * Add a node and the node subtree to the root of the scene graph.
	 * @example var spr = new GL2.Sprite();
	 * ...
	 * GL2.Root.addChild(spr);
	 * @param {GL2.Node} child The node to add.
	 * @see GL2.Root#removeChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	addChild: function(child)
	{
		this._children.push(child);
		child._didAddToParent(this);
		
		this._addChildSendGen(Core.ObjectRegistry.objectToId(child));
	},
	
	/**
	 * Remove the child node and the node subtree from the root of the scene graph.<br><br>
	 * <b>Note:</b> This method will not destroy the node. You can keep or destroy a reference to a node 
	 * if you have no further use for it.
	 * @example GL2.Root.removeChild(spr);
	 * @throws {removeChild called for a node that is not a child} Specified node is not a child node.
	 * @param {GL2.Node} child The node to remove.
	 * @see GL2.Root#addChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	removeChild: function(child)
	{
		child._willRemoveFromParent();
		
		var index = this._children.indexOf(child);
		if(index == -1)
			throw new Error('removeChild called for a node that is not a child');
		this._children.splice(index, 1);
		
		this._removeChildSendGen(Core.ObjectRegistry.objectToId(child));
	},
	
	/** 
	 * Translate screen coordinates into node coordinates.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {Core.Vector} location The screen coordinates to translate.
	 * @returns The location as node coordinates.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	screenToLocal: function(location)
	{
		return location;
	},
	
	/** 
	 * Translate node coordinates into screen coordinates.
	 * @param {Core.Vector} location The node coordinates to translate.
	 * @returns The location as screen coordinates.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	localToScreen: function(location)
	{
		return location;
	},
	
	_onTouchEventRecv: function( cmd )
	{
		var msg = {};
		if(!this._onTouchEventRecvGen(cmd, msg))
			return;
		
		// Build touch object.
		var touchId = msg.touchId;
		var touchAction = msg.touchAction;
		var touch = new Touch();
		touch._setId(touchId);
		touch._setAction(touchAction);
		touch._setPosition(msg.x, msg.y);
		
		// Extract all touch targets.
		var ids = [];
		for(var i=0; i < msg.touchTargetCount; ++i)
		{
			var t = {};
			if(!this._touchTargetRecvGen(cmd, t))
				return;
			// Add an array entry for every touch event that we have gotten from native.
			ids.push(t.nodeId);
		}
		
		touch._setTargetIds(ids);
		
		switch(touchAction)
		{
			case Touch.Action.Start:
				// Dispatch to all touch targets until one handles it.
				for(var key in ids)
				{
					var id=ids[key];
					var o = Core.ObjectRegistry.idToObject(id);
					if(o && o.getTouchEmitter().chain(touch))
					{
						this._touchTracking[touchId] = id;
						break;
					}
				}
				break;
			case Touch.Action.End:
				// Dispatch to tracking object.
				var track = this._touchTracking[touchId];
				if(track)
				{
					var o = Core.ObjectRegistry.idToObject(track);
                    if (o)
                        o.getTouchEmitter().chain(touch);
					delete this._touchTracking[touch.getId()];
				}
				break;
			case Touch.Action.Move:
				// Dispatch to tracking object.
				var track = this._touchTracking[touchId];
				if(track)
				{
					var o = Core.ObjectRegistry.idToObject(track);
                    if (o)
                        o.getTouchEmitter().chain(touch);
				}
				break;
		}
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 309
	// Method create = -1
	// Method addChild = 2
	// Method removeChild = 3
	// Method onTouchEvent = 4
	// Method touchTarget = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 4:
					instance._onTouchEventRecv( cmd );
					break;
				case 5:
					instance._touchTargetRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Root._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Root._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[309] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onTouchEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 5 )
		{
			NgLogE("Could not parse due to wrong argument count in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "touchId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "touchId" ] === undefined )
		{
			NgLogE("Could not parse touchId in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "touchAction" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "touchAction" ] === undefined )
		{
			NgLogE("Could not parse touchAction in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "touchTargetCount" ] = Core.Proc.parseInt( cmd[ 4 ] );
		if( obj[ "touchTargetCount" ] === undefined )
		{
			NgLogE("Could not parse touchTargetCount in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 5);
		return true;
	},
	
	/** @private */
	_touchTargetRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Root.touchTarget from command: " + cmd );
			return false;
		}
		
		obj[ "nodeId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "nodeId" ] === undefined )
		{
			NgLogE("Could not parse nodeId in Root.touchTarget from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 1);
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":309,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_addChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":309,2," + this.__objectRegistryId + "," + child  );
	},
	
	/** @private */
	_removeChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":309,3," + this.__objectRegistryId + "," + child  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// addChild: function( child ) {}
	
	// removeChild: function( child ) {}
	
	// _onTouchEventRecv: function( cmd ) {}
	// _touchTargetRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Sprite'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Sprite'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Sprite'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Animation = require('NGCore/Client/GL2/Animation').Animation;
var Core = require('NGCore/Client/Core').Core;

exports.Sprite = Node.subclass(
/** @lends GL2.Sprite.prototype */
{
	classname: 'Sprite',
	
	/**	 
	 * @class The <code>Sprite</code> class constructs objects that are used to display either a single image file 
	 * (see <code><a href="GL2.Sprite.html#setImage">setImage()</a></code>) or an animation.<br><br>
	 * Sprites apply their composite node transform and color to the final 
	 * rendered output of each <code><a href="GL2.Animation.Frame.html">frame</a></code> they display. Frames manage the
	 * pre-transform offset within the image. The pre-transform offset is used by frames for rotation and scale of the image. Combining these
	 * two features, an application can accurately place an image within the view.<br><br>
	 * Animations that reach the end of the last animation frame will trigger the
	 * <code>AnimationCompleteEmitter</code> (see <code><a href="GL2.Sprite.html#getAnimationCompleteEmitter">getAnimationCompleteEmitter()</a></code>). 
	 * All other cases, such as setting a new
	 * animation, does not trigger the emitter.<br><br>
	 * <b>Note:</b> The tick rate for any animation instantiated through <code>Sprite</code> is set through <code>{@link Core.UpdateEmitter#setTickRate}</code>.
	 * @constructs The default constructor.
	 * @augments GL2.Node
	 */
    initialize: function()
    {
		this._clubObject = null;
        this._animation = null;
		this._ownsAnimation = false;
		
		this._animationCompleteEmitter = new Core.MessageEmitter();
    },

	/**
	 * The default destructor.
	 * This call cleans up any attached <code>Animation</code> and <code>AnimationCompleteEmitter</code> objects.
	 * @see GL2.Animation,
	 * @see GL2.Sprite#getAnimationCompleteEmitter
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this._tryDestroyAnimation();
		this._animationCompleteEmitter.destroy();
	},
	
	/**
	 * Retrieve the current <code>Sprite</code> animation.
	 * If the sprite is rendering a single image animation through <code>setImage()</code>,
	 * this method will return <code>undefined</code>.
	 * @returns {GL2.Animation} The current animation. Returns <code>null</code> if the application is not currently playing an animation.
	 * @see GL2.Sprite#setAnimation,
	 * @see GL2.Sprite#setImage
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnimation: function()
	{
		if(this._ownsAnimation) return null;
		
		return this._animation;
	},
    
    /**
	 * Retrieve the animation complete emitter for this <code>Sprite</code>.
	 *
	 * This emitter is triggered when one of the following conditions occurs:<br><br>
	 *<ul>
	 * <li>The sprite reaches the end of an animation for which the last frame has a duration of <code>0</code>.</li>
	 * <li>A <code>setAnimation()</code> or a <code>setImage()</code> call resets the animation complete emitter.</li>
	 *</ul>
	 * Any code that requires notification when an animation completes should register as a 
	 * listener to this emitter. The emitter callback will pass this sprite as the only parameter.<br><br>
	 * <b>Note:</b> Looping animations and starting new animations do not trigger this emitter.
	 * @returns {Core.MessageEmitter} The emitter that triggers the completion callback.
	 * @see GL2.Sprite#setAnimation,
	 * @see GL2.Sprite#setImage	 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnimationCompleteEmitter: function()
	{
		return this._animationCompleteEmitter;
	},
    
    /**
	 * Begin playing the specified animation with this <code>Sprite</code>.
	 * If the sprite is playing another animation at the time of this call, the new animation will take priority over the sprite.
	 * The previous animation will stop and the complete emitter will not respond. This is because the animation did not technically complete a full playback cycle. 
	 * <br><br>
	 * <b>Note:</b> You can release the resources for any animation set with <code>setAnimation()</code> from the native backend if no other frame
	 * contains it.
	 * @example var animation = Animation.getNamed('background');
	 * ...
	 * var sprite = new GL2.Sprite();
	 * sprite.setAnimation(animation);
	 * @param {GL2.Animation} animation The animation to play.
	 * @param {Number} [startTime=0] The time offset where playback should start relative to the actual start of the animation. Expressed in milliseconds.<br><br>
	 * <b>Example:</b> If <code>setAnimation()</code> is called with a <code>startTime</code> equal to half the total duration of the animation, 
	 * playback begins half way through the animation.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setAnimation: function(animation, startTime)
	{
		this._tryDestroyAnimation();
		this._animation = animation;
		
		this._setAnimationSendGen(Core.ObjectRegistry.objectToId(animation), startTime || 0);
		
		return this;
	},
    
    /**
	 * Set a static image as the current animation for this <code>Sprite</code>.
	 * Internally, this method instantiates a single frame animation of infinite duration using the
	 * specified image. If the sprite is playing another animation at the time of this call, the new animation will take priority over the sprite.
	 * The previous animation will stop and the complete emitter will not respond. This is because the animation did not technically complete a full playback cycle. 
	 * <br><br>
	 * <b>Note:</b> You can release the resources for any image set with <code>setImage()</code> from the native backend if no other frame
	 * contains it.
	 * @example var myImage = new GL2.Sprite();
	 * myImage.setImage('./Content/animation.png', size);
	 * @param {String} image The directory path to an image resource.
	 * @param {Core.Size} [size] The size of the image to display (in pixels).
	 * @param {Core.Point} [anchor] The anchor coordinates that indicate the image center in the animation.
	 * @param {Core.Rect} [uvs] The UV coordinates used to specify the subset of an image.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setImage: function(image, size, anchor, uvs)
	{
		this._tryDestroyAnimation();
		
		// Create a single frame animation.
		var args = Array.prototype.slice.call(arguments, 0);
		args.splice(1, 0, 0); // Insert a duration of zero into our arguments.
		var frame = new Animation.Frame();
		frame.constructor.apply(frame, args);
		var animation = new Animation();
		animation.pushFrame(frame);
		
		this._animation = animation;
		this._ownsAnimation = true;
		
		this._setAnimationSendGen(Core.ObjectRegistry.objectToId(animation),0);
		
		return this;
	},
	
	_tryDestroyAnimation: function()
	{
		if(this._ownsAnimation)
		{
			// Set our animation to NULL to unlink ourselves from the animation on the backend
			// or else trying to destory the animation will fail because we are still using it.
			this._setAnimationSendGen(0,0);
		
			this._animation.destroy();
			this._animation = null;
			this._ownsAnimation = false;
		}
		this._animation = null;
	},
	
	_animationCompleteRecv: function(cmd)
	{
		var msg = {};
		if(!this._animationCompleteRecvGen(cmd, msg))
			return;
		
		this._animationCompleteEmitter.emit(this);
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 310
	// Method create = -1
	// Method setAnimation = 2
	// Method animationComplete = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._animationCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Sprite._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Sprite._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[310] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_animationCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Sprite.animationComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":310,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_setAnimationSendGen: function( animation, startTime )
	{
		Core.Proc.appendToCommandString( ":310,2," + this.__objectRegistryId + "," + animation + "," + startTime  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setAnimation: function( animation, startTime ) {}
	
	// _animationCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Text'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Text'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Text'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Core = require('NGCore/Client/Core').Core;

exports.Text = Node.subclass(
/** @lends GL2.Text.prototype */
{
	classname: 'Text',
    
	/**
	 * @class The <code>Text</code> class constructs objects that provide font specifications to the GL2 module. 
	 * <code>Text</code> objects define positionable areas for rendering text strings as application labels.
	 * @constructs The default constructor. 
	 * @augments GL2.Node
	 * @param {String} [text] The text string to render in the constructor.
	 */
    initialize: function(text)
    {
		this._size = new Core.Size();
		this._anchor = new Core.Point(0.5, 0.5);
        this._horizontalAlign = this.HorizontalAlign.Center;
        this._verticalAlign = this.VerticalAlign.Middle;
        this._text = '';
		if (text)
			 this.setText(text);
							 
        this._fontFamily = '';
        this._fontSize = 18;
		this._overflowMode = this.OverflowMode.Multiline;
		this._fontLocation = this.FontLocation.Default;
    },
    
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the size of the text area from this <code>Text</code> node.
	 * The text area size is defined through two components: <i>width</i> and <i>height</i>.
	 * A value of <code>0</code> for either component means the text area will expand to the size of the string.
	 * @returns {Core.Vector} The current size of the text area (expressed as points).
	 * @see GL2.Text#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSize: function()
	{
		return this._size;
	},
	
	/**
	 * Retrieve the placement offset for translating before applying the transform of this <code>Text</code> node.
	 * This value is specified as a multiple of the text area size with <code>(0,0)</code> as the top-left corner.
	 * @returns {Core.Vector} The current placement offset.
	 * @see GL2.Text#setAnchor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnchor: function()
	{
		return this._anchor;
	},
	
	/**
	 * Retrieve the horizontal alignment of the text area from this <code>Text</code> node.
	 * @returns {GL2.Text#HorizontalAlign} The current horizontal alignment of the text area.
	 * @see GL2.Text#setHorizontalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHorizontalAlign: function()
	{
		return this._horizontalAlign;
	},
	
	/**
	 * Retrieve the vertical alignment of the text area from this <code>Text</code> node.
	 * @returns {GL2.Text#VerticalAlign} The curren vertical alignment of the text area.
	 * @see GL2.Text#setVerticalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVerticalAlign: function()
	{
		return this._verticalAlign;
	},
	
	/**
	 * Retrieve the text string this <code>Text</code> node will render.
	 * @returns {String} The current text string to render in the text area.
	 * @see GL2.Text#setText
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getText: function()
	{
		return this._text;
	},
	
	/**
	 * Retrieve the font family for the text area from this <code>Text</code> node.
	 * The GL2 module uses Arial as the text area font family when this value is undefined.<br><br>
	 * <b>Note:</b> <code>Text</code> nodes default to Arial as the font family when an application cannot load the specified font.
	 * @returns The current font family defined for the text area.
	 * @see GL2.Text#setFontFamily
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getFontFamily: function()
	{
		return this._fontFamily;
	},
	
	/**
	 * Retrieve the font size for the text area from this <code>Text</code> node.
	 * @returns {Number} The current font size defined for the text area.
	 * @see GL2.Text#setFontSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFontSize: function()
	{
		return this._fontSize;
	},
	
	/**
	 * Retrieve the overflow style of the text area from this <code>Text</code> node. 
	 * @returns {GL2.Text#OverflowMode} The current overflow style defined for the text area.
	 * @see GL2.Text#setOverflowMode,
	 * @see GL2.Text#OverflowMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getOverflowMode: function()
	{
		return this._overflowMode;
	},
	
    /**
	 * Set the size in pixels of the text area for this <code>Text</code> node.
	 * The text area size is defined through two components: <i>width</i> and <i>height</i>. 
	 * @example var w = Core.Capabilities.getScreenWidth();
	 * var h = Core.Capabilities.getScreenHeight();
	 * ...
	 * var label = new GL2.Text();
	 * label.setSize(w, h);
	 * @param {Core.Vector} size A new vector specifying the text area size in pixels.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSize: function(size)
	{
		var s = this._size;
		s.setAll.apply(s, arguments);

		this._setSizeSendGen(s.getWidth(),s.getHeight());
		
		return this;
	},
	
    /**
	 * Set the text area offset as a multiple of the area size (<i>width</i> and <i>height</i>).
	 * An <code>Anchor</code> defines a location the text area will rotate and scale around; <code>Anchors</code> are applied
	 * to the drawing prior to the composite transform for the node. When the text size of the text area is <code>0</code> in either
	 * dimension, the offset is measured from the rendered size of the string in that dimension.<br><br>
	 * <b>Example:</b> If you want to display a text area as centered, you can set the <code>horizontalAlign</code> to
	 * <code>centered</code> and set the <code>anchor</code> to <code>[0.5,h]</code> with <i>h</i> representing a vertical offset.
	 * @example text.setAnchor(0.5,h);
	 * @param {Core.Vector} location A new vector specifying the offset location.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node,
	 * @see GL2.Text#getAnchor,
	 * @see GL2.Text#setHorizontalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAnchor: function(location)
	{
		var a = this._anchor;
		a.setAll.apply(a, arguments);
		
		this._setAnchorSendGen(a.getX(),a.getY());
		
		return this;
	},
	
    /**
	 * Set the horizontal alignment of the text area for this <code>Text</code> node.
	 * @example var t = new GL2.Text(this._label);
	 * ...
	 * t.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
	 * @param {GL2.Text#HorizontalAlign} horizontalAlign The new horizontal alignment for the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setHorizontalAlign: function(horizontalAlign)
	{
		this._horizontalAlign = horizontalAlign;
		
		this._setHorizontalAlignSendGen(horizontalAlign);
		
		return this;
	},
    
    /**
	 * Set the vertical alignment of the text area for this <code>Text</code> node.
	 * @example var t = new GL2.Text(this._label);
	 * ...
	 * t.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
	 * @param {GL2.Text#VerticalAlign} verticalAlign The new vertical alignment for the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getVerticalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setVerticalAlign: function(verticalAlign)
	{
		this._verticalAlign = verticalAlign;
		
		this._setVerticalAlignSendGen(verticalAlign);
		
		return this;
	},
    
    /**
	 * Set the text string to render in the text area of this <code>Text</code> node.
	 * @example var label = new GL2.Text();
	 * ...
	 * label.setText('This is a label');
	 * @param {String} text The new text string to render in the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getText
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setText: function(text)
	{
		this._text = text;
		
		this._setTextSendGen(text);
		
		return this;
	},
    
    /**
	 * Set the font family to use for rendering text strings in the text area of this <code>Text</code> node.<br><br>
	 * Using this call to set application specific fonts (os-independent) requires you to add the font file name with extension (.ttf) to the manifest.json.
	 * The font family file must reside in the <code>Content</code> directory. The font family file name is passed in this call. The font face is applied to each object of type 
	 * <code>GL2.Text</code> that will override the system font.
	 * @example var font = new GL2.Text();
	 * ...
	 * font.setFontFamily("Content/Cacophony.ttf");
	 * @param {String} [fontFamily=Arial] The new font family to render in the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getFontFamily
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setFontFamily: function(fontFamily)
	{
		this._fontFamily = fontFamily;
		
		this._setFontFamilySendGen(fontFamily);
		
		return this;
	},
    
    /**
	 * Set the text area font size for this <code>Text</code> node.
	 * @example var fontSize = 24;
	 *
	 * var font = new GL2.Text();
	 * ...
	 * font.setFontSize(fontSize);
	 * @param {Number} [fontSize=18pt] The new font size for text strings (expressed in points).
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getFontSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setFontSize: function(fontSize)
	{
		this._fontSize = fontSize;
		
		this._setFontSizeSendGen(fontSize);
		
		return this;
	},
	
	/**
	 * Set the overflow style of the text area for this <code>Text</code> node. 
	 * This method defines how a <code>Text</code> node will fit a rendered string inside 
	 * the text area when the string is too long.
	 * @example var font = new GL2.Text();
	 * ...
	 * font.setOverflowMode(GL2.Text.OverflowMode.ReduceFontSize);
	 * @param {GL2.Text#OverflowMode} overflowMode The overflow rendering style for long text strings.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getOverflowMode,
	 * @see GL2.Text#OverflowMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setOverflowMode: function(overflowMode)
	{
		this._overflowMode = overflowMode;
		
		this._setOverflowModeSendGen(overflowMode);
		
		return this;
	},
	
	/**
	 * Set the directory path to the location of a font used by this <code>Text</code> node.
	 * @example var font = new GL2.Text();
	 * ...
	 * font.setFontLocation(GL2.Text.FontLocation.System);
	 * @param {String} fontLocation The new directory path to a font used in the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setFontLocation: function(fontLocation)
	{
		this._fontLocation = fontLocation;
		
		this._setFontLocationSendGen(fontLocation);
		
		return this;
	},
	
	/**
	 * Translate a global scene location to the local coordinate space of this <code>Text</code> node.
	 * Use this method when determining <code>touchMoved</code> offsets.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	screenToLocal: function($super, location)
	{
		location = $super(location);
		if(!location)
			return undefined;
		
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() + a.getX() * s.getWidth());
		location.setY(location.getY() + a.getY() * s.getHeight());
		return location;
	},
	
	/**
	 * Translate a location in the local coordinate space to the global scene coordinate space of this <code>Text</code> node.
	 * Use this method for translating between local coordinate spaces.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	localToScreen: function($super, location)
	{
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() - a.getX() * s.getWidth());
		location.setY(location.getY() - a.getY() * s.getHeight());
		
		location = $super(location);
		if(!location)
			return undefined;
		return location;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for horizontal alignment modes.
	 * @namespace
	 */
	HorizontalAlign:
	{ 
		/** Align text to the left. */
		Left: 0,
		/** Align text in the center. */
		Center: 1,
		/** Align text to the right. */
		Right: 2,
	},
	
	/** 
	 * Enumeration for vertical alignment modes.
	 * @namespace
	 */
	VerticalAlign:
	{ 
		/** Align text to the top. */
		Top: 0,
		/** Align text in the middle. */
		Middle: 1,
		/** Align text to the bottom. */
		Bottom: 2,
	},
	
	/** 
	 * Enumeration for the behavior when there is too much text to fit on one line.
	 * @namespace
	 */
	OverflowMode:
	{ 
		/** Reduce the font size until the text fits. */
		ReduceFontSize: 0,
		/** Break the text across multiple lines. */
		Multiline: 1,
	},
	
	/** 
	 * Enumeration for location of fonts.
	 * @namespace
	 */
	FontLocation:
	{ 
		/** Use Default fonts. */
		Default: 0,
		/** Use System fonts. */
		System: 1,
		/** Use bundled fonts that ship with engine and available to all apps. */
		Bundled: 2,
		/** Use custom fonts that are loaded with app manifest. */
		Manifest: 3,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 311
	// Method create = -1
	// Method destroy = 2
	// Method setSize = 3
	// Method setAnchor = 4
	// Method setHorizontalAlign = 5
	// Method setVerticalAlign = 6
	// Method setText = 7
	// Method setFontFamily = 8
	// Method setFontSize = 9
	// Method setOverflowMode = 10
	// Method setFontLocation = 11
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Text._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Text._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[311] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":311,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":311,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setSizeSendGen: function( width, height )
	{
		Core.Proc.appendToCommandString( ":311,3," + this.__objectRegistryId + "," + width + "," + height  );
	},
	
	/** @private */
	_setAnchorSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":311,4," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setHorizontalAlignSendGen: function( align )
	{
		Core.Proc.appendToCommandString( ":311,5," + this.__objectRegistryId + "," + align  );
	},
	
	/** @private */
	_setVerticalAlignSendGen: function( align )
	{
		Core.Proc.appendToCommandString( ":311,6," + this.__objectRegistryId + "," + align  );
	},
	
	/** @private */
	_setTextSendGen: function( text )
	{
		Core.Proc.appendToCommandString( ":311,7," + this.__objectRegistryId + "," + Core.Base64.encode( text )  );
	},
	
	/** @private */
	_setFontFamilySendGen: function( fontFamily )
	{
		Core.Proc.appendToCommandString( ":311,8," + this.__objectRegistryId + "," + Core.Base64.encode( fontFamily )  );
	},
	
	/** @private */
	_setFontSizeSendGen: function( fontSize )
	{
		Core.Proc.appendToCommandString( ":311,9," + this.__objectRegistryId + "," + fontSize  );
	},
	
	/** @private */
	_setOverflowModeSendGen: function( overflowMode )
	{
		Core.Proc.appendToCommandString( ":311,10," + this.__objectRegistryId + "," + overflowMode  );
	},
	
	/** @private */
	_setFontLocationSendGen: function( fontLocation )
	{
		Core.Proc.appendToCommandString( ":311,11," + this.__objectRegistryId + "," + fontLocation  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setSize: function( width, height ) {}
	
	// setAnchor: function( x, y ) {}
	
	// setHorizontalAlign: function( align ) {}
	
	// setVerticalAlign: function( align ) {}
	
	// setText: function( text ) {}
	
	// setFontFamily: function( fontFamily ) {}
	
	// setFontSize: function( fontSize ) {}
	
	// setOverflowMode: function( overflowMode ) {}
	
	// setFontLocation: function( fontLocation ) {}
	

// {{/Wg Generated Code}}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/RenderTarget'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/RenderTarget'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/RenderTarget'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.RenderTarget = Core.Class.subclass(
	/** @lends GL2.RenderTarget.prototype */
{
	classname: 'RenderTarget',

	/**
	 * @class The GL2.RenderTarget object is used to render a set of GL2.Nodes into a texture target.
	 * this target can then be attached to GL2.Animation.Frames and rendered attached to a GL2.Sprite or GL2.Primitive node.
	 *
	 * @constructs Constructs a new GL2.RenderTarget object.
	 * @param {Number} width Width of texture, must be power of two.
	 * @param {Number} height Height of texture, must be power of two.
	 * @param {bool} [isOpaque] When false (the default) the texture will include an alpha channel, when true the texture will be opaque.
	 */
	initialize: function (width, height, isOpaque, sizePolicy) {
		Core.ObjectRegistry.register(this);
		this._children = [];
		this._width = width;
		this._height = height;
		this._isOpaque = isOpaque ? true : false;
		this._createSendGen(this.__objectRegistryId, width, height, this._isOpaque);
		this._callbackIndexCounter = 1;
		this._callbacks = [];
	},

	/**
	 * Destroys the texture target.
	 */
	destroy: function () {
		var children = this._children;
		while (children.length) {
			this.removeChild(children[0]);
		}
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},

	/**
	 * Adds a GL2.Node object to the RenderTarget.  Visual changes will take effect on the next update.
	 * @param {GL2.Node} child Node to be added.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	addChild: function (child) {
		this._children.push(child);
		child._didAddToParent(this);
		this._addChildSendGen(Core.ObjectRegistry.objectToId(child));
		return this;
	},

	/**
	 * Removes a GL2.Node object from the RenderTarget. Visual changes will take effect on the next update.
	 * @param {GL2.Node} child Node to be removed.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	removeChild: function (child) {
		child._willRemoveFromParent();
		var index = this._children.indexOf(child);
		if (index === -1)
			throw new Error('removeChild called for a node that is not a child');
		this._children.splice(index, 1);
		this._removeChildSendGen(Core.ObjectRegistry.objectToId(child));
		return this;
	},

	/**
	 * Render all the currently attached GL2.Nodes into the texture target.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	update: function () {
		this._updateSendGen();
		return this;
	},

	/**
	 * Automatically render all currently attached GL2.Nodes every frame.
	 * This has the same effect as calling the update method on every frame.
	 * @param {bool} [autoUpdateEnable] Defaults to true, which causes the texture to be updated frame.  Set to false to stop auto updates.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	setAutoUpdate: function (autoUpdateEnable) {
		var enable = (autoUpdateEnable || (autoUpdateEnable === undefined)) ? true : false;
		this._setAutoUpdateSendGen(enable);
		return this;
	},

	/**
	 * Clear texture background before rendering.  By default the background is not cleared.
	 * @param {bool} [clearEnabled] Defaults to true, causing the texture to be cleared before nodes are drawn.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	setClearEnable : function (clearEnable) {
		var enable = (clearEnable || (clearEnable === undefined)) ? true : false;
		this._setClearEnableSendGen(enable);
		return this;
	},

	/**
	 * Set background color of texture.  Can be called with a single Core.color argument or 3 Number arguments.
	 * The default clear color is white.  If the RenderTarget has an alpha component it can be set via the setClearColorAlpha() method.
	 * @param {Number|Core.color} colorOrRed Opaque background color, or the red component if 3 or 4 parameters are given.
	 * @param {Number} [green] Green component of clear color (0, 1).
	 * @param {Number} [blue] Blue component of clear color (0, 1).
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	setClearColor : function () {
		var r, g, b, color;
		if (arguments.length === 1)
		{
			color = arguments[0];
			r = color.getRed();
			g = color.getGreen();
			b = color.getBlue();
		}
		else
		{
			r = arguments[0];
			g = arguments[1];
			b = arguments[2];
		}
		this._setClearColorSendGen(r, g, b);
		return this;
	},

	/**
	 * Set alpha component of background color of texture.
	 * The default clear alpha is 1, opaque.
	 * @param {Number} alpha background color opacity.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	setClearColorAlpha : function (alpha) {
		this._setClearColorAlphaSendGen(alpha);
		return this;
	},

	/**
	 * Save image to the filesystem.
	 * @param {String} filename name of bitmap.
	 * @param {Core.Rect} [rect] Image clip rectangle.  If not specfied the entire RenderTexture will be saved.
	 * @param {Function} [callback] A closure to be executed after image has been saved.  The resulting filename is passed as an argument.
	 */
	save : function (filename, rect, callback) {
		var id = 0;
		if (callback) {
			id = this._callbackIndexCounter++;
			this._callbacks[id] = callback;
		}
		var x = rect ? rect.getOrigin().getX() : -1;
		var y = rect ? rect.getOrigin().getY() : -1;
		var w = rect ? rect.getSize().getWidth() : -1;
		var h = rect ? rect.getSize().getHeight() : -1;
		this._saveSendGen(id, filename, x, y, w, h);
	},

	/**
	 * @private
	 */
	_invokeCallbackRecv: function (cmd)	{
		var msg = {};
		if (!this._invokeCallbackRecvGen(cmd, msg)) {
			return;
		}

		var id = msg.callbackId;
		var err = msg.error;
		if (!id) {
			NgLogE("invokeCallbackRecv command : bad id = " + id);
			return;
		}
		var cb = this._callbacks[id];
		if (!cb) {
			NgLogE("invokeCallbackRecv command : No registered callback found, id = " + id);
			return;
		}
		delete this._callbacks[id];
		cb(err);
	},

	/**
	 * Enable or disable backing store for RenderTarget. Disabled by default
	 * The backing store is used to guarantee that texture will be restored after the application is suspended and restored.
	 * If backing store is not enabled, then the texture is not guaranteed to render correctly after the application is restored.
	 * @param {Bool} [backingStoreEnable] If omitted backing store will be enabled.
	 */
	setBackingStoreEnable: function (backingStoreEnable) {
		var enable = (backingStoreEnable || (backingStoreEnable === undefined)) ? true : false;
		this._setBackingStoreEnableSendGen(enable);
		return this;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 353
	// Method create = -1
	// Method destroy = 2
	// Method addChild = 3
	// Method removeChild = 4
	// Method update = 5
	// Method setAutoUpdate = 6
	// Method setClearEnable = 7
	// Method setClearColor = 8
	// Method setClearColorAlpha = 9
	// Method save = 10
	// Method invokeCallback = 11
	// Method setBackingStoreEnable = 12
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 11:
					instance._invokeCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in RenderTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in RenderTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[353] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_invokeCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in RenderTarget.invokeCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in RenderTarget.invokeCallback from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in RenderTarget.invokeCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( objectRegistryId, width, height, isOpaque )
	{
		Core.Proc.appendToCommandString( ":353,-1," + objectRegistryId + "," + width + "," + height + "," + ( isOpaque ? 1 : 0 )  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":353,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_addChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":353,3," + this.__objectRegistryId + "," + child  );
	},
	
	/** @private */
	_removeChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":353,4," + this.__objectRegistryId + "," + child  );
	},
	
	/** @private */
	_updateSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":353,5," + this.__objectRegistryId );
	},
	
	/** @private */
	_setAutoUpdateSendGen: function( autoUpdateEnable )
	{
		Core.Proc.appendToCommandString( ":353,6," + this.__objectRegistryId + "," + ( autoUpdateEnable ? 1 : 0 )  );
	},
	
	/** @private */
	_setClearEnableSendGen: function( clearEnable )
	{
		Core.Proc.appendToCommandString( ":353,7," + this.__objectRegistryId + "," + ( clearEnable ? 1 : 0 )  );
	},
	
	/** @private */
	_setClearColorSendGen: function( r, g, b )
	{
		Core.Proc.appendToCommandString( ":353,8," + this.__objectRegistryId + "," + r + "," + g + "," + b  );
	},
	
	/** @private */
	_setClearColorAlphaSendGen: function( a )
	{
		Core.Proc.appendToCommandString( ":353,9," + this.__objectRegistryId + "," + a  );
	},
	
	/** @private */
	_saveSendGen: function( callbackId, filename, originX, originY, width, height )
	{
		Core.Proc.appendToCommandString( ":353,10," + this.__objectRegistryId + "," + callbackId + "," + Core.Base64.encode( filename ) + "," + originX + "," + originY + "," + width + "," + height  );
	},
	
	/** @private */
	_setBackingStoreEnableSendGen: function( backingStoreEnable )
	{
		Core.Proc.appendToCommandString( ":353,12," + this.__objectRegistryId + "," + ( backingStoreEnable ? 1 : 0 )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( objectRegistryId, width, height, isOpaque ) {}
	
	// destroy: function(  ) {}
	
	// addChild: function( child ) {}
	
	// removeChild: function( child ) {}
	
	// update: function(  ) {}
	
	// setAutoUpdate: function( autoUpdateEnable ) {}
	
	// setClearEnable: function( clearEnable ) {}
	
	// setClearColor: function( r, g, b ) {}
	
	// setClearColorAlpha: function( a ) {}
	
	// save: function( callbackId, filename, originX, originY, width, height ) {}
	
	// _invokeCallbackRecv: function( cmd ) {}
	// setBackingStoreEnable: function( backingStoreEnable ) {}
	

// {{/Wg Generated Code}}

});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2'] = exports; /**
 * <p>Classes and objects contained by the Physics2 module.</p>
 * @name Physics2
 * @namespace
 * @description <p>The Physics2 module is a collection of classes that control physics interaction between application bodies.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 * <li><code>{@link Physics2.Body}</code>: Construct objects that support physics interaction with other <code>Body</code> objects.</li>
 * <li><code>{@link Physics2.BoxShape}</code>: Construct a box collision shape.</li>
 * <li><code>{@link Physics2.CircleShape}</code>: Construct a circle collision shape.</li>
 * <li><code>{@link Physics2.Contact}</code>: Construct objects that store information about contact between two bodies.</li>
 * <li><code>{@link Physics2.DistanceJoint}</code>: Construct a distance joint that restricts the distance between two bodies.</li>
 * <li><code>{@link Physics2.Joint}</code>: A base class object for constructing <code>joint</code> objects.</li>
 * <li><code>{@link Physics2.MouseJoint}</code>: Construct a mouse joint that applies force at a specific location.</li>
 * <li><code>{@link Physics2.PolygonShape}</code>: Construct a polygon collision shape.</li>
 * <li><code>{@link Physics2.PrismaticJoint}</code>: Construct a prismatic joint that confines movement of two bodies along a specific axis.</li>
 * <li><code>{@link Physics2.Shape}</code>: A base class object for constructing <code>shape</code> objects.</li>
 * <li><code>{@link Physics2.WeldJoint}</code>: Construct a weld joint that holds two bodies completely stationary relative to each other.</li>
 * <li><code>{@link Physics2.World}</code>: Construct a physics world that contains bodies and allows simulation stepping.</li>
 * </ul>
 */
var Physics2 = exports.Physics2 = {};

Physics2.__defineGetter__("Body", function() {
	delete this.Body;
	return this.Body = require('NGCore/Client/Physics2/Body').Body;
});
Physics2.__defineGetter__("BoxShape", function() {
	delete this.BoxShape;
	return this.BoxShape = require('NGCore/Client/Physics2/BoxShape').BoxShape;
});
Physics2.__defineGetter__("CircleShape", function() {
	delete this.CircleShape;
	return this.CircleShape = require('NGCore/Client/Physics2/CircleShape').CircleShape;
});
Physics2.__defineGetter__("PolygonShape", function() {
	delete this.PolygonShape;
	return this.PolygonShape = require('NGCore/Client/Physics2/PolygonShape').PolygonShape;
});
Physics2.__defineGetter__("Shape", function() {
	delete this.Shape;
	return this.Shape = require('NGCore/Client/Physics2/Shape').Shape;
});
Physics2.__defineGetter__("World", function() {
	delete this.World;
	return this.World = require('NGCore/Client/Physics2/World').World;
});
Physics2.__defineGetter__("Joint", function() {
	delete this.Joint;
	return this.Joint = require('NGCore/Client/Physics2/Joint').Joint;
});
Physics2.__defineGetter__("DistanceJoint", function() {
	delete this.DistanceJoint;
	return this.DistanceJoint = require('NGCore/Client/Physics2/DistanceJoint').DistanceJoint;
});
Physics2.__defineGetter__("MouseJoint", function() {
	delete this.MouseJoint;
	return this.MouseJoint = require('NGCore/Client/Physics2/MouseJoint').MouseJoint;
});
Physics2.__defineGetter__("PrismaticJoint", function() {
	delete this.PrismaticJoint;
	return this.PrismaticJoint = require('NGCore/Client/Physics2/PrismaticJoint').PrismaticJoint;
});
Physics2.__defineGetter__("RevoluteJoint", function() {
	delete this.RevoluteJoint;
	return this.RevoluteJoint = require('NGCore/Client/Physics2/RevoluteJoint').RevoluteJoint;
});
Physics2.__defineGetter__("WeldJoint", function() {
	delete this.WeldJoint;
	return this.WeldJoint = require('NGCore/Client/Physics2/WeldJoint').WeldJoint;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Spring'] = function(){var exports = $MODULE_REGISTRY['Code/Spring'] || {}; $MODULE_REGISTRY['Code/Spring'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var Physics2 = require('NGCore/Client/Physics2').Physics2;

var GameConstants = require('Code/GameConstants').GameConstants;
var Vector2 = require('Code/util/Vector').Vector2;

var exports = {};

var Spring = Core.Class.subclass({
	initialize: function(json, world, node){
		this.m_body_a = null;
		this.m_pris_joint = null;
		this.m_distance_joint = null;
		this.m_sprite;
		this.m_json = json;
		this.m_default_length = json.scale.y;
		// create the physics body
		this.m_body = new Physics2.Body();
		this.m_body.setPosition(json.pos.x / GameConstants.BOX2D_SCALE, (GameConstants.ORIGINAL_WIDTH - json.pos.y) / GameConstants.BOX2D_SCALE);
		//this.m_body.setRotation(json.rot);
		this.m_body.setType(Physics2.Body.Type.Static);
		this.m_node = node;
		
		/*this.m_shape = new Physics2.BoxShape();
		this.m_shape.setSize(json.scale.x / GameConstants.BOX2D_SCALE, json.scale.y / GameConstants.BOX2D_SCALE);
		this.m_body.addShape(this.m_shape);
		*/
		
		
		world.addBody(this.m_body);
		
		if (json.texture != "" && json.texture != null) {
			this.m_sprite = new GL2.Sprite();
			json.texture = "/" + json.texture.replace(" ", "_");
			this.m_sprite.setImage(json.texture, [json.scale.x * GameConstants.HEIGHT_SCALE, json.scale.y * GameConstants.WIDTH_SCALE], [0.5, 1]);
			this.m_sprite.setPosition(json.pos.x * GameConstants.HEIGHT_SCALE, (GameConstants.ORIGINAL_WIDTH - json.pos.y) * GameConstants.WIDTH_SCALE);
			node.addChild(this.m_sprite);
			this.m_sprite.setColor(json.color.r, json.color.g, json.color.b);
			this.m_sprite.setRotation(json.rot);
		}
		
		this.json = this.m_json;
	},
	
	destroy: function(){
		if (this.m_pris_joint) {
			this.m_pris_joint.destroy();
		}
		if (this.m_distance_joint) {
			this.m_distance_joint.destroy();
		}
		if (this.m_sprite) {
			this.m_sprite.destroy();
		}
		this.m_body.destroy();
		
	},
	
	update: function(){
		// get the midpoint to position the sprite properly
		if (this.m_body_a != null && this.m_sprite != null) {
		
			var pos_a = this.m_body_a.body.getPosition();
			var pos_b = this.m_body.getPosition();
			var mid_x = pos_a.getX() + pos_b.getX() - this.m_body_a.shape.getSize().getHeight() / 2;
			mid_x = mid_x * GameConstants.HEIGHT_SCALE * GameConstants.BOX2D_SCALE / 2;
			var mid_y = pos_a.getY() + pos_b.getY();
			mid_y = mid_y * GameConstants.WIDTH_SCALE * GameConstants.BOX2D_SCALE / 2;
			this.m_sprite.setPosition(pos_b.getX() * GameConstants.HEIGHT_SCALE * GameConstants.BOX2D_SCALE, pos_b.getY() * GameConstants.WIDTH_SCALE * GameConstants.BOX2D_SCALE);
			var l = this.getSpriteLength();
			
			//		
			//		if (l == null) {
			//			l = this.m_default_length;
			//		}
			var s = (l * GameConstants.BOX2D_SCALE) / this.m_default_length;
			
			this.m_sprite.setScale(1, s);
		}
	},
	
	fallOut: function() {
		this.m_body.setType(Physics2.Body.Type.Dynamic);
		if (this.m_sprite && this.m_sprite.getParent() != null) {
			this.m_sprite.getParent().removeChild(this.m_sprite);
		}
	},
	
	reset: function() {
		this.m_body.setType(Physics2.Body.Type.Static);
		this.m_body.setPosition(this.json.pos.x / GameConstants.BOX2D_SCALE, (GameConstants.ORIGINAL_WIDTH - this.json.pos.y) / GameConstants.BOX2D_SCALE);
		if (this.m_sprite && this.m_sprite.getParent() == null) {
			this.m_node.addChild(this.m_sprite);
		}
	},
	
	attachBody: function(new_body, anchor_this, anchor_other){
		this.m_body_a = new_body;
		if (this.m_pris_joint == null) {
			this.m_pris_joint = new Physics2.PrismaticJoint();
			this.m_pris_joint.setBodyB(this.m_body);
			// TODO: joint locs
			this.m_distance_joint = new Physics2.DistanceJoint();
			this.m_distance_joint.setBodyB(this.m_body);
		}
//		var dir = Vector2.subtract(new Vector2(new_body.body.getPosition().getX(), new_body.body.getPosition().getY()), new Vector2(this.m_body.getPosition().getX(), this.m_body.getPosition().getY()));
//		console.log("EULER" + (dir.getNegativeRotation()));
//		this.m_sprite.setRotation(dir.getNegativeRotation());
		/*if (new_body.json.jointAxis.x == 1 && new_body.json.jointAxis.y == 0 && this.m_sprite != null) {
			this.m_sprite.setRotation(90);
		}*/
		/*this.m_pris_joint.setLocalAnchorA(anchor_other);
		this.m_pris_joint.setLocalAnchorB(anchor_this);
		this.m_distance_joint.setLocalAnchorA(anchor_other);
		this.m_distance_joint.setLocalAnchorB(anchor_this);*/
		this.m_pris_joint.setLocalAnchorA(new Core.Vector(0, 0));
		this.m_pris_joint.setLocalAnchorB(new Core.Vector(0, 0));
		this.m_distance_joint.setLocalAnchorA(new Core.Vector(0, 0));
		this.m_distance_joint.setLocalAnchorB(new Core.Vector(0, 0));
		this.m_distance_joint.setDampingRatio(this.m_body_a.json.jointDamping);
		this.m_distance_joint.setFrequency(this.m_body_a.json.jointStiffness);
		var v1 = new Vector2(this.m_body.getPosition().getX(), this.m_body.getPosition().getY());
		var v2 = new Vector2(this.m_body_a.body.getPosition().getX(), this.m_body_a.body.getPosition().getY());
		var v = Vector2.subtract(v1, v2);
		//v = v.rotated(this.m_body_a.body.getRotation() * 2 * Math.PI / 360).normalized(); // I have no idea why i have to do this.
		v = v.normalized();
		this.m_pris_joint.setLocalAxis(new Core.Vector(v.x, v.y));
		
		var l = this.getCurrentLength();
		this.m_distance_joint.setLength(l);
		this.m_pris_joint.setBodyA(this.m_body_a.body);
		this.m_distance_joint.setBodyA(this.m_body_a.body);
		console.log("Spring: " + v1.x + ", " + v1.y);
		console.log("BodyA: " + v2.x + ", " + v2.y);
		console.log("Axis of motion: " + this.m_pris_joint.getLocalAxis().getX() + ", " + this.m_pris_joint.getLocalAxis().getY());
		console.log("Length: " + l);
		
	},
	
	setDamping: function(newV) {
		this.m_distance_joint.setDampingRatio(newV);
	},
	
	setFreq: function(newV) {
		this.m_distance_joint.setFrequency(newV);
	},
	
	getCurrentLength: function(){
		if (this.m_body_a != null) {
			var x1 = this.m_body_a.body.getPosition().getX();
			var x2 = this.m_body.getPosition().getX();
			var y1 = this.m_body_a.body.getPosition().getY();
			var y2 = this.m_body.getPosition().getY();
			var xDiff = x1 - x2;
			var yDiff = y1 - y2;
			var l = Math.sqrt(xDiff * xDiff + yDiff * yDiff);
			return l;
		}
		return null;
	},
	
	getSpriteLength: function(){
		if (this.m_body_a != null) {
			var x1 = this.m_body_a.body.getPosition().getX();
			var x2 = this.m_body.getPosition().getX();
			var y1 = this.m_body_a.body.getPosition().getY();
			var y2 = this.m_body.getPosition().getY();
			var xDiff = x1 - x2;
			var yDiff = y1 - y2;
			var l = Math.sqrt(xDiff * xDiff + yDiff * yDiff) - this.m_body_a.shape.getSize().getHeight() / 2
			return l;
		}
		return null;
	},

});

exports.Spring = Spring;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Updaters'] = function(){var exports = $MODULE_REGISTRY['Code/Updaters'] || {}; $MODULE_REGISTRY['Code/Updaters'] = exports; var Core = require('NGCore/Client/Core').Core;
var Physics2 = require('NGCore/Client/Physics2').Physics2;
var exports = {};

var factoryDoor;

var theGateLever;
var theGateTarget;

var trapDoorCircle;

var underTheEyeBox0;
var underTheEyeBox1;

var pineForestBox1;

var targetFactoryDoor1;
var targetFactoryDoor2;

var candyMachineBox4;
var candyMachineBox6;

var tankBox18;
var tankObject1;
var tankObject2;

var chambersBox21;
var chambersBox24;
var chambersTarget;
var chambersLastRot;

var trashCompactorBox30;
var trashCompactorBox28;
var trashCompactorBox27;
var trashCompactorBox29;
var trashCompactorLever2;
var trashCompactorLever1;
var trashCompactorLever4;
var trashCompactorLever3;
var trashCompactorBox7;
var trashCompactorCannon;

var pinballSwitch0;
var pinballSwitch1;

var theClawRoot;
var theClawBalanceBar;

var enigmaticLeft;

var Updaters = Core.Class.subclass({
	
	$checkForUpdateFunction: function(obj, level_name, all_objects){
		var found = false;
		
		switch (level_name) {
			case ("Platformer"):{
				switch (obj.json.name) {
					case ("box0"):
					case ("box1"):
					{
						obj.updater = Updaters.platformerBox0;
						found = true;
						break;
					}
					case ("box2"):
					case ("box3"):
					{
						obj.updater = Updaters.platformerBox2;
						found = true;
						break;
					}
					case ("box4"):
					case ("box5"):
					{
						obj.updater = Updaters.platformerBox4;
						found = true;
						break;
					}
				}
				break;
			}
			case ("Factory"):{
				if (obj.json.name == "box16") {
					obj.updater = Updaters.factory;
					factoryDoor = Updaters.findObject(all_objects, "door");
					found = true;
				}
				break;
			}
			case ("Boulder"):{
				if (obj.json.name == "target") {
					obj.updater = Updaters.boulder;
					found = true;
				}
				break;
			}
			case ("The Gate"):{
				if (obj.json.name == "box7") {
					obj.updater = Updaters.theGate;
					found = true;
					theGateLever = Updaters.findObject(all_objects, "box0");
					theGateTarget = Updaters.findObject(all_objects, "target");
					theGateTarget.body.setIsSleepingAllowed(false);
				}
				break;
			}
			case ("Trap Door"):{
				switch (obj.json.name) {
					case ("box1"):{
						obj.updater = Updaters.trapDoorBox1;
						trapDoorCircle = Updaters.findObject(all_objects, "circle0");
						Updaters.findObject(all_objects, "box0").body.setIsSleepingAllowed(false);
						found = true;
						break;
					}
					case ("box2"):{
						obj.updater = Updaters.trapDoorBox2;
						found = true;
						break;
					}
				}
				break;
			}
			case ("Under the Eye"):{
				switch (obj.json.name) {
					case ("box9"):{
						obj.updater = Updaters.underTheEyeBox9;
						underTheEyeBox0 = Updaters.findObject(all_objects, "box0");
						Updaters.findObject(all_objects, "target").body.setIsSleepingAllowed(false);
						found = true;
						break;
					}
					case ("box4"):{
						obj.updater = Updaters.underTheEyeBox4;
						underTheEyeBox1 = Updaters.findObject(all_objects, "box1");
						found = true;
						break;
					}
				}
				break;
			}
			case ("Pine Forest"):{
				switch (obj.json.name) {
					case ("target"): {
						obj.updater = Updaters.pineForestTarget;
						pineForestBox1 = Updaters.findObject(all_objects, "box1");
						found = true;
						break;	
					}
					case ("box2"):{
						obj.updater = Updaters.pineForestBox2;
						found = true;
						break;
					
					}
					
				}
				break;
			}
			case ("Target Factory"):{
				switch (obj.json.name) {
					case ("target"):{
						obj.updater = Updaters.targetFactoryTarget;
						found = true;
						break;
					}
					case("box35"): {
						obj.updater = Updaters.targetFactoryBox35;
						targetFactoryDoor1 = Updaters.findObject(all_objects, "door1");
						targetFactoryDoor2 = Updaters.findObject(all_objects, "door2");
						targetFactoryDoor1.body.setIsSynchronized(true);
						targetFactoryDoor2.body.setIsSynchronized(true);
						found = true;
						break;
					}
				}
				break;
			}
			
			case ("Pinwheel"):{
				if (obj.json.name == "ball2") {
					obj.updater = Updaters.pinwheel;
					found = true;
				}
				break;
			}
			case ("Candy Machine"):{
				switch (obj.json.name) {
					case ("box7"):{
						obj.updater = Updaters.candyMachineBox7;
						candyMachineBox4 = Updaters.findObject(all_objects, "box4");
						Updaters.findObject(all_objects, "circle0").body.setIsSleepingAllowed(false);
						Updaters.findObject(all_objects, "circle7").body.setIsSleepingAllowed(false);
						Updaters.findObject(all_objects, "circle6").body.setIsSleepingAllowed(false);
						Updaters.findObject(all_objects, "circle4").body.setIsSleepingAllowed(false);
						Updaters.findObject(all_objects, "circle1").body.setIsSleepingAllowed(false);
						Updaters.findObject(all_objects, "circle5").body.setIsSleepingAllowed(false);
						Updaters.findObject(all_objects, "circle2").body.setIsSleepingAllowed(false);
						Updaters.findObject(all_objects, "circle3").body.setIsSleepingAllowed(false);
						Updaters.findObject(all_objects, "target").body.setIsSleepingAllowed(false);
						found = true;
						break;
					}
					case ("box15"):{
						obj.updater = Updaters.candyMachineBox15;
						candyMachineBox6 = Updaters.findObject(all_objects, "box6");
						found = true;
						break;
					}
				}
				
				break;
			}
			case ("Tank"):{
			
				if (obj.json.name == "box7") {
					obj.updater = Updaters.tank;
					tankBox18 = Updaters.findObject(all_objects, "box18");
					tankObject2 = Updaters.findObject(all_objects, "object2");
					tankObject1 = Updaters.findObject(all_objects, "object1");
					found = true;
				}
				else if (obj.json.name == "box13") {
					Updaters.findObject(all_objects, "circle0").body.setIsSleepingAllowed(false);
					found = true;	
				}
				break;
			}
			case ("Chambers"):{
				switch (obj.json.name) {
					case ("lever"):{
						obj.updater = Updaters.chambersLever;
						chambersBox21 = Updaters.findObject(all_objects, "box21");
						chambersBox24 = Updaters.findObject(all_objects, "box24");
						chambersTarget = Updaters.findObject(all_objects, "target");
						found = true;
						break;
					}
					case ("box24"):{
						obj.updater = Updaters.chambersBox;
						found = true;
						break;
					}
					case ("cannon"):{
						obj.updater = Updaters.chambersCannon;
						found = true;
						break;
					}
				}
			
				break;
			}
			case ("The Claw"):{
				switch (obj.json.name) {
					case ("claw_low_right"):{
						obj.updater = Updaters.theClawLowRight;
						theClawRoot = Updaters.findObject(all_objects, "claw_root");
						theClawBalanceBar = Updaters.findObject(all_objects, "balancebar");
						found = true;
						break;
					}
					case ("claw_low_left"):{
						obj.updater = Updaters.theClawLowLeft;
						found = true;
						break;
					}
					case ("claw_up_left"):
					case ("claw_up_right"):{
						obj.updater = Updaters.theClawUpper;
						found = true;
						break;
					}
					case ("circle0"):{
						found = true;
						break;
					}
				}
				break;
			}
			case ("Trash Compactor"):{
				switch (obj.json.name) {
					case ("box4"):{
						obj.updater = Updaters.trashCompactorBox4;
						trashCompactorBox30 = Updaters.findObject(all_objects, "box30");
						found = true;
						
						break;
					}
					case ("box5"):{
						obj.updater = Updaters.trashCompactorBox5;
						trashCompactorBox28 = Updaters.findObject(all_objects, "box28");
						found = true;
						break;
					}
					case ("box6"):{
						obj.updater = Updaters.trashCompactorBox6;
						trashCompactorBox27 = Updaters.findObject(all_objects, "box27");
						found = true;
						break;
					}
					case ("box7"):{
						obj.updater = Updaters.trashCompactorBox7;
						trashCompactorBox29 = Updaters.findObject(all_objects, "box29");
						found = true;
						break;
					}
					case ("door2"):{
						obj.updater = Updaters.trashCompactorDoor2;
						trashCompactorLever2 = Updaters.findObject(all_objects, "lever2");
						found = true;
						break;
					}
					case ("door4"):{
						obj.updater = Updaters.trashCompactorDoor4;
						trashCompactorLever4 = Updaters.findObject(all_objects, "lever4");
						found = true;
						break;
					}
					case ("door3"):{
						obj.updater = Updaters.trashCompactorDoor3;
						trashCompactorLever3 = Updaters.findObject(all_objects, "lever3");
						found = true;
						break;
					}
					case ("door1"):{
						obj.updater = Updaters.trashCompactorDoor1;
						trashCompactorLever1 = Updaters.findObject(all_objects, "lever1");
						found = true;
						break;
					}
					case ("door5"):{
						obj.updater = Updaters.trashCompactorDoor5;
						trashCompactorBox7 = Updaters.findObject(all_objects, "box7");
						trashCompactorCannon = Updaters.findObject(all_objects, "cannon");
						found = true;
						break;
					}
				}
				break;
			}
			case ("Equilibrium"):{
				switch (obj.json.name) {
					case ("target"):
					case ("circle0"):
					case ("circle1"):
					case ("circle2"):
					case ("circle3"):
					case ("circle4"):
					case ("circle5"): {
						obj.updater = Updaters.equilibriumLeft;
						found = true;
						break;
					}
				}
				break;
			}
			case ("Heavyweight"):{
				if (obj.json.name == "box3") {
					obj.updater = Updaters.heavyweight;
					found = true;
				}
				break;
			}
			case ("Pinball"):{
				switch (obj.json.name) {
					case ("switch0"):{
						obj.updater = Updaters.pinballSwitch;
						pinballSwitch0 = obj;
						found = true;
						break;
					}
					case ("box24"):{
						obj.updater = Updaters.pinballLeftFlipper;
						found = true;
						break;
					}
					case ("switch1"):{
						obj.updater = Updaters.pinballSwitch;
						pinballSwitch1 = obj;
						found = true;
						break;
					}
					case ("box1"):{
						obj.updater = Updaters.pinballRightFlipper;
						found = true;
						break;
					}
				}
				break;
			}
			case ("Ricochet"):{
				if (obj.json.name == "box8") {
					obj.updater = Updaters.ricochet;
					found = true;
				}
				break;
			}
			case ("Bucket"):{
				if (obj.json.name == "box11") {
					obj.updater = Updaters.bucket;
					found = true;
				}
			}
			case ("Racer"):{
				switch (obj.json.name) {
					case ("box3"):{
						obj.updater = Updaters.racerBox3;
						found = true;
						break;
					}
					case ("box2"):{
						obj.updater = Updaters.racerBox2;
						found = true;
						break;
					}
				}
				break;
			}
			case ("Hanging Out"):{
				switch (obj.json.name) {
					case ("box9"):
					case ("box8"): {
						obj.updater = Updaters.hangingOutBox9;
						found = true;
						break;
					}
				}
				break;
			}
			case ("Tuber"):{
				switch (obj.json.name) {
					case ("box9"):{
						obj.updater = Updaters.tuberBox9;
						found = true;
						break;
					}
					case ("box7"):
					case ("box8"):{
						obj.updater = Updaters.tuberLower;
						found = true;
						break;
					}
				}
				break;
			}
			case ("Enigmatic"):{
				switch (obj.json.name) {
					case ("box0"):{
						obj.updater = Updaters.enigmatic;
						enigmaticLeft = Updaters.findObject(all_objects, "left");
						found = true;
						break;
					}
				}
				
			}
		}
		
		return found;
	},
	
	$findObject: function(objects, object_name) {
		for (var idx = 0; idx < objects.length; idx++) {
			if (objects[idx].json != null && objects[idx].json.name == object_name) {
				return objects[idx];
			}
		}
		console.log("COULD NOT FIND OBJECT WITH NAME: " + object_name);
	},
	
	$platformerBox0: function(obj, delta){
		
		var pos = obj.body.getPosition();
		pos.setX(pos.getX() * GameConstants.BOX2D_SCALE);
		pos.setY(pos.getY() * GameConstants.BOX2D_SCALE);
		pos.setY(pos.getY() - 200 * (delta / 1000));
		if (pos.getY() < -32) {
			pos.setY(352);
		}
		obj.sprite.setPosition(pos.getX() * GameConstants.HEIGHT_SCALE, pos.getY() * GameConstants.WIDTH_SCALE);
		obj.body.setPosition(pos.getX() / GameConstants.BOX2D_SCALE, pos.getY() / GameConstants.BOX2D_SCALE);
	},
	
	$platformerBox2: function(obj, delta){

		var pos = obj.body.getPosition();
		pos.setX(pos.getX() * GameConstants.BOX2D_SCALE);
		pos.setY(pos.getY() * GameConstants.BOX2D_SCALE);
		pos.setY(pos.getY() - 100 * (delta / 1000));
		if (pos.getY() < -32) {
			pos.setY(352);
		}
		obj.sprite.setPosition(pos.getX() * GameConstants.HEIGHT_SCALE, pos.getY() * GameConstants.WIDTH_SCALE);
		obj.body.setPosition(pos.getX() / GameConstants.BOX2D_SCALE, pos.getY() / GameConstants.BOX2D_SCALE);
		
	},
	
	$platformerBox4: function(obj, delta){

		var pos = obj.body.getPosition();
		pos.setX(pos.getX() * GameConstants.BOX2D_SCALE);
		pos.setY(pos.getY() * GameConstants.BOX2D_SCALE);
		pos.setY(pos.getY() + 100 * (delta / 1000));
		if (pos.getY() > 352) {
			pos.setY(-32);
		}
		obj.sprite.setPosition(pos.getX() * GameConstants.HEIGHT_SCALE, pos.getY() * GameConstants.WIDTH_SCALE);
		obj.body.setPosition(pos.getX() / GameConstants.BOX2D_SCALE, pos.getY() / GameConstants.BOX2D_SCALE);
		

	},
	
	$factory: function(obj, delta){

		if (obj.body.getRotation() >= -20) {
			factoryDoor.body.setType(Physics2.Body.Type.Static);
			factoryDoor.body.setPosition(182 / GameConstants.BOX2D_SCALE, 186 / GameConstants.BOX2D_SCALE);
			factoryDoor.body.setRotation(0);
		}
		else {
			factoryDoor.body.setType(Physics2.Body.Type.Dynamic);
			factoryDoor.shape.setDensity(1);
			factoryDoor.body.setIsSynchronized(true);
		}
		pos = factoryDoor.body.getPosition();
		factoryDoor.sprite.setPosition(pos.getX() * GameConstants.BOX2D_SCALE * GameConstants.HEIGHT_SCALE, pos.getY() * GameConstants.BOX2D_SCALE * GameConstants.WIDTH_SCALE);
		factoryDoor.sprite.setRotation(factoryDoor.body.getRotation());
		
	},
	
	$boulder: function(obj, delta){

		var pos = obj.body.getPosition();
		if (pos.getX() + obj.getShape().getRadius() > (Core.Capabilities.getScreenHeight()) / GameConstants.BOX2D_SCALE) {
			pos.setX(-24 / GameConstants.BOX2D_SCALE);
			pos.setY(182 / GameConstants.BOX2D_SCALE);
			obj.body.setPosition(pos.getX(), pos.getY());
			obj.body.setLinearVelocity(0, 0); // kill the velocity so the target isn't hauling ass
		}
	},
	
	$theGate: function(obj, delta){

		var r = theGateLever.body.getRotation() - 17;
		obj.body.setPosition(371 / GameConstants.BOX2D_SCALE, (161 - r * -1.35) / GameConstants.BOX2D_SCALE);
		obj.sprite.setPosition(obj.body.getPosition().getX() * GameConstants.BOX2D_SCALE * GameConstants.HEIGHT_SCALE, obj.body.getPosition().getY() * GameConstants.BOX2D_SCALE * GameConstants.WIDTH_SCALE);
	},
	
	$trapDoorBox1: function(obj, delta){

		var r = trapDoorCircle.body.getRotation();
		r = Math.max(r, 0);
		obj.body.setRotation(r / 1.25);
		obj.sprite.setRotation(r / 1.25);
	
	},
	
	$trapDoorBox2: function(obj, delta){
		var r = trapDoorCircle.body.getRotation();
		r = Math.max(r, 0);
		obj.body.setRotation(-r / 1.25);
		obj.sprite.setRotation(-r / 1.25);
	},
	
	$underTheEyeBox4: function(obj, delta){
		var loc = underTheEyeBox1.body.getPosition();
		var pos = new Core.Point();
		pos.setX(loc.getX() * GameConstants.BOX2D_SCALE);
		pos.setY(loc.getY() * GameConstants.BOX2D_SCALE);
		var a = pos.getX() - 351;
		a = a * 3;
		a = Math.max(a, 0);
		a = Math.min(a, 90);
		obj.body.setRotation(-a);
		obj.sprite.setRotation(-a);
		
	},
	
	$underTheEyeBox9: function(obj, delta){
		var loc = underTheEyeBox0.body.getPosition();
		var pos = new Core.Point();
		pos.setX(loc.getX() * GameConstants.BOX2D_SCALE);
		pos.setY(loc.getY() * GameConstants.BOX2D_SCALE);
		var a = pos.getX() - 351;
		a = a * 3;
		a = Math.max(a, 0);
		a = Math.min(a, 90);
		obj.body.setRotation(a);
		obj.sprite.setRotation(a);
		
	},
	
	$pineForestTarget: function(obj, delta){
		
		var pos = pineForestBox1.body.getPosition();
		var offset = pos.getY() * GameConstants.BOX2D_SCALE - 107;
		obj.body.setPosition(447 / GameConstants.BOX2D_SCALE, (196 - offset) / GameConstants.BOX2D_SCALE);
		console.log("target is now at : " + obj.body.getPosition().getX() + ", " + obj.body.getPosition().getY());
	},
	
	$pineForestBox2: function(obj, delta){
		var pos = pineForestBox1.body.getPosition();
		var offset = pos.getY() * GameConstants.BOX2D_SCALE - 107;
		obj.body.setPosition(447 / GameConstants.BOX2D_SCALE, (69 - offset) / GameConstants.BOX2D_SCALE);
		console.log("Box 2 is now at : " + obj.body.getPosition().getX() + ", " + obj.body.getPosition().getY());
	},
	
	$targetFactoryTarget: function(obj, delta){
		var i = (new Date().getTime() / 1000) % 2;
		if (i > 1) {
			i = 1 - (i - 1);
		}
		i = 1 - i * 0.4;
		obj.getSprite().setColor(i, 0, 0);
		
		var shape = obj.getShape();
		if (shape.getDensity() < 1 && obj.getBody().getPosition().getX() < 36 / GameConstants.BOX2D_SCALE) {
			shape.setDensity(1);
		}
	},
	
	$targetFactoryBox35: function(obj, delta){
		if (obj.body.getRotation() > 18) {
			targetFactoryDoor1.shape.setDensity(0.1);
			targetFactoryDoor1.body.setType(Physics2.Body.Type.Dynamic);
			targetFactoryDoor2.shape.setDensity(0.1);
			targetFactoryDoor2.body.setType(Physics2.Body.Type.Dynamic);
		}
		targetFactoryDoor2.sprite.setPosition(targetFactoryDoor2.body.getPosition().getX() * GameConstants.BOX2D_SCALE * GameConstants.HEIGHT_SCALE, targetFactoryDoor2.body.getPosition().getY() * GameConstants.BOX2D_SCALE * GameConstants.WIDTH_SCALE);
		targetFactoryDoor2.sprite.setRotation(targetFactoryDoor2.body.getRotation());
		targetFactoryDoor1.sprite.setPosition(targetFactoryDoor1.body.getPosition().getX() * GameConstants.BOX2D_SCALE * GameConstants.HEIGHT_SCALE, targetFactoryDoor1.body.getPosition().getY() * GameConstants.BOX2D_SCALE * GameConstants.WIDTH_SCALE);
		targetFactoryDoor1.sprite.setRotation(targetFactoryDoor1.body.getRotation());
		
	},
	
	$pinwheel: function(obj, delta){
		if (obj.body.getPosition().getY() > 352 / GameConstants.BOX2D_SCALE) {
			obj.body.setPosition(120 / GameConstants.BOX2D_SCALE, -32 / GameConstants.BOX2D_SCALE);
		}
	},
	
	$candyMachineBox7: function(obj, delta){
		var pos = candyMachineBox4.body.getPosition();
		var offset = pos.getY() * GameConstants.BOX2D_SCALE - 174;
		obj.body.setPosition(124 / GameConstants.BOX2D_SCALE, (147 + offset) / GameConstants.BOX2D_SCALE);
		obj.sprite.setPosition(124 * GameConstants.HEIGHT_SCALE, (147 + offset) * GameConstants.WIDTH_SCALE);
		
	},
	
	$candyMachineBox15: function(obj, delta){
		var pos = candyMachineBox6.body.getPosition();
		var offset = pos.getY() * GameConstants.BOX2D_SCALE - 174;
		obj.body.setPosition(274 / GameConstants.BOX2D_SCALE, (147 + offset) / GameConstants.BOX2D_SCALE);
		obj.sprite.setPosition(274 * GameConstants.HEIGHT_SCALE, (147 + offset) * GameConstants.WIDTH_SCALE);
	},
	
	$tank: function(obj, delta){
		
		if (obj.body.getRotation() < 0  && tankObject1.joint.getMotorSpeed() == 0) {
			tankObject1.joint.setMotorSpeed(2);
			tankObject1.joint.setEnableMotor(true);
			tankObject2.joint.setMotorSpeed(2);
			tankObject2.joint.setEnableMotor(true);
			tankObject1.body.setType(Physics2.Body.Type.Dynamic);
			tankObject2.body.setType(Physics2.Body.Type.Dynamic);
			tankObject1.joint.setMaxMotorTorque(1000000);
			tankObject2.joint.setMaxMotorTorque(1000000);
			tankBox18.shape.setDensity(10);
			tankBox18.body.setType(Physics2.Body.Type.Dynamic);
			tankBox18.body.setIsSynchronized(true);
			tankObject1.body.setIsSynchronized(true);
			tankObject2.body.setIsSynchronized(true);
		}
		tankBox18.sprite.setPosition(tankBox18.body.getPosition().getX() * GameConstants.BOX2D_SCALE * GameConstants.HEIGHT_SCALE, tankBox18.body.getPosition().getY() * GameConstants.BOX2D_SCALE * GameConstants.WIDTH_SCALE);
		tankBox18.sprite.setRotation(tankBox18.body.getRotation());
		tankObject1.sprite.setPosition(tankObject1.body.getPosition().getX() * GameConstants.BOX2D_SCALE * GameConstants.HEIGHT_SCALE, tankObject1.body.getPosition().getY() * GameConstants.BOX2D_SCALE * GameConstants.WIDTH_SCALE);
		tankObject1.sprite.setRotation(tankObject1.body.getRotation());
		tankObject2.sprite.setPosition(tankObject2.body.getPosition().getX() * GameConstants.BOX2D_SCALE * GameConstants.HEIGHT_SCALE, tankObject2.body.getPosition().getY() * GameConstants.BOX2D_SCALE * GameConstants.WIDTH_SCALE);
		tankObject2.sprite.setRotation(tankObject2.body.getRotation());
	},
	
	$chambersLever: function(obj, delta){
		var r = obj.body.getRotation();
		if (r > 35) {
			var r1 = chambersBox21.body.getRotation();
			var new_rot = r1 + delta / 20;
			chambersBox21.body.setRotation(new_rot);
			chambersBox24.body.setRotation(new_rot);
			var pos = chambersTarget.body.getPosition();
			chambersTarget.body.setPosition(pos.getX(), Math.min(pos.getY() + (4 * delta / 1000) / GameConstants.BOX2D_SCALE, 170 / GameConstants.BOX2D_SCALE));
		}
	},
	
	$chambersBox: function(obj, delta){
		if (!chambersLastRot) {
			chambersLastRot = 0;
		}
		
		var rot = obj.body.getRotation();
		var d = rot - chambersLastRot;
		if (Math.abs(d) > 180) {
			if (d < 0) {
				d = -(-360 - d);
			}
			else {
				d = -(360 - d);
			}
		}
		chambersLastRot = rot;
		var p = chambersTarget.body.getPosition();
		p.setY(Math.max(142 / GameConstants.BOX2D_SCALE, Math.min(164 / GameConstants.BOX2D_SCALE, p.getY() - (d * 0.05) / GameConstants.BOX2D_SCALE)));
		chambersTarget.body.setPosition(p.getX(), p.getY());
	},
	
	$chambersCannon: function(obj, delta){
		obj.body.setPosition(obj.body.getPosition().getX(), (160 * (1 + Math.cos(new Date().getTime() / 1000))) / GameConstants.BOX2D_SCALE);
		obj.update();
	},
	
	$updateObjectSprite: function(obj) {
		obj.sprite.setPosition(obj.body.getPosition().getX() * GameConstants.BOX2D_SCALE * GameConstants.HEIGHT_SCALE, obj.body.getPosition().getY() * GameConstants.BOX2D_SCALE * GameConstants.WIDTH_SCALE);
		obj.sprite.setRotation(obj.body.getRotation() + obj.shape.getRotation());
	},
	
	$trashCompactorBox4: function(obj, delta){
		var pos = obj.body.getPosition();
		var dx = delta / 100;
		if (pos.getX() < 240 / GameConstants.BOX2D_SCALE) {
			obj.body.setPosition(pos.getX() + dx / GameConstants.BOX2D_SCALE, pos.getY());
			Updaters.updateObjectSprite(obj);
			var pos1 = trashCompactorBox30.body.getPosition();
			trashCompactorBox30.body.setPosition(pos1.getX() + dx / GameConstants.BOX2D_SCALE, pos1.getY());
			Updaters.updateObjectSprite(trashCompactorBox30);
		}
	},
	
	$trashCompactorBox5: function(obj, delta){
		var pos = obj.body.getPosition();
		var dx = delta / 100;
		if (pos.getX() < 206 / GameConstants.BOX2D_SCALE) {
			obj.body.setPosition(pos.getX() + dx / GameConstants.BOX2D_SCALE, pos.getY());
			Updaters.updateObjectSprite(obj);
			var pos1 = trashCompactorBox28.body.getPosition();
			trashCompactorBox28.body.setPosition(pos1.getX() + dx / GameConstants.BOX2D_SCALE, pos1.getY());
			Updaters.updateObjectSprite(trashCompactorBox28);
		}
	},
	
	$trashCompactorBox6: function(obj, delta){
		var pos = obj.body.getPosition();
		var dx = delta / -100;
		if (pos.getX() > 281 / GameConstants.BOX2D_SCALE) {
			obj.body.setPosition(pos.getX() + dx / GameConstants.BOX2D_SCALE, pos.getY());
			Updaters.updateObjectSprite(obj);
			var pos1 = trashCompactorBox27.body.getPosition();
			trashCompactorBox27.body.setPosition(pos1.getX() + dx / GameConstants.BOX2D_SCALE, pos1.getY());
			Updaters.updateObjectSprite(trashCompactorBox27);
		}
	},
	
	$trashCompactorBox7: function(obj, delta){
		var pos = obj.body.getPosition();
		var dx = delta / -100;
		if (pos.getX() > 250 / GameConstants.BOX2D_SCALE) {
			obj.body.setPosition(pos.getX() + dx / GameConstants.BOX2D_SCALE, pos.getY());
			Updaters.updateObjectSprite(obj);
			var pos1 = trashCompactorBox29.body.getPosition();
			trashCompactorBox29.body.setPosition(pos1.getX() + dx / GameConstants.BOX2D_SCALE, pos1.getY());
			Updaters.updateObjectSprite(trashCompactorBox29);
		}
	},
	
	$trashCompactorDoor2: function(obj, delta){
		var d = obj.shape.getDensity();
		var r = trashCompactorLever2.body.getRotation();
		
		if (r > 30 && d == 0) {
			obj.shape.setDensity(1);
			obj.body.setType(Physics2.Body.Type.Dynamic);
			obj.body.setIsSynchronized(true);
		}
		Updaters.updateObjectSprite(obj);
	},
	
	$trashCompactorDoor4: function(obj, delta){
		var d = obj.shape.getDensity();
		var r = trashCompactorLever4.body.getRotation();
		
		if (r < -25 && d == 0) {
			obj.shape.setDensity(1);
			obj.body.setType(Physics2.Body.Type.Dynamic);
			obj.body.setIsSynchronized(true);
		}
		Updaters.updateObjectSprite(obj);
	},
	
	
	$trashCompactorDoor3: function(obj, delta){
		var d = obj.shape.getDensity();
		var r = trashCompactorLever3.body.getRotation();
		
		if (r < -25 && d == 0) {
			obj.shape.setDensity(1);
			obj.body.setType(Physics2.Body.Type.Dynamic);
			obj.body.setIsSynchronized(true);
		}
		Updaters.updateObjectSprite(obj);
	},
	
	
	$trashCompactorDoor1: function(obj, delta){
		var d = obj.shape.getDensity();
		var r = trashCompactorLever1.body.getRotation();
		//console.log("1: " + r);
		
		if (r > 30 && d == 0) {
			obj.shape.setDensity(1);
			obj.body.setType(Physics2.Body.Type.Dynamic);
			obj.body.setIsSynchronized(true);
		}
		Updaters.updateObjectSprite(obj);
	},
	
	
	$trashCompactorDoor5: function(obj, delta){
		var b = trashCompactorBox7.body.getPosition();
		if (b.getX() <= 320 / GameConstants.BOX2D_SCALE && obj.shape.getDensity() == 0) {
			obj.shape.setDensity(1);
			obj.body.setType(Physics2.Body.Type.Dynamic);
			obj.body.setIsSynchronized(true);
			trashCompactorCannon.body.setIsSynchronized(true);
			trashCompactorCannon.setDensity(1);
			trashCompactorCannon.body.setType(Physics2.Body.Type.Dynamic);
		}
		Updaters.updateObjectSprite(obj); 
		trashCompactorCannon.update(); 
	},
	
	$equilibriumLeft: function(obj, delta){
		if (obj.body.getPosition().getY() > 353 / GameConstants.BOX2D_SCALE && obj.body.getPosition().getX() > 240 / GameConstants.BOX2D_SCALE) {
			obj.body.setPosition(40 / GameConstants.BOX2D_SCALE, -20 / GameConstants.BOX2D_SCALE);
		}
	},
	
	$heavyweight: function(obj, delta){
		var r = obj.body.getRotation();
		obj.joint.setEnableMotor(true);
		obj.joint.setMaxMotorTorque(11262.4);
		obj.joint.setMotorSpeed(0);
	},
	
	$pinballSwitch: function(obj, delta) {
		var r = obj.body.getRotation();
		/*if (!obj.joint.getEnableMotor()) {
			obj.joint.setEnableMotor(true);
			obj.joint.setMaxMotorTorque(1000000);
		}*/
		//obj.joint.setMotorSpeed(0);
		if (Math.abs(r) > 5) {
			obj.joint.setEnableMotor(true);
			obj.joint.setMaxMotorTorque(0.5);
			var speed = r * 0.1;
			obj.joint.setMotorSpeed(speed);
		}
		else {
			obj.joint.setEnableMotor(false);
			
		}
	},
	
	$pinballLeftFlipper: function(obj, delta){
		if (pinballSwitch0.body.getRotation() < -20) {
			obj.joint.setEnableMotor(true);
			obj.joint.setMaxMotorTorque(10000000);
			obj.joint.setMotorSpeed(4);
		}
		else if(obj.body.getRotation() < -45) {
			obj.joint.setEnableMotor(false);
		}
	},
	
	$pinballRightFlipper: function(obj, delta){
		if (pinballSwitch1.body.getRotation() > 20) {
			obj.joint.setEnableMotor(true);
			obj.joint.setMaxMotorTorque(10000000);
			obj.joint.setMotorSpeed(-4);
		}
		else if (obj.body.getRotation() > 45) {
			obj.joint.setEnableMotor(false);	
		}
	},
	
	$ricochet: function(obj, delta){
		obj.joint.setEnableMotor(true);
		obj.joint.setMaxMotorTorque(3000);
		obj.joint.setMotorSpeed(.1);
	},
	
	$bucket: function(obj, delta){
		obj.joint.setEnableMotor(true);
		obj.joint.setMaxMotorTorque(10146);
		if (obj.body.getRotation() < 0) {
			obj.joint.setMotorSpeed(-0.2);
		}
		else {
			obj.joint.setMotorSpeed(0);
		}
	},
	
	$racerBox3: function(obj, delta) {
		obj.joint.setEnableMotor(true);
		if (obj.body.getRotation() < 10) {
			obj.joint.setMotorSpeed(0);
			obj.joint.setMaxMotorTorque(1);
		}
		else {
			obj.joint.setMotorSpeed(1);
		}
		
	},
	
	$racerBox2: function(obj, delta){
		obj.joint.setEnableMotor(true);
		obj.joint.setMotorSpeed(0);
		obj.joint.setMaxMotorTorque(1);
	},
	
	$hangingOutBox9: function(obj, delta){
		var r = obj.body.getRotation();
		if (Math.abs(r) > 1) {
			obj.joint.setEnableMotor(true);
			obj.joint.setMaxMotorTorque(8);
			var speed = r * 0.05;
			obj.joint.setMotorSpeed(speed);
		}
		else {
			obj.joint.setEnableMotor(false);
		}
	},
	
	$theClawLowRight: function(obj, delta){
		var pos = obj.body.getPosition();
		if (pos.getY() > 90 / GameConstants.BOX2D_SCALE && pos.getX() > 450 / GameConstants.BOX2D_SCALE) {
			obj.joint.setEnableMotor(false);
			obj.joint.setEnableLimit(false);
		}
		else {
			var r = obj.body.getRotation();
			// make r relative to the root;
			r -= theClawRoot.body.getRotation();
			if (r > 2) {
				obj.joint.setMotorSpeed(0.3);
			}
			else if (r < -2) {
				obj.joint.setMotorSpeed(-0.3);
			}
			else {
				obj.joint.setMotorSpeed(0);
			}
			obj.joint.setEnableMotor(true);
			obj.joint.setMaxMotorTorque(50);
			obj.joint.setEnableLimit(true);
			obj.joint.setLowerRotation(0);
			obj.joint.setUpperRotation(180);
		}
		
		if (theClawBalanceBar.joint) {
			theClawBalanceBar.joint.setEnableLimit(true);
			theClawBalanceBar.joint.setLowerRotation(-35);
			theClawBalanceBar.joint.setUpperRotation(35);
		}
	},
	
	$theClawLowLeft: function(obj, delta){
		var pos = obj.body.getPosition();
		if (pos.getY() > 90 / GameConstants.BOX2D_SCALE && pos.getX() > 390 / GameConstants.BOX2D_SCALE) {
			obj.joint.setEnableMotor(false);
			obj.joint.setEnableLimit(false);
		}
		else {
			var r = obj.body.getRotation();
			// make r relative to the root;
			r -= theClawRoot.body.getRotation();
			if (r > 2) {
				obj.joint.setMotorSpeed(0.3);
			}
			else if (r < -2) {
				obj.joint.setMotorSpeed(-0.3);
			}
			else {
				obj.joint.setMotorSpeed(0);
			}
			obj.joint.setEnableMotor(true);
			obj.joint.setMaxMotorTorque(50);
			obj.joint.setEnableLimit(true);
			obj.joint.setLowerRotation(-180);
			obj.joint.setUpperRotation(0);
		}
	},
	
	$theClawUpper: function(obj, delta){
		var r = obj.body.getRotation();
		
		// make r relative to the root;
		r -= theClawRoot.body.getRotation();
		if (r > 5) {
			obj.joint.setMotorSpeed(0.5);
		}
		else if (r < -5) {
			obj.joint.setMotorSpeed(-0.5);
		}
		else {
			obj.joint.setMotorSpeed(0);
		}
		obj.joint.setEnableMotor(true);
		obj.joint.setMaxMotorTorque(15);
	},
	
	$tuberBox9: function(obj, delta){
		obj.joint.setEnableMotor(true);
		obj.joint.setMaxMotorTorque(0.5);
		if (obj.body.getRotation() < 0) {
			obj.joint.setMotorSpeed(0);
		}
		else {
			obj.joint.setMotorSpeed(0.5);
		}
	},
	
	$tuberLower: function(obj, delta){
		obj.joint.setEnableMotor(true);
		obj.joint.setMaxMotorTorque(3.05);
		var r = obj.body.getRotation();
		if (r != 0) {
			obj.joint.setMotorSpeed(Math.abs(r) / r * 0.5);
		}
		else {
			obj.joint.setMotorSpeed(0);
		}
	},
	
	$enigmatic: function(obj, delta){
		obj.joint.setEnableMotor(true);
		obj.joint.setMaxMotorTorque(0.1);
		var r = obj.body.getRotation();
		r -= enigmaticLeft.body.getRotation();
		if (r != 0) {
			obj.joint.setMotorSpeed(Math.abs(r) / r * 0.5);
		}
		else {
			obj.joint.setMotorSpeed(0);
		}
	},

});

exports.Updaters = Updaters;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/AnimatedSprite'] = function(){var exports = $MODULE_REGISTRY['Code/AnimatedSprite'] || {}; $MODULE_REGISTRY['Code/AnimatedSprite'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;

var Vector2 = require('Code/util/Vector').Vector2;

var exports = {};

var AnimatedSprite = Core.MessageListener.subclass(
{
	initialize: function(imageLoc, framesWide, framesTall, frameLength, frameWidth, frameHeight){
		this.node = new GL2.Node();
		
		this.max_frames = framesWide * framesTall;
		
		this.frames = new Array(this.max_frames);
		
		this.currentFrameNo = 0;
		
		this.last_update_ms = 0;
				
		this.frame_length = frameLength;
		
		this.m_size = new Vector2(frameWidth, frameHeight);
		
		this.paused = false;
		for(var idx2 = 0; idx2 < framesTall; idx2++)
			for (var idx = 0; idx < framesWide; idx++) {
			{
				var tempSprite = new GL2.Sprite();
				var currentFrame = idx + framesWide * idx2;
				var currentImageLoc = imageLoc.substring(0, imageLoc.length - 4) + "_" + (currentFrame + 1) + imageLoc.substring(imageLoc.length - 4);
				tempSprite.setImage(currentImageLoc, [frameWidth, frameHeight], [0.5, 0.5]);
				this.frames[currentFrame] = tempSprite;
			}
		} // for
		
		// add every frame immediatly to prevent flickering, they will be cleaned up after the first playthrough of the animation
		// do it in reverse so the first frame is on top
		// set it offscreen for now.
		
		for (var idx = this.max_frames - 1; idx >= 0; idx--) {
			this.frames[idx].setPosition(-1000, -1000);
			this.node.addChild(this.frames[idx]);
		}
		
		this.frames[0].setPosition(0, 0);
		
		Core.UpdateEmitter.addListener(this, this.onUpdate);
		
	},
	
	destroy: function(){
		for (var idx = 0; idx < this.max_frames; idx++) {
			this.frames[idx].destroy();
		}
		this.node.destroy();
	},
	
	setScale: function(x, y)
	{
		this.node.setScale(x, y);
	},
	
	getSize: function(){
		return this.m_size;
	},
	
	nextFrame: function(){
		if (!this.onlyPlayOnce) {
			if (this.currentFrameNo < this.max_frames - 1) {
				this.gotoFrame(this.currentFrameNo + 1);
			}
			else {
				this.gotoFrame(0);
			}
		}
		else {
			if (this.currentFrameNo == this.max_frames - 1) {
				this.pause();
				this.root_node.removeChild(this.node);
			}
			else {
				this.gotoFrame(this.currentFrameNo + 1);
			}
		}
	},
	
	gotoFrame: function(frameNo){
		if (frameNo != this.currentFrameNo) {
			this.node.addChild(this.frames[frameNo]);
			this.node.removeChild(this.frames[this.currentFrameNo]);
			// readjust the position so that it's centered.
			this.frames[frameNo].setPosition(0, 0);
			this.currentFrameNo = frameNo;
		}
	},
	
	onUpdate: function(delta){
		if (!this.paused) {
			if (this.last_update_ms + delta > this.frame_length) {
				// update the frame
				this.last_update_ms = this.last_update_ms + delta - this.frame_length;
				this.nextFrame();
			}
			else {
				this.last_update_ms += delta;
			}
		}
	},
	
	playOnce: function(root_node) {
		this.root_node = root_node;
		this.onlyPlayOnce = true;
		this.root_node.addChild(this.node);
		this.gotoFrame(0);
		this.unPause();
	},
	
	getNode: function(){
		return this.node;
	},
	
	setColor:function(r, g, b) {
		for (var idx = 0; idx < this.frames.length; idx++) {
			this.frames[idx].setColor(r, g, b);
		}	
	},
	
	setPosition: function(x, y){
		this.node.setPosition(x, y);
	},
	
	setRotation: function(rot) {
		this.node.setRotation(rot);
	},
	
	setDepth: function(z) {
		this.node.setDepth(z);
	},
	
	getDepth: function() {
		return this.node.getDepth();
	},
	
	pause: function(){
		this.paused = true;
	},
	
	unPause: function() {
		this.paused = false;	
	},
	
	isPaused: function() {
		return this.paused;	
	},
});

exports.AnimatedSprite = AnimatedSprite;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/Body'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/Body'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/Body'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Body = Core.Class.subclass(
/** @lends Physics2.Body.prototype */
{
	classname: 'Body',
	
	/**
	 * @class The <code>Body</code> class constructs instances of application bodies.
	 * Most properties are identical to properties for the <code>b2Body</code> class
	 * of <code>Box2d</code>.
	 * @constructs The default constructor. 
	 * @see <a href="http://www.box2d.org/manual.html">Properties of b2Body</a>
	 * @augments Core.Class 
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._shapes = [];
		this._gl2Node = null;
		this._type = this.Type.Dynamic;
		this._contactFlags = 0;
		this._isSynchronized = false;
		this._isBullet = false;
		this._isAwake = true;
		this._isSleepingAllowed = true;
		this._isFixedRotation = false;
		this._linearDamping = 0;
		this._angularDamping = 0;
		this._position = new Core.Point();
		this._rotation = 0;
		this._linearVelocity = new Core.Vector();
		this._angularVelocity = 0;
		this._world = null;
		this._joints = [];
		
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash
	 */
	destroy: function()
	{
		shapes = this._shapes;
		while(shapes.length)
		{
			this.removeShape(shapes[0]);
		}
		
		if(this._world)
		{
			this._world.removeBody(this);
		}

		joints = this._joints;
		while(joints.length)
		{
			this._removeFromJoint(joints[0]);
		}
			
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Add a collision shape to this <code>Body</code>.
	 * @example var body = new Physics2.Body();
	 * ...
	 * var shape = new Physics2.BoxShape();
	 * ...
	 * body.addShape(shape);
	 * @param {Physics2.Shape} shape The collision shape to add.
	 * @see Physics2.Body#removeShape
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	addShape: function(shape)
	{
		this._shapes.push(shape);
		
		this._addShapeSendGen(Core.ObjectRegistry.objectToId(shape));
	},
	
	/**
	 * Remove a collision shape from this <code>Body</code>.
	 * @param {Physics2.Shape} shape The collision shape to remove.
	 * @see Physics2.Body#addShape
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	removeShape: function(shape)
	{
		var index = this._shapes.indexOf(shape);
		if(index != -1)
			this._shapes.splice(index, 1);
		
		this._removeShapeSendGen(Core.ObjectRegistry.objectToId(shape));
	},
	
	/**
	 * Retrieve the number of collision shapes in this <code>Body</code>.
	 * @returns {Number} The current number of collision shapes.
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getShapeCount: function()
	{
		return this._shapes.length;
	},
	
	/**
	 * Retrieve a collision shape at a specific index of this <code>Body</code>.
	 * @param {Number} index The index from which to retrieve a collision shape.
	 * @returns {Physics2.Shape} The current collision shape retrieved from the specified index.
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getShape: function(index)
	{
		return this._shapes[index];
	},
	
	/**
	 * Retrieve the node this <code>Body</code> is controlling.
	 * @returns {GL2.Node} The current node.
	 * @see Physics2.Body#setGL2Node
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getGL2Node: function()
	{
		return this._gl2Node;
	},
	
	/**
	 * Set the node this <code>Body</code> is controlling.
	 * When the physics simulation moves this <code>Body</code>,
	 * the position and rotation will automatically
	 * apply to the node specified through this call.
	 * @param {GL2.Node} [gl2Node=null] The new node to control.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setGL2Node: function(gl2Node)
	{
		this._gl2Node = gl2Node;
		this._setGL2NodeSendGen(Core.ObjectRegistry.objectToId(gl2Node));
		return this;
	},
	
	/**
	 * Retrieve the body type for this <code>Body</code>.
	 * @returns {Physics2.Body#Type} The current body type.
	 * @see Physics2.Body#setType
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getType: function()
	{
		return this._type;
	},
	
	/**
	 * Set the body type for this <code>Body</code>.
	 * @example var ground = new Physics2.Body();
	 * ground.setType(Physics2.Body.Type.Static);
	 * @param {Physics2.Body#Type} [type=Dynamic] The new body type.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getType
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setType: function(type)
	{
		this._type = type;
		
		if(type == this.Type.Static)
		{
			this._linearVelocity.setAll(0,0);
			this._angularVelocity = 0.0;
		}
		
		this._isAwake = true;
		
		this._setTypeSendGen(type);
		return this;
	},
	
	/**
	 * Retrieve the contact flags for this <code>Body</code>.
	 * @returns {Number} The current number of contact flags.
	 * @see Physics2.Body#setContactFlags
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getContactFlags: function()
	{
		return this._contactFlags;
	},
	
	/**
	 * Set the contact flags for this <code>Body</code>.
	 * Contact flags control the collision dynamics that will generate
	 * contact events for this <code>Body</code>.
	 * @example var body = new Physics2.Body();
	 * body.setContactFlags(Physics2.Body.ContactFlags.Begin);
	 * @param {Physics2.Body#ContactFlags} [flags=none] The new number of contact flags.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setContactFlags: function(contactFlags)
	{
		this._contactFlags = contactFlags;
		this._setContactFlagsSendGen(contactFlags);
		return this;
	},
	
	/**
	 * Retrieve the synchronization state for this <code>Body</code>.
	 * @returns {Boolean} Returns <code>true</code> if this <code>Body</code> is synchronized.
	 * @see Physics2.Body#setIsSynchronized
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getIsSynchronized: function()
	{
		return this._isSynchronized;
	},
	
	/**
	 * Set the synchronization state for this <code>Body</code>.
	 * A <code>Body</code> specified through this call will synchronize the position, rotation, linear velocity, and angular
	 * velocity with the physics simulation on the backend.	 
	 * <br><br>
	 * <b>Note:</b> Synchronized bodies require significantly more processing time than non-synchronized bodies.
	 * Enable this only for bodies that require inspection from application code.
	 * @example var body = new Physics2.Body();
	 * body.setIsSynchronized(true);
	 * @param {Boolean} [isSynchronized=false] Set as <code>true</code> if this <code>Body</code> is synchronized.
	 * If <code>true</code>, <code>getPosition()</code>, <code>getRotation()</code>,
	 * <code>getLinearVelocity()</code>, <code>getAngularVelocity()</code> and 
	 * <code>getIsAwake()</code> return the state of the body on the native backend. If <code>false</code>,
	 * those functions will return the last value passed to the corresponding set function and will not
	 * reflect the current state of the physics simulation.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getIsSynchronized,
	 * @see Physics2.Body#getPosition,
	 * @see Physics2.Body#getRotation,
	 * @see Physics2.Body#getLinearVelocity,
	 * @see Physics2.Body#getAngularVelocity, 
	 * @see Physics2.Body#getIsAwake
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setIsSynchronized: function(isSynchronized)
	{
		this._isSynchronized = isSynchronized;
		this._setIsSynchronizedSendGen(isSynchronized);
		return this;
	},
	
	/**
	 * Retrieve whether this <code>Body</code> is a bullet.
	 * @returns {Boolean} Returns <code>true</code> if this <code>Body</code> is a bullet.
	 * @see Physics2.Body#setIsBullet
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getIsBullet: function()
	{
		return this._isBullet;
	},
	
	/**
	 * Set this <code>Body</code> as a bullet.
	 * @param {Boolean} [isBullet=false] Set as <code>true</code> if this <code>Body</code> is a bullet.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getIsBullet
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setIsBullet: function(isBullet)
	{
		this._isBullet = isBullet;
		this._setIsBulletSendGen(isBullet);
		return this;
	},
	
	/**
	 * Retrieve whether this <code>Body</code> is awake.
	 * @returns {Boolean} Returns <code>true</code> if this <code>Body</code>.
	 * @see Physics2.Body#setIsAwake
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getIsAwake: function()
	{
		return this._isAwake;
	},
	
	/**
	 * Set this <code>Body</code> as awake.
	 * @param {Boolean} [isAwake=true] Set as <code>true</code> if this <code>Body</code> is awake.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Pysics2.Body#getIsAwake
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setIsAwake: function(isAwake)
	{
		this._isAwake = isAwake;
		this._setIsAwakeSendGen(isAwake);
		return this;
	},
	
	/**
	 * Retrieve whether sleeping is allowed for this <code>Body</code>.
	 * @returns {Boolean} Returns <code>true</code> if sleeping is allowed.
	 * @see Physics2.Body#setIsSleepingAllowed
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getIsSleepingAllowed: function()
	{
		return this._isSleepingAllowed;
	},
	
	/**
	 * Set whether this <code>Body</code> is allowed to sleep.
	 * @param {Boolean} [isSleepingAllowed=true] Set as <code>true</code> if sleeping is allowed.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getIsSleepingAllowed
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setIsSleepingAllowed: function(isSleepingAllowed)
	{
		this._isSleepingAllowed = isSleepingAllowed;
		this._setIsSleepingAllowedSendGen(isSleepingAllowed);
		return this;
	},
	
	/**
	 * Retrieve whether rotation is fixed for this <code>Body</code>.
	 * @returns {Boolean} Returns <code>true</code> if the rotation is fixed.
	 * @see Physics2.Body#setIsFixedRotation
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getIsFixedRotation: function()
	{
		return this._isFixedRotation;
	},
	
	/**
	 * Set whether rotation is fixed for this <code>Body</code>.
	 * @param {Boolean} [isFixedRotation=false] Returns <code>true</code> if rotation is fixed.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getIsFixedRotation
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setIsFixedRotation: function(isFixedRotation)
	{
		this._isFixedRotation = isFixedRotation;
		this._setIsFixedRotationSendGen(isFixedRotation);
		return this;
	},
	
	/**
	 * Retrieve the linear damping amount for this <code>Body</code>.
	 * @returns {Number} The current linear damping amount.
	 * @see Physics2.Body#setLinearDamping
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getLinearDamping: function()
	{
		return this._linearDamping;
	},
	
	/**
	 * Set the linear damping amount for this <code>Body</code>.
	 * @param {Number} [linearDamping=0] The new linear damping amount.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getLinearDamping
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setLinearDamping: function(linearDamping)
	{
		this._linearDamping = linearDamping;
		this._setLinearDampingSendGen(linearDamping);
		return this;
	},
	
	/**
	 * Retrieve the angular damping amount for this <code>Body</code>.
	 * @returns {Number} The current angular damping amount.
	 * @see Physics2.Body#setAngularDamping
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getAngularDamping: function()
	{
		return this._angularDamping;
	},
	
	/**
	 * Set the angular damping amount for this <code>Body</code>.
	 * @param {Number} [angularDamping=0] The new angular damping amount.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getAngularDamping
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setAngularDamping: function(angularDamping)
	{
		this._angularDamping = angularDamping;
		this._setAngularDampingSendGen(angularDamping);
		return this;
	},
	
	/**
	 * Retrieve the position for this <code>Body</code>. If this <code>Body</code> is synchronized,
	 * this call will retrieve the current value from the physics simulation.
	 * @returns {Core.Point} The current position.
	 * @see Physics2.Body#setPosition
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getPosition: function()
	{
		return this._position;
	},
	
	/**
	 * Set the position for this <code>Body</code>.
	 * @example var w = Core.Capabilities.getScreenWidth();
	 * var h = Core.Capabilities.getScreenHeight();
	 * ...
	 * var body = new Physics2.Body();
	 * body.setPosition(w/4, h/5);
	 * @param {Core.Point} [position=(0,0)] The new position.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getPosition
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setPosition: function(position)
	{
		var p = this._position;
		p.setAll.apply(p, arguments);
		this._setPositionSendGen(p.getX(),p.getY());
		return this;
	},
	
	/**
	 * Retrieve the rotation for this <code>Body</code>. If this <code>Body</code> is synchronized,
	 * this call will retrieve the current value from the physics simulation.
	 * @returns {Core.Point} The current rotation.
	 * @see Physics2.Body#setRotation
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getRotation: function()
	{
		return this._rotation;
	},
	
	/**
	 * Set the rotation for this <code>Body</code>.
	 * @example var body = new Physics2.Body();
	 * body.setRotation(5);
	 * @param {Number} [rotation=0] The new rotation.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getRotation
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setRotation: function(rotation)
	{
		this._rotation = rotation;
		this._setRotationSendGen(rotation);
		return this;
	},

	/**
	 * Retrieve the linear velocity for this <code>Body</code>. If this <code>Body</code> is synchronized,
	 * this call will retrieve the current value from the physics simulation.
	 * @returns {Core.Vector} The current linear velocity.
	 * @see Physics2.Body#setLinearVelocity
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getLinearVelocity: function()
	{
		return this._linearVelocity;
	},
	
	/**
	 * Set the linear velocity for this <code>Body</code>.
	 * @example var body = new Physics2.Body();
	 * body.setLinearVelocity(40, 0);
	 * @param {Core.Vector} [linearVelocity=(0, 0)] The new linear velocity.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getLinearVelocity
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setLinearVelocity: function(linearVelocity)
	{
		var v = this._linearVelocity;
		v.setAll.apply(v, arguments);
		this._setLinearVelocitySendGen(v.getX(),v.getY());
		return this;
	},
	
	/**
	 * Retrieve the angular velocity of this <code>Body</code>. If this <code>Body</code> is synchronized,
	 * this call will retrieve the current value from the physics simulation.
	 * @returns {Nmber} The current angular velocity.
	 * @see Physics2.Body#setAngularVelocity
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getAngularVelocity: function()
	{
		return this._angularVelocity;
	},
	
	/**
	 * Set the angular velocity of this <code>Body</code>.
	 * @example var body = new Physics2.Body();
	 * ...
	 * var rvel = Math.random() * 12 - 6;
	 * ...
	 * body.setAngularVelocity(rvel);
	 * @param {Number} [angularVelocity=0] The new angular velocity.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getAngularVelocity
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setAngularVelocity: function(angularVelocity)
	{
		this._angularVelocity = angularVelocity;
		this._setAngularVelocitySendGen(angularVelocity);
		return this;
	},
	
	/**
	 * Set the force an application will apply to this <code>Body</code> at a specific location. The application will continue to apply the specified force
	 * every physics step until reaching a force of <code>0</code>.
	 * @param {Core.Vector} force The force to apply.
	 * @param {Core.Point} point The location point where force is applied.
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	applyForce: function(force, point)
	{
		this._applyForceSendGen(force.getX(),force.getY(),point.getX(),point.getY());
	},
	
	/**
	 * Set the torque an application will apply to this <code>Body</code>. The application will continue to apply the specified torque
	 * every physics step until reaching a toruqe of <code>0</code>.
	 * @param {Number} torque The torque to apply.
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	applyTorque: function(torque)
	{
		this._applyTorqueSendGen(torque);
	},
	
	/**
	 * Apply a one-time impulse to this <code>Body</code> at a specific location. 
	 * @param {Core.Vector} impulse The impulse to apply.
	 * @param {Core.Point} point The location point where the impulse is applied.
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	applyLinearImpulse: function(impulse, point)
	{
		this._applyLinearImpulseSendGen(impulse.getX(),impulse.getY(),point.getX(),point.getY());
	},
	
	/**
	 * Apply a one-time angular impulse. The impulse is designed to generate angular momentum on the <code>Body</code>.
	 * @param {Number} impulse The impulse to apply.
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	applyAngularImpulse: function(impulse)
	{
		this._applyAngularImpulseSendGen(impulse);
	},
	
	_setIsAwakeRecv: function( cmd ) 
	{
		var msg = {};
		if (!this._setIsAwakeRecvGen(cmd, msg))
			return;
		
		this._isAwake = msg.isAwake;
	},
	
	_synchronizeBodyRecv: function(cmd)
	{
		if (!this._isSynchronized) return;
		var msg = {};
		if(!this._synchronizeBodyRecvGen(cmd, msg))
			return;
		this._position.setAll(msg.px, msg.py);
		this._rotation = msg.rotation;
		this._linearVelocity.setAll(msg.vx, msg.vy);
		this._angularVelocity = msg.angularVelocity;
	},
	
	_didAddToWorld: function(world)
	{
		if(this._world)
			this._world.removeBody(this);
		
		this._world = world;
	},
	
	_willRemoveFromWorld: function(world)
	{
		this._world = null;
	},
	
	_didAddToJoint: function(joint)
	{
		this._joints.push(joint);
	},

	_willRemoveFromJoint: function(joint)
	{
		var index = this._joints.indexOf(joint);
		if(index == -1)
			return;

		this._joints.splice(index,1);
	},

	_removeFromJoint: function(joint)
	{
		this._willRemoveFromJoint(joint);

		if(joint.getBodyA() == this);
		   joint.setBodyA(null);
	   if(joint.getBodyB() == this);
		   joint.setBodyB(null);
	},

	// note: this does not support overriding MassData
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for body type.
	 * @namespace
	 */
	Type:
	{ 
		/** <code>Body</code> will never move under simulation. */
		Static: 0,
		/** <code>Body</code> assumes control of velocity and will push dynamic bodies aside. */
		Kinematic: 1,
		/** <code>Body</code> is under complete control of the simulation. */
		Dynamic: 2,
	},
	
	/** 
	 * Enumeration for contact flags.
	 * @namespace
	 */
	ContactFlags:
	{ 
		/** Generate a contact callback when this <code>Body</code> begins touching another <code>Body</code>. */
		Begin: 1,
		/** Generate a contact callback when this <code>Body</code> stops touching another <code>Body</code>. */
		End: 2,
		/** Generate a contact callback each simulation step that this <code>Body</code> is touching another <code>Body</code>. */
		Solved: 4,
		/** Generate a contact callback for all cases. */
		All: 7,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 315
	// Method create = -1
	// Method destroy = 2
	// Method addShape = 3
	// Method removeShape = 4
	// Method setGL2Node = 5
	// Method setType = 6
	// Method setContactFlags = 7
	// Method setIsSynchronized = 8
	// Method setIsBullet = 9
	// Method setIsAwake = 10
	// Method setIsSleepingAllowed = 11
	// Method setIsFixedRotation = 12
	// Method setLinearDamping = 13
	// Method setAngularDamping = 14
	// Method setPosition = 15
	// Method setRotation = 16
	// Method setLinearVelocity = 17
	// Method setAngularVelocity = 18
	// Method applyForce = 19
	// Method applyTorque = 20
	// Method applyLinearImpulse = 21
	// Method applyAngularImpulse = 22
	// Method synchronizeBody = 23
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 10:
					instance._setIsAwakeRecv( cmd );
					break;
				case 23:
					instance._synchronizeBodyRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Body._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Body._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[315] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_setIsAwakeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Body.setIsAwake from command: " + cmd );
			return false;
		}
		
		obj[ "isAwake" ] = Core.Proc.parseBool( cmd[ 0 ] );
		if( obj[ "isAwake" ] === undefined )
		{
			NgLogE("Could not parse isAwake in Body.setIsAwake from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_synchronizeBodyRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 6 )
		{
			NgLogE("Could not parse due to wrong argument count in Body.synchronizeBody from command: " + cmd );
			return false;
		}
		
		obj[ "px" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "px" ] === undefined )
		{
			NgLogE("Could not parse px in Body.synchronizeBody from command: " + cmd );
			return false;
		}
		
		obj[ "py" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "py" ] === undefined )
		{
			NgLogE("Could not parse py in Body.synchronizeBody from command: " + cmd );
			return false;
		}
		
		obj[ "rotation" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "rotation" ] === undefined )
		{
			NgLogE("Could not parse rotation in Body.synchronizeBody from command: " + cmd );
			return false;
		}
		
		obj[ "vx" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "vx" ] === undefined )
		{
			NgLogE("Could not parse vx in Body.synchronizeBody from command: " + cmd );
			return false;
		}
		
		obj[ "vy" ] = Core.Proc.parseFloat( cmd[ 4 ] );
		if( obj[ "vy" ] === undefined )
		{
			NgLogE("Could not parse vy in Body.synchronizeBody from command: " + cmd );
			return false;
		}
		
		obj[ "angularVelocity" ] = Core.Proc.parseFloat( cmd[ 5 ] );
		if( obj[ "angularVelocity" ] === undefined )
		{
			NgLogE("Could not parse angularVelocity in Body.synchronizeBody from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":315,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":315,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_addShapeSendGen: function( shape )
	{
		Core.Proc.appendToCommandString( ":315,3," + this.__objectRegistryId + "," + shape  );
	},
	
	/** @private */
	_removeShapeSendGen: function( shape )
	{
		Core.Proc.appendToCommandString( ":315,4," + this.__objectRegistryId + "," + shape  );
	},
	
	/** @private */
	_setGL2NodeSendGen: function( gl2Node )
	{
		Core.Proc.appendToCommandString( ":315,5," + this.__objectRegistryId + "," + gl2Node  );
	},
	
	/** @private */
	_setTypeSendGen: function( type )
	{
		Core.Proc.appendToCommandString( ":315,6," + this.__objectRegistryId + "," + type  );
	},
	
	/** @private */
	_setContactFlagsSendGen: function( contactFlags )
	{
		Core.Proc.appendToCommandString( ":315,7," + this.__objectRegistryId + "," + contactFlags  );
	},
	
	/** @private */
	_setIsSynchronizedSendGen: function( isSynchronized )
	{
		Core.Proc.appendToCommandString( ":315,8," + this.__objectRegistryId + "," + ( isSynchronized ? 1 : 0 )  );
	},
	
	/** @private */
	_setIsBulletSendGen: function( isBullet )
	{
		Core.Proc.appendToCommandString( ":315,9," + this.__objectRegistryId + "," + ( isBullet ? 1 : 0 )  );
	},
	
	/** @private */
	_setIsAwakeSendGen: function( isAwake )
	{
		Core.Proc.appendToCommandString( ":315,10," + this.__objectRegistryId + "," + ( isAwake ? 1 : 0 )  );
	},
	
	/** @private */
	_setIsSleepingAllowedSendGen: function( isSleepingAllowed )
	{
		Core.Proc.appendToCommandString( ":315,11," + this.__objectRegistryId + "," + ( isSleepingAllowed ? 1 : 0 )  );
	},
	
	/** @private */
	_setIsFixedRotationSendGen: function( isFixedRotation )
	{
		Core.Proc.appendToCommandString( ":315,12," + this.__objectRegistryId + "," + ( isFixedRotation ? 1 : 0 )  );
	},
	
	/** @private */
	_setLinearDampingSendGen: function( linearDamping )
	{
		Core.Proc.appendToCommandString( ":315,13," + this.__objectRegistryId + "," + linearDamping  );
	},
	
	/** @private */
	_setAngularDampingSendGen: function( angularDamping )
	{
		Core.Proc.appendToCommandString( ":315,14," + this.__objectRegistryId + "," + angularDamping  );
	},
	
	/** @private */
	_setPositionSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":315,15," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setRotationSendGen: function( rotation )
	{
		Core.Proc.appendToCommandString( ":315,16," + this.__objectRegistryId + "," + rotation  );
	},
	
	/** @private */
	_setLinearVelocitySendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":315,17," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setAngularVelocitySendGen: function( angularVelocity )
	{
		Core.Proc.appendToCommandString( ":315,18," + this.__objectRegistryId + "," + angularVelocity  );
	},
	
	/** @private */
	_applyForceSendGen: function( fx, fy, px, py )
	{
		Core.Proc.appendToCommandString( ":315,19," + this.__objectRegistryId + "," + fx + "," + fy + "," + px + "," + py  );
	},
	
	/** @private */
	_applyTorqueSendGen: function( torque )
	{
		Core.Proc.appendToCommandString( ":315,20," + this.__objectRegistryId + "," + torque  );
	},
	
	/** @private */
	_applyLinearImpulseSendGen: function( ix, iy, px, py )
	{
		Core.Proc.appendToCommandString( ":315,21," + this.__objectRegistryId + "," + ix + "," + iy + "," + px + "," + py  );
	},
	
	/** @private */
	_applyAngularImpulseSendGen: function( angularImpulse )
	{
		Core.Proc.appendToCommandString( ":315,22," + this.__objectRegistryId + "," + angularImpulse  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// addShape: function( shape ) {}
	
	// removeShape: function( shape ) {}
	
	// setGL2Node: function( gl2Node ) {}
	
	// setType: function( type ) {}
	
	// setContactFlags: function( contactFlags ) {}
	
	// setIsSynchronized: function( isSynchronized ) {}
	
	// setIsBullet: function( isBullet ) {}
	
	// _setIsAwakeRecv: function( cmd ) {}
	// setIsAwake: function( isAwake ) {}
	
	// setIsSleepingAllowed: function( isSleepingAllowed ) {}
	
	// setIsFixedRotation: function( isFixedRotation ) {}
	
	// setLinearDamping: function( linearDamping ) {}
	
	// setAngularDamping: function( angularDamping ) {}
	
	// setPosition: function( x, y ) {}
	
	// setRotation: function( rotation ) {}
	
	// setLinearVelocity: function( x, y ) {}
	
	// setAngularVelocity: function( angularVelocity ) {}
	
	// applyForce: function( fx, fy, px, py ) {}
	
	// applyTorque: function( torque ) {}
	
	// applyLinearImpulse: function( ix, iy, px, py ) {}
	
	// applyAngularImpulse: function( angularImpulse ) {}
	
	// _synchronizeBodyRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/BoxShape'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/BoxShape'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/BoxShape'] = exports; var Shape = require('NGCore/Client/Physics2/Shape').Shape;
var Core = require('NGCore/Client/Core').Core;

exports.BoxShape = Shape.subclass(
/** @lends Physics2.BoxShape.prototype */
{
	classname: 'BoxShape',
	
	/**
	 * @class The <code>BoxShape</code> class constructs objects that define the collision box shape.
	 * @constructs The default constructor. 
	 * @augments Physics2.Shape
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._position = new Core.Point();
		this._anchor = new Core.Point(0.5, 0.5);
		this._size = new Core.Size();
		this._rotation = 0;
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the position for this <code>BoxShape</code>.
	 * @returns {Core.Point} The current position.
	 * @see Physics2.BoxShape#setPosition
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPosition: function()
	{
		return this._position;
	},
	
	/**
	 * Set the position for this <code>BoxShape</code>.
	 * @example var box = new Physics2.BoxShape();
	 * box.setPosition(0, Core.Capabilities.getScreenHeight());
	 * @param {Core.Point} [position=(0, 0)] The new position.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.BoxShape#getPosition
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setPosition: function(position)
	{
		var p = this._position;
		p.setAll.apply(p, arguments);
		this._setPositionSendGen(p.getX(),p.getY());
		return this;
	},
	
	/**
	 * Retrieve the anchor for this <code>BoxShape</code>.
	 * @returns {Core.Point} The current anchor.
	 * @see Physics2.BoxShape#setAnchor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnchor: function()
	{
		return this._anchor;
	},
	
	/**
	 * Set the anchor for this <code>BoxShape</code>.
	 * @example var box = new Physics2.BoxShape();
	 * box.setAnchor(0, 1);
	 * @param {Core.Point} [anchor=(0.5, 0.5)] The new anchor.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.BoxShape#getAnchor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAnchor: function(anchor)
	{
		var a = this._anchor;
		a.setAll.apply(a, arguments);
		this._setAnchorSendGen(a.getX(),a.getY());
		return this;
	},
	
	/**
	 * Retrieve the size for this <code>BoxShape</code>.
	 * @returns {Core.Size} The current size.
	 * @see Physics2.BoxShape#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSize: function()
	{
		return this._size;
	},
	
	/**
	 * Set the size for this <code>BoxShape</code>.
	 * @example var box = new Physics2.BoxShape();
	 * box.setSize(Core.Capabilities.getScreenWidth(), thick);
	 * @param {Core.Size} [size=(0, 0)] The new size.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.BoxShape#getSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSize: function(size)
	{
		var s = this._size;
		s.setAll.apply(s, arguments);
		this._setSizeSendGen(s.getWidth(),s.getHeight());
		return this;
	},
	
	/**
	 * Retrieve the rotation for this <code>BoxShape</code>.
	 * @returns {Number} The current rotation.
	 * @see Physics2.BoxShape#setRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getRotation: function()
	{
		return this._rotation;
	},
	
	/**
	 * Set the rotation for this <code>BoxShape</code>.
	 * @example var box = BoxShape();
	 * box.setRotation(45);
	 * @param {Number} [rotation=0] The new rotation.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.BoxShape#getRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setRotation: function(rotation)
	{
		this._rotation = rotation;
		this._setRotationSendGen(rotation);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 317
	// Method create = -1
	// Method destroy = 2
	// Method setPosition = 3
	// Method setAnchor = 4
	// Method setSize = 5
	// Method setRotation = 6
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in BoxShape._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in BoxShape._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[317] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":317,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":317,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setPositionSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":317,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setAnchorSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":317,4," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setSizeSendGen: function( width, height )
	{
		Core.Proc.appendToCommandString( ":317,5," + this.__objectRegistryId + "," + width + "," + height  );
	},
	
	/** @private */
	_setRotationSendGen: function( rotation )
	{
		Core.Proc.appendToCommandString( ":317,6," + this.__objectRegistryId + "," + rotation  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPosition: function( x, y ) {}
	
	// setAnchor: function( x, y ) {}
	
	// setSize: function( width, height ) {}
	
	// setRotation: function( rotation ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/CircleShape'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/CircleShape'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/CircleShape'] = exports; var Shape = require('NGCore/Client/Physics2/Shape').Shape;

exports.CircleShape = Shape.subclass(
/** @lends Physics2.CircleShape.prototype */
{
	classname: 'CircleShape',
	
	/**
	 * @class The <code>CircleShape</code> class constructs objects that define the collision circle shape.
	 * @constructs The default constructor. 
	 * @augments Physics2.Shape
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._position = new Core.Point();
		this._radius = 0;
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the position of this <code>CircleShape</code>.
	 * @returns {Core.Point} The current position.
	 * @see Physics2.CircleShape#setPosition
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPosition: function()
	{
		return this._position;
	},
	
	/**
	 * Set the position for this <code>CircleShape</code>.
	 * @example var circle = new Physics2.CircleShape();
	 * circle.setPosition(0, Core.Capabilities.getScreenHeight());
	 * @param {Core.Point} [position=(0, 0)] The new position.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.CircleShape#getPosition
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setPosition: function(position)
	{
		var p = this._position;
		p.setAll.apply(p, arguments);
		this._setPositionSendGen(p.getX(),p.getY());
		return this;
	},
	
	/**
	 * Retrieve the radius for this <code>CircleShape</code>.
	 * @returns {Number} The current radius.
	 * @see Physics2.CircleShape#setRadius
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getRadius: function()
	{
		return this._radius;
	},
	
	/**
	 * Set the radius for this <code>CircleShape</code>.
	 * @example function makeCircle(position, radius)
	 * ...
	 * var circle = new Physics2.CircleShape();
	 * circle.setRadius(radius);
	 * @param {Number} [radius=0] The new radius.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.CircleShape#getRadius
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setRadius: function(radius)
	{
		this._radius = radius;
		this._setRadiusSendGen(radius);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 318
	// Method create = -1
	// Method destroy = 2
	// Method setPosition = 3
	// Method setRadius = 4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in CircleShape._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in CircleShape._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[318] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":318,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":318,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setPositionSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":318,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setRadiusSendGen: function( radius )
	{
		Core.Proc.appendToCommandString( ":318,4," + this.__objectRegistryId + "," + radius  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPosition: function( x, y ) {}
	
	// setRadius: function( radius ) {}
	

// {{/Wg Generated Code}}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/PolygonShape'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/PolygonShape'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/PolygonShape'] = exports; var Shape = require('NGCore/Client/Physics2/Shape').Shape;

exports.PolygonShape = Shape.subclass(
/** @lends Physics2.PolygonShape.prototype */
{
	classname: 'PolygonShape',
	
	/**
	 * @class The <code>PolygonShape</code> class constructs objects that define a polygon collision shape.
	 * @constructs The default constructor. 
	 * @augments Physics2.Shape
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._vertexes = [];
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the number of vertices from this <code>PolygonShape</code>.
	 * @returns {Number} The current number of vertices.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVertexCount: function()
	{
		return this._vertexes.length;
	},
	
	/**
	 * Retrieve a vertex at a specific index of this <code>PolygonShape</code>.
	 * @param {Number} index The index containing the vertex to retrieve.
	 * @returns {Core.Point} The current vertex at the specified index.
	 * @see Physics2.PolygonShape#setVertex
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVertex: function(index)
	{
		return this._vertexes[index];
	},
	
    /**
	 * Add a vertex polygon to this <code>PolygonShape</code>.
	 * <pre class="code"><font size="1">var poly = new Physics2.PolygonShape();
	 * ...
	 * poly.pushVertex(new Core.Point(w*2/10, h*5/6));</font></pre>
	 * Calling <code>pushVertex()</code> is equivalent to calling <code>spliceVertexes()</code> in the following way:
	 * <pre class="code"><font size="1">PolygonShape.spliceVertexes(polygon.getVertexCount(), 0, vertex)</font></pre>
	 * @param {Core.Point} vertex The vertex to add.
	 * @see Physics2.PolygonShape#spliceVertexes
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	pushVertex: function(vertex)
	{
		return this.spliceVertexes(this._vertexes.length, 0, vertex);
	},
	
    /**
	 * Set the vertex at index <i>i</i> for this <code>PolygonShape</code>.
	 * Calling <code>setVertex()</code> is equivalent to calling <code>spliceVertexes()</code> in the following way:
	 * <pre class="code"><font size="2">vertex.spliceVertexes(i, 1, vertex)</font></pre>
	 * @param {Number} <i>i</i> The specified index.
	 * @param {Core.Point} vertex The vertex to set.
	 * @see Physics2.PolygonShape#getVertex
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setVertex: function(i, vertex)
	{
		return this.spliceVertexes(i, 1, vertex);
	},
	
    /**
	 * Remove <code>len</code> vertices, beginning at <code>start</code> position, and insert vertices at <code>start</code> position.
	 * This method accepts <i>n</i> parameters, assuming that the second parameter and higher are references to vertices.<br><br>
	 * The following is an example of passing three vertices to insert.
	 * @param {Number} start The index of the first vertex to remove.
	 * @param {Number} len The number of vertices to remove.
	 * @param {Core.Point} vertexes The vertices to remove.
	 * @example
	 * PolygonShape.spliceVertexes(0, 0, vertex1, vertex2, vertex3).
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    spliceVertexes: function(start, len, vertexes)
	{
		var v = this._vertexes;
		v.splice.apply(v, arguments);
		
		var vertexCount = arguments.length-2;
		this._spliceVertexesSendGen(start,len,vertexCount);
		
		for(var i=0; i < vertexCount; ++i)
		{
			var vertex = arguments[i+2];
			this._vertexSendGen(vertex.getX(),vertex.getY());
		}
		
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 319
	// Method create = -1
	// Method destroy = 2
	// Method spliceVertexes = 3
	// Method vertex = 4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in PolygonShape._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in PolygonShape._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[319] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":319,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":319,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_spliceVertexesSendGen: function( start, len, vertexCount )
	{
		Core.Proc.appendToCommandString( ":319,3," + this.__objectRegistryId + "," + start + "," + len + "," + vertexCount  );
	},
	
	/** @private */
	_vertexSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( "," + x + "," + y  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// spliceVertexes: function( start, len, vertexCount ) {}
	
	// vertex: function( x, y ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/Shape'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/Shape'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/Shape'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Shape = Core.Class.subclass(
/** @lends Physics2.Shape.prototype */
{
	classname: 'Shape',
	
	/**
	 * @class The <code>Shape</code> class is a base class for constructing collision shape objects.
	 * Most properties are identical to <a href="http://www.box2d.org/manual.html">properties of the b2Body</a> class
	 * of <code>Box2d</code>.<br><br>
	 * <b>Caution!:</b> Do not instantiate this class directly. Use classes derived from <code>Shape</code> for instantiation. This includes:
	 * <div class="ul">
	 * <li>{@link Physics2.BoxShape}</li>
	 * <li>{@link Physics2.CircleShape}</li>
	 * <li>{@link Physics2.PolygonShape}</li>
	 * </div>
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		
		this._isSensor = false;
		this._categoryBits = 0;
		this._maskBits = 0;
		this._groupIndex = 0;
		this._friction = 0;
		this._restitution = 0;
		this._density = 1;
		
		this._createSendGen(this.__objectRegistryId);
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this._destroySendGen();
		
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Retrieve whether this <code>Shape</code> is a sensor.
	 * @returns {Boolean} Returns <code>true</code> if this shape is a sensor.
	 * @see Physics2.Shape#setIsSensor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getIsSensor: function()
	{
		return this._isSensor;
	},
	
	/**
	 * Set whether this <code>Shape</code> is a sensor.
	 * @example var shape = new Physics2.PolygonShape();
	 * ...
	 * shape.setIsSensor(true);
	 * @param {Boolean} isSensor Set as <code>true</code> if this shape is a sensor.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Shape#getIsSensor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setIsSensor: function(isSensor)
	{
		this._isSensor = isSensor;
		this._setIsSensorSendGen(isSensor);
		return this;
	},
	
	/**
	 * Retrieve category collision bits for this <code>Shape</code>.
	 * @returns {Number} The current number of category collision bits.
	 * @see Physics2.Shape#setCategoryBits
	 * @status iOS, Android, Flash
	 */
	getCategoryBits: function()
	{
		return this._categoryBits;
	},
	
	/**
	 * Set category collision bits for this <code>Shape</code>.
	 * @example var shape = new Physics2.BoxShape();
	 * ...
	 * shape.setCategoryBits(1);
	 * @param {Number} categoryBits The new number of category collision bits.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Shape#getCategoryBits
	 * @status iOS, Android, Flash
	 */
	setCategoryBits: function(categoryBits)
	{
		this._categoryBits = categoryBits;
		this._setCategoryBitsSendGen(categoryBits);
		return this;
	},
	
	/**
	 * Retrieve mask collision bits for this <code>Shape</code>.
	 * @returns {Number} The current number of mask collision bits.
	 * @see Physics2.Shape#setMaskBits
	 * @status iOS, Android, Flash
	 */
	getMaskBits: function()
	{
		return this._maskBits;
	},
	
	/**
	 * Set mask collision bits for this <code>Shape</code>.
	 * @example var shape = new Physics2.CircleShape();
	 * ...
	 * shape.setMaskBits(1);
	 * @param {Number} maskBits The new number of mask collision bits.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Shape#getMaskBits
	 * @status iOS, Android, Flash
	 */
	setMaskBits: function(maskBits)
	{
		this._maskBits = maskBits;
		this._setMaskBitsSendGen(maskBits);
		return this;
	},
	
	/**
	 * Retrieve the group collision index for this <code>Shape</code>.
	 * @returns {Number} The current group collision index.
	 * @see Physics2.Shape#setGroupIndex
	 * @status iOS, Android, Flash
	 */
	getGroupIndex: function()
	{
		return this._groupIndex;
	},
	
	/**
	 * Set the group collision index for this <code>Shape</code>.
	 * @example var shape = new Physics2.BoxShape();
	 * ...
	 * shape.setGroupIndex(-1);
	 * @param {Number} groupIndex The new group collision index.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Shape#getGroupIndex
	 * @status iOS, Android, Flash
	 */
	setGroupIndex: function(groupIndex)
	{
		this._groupIndex = groupIndex;
		this._setGroupIndexSendGen(groupIndex);
		return this;
	},
	
	/**
	 * Retrieve the amount of friction applied to this <code>Shape</code>.
	 * @returns {Number} The current amount of friction.
	 * @see Physics2.Shape#setFriction
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFriction: function()
	{
		return this._friction;
	},
	
	/**
	 * Set the amount of friction applied to this <code>Shape</code>.
	 * @example var shape = new Physics2.PolygonShape();
	 * ...
	 * shape.setFriction(0.1);
	 * @param {Number} [friction=0] The new amount of friction.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Shape#getFriction
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setFriction: function(friction)
	{
		this._friction = friction;
		this._setFrictionSendGen(friction);
		return this;
	},
	
	/**
	 * Retrieve the restitution for this <code>Shape</code>.
	 * @returns {Number} The current restitution applied.
	 * @see Physics2.Shape#setRestitution
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getRestitution: function()
	{
		return this._restitution;
	},
	
	/**
	 * Set the restitution for this <code>Shape</code>.
	 * @example var shape = new Physics2.BoxShape();
	 * ...
	 * shape.setRestitution(0.8);
	 * @param {Number} [restitution=0] The new restitution applied.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Shape#getRestitution
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setRestitution: function(restitution)
	{
		this._restitution = restitution;
		this._setRestitutionSendGen(restitution);
		return this;
	},
	
	/**
	 * Retrieve the density of this <code>Shape</code>.
	 * @returns {Number} The current density.
	 * @see Physics2.Shape#setDensity
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getDensity: function()
	{
		return this._density;
	},
	
	/**
	 * Set the density of this <code>Shape</code>.
	 * @example var shape = new Physics2.CircleShape();
	 * ...
	 * shape.setDensity(100);
	 * @param {Number} [density=0] The new density.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Shape#getDensity
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setDensity: function(density)
	{
		this._density = density;
		this._setDensitySendGen(density);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 316
	// Method destroy = 1
	// Method setIsSensor = 2
	// Method setCategoryBits = 3
	// Method setMaskBits = 4
	// Method setGroupIndex = 5
	// Method setFriction = 6
	// Method setRestitution = 7
	// Method setDensity = 8
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Shape._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Shape._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[316] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":316,1," + this.__objectRegistryId );
	},
	
	/** @private */
	_setIsSensorSendGen: function( isSensor )
	{
		Core.Proc.appendToCommandString( ":316,2," + this.__objectRegistryId + "," + ( isSensor ? 1 : 0 )  );
	},
	
	/** @private */
	_setCategoryBitsSendGen: function( categoryBits )
	{
		Core.Proc.appendToCommandString( ":316,3," + this.__objectRegistryId + "," + categoryBits  );
	},
	
	/** @private */
	_setMaskBitsSendGen: function( maskBits )
	{
		Core.Proc.appendToCommandString( ":316,4," + this.__objectRegistryId + "," + maskBits  );
	},
	
	/** @private */
	_setGroupIndexSendGen: function( groupIndex )
	{
		Core.Proc.appendToCommandString( ":316,5," + this.__objectRegistryId + "," + groupIndex  );
	},
	
	/** @private */
	_setFrictionSendGen: function( friction )
	{
		Core.Proc.appendToCommandString( ":316,6," + this.__objectRegistryId + "," + friction  );
	},
	
	/** @private */
	_setRestitutionSendGen: function( restitution )
	{
		Core.Proc.appendToCommandString( ":316,7," + this.__objectRegistryId + "," + restitution  );
	},
	
	/** @private */
	_setDensitySendGen: function( density )
	{
		Core.Proc.appendToCommandString( ":316,8," + this.__objectRegistryId + "," + density  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// destroy: function(  ) {}
	
	// setIsSensor: function( isSensor ) {}
	
	// setCategoryBits: function( categoryBits ) {}
	
	// setMaskBits: function( maskBits ) {}
	
	// setGroupIndex: function( groupIndex ) {}
	
	// setFriction: function( friction ) {}
	
	// setRestitution: function( restitution ) {}
	
	// setDensity: function( density ) {}
	

// {{/Wg Generated Code}}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/World'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/World'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/World'] = exports; var Core = require('NGCore/Client/Core').Core;
var Contact = require('NGCore/Client/Physics2/Contact').Contact;
var Body = require('NGCore/Client/Physics2/Body').Body;

exports.World = Core.Class.subclass(
/** @lends Physics2.World.prototype */
{
	classname: 'World',
	
	/**
	 * @class The <code>World</code> class constructs objects that contain application bodies and support simulation stepping.
	 * Most properties are identical to <a href="http://www.box2d.org/manual.html">properties of the b2Body</a> class
	 * of <code>Box2d</code>.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._bodies = [];
		this._timeStep = 1/60;
		this._timeScale = 1;
		this._maxSteps = 5;
		this._velocityIterations = 10;
		this._positionIterations = 10;
		this._gravity = new Core.Vector(0, 9.8);
		this._debugDrawFlags = 0;
		this._debugDrawGL2Node = null;
		this._contactEmitter = new Core.MessageEmitter();
		
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash
	 */
	destroy: function()
	{
		this._contactEmitter.destroy();
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Retrieve the time step for this <code>World</code>. 
	 * @returns {Number} The current time step.
	 * @see Physics2.World#setTimeStep
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTimeStep: function()
	{
		return this._timeStep;
	},
	
	/**
	 * Set the time step for this <code>World</code>. This method controls how often the physics simulation will perform a time step.
	 * @example var body = new Physics2.Body();
	 * ...
	 * World.setTimeStep(1/30);
	 * @param {Number} [timeStep=1/60] The new time step.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.World#getTimeStep
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setTimeStep: function(timeStep)
	{
		this._timeStep = timeStep;
		this._setTimeStepSendGen(timeStep);
		return this;
	},
	
	/**
	 * Retrieve the time scale for this <code>World</code>.
	 * @returns {Number} The current time scale.
	 * @see Physics2.World#setTimeScale
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTimeScale: function()
	{
		return this._timeScale;
	},
	
	/**
	 * Set the time scale for this <code>World</code>.
	 * For each simulation step, the amount of time that is
	 * simulated by the physics engine is:
	 * <pre class=code>timeStep * timeScale</pre> 
	 * <b>Note:</b> You must set this value as greater than zero (<i>x</i> > 0). Setting this to a value less than one but greater than zero
	 * will cause the <code>World</code> physics to run slower. Setting this to a value greater than one causes the <code>World</code>
	 * physics to run faster.
	 * @example var world = this._world.getTimeScale();
	 * ...
	 * this._world.setTimeScale(world);
	 * @param {Number} [timeScale=1] The new time scale.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.World#getTimeScale
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setTimeScale: function(timeScale)
	{
		this._timeScale = timeScale;
		this._setTimeScaleSendGen(timeScale);
		return this;
	},
	
	/**
	 * Retrieve the maximum number of physics steps for this <code>World</code>.
	 * @returns {Number} The current maximum number of physics steps.
	 * @see Physics2.World#setMaxSteps
	 * @status iOS, Android, Flash
	 */
	getMaxSteps: function()
	{
		return this._maxSteps;
	},
	
	/**
	 * Set the maximum number of physics steps for this <code>World</code>. This method controls the maximum number of
	 * physics steps covered in a single step. This prevents the physics engine from getting too far behind and freezing because it fails to
	 * catch up.
	 * @example var world = new Physics2.World();
	 * ...
	 * world.setMaxStep(3);
	 * @param {Number} [maxSteps=5] The new maxmimum number of physics steps.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.World#getMaxSteps
	 * @status iOS, Android, Flash
	 */
	setMaxSteps: function(maxSteps)
	{
		this._maxSteps = maxSteps;
		this._setMaxStepsSendGen(maxSteps);
		return this;
	},
	
	/**
	 * Retrieve the number of velocity iterations for this <code>World</code>.
	 * @returns {Number} The current number of velocity iterations.
	 * @see Physics2.World#setVelocityIterations
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVelocityIterations: function()
	{
		return this._velocityIterations;
	},
	
	/**
	 * Set the number of velocity iterations for this <code>World</code>.
	 * @example var world = new Physics2.World();
	 * ...
	 * world.setVelocityIterations(5);
	 * @param {Number} [velocityIterations=10] The new number of velocity iterations.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.World#getVelocityIterations
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setVelocityIterations: function(velocityIterations)
	{
		this._velocityIterations = velocityIterations;
		this._setVelocityIterationsSendGen(velocityIterations);
		return this;
	},
	
	/**
	 * Retrieve the number of position iterations for this <code>World</code>.
	 * @returns {Number} The number of position iterations.
	 * @see Physics2.World#setPositionIterations
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPositionIterations: function()
	{
		return this._positionIterations;
	},
	
	/**
	 * Set the number of position iterations for this <code>World</code>.
	 * @example var world = new Physics2.World();
	 * ...
	 * world.setPositionIterations(5);
	 * @param {Number} [positionIterations=10] The new number of position iterations.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.World#getPositionIterations
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setPositionIterations: function(positionIterations)
	{
		this._positionIterations = positionIterations;
		this._setPositionIterationsSendGen(positionIterations);
		return this;
	},
	
	/**
	 * Retrieve the number of bodies in this <code>World</code>.
	 * @returns {Number} The current number of bodies.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBodyCount: function()
	{
		return this._bodies.length;
	},
	
	/**
	 * Retrieve a body at a specific index.
	 * @param {Number} index The specified index.
	 * @returns {Physics2.Body} The body to retrieve.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBody: function(index)
	{
		return this._bodies[index];
	},
	
	/**
	 * Add a body to this <code>World</code>.
	 * @example var p = new Physics2.World(); 
	 * ...
	 * var b = new Physics2.Body();
	 * ...
	 * p.addBody(b);
	 * @param {Physics2.Body} body The body to add.
	 * @see Physics2.World#removeBody
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	addBody: function(body)
	{
		this._bodies.push(body);
		body._didAddToWorld(this);
		
		this._addBodySendGen(Core.ObjectRegistry.objectToId(body));
	},
	
	/**
	 * Remove a body from this <code>World</code>.
	 * @example var p = new Physics2.World(); 
	 * ...
	 * var b = new Physics2.Body();
	 * ...
	 * p.addBody(b);
	 *...
	 * p.removeBody(b);
	 * @param {Physics2.Body} body The body to remove.
	 * @see Physics2.World#addBody
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	removeBody: function(body)
	{
		var index = this._bodies.indexOf(body);
		if(index != -1)
		{
			this._bodies.splice(index, 1);
			body._willRemoveFromWorld(this);
		}
		
		this._removeBodySendGen(Core.ObjectRegistry.objectToId(body));
	},
	
	/**
	 * Retrieve the number of debug draw flags for this <code>World</code>.
	 * @returns {Number} The current number of debug draw flags.
	 * @see Physics2.World#setDebugDrawFlags
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getDebugDrawFlags: function()
	{
		return this._debugDrawFlags;
	},
	
	/**
	 * Set the number of debug draw flags for this <code>World</code>.<br><br>
	 * <b>Note:</b> This value is a bitwise combination of 
	 * <code>DebugDrawFlags</code>.
	 * @example var p = new Physics2.World(); 
	 * ...
	 * p.setDebugDrawFlags(Physics2.World.DebugDrawFlags.Shapes); 
	 * @param {Number} [debugDrawFlags=0] The new number of debug draw flags.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.World#DebugDrawFlags,
	 * @see Physics2.World#getDebugDrawFlags
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setDebugDrawFlags: function(debugDrawFlags)
	{
		if (arguments.length == 0)
			this._debugDrawFlags = 0;
		else
			this._debugDrawFlags = debugDrawFlags;
		
		this._setDebugDrawFlagsSendGen(this._debugDrawFlags);
		
		return this;
	},
	
	/**
	 * Retrieve the debug draw node for this <code>World</code>.
	 * @returns {GL2.Node} The current debug draw node.
	 * @see Physics2.World#setDebugDrawGL2Node
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getDebugDrawGL2Node: function()
	{
		return this._debugDrawGL2Node;
	},
	
	/**
	 * Set the debug draw node for this <code>World</code>. When performing debug drawing,
	 * all of the debug elements will translate as if the elements were children of this node.
	 * This allows debug drawing to accurately maintain camera position, rotation, and scale.
	 * @example var p = new Physics2.World(); 
	 * ...
	 * this._world.setDebugDrawGL2Node(this._root);
	 * @param {GL2.Node} [debugDrawGL2Node=null] The new debug draw node.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.World#getDebugDrawGL2Node
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setDebugDrawGL2Node: function(debugDrawGL2Node)
	{
		this._debugDrawGL2Node = debugDrawGL2Node;
		
		this._setDebugDrawGL2NodeSendGen(Core.ObjectRegistry.objectToId(debugDrawGL2Node));
		
		return this;
	},
	
	/**
	 * Retrieve the gravity applied to this <code>World</code>.
	 * @returns {Core.Vector} The current gravity applied.
	 * @see Physics2.World#setGravity
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getGravity: function()
	{
		return this._gravity;
	},
	
	/**
	 * Set the gravity applied to this <code>World</code>.
	 * @example var p = new Physics2.World(); 
	 * ...
	 * p.setGravity(0, 98);
	 * @param {Core.Vector} [gravity=(0, 9.8)] The new gravity applied.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.World#getGravity
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setGravity: function(gravity)
	{
		var g = this._gravity;
		g.setAll.apply(g, arguments);
		
		this._setGravitySendGen(g.getX(),g.getY());
		
		return this;
	},
	
	/**
	 * Retrieve the contact emitter for this <code>World</code>. This emitter will trigger when contact occurs between two bodies 
	 * and one of the bodies contains contact flags configured for that specific collision.<br><br>
	 * <b>Note:</b> The parameter to the emitter callback is always an instance of <code>Contact</code>.
	 * @returns {Core.MessageEmitter} The current contact emitter.
	 * @see Physics2.Contact
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getContactEmitter: function()
	{
		return this._contactEmitter;
	},
	
	_contactEventRecv: function(cmd)
	{
		var header = {};
		if( ! this._contactEventRecvGen(cmd, header) )
			return;
		
		var contact = new Contact();
		contact._type = header.type;
		contact._shapeA = Core.ObjectRegistry.idToObject(header.shapeA);
		contact._shapeB = Core.ObjectRegistry.idToObject(header.shapeB);
		contact._timestamp = header.timestamp;
		contact._normal = new Core.Vector(header.nx, header.ny);
		contact._locations = [];
		
		var impulses = (contact._type == Body.ContactFlags.Solved);
		
		for(var i=0; i < header.locationCount; ++i)
		{
			var msg = {};
			if( ! this._contactLocationRecvGen(cmd, msg) )
				return;
			
			var location = new Contact.Location();
			location._position = new Core.Point(msg.px, msg.py);
			
			if(impulses)
			{
				var msg = {};
				if( ! this._contactImpulsesRecvGen(cmd, msg) )
					return;

				location._normalImpulse = msg.normalImpulse;
				location._tangentImpulse = msg.tangentImpulse;
			}
			else
			{
				location._normalImpulse = NaN;
				location._tangentImpulse = NaN;
			}
			
			contact._locations.push(location);
		}
		
		this._contactEmitter.emit(contact);
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for debug draw flags.
	 * @namespace
	 */
	DebugDrawFlags:
	{ 
		/** Draw all shapes. */
		Shapes: 1,
		/** Draw all joints. */
		Joints: 2,
		/** Draw all bounding boxes. */
		AABBs: 4,
		/** Draw all pairs that overlap in the broad phase. */
		Pairs: 8,
		/** Draw the center of mass for all bodies. */
		CenterOfMass: 16,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 314
	// Method create = -1
	// Method destroy = 2
	// Method setTimeStep = 3
	// Method setTimeScale = 4
	// Method setMaxSteps = 5
	// Method setVelocityIterations = 6
	// Method setPositionIterations = 7
	// Method setDebugDrawFlags = 8
	// Method setDebugDrawGL2Node = 9
	// Method addBody = 10
	// Method removeBody = 11
	// Method setGravity = 12
	// Method contactEvent = 13
	// Method contactLocation = 14
	// Method contactImpulses = 15
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 13:
					instance._contactEventRecv( cmd );
					break;
				case 14:
					instance._contactLocationRecv( cmd );
					break;
				case 15:
					instance._contactImpulsesRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in World._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in World._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[314] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_contactEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 7 )
		{
			NgLogE("Could not parse due to wrong argument count in World.contactEvent from command: " + cmd );
			return false;
		}
		
		obj[ "type" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "type" ] === undefined )
		{
			NgLogE("Could not parse type in World.contactEvent from command: " + cmd );
			return false;
		}
		
		obj[ "shapeA" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "shapeA" ] === undefined )
		{
			NgLogE("Could not parse shapeA in World.contactEvent from command: " + cmd );
			return false;
		}
		
		obj[ "shapeB" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "shapeB" ] === undefined )
		{
			NgLogE("Could not parse shapeB in World.contactEvent from command: " + cmd );
			return false;
		}
		
		obj[ "timestamp" ] = Core.Proc.parseInt( cmd[ 3 ] );
		if( obj[ "timestamp" ] === undefined )
		{
			NgLogE("Could not parse timestamp in World.contactEvent from command: " + cmd );
			return false;
		}
		
		obj[ "nx" ] = Core.Proc.parseFloat( cmd[ 4 ] );
		if( obj[ "nx" ] === undefined )
		{
			NgLogE("Could not parse nx in World.contactEvent from command: " + cmd );
			return false;
		}
		
		obj[ "ny" ] = Core.Proc.parseFloat( cmd[ 5 ] );
		if( obj[ "ny" ] === undefined )
		{
			NgLogE("Could not parse ny in World.contactEvent from command: " + cmd );
			return false;
		}
		
		obj[ "locationCount" ] = Core.Proc.parseInt( cmd[ 6 ] );
		if( obj[ "locationCount" ] === undefined )
		{
			NgLogE("Could not parse locationCount in World.contactEvent from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 7);
		return true;
	},
	
	/** @private */
	_contactLocationRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 2 )
		{
			NgLogE("Could not parse due to wrong argument count in World.contactLocation from command: " + cmd );
			return false;
		}
		
		obj[ "px" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "px" ] === undefined )
		{
			NgLogE("Could not parse px in World.contactLocation from command: " + cmd );
			return false;
		}
		
		obj[ "py" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "py" ] === undefined )
		{
			NgLogE("Could not parse py in World.contactLocation from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 2);
		return true;
	},
	
	/** @private */
	_contactImpulsesRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 2 )
		{
			NgLogE("Could not parse due to wrong argument count in World.contactImpulses from command: " + cmd );
			return false;
		}
		
		obj[ "normalImpulse" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "normalImpulse" ] === undefined )
		{
			NgLogE("Could not parse normalImpulse in World.contactImpulses from command: " + cmd );
			return false;
		}
		
		obj[ "tangentImpulse" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "tangentImpulse" ] === undefined )
		{
			NgLogE("Could not parse tangentImpulse in World.contactImpulses from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 2);
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":314,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":314,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setTimeStepSendGen: function( timeStep )
	{
		Core.Proc.appendToCommandString( ":314,3," + this.__objectRegistryId + "," + timeStep  );
	},
	
	/** @private */
	_setTimeScaleSendGen: function( timeScale )
	{
		Core.Proc.appendToCommandString( ":314,4," + this.__objectRegistryId + "," + timeScale  );
	},
	
	/** @private */
	_setMaxStepsSendGen: function( maxSteps )
	{
		Core.Proc.appendToCommandString( ":314,5," + this.__objectRegistryId + "," + maxSteps  );
	},
	
	/** @private */
	_setVelocityIterationsSendGen: function( velocityIterations )
	{
		Core.Proc.appendToCommandString( ":314,6," + this.__objectRegistryId + "," + velocityIterations  );
	},
	
	/** @private */
	_setPositionIterationsSendGen: function( positionIterations )
	{
		Core.Proc.appendToCommandString( ":314,7," + this.__objectRegistryId + "," + positionIterations  );
	},
	
	/** @private */
	_setDebugDrawFlagsSendGen: function( debugDrawFlags )
	{
		Core.Proc.appendToCommandString( ":314,8," + this.__objectRegistryId + "," + debugDrawFlags  );
	},
	
	/** @private */
	_setDebugDrawGL2NodeSendGen: function( debugDrawGL2Node )
	{
		Core.Proc.appendToCommandString( ":314,9," + this.__objectRegistryId + "," + debugDrawGL2Node  );
	},
	
	/** @private */
	_addBodySendGen: function( body )
	{
		Core.Proc.appendToCommandString( ":314,10," + this.__objectRegistryId + "," + body  );
	},
	
	/** @private */
	_removeBodySendGen: function( body )
	{
		Core.Proc.appendToCommandString( ":314,11," + this.__objectRegistryId + "," + body  );
	},
	
	/** @private */
	_setGravitySendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":314,12," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setTimeStep: function( timeStep ) {}
	
	// setTimeScale: function( timeScale ) {}
	
	// setMaxSteps: function( maxSteps ) {}
	
	// setVelocityIterations: function( velocityIterations ) {}
	
	// setPositionIterations: function( positionIterations ) {}
	
	// setDebugDrawFlags: function( debugDrawFlags ) {}
	
	// setDebugDrawGL2Node: function( debugDrawGL2Node ) {}
	
	// addBody: function( body ) {}
	
	// removeBody: function( body ) {}
	
	// setGravity: function( x, y ) {}
	
	// _contactEventRecv: function( cmd ) {}
	// _contactLocationRecv: function( cmd ) {}
	// _contactImpulsesRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/Joint'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/Joint'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/Joint'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Joint = Core.Class.subclass(
/** @lends Physics2.Joint.prototype */
{
	classname: 'Joint',
	
	/**
	 * @class The <code>Joint</code> class is a base class for constructing objects that connect two application bodies (see <code>{@link Physics2.Body}</code>).
	 * Most properties are identical to <a href="http://www.box2d.org/manual.html">properties of the b2Joint</a> class
	 * of <code>Box2d</code>.<br><br>
	 * <b>Caution!:</b> Do not instantiate this class directly. Use classes derived from <code>Joint</code> for instantiation. This includes:
	 * <div class="ul">
	 * <li>{@link Physics2.DistanceJoint}</li>
	 * <li>{@link Physics2.MouseJoint}</li>
	 * <li>{@link Physics2.PrismaticJoint}</li>
	 * <li>{@link Physics2.RevoluteJoint}</li>
	 * <li>{@link Physics2.WeldJoint}</li>
	 * </div>
	 * @constructs The default constructor. 	
	 * @augments Core.Class
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._bodyA = null;
		this._bodyB = null;
		this._collideConnected = false;
		
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Retrieve the first connected body for this <code>Joint</code>.
	 * @returns {Physics2.Body} The current first connected body.
	 * @see Physics2.Joint#setBodyA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBodyA: function()
	{
		return this._bodyA;
	},
	
	/**
	 * Set the first connected body for this <code>Joint</code>.
	 * @example var b1 = makeCircle([w*1/3+32*-1, h*1/8], 16);
	 * ...
	 * b1.setContactFlags(Physics2.Body.ContactFlags.All);
	 * ...
	 * var joint = new Physics2.DistanceJoint();
	 * joint.setBodyA(b1);
	 * @param {Physics2.Body} bodyA The new first connected body.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Joint#getBodyA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setBodyA: function(bodyA)
	{
		//Let prev body know it was detached from this joint
		if(this._bodyA!=null)
			this._bodyA._willRemoveFromJoint(this);

		//Assign new body
		this._bodyA = bodyA;

		//Let new body know it was attached to this joint
		if(bodyA!=null)
			bodyA._didAddToJoint(this);

		this._setBodyASendGen( (bodyA == null) ? -1 : Core.ObjectRegistry.objectToId(bodyA) );
		return this;
	},
	
	/**
	 * Retrieve the second connected body for this <code>Joint</code>.
	 * @returns {Physics2.Body} The current second connected body.
	 * @see Physics2.Joint#setBodyB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBodyB: function()
	{
		return this._bodyB;
	},
	
	/**
	 * Set the second connected body for this <code>Joint</code>.
	 * @example var b2 = makeCircle([w*1/3+32*0, h*1/8], 16);
	 * ...
	 * b2.setContactFlags(Physics2.Body.ContactFlags.All);
	 * ...
	 * var joint = new Physics2.DistanceJoint();
	 * joint.setBodyB(b2);
	 * @param {Physics2.Body} bodyB The new second connected body.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Joint#getBodyB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setBodyB: function(bodyB)
	{
		//Let prev body know it was detached from this joint
		if(this._bodyB!=null)
			this._bodyB._willRemoveFromJoint(this);

		//Assign new body
		this._bodyB = bodyB;

		//Let new body know it was attached to this joint
		if(bodyB!=null)
			bodyB._didAddToJoint(this);

		this._setBodyBSendGen( (bodyB == null) ? -1 : Core.ObjectRegistry.objectToId(bodyB) );
		return this;
	},
	
	/**
	 * Retrieve whether two connected bodies collide with each other.
	 * @returns {Boolean} Returns <code>true</code> if connected bodies collide. Returns <code>false</code> in all other cases.
	 * @see Physics2.Joint#setCollideConnected
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getCollideConnected: function()
	{
		return this._collideConnected;
	},
	
	/**
	 * Set whether two connected bodies collide with each other.
	 * @param {Boolean} [collideConnected=false] Set as <code>true</code> if connected bodies collide.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Joint#getCollideConnected
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setCollideConnected: function(collideConnected)
	{
		this._collideConnected = collideConnected;
		this._setCollideConnectedSendGen(collideConnected);
		return this;
	},
	
	_removeBody: function(body)
	{
		if(body==bodyA)
			this.setBodyA(null);
		if(body==bodyB)
			this.setBodyB(null);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 320
	// Method destroy = 1
	// Method setBodyA = 2
	// Method setBodyB = 3
	// Method setCollideConnected = 4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Joint._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Joint._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[320] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":320,1," + this.__objectRegistryId );
	},
	
	/** @private */
	_setBodyASendGen: function( bodyA )
	{
		Core.Proc.appendToCommandString( ":320,2," + this.__objectRegistryId + "," + bodyA  );
	},
	
	/** @private */
	_setBodyBSendGen: function( bodyB )
	{
		Core.Proc.appendToCommandString( ":320,3," + this.__objectRegistryId + "," + bodyB  );
	},
	
	/** @private */
	_setCollideConnectedSendGen: function( collideConnected )
	{
		Core.Proc.appendToCommandString( ":320,4," + this.__objectRegistryId + "," + ( collideConnected ? 1 : 0 )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// destroy: function(  ) {}
	
	// setBodyA: function( bodyA ) {}
	
	// setBodyB: function( bodyB ) {}
	
	// setCollideConnected: function( collideConnected ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/DistanceJoint'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/DistanceJoint'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/DistanceJoint'] = exports; var Joint = require('NGCore/Client/Physics2/Joint').Joint;
var Core = require('NGCore/Client/Core').Core;

exports.DistanceJoint = Joint.subclass(
/** @lends Physics2.DistanceJoint.prototype */
{
	classname: 'DistanceJoint',
	
	/**
	 * @class The <code>DistanceJoint</code> class constructs objects that restrict the distance between two bodies
	 * but does not constrain their rotation (see <code>{@link Physics2.Body}</code>).
	 * @constructs The default constructor. 
	 * @augments Physics2.Joint
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._localAnchorA = new Core.Point();
		this._localAnchorB = new Core.Point();
		this._length = 0;
		this._frequency = 0;
		this._dampingRatio = 0;
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the local anchor point for the first connected body.
	 * @returns {Core.Point} The current local anchor point for the first body.
	 * @see Physics2.DistanceJoint#setLocalAnchorA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocalAnchorA: function()
	{
		return this._localAnchorA;
	},
	
	/**
	 * Set the local anchor point for the first connected body.
	 * @example var joint = new Physics2.DistanceJoint();
	 * joint.setLocalAnchorA(0, 16);
	 * @param {Core.Point} [localAnchorA=(0, 0)] The new local anchor point for the first body.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.DistanceJoint#getLocalAnchorA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLocalAnchorA: function(localAnchorA)
	{
		var l = this._localAnchorA;
		l.setAll.apply(l, arguments);
		this._setLocalAnchorASendGen(l.getX(),l.getY());
		return this;
	},
	
	/**
	 * Retrieve the local anchor point for the second connected body.
	 * @returns {Core.Point} The current local anchor point for the second body.
	 * @see Physics2.DistanceJoint#setLocalAnchorB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocalAnchorB: function()
	{
		return this._localAnchorB;
	},
	
	/**
	 * Set the local anchor point for the second connected body.
	 * @example var joint = new Physics2.DistanceJoint();
	 * joint.setLocalAnchorB(0, -16);
	 * @param {Core.Point} [localAnchorB=(0, 0)] The new local anchor point for the second body.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.DistanceJoint#getLocalAnchorB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLocalAnchorB: function(localAnchorB)
	{
		var l = this._localAnchorB;
		l.setAll.apply(l, arguments);
		this._setLocalAnchorBSendGen(l.getX(),l.getY());
		return this;
	},
	
	/**
	 * Retrieve the joint length for this <code>DistanceJoint</code>.
	 * @returns {Number} The current joint length.
	 * @see Physics2.DistanceJoint#setLength
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLength: function()
	{
		return this._length;
	},
	
	/**
	 * Set the joint length for this <code>DistanceJoint</code>.
	 * @example var joint = new Physics2.DistanceJoint();
	 * joint.setLength(48);
	 * @param {Number} [length=0] The new joint length.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.DistanceJoint#getLength
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLength: function(length)
	{
		this._length = length;
		this._setLengthSendGen(length);
		return this;
	},
	
	/**
	 * Retrieve the damping frequency of this <code>DistanceJoint</code>.
	 * @returns {Number} The current damping frequency.
	 * @see Physics2.DistanceJoint#setFrequency
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrequency: function()
	{
		return this._frequency;
	},
	
	/**
	 * Set the damping frequency for this <code>DistanceJoint</code>.
	 * @example var joint = new Physics2.DistanceJoint();
	 * joint.setFrequency(1);
	 * @param {Number} [frequency=0] The new damping frequency.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.DistanceJoint#getFrequency
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setFrequency: function(frequency)
	{
		this._frequency = frequency;
		this._setFrequencySendGen(frequency);
		return this;
	},
	
	/**
	 * Retrieve the damping ratio of this <code>DistanceJoint</code>.
	 * @returns {Number} The current damping ratio.
	 * @see Physics2.DistanceJoint#setDampingRatio
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getDampingRatio: function()
	{
		return this._dampingRatio;
	},
	
	/**
	 * Set the damping ratio for this <code>DistanceJoint</code>.
	 * @example var joint = new Physics2.DistanceJoint();
	 * joint.setDampingRatio(10);
	 * @param {Number} [dampingRatio=0] The new damping ratio.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.DistanceJoint#setDampingRatio
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setDampingRatio: function(dampingRatio)
	{
		this._dampingRatio = dampingRatio;
		this._setDampingRatioSendGen(dampingRatio);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 321
	// Method create = -1
	// Method destroy = 2
	// Method setLocalAnchorA = 3
	// Method setLocalAnchorB = 4
	// Method setLength = 5
	// Method setFrequency = 6
	// Method setDampingRatio = 7
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in DistanceJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in DistanceJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[321] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":321,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":321,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setLocalAnchorASendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":321,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setLocalAnchorBSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":321,4," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setLengthSendGen: function( length )
	{
		Core.Proc.appendToCommandString( ":321,5," + this.__objectRegistryId + "," + length  );
	},
	
	/** @private */
	_setFrequencySendGen: function( frequency )
	{
		Core.Proc.appendToCommandString( ":321,6," + this.__objectRegistryId + "," + frequency  );
	},
	
	/** @private */
	_setDampingRatioSendGen: function( dampingRatio )
	{
		Core.Proc.appendToCommandString( ":321,7," + this.__objectRegistryId + "," + dampingRatio  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setLocalAnchorA: function( x, y ) {}
	
	// setLocalAnchorB: function( x, y ) {}
	
	// setLength: function( length ) {}
	
	// setFrequency: function( frequency ) {}
	
	// setDampingRatio: function( dampingRatio ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/MouseJoint'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/MouseJoint'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/MouseJoint'] = exports; var Joint = require('NGCore/Client/Physics2/Joint').Joint;
var Core = require('NGCore/Client/Core').Core;

exports.MouseJoint = Joint.subclass(
/** @lends Physics2.MouseJoint.prototype */
{
	classname: 'MouseJoint',
	
	/**
	 * @class The <code>MouseJoint</code> class constructs objects that apply a force for moving an application body to a specific point (see <code>{@link Physics2.Body}</code>).
	 * @constructs The default constructor. 
	 * @augments Physics2.Joint
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._target = new Core.Point();
		this._maxForce = 0;
		this._frequency = 0;
		this._dampingRatio = 0;
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the target location that applies to this <code>MouseJoint</code>.
	 * @returns {Core.Point} The current target location.
	 * @see Physics2.MouseJoint#setTarget
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTarget: function()
	{
		return this._;
	},
	
	/**
	 * Set the target location that applies to this <code>MouseJoint</code>.
	 * @example var circle = makeCircle([w/2, h*6/8], 16);
	 * ...
	 * joint.setTarget(c.getPosition());
	 * @param {Core.Point} [target=(0, 0)] The new target location.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.MouseJoint#getTarget
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setTarget: function(target)
	{
		var t = this._target;
		t.setAll(arguments);
		this._setTargetSendGen(t.getX(),t.getY());
		return this;
	},
	
	/**
	 * Retrieve the maximum force applied by this <code>MouseJoint</code>.
	 * @returns {Number} The current maximum force applied.
	 * @see Physics2.MouseJoint#setMaxForce
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMaxForce: function()
	{
		return this._maxForce;
	},
	
	/**
	 * Set the maximum force applied by this <code>MouseJoint</code>.
	 * @example var joint = new Physics2.MouseJoint();
	 * joint.setMaxForce(20);
	 * @param {Number} [maxForce=0] The new maximum force applied.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.MouseJoint#getMaxForce
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setMaxForce: function(maxForce)
	{
		this._maxForce = maxForce;
		this._setMaxForceSendGen(maxForce);
		return this;
	},
	
	/**
	 * Retrieve the damping frequency that applies to this <code>MouseJoint</code>.
	 * @returns {Number} The current damping frequency.
	 * @see Physics2.MouseJoint#setFrequency
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrequency: function()
	{
		return this._frequency;
	},
	
	/**
	 * Set the damping frequency that applies to this <code>MouseJoint</code>.
	 * @param {Number} [frequency=0] The new damping frequency.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.MouseJoint#getFrequency
	 */
	setFrequency: function(frequency)
	{
		this._frequency = frequency;
		this._setFrequencySendGen(frequency);
		return this;
	},
	
	/**
	 * Retrieve the damping ratio that applies to this <code>MouseJoint</code>.
	 * @returns {Number} The current damping ratio.
	 * @see Physics2.MouseJoint#setDampingRatio
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getDampingRatio: function()
	{
		return this._dampingRatio;
	},
	
	/**
	 * Set the damping ratio that applies to this <code>MouseJoint</code>.
	 * @param {Number} [dampingRatio=0] The new damping ratio.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.MouseJoint#getDampingRatio
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setDampingRatio: function(dampingRatio)
	{
		this._dampingRatio = dampingRatio;
		this._setDampingRatioSendGen(dampingRatio);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 322
	// Method create = -1
	// Method destroy = 2
	// Method setTarget = 3
	// Method setMaxForce = 4
	// Method setFrequency = 5
	// Method setDampingRatio = 6
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in MouseJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in MouseJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[322] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":322,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":322,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setTargetSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":322,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setMaxForceSendGen: function( maxForce )
	{
		Core.Proc.appendToCommandString( ":322,4," + this.__objectRegistryId + "," + maxForce  );
	},
	
	/** @private */
	_setFrequencySendGen: function( frequency )
	{
		Core.Proc.appendToCommandString( ":322,5," + this.__objectRegistryId + "," + frequency  );
	},
	
	/** @private */
	_setDampingRatioSendGen: function( dampingRatio )
	{
		Core.Proc.appendToCommandString( ":322,6," + this.__objectRegistryId + "," + dampingRatio  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setTarget: function( x, y ) {}
	
	// setMaxForce: function( maxForce ) {}
	
	// setFrequency: function( frequency ) {}
	
	// setDampingRatio: function( dampingRatio ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/PrismaticJoint'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/PrismaticJoint'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/PrismaticJoint'] = exports; var Joint = require('NGCore/Client/Physics2/Joint').Joint;
var Core = require('NGCore/Client/Core').Core;

exports.PrismaticJoint = Joint.subclass(
/** @lends Physics2.PrismaticJoint.prototype */
{
	classname: 'PrismaticJoint',
	
	/**
	 * @class The <code>PrismaticJoint</code> class constructs objects that confine movement of two application bodies 
	 * along a specific axis (see <code>{@link Physics2.Body}</code>). This concept is similar to how a piston functions. 
	 * Movement is confined to bodies moving either towards or away from each other.
	 * @constructs The default constructor. 
	 * @augments Physics2.Joint
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._localAnchorA = new Core.Point();
		this._localAnchorB = new Core.Point();
		this._localAxis = new Core.Vector();
		this._referenceRotation = 0;
		this._enableLimit = false;
		this._lowerTranslation = 0;
		this._upperTranslation = 0;
		this._enableMotor = false;
		this._motorSpeed = 0;
		this._maxMotorForce = 0;
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the local anchor point for the first connected body.
	 * @returns {Core.Point} The current local anchor point for the first connected body.
	 * @see Physics2.PrismaticJoint#setLocalAnchorA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocalAnchorA: function()
	{
		return this._localAnchorA;
	},
	
	/**
	 * Set the local anchor point for the first connected body.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setLocalAnchorA(25, 0);
	 * @param {Core.Point} [localAnchorA=(0,0)] The new local anchor point for the first connected body.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getLocalAnchorA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLocalAnchorA: function(localAnchorA)
	{
		var l = this._localAnchorA;
		l.setAll.apply(l, arguments);
		this._setLocalAnchorASendGen(l.getX(),l.getY());
		return this;
	},
	
	/**
	 * Retrieve the local anchor point for the second connected body.
	 * @returns {Core.Point} The current local anchor point for the second connected body.
	 * @see Physics2.PrismaticJoint#setLocalAnchorB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocalAnchorB: function()
	{
		return this._localAnchorB;
	},
	
	/**
	 * Set the local anchor point for the second connected body.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setLocalAnchorB(-25, 0);
	 * @param {Core.Point} [localAnchorB=(0,0)] The new local anchor point for the second connected body.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getLocalAnchorB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLocalAnchorB: function(localAnchorB)
	{
		var l = this._localAnchorB;
		l.setAll.apply(l, arguments);
		this._setLocalAnchorBSendGen(l.getX(),l.getY());
		return this;
	},
	
	/**
	 * Retrieve the local axis of movement for this <code>PrismaticJoint</code>.
	 * @returns {Core.Vector} The current local axis of movement.
	 * @see Physics2.PrismaticJoint#setLocalAxis
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocalAxis: function()
	{
		return this._localAxis;
	},
	
	/**
	 * Set the local axis of movement for this <code>PrismaticJoint</code>.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setLocalAxis(0, -1);
	 * @param {Core.Vector} [localAxis=(0,0)] The new local axis of movement.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getLocalAxis
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLocalAxis: function(localAxis)
	{
		var a = this._localAxis;
		a.setAll(arguments);
		this._setLocalAxisSendGen(a.getX(),a.getY());
		return this;
	},
	
	/**
	 * Retrieve the reference rotation for this <code>PrismaticJoint</code>.
	 * @returns {Number} The current reference rotation.
	 * @see Physics2.PrismaticJoint#setReferenceRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getReferenceRotation: function()
	{
		return this._referenceRotation;
	},
	
	/**
	 * Set the reference rotation for this <code>PrismaticJoint</code>.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setReferenceRotation(-90);
	 * @param {Number} [refereceRotation=0] The new reference rotation.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getReferenceRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setReferenceRotation: function(referenceRotation)
	{
		this._referenceRotation = referenceRotation;
		this._setReferenceRotationSendGen(referenceRotation);
		return this;
	},
	
	/**
	 * Retrieve whether the range limiter is enabled for this <code>PrismaticJoint</code>.
	 * @returns {Boolean} Returns <code>true</code> if range limiter is enabled.
	 * @see Physics2.PrismaticJoint#setEnableLimit
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getEnableLimit: function()
	{
		return this._enableLimit;
	},
	
	/**
	 * Set whether the range limiter is enabled for this <code>PrismaticJoint</code>.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setEnableLimit(true);
	 * @param {Boolean} [enableLimit=false] Set as <code>true</code> to enable the range limiter.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getEnableLimit
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setEnableLimit: function(enableLimit)
	{
		this._enableLimit = enableLimit;
		this._setEnableLimitSendGen(enableLimit);
		return this;
	},
	
	/**
	 * Retrieve the lower range limit for this <code>PrismaticJoint</code>.
	 * @returns {Number} The current lower range limit.
	 * @see Physics2.PrismaticJoint#setLowerTranslation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLowerTranslation: function()
	{
		return this._lowerTranslation;
	},
	
	/**
	 * Set the lower range limit for this <code>PrismaticJoint</code>.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setLowerTranslation(0);
	 * @param {Number} [lowerTranslation=0] The new lower range limit.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getLowerTranslation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLowerTranslation: function(lowerTranslation)
	{
		this._lowerTranslation = lowerTranslation;
		this._setLowerTranslationSendGen(lowerTranslation);
		return this;
	},
	
	/**
	 * Retrieve the upper range limit for this <code>PrismaticJoint</code>.
	 * @returns {Number} The current upper range limit.
	 * @see Physics2.PrismaticJoint#setUpperTranslation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getUpperTranslation: function()
	{
		return this._upperTranslation;
	},
	
	/**
	 * Set the upper range limit for this <code>PrismaticJoint</code>.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setUpperTranslation(32);
	 * @param {Number} [upperTranslation=0] The new upper range limit.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getUpperTranslation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setUpperTranslation: function(upperTranslation)
	{
		this._upperTranslation = upperTranslation;
		this._setUpperTranslationSendGen(upperTranslation);
		return this;
	},
	
	/**
	 * Retrieve whether the motor is enabled for this <code>PrismaticJoint</code>.
	 * @returns {Boolean} Returns <code>true</code> if the motor is eanbled.
	 * @see Physics2.PrismaticJoint#setEnableMotor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getEnableMotor: function()
	{
		return this._enableMotor;
	},
	
	/**
	 * Set whether the motor is enabled for this <code>PrismaticJoint</code>.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setEnableMotor(true);
	 * @param {Boolean} [enableMotor=false] Set as <code>true</code> if the motor is eanbled.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getEnableMotor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setEnableMotor: function(enableMotor)
	{
		this._enableMotor = enableMotor;
		this._setEnableMotorSendGen(enableMotor);
		return this;
	},
	
	/**
	 * Retrieve the motor speed for this <code>PrismaticJoint</code>.
	 * @returns {Number} The current motor speed.
	 * @see Physics2.PrismaticJoint#setMotorSpeed
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested 
	 */
	getMotorSpeed: function()
	{
		return this._motorSpeed;
	},
	
	/**
	 * Set the motor speed for this <code>PrismaticJoint</code>.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setMotorSpeed(1);
	 * @param {Number} [motorSpeed=0] The new motor speed.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getMotorSpeed
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setMotorSpeed: function(motorSpeed)
	{
		this._motorSpeed = motorSpeed;
		this._setMotorSpeedSendGen(motorSpeed);
		return this;
	},
	
	/**
	 * Retrieve the max motor force applied by this <code>PrismaticJoint</code>.
	 * @returns {Number} The current max motor force.
	 * @see Physics2.PrismaticJoint#setMaxMotorForce
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMaxMotorForce: function()
	{
		return this._maxMotorForce;
	},
	
	/**
	 * Set the max motor force applied by this <code>PrismaticJoint</code>.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setMaxMotorForce(1);
	 * @param {Number} [maxMotorForce=0] The new max motor force.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getMaxMotorForce
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setMaxMotorForce: function(maxMotorForce)
	{
		this._maxMotorForce = maxMotorForce;
		this._setMaxMotorForceSendGen(maxMotorForce);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 323
	// Method create = -1
	// Method destroy = 2
	// Method setLocalAnchorA = 3
	// Method setLocalAnchorB = 4
	// Method setLocalAxis = 5
	// Method setReferenceRotation = 6
	// Method setEnableLimit = 7
	// Method setLowerTranslation = 8
	// Method setUpperTranslation = 9
	// Method setEnableMotor = 10
	// Method setMotorSpeed = 11
	// Method setMaxMotorForce = 12
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in PrismaticJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in PrismaticJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[323] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":323,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":323,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setLocalAnchorASendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":323,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setLocalAnchorBSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":323,4," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setLocalAxisSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":323,5," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setReferenceRotationSendGen: function( referenceRotation )
	{
		Core.Proc.appendToCommandString( ":323,6," + this.__objectRegistryId + "," + referenceRotation  );
	},
	
	/** @private */
	_setEnableLimitSendGen: function( enableLimit )
	{
		Core.Proc.appendToCommandString( ":323,7," + this.__objectRegistryId + "," + ( enableLimit ? 1 : 0 )  );
	},
	
	/** @private */
	_setLowerTranslationSendGen: function( lowerTranslation )
	{
		Core.Proc.appendToCommandString( ":323,8," + this.__objectRegistryId + "," + lowerTranslation  );
	},
	
	/** @private */
	_setUpperTranslationSendGen: function( upperTranslation )
	{
		Core.Proc.appendToCommandString( ":323,9," + this.__objectRegistryId + "," + upperTranslation  );
	},
	
	/** @private */
	_setEnableMotorSendGen: function( enableMotor )
	{
		Core.Proc.appendToCommandString( ":323,10," + this.__objectRegistryId + "," + ( enableMotor ? 1 : 0 )  );
	},
	
	/** @private */
	_setMotorSpeedSendGen: function( motorSpeed )
	{
		Core.Proc.appendToCommandString( ":323,11," + this.__objectRegistryId + "," + motorSpeed  );
	},
	
	/** @private */
	_setMaxMotorForceSendGen: function( maxMotorForce )
	{
		Core.Proc.appendToCommandString( ":323,12," + this.__objectRegistryId + "," + maxMotorForce  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setLocalAnchorA: function( x, y ) {}
	
	// setLocalAnchorB: function( x, y ) {}
	
	// setLocalAxis: function( x, y ) {}
	
	// setReferenceRotation: function( referenceRotation ) {}
	
	// setEnableLimit: function( enableLimit ) {}
	
	// setLowerTranslation: function( lowerTranslation ) {}
	
	// setUpperTranslation: function( upperTranslation ) {}
	
	// setEnableMotor: function( enableMotor ) {}
	
	// setMotorSpeed: function( motorSpeed ) {}
	
	// setMaxMotorForce: function( maxMotorForce ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/RevoluteJoint'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/RevoluteJoint'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/RevoluteJoint'] = exports; var Joint = require('NGCore/Client/Physics2/Joint').Joint;
var Core = require('NGCore/Client/Core').Core;

exports.RevoluteJoint = Joint.subclass(
/** @lends Physics2.RevoluteJoint.prototype */
{
	classname: 'RevoluteJoint',
	
	/**
	 * @class The <code>RevoluteJoint</code> class constructs objects that confine movement of two application bodies, 
	 * rotating the bodies around a specified point (see {@link Physics2.Body}. This concept is similar to how a hinge functions.
	 * @constructs The default constructor. 
	 * @see Physics2.Body
	 * @augments Physics2.Joint
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._localAnchorA = new Core.Point();
		this._localAnchorB = new Core.Point();
		this._referenceRotation = 0;
		this._enableLimit = false;
		this._lowerRotation = 0;
		this._upperRotation = 0;
		this._enableMotor = false;
		this._motorSpeed = 0;
		this._maxMotorTorque = 0;
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the local anchor point for the first connected body.
	 * @returns {Core.Point} The current local anchor point for the first connected body.
	 * @see Physics2.RevoluteJoint#setLocalAnchorA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocalAnchorA: function()
	{
		return this._localAnchorA;
	},
	
	/**
	 * Set the local anchor point for the first connected body.
	 * @example var joint = new Physics2.RevoluteJoint();
	 * ...
	 * joint.setLocalAnchorA(25, 0);
	 * @param {Core.Point} [localAnchorA=(0,0)] The new local anchor point.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.RevoluteJoint#getLocalAnchorA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLocalAnchorA: function(localAnchorA)
	{
		var l = this._localAnchorA;
		l.setAll.apply(l, arguments);
		this._setLocalAnchorASendGen(l.getX(),l.getY());
		return this;
	},
	
	/**
	 * Retrieve the local anchor point for the second connected body.
	 * @returns {Core.Point} The current local anchor point for the second connected body.
	 * @see Physics2.RevoluteJoint#setLocalAnchorB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocalAnchorB: function()
	{
		return this._localAnchorB;
	},
	
	/**
	 * Set the local anchor point for the second connected body.
	 * @example var joint = new Physics2.RevoluteJoint();
	 * ...
	 * joint.setLocalAnchorB(-25, 0);
	 * @param {Core.Point} [localAnchorB=(0,0)] The new local anchor point.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.RevoluteJoint#getLocalAnchorB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLocalAnchorB: function(localAnchorB)
	{
		var l = this._localAnchorB;
		l.setAll.apply(l, arguments);
		this._setLocalAnchorBSendGen(l.getX(),l.getY());
		return this;
	},
	
	/**
	 * Retrieve the reference rotation for this <code>RevoluteJoint</code>.
	 * @returns {Number} The current reference rotation.
	 * @see Physics2.RevoluteJoint#setReferenceRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getReferenceRotation: function()
	{
		return this._referenceRotation;
	},
	
	/**
	 * Set the reference rotation for this <code>RevoluteJoint</code>.
	 * @example var joint = new Physics2.RevoluteJoint();
	 * ...
	 * joint.setReferenceRotation(-90);
	 * @param {Number} [refereceRotation=0] The new reference rotation.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.RevoluteJoint#getReferenceRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setReferenceRotation: function(referenceRotation)
	{
		this._referenceRotation = referenceRotation;
		this._setReferenceRotationSendGen(referenceRotation);
		return this;
	},
	
	/**
	 * Retrieve whether the range limiter is enabled  for this <code>RevoluteJoint</code>.
	 * @returns {Boolean} Returns <cod>true</code> if the range limiter is enabled.
	 * @see Physics2.RevoluteJoint#setEnableLimit
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getEnableLimit: function()
	{
		return this._enableLimit;
	},
	
	/**
	 * Set whether the range limiter is enabled for this <code>RevoluteJoint</code>.
	 * @example var joint = new Physics2.RevoluteJoint();
	 * ...
	 * joint.setEnableLimit(true);
	 * @param {Boolean} [enableLimit=false] Set as <code>true</code> if the range limiter is enabled.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.RevoluteJoint#getEnableLimit
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setEnableLimit: function(enableLimit)
	{
		this._enableLimit = enableLimit;
		this._setEnableLimitSendGen(enableLimit);
		return this;
	},
	
	/**
	 * Retrieve the lower range limit for this <code>RevoluteJoint</code>.
	 * @returns {Number} The current lower range limit.
	 * @see Physics2.RevoluteJoint#setLowerRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLowerRotation: function()
	{
		return this._lowerRotation;
	},
	
	/**
	 * Set the lower range limit for this <code>RevoluteJoint</code>.
	 * @example var joint = new Physics2.RevoluteJoint();
	 * ...
	 * joint.setLowerRotation(-30);
	 * @param {Number} [lowerRotation=0] The new lower range limit.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.RevoluteJoint#getLowerRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLowerRotation: function(lowerRotation)
	{
		this._lowerRotation = lowerRotation;
		this._setLowerRotationSendGen(lowerRotation);
		return this;
	},
	
	/**
	 * Retrieve the upper range limit for this <code>RevoluteJoint</code>.
	 * @returns {Number} The current upper range limit.
	 * @see Physics2.RevoluteJoint#setUpperRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getUpperRotation: function()
	{
		return this._upperRotation;
	},
	
	/**
	 * Set the upper range limit for this <code>RevoluteJoint</code>.
	 * @example var joint = new Physics2.RevoluteJoint();
	 * ...
	 * joint.setUpperRotation(30);
	 * @param {Number} [upperRotation=0] The new upper range limit.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.RevoluteJoint#getUpperRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setUpperRotation: function(upperRotation)
	{
		this._upperRotation = upperRotation;
		this._setUpperRotationSendGen(upperRotation);
		return this;
	},
	
	/**
	 * Retrieve whether the motor is enabled for this <code>RevoluteJoint</code>.
	 * @returns {Boolean} Returns <code>true</code> if the motor is enabled.
	 * @see Physics2.RevoluteJoint#setEnableMotor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getEnableMotor: function()
	{
		return this._enableMotor;
	},
	
	/**
	 * Set whether the motor is enabled for this <code>RevoluteJoint</code>.
	 * @example var joint = new Physics2.RevoluteJoint();
	 * ...
	 * joint.setEnableMotor(true);
	 * @param {Boolean} [enableMotor=false] Set as <code>true</code> if the motor is enabled.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.RevoluteJoint#getEnableMotor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setEnableMotor: function(enableMotor)
	{
		this._enableMotor = enableMotor;
		this._setEnableMotorSendGen(enableMotor);
		return this;
	},
	
	/**
	 * Retrieve the motor speed applied by this <code>RevoluteJoint</code>.
	 * @returns {Number} The current motor speed.
	 * @see Physics2.RevoluteJoint#setMotorSpeed
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMotorSpeed: function()
	{
		return this._motorSpeed;
	},
	
	/**
	 * Set the motor speed applied by this <code>RevoluteJoint</code>.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setMotorSpeed(1);
	 * @param {Number} [motorSpeed=0] The new motor speed.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.RevoluteJoint#getMotorSpeed
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setMotorSpeed: function(motorSpeed)
	{
		this._motorSpeed = motorSpeed;
		this._setMotorSpeedSendGen(motorSpeed);
		return this;
	},
	
	/**
	 * Retrieve the max motor torque applied by this <code>RevoluteJoint</code>.
	 * @returns {Number} The current max motor torque.
	 * @see Physics2.RevoluteJoint#setMaxMotorTorque
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMaxMotorTorque: function()
	{
		return this._maxMotorTorque;
	},
	
	/**
	 * Set the max motor torque applied by this <code>RevoluteJoint</code>.
	 * @example var joint = new Physics2.RevoluteJoint();
	 * ...
	 * joint.setMaxMotorTorque(1);
	 * @param {Number} [maxMotorTorque=0] The new max motor torque.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.RevoluteJoint#getMaxMotorTorque
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setMaxMotorTorque: function(maxMotorTorque)
	{
		this._maxMotorTorque = maxMotorTorque;
		this._setMaxMotorTorqueSendGen(maxMotorTorque);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 324
	// Method create = -1
	// Method destroy = 2
	// Method setLocalAnchorA = 3
	// Method setLocalAnchorB = 4
	// Method setReferenceRotation = 5
	// Method setEnableLimit = 6
	// Method setLowerRotation = 7
	// Method setUpperRotation = 8
	// Method setEnableMotor = 9
	// Method setMotorSpeed = 10
	// Method setMaxMotorTorque = 11
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in RevoluteJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in RevoluteJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[324] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":324,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":324,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setLocalAnchorASendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":324,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setLocalAnchorBSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":324,4," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setReferenceRotationSendGen: function( referenceRotation )
	{
		Core.Proc.appendToCommandString( ":324,5," + this.__objectRegistryId + "," + referenceRotation  );
	},
	
	/** @private */
	_setEnableLimitSendGen: function( enableLimit )
	{
		Core.Proc.appendToCommandString( ":324,6," + this.__objectRegistryId + "," + ( enableLimit ? 1 : 0 )  );
	},
	
	/** @private */
	_setLowerRotationSendGen: function( lowerRotation )
	{
		Core.Proc.appendToCommandString( ":324,7," + this.__objectRegistryId + "," + lowerRotation  );
	},
	
	/** @private */
	_setUpperRotationSendGen: function( upperRotation )
	{
		Core.Proc.appendToCommandString( ":324,8," + this.__objectRegistryId + "," + upperRotation  );
	},
	
	/** @private */
	_setEnableMotorSendGen: function( enableMotor )
	{
		Core.Proc.appendToCommandString( ":324,9," + this.__objectRegistryId + "," + ( enableMotor ? 1 : 0 )  );
	},
	
	/** @private */
	_setMotorSpeedSendGen: function( motorSpeed )
	{
		Core.Proc.appendToCommandString( ":324,10," + this.__objectRegistryId + "," + motorSpeed  );
	},
	
	/** @private */
	_setMaxMotorTorqueSendGen: function( maxMotorTorque )
	{
		Core.Proc.appendToCommandString( ":324,11," + this.__objectRegistryId + "," + maxMotorTorque  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setLocalAnchorA: function( x, y ) {}
	
	// setLocalAnchorB: function( x, y ) {}
	
	// setReferenceRotation: function( referenceRotation ) {}
	
	// setEnableLimit: function( enableLimit ) {}
	
	// setLowerRotation: function( lowerRotation ) {}
	
	// setUpperRotation: function( upperRotation ) {}
	
	// setEnableMotor: function( enableMotor ) {}
	
	// setMotorSpeed: function( motorSpeed ) {}
	
	// setMaxMotorTorque: function( maxMotorTorque ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/WeldJoint'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/WeldJoint'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/WeldJoint'] = exports; var Joint = require('NGCore/Client/Physics2/Joint').Joint;
var Core = require('NGCore/Client/Core').Core;

exports.WeldJoint = Joint.subclass(
/** @lends Physics2.WeldJoint.prototype */
{
	classname: 'WeldJoint',
	
	/**
	 * @class The <code>WeldJoint</code> class constructs objects that hold two application bodies completely stationary relative to each other 
	 * (see <code>{@link Physics2.Body}</code>).
	 * @constructs The default constructor. 
	 * @augments Physics2.Joint
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._localAnchorA = new Core.Point();
		this._localAnchorB = new Core.Point();
		this._referenceRotation = 0;
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the local anchor point for the first connected body.
	 * @returns {Core.Point} The current local anchor point for the first connected body.
	 * @see Physics2.WeldJoint#setLocalAnchorA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocalAnchorA: function()
	{
		return this._localAnchorA;
	},
	
	/**
	 * Set the local anchor point for the first connected body.
	 * @example var joint = new Physics2.WeldJoint();
	 * ...
	 * joint.setLocalAnchorA(25, 0);
	 * @param {Core.Point} [localAnchorA=(0,0)] The new local anchor point for the first connected body.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.WeldJoint#getLocalAnchorA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLocalAnchorA: function(localAnchorA)
	{
		var l = this._localAnchorA;
		l.setAll.apply(l, arguments);
		this._setLocalAnchorASendGen(l.getX(),l.getY());
		return this;
	},
	
	/**
	 * Retrieve the local anchor point for the second connected body.
	 * @returns {Core.Point} The current local anchor point for the second connected body.
	 * @see Physics2.WeldJoint#setLocalAnchorB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocalAnchorB: function()
	{
		return this._localAnchorB;
	},
	
	/**
	 * Set the local anchor point for the second connected body.
	 * @example var joint = new Physics2.WeldJoint();
	 * ...
	 * joint.setLocalAnchorB(-25, 0);
	 * @param {Core.Point} [localAnchorB=(0,0)] The new local anchor point for the second connected body.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.WeldJoint#setLocalAnchorB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLocalAnchorB: function(localAnchorB)
	{
		var l = this._localAnchorB;
		l.setAll.apply(l, arguments);
		this._setLocalAnchorBSendGen(l.getX(),l.getY());
		return this;
	},
	
	/**
	 * Retrieve the reference rotation for this <code>WeldJoint</code>.
	 * @returns {Number} The current reference rotation.
	 * @see Physics2.WeldJoint#setReferenceRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getReferenceRotation: function()
	{
		return this._referenceRotation;
	},
	
	/**
	 * Set the reference rotation for this <code>WeldJoint</code>.
	 * @example var joint = new Physics2.WeldJoint();
	 * ...
	 * joint.setReferenceRotation(-90);
	 * @param {Number} [refereceRotation=0] The new reference rotation.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.WeldJoint#getReferenceRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setReferenceRotation: function(referenceRotation)
	{
		this._referenceRotation = referenceRotation;
		this._setReferenceRotationSendGen(referenceRotation);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 325
	// Method create = -1
	// Method destroy = 2
	// Method setLocalAnchorA = 3
	// Method setLocalAnchorB = 4
	// Method setReferenceRotation = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in WeldJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in WeldJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[325] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":325,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":325,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setLocalAnchorASendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":325,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setLocalAnchorBSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":325,4," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setReferenceRotationSendGen: function( referenceRotation )
	{
		Core.Proc.appendToCommandString( ":325,5," + this.__objectRegistryId + "," + referenceRotation  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setLocalAnchorA: function( x, y ) {}
	
	// setLocalAnchorB: function( x, y ) {}
	
	// setReferenceRotation: function( referenceRotation ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/Contact'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/Contact'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/Contact'] = exports; var Core = require('NGCore/Client/Core').Core;

/**
 * @class The <code>Contact</code> class constructs objects that store information about collisions that occur between two bodies (see <code>{@link Physics2.Body}</code>).
 * @name Physics2.Contact
 * @augments Core.Class
 * @status iOS, Android, Flash
 */
exports.Contact = Core.Class.subclass(
/** @lends Physics2.Contact.prototype */
{
	classname: 'Contact',
	
	/**
	 * Retrieve the contact type for this <code>Contact</code>.
	 * @returns {Physics2.Body#ContactFlags} The current contact type.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getType: function()
	{
		return this._type;
	},
	
	/**
	 * Retrieve the first collision shape for this <code>Contact</code>.
	 * @returns {Physics2.Body} The first collision shape.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getShapeA: function()
	{
		return this._shapeA;
	},
	
	/**
	 * Retrieve the second collision shape for this <code>Contact</code>.
	 * @returns {Physics2.Body} The second collision shape.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getShapeB: function()
	{
		return this._shapeB;
	},
	
	/**
	 * Retrieve the timestamp of a collision for this <code>Contact</code> (expressed in milliseconds).
	 * @returns {Number} The current timestamp.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTimestamp: function()
	{
		return this._timestamp;
	},
		
	/**
	 * Retrieve the normal force for this <code>Contact</code>.
	 * @returns {Core.Vector} The normal force applied to a collision between two bodies.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getNormal: function()
	{
		return this._normal;
	},
	
	/**
	 * Retrieve the number of collision locations for this <code>Contact</code>.
	 * @returns {Number} The current number of collision locations.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocationCount: function()
	{
		return this._locations.length;
	},
	
	/**
	 * Retrieve a collision location at a specific index.
	 * @param {Number} index The specified index.
	 * @returns {Physics2.Contact.Location} The current collision location.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocation: function(index)
	{
		return this._locations[index];
	},
	
	/**
	 * @class <code>Location</code> objects store the location of a single point of contact.
	 * @name Physics2.Contact.Location
	 * @augments Core.Class
	 */
	$Location: Core.Class.subclass(
	/** @lends Physics2.Contact.Location.prototype */
	{
		/**
		 * Retrieve the position of this <code>Contact</code>.
		 * @returns {Core.Point} The position.
		 * @see Physics2.Contact
	 	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getPosition: function()
		{
			return this._position;
		},
		
		/**
		 * Retrieve the impulse that is in the direction of the contact normal.
		 * @returns {Number} The normal impulse.
		 * @see Physics2.Contact
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 	 */
		getNormalImpulse: function()
		{
			return this._normalImpulse;
		},
		
		/**
		 * Retrieve the impulse that is a tangent to the contact normal.
		 * @returns {Number} The tangent impulse.
		 * @see Physics2.Contact
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 	 */
		getTangentImpulse: function()
		{
			return this._tangentImpulse;
		},
	}),
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio'] = exports; /**
 * <p>Classes and objects contained by the Audio module.</p>
 * @name Audio
 * @namespace 
 * @description <p>The Audio module is a collection of classes that support manipulation of audio effects in an application. 
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 *<ul>
 *<li><code>{@link Audio.ActiveEffect}</code>: Construct objects for controlling the reproduction of <code>Effect</code> objects.</li>
 *<li><code>{@link Audio.Device}</code>: A singleton object that controls device sound effects volume.</li>
 *<li><code>{@link Audio.Effect}</code>: Construct objects that load sound resources into memory.</li>
 *<li><code>{@link Audio.Music}</code>: A singleton object that controls the reproduction of application background music.</li>
 *</ul>
 */
exports.Audio = {};

exports.Audio.__defineGetter__("ActiveEffect", function() {
	delete this.ActiveEffect;
	return this.ActiveEffect = require('NGCore/Client/Audio/ActiveEffect').ActiveEffect;
});
exports.Audio.__defineGetter__("Effect", function() {
	delete this.Effect;
	return this.Effect = require('NGCore/Client/Audio/Effect').Effect;
});
exports.Audio.__defineGetter__("Device", function() {
	delete this.Device;
	return this.Device = require('NGCore/Client/Audio/Device').Device;
});
exports.Audio.__defineGetter__("Music", function() {
	delete this.Music;
	return this.Music = require('NGCore/Client/Audio/Music').Music;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/ActiveEffect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/ActiveEffect'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/ActiveEffect'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.ActiveEffect = Core.Class.subclass(
/** @lends Audio.ActiveEffect.prototype */
{
	/**
	 * @class The <code>ActiveEffect</code> class constructs objects that control 
	 * the reproduction of an audio effect. Audio effects in Mobage applications are captured as <code>{@link Audio.Effect}</code> objects. 
	 * <code>{@link Audio.Effect}</code> objects handle and load data for an audio effect into memory. 
	 * This seperation allows applications to manage effect data independently of effect reproduction.
	 * <br><br>
	 * <b>Note:</b> You can only specify <code>{@link Audio.Effect}</code> objects to reproduce at instantiation.
	 * 
	 * @example
	 *
	 *   var effect = new Audio.Effect('some_effect.wav');
	 *   var activeEffect = new Audio.ActiveEffect(effect);
	 *   activeEffect.play();
	 * @constructs The default constructor. 	 
	 * @augments Core.Class
	 * @param {Audio.Effect} effect The <code>{@link Audio.Effect}</code> that this <code>ActiveEffect</code> object plays.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function(effect)
	{
		this._volume  = 1.0;
		this._loops   = false;
		this._playing = false;
		this._paused  = false;

		this._playCompleteEmitter = new Core.MessageEmitter();

		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._setEffect(effect);
	},
	
	/**
	 * Destroy this instance and releases resources on the backend.
	 * <b>Note:</b> This call does not automatically destroy the associated <code>{@link Audio.Effect}</code>.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this.stop();
		this._effect = null;
		this._playCompleteEmitter.destroy();
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Return the volume level for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Number} The current volume level.
	 * @see Audio.ActiveEffect#setVolume
	 * @status iOS, Android, Test
	 */
	getVolume: function()
	{
		return this._volume;
	},
	
	/**
	 * Set the volume level for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * Calling this changes the volume even if an application is in the middle of reproducing an <code>{@link Audio.Effect}</code> object.
	 * The new volume level applies to any subsequent reproductions of the <code>{@link Audio.Effect}</code> object.
	 * @example Audio.ActiveEffect.setVolume(0.5);
	 * @param {Number} [volume=1] The new volume level. Supported values range between <code>(0-1)</code>. 
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.ActiveEffect#getVolume
	 * @status iOS, Android
	 */
	setVolume: function(volume)
	{
		if (volume < 0.0) volume = 0.0;
		if (volume > 1.0) volume = 1.0;

		this._volume = volume;
		this._setVolumeSendGen(volume);
		return this;
	},
	
	/**
	 * Return the loop status for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Boolean} Returns <code>true</code> if looping is enabled.
	 * @see Audio.ActiveEffect#setLoops
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getLoops: function()
	{
		return this._loops;
	},
	
	/**
	 * Set the loop state for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * A looped effect wraps seamlessly from begining to end.
	 * @example Audio.ActiveEffect.setLoops(true);
	 * @param {Boolean} loops Set as <code>true</code> to enable looping.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.ActiveEffect#getLoops
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setLoops: function(loops)
	{
		this._loops = loops;
		this._setLoopsSendGen(loops);
		return this;
	},
	
	/**
	 * Return the <code>Play Complete</code> emitter for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * The <code>Play Complete</code> emitter notifies applications when reproduction of an <code>{@link Audio.Effect}</code> is complete.<br><br>
	 * <b>Notes:</b>
	 * <ul>
	 *   <li>Any <code>{@link Audio.Effect}</code> object that does not loop uses the <code>Play Complete</code> emitter. </li>
	 * </ul>
	 * @returns {Core.MessageEmitter} The current state of the <code>Play Complete</code> emitter.
	 * @status iOS
	 */
	getPlayCompleteEmitter: function()
	{
		return this._playCompleteEmitter;
	},
	
	/**
	 * Return the play status of the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Boolean} Returns <code>true</code> if this <code>ActiveEffect</code> is reproducing an <code>{@link Audio.Effect}</code>.
	 * @see Audio.ActiveEffect#play
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPlaying: function()
	{
		return this._playing;
	},
	
	/**
	 * Return the pause status of the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Boolean} Returns <code>true</code> if this <code>(@link Audio.Effect}</code> is in a paused state.
	 * @see Audio.ActiveEffect#pause
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPaused: function()
	{
		return this._paused;
	},
	
	/**
	 * Begin reproducing an <code>{@link Audio.Effect}</code>.
	 * <ul>
	 * <li>If this <code>{@link Audio.Effect}</code> is new or in a stopped state,
	 * reproduction starts at the beginning.</li>
	 * <li>If this <code>{@link Audio.Effect}</code> is in a paused state, reproduction resumes from the previous position.</li>
	 * <li>If this <code>{@link Audio.Effect}</code> is playing, this call does nothing.</li>
	 * </ul>
	 * @see Audio.ActiveEffect#getIsPlaying
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	play: function()
	{
		this._playing = true;
		this._paused  = false;
		this._playSendGen( );
	},
	
	/**
	 * Pause reproduction of an <code>{@link Audio.Effect}</code>.
	 * <ul>
	 * <li>If this <code>ActiveEffect</code> is in the process of reproducing an <code>{@link Audio.Effect}</code>, this call pauses reproduction.</li>
	 * <li>If the <code>{@link Audio.Effect}</code> is in a stopped or paused state, this call does nothing.</li>
	 * </ul>
	 * <b>Note:</b> Calling this does not trigger the <code>Play Complete</code> emitter.
	 * @see Audio.ActiveEffect#getIsPaused
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	pause: function()
	{
		this._playing = false;
		this._paused  = true;
		this._pauseSendGen( );
	},
	
	/**
	 * Stop reprodution of an <code>{@link Audio.Effect}</code> object.
	 * <ul>
	 * <li>If this <code>ActiveEffect</code> is currently reproducing an <code>{@link Audio.Effect}</code> or the <code>{@link Audio.Effect}</code> is in a paused state, this call stops reproduction.</li>
	 * <li>If the <code>{@link Audio.Effect}</code> is in a stopped state, this call does nothing.</li>
	 * </ul>
	 * <b>Note:</b> Calling <code>stop()</code> does not trigger the <code>Play Complete</code> emitter.
	 * @status iOS, Android, Test, iOSTested, AndroidTested	 
	 */
	stop: function()
	{
		this._playing = false;
		this._paused  = false;
		this._stopSendGen( );
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 328
	// Method create = -1
	// Method destroy = 2
	// Method setVolume = 3
	// Method setLoops = 4
	// Method play = 5
	// Method pause = 6
	// Method stop = 7
	// Method setEffect = 8
	// Method playComplete = 9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 9:
					instance._playCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in ActiveEffect._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in ActiveEffect._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[328] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_playCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in ActiveEffect.playComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":328,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":328,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setVolumeSendGen: function( volume )
	{
		Core.Proc.appendToCommandString( ":328,3," + this.__objectRegistryId + "," + volume  );
	},
	
	/** @private */
	_setLoopsSendGen: function( loops )
	{
		Core.Proc.appendToCommandString( ":328,4," + this.__objectRegistryId + "," + ( loops ? 1 : 0 )  );
	},
	
	/** @private */
	_playSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":328,5," + this.__objectRegistryId );
	},
	
	/** @private */
	_pauseSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":328,6," + this.__objectRegistryId );
	},
	
	/** @private */
	_stopSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":328,7," + this.__objectRegistryId );
	},
	
	/** @private */
	_setEffectSendGen: function( effectId )
	{
		Core.Proc.appendToCommandString( ":328,8," + this.__objectRegistryId + "," + effectId  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setVolume: function( volume ) {}
	
	// setLoops: function( loops ) {}
	
	// play: function(  ) {}
	
	// pause: function(  ) {}
	
	// stop: function(  ) {}
	
	// setEffect: function( effectId ) {}
	
	// _playCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}

	_setEffect: function(effect)
	{
		this._effect  = effect;
		this._setEffectSendGen(this._effect.__objectRegistryId);
		return this;
	},

	_playCompleteRecv: function( cmd )
	{
		var msg = {};
		if(!this._playCompleteRecvGen(cmd, msg))
			return;

		this._playing = false;
		this._paused  = false;

		this._playCompleteEmitter.emit(this);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/Effect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/Effect'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/Effect'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Effect = Core.Class.subclass(
/** @lends Audio.Effect.prototype */
{
	/**
	 * @class The <code>Effect</code> class constructs objects for handling audio resources that comprise an audio effect.
	 * Instantiating these objects allocates resources on the backend.
	 * After creating an <code>Effect</code> object, applications can control reproduction through an <code>{@link Audio.ActiveEffect}</code> object.<br><br>
	 * @example
	 * var effect = new Audio.Effect('Content/explosion.wav');
	 * @constructs The default constructor.<br><br>
	 * The following code is an example of constructing a new <code>Effect</code> object.
	 * @augments Core.Class
	 * @param {String} path A directory path that points to the audio file to load.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function(path)
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._setPath(path);
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Set a directory path to the audio file resource for this <code>Effect</code> object.
	 * @param {String} path The new directory path.
	 * @returns Calls to <code>setPath()</code> return <code>this</code> to support method invocation chaining.
	 */
	_setPath: function(path)
	{
		this._path = path;
		this._setPathSendGen(path);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 326
	// Method create = -1
	// Method destroy = 2
	// Method setPath = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Effect._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Effect._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[326] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":326,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":326,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setPathSendGen: function( path )
	{
		Core.Proc.appendToCommandString( ":326,3," + this.__objectRegistryId + "," + Core.Base64.encode( path )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPath: function( path ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/Device'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/Device'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/Device'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Device = Core.Class.singleton(
/** @lends Audio.Device.prototype */
{
	classname: 'Device',

	/**
	 * @class The <code>Device</code> class constructs a singleton object that contains audio device properties.
	 * Applications can use <codeDevice</code> objects to control global audio effects volume 
	 * and reproduce detached audio effects.
	 * <br><br>
	 * <b>Note:</b> An application should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	 
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._volume = undefined; // default value

		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		var initialValues = KeyValueCache.global("Audio.Device.InitialValues");

		var self = this;
		initialValues.getItem("effectsVolume", function(error, value) {
			self._volume = parseFloat(value);
		});
	},
	
	/**
	 * Return the global sound effects volume for this <code>Device</code> object.
	 * @returns {Number} The current global sound effects volume.
	 * @see Audio.Device#setEffectsVolume	 
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getEffectsVolume: function()
	{
		return this._volume;
	},
	
	/**
	 * Set the global sound effects volume for this <code>Device</code> object.
	 * Volume for each active effect multiplies
	 * by this value to produce a new volume level. 
	 * For example, if the global sound effects volume is set to 0.5, each active effect will play at half the volume set on the effect.
	 * @param {Number} [effectsVolume=1] The new volume for global sound effects. 
	 * Supported values range between <code>(0-1)</code>. 
	 * @example Audio.Device.setEffectsVolume(0.5);
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.Device#getEffectsVolume
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setEffectsVolume: function(effectsVolume)
	{
		if (effectsVolume < 0.0) effectsVolume = 0.0;
		if (effectsVolume > 1.0) effectsVolume = 1.0;

		this._volume = effectsVolume;
		this._setEffectsVolumeSendGen(effectsVolume);
		return this;
	},
	
	/**
	 * Play an audio effect in a way that is completely detached from upstream or downstream processing.
	 * Using this call is a simple, high-level way to reproduce an audio effect.<br><br>
	 * The specified audio effect is only reproduced once.
	 * There is no control over the effect volume or effect playback.
	 * Resource allocation automatically occurs on the backend when playback begins. Resources are automatically released when playback ends.	 
	 * The following code is an example of a <code>playDetached()</code> call.
	 * @example
	 * Audio.Device.playDetached('Content/explosion.wav');
	 * @param {String} path A relative directory path to the audio file.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	playDetached: function(path)
	{
		this._playDetachedSendGen( path );
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 327
	// Method create = -1
	// Method setEffectsVolume = 2
	// Method playDetached = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Device._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Device._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[327] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":327,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_setEffectsVolumeSendGen: function( effectsVolume )
	{
		Core.Proc.appendToCommandString( ":327,2," + this.__objectRegistryId + "," + effectsVolume  );
	},
	
	/** @private */
	_playDetachedSendGen: function( path )
	{
		Core.Proc.appendToCommandString( ":327,3," + this.__objectRegistryId + "," + Core.Base64.encode( path )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setEffectsVolume: function( effectsVolume ) {}
	
	// playDetached: function( path ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/Music'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/Music'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/Music'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Music = Core.Class.singleton(
/** @lends Audio.Music.prototype */
{
	classname: 'Music',

	/**
	 * @class The <code>Music</code> class constructs a singleton object that provides control over reproduction
	 * of application background music.
	 * This object is constructed independently of <code>Device</code> objects because many devices
	 * already provide hardware-accelerated streaming and decode
	 * for a single background music track. Some
	 * devices gracefully mute a background music track
	 * if the user is playing a music track from their own library.
	 * <br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @example 
	 * var background = new Audio.Music('Content/music.mp3');
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._path    = null;
		this._playing = false;
		this._paused  = false;
		this._volume  = 1.0;
	},
	
	/**
	 * Return the directory path to the background music file used as a resource for this <code>Music</code> object.
	 * @returns {String} The directory path to a music file.
	 * @see Audio.Music#setPath
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPath: function()
	{
		return this._path;
	},
	
	/**
	 * Set the directory path for the background music file that this <code>Music</code> object loads.<br><br>
	 * <b>Note:</b> If the application is reproducing music when this is called, reproduction will stop.
	 * The application must call <code>play()</code> again to start reproduction of the new resource.<br><br>
	 * The code in the following example sets a directory path to a music resource and plays that resource.
	 * @example
	 * Audio.Music.setPath('Content/music.mp3');
	 * Audio.Music.play();
	 *
	 * @param {string} path The new directory path to a music file.
	 * @see Audio.Music#getPath,
	 * @see Audio.Music#play
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setPath: function(path)
	{
		this._path = path;
		this._setPathSendGen(path);
	},
	
	/**
	 * Return the volume level used for reproduction of this <code>Music</code> object.
	 * @returns {Number} The current volume level.
	 * @see Audio.Music#setVolume
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getVolume: function()
	{
		return this._volume;
	},
	
	/**
	 * Set the volume level used for reproduction of this <code>Music</code> object.
	 * This call instantly modifies the background music volume level.
	 * Any subsequent reproductions of background music will play at the specified volume.
	 * @example Audio.Music.setVolume(0.5);
	 * @param {Number} [volume=1] The new volume. Supported values range between <code>(0-1)</code>.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.Music#getVolume
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setVolume: function(volume)
	{
		if (volume < 0.0) volume = 0.0;
		if (volume > 1.0) volume = 1.0;

		this._volume = volume;
		this._setVolumeSendGen(volume);
		return this;
	},
	
	/**
	 * Return the playback state of this <code>Music</code> object. 
	 * @returns {Boolean} Returns <code>true</code> if an application is reproducing background music.
	 * @see Audio.Music#play
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPlaying: function()
	{
		return this._playing;
	},
	
	/**
	 * Return the pause state of this <code>Music</code> object.
	 * @returns {Boolean} Returns <code>true</code> if an application is reproducing background music.
	 * @see Audio.Music#pause
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPaused: function()
	{
		return this._paused;
	},
	
	/**
	 * Begin reproduction of this <code>Music</code> object.
	 * <ul>	
	 * <li>If this <code>Music</code> object is a new background music track, or the application has stopped the current background music track, 
	 * this call begins reproduction from the beginning.</li>
	 * <li>If the background music track is in a paused state, this call resumes reproduction from the previous position.</li>
	 * <li>If the background music track is currently playing, this call does nothing.</li>
	 * </ul>
	 * @see Audio.Music#getIsPlaying,
	 * @see Audio.Music#pause,
	 * @see Audio.Music#stop
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	play: function()
	{
		this._playing = true;
		this._paused  = false;
		this._playSendGen( );
	},
	
	/**
	 * Pause reproduction of this <code>Music</code> object.
	 * <ul>
	 * <li>If an application is currently reproducing a background music track, this call pauses reproduction.</li>
	 * <li>If the background music track is in a paused or stopped state, this call does nothing.</li>
	 * </ul>
	 * @see Audio.Music#getIsPaused
	 * @see Audio.Music#play,
	 * @see Audio.Music#stop
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	pause: function()
	{
		this._playing = false;
		this._paused  = true;
		this._pauseSendGen( );
	},
	
	/**
	 * Stop reproduction of this <code>Music</code> object.
	 * <ul>
	 * <li>If the background music track is playing or in a paused state, this call stops playback.</li>
	 * <li>If the background music track is in a stopped state, this call does nothing.</li>
	 * </ul>
	 * @see Audio.Music#play,
	 * @see Audio.Music#pause
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	stop: function()
	{
		this._playing = false;
		this._paused  = false;
		this._stopSendGen( );
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 329
	// Method create = -1
	// Method destroy = 2
	// Method setPath = 3
	// Method setVolume = 4
	// Method play = 5
	// Method pause = 6
	// Method stop = 7
	// Method playComplete = 8
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 8:
					instance._playCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Music._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Music._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[329] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_playCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Music.playComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":329,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":329,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setPathSendGen: function( path )
	{
		Core.Proc.appendToCommandString( ":329,3," + this.__objectRegistryId + "," + Core.Base64.encode( path )  );
	},
	
	/** @private */
	_setVolumeSendGen: function( volume )
	{
		Core.Proc.appendToCommandString( ":329,4," + this.__objectRegistryId + "," + volume  );
	},
	
	/** @private */
	_playSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":329,5," + this.__objectRegistryId );
	},
	
	/** @private */
	_pauseSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":329,6," + this.__objectRegistryId );
	},
	
	/** @private */
	_stopSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":329,7," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPath: function( path ) {}
	
	// setVolume: function( volume ) {}
	
	// play: function(  ) {}
	
	// pause: function(  ) {}
	
	// stop: function(  ) {}
	
	// _playCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}

	_playCompleteRecv: function( cmd )
	{
		var msg = {};
		if(!this._playCompleteRecvGen(cmd, msg))
			return;

		this._playing = false;
		this._paused  = false;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/Scroller'] = function(){var exports = $MODULE_REGISTRY['Code/UI/Scroller'] || {}; $MODULE_REGISTRY['Code/UI/Scroller'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;

var exports = {};

var Scrollinator = Core.MessageListener.subclass({
	initialize: function(width, height){
		this.m_node = new GL2.Node();
		this.m_child_node = new GL2.Node();
		this.m_width = width;
		this.m_height = height;
		this.m_current_velocity = 0;
		this.m_start_time;
		this.m_start_point;
		this.m_last_diff = null;
		
		this.m_target = new GL2.TouchTarget();
		this.m_target.setSize(width, height);
		this.m_target.setPosition(-width / 2, -height / 2);
		this.m_target.getTouchEmitter().addListener(this, this.onTouch);
		
		this.m_node.addChild(this.m_target);
		
		this.m_node.addChild(this.m_child_node);
		
		this.m_current_touch_id = null;
		this.m_last_touch_point = null;
		this.m_min_y = null;
		this.m_max_y = null;
		
		Core.UpdateEmitter.addListener(this, this.onUpdate);
	},
	
	destroy: function(){
		this.m_target.destroy();
		this.m_child_node.destroy();
		this.m_node.destroy();
	},
	
	onTouch: function(touch_event){
		switch (touch_event.getAction()) {
			case (GL2.Touch.Action.Start):{
				if (this.m_current_touch_id == null) {
					this.m_current_touch_id = touch_event.getId(); // store this to force single touch   	
					this.m_last_touch_point = touch_event.getPosition();
					this.m_start_point = touch_event.getPosition().getY();
					this.m_start_time = Core.Time.getFrameTime();
					return true;
				}
				break;
			}
			case (GL2.Touch.Action.End):{
				if (this.m_current_touch_id == touch_event.getId()) {
					this.m_current_touch_id = null;
					var t = Core.Time.getFrameTime() - this.m_start_time;
					if (t == 0) {
						this.m_current_velocity = 0;
					}
					else {
						this.m_current_velocity = (this.m_start_point - this.m_last_touch_point.getY()) / (Core.Time.getFrameTime() - this.m_start_time);
					}
					this.m_last_diff = null;
				}
				break;
			}
			case (GL2.Touch.Action.Move):{
				if (this.m_current_touch_id == touch_event.getId()) {
					var diff = this.m_last_touch_point.getY() - touch_event.getPosition().getY();
					if (this.m_last_diff == null || (this.m_last_diff < 0 && diff > 0) || (this.m_last_diff > 0 && diff < 0)) {
						this.m_last_diff = diff;
						this.m_start_time = Core.Time.getFrameTime();
						this.m_start_point = touch_event.getPosition().getY();
					}
					this.m_last_touch_point = touch_event.getPosition();
					var temp_pos = this.m_child_node.getPosition();
					if (temp_pos.getY() - diff < -this.m_max_y + this.m_height / 2) {
						this.adjustScroll(-this.m_max_y + this.m_height / 2);
					}
					if (temp_pos.getY() - diff > this.m_min_y) {
						this.adjustScroll(this.m_min_y);
					}
					else {
						this.adjustScroll(temp_pos.getY() - diff);
					}
				}
				break;
			}
		}
	},
	
	onUpdate: function(delta) {
		if (this.m_current_touch_id == null) {
			var rate = 0.1;
			if (this.m_current_velocity != 0) {
				var temp_pos = this.m_child_node.getPosition();
				if (temp_pos.getY() - this.m_current_velocity * delta < -this.m_max_y + this.m_height / 2) {
					this.adjustScroll(-this.m_max_y + this.m_height / 2);
				}
				if (temp_pos.getY() - this.m_current_velocity * delta > this.m_min_y) {
					this.adjustScroll(this.m_min_y);
				}
				else {
					this.adjustScroll(temp_pos.getY() - this.m_current_velocity * delta);
				}
				
				if (this.m_current_velocity < 0) {
					this.m_current_velocity += rate;
					if (this.m_current_velocity > 0) {
						this.m_current_velocity = 0;
					}
				}
				if (this.m_current_velocity > 0) {
					this.m_current_velocity -= rate;
					if (this.m_current_velocity < 0) {
						this.m_current_velocity = 0;
					}
				}
			}
		}
	},
	
	adjustScroll: function(new_y) {
		this.m_child_node.setPosition(this.m_child_node.getPosition().getX(), new_y);
		
	},
	
	setPosition: function(x, y) {
		this.m_node.setPosition(x, y);
	},
	
	getNode: function(){
		return this.m_node;
	},
	
	addChild: function(child, x, y, height){
		this.m_child_node.addChild(child);
		child.setPosition(x, y);
		if (this.m_max_y == null) {
			this.m_max_y = y + height / 2 + 56 * GameConstants.WIDTH_SCALE;
		}
		this.m_max_y = Math.max(y + height / 2 + 56 * GameConstants.WIDTH_SCALE, this.m_max_y);
		if(this.m_min_y == null) {
			this.m_min_y = -this.m_height / 2 + height / 2 + y;	
		}
		this.m_min_y = Math.min(y - height / 2, this.m_min_y);
		if (this.m_child_node.getPosition().getY() > -this.m_height / 2) {
			this.m_child_node.setPosition(this.m_child_node.getPosition().getX(), -this.m_height / 2);
		}
		if (this.m_child_node.getPosition().getY() < this.m_min_y) {
			this.m_child_node.setPosition(this.m_child_node.getPosition().getX(), this.m_min_y);
		}
	},
	
	addNonvisibleChild: function(child, x, y) {
		this.m_child_node.addChild(child);
		child.setPosition(x, y);	
	},
	
	removeChild: function(child){
		if (child.getParent() == this.m_child_node) {
			this.m_child_node.removeChild(child);
		}
	},
});

exports.Scroller = Scrollinator;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/AdView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/AdView'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/AdView'] = exports; //
//  Mobclix.AdView.Base.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var AdViewInternal = require('NGCore/Client/Mobclix/AdViewInternal').AdViewInternal;

var AdView = exports.AdView = AdViewInternal.subclass(
/** @lends Mobclix.AdView.prototype */
{
	__className: "Mobclix.AdView",
	_subsequent: false,
	
	/**
	 * @class 
	 * This class should not be instantiated directly, instead use one of the following subclasses:
	 * <ul>
	 * <li>{@link Mobclix.AdView_320x50}</li>
	 * <li>{@link Mobclix.AdView_300x250}</li>
	 * </ul>
     *<br>
     * Mobclix.AdViews are resized automatically for screen density. Please
     * do not override the width and height of the AdView.<br>
     * Thus, when positioning a Mobclix.AdView, do not override the AdView's
     * frame's width and height accidentally. Positioning of the AdView
     * should be done in the following manner:<br><br>
     * var adViewFrame = adView.getFrame();<br>
     * adViewFrame[0] = x;<br>
     * adViewFrame[1] = y;<br>
     * adView.setFrame(adViewFrame);<br>
     *
	 * @constructs The default constructor.
	 * @public
	 */
	initialize: function($super) {
		$super();
	},

	/**
	 * Requests a new ad from the server
	 * If ad refreshes are paused, this will also call resumeAdAutoRefresh
	 *
	 * This should only be called when you want to manually refresh an ad.
	 * @public
	 */
	getAd: function() {
		this._subsequent = false;
		AdViewInternal.prototype.getAd.apply(this, arguments);
	},
	
	/**
	 * Pauses the autorefresh of ads
	 *
	 * This should be called in viewWillDisappear
	 * @public
	 */
	pauseAdAutoRefresh: function() {
		this.cancelScheduledGetAd();
	},

	/**
	 *	Resumes the autorefresh of ads
	 *
	 * This should be called in viewDidAppear
	 * @public
	 */
	resumeAdAutoRefresh: function() {
		if(!this._subsequent) {
			this.getAd();
		} else {
			this.scheduleNextGetAd();	
		}
	},

	/**
	 * Cancels any ads currently load and calls pauseAdRefresh
	 *
	 * This should be called in viewDidUnload/dealloc
	 * @public
	 */
	cancelAd: function() {
		this._cancelAd();
	}
});

/**
 * @class
 * Use this class to create an ad view for the 320x50 unit.
 * @name Mobclix.AdView_320x50
 * @extends Mobclix.AdView
 * @public
 */
exports.AdView_320x50 = AdView.subclass({
	_size: {
		width: 320,
		height: 50
	}
});

/**
 * @class
 * Use this class to create an ad view for the 300x250 unit.
 * @name Mobclix.AdView_300x250
 * @extends Mobclix.AdView
 * @public
 */
exports.AdView_300x250 = AdView.subclass({
	_size: {
		width: 300,
		height: 250
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix'] = exports; //
//  Mobclix.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

/**
 * Classes and objects contained by the Mobclix package.
 * @name Mobclix
 * @namespace
 * @description
 */

exports.Mobclix = {
	AdView: require('NGCore/Client/Mobclix/AdView').AdView,

	/**
	 * AdView class for the 320x50 unit.
	 * @name Mobclix#AdView_320x50
	 * @see Mobclix.AdView_320x50
	 * @see Mobclix.AdView
	 */
	AdView_320x50: require('NGCore/Client/Mobclix/AdView').AdView_320x50,

	/**
	 * AdView class for the 300x250 unit.
	 * @name Mobclix#AdView_300x250
	 * @see Mobclix.AdView_300x250
	 * @see Mobclix.AdView
	 */
	AdView_300x250: require('NGCore/Client/Mobclix/AdView').AdView_300x250,

	/**
	 * AdView class for the FullScreen unit.
	 * @name Mobclix#AdView_FullScreen
	 * @see Mobclix.AdView_FullScreen
	 * @see Mobclix.FullScreenAdView
	 */
	AdView_FullScreen: require('NGCore/Client/Mobclix/FullScreenAdView').AdView_FullScreen,
	
	/**
	 * Start up the Mobclix SDK, this must be called prior to requesting ads.
	 * @name Mobclix#startWithApplicationId
	 * @function
	 * @param	{String}	applicationId	The Mobclix Application ID for your app
	 */
	startWithApplicationId: function(applicationId) {
		require('NGCore/Client/Mobclix/Core/Controller').Controller.startWithApplicationId(applicationId);
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/AdViewInternal'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/AdViewInternal'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/AdViewInternal'] = exports; //
//  Mobclix.AdViewInternal.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var UI = require('NGCore/Client/UI').UI;
var MMView = require('NGCore/Client/Mobclix/Core/MMView').MMView;

var Config = require('NGCore/Client/Mobclix/Core/Config').Config;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;
var Controller = require('NGCore/Client/Mobclix/Core/Controller').Controller;
var HTTPRequest = require('NGCore/Client/Mobclix/Core/HTTPRequest').HTTPRequest;
var MMArray = require('NGCore/Client/Mobclix/Core/MMArray').MMArray;

var Browser = require('NGCore/Client/Mobclix/Browser').Browser;

var Creative = require('NGCore/Client/Mobclix/Creative').Creative;

var WebCreativeView = require('NGCore/Client/Mobclix/CreativeView/Web').Web;
var FullScreenCreativeView = require('NGCore/Client/Mobclix/CreativeView/FullScreen').FullScreen;

var Social = require('NGCore/Client/Social').Social;

var FullScreenAdSize = exports.FullScreenAdSize = {
	width: 999,
	height: 999
};

var AdViewInternal = exports.AdViewInternal = MMView.subclass(
/** @lends Mobclix.AdViewInternal.prototype */
{
	__className: "Mobclix.AdViewInternal",

	/**
	 * Enumeration for error codes.
	 * @name Mobclix.AdView.Error
	 * @namespace
	 * @public
	 */
	Error: {
		/** 
		 * Unknown error occured
		 * @name Mobclix.AdView.Error#Unknown
		 */
		Unknown: 0,

		/** 
		 * There was an error on the Mobclix Server
		 * @name Mobclix.AdView.Error#ServerError
		 */
		ServerError: -500,
		
		/** 
		 * Ads are currently unavailable
		 * @name Mobclix.AdView.Error#ServerError
		 */
		Unavailable: -503,

		/** 
		 * Connection error occured
		 * @name Mobclix.AdView.Error#Connection
		 */
		Connection: -7777777,

		/** 
		 * An ad was requested without calling {@link Mobclix#startWithApplicationId}
		 * @name Mobclix.AdView.Error#NotStarted
		 */
		NotStarted: -8888888,
		
		/** 
		 * The requested unit side has been remotely disabled
		 * @name Mobclix.AdView.Error#Disabled
		 */
		Disabled: -9999999
	},
	
	_listener: null,
	_ordinalNumber: 0,
	_inTestMode: false,
	_size: {
		width: 320,
		height: 50
	},
	
	_shouldGetAdAfterConfig: false,
	_autoDisplayNextAdRequest: false,
	_hasPrefetchedAd: false,
	_wasPaused: false,
	_pausedSelf: false,
	_isLoading: false,
	_refreshTimeout: null,
	_shouldAutoplay: false,
	_lastAutoplayTime: 0,
	_hasFinishedStarting: false,
	_shouldGetAdAfterFinishedStarting: false,
	_originOfRegistration: null,
    _distributionName: null,
    
	/**
	 * @class AdViewInternal 
	 * @constructs The default constructor. 
	 * @param $super This parameter is stripped out during execution. Do not supply it.
	 * @private
	 */
	initialize: function($super) {
		$super();
		var self = this;
        
        this._setAdSpace();
        
		this.setFrame([0, 0, $mc.dip(this._size.width), $mc.dip(this._size.height)]);
		this._listener = new Core.MessageListener();
		Config.addListener(this._listener, function() { self._configUpdated(); });
		Controller.addListener(this._listener, function() { self._finishStarting(); });
		var creatives = new MMArray();
		this.currentCreatives = creatives;
		creatives.release();
		
		if(Controller.hasBeenStarted()) {
			this._finishStarting();
		}
	},
	
    _setAdSpace: function() {
        var self = this;
        try {
            var session = Social.US.Session.getCurrentSession();
            var user = session.user();
            user.getOriginOfRegistration(function(error, originOfRegistration) {
                if(!originOfRegistration) {
                    var errorCode = error.errorCode;
                    var errorDesc = error.description;
                } else {
                    self._originOfRegistration = originOfRegistration.replace(/[aeiou_-]/g,"");
                }
            });
            
        } catch(e) {
            $mc.log("Error getting the OoR.", e);
        }
        try {
            var dist = Core.Capabilities.getDistributionName();
            this._distributionName = dist.replace(/[aeiou_-]/g,"");
        } catch(e) {
            $mc.log("Error getting the Distribution Name.", e);
        }
    },
    
	/**
	 * Called after {@link Mobclix.Config} is finished updating.
	 * @private
	 */
	_configUpdated: function() {
		$mc.log("config finished updating");
		if(this._shouldGetAdAfterConfig) {
			this._shouldGetAdAfterConfig = false;
			this.getAd();
		}
	},
	
	_finishStarting: function() {
		if(this._hasFinishedStarting) return;
		this._hasFinishedStarting = true;
	
		if(this._shouldGetAdAfterFinishedStarting) {
			this._shouldGetAdAfterFinishedStarting = false;
			this.getAd();
		}
	},
	
	_handleMobclixNotStarting: function() {
		if(this._hasFinishedStarting) return;
		this._shouldGetAdAfterFinishedStarting = false;

		this.failWithError(this.Error.NotStarted, "No application id found.  Please be sure to start Mobclix prior to requesting ads.");
	},
	
	// ====
	// Autorefreshing methods
	// ====
	
	/**
	 * Clears the refresh timeout
	 * @private
	 */
	clearRefreshTimeout: function() {
		if(this._refreshTimeout) {
			clearTimeout(this._refreshTimeout);
			this._refreshTimeout = null;
		}
	},
	
	/**
	 * Schedule the next get ad
	 * @private
	 */
	scheduleNextGetAd: function() {
		this._wasPaused = false;
		this._pausedSelf = false;
		var refreshTime = this._getRefreshTime();
		$mc.log("scheduleNextGetAd:", refreshTime);

		if(refreshTime > 0) {
			var self = this;
			this.clearRefreshTimeout();
			this._refreshTimeout = setTimeout(function() { $mc.log("Requesting ad!"); self.getAd(); }, refreshTime);
		}
	},
	
	/**
	 * Schedule the next get ad from an internal error
	 * This behaves identical to {@link Mobclix.AdViewInternal#scheduleNextGetAd} except it doesn't change internal state variables
	 * @private
	 */
	scheduleNextGetAdFromError: function() {
		$mc.log("scheduleNextGetAdFromError");
		var refreshTime = this._getRefreshTime();
		if(refreshTime > 0) {
			var self = this;
			this.clearRefreshTimeout();
			this._refreshTimeout = setTimeout(function() { self.getAd(); }, refreshTime);
		}
	},
	
	/**
	 * Cancel any scheduled get ads
	 * @private
	 */
	cancelScheduledGetAd: function() {
		$mc.log("cancelScheduledGetAd");
		this._wasPaused = true;
		this._pausedSelf = false;
		clearTimeout(this._refreshTimeout);
	},

	/**
	 * Returns the refresh time in milliseconds
	 * @private
	 */
	_getRefreshTime: function() {
		var refreshTime = 0;
		
		try {
			refreshTime = parseInt(this.refreshTime, 10);
		} catch(e) {
			refreshTime = 0;
		}

		if(refreshTime == 0 || isNaN(refreshTime)) {
			return Config.refreshInteveralForAdUnit(this._size) * 1000;
		} else {
			return refreshTime * 1000;
		}
	},
	
	/**
	 * Determines whether next ad should be scheduled
	 * @private
	 */
	shouldScheduleGetAd: function() {
        if (this._size.width == 999)
            return false;
		return !this._wasPaused || this._pausedSelf;
	},

	// ====
	// Request Lifecycle
	// ====

	/**
	 * Requests a new ad from the server
	 * If ad refreshes are paused, this will also call resumeAdAutoRefresh
	 *
	 * This should only be called when you want to manually refresh an ad.
	 * @private
	 */
	getAd: function() {
		this._getAd(null, true);
	},
	
	/**
	 * Request an ad to be displayed in the future
	 * A subsequent call to {@link Mobclix.AdViewInternal#displayAd} must be called when the ad is
	 * displayed to fire off any events that need to be triggered when displayed.
	 * @private
	 */
	prefetchAd: function() {
		if(this._hasPrefetchedAd) return;
		
		this.cancelScheduledGetAd();
		this._wasPaused = false;
		this._getAd(null, false);
	},
	
	/**
	 * Internal called from other methods such as {@link #getAd} and {@link #prefetchAd}
	 * 
	 * Requests an ad from the servers (if possible)
	 * @param	{object}	params	Additional parameters to pass back to the server, this must be a single dimensional key-value object
	 * @param 	{bool}		shouldAutoDisplay	Flag to indicate whether or not this request should display itself when it's finished
	 * @private
	 */
	_getAd: function(params, shouldAutoDisplay) {
		var self = this;
		
		// If we have an ad prefetched, we should display it, not get another ad
		if(this.hasPrefetchedAd) {
			this.displayAd();
			return;
		}

		// Set autodisplay toggle
		this._autoDisplayNextAdRequest = shouldAutoDisplay;
		
		// We can't request ads until Mobclix has finished starting
		if(!this._hasFinishedStarting) {
			$mc.log("Mobclix hasn't been started yet..");
			this._shouldGetAdAfterFinishedStarting = true;
			setTimeout(function() {
				self._handleMobclixNotStarting();
			}, 10000);
			return;
		}

		// If config is updating, we wait
		if(Config.isUpdating()) {
			$mc.log("RC Updating blocked adview..");
			this._shouldGetAdAfterConfig = true;
			return;
		}
		
		// If we're already waiting, we wait
		if(this._isLoading) {
			this.scheduleNextGetAdFromError();
			return;
		}
		
		// If we've already taken over the screen, we wait
		if(Controller.inModal) {
			this.scheduleNextGetAdFromError();
			return;
		}

		// If we're disabled, we don't load
		if(!Config.isAdUnitEnabled(this._size)) {
			$mc.log("Ad unit is not enabled..");
			this.failWithError(this.Error.Disabled, "This ad unit size has been remotely disabled in the developer dashboard.");
			return;
		}
		
		// Build parameters
		params = params || {};
		params = typeof params == 'object' ? params : {};

		// Determine autoplay
		this._shouldAutoplay = Config.isAutoPlayEnabled(this._size);
		if(typeof this.canAutoplay == 'function') {
			this._shouldAutoplay = this.canAutoplay(this) ? true : false;
		}
		
		// Determine RMRUI
		var richMediaRequiresUserInteraction = Config.richMediaRequiresUserInteraction(this._size);
		if(typeof this.richMediaRequiresUserInteraction == 'function') {
			richMediaRequiresUserInteraction = this.richMediaRequiresUserInteraction(this) ? true : false;
		}

		// Set ordinal
		var ordinalNumber;
		if(this._size == FullScreenAdSize) {
			ordinalNumber = __fullscreenOrdinalNumber++;
		} else {
			ordinalNumber = this._ordinalNumber++;
		}
		
		// Cancel any scheduled ads
		var wasWasPaused = this._wasPaused;
		this.cancelScheduledGetAd();

		if(!wasWasPaused && this._getRefreshTime() > 0) {
			// cancelScheduledGetAd sets wasPaused to TRUE and pausedSelf to FALSE
			this._pausedSelf = true;
		}

		// ---------------------------
		// Ad Feed ID Parameters
		// ---------------------------

		// Application ID
		params.i = Controller.getApplicationId();

		// Platform Name
		params.p = Controller.isAndroid() ? 'android' : (Controller.isIPad() ? 'ipad' : 'iphone');

		// Unit Size
		if(this._size.width == 999) {
			params.s = "fullscreen";
		} else {
			params.s = this._size.width + "x" + this._size.height;
		}

		// ---------------------------
		// Ad View State ID Parameters
		// ---------------------------

		// Should Autoplay
		params.ap = this._shouldAutoplay;

		// Rich Media requires user interaction
		params.rm = richMediaRequiresUserInteraction;

		// Ordinal Number
		params.o = ordinalNumber;

		// Ad Space
		var adSpace = "";
        if (this._originOfRegistration != null) {
            adSpace += this._originOfRegistration;
        }
        
        if (this._distributionName != null) {
            adSpace += this._distributionName;
        }
        
        this.adSpaceName = adSpace;
		if(adSpace && adSpace.length > 0) {
			if(adSpace.length > 32) {
				adSpace = adSpace.substr(0,32);
			}

			params.as = adSpace;
		}

		// Test Mode (Only if enabled)
		if(this._inTestMode) params.t = 1;

		// ---------------------------
		// Hardware Environment
		// ---------------------------

		// UDID
		params.u = Core.Capabilities.getUniqueId();

		// Connection Type
		params.ct = Controller.getNetworkState();

		// Device Model
		params.dm = Core.Capabilities.getDeviceName();

		// Hardware Device Model
		params.hwdm = Core.Capabilities.getPlatformHW();

        // User Agent
        if (Controller.getUserAgent() != null)
            params.ua = Controller.getUserAgent();

		// ---------------------------
		// Software Environment
		// ---------------------------	

		// Application Version
		// params.av = "1.0"; // TODO

		// SDK Version
		params.v = Config.getVersion();

		// OS Version
		params.sv = Core.Capabilities.getPlatformOSVersion();
		
		// Runtime
		params.rt = 'mobage';
		params.rtv = Core.Capabilities.getSDKVersion();
		

		// ---------------------------
		// Location
		// ---------------------------

		var location = null;
		if((location = Controller.getLocation())) {
			queryString.ll = location;
			location = null;
		}

		// ---------------------------
		// Additional Parameters
		// These would be passed in from a previous request that failed
		// ---------------------------

		if(typeof this.requestKeywords == 'function') {
			params.k = this.requestKeywords(this);
			if(!params.k) delete(params.k);
			else params.k = params.k.toString();
		}
		
		if(typeof this.requestQuery == 'function') {
			params.q = this.requestQuery(this);
			if(!params.q) delete(params.q);
			else params.q = params.q.toString();
		}
		
		// Set the request ad url if the delegate responds
		if(typeof this.requestAdUrl == 'function') {
			params.adurl = this.requestAdUrl(this);
			if(!params.adurl) delete(params.adurl);
			else params.adurl = params.adurl.toString();
		}

		var request = new HTTPRequest;
		request.start({
			url: Config.getAdvertisingURL(),
			data: params,
			type: "get",
            userAgent: Controller.getUserAgent(),
			success: function(request, response) {
				if(request.getStatusCode() == 200) {
					self.adRequestFinished(request, response);
				} else {
					self.requestFailed(request, null);
				}
			},
			error: function(request, error) {
				self.requestFailed(request, error);
			}
		});
		request.release();
	},
	
	/**
	 * Handles an ad request that suceeded with a status code of 200
	 * Attempts to parse the response for creatives and load an ad,
	 * If failed to load, it will {@link Mobclix.AdViewInternal#requestFailed}
	 * 
	 * @see Mobclix.AdViewInternal#requestFailed
	 * @see Mobclix.AdViewInternal#loadAd
	 * @private
	 */
	adRequestFinished: function(request, response) {
		this._isLoading = false;
		
		$mc.log("Request finished, response: " + request.getResponseText());

		var newCreatives = new MMArray();
		try {
			for(var index in response.creatives) {
				try {
					var creative = Creative.Create({creative: response.creatives[index]});
					newCreatives.push(creative);
					creative.release();
				} catch(e2) {
					$mc.log("Error while building creative model: ", e);
				}
			}
		} catch(e) {
			$mc.log("Error while building creative models: ", e);
		}
		
		$mc.log("setting currentcreatives");
		
		this.currentCreatives = newCreatives;

		$mc.log("release newcreatives");
		newCreatives.release();

		if(!this.currentCreatives || this.currentCreatives.length < 1) {
			this.requestFailed(request, "Failed to parse creative");
		} else {
			this.loadCreative(this.currentCreatives.get(0));
		}
	},
	
	/**
	 * Handles a failed ad request
	 * @see Mobclix.AdViewInternal#failWithError
	 * @private
	 */
	requestFailed: function(request, error) {
		$mc.log("Request failed -- error: ", error, "status code: ", request.request.status);

		if(request.request.status == 500) {
			this.failWithError(this.Error.Server, error);
		} else if(request.request.status == 0) {
			this.failWithError(this.Error.Connection, error);
		} else {
			this.failWithError(this.Error.Unknown, error);
		}
        
        if (this._size.width == 999) {
            this._canRequestNextAd = true;
        }
	},
	
	// ====
	// Creative Display Lifecycle
	// ====
	
	/**
	 * Loads the provided creative into the related CreativeView Type
	 * @param	{Object}	creative	Creative model to be loaded, must be an instance of {@link Mobclix.Creative.Base}
	 * @private
	 */
	loadCreative: function(creative) {
		$mc.log("Loading creative: " + creative);
		this.currentCreative = creative;
		
        if(this._size.width == 999) {
            $mc.log("Creating FullScreen Creative View");
            var creativeView = new FullScreenCreativeView();
            this.nextCreativeView = creativeView;
            creativeView.release();
            
            this.nextCreativeView.adView = this;
            this.nextCreativeView.loadWithCreative(this.currentCreative);
        } else {
            var creativeView = new WebCreativeView();
            this.nextCreativeView = creativeView;
            creativeView.release();
            
            var x = 0;
            
            var frame = this.getBounds();
            frame[0] = frame[2] * -2;
            frame[1] = frame[3] * -2;
            
            this.nextCreativeView.setFrame(frame);
            this.nextCreativeView.adView = this;
            this.addChild(this.nextCreativeView);
            this.nextCreativeView.loadWithCreative(this.currentCreative);
        }
	},

	/**
	 * Callback for instances of {@link Mobclix.Creative.Base} to indicate they're finished loading and ready to be displayed
	 * 
	 * @param	{object}	creativeView	Instance of {@link Mobclix.CreativeView.Base}
	 * @param	{object}	creative		Instance of {@link Mobclix.Creative.Base}
	 * @return	{bool}	If false, the creativeView/creative is no longer the current creative being loaded and should immediately halt it's lifecycle
	 * @private
	 */
	creativeViewFinishedLoading: function(creativeView, creative) {
		if(creative != this.currentCreative) {
			$mc.log("Creative load finished, but wasn't current creative: ", creative);
			creativeView.removeFromParent();
			return false;
		}

		// Notify the delegate
		this._wasPaused = false;
		if(typeof this.onFinishLoad == 'function') {
			this.onFinishLoad(this);
		}

		// Auto display ad
		if(this._autoDisplayNextAdRequest)
            this.displayAd();
        else
			this._hasPrefetchedAd = true;
		
		// Schedule the next ad
		if(this.shouldScheduleGetAd()) this.scheduleNextGetAd();

		return true;
	},

	/**
	 * Callback for instances of {@link Mobclix.Creative.Base} to indicate they've failed to load
	 * 
	 * @param	{object}	creativeView	Instance of {@link Mobclix.CreativeView.Base}
	 * @param	{object}	creative		Instance of {@link Mobclix.Creative.Base}
	 * @param	{object}	error	Underlying error
	 * @return	{boolean}	Flag indicating whether or not the provided creativeView/creative is still the current creative being loaded
	 * @private
	 */
	creativeViewFailedToLoad: function(creativeView, creative, error) {
        $mc.log("creativeViewFailedToLoad: ", creativeView);
        $mc.log("creativeViewFailedToLoad: ", creative);
        $mc.log("creativeViewFailedToLoad: ", error);
		var returnValue = true;
		
		if(creative != this.currentCreative) {
			$mc.log("Creative load failed, but wasn't current creative: ", creative);
			returnValue = false;
		} else {
			this.nextCreativeView = null;

			var creativeIndex = this.currentCreatives.indexOf(creative);

			if(creativeIndex + 1 < this.currentCreatives.length) {
				this.loadCreative(this.currentCreatives.get(creativeIndex + 1));
				returnValue = false;
			} else {
				if(creative.requestParameters && creative.requestParameters.length > 0) {
					this._getAd(creative.requestParameters, this._autoDisplayNextAdRequest);
					returnValue = false;
				} else {
					this.failWithError(this.Error.Unknown, error);
					returnValue = true;
				}
			}
		}

		creativeView.removeFromParent(); // We remove at the end, because it deallocs on remove
		return returnValue;
	},
	
	/**
	 * Displays the next creative view and triggers any actions/events asssociated with it
	 * @private
	 */
	displayAd: function() {
        if (this.nextCreativeView == null)
            return;
    
		var creativeView = this.nextCreativeView;
		var self = this;
        
        // Remove any old creative views, but leave current creative views
        $mc.each(this.getChildren(), function(view) {
            if(view == creativeView) return;
            $mc.log("Removing: " + view);
            self.queueReusableCreativeView(view);
            view.removeFromParent();
        });
    
        // Add new creativeview if it's not already in the stack.
        // This shouldn't ever happen, but we better be sure.
        if(!creativeView.getParent() || creativeView.getParent() != this) {
            this.addChild(creativeView);
        }
            

        if (this._size.width == 999) {
            creativeView.display();
            
            if(typeof this.onPresentAd == 'function') {
                this.onPresentAd(this);
            }
                
            // Update current reference
            this.currentCreativeView = creativeView;
        } else {
            
            // Place a temporary view over the view, or else the first ad on
            // Android won't load.
            if (Controller.isAndroid()) {
                var tempView = new MMView();
                this.addChild(tempView);
                tempView.removeFromParent();
            }

            // Bring view on screen
            creativeView.setFrame(this.getBounds());

            // Update current reference
            this.currentCreativeView = creativeView;

            // Autoplay if asked to
            var action = this.currentCreative.getAction();
            if(action && action.shouldAutoplay() && this._shouldAutoplay) {
                this._lastAutoplayTime = new Date();
                this.openActionURL(self.currentCreative, action.getUrl());
            }
        
        }

        // Notify tracking URLs
        try { this.currentCreative.getEvents().triggerEvent("show"); } catch(e) { }
        this.currentCreativeView.creativeHasBeenDisplayed();
            
		this.nextCreativeView = null;
		this._hasPrefetchedAd = false;
		this._shouldAutoplay = false;
	},
	
	/**
	 * Attempts to queue a resueable creative view
	 * @param	{object}	creativeView	Instance of {@link Mobclix.CreativeView.Base}
	 * @private
	 */
	queueReusableCreativeView: function(creativeView) {
		// TODO
	},
	
	/**
	 * Handles errors when loading an ad and notifies any listeners
	 * @private
	 */
	failWithError: function(code, error) {
		this._isLoading = false;

		if(typeof this.onFailedToLoad == 'function') {
			this.onFailedToLoad(this, code, error);
		}

		if(this.shouldScheduleGetAd()) this.scheduleNextGetAd();
	},
	
	// ====
	// Actions
	// ====

	/**
	 * Determines whether or not a creative can touch through
	 * 
	 * @param	{object}	creative		Instance of {@link Mobclix.Creative.Base}
	 * 
	 * @return	{boolean}	Whether or not the creative can touch through
	 * @private
	 */
	shouldTouchThrough: function(creative) {
		return !Controller.inModal;
	},

	/**
	 * Tells the ad view a creative will touch through
	 * Any touch through events will be fired at this point
	 * 
	 * @param	{object}	creative		Instance of {@link Mobclix.Creative.Base}
	 * @private
	 */
	willTouchThrough: function(creative) {
		Controller.inModal = true;
		this.cancelScheduledGetAd();

		if(typeof this.onWillTouchThrough == 'function') {
			this.onWillTouchThrough(this);
		}
	},
	
	/**
	 * Tells the ad view a creative did touch through
	 * Any did touch through events will be fired at this point
	 * 
	 * @param	{object}	creative		Instance of {@link Mobclix.Creative.Base}
	 * @private
	 */
	didTouchThrough: function(creative) {
		Controller.inModal = false;

		if(typeof this.onDidTouchThrough == 'function') {
			this.onDidTouchThrough(this);
		}

		if(this.shouldScheduleGetAd()) this.scheduleNextGetAd();
	},
	
	/**
	 * Convenience method to handle opening a full screen action URL.
	 * This method will automatically handle any events
	 * that need to be triggered when handling full screen takeovers
	 * 
	 * @param	{object}	creative		Instance of {@link Mobclix.Creative.Base}
	 * @param	{string}	url		Action URL to open in a full screen browser
	 * 
	 * @return	{boolean}	Whether or not the action url was able to open
	 * @private
	 */
	openActionURL: function(creative, url) {
		if(!this.shouldTouchThrough()) {
			$mc.log("Already in modal, can't open url");
			return false;
		}

		var self = this;
		
		this.willTouchThrough();
		$mc.log("Opening action URL:", url);
		
		var browserType = null;
		
		try {
			browserType = creative.getBrowserType();
		} catch (e) {
			browserType = Browser.Type.Toolbar;
		}
		
		var browser = new Browser(browserType);
		browser.onDidFinish = function() {
			self.didTouchThrough(creative);
		};
		
		browser.loadUrl(url);
		browser.presentViewController(true);
		browser.release();
		browser = null;
	},
	
	// ====
	// Memory Management
	// ====
	
	/** @private */
	destroy: function($super) {
		Config.removeListener(this._listener);
		this._listener.destroy();
		
		this.currentCreatives = null;
		this.currentCreative = null;
		this.nextCreativeView = null;
		this.adSpaceName = null;
		this._size = null;
		
		$mc.log(" ---- ADVIEW DESTROY ---- ");
		$super();
	}
});

// Properties
(function() {
	AdViewInternal.addProperty('currentCreatives', true);
	AdViewInternal.addProperty('currentCreative', true);
	AdViewInternal.addProperty('nextCreativeView', true);
	AdViewInternal.addProperty('adSpaceName', false);
	AdViewInternal.addProperty('requestAdUrl', false);
	AdViewInternal.addProperty('refreshTime', false, 0);
})();

// MobclixAdView Events
(function() {
	/**
	 * @name Mobclix.AdView#setOnFinishLoad
	 * @description Set a function to call when the <code>finishLoad</code> event occurs.
	 * @param {Function} eventCallback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * <br><br><b>Note:</b> This event is disabled if the value of this parameter is not a function.<br>
	 * @see Mobclix.AdView#getOnFinishLoad
	 * @function
	 */
	/**
	 * @name Mobclix.AdView#getOnFinishLoad
	 * @description Retrieve the function to call when the <code>finishLoad</code> event occurs.
	 * @return {Function} The current callback function.
	 * @see Mobclix.AdView#setOnFinishLoad
	 * @function
	 */
    /**
	 * @name Mobclix.FullScreenAdView#setOnFinishLoad
	 * @description Set a function to call when the <code>finishLoad</code> event occurs.
	 * @param {Function} eventCallback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * <br><br><b>Note:</b> This event is disabled if the value of this parameter is not a function.<br>
	 * @see Mobclix.FullScreenAdView#getOnFinishLoad
	 * @function
	 */
	/**
	 * @name Mobclix.FullScreenAdView#getOnFinishLoad
	 * @description Retrieve the function to call when the <code>finishLoad</code> event occurs.
	 * @return {Function} The current callback function.
	 * @see Mobclix.FullScreenAdView#setOnFinishLoad
	 * @function
	 */
	AdViewInternal.addProperty('onFinishLoad', false);

	/**
	 * @name Mobclix.AdView#setOnFailedToLoad
	 * @description Set a function to call when the <code>failedToLoad</code> event occurs.
	 * @param {Function} eventCallback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView, code, error)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * The <code>code</code> parameter is the error code matching {@link Mobclix.AdView#Error}.
	 * The <code>error</code> parameter is a string describing the error.
	 * <br><br><b>Note:</b> This event is disabled if the value of this parameter is not a function.<br>
	 * @see Mobclix.AdView#getOnFailedToLoad
	 * @function
	 */

	/**
	 * @name Mobclix.AdView#getOnFailedToLoad
	 * @description Retrieve the function to call when the <code>failedToLoad</code> event occurs.
	 * @return {Function} The current callback function.
	 * @see Mobclix.AdView#setOnFailedToLoad
	 * @function
	 */
    
    	/**
	 * @name Mobclix.FullScreenAdView#setOnFailedToLoad
	 * @description Set a function to call when the <code>failedToLoad</code> event occurs.
	 * @param {Function} eventCallback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView, code, error)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * The <code>code</code> parameter is the error code matching {@link Mobclix.AdView#Error}.
	 * The <code>error</code> parameter is a string describing the error.
	 * <br><br><b>Note:</b> This event is disabled if the value of this parameter is not a function.<br>
	 * @see Mobclix.FullScreenAdView#getOnFailedToLoad
	 * @function
	 */

	/**
	 * @name Mobclix.FullScreenAdView#getOnFailedToLoad
	 * @description Retrieve the function to call when the <code>failedToLoad</code> event occurs.
	 * @return {Function} The current callback function.
	 * @see Mobclix.FullScreenAdView#setOnFailedToLoad
	 * @function
	 */
	AdViewInternal.addProperty('onFailedToLoad', false);

	/**
	 * @name Mobclix.AdView#setOnCanAutoplay
	 * @description Set a function for the ad view to call to determine if an ad can autoplay.
	 * This will override the default setting used on the developer dashboard.
	 * <br /><br />
	 * Autoplay ads are similar to interstitial ads and will automatically
	 * open a website, video, or any other kind of modal action supported by the SDK.
	 * <br /><br />
	 * If this method isn't implemented, the settings provided on the Dashboard are used.
	 * @param {Function} callback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * This function most return boolean value indicating whether or not ads can autoplay.
	 * <br><br><b>Note:</b> This event is disabled if the value of this parameter is not a function.<br>
	 * @see Mobclix.AdView#getOnCanAutoplay
	 * @function
	 */
	/**
	 * @name Mobclix.AdView#getOnCanAutoplay
	 * @description Retrieve the function to call when the ad view needs to determine if it can autoplay ads.
	 * @return {Function} The current callback function.
	 * @see Mobclix.AdView#setOnCanAutoplay
	 * @function
	 */
	AdViewInternal.addProperty('onCanAutoplay', false);


	/**
	 * @name Mobclix.AdView#setOnWillTouchThrough
	 * @description Set a function for the ad view to call when the user touches through.  When this happens, the ad view will take over the screen experience, so in the case of a game it should be paused.
	 * @param {Function} callback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * This function most return boolean value indicating whether or not ads can autoplay.
	 * <br><br><b>Note:</b> This event is disabled if the value of this parameter is not a function.<br>
	 * @see Mobclix.AdView#getOnWillTouchThrough
	 * @function
	 */
	/**
	 * @name Mobclix.AdView#getOnWillTouchThrough
	 * @description Retrieve the function to call when the user touches through.
	 * @return {Function} The current callback function.
	 * @see Mobclix.AdView#setOnWillTouchThrough
	 * @function
	 */
	AdViewInternal.addProperty('onWillTouchThrough', false);

	/**
	 * @name Mobclix.AdView#setOnDidTouchThrough
	 * @description Set a function for the ad view to call when the user touch through is finished.  When this happens, the ad view is no longer taking over the screen experience, so in the case of a game, game play can be resumed.
	 * @param {Function} callback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * This function most return boolean value indicating whether or not ads can autoplay.
	 * <br><br><b>Note:</b> This event is disabled if the value of this parameter is not a function.<br>
	 * @see Mobclix.AdView#getOnDidTouchThrough
	 * @function
	 */
	/**
	 * @name Mobclix.AdView#getOnDidTouchThrough
	 * @description Retrieve the function to call when the user touches through.
	 * @return {Function} The current callback function.
	 * @see Mobclix.AdView#setOnDidTouchThrough
	 * @function
	 */
	AdViewInternal.addProperty('onDidTouchThrough', false);

	/**
	 * @name Mobclix.FullScreenAdView#setOnPresentAd
	 * @description Set a function to call when the <code>presentAd</code> event occurs.
	 * @param {Function} eventCallback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * <br><br><b>Note:</b> This event is disabled if the value of this parameter is not a function.<br>
	 * @see Mobclix.FullScreenAdView#getOnPresentAd
	 * @function
	 */

	/**
	 * @name Mobclix.FullScreenAdView#getOnPresentAd
	 * @description Retrieve the function to call when the <code>presentAd</code> event occurs.
	 * @return {Function} The current callback function.
	 * @see Mobclix.FullScreenAdView#setOnPresentAd
	 * @function
	 */
	AdViewInternal.addProperty('onPresentAd', false);
    
    /**
	 * @name Mobclix.FullScreenAdView#setOnDismissAd
	 * @description Set a function to call when the <code>dismissAd</code> event occurs.
	 * @param {Function} eventCallback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * <br><br><b>Note:</b> This event is disabled if the value of this parameter is not a function.<br>
	 * @see Mobclix.FullScreenAdView#getOnDismissAd
	 * @function
	 */

	/**
	 * @name Mobclix.FullScreenAdView#getOnDismissAd
	 * @description Retrieve the function to call when the <code>dismissAd</code> event occurs.
	 * @return {Function} The current callback function.
	 * @see Mobclix.FullScreenAdView#setOnDismissAd
	 * @function
	 */
	AdViewInternal.addProperty('onDismissAd', false);

	/**
	 * @name Mobclix.AdView#setRichMediaRequiresUserInteraction
	 * @description Set a function for the ad view to call when determining if rich media requires user interaction:<br />
	 * Rich Media features include access to the following:<br />
	 * <ul>
	 *	<li>LED Flash</li>
	 *	<li>Vibrate</li>
	 *	<li>Sound</li>
	 * </ul>
	 * To allow these features to work automatically, this callback should return false.
	 * <br /></br />
	 * Applications that vibrate or play sound, should return true.
	 * <br /></br />
	 * If this callback isn't implemented, the settings provided on the Dashboard are used.
	 * @param {Function} callback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * This function most return boolean value indicating whether or not ads can autoplay.
	 * @see Mobclix.AdView#getRichMediaRequiresUserInteraction
	 * @function
	 */
	/**
	 * @name Mobclix.AdView#getRichMediaRequiresUserInteraction
	 * @description Retrieve the function to call when determining if rich media requires user interaction.
	 * @return {Function} The current callback function.
	 * @see Mobclix.AdView#setRichMediaRequiresUserInteraction
	 * @function
	 */
	AdViewInternal.addProperty('richMediaRequiresUserInteraction', false);
	
	/**
	 * @name Mobclix.AdView#setRequestKeywords
	 * @description Set a function for the ad view to call to get the request keywords.
	 * @param {Function} callback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * This function most return boolean value indicating whether or not ads can autoplay.
	 * @see Mobclix.AdView#getRequestKeywords
	 * @function
	 */
	/**
	 * @name Mobclix.AdView#getRequestKeywords
	 * @description Retrieve the function to call to get the request keywords.
	 * @return {Function} The current callback function.
	 * @see Mobclix.AdView#setRequestKeywords
	 * @function
	 */
	AdViewInternal.addProperty('requestKeywords', false);
	
	/**
	 * @name Mobclix.AdView#setRequestQuery
	 * @description Set a function for the ad view to call to get the request query.
	 * @param {Function} callback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * This function most return boolean value indicating whether or not ads can autoplay.
	 * @see Mobclix.AdView#getRequestQuery
	 * @function
	 */
	/**
	 * @name Mobclix.AdView#getRequestQuery
	 * @description Retrieve the function to call to get the request query.
	 * @return {Function} The current callback function.
	 * @see Mobclix.AdView#setRequestQuery
	 * @function
	 */
	AdViewInternal.addProperty('requestQuery', false);
})();

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/MMView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/MMView'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/MMView'] = exports; //
//  Mobclix.Core.MMView.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var UI = require('NGCore/Client/UI').UI;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

/**
 * @class MMView is a memory managed subclass of UI.View that brings in all methods supplied by {@link Mobclix.Core.MMClass}
 * @name Mobclix.Core.MMView
 * @extends UI.View
 * @private
 */
var mmViewMethods = exports.MMViewMethods = 
/** @lends Mobclix.Core.MMView.prototype */
{
	__className: "MMView",

	/**
	 * Adds the child node from it's view hierarchy and retains it
	 * @private
	 * @function
	 */
	addChild: function($super, childNode, index) {
		$super(childNode, index);
		try { childNode.retain(); } catch(e) { }
	},

	/**
	 * Removes the child node from it's view hierarchy and releases it
	 * @private
	 * @function
	 */
	removeChild: function($super, childNode) {
		$super(childNode);
		try { childNode.release(); } catch(e) { }
	},

	/**
	 * Gets the current bounds of the view
	 * @function
	 * @return	{object}	Bounds of the object
	 * @private
	 */
	getBounds: function() {
		var frame = this.getFrame();
        var bounds = [frame[0], frame[1], frame[2], frame[3]];
		bounds[0] = 0;
		bounds[1] = 0;
		return bounds;
	}
};

var MMView = exports.MMView = UI.View.subclass($mc.extend(require('NGCore/Client/Mobclix/Core/MMClass').Memory, mmViewMethods));
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/Config'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/Config'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/Config'] = exports; //
//  Mobclix.Core.Config.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var Network = require('NGCore/Client/Network').Network;
var Storage = require('NGCore/Client/Storage').Storage;
var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;

var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;
// var Controller = require('./Controller').Controller;
var HTTPRequest = require('NGCore/Client/Mobclix/Core/HTTPRequest').HTTPRequest;

exports.Config = Core.Class.singleton({
	version: "0.99",
	
	configURL: "http://data.mobclix.com/post/config",
	advertisingURL: "http://ads.mobclix.com/",
	
	config: {},
	emitter: null,
	_isUpdating: false,
	_hasConfigFailed: false,
	_idleTimeoutInterval: 0.0,
	
	initialize: function() {
		this.emitter = new Core.MessageEmitter();
	},
	
	updateConfiguration: function(controller) {
		if(this.isUpdating()) return;
		else this._setUpdating(true);

		this._updateConfiguration(controller);
	},
	
	_updateConfiguration: function(controller) {
		var sessionTracking = controller.sessionTracking;
		
		if(controller.getNetworkState() == "none") {
			$mc.log("network state none");
			this.isUpdating(false);
			sessionTracking.offlineSessionCount++;
			sessionTracking.saveSessionTrackingData();
			this._hasConfigFailed = true;
			this.emitter.emit(this);
			return;
		}

		var self = this;

		// Load cached first
		try {
			Storage.FileSystem.readFile("MobclixConfig-" + controller.applicationId, false, function(error, value) {
				try {
					value = eval("("+value+")");
				} catch(e) { }

				if(value && typeof value == 'object' && value.length > 0) {
					self.config = value;
				}
			});
            
            var kv = new Storage.KeyValue();
            kv.registerForKey("mobclix");
            kv.getItem("userAgent", function(param1, value, key) {
                controller.setUserAgent(value, true);
                kv.destroy();
            });
		} catch(e) { }

		// Request fresh config
		var queryString = {
			a: controller.applicationId,
			p: controller.isAndroid() ? 'android' : (controller.isIPad() ? 'ipad' : 'iphone'),
			m: this.version,
			// v: "1.0", // TODO
			d: Core.Capabilities.getUniqueId(),
			dm: Core.Capabilities.getDeviceName(),
			// dv: "", // TODO
			hwdm: Core.Capabilities.getPlatformHW(),
			g: controller.getNetworkState(),
			off: sessionTracking.offlineSessionCount,
			st: sessionTracking.lastSessionLength,
			it: sessionTracking.idleSessionTime,
			rt: 'mobage',
			rtv: Core.Capabilities.getSDKVersion()
		};

		$mc.log("sessionTracking.offlineSessionCount:", sessionTracking.offlineSessionCount);
		$mc.log("sessionTracking.lastSessionLength:", sessionTracking.lastSessionLength);
		$mc.log("sessionTracking.idleSessionTime:", sessionTracking.idleSessionTime);
		
		// Location
		var location = null;
		if((location = controller.getLocation())) {
			queryString.ll = location;
			location = null;
		}
		
		var newKey = controller.applicationId + "-new";
		KeyValueCache.local.getItem(newKey, function(error, value) {
			// Determine if new
			if((error && error.length > 0) || value !== "false") {
				$mc.log("Detected new user");
				queryString['new'] = true;
				KeyValueCache.local.setItem(newKey, "false");
			}

			// Start request
			var request = new HTTPRequest;
			request.start({
				url: self.getConfigURL(),
				data: queryString,
				type: "get",
				success: function(request, response) {
					if(request.getStatusCode() == 200) {
						if(typeof response == 'string') {
							// Temp fix until the headers are updated on remote config
							response = eval("("+response+")");
						}

						self.finishedUpdating(response, controller);
					} else {
						self.failedToUpdate("Unknown error", controller);
					}
				},
				error: function(request, error) {
					self.failedToUpdate(error, controller);
				}
			});
			request.release();
		}, true);
	},
	
	finishedUpdating: function(response, controller) {
		this._setUpdating(false);
		this._hasConfigFailed = false;
		this.config = typeof response == 'object' ? response : {};
		controller.sessionTracking.idleSessionTime = 0;
		controller.sessionTracking.lastSessionLength = 0;
		controller.sessionTracking.offlineSessionCount = 0;
		controller.sessionTracking.saveSessionTrackingData();
		
		try {
			Storage.FileSystem.writeFile("MobclixConfig-" + controller.applicationId, JSON.stringify(this.config));
		} catch(e) { }
		
		this.emitter.emit(this);
	},
	
	failedToUpdate: function(error, controller) {
		$mc.log("Config Request failed, error: ", error);
		this._hasConfigFailed = true;
		this._setUpdating(false);
		controller.sessionTracking.offlineSessionCount++;
		controller.sessionTracking.saveSessionTrackingData();
		this.emitter.emit(this);
	},
	
	hasConfigFailed: function() {
		return this._hasConfigFailed;
	},
	
	addListener: function(listener, func) {
		this.emitter.addListener(listener, func);
	},
	
	removeListener: function(listener) {
		this.emitter.removeListener(listener);
	},
	
	getVersion: function() {
		return this.version;
	},
	
	_setUpdating: function(b) {
		this._isUpdating = b;
	},
	
	isUpdating: function() {
		return this._isUpdating;
	},
	
	getIdleTimeoutInterval: function() {
		try {
			return this.config.idle_timeout || this._idleTimeoutInterval;
		} catch (e) {
			return this._idleTimeoutInterval;
		}
	},
	
	getConfigURL: function() {
		try {
			return this.config.urls.config || this.configURL;
		} catch (e) {
			return this.configURL;
		}
	},
	
	getAdvertisingURL: function() {
		try {
			return this.config.urls.ads || this.advertisingURL;
		} catch (e) {
			return this.advertisingURL;
		}
	},
	
	getAnalyticsURL: function() {
		try {
			return this.config.urls.analytics || this.analyticsURL;
		} catch (e) {
			return this.analyticsURL;
		}
	},
	
	getNativeURLs: function() {
		var nativeURLs = null;
		
		try {
			nativeURLs = this.config.native_urls;
			if(!nativeURLs instanceof Array) {
				nativeURLs = null;
			}
		} catch(e) {
			nativeURLs = null;
		}
		
		if(!nativeURLs || nativeURLs.length == 0) {
			nativeURLs = [
							"itunes.apple.com",
							"phobos.apple.com",
							"maps.google.com",
							"youtube.com",
							"mailto:"
						];
		}
		
		return nativeURLs;
	},
	
	isAdUnitEnabled: function(size) {
		var props = this._propertiesForAdUnit(size);
		return $mc.parseBool(props.autoplay_interval) || true;
	},
	
	isAutoPlayEnabled: function(size) {
		var props = this._propertiesForAdUnit(size);
		return $mc.parseBool(props.autoplay) || false;
	},
	
	richMediaRequiresUserInteraction: function(size) {
		var props = this._propertiesForAdUnit(size);
		return $mc.parseBool(props.rm_require_user) || true;
	},
	
	refreshInteveralForAdUnit: function(size) {
		var props = this._propertiesForAdUnit(size);
		return parseInt(props.autoplay_interval, 10) || 30;
	},
	
	autoplayTimeoutInteveralForAdUnit: function(size) {
		var props = this._propertiesForAdUnit(size);
		return parseInt(props.autoplay_interval, 10) || size.height == 250 ? 0 : 120;
	},
	
	_propertiesForAdUnit: function(size) {
		var props = null;
		
		if(size.width == 999) {
			size = "fullscreen";
		} else {
			size = size.width  + "x" + size.height;
		}

		try {
			if(this.config.ad_units) $mc.each(this.config.ad_units, function(unit, key) {
				if(unit.size == size) {
					props = unit;
					return false;
				}
			});
		} catch(e) { }

		return props || {};
	},
	
	destroy: function() {
		this.version = null;
		this.configURL = null;
		this.advertisingURL = null;
		this.analyticsURL = null;
		this.config = null;
		this.emitter = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/Utils'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/Utils'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/Utils'] = exports; //
//  Mobclix.Core.Utils.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;

exports.Utils = Core.Class.singleton(
/** @lends Mobclix.Core.Utils.prototype */
{
	/**
	 * @class Utils is a singleton class with a collection of static utility methods to help with development.
	 * @constructs The default constructor.
	 * @private
	 */
	initialize: function() {
		
	},
	
	/**
	 * Gets device indpenedent pixel
	 * @param	{number} pixel	Pixel to conver to DIP
	 * @return	{number} pixel converted to dip
	 * @private
	 */
	$dip: function(pixel) {
		return Math.round(pixel * Core.Capabilities.getScreenUnits());
	},
	
	/**
	 * Add a property to a class so it can be called the following ways:
	 * @example
	 * <code>(function() {
	 * Foo.addProperty('bar', true);
	 * })();
	 *
	 * // Instances of Foo can now access the bar property the following ways:
	 * obj.bar = value;
	 * obj.setBar(value);
	 * var barVal = obj.bar;
	 * var barVal = obj.getBar();</code>
	 * 
	 * 
	 * @param	{class}	target		Target class to this property to
	 * @param	{string}	propName	Name of the property to add to the class
	 * @param	{boolean}	shouldRetain	Whether or not this property should be retained when set (and released when unset)
	 * @param	{mixed}	defaultValue	Default value of this property
	 * @private
	 * @function
	 * @static
	 */
	$addProperty: function(target, propName, shouldRetain, defaultValue) {
		if(!propName) return;
		var self = this;
		
		shouldRetain = shouldRetain || false;

		var instVarName = '__' + propName;
		var caseAdjusted = propName.charAt(0).toUpperCase() + propName.substr(1);

		target.prototype[instVarName] = defaultValue || null;
		
		if(typeof target.prototype['get'+caseAdjusted] != 'function') {
			target.prototype['get'+caseAdjusted] = function() {
				return this[instVarName];
			};
		}

		if(typeof target.prototype['set'+caseAdjusted] != 'function') {
			target.prototype['set'+caseAdjusted] = function(newValue) {
				this[instVarName] = newValue;
			};
		}

		target.prototype.__defineSetter__(propName, function(newValue) {
			if(this[instVarName] && shouldRetain) {
				if(shouldRetain) {
					try {
						this[instVarName].release();
					} catch(e) {
						self.log("Error releasing ", target[instVarName], e);
					} finally {
						this[instVarName] = defaultValue;
					}
				}
			}
			
			this[instVarName] = newValue;
			if(shouldRetain && newValue) {
				try {
					newValue.retain();
				} catch(e) {
					self.log("Error retaining ", newValue, e);
				}
			}
		});
		
		target.prototype.__defineGetter__(propName, function() {
			return this[instVarName];
		});
	},
	
	/**
	 * Logs to console
	 */
	$log: function() {
		arguments[0] = "MobclixSDK: " + arguments[0];
		console.log.apply(console.log, arguments);
	},
	
	/**
	 * Primative stack trace tool
	 */
	$trace: function() {
		var stack = arguments.callee;
		
		this.log("+ Starting Trace");

		while(stack) {
			this.log("|", stack.toString().split('\n')[0].replace(/\{\s?/, ""));
			stack = stack.caller;
		}
		
		this.log("+ Finished Trace");
	},
	
	/**
	 * Quickly enumerate an object or array
	 * 
	 * @param	{mixed}	object	Object or array to enumerate through
	 * @param	{function}	callback	Calback function that will be run on each element in the object.  Should conform to <code>function(value, key)</code>
	 * @private
	 * @function
	 * @static
	 */
	$each: function(object, callback) {
		if(!object) {
			this.log("Passed null object.. ");
			this.trace();
		}
		
		if(typeof object == 'array' || (typeof object.length == 'number' && typeof object[0] != 'undefined')) {
			for(var index = 0; index < object.length; index++) {
				if(callback(object[index], index) === false) break;
			}
		} else if(typeof object == 'object' && (typeof object.length != 'number' || object.length > 0)) {
			for(var key in object) {
				if(callback(object[key], key) === false) break;
			}
		}
	},
	
	/**
	 * Extend classes with functions and variables from another object
	 * 
	 * @param	{mixed}	target	base target to extend
	 * @param	{object}	objects,...	subsequent objects to apply to the base target
	 * @return	{mixed}	target extended with new functions/params
	 */
	$extend: function() {
		self = this;
		
		// Make sure we have a target
		if(arguments.length == 0) return {};

		// Get the tag
		var target = arguments[0];

		// Ensure we have an extendable target
		if(typeof target != 'object' && typeof target != 'function') {
			target = {};
		}

		for(var i = 1; i < arguments.length; i++) {
			// Get the object
			var object = arguments[i];

			// Ensure we have an object we can extend with, otherwise, bail.
			if(typeof object != 'object') {
				return target;
			}

			// Loop through object and bring eerything into the target scope
			for(var key in object) {
				var value = object[key];

				// Ignore undefined values
				if(typeof value == 'undefined') continue;

				// Handle null
				else if(value == null) {
					if(typeof target == 'function') target.prototype[key] = null;
					else target[key] = null;
				}

				// Handle objects recursively
				else if(typeof value == 'object') {
					if(typeof target == 'function') {
						target.prototype[key] = self.extend(target.prototype[key], value);
					} else {
						target[key] = self.extend(target[key], value);
					}
				}

				// For the rest, just do a straight assign
				else {
					if(typeof target == 'function') target.prototype[key] = value;
					else target[key] = value;
				}
			}
		}

		// Pass it back
		return target;
	},
	
	/**
	 * Get the bounds of a provided view
	 * 
	 * @param	{UI.View}	view	Instance of <code>UI.View</code> to get the bounds of
	 * @private
	 * @function
	 * @static
	 * @return	Bounds of the view
	 */
	$bounds: function(view) {
		var frame = view.getFrame();
		frame[0] = 0;
		frame[1] = 0;
		return frame;
	},
	
	/**
	 * Get the boolean value of a string
	 * 
	 * @param	{string}	str
	 * @private
	 * @function
	 * @static
	 * @return	Boolean
	 */
	$parseBool: function(str) {
		if(typeof str == 'undefined') return false;
		
		if(typeof str == 'boolean') {
			return str;
		}
		
		try {
			str = str.toString().substr(0, 1);
			if(str == "t" || str == "y" || str == "1") {
				return true;
			} else {
				return false;
			}
		} catch(e) {
			return false;
		}
	},
	
	/**
	 * Get the double value of a string
	 * 
	 * @param	{string}	str
	 * @private
	 * @function
	 * @static
	 * @return	Double
	 */
	$parseDouble: function(str) {
		if(typeof str == 'double' || typeof str == 'undefined') {
			return str;
		}
		
		if(str == null) return str;
		
		return str + 0.0;
	},
	
	/**
	 * Get the SHA1 value of a string
	 * 
	 * @param	{string}	msg
	 * @private
	 * @function
	 * @static
	 * @return	SHA1 String
	 */
	$sha1: function(msg) {
		/**
		*
		*  Secure Hash Algorithm (SHA1)
		*  http://www.webtoolkit.info/
		*
		**/

		function rotate_left(n,s) {
			var t4 = ( n<<s ) | (n>>>(32-s));
			return t4;
		};

		function lsb_hex(val) {
			var str="";
			var i;
			var vh;
			var vl;

			for( i=0; i<=6; i+=2 ) {
				vh = (val>>>(i*4+4))&0x0f;
				vl = (val>>>(i*4))&0x0f;
				str += vh.toString(16) + vl.toString(16);
			}
			return str;
		};

		function cvt_hex(val) {
			var str="";
			var i;
			var v;

			for( i=7; i>=0; i-- ) {
				v = (val>>>(i*4))&0x0f;
				str += v.toString(16);
			}
			return str;
		};


		function Utf8Encode(string) {
			string = string.replace(/\r\n/g,"\n");
			var utftext = "";

			for (var n = 0; n < string.length; n++) {

				var c = string.charCodeAt(n);

				if (c < 128) {
					utftext += String.fromCharCode(c);
				}
				else if((c > 127) && (c < 2048)) {
					utftext += String.fromCharCode((c >> 6) | 192);
					utftext += String.fromCharCode((c & 63) | 128);
				}
				else {
					utftext += String.fromCharCode((c >> 12) | 224);
					utftext += String.fromCharCode(((c >> 6) & 63) | 128);
					utftext += String.fromCharCode((c & 63) | 128);
				}

			}

			return utftext;
		};

		var blockstart;
		var i, j;
		var W = new Array(80);
		var H0 = 0x67452301;
		var H1 = 0xEFCDAB89;
		var H2 = 0x98BADCFE;
		var H3 = 0x10325476;
		var H4 = 0xC3D2E1F0;
		var A, B, C, D, E;
		var temp;

		msg = Utf8Encode(msg);

		var msg_len = msg.length;

		var word_array = new Array();
		for( i=0; i<msg_len-3; i+=4 ) {
			j = msg.charCodeAt(i)<<24 | msg.charCodeAt(i+1)<<16 |
			msg.charCodeAt(i+2)<<8 | msg.charCodeAt(i+3);
			word_array.push( j );
		}

		switch( msg_len % 4 ) {
			case 0:
				i = 0x080000000;
			break;
			case 1:
				i = msg.charCodeAt(msg_len-1)<<24 | 0x0800000;
			break;

			case 2:
				i = msg.charCodeAt(msg_len-2)<<24 | msg.charCodeAt(msg_len-1)<<16 | 0x08000;
			break;

			case 3:
				i = msg.charCodeAt(msg_len-3)<<24 | msg.charCodeAt(msg_len-2)<<16 | msg.charCodeAt(msg_len-1)<<8	| 0x80;
			break;
		}

		word_array.push( i );

		while( (word_array.length % 16) != 14 ) word_array.push( 0 );

		word_array.push( msg_len>>>29 );
		word_array.push( (msg_len<<3)&0x0ffffffff );


		for ( blockstart=0; blockstart<word_array.length; blockstart+=16 ) {

			for( i=0; i<16; i++ ) W[i] = word_array[blockstart+i];
			for( i=16; i<=79; i++ ) W[i] = rotate_left(W[i-3] ^ W[i-8] ^ W[i-14] ^ W[i-16], 1);

			A = H0;
			B = H1;
			C = H2;
			D = H3;
			E = H4;

			for( i= 0; i<=19; i++ ) {
				temp = (rotate_left(A,5) + ((B&C) | (~B&D)) + E + W[i] + 0x5A827999) & 0x0ffffffff;
				E = D;
				D = C;
				C = rotate_left(B,30);
				B = A;
				A = temp;
			}

			for( i=20; i<=39; i++ ) {
				temp = (rotate_left(A,5) + (B ^ C ^ D) + E + W[i] + 0x6ED9EBA1) & 0x0ffffffff;
				E = D;
				D = C;
				C = rotate_left(B,30);
				B = A;
				A = temp;
			}

			for( i=40; i<=59; i++ ) {
				temp = (rotate_left(A,5) + ((B&C) | (B&D) | (C&D)) + E + W[i] + 0x8F1BBCDC) & 0x0ffffffff;
				E = D;
				D = C;
				C = rotate_left(B,30);
				B = A;
				A = temp;
			}

			for( i=60; i<=79; i++ ) {
				temp = (rotate_left(A,5) + (B ^ C ^ D) + E + W[i] + 0xCA62C1D6) & 0x0ffffffff;
				E = D;
				D = C;
				C = rotate_left(B,30);
				B = A;
				A = temp;
			}

			H0 = (H0 + A) & 0x0ffffffff;
			H1 = (H1 + B) & 0x0ffffffff;
			H2 = (H2 + C) & 0x0ffffffff;
			H3 = (H3 + D) & 0x0ffffffff;
			H4 = (H4 + E) & 0x0ffffffff;

		}

		var temp = cvt_hex(H0) + cvt_hex(H1) + cvt_hex(H2) + cvt_hex(H3) + cvt_hex(H4);

		return temp.toLowerCase();
	},


	/**
	 * Base64 decode
	 * http://www.webtoolkit.info/
	 * 
	 * @param	{string}	input	base64 encoded string
	 * @function
	 * @static
	 * @private
	 * @return	{string} base64 decoded string
	 **/
	$base64Decode: function(input) {
		var keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
		
		var utf8_decode = function(utftext) {
			var string = "";
			var i = 0;
			var c = c1 = c2 = 0;

			while ( i < utftext.length ) {

				c = utftext.charCodeAt(i);

				if (c < 128) {
					string += String.fromCharCode(c);
					i++;
				}
				else if((c > 191) && (c < 224)) {
					c2 = utftext.charCodeAt(i+1);
					string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
					i += 2;
				}
				else {
					c2 = utftext.charCodeAt(i+1);
					c3 = utftext.charCodeAt(i+2);
					string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
					i += 3;
				}

			}

			return string;
		};
		
		var output = "";
		var chr1, chr2, chr3;
		var enc1, enc2, enc3, enc4;
		var i = 0;

		input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

		while (i < input.length) {

			enc1 = keyStr.indexOf(input.charAt(i++));
			enc2 = keyStr.indexOf(input.charAt(i++));
			enc3 = keyStr.indexOf(input.charAt(i++));
			enc4 = keyStr.indexOf(input.charAt(i++));

			chr1 = (enc1 << 2) | (enc2 >> 4);
			chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
			chr3 = ((enc3 & 3) << 6) | enc4;

			output = output + String.fromCharCode(chr1);

			if (enc3 != 64) {
				output = output + String.fromCharCode(chr2);
			}
			if (enc4 != 64) {
				output = output + String.fromCharCode(chr3);
			}

		}

		return utf8_decode(output);
	}

});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/Controller'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/Controller'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/Controller'] = exports; //
//  Mobclix.Core.Controller.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var Device = require('NGCore/Client/Device').Device;
var Storage = require('NGCore/Client/Storage').Storage;
var Session = require('NGCore/Client/Mobclix/Core/Session').Session;
var SessionTracking = require('NGCore/Client/Mobclix/Core/SessionTracking').SessionTracking;
var Config = require('NGCore/Client/Mobclix/Core/Config').Config;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var ProxyListener = Core.MessageListener.subclass({
	onUpdate: function() {}
});

exports.Controller = Core.Class.singleton({
	applicationId: null,
    userAgent: null,
	networkEmitter: null,
	proxyListener: null,
	_isAppActive: true,
	sessionTracking: null,
	inModal: false,
	emitter: null,
	_hasBeenStarted: false,
	
	initialize: function() {
		this.proxyListener = new ProxyListener();
		var self = this;
		
		this.emitter = new Core.MessageEmitter();
		
		Device.NetworkEmitter.addListener(this.proxyListener, function() { });
		Device.LifecycleEmitter.addListener(this.proxyListener, function(event) {
			if(event == Device.LifecycleEmitter.Event.Suspend) {
				self.willGoInactive();
			} else if(event == Device.LifecycleEmitter.Event.Resume) {
				self.didBecomeActive();
			} else if(event == Device.LifecycleEmitter.Event.Terminate) {
				self.willTerminate();
			}
		});
	},
	
	hasBeenStarted: function() {
		return this._hasBeenStarted;
	},
	
	startWithApplicationId: function(id) {
		$mc.log("Starting with app id: " + id);

		var oldAppId = this.applicationId;
		var self = this;
		this.applicationId = id;

		if(!oldAppId || oldAppId != id) {
			Session.renewIdentifier();
			
			if(this.sessionTracking) this.sessionTracking.destroy();
			this.sessionTracking = new SessionTracking(this);
		}
		
		this._hasBeenStarted = true;
		
		Config.updateConfiguration(this);
		setTimeout(function() {
			self.emitter.emit(self);
		}, 1);
	},
	
	addListener: function(listener, func) {
		this.emitter.addListener(listener, func);
	},
	
	removeListener: function(listener) {
		this.emitter.removeListener(listener);
	},

	willTerminate: function() {
		this._isAppActive = false;
		if(this.sessionTracking) this.sessionTracking.willTerminate();
		$mc.log("App Lifecycle: willTerminate");
	},
	
	didBecomeActive: function() {
		this._isAppActive = true;
		if(this.sessionTracking) this.sessionTracking.didBecomeActive();
		$mc.log("App Lifecycle: didBecomeActive");
	},
	
	willGoInactive: function() {
		this._isAppActive = false;
		if(this.sessionTracking) this.sessionTracking.willGoInactive();
		$mc.log("App Lifecycle: willGoInactive");
	},
	
	isApplicationActive: function() {
		return this._isAppActive;
	},
	
	isAndroid: function() {
		return Core.Capabilities.getPlatformOS().match(/android/i);
	},
	
	isIOS: function() {
		return Core.Capabilities.getPlatformOS().match(/iphone|ipad|ios|ipod/i);
	},
	
	isIPad: function() {
		return Core.Capabilities.getPlatformOS().match(/ipad/i);
	},
		
	getNetworkState: function() {
		return "wifi";
		
		// This is broken
		switch (Device.NetworkEmitter.getLastStatus()) {
			case Device.NetworkEmitter.Status.Cellular:
				return "wifi";
			case Device.NetworkEmitter.Status.Wifi:
				return "carrier";
			default:
				return "none";
		}
	},
	
	getLocation: function() {
		if(Device.LocationEmitter.getListenerCount() > 0) {
			var lastLocation = Device.LocationEmitter.getLastLocation();
			if(lastLocation && lastLocation.position) {
				return lastLocation.position.getX() + "," + lastLocation.position.getY();
			}
		}

		return null;
	},
	
	getApplicationId: function() {
		return this.applicationId;
	},
    
    setUserAgent: function(ua, fromCache) {
        if (this.userAgent == null && fromCache) {
            $mc.log("Loading user agent from cache: ", ua);
            this.userAgent = ua;
            return;
        } else if (this.userAgent == null ||
                ua != this.userAgent) {
            $mc.log("Saving new user agent to cache: ", ua);
            this.userAgent = ua;
            var kv = new Storage.KeyValue();
            kv.registerForKey("mobclix");
            kv.setItem("userAgent", ua, function(param1, value, key) {
                kv.destroy();
            });
            return;
        }
        $mc.log("Ignoring matching user agent: ", ua);
    },
    
    getUserAgent: function(ua) {
        return this.userAgent;
    },
	
	destroy: function() {
		this.applicationId = null;
		if(this.sessionTracking) this.sessionTracking.destroy();
		this.sessionTracking = null;
		Device.NetworkEmitter.removeListener(this.proxyListener);
		this.emitter = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/HTTPRequest'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/HTTPRequest'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/HTTPRequest'] = exports; //
//  Mobclix.Core.HTTPRequest.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var MMClass = require('NGCore/Client/Mobclix/Core/MMClass').MMClass;
var Network = require('NGCore/Client/Network').Network;
var Utils = require('NGCore/Client/Mobclix/Core/Utils').Utils;

exports.HTTPRequest = MMClass.subclass({
	__className: "HTTPRequest",

	success: false,
	loading: false,
	error: false,
	response: null,
	statusCode: 0,
	request: null,
	
	initialize: function() {
		try {
			this.request = new Network.XHR();
		} catch (e) {
			this.request = null;
		}
	},
	
	getStatusCode: function() {
		return this.statusCode;
	},
	
	getResponse: function() {
		return this.response;
	},
	
	getResponseText: function() {
		return this.request.responseText;
	},
	
	wasSuccessful: function() {
		return this.success;
	},
	
	getError: function() {
		return this.error;
	},

	start: function(options) {
		// If we don't have an ajax object, bail out
		if(!this.request) {
			this.error = true;
			if(options.error) options.error(this);
			return false;
		}
		
		// Cleanup options
		if(typeof options != "object") {
			options = {url: options};
		}
		
		// Setup some defaults
		options.type = options.type || "GET";
		options.timeout = options.timeout || 120;
		options.data = options.data || "";
		options.async = options.async || true;
		
		
		// Build data
		if(typeof options.data == "object") {
			var params = options.data;
			options.data = "";

			for(var key in params) {
				options.data += "&" + escape(key) + "=" + escape(params[key]);
			}
			
			if(options.data.length > 0) {
				options.data = options.data.substring(1, options.length);
			}
		} else if(options != null && typeof options != 'undefined') {
			options.data = options.data.toString();
		} else {
			options.data = "";
		}
        
		// Setup state change handler
		var self = this;
		self.retain();

		this.request.onreadystatechange = function() {
			// Check if we're done loading
			if(self.request.readyState != 4) return;
			self.loading = false;
			
			// Store status code
			self.statusCode = self.request.status;

			// See if it's a valid response
			if((self.statusCode >= 200 && self.statusCode < 300) || (!options.async && self.statusCode == 0)) {
				self.success = true;

				if(self.request.getResponseHeader("Content-type").indexOf("json") >= 0 || self.request.getResponseHeader("Content-type").indexOf("javascript") >= 0) {
					try {
						resp = eval("("+self.request.responseText+")");
					} catch (e) {
						resp = null;
					}
					
					if(resp == null || typeof resp == 'undefined') {
						resp = self.request.responseText;
					}
				} else {
					resp = self.request.responseText;
				}
				
				if(options.success) options.success(self, resp);
			} else if(self.request.responseXML) {
				resp = self.request.responseXML;
			} else {
				self.error = true;
				if(options.error) options.error(self, self.statusCode);
			}
			
			self.release();
		};
		
		// Start the request
		if(options.type.toLowerCase() == "get") {
			var url = options.url + (options.url.indexOf("?") >= 0 ? "&" : "?") + options.data;
			this.request.open("GET", url, options.async);

            if (options.userAgent != null)
                this.request.setRequestHeader("User-Agent", options.userAgent);
			this.request.send(null);
		} else {
			this.request.open(options.type, options.url, options.async);
			this.request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
			this.request.setRequestHeader("Content-length", options.data.length);
            if (options.userAgent != null)
                this.request.setRequestHeader("User-Agent", options.userAgent);
			this.request.send(options.data);
		}
		
		this.loading = true;
	},
	
	destroy: function($super) {
		// if(this.request) this.request.destroy(); // Network.XHR doesn't have a .destroy() -- what?
		this.request = null;
		this.response = null;
		
		$super();
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/MMArray'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/MMArray'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/MMArray'] = exports; //
//  Mobclix.Core.MMArray.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var MMClass = require('NGCore/Client/Mobclix/Core/MMClass').MMClass;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var MMArray = exports.MMArray = MMClass.subclass({
	__className: "MMArray",
	___array: null,
	length: 0,
	
	initialize: function($super) {
		$super();
		this.___array = new Array();
	},
	
	get: function(index) {
		return this.___array[index];
	},
	
	set: function(index, element) {
		if(this.___array[index]) {
			try { this.___array[index].release(); } catch (e) { }
		}
		
		this.___array[index] = element;
		try { this.___array[index].retain(); } catch(e) { }
		
		this.length = this.___array.length;
	},
	
	remove: function(index) {
		var element = this.___array[index];
		this.___array = this.___array.slice(0, index).join(this.___array.slice(index+1));
		try { element.release(); } catch (e) { }
		this.length = this.___array.length;
	},
	
	push: function() {
		for(var i = 0; i < arguments.length; i++) {
			var element = arguments[i];
			$mc.log("Adding " + element.__description()  + " to " + this.__description());
			this.___array.push(element);
			try { element.retain(); } catch(e) {}
		}
		this.length = this.___array.length;
	},
	
	pop: function() {
		var element = this.___array.pop();
		try { element.release(); } catch(e) { }
		this.length = this.___array.length;
		return element;
	},
	
	valueOf: function() {
		return this.___array.valueOf();
	},
	
	toString: function() {
		return this.___array.toString();
	},
	
	reverse: function() {
		this.___array.reverse();
	},
	
	indexOf: function(element) {
		for(var i = 0; i < this.___array.length; i++) {
			if(element == this.___array[i]) {
				return i;
			}
		}
		
		return -1;
	},
	
	each: function(callback) {
		for(var i = 0; i < this.___array.length; i++) {
			if(callback(this.___array[i], i) === false) break;
		}
	},
	
	destroy: function($super) {
		var self = this;
		this.each(function(element) {
			$mc.log("Removing " + element.__description()  + " from " + self.__description());
			try { element.release(); } catch(e) { }
		});
		
		this.length = this.___array.length;
		this.___array = null;

		$super();
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Browser'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Browser'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Browser'] = exports; //
//  Mobclix.Browser.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var Device = require('NGCore/Client/Device').Device;
var UI = require('NGCore/Client/UI').UI;
var ViewController = require('NGCore/Client/Mobclix/ViewController').ViewController;
var Controller = require('NGCore/Client/Mobclix/Core/Controller').Controller;
var MMView = require('NGCore/Client/Mobclix/Core/MMView').MMView;
var MMWebView = require('NGCore/Client/Mobclix/Core/MMWebView').MMWebView;
var Config = require('NGCore/Client/Mobclix/Core/Config').Config;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var ProxyListener = Core.MessageListener.subclass({
	onUpdate: function() {}
});

var Browser = exports.Browser = ViewController.subclass(
/** @lends Mobclix.Browser.prototype */
{
	__className: "Mobclix.Browser",
	webView: null,
	onDidFinish: null,
    browserType: null,
	topBar: null,
	bottomBar: null,
	bottomBorders: [null, null],
	prevArrow: null,
	nextArrow: null,
	doneButton: null,
	proxyListener: null,
    keyListener: null,
	
    // Null unless this is a fullscreen ad
    creativeView: null,
    
	Type: {
		Toolbar: 1,
		Navigation: 2,
		Full: 3,
		Minimal: 4
	},
	
	initialize: function($super, browserType, creativeView) {
		$super();
		
		var self = this;
		var types = this.Type;
        this.creativeView = creativeView;

        // Register register to close browser when app loses focus if not a fullscreen ad.
        if (creativeView == null) {
            this.proxyListener = new ProxyListener();
            Device.LifecycleEmitter.addListener(this.proxyListener, function(event) {
                if(event == Device.LifecycleEmitter.Event.Suspend) {
                    if(self.isPresented()) {
                        self.dismissViewController();
                    }
                }
            });
        }
        
        this.keyListener = new ProxyListener();
        Device.KeyEmitter.addListener(this.keyListener, function(event) {
            if(event.code === Device.KeyEmitter.Keycode.back) {
                if(self.isPresented()) {
                    self.dismissViewController();
                    return true;
                }
            }
        }, 0xffffffff);

		var browserType = browserType || this.Type.Toolbar;
		this.browserType = browserType;
        
		// Web View
		this.webView = new MMWebView();
		this.addChild(this.webView);
		
		// Bottom Bar
		(function() {
			if(browserType != types.Toolbar && browserType != types.Navigation && browserType != types.Full) return;
			
			self.bottomBar = new MMView();
			self.bottomBar.setGradient({
				gradient: [ "ffb0bccd 0.0", "ff879ab3 0.5", "ff8094ae 0.5", "ff6d83a1 1.0" ]
			});
			self.addChild(self.bottomBar);
			
			self.doneButton = new UI.Button({
				'text': 'Close',
				'textColor': 'ff',
				'textShadow': "8000 1.0 {0,1}",
				'textSize': 13,
				'textFont': UI.FontStyle.Bold,
				'textGravity': UI.ViewGeometry.Gravity.Center,
				'frame': [0, 0, 60, 30]
			});
			
			var corners = $mc.dip(4);
			corners = [corners, corners, corners, corners].join(' ');
			
			self.doneButton.setNormalGradient({
				corners: corners,
				outerLine: "ff2952b8 1",
				gradient: [ "ff7b9eea 0.0", "ff376fe0 0.5", "ff2260dd 0.5", "ff2463de 1.0" ]
			});
			self.doneButton.setHighlightedGradient({
				corners: corners,
				outerLine: "ff1b2c4e 1",
				gradient: [ "ff7d88a5 0.0", "ff3a4e77 0.5", "ff253c6a 0.5", "ff273e6d 1.0" ]
			});
			
			self.doneButton.setOnClick(function() {
				self.dismissViewController(true);
			});

			self.bottomBar.addChild(self.doneButton);

			var arrowProps = {
				'text': '◀',
				'textColor': 'ff',
				'textShadow': "8000 1.0 {0,1}",
				'textSize': 16,
				'textFont': UI.FontStyle.Bold,
				'textGravity': UI.ViewGeometry.Gravity.Center
			};
			
			if(Controller.isAndroid()) {
				arrowProps.textSize = 32;
			}
			
			self.prevArrow = new UI.Button(arrowProps);
			self.prevArrow.setOnClick(function() { self.webView.goBack(); });
			self.prevArrow.setTextColor('ffa8d4ff', UI.State.Pressed);
			self.bottomBar.addChild(self.prevArrow);

			arrowProps.text = '▶';
			self.nextArrow = new UI.Button(arrowProps);
			self.nextArrow.setTextColor('ffa8d4ff', UI.State.Pressed);
			self.nextArrow.setOnClick(function() { self.webView.goForward(); });
			self.bottomBar.addChild(self.nextArrow);
			
			self.bottomBorders[0] = new MMView();
			self.bottomBorders[0].setBackgroundColor('ff2d3034');
			self.bottomBar.addChild(self.bottomBorders[0]);
			
			self.bottomBorders[1] = new MMView();
			self.bottomBorders[1].setBackgroundColor('ffd8dee6');
			self.bottomBar.addChild(self.bottomBorders[1]);
			
			self.loadingIndicator = new UI.Spinner({
				'frame': [0, 0, 30, 30]
			});
			self.bottomBar.addChild(self.loadingIndicator);
			
			// Setup WebView listenres to control the bar items
            // Only for non-fullscreen creatives. Fullscreen listeners are set below.
            if (self.creativeView == null) {
                self.webView.setOnPageevent(function(event) {
                    self.updateArrows();
                });

                self.webView.setOnStartload(function(event) {
                    self.updateArrows();
                    self.loadingIndicator.setVisible(true);
                });

                self.webView.setOnPageload(function(event) {
                    self.updateArrows();
                    self.loadingIndicator.setVisible(false);
                });

                self.webView.setOnError(function(event) {
                    self.updateArrows();
                    self.loadingIndicator.setVisible(false);
                });

                self.webView.setOnLoad(function(event) {
                    self.updateArrows();
                });
            }
		})();

		// Widget close
		(function() {
			if(browserType != types.Minimal) return;

			var cornerSize = $mc.dip(14);
			var backFontSize = 18;
		
			if(Controller.isAndroid()) {
				backFontSize = 20;
			}

			var back = new UI.Button({
				'text': '✖',
				'textColor': 'ff',
				'textSize': backFontSize,
				'textFont': UI.FontStyle.Bold,
				'textGravity': UI.ViewGeometry.Gravity.Center,
				'textInsets': [1, 0, 0, 1],
				'frame': [$mc.dip(10), $mc.dip(10), $mc.dip(32), $mc.dip(32)]
			});

			back.setGradient({
				corners: [cornerSize, cornerSize, cornerSize, cornerSize].join(' '),
				outerLine: "ff 2",
				gradient: [ "00 0.0", "00 1.0" ]
			}, UI.State.Normal);
		
			back.setGradient({
				corners: [cornerSize, cornerSize, cornerSize, cornerSize].join(' '),
				outerLine: "ff 2",
				gradient: [ "00 0.0", "00 1.0" ]
			}, UI.State.Pressed);
		
			back.onclick = function() {
				self.dismissViewController(true);
			};
		
			self.addChild(back);
		})();
        
        if (creativeView != null) {
            this.webView.setOnPageevent(function(event) {
                self.onPageEvent(event);
            });
            
            this.webView.setOnStartload(function(event) {
                self.onStartLoad(event);
            });

            this.webView.setOnShouldload(function(event) {
                return self.onShouldLoad(event);
            });

            this.webView.setOnPageload(function(event) {
                self.onPageLoad(event);
            });
            
            this.webView.setOnError(function(event) {
                self.onError(event);
            });
        }
	},
	
    updateArrows: function() {
        var canGoForward = this.webView.canGoForward();
        this.nextArrow.setAlpha(canGoForward ? 1.0 : 0.6);
        this.nextArrow.setState(canGoForward ? UI.State.Normal : UI.State.Disabled);

        var canGoBack = this.webView.canGoBack();
        this.prevArrow.setAlpha(canGoBack ? 1.0 : 0.6);
        this.prevArrow.setState(canGoBack ? UI.State.Normal : UI.State.Disabled);
    },
    
	viewWillAppear: function($super, animated) {
		$super(animated);
		this.layoutSubviews();
	},
	
	setFrame: function() {
		UI.View.prototype.setFrame.apply(this, arguments);
		this.layoutSubviews();
	},
	
	layoutSubviews: function() {
		var bounds = this.getBounds();
		var webViewFrame = this.getBounds();
		
		if(this.bottomBar) {
			var barHeight = $mc.dip(44);
			this.bottomBar.setFrame(0, bounds[3] - barHeight, bounds[2], barHeight);
			webViewFrame[3] -= barHeight;

			var loadingFrame = [0,0,25,25];
			loadingFrame[0] = Math.floor((bounds[2] - loadingFrame[2]) / 2);
			loadingFrame[1] = Math.floor((barHeight - loadingFrame[3]) / 2);
			this.loadingIndicator.setFrame(loadingFrame);
		
			var donePadding = $mc.dip(6);
			
			var doneFrame = this.doneButton.getFrame();
			doneFrame[2] = $mc.dip(54);
			doneFrame[3] = $mc.dip(29);
			doneFrame[0] = bounds[2] - doneFrame[2] - donePadding;
			doneFrame[1] = Math.floor((barHeight - doneFrame[3]) / 2);
			this.doneButton.setFrame(doneFrame);
			
			var doneOuterWidth = doneFrame[2] + $mc.dip(6);
			
			var arrowFrame = [0,0,0,0];
			arrowFrame[0] = doneOuterWidth;
			arrowFrame[1] = 0;
			arrowFrame[2] = Math.floor((bounds[2] - (doneOuterWidth * 2)) / 3);
			arrowFrame[3] = barHeight;
			this.prevArrow.setFrame(arrowFrame);

			arrowFrame[0] = bounds[2] - arrowFrame[2] - doneOuterWidth;
			this.nextArrow.setFrame(arrowFrame);
			
			var borderFrame = [0, 0, bounds[2], $mc.dip(1)];
			this.bottomBorders[0].setFrame(borderFrame);
			
			borderFrame[1] = $mc.dip(1);
			this.bottomBorders[1].setFrame(borderFrame);
		}
		
		this.webView.setFrame(webViewFrame);
	},
	
	dismissViewController: function($super, animated) {
		if(typeof this.onDidFinish == 'function') {
			this.onDidFinish();
		}
		$super(animated);
	},
	
	loadUrl: function(url) {
		this.webView.loadUrl(url);
	},
    
    loadWithCreative: function(cacheLocation) {
		this.webView.loadDocument(cacheLocation);
	},
	
    getParameterByName: function(url, name, d) {
		name = name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
		var regexS = "[\\?&]"+name+"=([^&#]*)";
		var regex = new RegExp( regexS );
		var results = regex.exec( url );
		if( results == null )
			return d;
		else
			return decodeURIComponent(results[1].replace(/\+/g, " "));
	},
    
    onShouldLoad: function(event) {
        if (this.creativeView.loaded && !this.creativeView.touched) {
            try {
                this.creativeView.adView.currentCreative.getEvents().triggerEvent("touch");
            } catch(e) { }
        }
        this.creativeView.touched = true;
		return true;
	},
	
	onPageEvent: function(event) {
		$mc.log("WebView webgame Page Event: ", JSON.stringify(event));
        var method = event.eventStream.split("?")[0];
        if (method == "setUserAgent") {
            var userAgent = this.getParameterByName(event.eventStream, "ua") || null;
            Controller.setUserAgent(userAgent);
        }
        if(this.browserType == this.Type.Toolbar || this.browserType == this.Type.Navigation || this.browserType == this.Type.Full)
            this.updateArrows();
	},

	onStartLoad: function(event) {
		$mc.log("WebView webgame Page Start Load: ", JSON.stringify(event));
        if(this.browserType == this.Type.Toolbar || this.browserType == this.Type.Navigation || this.browserType == this.Type.Full) {
            this.updateArrows();
            this.loadingIndicator.setVisible(true);
        }
	},

	onPageLoad: function(event) {
		$mc.log("WebView webgame Page Load: ", JSON.stringify(event));
		if (!this.creativeView.loaded) {
			this.creativeView.loaded = true;
			this.creativeView.adView.creativeViewFinishedLoading(this.creativeView, this.creativeView.currentCreative);
            try {
                this.webView.invoke("var uaUrl = \"ngcore://setUserAgent?ua=\" + escape(navigator.userAgent); window.location=uaUrl;");
            } catch (err) {}
		}
        if(this.browserType == this.Type.Toolbar || this.browserType == this.Type.Navigation || this.browserType == this.Type.Full) {
            this.updateArrows();
            this.loadingIndicator.setVisible(false);
        }
	},

	onError: function(event) {
		$mc.log("WebView webgame Error: ", JSON.stringify(event));
        if(this.browserType == this.Type.Toolbar || this.browserType == this.Type.Navigation || this.browserType == this.Type.Full) {
            this.updateArrows();
            this.loadingIndicator.setVisible(false);
        }
	},
    
	destroy: function($super) {
		if(this.bottomBar) {
			this.prevArrow.removeFromParent();
			this.nextArrow.removeFromParent();
			this.doneButton.removeFromParent();
			this.loadingIndicator.removeFromParent();
			this.bottomBorders[0].removeFromParent();
			this.bottomBorders[1].removeFromParent();
			
			try { this.prevArrow.destroy(); } catch (e) { }
			try { this.nextArrow.destroy(); } catch (e) { }
			try { this.doneButton.destroy(); } catch (e) { }
			try { this.loadingIndicator.destroy(); } catch (e) { }
			try { this.bottomBorders[0].destroy(); } catch (e) { }
			try { this.bottomBorders[1].destroy(); } catch (e) { }

			this.removeChild(this.bottomBar);
			this.bottomBar.release();
			this.bottomBar = null;
		}
		
		this.removeChild(this.webView);
		this.webView.release();
        try {
            Device.NetworkEmitter.removeListener(this.proxyListener);
        } catch (e) {}
        try {
            Device.KeyEmitter.removeListener(this.keyListener);
        } catch (e) {}

		$super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Creative'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative'] = exports; //
//  Mobclix.Creative.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

exports.Creative =
/** @lends Mobclix.Creative.prototype */
{
	Types: require('NGCore/Client/Mobclix/Creative/Base').Types,
	Web: require('NGCore/Client/Mobclix/Creative/Web').Web,

	/**
	 * Create an Creative model from a JSON objects
	 * @param {object}	JSON creative object
	 * @private
	 */
	Create: function(obj) {
		var creativeType = null;
		try {
			creativeType = obj.creative.type || "web";
		} catch(e) {
			creativeType = "web";
		}

		switch(creativeType) {
			case 'html':
			case 'web':
			default:
				$mc.log("HTML or Unknown ad type detected: ", creativeType);
				return new this.Web(obj);
		}
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/CreativeView/Web'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/Web'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/Web'] = exports; //
//  Mobclix.CreativeView.Web.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var Controller = require('NGCore/Client/Mobclix/Core/Controller').Controller;
var UI = require('NGCore/Client/UI').UI;
var Device = require('NGCore/Client/Device').Device;
var Storage = require('NGCore/Client/Storage').Storage;
var Base = require('NGCore/Client/Mobclix/CreativeView/Base').Base;
var MMWebView = require('NGCore/Client/Mobclix/Core/MMWebView').MMWebView;
var RMWebView = require('NGCore/Client/Mobclix/CreativeView/WebView').WebView;
var Browser = require('NGCore/Client/Mobclix/Browser').Browser;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var ProxyListener = Core.MessageListener.subclass({
	onUpdate: function() {}
});

exports.Web = Base.subclass(
/** @lends Mobclix.CreativeView.Web.prototype */
{
	__className: "Mobclix.CreativeView.Web",
	webView: null,
	cacheLocation: null,
	loaded: false,
    touched: false,
	fs: null,
	useRichMedia: false,
	
	/**
	 * @class Web CreativeView class for display {@link Mobclix.Creative.Web} creatives
	 * @constructs The default constructor. 
	 * @param $super This parameter is stripped out during execution. Do not supply it.
	 * @extends Mobclix.Creative.Base
	 * @private
	 */
	initialize: function($super) {
		$super();

		if(this.useRichMedia) {
			this.webView = new RMWebView();
			this.webView.parentCreative = this;
		} else {
			this.webView = new MMWebView();
		}
		
		this.addChild(this.webView);
		this.fs = Storage.FileSystem;
		
		var self = this;
		
        this.webView.setScrollable(false);
        
		if(this.useRichMedia) {
			this.webView.setOnPageevent(this.webView.onPageEvent);
		} else {
            this.webView.setOnPageevent(function(event) {
                self.onPageEvent(event);
            });
        }
		
		this.webView.setOnStartload(function(event) {
			self.onStartLoad(event);
		});

		this.webView.setOnShouldload(function(event) {
			return self.onShouldLoad(event);
		});

		this.webView.setOnPageload(function(event) {
			self.onPageLoad(event);
		});
		
		this.webView.setOnError(function(event) {
			self.onError(event);
		});
		
		this.proxyListener = new ProxyListener();
		$mc.log("Adding life cycle listener");
		Device.LifecycleEmitter.addListener(this.proxyListener, function(event) {
			$mc.log("life cycle changed!");
			if(event == Device.LifecycleEmitter.Event.Terminate) {
				self.fs.deleteFile(this.cacheLocation);
				self.fs = null;
				self.cacheLocation = null;
			}
		});
		$mc.log("Added life cycle listener");
	},
	
	getParameterByName: function(url, name, d) {
		name = name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
		var regexS = "[\\?&]"+name+"=([^&#]*)";
		var regex = new RegExp( regexS );
		var results = regex.exec( url );
		if( results == null )
			return d;
		else
			return decodeURIComponent(results[1].replace(/\+/g, " "));
	},
	
	/**
	 * Resize the internal webview if our bounds change
	 * 
	 * NOTE: Couldn't find any "autoresizing" options like iOS
	 * has, this should be replaced with that if found.
	 */
	setFrame: function() {
		UI.View.prototype.setFrame.apply(this, arguments);
		var frame = this.getFrame();
		this.webView.setFrame(0, 0, frame[2], frame[3]);
	},

	/**
	 * Tells AdView what kind of view this is
	 * and when to reuse it
	 */
	reuseIdentifier: function() {
		return "web";
	},
	
	/**
	 * Should prepare the current creative view to be reused
	 * Only called if canBeReused returns true
	 */
	prepareForReuse: function() {
		this.webView.loadUrl("about:blank");
		this.fs.deleteFile(this.cacheLocation);
		this.cacheLocation = null;
        this.loaded = false;
        this.touched = false;
	},
	
	/**
	 * Whether or not the current creative view can be reused
	 * Reuseable creative views are encouraged to lower memory and cpu usage
	 */
	canBeReused: function() {
		return true;
	},
	
	/**
	 * Load the current creative
	 */
	loadWithCreative: function($super, creative) {
		$super(creative);
		
		var ts = parseInt((new Date()).getTime(), 10);
		this.cacheLocation = "MobclixTempCreative-"+ts+".html";
		
		$mc.log("Loading HTML: ", this.currentCreative.html);
		
		this.fs.writeFile(this.cacheLocation, this.currentCreative.html);
		this.webView.loadDocument(this.cacheLocation);
	},
	
	onShouldLoad: function(event) {
        if(this.loaded && !this.touched) {
            try {
                this.adView.currentCreative.getEvents().triggerEvent("touch");
            } catch(e) { }
        }
        this.touched = true;
		if(!this.useRichMedia) {
			this.adView.openActionURL(this.currentCreative, event.url);
			return false;
		}
		
		var shouldOpenInNewWindow = this.getParameterByName(event.url, "shouldOpenInNewWindow", null);
		
		if ((this.webView.expanded || this.webView.fullscreen) &&
				shouldOpenInNewWindow != "yes") {
			return true;
		} else if (shouldOpenInNewWindow == "no") {
			return true;
		}
		
		// If not an expanded or fullscreen ad, check if another modal is open
		if (!this.webView.expanded && !this.webView.fullscreen) {
			if(!this.adView.shouldTouchThrough()) {
				$mc.log("Already in modal, can't open:", url);
				return false;
			}
			this.adView.willTouchThrough();
		}
		
		var browser = new Browser();
		
		var self = this;
		browser.onDidFinish = function() {
			// If not an expanded or fullscreen ad, reset touchThrough status
			if (!self.webView.expanded && !self.webView.fullscreen)
				self.adView.didTouchThrough(self);
			self.webView.adDidReturnFromHidden();
			self.webView.resumeListeners();
		};
		this.webView.adWillBecomeHidden();
		this.webView.pauseListeners();
	
		browser.loadUrl(event.url);
		browser.presentViewController(true);
		browser.release();
		browser = null;

		return false;
	},
	
	onPageEvent: function(event) {
		$mc.log("WebView webgame Page Event: ", JSON.stringify(event));
        var method = event.eventStream.split("?")[0];
        if (method == "setUserAgent") {
            var userAgent = this.getParameterByName(event.eventStream, "ua") || null;
            Controller.setUserAgent(userAgent);
        }
	},

	onStartLoad: function(event) {
		$mc.log("WebView webgame Page Start Load: ", JSON.stringify(event));
	},

	onPageLoad: function(event) {
		$mc.log("WebView webgame Page Load: ", JSON.stringify(event));
		if (!this.loaded) {
			this.adView.creativeViewFinishedLoading(this, this.currentCreative);
			this.loaded = true;
            try {
                this.webView.invoke("var uaUrl = \"ngcore://setUserAgent?ua=\" + escape(navigator.userAgent); window.location=uaUrl;");
            } catch (err) {}
		}
	},

	onError: function(event) {
		$mc.log("WebView webgame Error: ", JSON.stringify(event));
	},
	
	/**
	 * Stop all loading of the creative
	 */
	stopLoading: function() {
		this.webView.stopLoading();
	},
	
	/**
	 * Called after a creative has been displayed, any post-display 
	 * events or actions that need to be triggered, should be triggered here
	 */
	creativeHasBeenDisplayed: function() {
		
	},
	
	/**
	 * Clean up
	 */
	destroy: function($super) {
		$mc.log('Web - destroy - adView_frame: ');
		this.webView.removeFromParent();
		
		try {
			this.webView.release();
			this.webView = null;
		} catch (e) {
			$mc.log("Exception while destroying WebView: ", e);
		}
			
		try {
			this.fs.deleteFile(this.cacheLocation);
			this.fs = null;
			this.cacheLocation = null;
		} catch (e) {
			$mc.log("Exception while destroying CreativeView.Web: ", e);
		}
		
		this.proxyListener = null;
		
		$super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/CreativeView/FullScreen'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/FullScreen'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/FullScreen'] = exports; //
//  Mobclix.CreativeView.FullScreen.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var Controller = require('NGCore/Client/Mobclix/Core/Controller').Controller;
var UI = require('NGCore/Client/UI').UI;
var Device = require('NGCore/Client/Device').Device;
var Storage = require('NGCore/Client/Storage').Storage;
var Base = require('NGCore/Client/Mobclix/CreativeView/Base').Base;
var MMWebView = require('NGCore/Client/Mobclix/Core/MMWebView').MMWebView;
var RMWebView = require('NGCore/Client/Mobclix/CreativeView/WebView').WebView;
var Browser = require('NGCore/Client/Mobclix/Browser').Browser;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var ProxyListener = Core.MessageListener.subclass({
	onUpdate: function() {}
});

exports.FullScreen = Base.subclass(
/** @lends Mobclix.CreativeView.FullScreen.prototype */
{
	__className: "Mobclix.CreativeView.FullScreen",
	browser: null,
	cacheLocation: null,
	fs: null,
	useRichMedia: false,
	loaded: false,
    touched: false,
    
	/**
	 * @class Web CreativeView class for display {@link Mobclix.Creative.Web} creatives
	 * @constructs The default constructor. 
	 * @param $super This parameter is stripped out during execution. Do not supply it.
	 * @extends Mobclix.Creative.Base
	 * @private
	 */
	initialize: function($super) {
		$super();

        $mc.log("Initializing the FullScreen CreativeView");
        
		var self = this;
        
        
		
        
        $mc.log("Initializing the FileSystem");
		this.fs = Storage.FileSystem;
		
        $mc.log("Setting up poxylistener");
		this.proxyListener = new ProxyListener();
		$mc.log("Adding life cycle listener");
		Device.LifecycleEmitter.addListener(this.proxyListener, function(event) {
			$mc.log("life cycle changed!");
			if(event == Device.LifecycleEmitter.Event.Terminate) {
				self.fs.deleteFile(this.cacheLocation);
				self.fs = null;
				self.cacheLocation = null;
			}
		});
		$mc.log("Added life cycle listener");
	},
	
	/**
	 * Resize the internal webview if our bounds change
	 * 
	 * NOTE: Couldn't find any "autoresizing" options like iOS
	 * has, this should be replaced with that if found.
	 *
	setFrame: function() {
		UI.View.prototype.setFrame.apply(this, arguments);
		var frame = this.getFrame();
		this.webView.setFrame(0, 0, frame[2], frame[3]);
	},*/

	/**
	 * Tells AdView what kind of view this is
	 * and when to reuse it
	 */
	reuseIdentifier: function() {
		return "fullscreen";
	},
	
	/**
	 * Should prepare the current creative view to be reused
	 * Only called if canBeReused returns true
	 */
	prepareForReuse: function() {
		//this.webView.loadUrl("about:blank");
		this.fs.deleteFile(this.cacheLocation);
		this.cacheLocation = null;
        this.loaded = false;
        this.touched = false;
	},
	
	/**
	 * Whether or not the current creative view can be reused
	 * Reuseable creative views are encouraged to lower memory and cpu usage
	 */
	canBeReused: function() {
		return true;
	},
	
	/**
	 * Load the current creative
	 */
	loadWithCreative: function($super, creative) {
		$super(creative);
		
		var ts = parseInt((new Date()).getTime(), 10);
		this.cacheLocation = "MobclixTempCreative-"+ts+".html";
		
		$mc.log("Loading HTML: ", this.currentCreative.html);
		
        var browserType = Browser.Type.Toolbar;
        if (this.currentCreative.html.search(/<meta[^>]*MobclixUseWidgetStyle/i) != -1)
            browserType = Browser.Type.Minimal;
        if (this.currentCreative.html.search(/<meta[^>]*MobileAdsUseWidgetStyle/i) != -1)
            browserType = Browser.Type.Minimal;
        
        var self = this;
        
        $mc.log("Creating browser");
		this.browser = new Browser(browserType, this);
        
        // Set the frame here to prevent iOS scaling issues.
        var screenSize = {width: NGWindow.getWidth(), height: NGWindow.getHeight()};
		var startFullScreenFrame = [0, screenSize.height, screenSize.width, screenSize.height];
        this.browser.setFrame(startFullScreenFrame);
        
        this.browser.onDidFinish = function() {
            try {
                if(typeof self.adView.onDismissAd == 'function') {
                    self.adView.onDismissAd(self.adView);
                }
            } catch (err) {}
            try {
                self.adView._canRequestNextAd = true;
            } catch (err) {}
        };
        
		this.fs.writeFile(this.cacheLocation, this.currentCreative.html);
		this.browser.loadWithCreative(this.cacheLocation);
	},
	
	/**
	 * Stop all loading of the creative
	 */
	stopLoading: function() {
		//this.webView.stopLoading();
	},
	
    display: function() {
        this.browser.presentViewController(true);
		this.browser.release();
		this.browser = null;
    },
    
	/**
	 * Called after a creative has been displayed, any post-display 
	 * events or actions that need to be triggered, should be triggered here
	 */
	creativeHasBeenDisplayed: function() {
		
	},
	
	/**
	 * Clean up
	 */
	destroy: function($super) {
		$mc.log('Web - destroy - fullscreen creativeview: ');
		
		try {
			this.browser.release();
            this.browser = null;
		} catch (e) {
			$mc.log("Exception while destroying Browser: ", e);
		}
			
		try {
			this.fs.deleteFile(this.cacheLocation);
			this.fs = null;
			this.cacheLocation = null;
		} catch (e) {
			$mc.log("Exception while destroying CreativeView.Web: ", e);
		}
		
		this.proxyListener = null;
		
		$super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/MMClass'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/MMClass'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/MMClass'] = exports; //
//  Mobclix.Core.MMClass.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;
var __internalMMClassCounter = 0;

exports.Memory =
/** @lends Mobclix.Core.MMClass.prototype */
{
	__className: "MMClass",
	retainCount: 0,
	__instanceId: 0,

	/**
	 * @class MMClass provides a base foundation for memory managed objects
	 * @description Any objects that subclass MMClass will have their memory managed for them
	 * @constructs The default constructor. 
	 * @param $super This parameter is stripped out during execution. Do not supply it.
	 * @private
	 */
	initialize: function($super) {
		if($super) $super();
		this.__instanceId = ++__internalMMClassCounter;
		// $mc.log("--- initialized: "+this.__description()+" ---");
		this.retain();
	},
	
	/**
	 * Redirects all calls to $addProperty
	 * @private
	 * @see Mobclix.Utils#$addProperty
	 * @function
	 * @static
	 */
	$addProperty: function(propName, shouldRetain, defaultValue) {
		$mc.addProperty(this, propName, shouldRetain, defaultValue);
	},
	
	/**
	 * Gets the description of the current object
	 *  @private
	 */
	__description: function() {
		var hash = this.__instanceId.toString();
		while(hash.length < 5) 	hash = "0" + hash;

		return "[" + this.__className + " 0x" + hash + "]";
	},
	
	/**
	 * Increase the instances retain count by one
	 * @return	current instance
	 * @private
	 */
	retain: function() {
		this.retainCount++;
		// $mc.log("--- retained: "+this.__description()+", new count: "  + this.retainCount + " ---");
		return this;
	},
	
	/**
	 * Schedules {@link #release} to be called at the start of the next run loop
	 * @see Mobclix.Core.MMClass.release
	 * @return	current instance
	 * @private
	 */
	autorelease: function() {
		var self = this;
		setTimeout(function() {
			self.release();
		}, 1);
		return this;
	},
	
	/**
	 * Decreases the instances retain count by one
	 * If the retainCount hits 0, the object will call {@link #destroy}.
	 * @see Mobclix.Core.MMClass.destroy
	 * @private
	 */
	release: function() {
		this.retainCount--;

		// $mc.log("--- released: "+this.__description()+", new count: "  + this.retainCount + " ---");
		
		if(this.retainCount <= 0) {
			this.destroy();
		}
	},
	
	/**
	 * Convers the object to a useable string format
	 * @private
	 */
	toString: function() {
		return "[" + this.__className + " object]";
	},
	
	/**
	 * @private
	 */
	destroy: function($super) {
		// $mc.log("--- destroy: "+this.__description()+" ---");
		if($super) $super();
	}
	
};

exports.MMClass = Core.Class.subclass(exports.Memory);
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/Session'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/Session'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/Session'] = exports; //
//  Mobclix.Core.Session.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

exports.Session = Core.Class.singleton({
	identifier: null,
	connectionType: null,

	initialize: function() {

	},
	
	renewIdentifier: function() {
		this.identifier = $mc.sha1(Core.Capabilities.getUniqueId() + Core.Time.getRealTime());
		$mc.log("Generated session identifier: " + this.identifier);
	},
	
	update: function() {
		
	},
	
	destroy: function() {
		this.identifier = null;
		this.connectionType = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/SessionTracking'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/SessionTracking'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/SessionTracking'] = exports; //
//  Mobclix.Core.SessionTracking.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var Storage = require('NGCore/Client/Storage').Storage;
var Config = require('NGCore/Client/Mobclix/Core/Config').Config;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;
var Session = require('NGCore/Client/Mobclix/Core/Session').Session;

exports.SessionTracking = Core.Class.subclass({
	offlineSessionCount: 0,
	sessionStartDate: null,
	sessionWentIdleDate: null,
	sessionEndDate: null,
	idleSessionTime: 0.0,
	lastSessionLength: 0.0,
	dataFile: null,
	firstRun: false,
	
	initialize: function($super, controller) {
		if($super) $super();

		this.dataFile = "MobclixSessionTracking-" + controller.getApplicationId() + ".json";
		
		this.offlineSessionCount = 0;
		this.lastSessionLength = 0.0;
		this.idleSessionTime = 0.0;
		this.firstRun = true;
		
		var self = this;

		this.loadSessionTrackingData(function() {
			if(self.lastSessionLength == 0 && self.sessionWentIdleDate) {
				self.sessionEndDate = self.sessionWentIdleDate;
				self.lastSessionLength = (self.sessionEndDate.getTime() - self.sessionStartDate.getTime()) / 1000;
			}

			self.startNewSession();
		});
	},
	
	startNewSession: function() {
		this.sessionStartDate = new Date();
		this.sessionWentIdleDate = null;
		this.sessionEndDate = null;
	},

	// Application State Tracking

	didBecomeActive: function() {
		if(!this.sessionWentIdleDate) return; // First launch.

		var now = new Date();
		var idleInterval = (now.getTime() - this.sessionWentIdleDate.getTime()) / 1000;
		$mc.log("idleInterval: ", idleInterval);

		if(idleInterval >= Config.getIdleTimeoutInterval()) {
			$mc.log("Starting new session!");
			this.lastSessionLength = (this.sessionWentIdleDate.getTime() - this.sessionStartDate.getTime()) / 1000;
			Session.renewIdentifier();
			Config.updateConfiguration(require('NGCore/Client/Mobclix/Core/Controller').Controller);
			this.startNewSession();
		} else if(Config.hasConfigFailed()) {
			this.offlineSessionCount--; // Config will auto-increase this if it fails again.
			Config.updateConfiguration(require('NGCore/Client/Mobclix/Core/Controller').Controller);
		} else {
			this.idleSessionTime += idleInterval;
			$mc.log("Within idle timeout range: ", Config.getIdleTimeoutInterval());
		}

		this.saveSessionTrackingData();
	},
	
	willGoInactive: function() {
		this.sessionWentIdleDate = new Date();
		this.saveSessionTrackingData();
	},

	willTerminate: function() {
		this.sessionEndDate = new Date();
		this.lastSessionLength = (this.sessionEndDate.getTime() - this.sessionStartDate.getTime()) / 1000;
		this.saveSessionTrackingData();
	},
	
	// Session Tracking Data Management
	
	loadSessionTrackingData: function(callback) {
		Storage.FileSystem.readFile(this.dataFile, false, function(error, value) {
			try {
				value = eval("("+value+")");
			} catch(e) { }
			
			if(value && typeof value == 'object' && value.length > 0) {
				this.offlineSessionCount = $mc.parseDouble(value.offlineSessionCount) || 0.0;
				
				this.idleSessionTime = $mc.parseDouble(value.idleSessionTime) || 0.0;
				
				if(value.sessionStartDate) {
					try { this.sessionStartDate = new Date(value.sessionStartDate); } catch (e) { }
				}
				
				if(value.sessionWentIdleDate) {
					try { this.sessionWentIdleDate = new Date(value.sessionWentIdleDate); } catch (e) { }
				}
				
				if(value.sessionEndDate) {
					try { this.sessionEndDate = new Date(value.sessionEndDate); } catch (e) { }
				}
				
				this.lastSessionLength = $mc.parseDouble(value.lastSessionLength) || 0.0;

				if(value.firstRun) {
					this.firstRun = $mc.parseBool(value.firstRun);
				}
			}
			
			callback();
		});
	},
	
	saveSessionTrackingData: function() {
		var data = {};
		data.offlineSessionCount = this.offlineSessionCount;
		data.idleSessionTime = this.idleSessionTime;
		data.lastSessionLength = this.lastSessionLength;
		data.firstRun = this.firstRun ? "true" : "false";

		if(this.sessionStartDate) {
			data.sessionStartDate = this.sessionStartDate.toString();
		}

		if(this.sessionWentIdleDate) {
			data.sessionWentIdleDate = this.sessionWentIdleDate.toString();
		}

		if(this.sessionEndDate) {
			data.sessionEndDate = this.sessionEndDate.toString();
		}

		try {
			Storage.FileSystem.writeFile(this.dataFile, JSON.stringify(data));
		} catch(e) { }
	},
	
	
	// Clean up
	
	destroy: function($super) {
		this.sessionEndDate = null;
		this.sessionStartDate = null;
		this.sessionWentIdleDate = null;
		this.originalUDID = null;

		dataFile.release();
		_environment.release();
		
		if($super) $super();
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/ViewController'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/ViewController'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/ViewController'] = exports; //
//  Mobclix.ViewController.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var UI = require('NGCore/Client/UI').UI;
var MMView = require('NGCore/Client/Mobclix/Core/MMView').MMView;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var ViewController = exports.ViewController = MMView.subclass(
/** @lends Mobclix.ViewController.prototype */
{
	__className: "Mobclix.ViewController",
	_isPresented: false,
	initialize: function($super) {
		$super();
		
		this.setBackgroundColor("00");
	},
	
	presentViewController: function(animated) {
		animated = animated || false;

		var screenSize = {width: NGWindow.getWidth(), height: NGWindow.getHeight()};
		
		var startFullScreenFrame = [0, screenSize.height, screenSize.width, screenSize.height];
		var finalFullScreenFrame = [0, 0, screenSize.width, screenSize.height];
		this.setFrame(startFullScreenFrame);
		
		this.viewWillAppear(animated);
		NGWindow.document.addChild(this);
		var self = this;
		
		if(animated) {
			UI.animate(function() {
				self.setFrame(finalFullScreenFrame);
			}, 300, function() {
				self.viewDidAppear(true);
			});
		} else {
			this.setFrame(finalFullScreenFrame);
			this.viewDidAppear(false);
		}
	},
	
	dismissViewController: function(animated) {
		$mc.log("animated: ", animated);
		animated = animated || false;
		this.viewWillDisappear(animated);
		var self = this;
		
		if(animated) {
			UI.animate(function() {
				self.setFrame([0, NGWindow.getHeight(), NGWindow.getWidth(), NGWindow.getHeight()]);
			}, 300, function() {
				self.removeFromParent();
				self.viewDidDisappear(true);
			});
		} else {
			this.removeFromParent();
			this.viewDidDisappear(false);
		}
	},
	
	isPresented: function() {
		return this._isPresented;
	},

	viewWillAppear: function(animated) {
		this.retain();
		this._isPresented = true;
	},
	
	viewDidAppear: function(animated) {
	},
	
	viewWillDisappear: function(animated) {
		this._isPresented = false;
	},
	
	viewDidDisappear: function(animated) {
		this.release();
	},
	
	destroy: function($super) {
		$super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/MMWebView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/MMWebView'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/MMWebView'] = exports; //
//  Mobclix.Core.MMWebView.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var UI = require('NGCore/Client/UI').UI;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var MMWebView = exports.MMWebView = UI.WebView.subclass($mc.extend(require('NGCore/Client/Mobclix/Core/MMView').MMViewMethods, {
	__className: "MMWebView"
}));; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Creative/Base'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative/Base'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative/Base'] = exports; //
//  Mobclix.Creative.Base.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var MMClass = require('NGCore/Client/Mobclix/Core/MMClass').MMClass;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var Action = require('NGCore/Client/Mobclix/Creative/Action').Action;
var Events = require('NGCore/Client/Mobclix/Creative/Events').Events;

// Creative Types
exports.Types = {
	Web: 1,
	Text: 2,
	Banner: 3
};

exports.Base = MMClass.subclass(
/** @lends Mobclix.Creative.Base.prototype */
{
	__className: "Mobclix.Creative.Base",

	// @public properties
	identifier: "",
	type: null,
	events: null,
	properties: {},
	action: null,
	requestParameters: {},

	/**
	 * @class Base class for different creative types.
	 * @constructs The default constructor. 
	 * @param	$super This parameter is stripped out during execution. Do not supply it.
	 * @param	{object} obj	JSON creative used to create this model
	 * @private
	 */
	initialize: function($super, obj) {
		$super();
		var x = 0;

		try {
			this.identifier = obj.creative.id || "";
		} catch(e) {
			this.identifier = "";
		}

		var creativeType = null;
		try {
			creativeType = obj.creative.type || "web";
		} catch(e) {
			creativeType = "web";
		}

		switch(creativeType) {
			case 'html':
			case 'web':
			default:
				this.type = exports.Types.Web;
		}
		
		try {
			this.properties = obj.creative.props || {};
		} catch(e) {
			this.properties = {};
		}

		try {
			if(obj.creative.action) {
				this.action = new Action(obj.creative.action);
			}
		} catch (e) { }

		try {
			var eventUrls = null;
			try {
				eventUrls = obj.creative.eventUrls || {};
			} catch(e) {
				eventUrls = null;
			}

			this.events = new Events(eventUrls);
		} catch(e) {
			$mc.log("Exception creating events.. ", e);
		}
		
		try {
			this.requestParameters = this.properties.params || {};
		} catch(e) {
			this.requestParameters = {};
		}
	},
	
	getAction: function() {
		return this.action;
	},
	
	getEvents: function() {
		return this.events;
	},
	
	// Destructor
	destroy: function($super) {
		$mc.log("Destroying creative");
		this.identifier = null;
		this.type = null;
		this.events = null;
		this.properties = null;
		if(this.action) this.action.release();
		this.requestParameters = null;
		$super();
	}
	
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Creative/Web'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative/Web'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative/Web'] = exports; //
//  Mobclix.Creative.Web.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var Base = require('NGCore/Client/Mobclix/Creative/Base').Base;

exports.Web = Base.subclass(
/** @lends Mobclix.Creative.Web.prototype */
{
	__className: "Mobclix.Creative.Web",

	html: "",
	
	/**
	 * @class Web class for the web creative.
	 * @constructs The default constructor. 
	 * @param $super This parameter is stripped out during execution. Do not supply it.
	 * @param	{object} obj	JSON creative used to create this model
	 * @augments Mobclix.Creative.Base
	 * @private
	 */
	initialize: function($super, obj) {
		$super(obj);
		
		try {
			this.html = this.properties.html || "";
		} catch(e) {
			this.html = "";
		}
	},
	
	/**
	 * Destroys the current object
	 * @private
	 */
	destroy: function($super) {
		this.html = "";
		$super();
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Creative/Action'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative/Action'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative/Action'] = exports; //
//  Mobclix.Creative.Action.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var MMClass = require('NGCore/Client/Mobclix/Core/MMClass').MMClass;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;
var Browser = require('NGCore/Client/Mobclix/Browser').Browser;

exports.Action = MMClass.subclass({
	
	__className: "Mobclix.Creative.Action",
	action: null,
	events: null,
	
	initialize: function($super, obj) {
		$super();
		
		this.action = obj;
		
		var eventUrls = null;
		try {
			eventUrls = obj.creative.eventUrls || {};
		} catch(e) {
			eventUrls = null;
		}
		
		this.events = new Events(eventUrls);
	},
	
	shouldAutoplay: function() {
		return $mc.parseBool(this.action.autoplay) || false;
	},
	
	getEvents: function() {
		return this.events;
	},
	
	getUrl: function() {
		return this.action.url || null;
	},
	
	getBrowserType: function() {
		try {
			var browserType = this.action.browserType.toLowerCase();
			
			if(browserType == "minimal") {
				return Browser.Type.Minimal;
			} else if(browserType == "full") {
				return Browser.Type.Full;
			} else if(browserType == "navigation") {
				return Browser.Type.Navigation;
			} else {
				return Browser.Type.Toolbar;
			}
		} catch(e) {
			$mc.log("Exception getting browser type: ", e);
			return Browser.Type.Toolbar;
		}
	},
	
	destroy: function($super) {
		this.events.release();
		$super();
	}
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Creative/Events'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative/Events'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative/Events'] = exports; //
//  Mobclix.Creative.Events.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var MMClass = require('NGCore/Client/Mobclix/Core/MMClass').MMClass;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;
var HTTPRequest = require('NGCore/Client/Mobclix/Core/HTTPRequest').HTTPRequest;
var Controller = require('NGCore/Client/Mobclix/Core/Controller').Controller;

exports.Events = MMClass.subclass({
	__className: "Mobclix.Creative.Events",
	events: null,
	
	initialize: function($super, obj) {
		$super();
		
		var self = this;
		this.events = {};
		$mc.each(obj, function(urls, key) {
			var normalizedUrls = [];
			$mc.each(urls, function(url) {
				if(url.toString().indexOf("://") != -1) {
					normalizedUrls.push(url);
				}
				
				if(normalizedUrls.length > 0) {
					key = self._normalizeKey(key);
					self.events[key] = normalizedUrls;
				}
			});
		});
	},
	
	triggerEvent: function(name) {
		name = this._normalizeKey(name);
		if(!this.events[name] || this.events[name].length == 0) return;
		
		$mc.each(this.events[name], function(url) {
			var request = new HTTPRequest;
			request.start({
				url: url,
				type: "get",
                userAgent: Controller.getUserAgent()
			});
			request.release();
		});
	},
	
	_normalizeKey: function(key) {
		return key.toString().replace(/^on/i, "").toLowerCase();
	},

	destroy: function($super) {
		this.events.release();
		$super();
	}
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/CreativeView/Base'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/Base'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/Base'] = exports; //
//  Mobclix.CreativeView.Base.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var MMView = require('NGCore/Client/Mobclix/Core/MMView').MMView;

var Base = exports.Base = MMView.subclass(
/** @lends Mobclix.CreativeView.Base.prototype */
{
	__className: "Mobclix.CreativeView.Base",
	adView: null,
	
	/**
	 * @class Base CreativeView class.
	 * @constructs The default constructor. 
	 * @param $super This parameter is stripped out during execution. Do not supply it.
	 * @private
	 */
	initialize: function($super) { $super(); },
	
	/**
	 * Tells AdView what kind of view this is
	 * and when to reuse it
	 */
	reuseIdentifier: function() {
		return null;
	},
	
	/**
	 * Should prepare the current creative view to be reused
	 * Only called if canBeReused returns true
	 */
	prepareForReuse: function() {
		
	},
	
	/**
	 * Whether or not the current creative view can be reused
	 * Reuseable creative views are encouraged to lower memory and cpu usage
	 */
	canBeReused: function() {
		return false;
	},
	
	/**
	 * Load the current creative
	 */
	loadWithCreative: function(creative) {
		this.currentCreative = creative;
	},
	
	/**
	 * Stop all loading of the creative
	 */
	stopLoading: function() {
		
	},
	
	/**
	 * Called after a creative has been displayed, any post-display 
	 * events or actions that need to be triggered, should be triggered here
	 */
	creativeHasBeenDisplayed: function() {
		
	},
	
	/**
	 * Clean up!
	 */
	destroy: function($super) {
		this.currentCreative = null;
		$super();
	}
});

(function() {
	Base.addProperty('currentCreative', true);
})();

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/CreativeView/WebView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/WebView'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/WebView'] = exports; //
//  Mobclix.CreativeView.WebView.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var UI = require('NGCore/Client/UI').UI;
var Core = require('NGCore/Client/Core').Core;
var Device = require('NGCore/Client/Device').Device;
var Controller = require('NGCore/Client/Mobclix/Core/Controller').Controller;
var WebViewMessageListener = require('NGCore/Client/Mobclix/CreativeView/WebViewMessageListener').WebViewMessageListener;
var MMWebView = require('NGCore/Client/Mobclix/Core/MMWebView').MMWebView;
var Browser = require('NGCore/Client/Mobclix/Browser').Browser;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var WebView = exports.WebView = MMWebView.subclass({
	__className: "Mobclix.CreativeView.WebView",

    parentCreative: null,
    
    // Permissions
    uniqueKey: "",
    autoplay: true,
    requireUserInteraction: false,
    hasUserInteracted: false,
    
    // State tracking
    screenCover: null,
    backButton: null,
    adView_frame: [0,0,0,0],
    expanded: false,
    fullscreen: false,
    detaching: false,
    dont_destroy_me: false,
    
    // GPS
    gpsDistanceFilter: 0.0,
    gpsDataCallbackFunctionName: null,
    gpsListenerAdded: false,
    gpsEnabled: false,
    networkEnabled: false,
    
    messageListener: null,
    
    // Display Callbacks
    adDidDisplayCallbackFunctionName: null,
    adFinishedResizingCallbackFunctionName: null,
    adWillContractCallbackFunctionName: null,
    adWillTerminateCallbackFunctionName: null,
    adWillBecomeHiddenCallbackFunctionName: null,
    adDidReturnFromHiddenCallbackFunctionName: null,
    
    initialize: function($super, obj) {
		$super(obj);
		
        this.createBackButton();
        
        this.messageListener = new WebViewMessageListener(this);
        
        Device.KeyEmitter.addListener(this.messageListener, this.messageListener.onKeyEvent, 10000);
        Device.LifecycleEmitter.addListener(this.messageListener, this.messageListener.onLifecycleEvent, 10000);
	},
    
    createBackButton: function()
    {
    	// Add a back button.
        this.backButton = new UI.Button();
        this.backButton.setNormalText('x');
        this.backButton.setTextSize(32);
        this.backButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this.backButton.setFrame([10, 10, 32, 32]);
        this.backButton.setNormalGradient({
            corners: '12 12 12 12',
            outerLine: "00 3",
            //gradient: [ "FF9bd6f4 0.0", "FF0077BC 1.0" ]
            gradient: [ "FFFF0000 0.0", "FFFF0000 1.0" ]
        });
        this.backButton.setHighlightedGradient({
            corners: '12 12 12 12',
            outerLine: "00 3",
            //gradient: [ "FF0077BC 0.0", "FF9bd6f4 1.0" ]
            gradient: [ "FF990000 0.0", "FF990000 1.0" ]
        });
        var self = this;
        this.backButton.onclick = function() {
            self.close(300);
        };
    
    },
    
    pauseListeners: function()
    {
        this.messageListener.pauseListeners();
    },
    
    resumeListeners: function()
    {
        this.messageListener.resumeListeners();
    },
    
    getParameterByName: function(url, name, d)
    {
        name = name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
        var regexS = "[\\?&]"+name+"=([^&#]*)";
        var regex = new RegExp( regexS );
        var results = regex.exec( url );
        if( results == null )
            return d;
        else
            return decodeURIComponent(results[1].replace(/\+/g, " "));
    },
    
    onPageEvent: function(event)
    {
        if (event == null) {
            NGWindow.log("WebView webgame Page Event: null");
        }
		NGWindow.log(["WebView webgame Page Event: ", event.eventStream]);
        var method = event.eventStream.split("?")[0];
        
        if (method == "domReady") {
            this.domReady();
        } else if (method == "checkPermissionsForUserInteractionResponse") {
            this.checkPermissionsForUserInteractionResponse(event.eventStream);
        } else if (method == "accelerometerStart") {
            this.accelerometerStart(event.eventStream);
        } else if (method == "accelerometerStop") {
            this.accelerometerStop(event.eventStream);
        } else if (method == "gyroscopeStart") {
            this.gyroscopeStart(event.eventStream);
        } else if (method == "gyroscopeStop") {
            this.gyroscopeStop(event.eventStream);
        } else if (method == "magnetometerStart") {
            this.magnetometerStart(event.eventStream);
        } else if (method == "magnetometerStop") {
            this.magnetometerStop(event.eventStream);
        } else if (method == "deviceMotionStart") {
            this.deviceMotionStart(event.eventStream);
        } else if (method == "deviceMotionStop") {
            this.deviceMotionStop(event.eventStream);
        } else if (method == "gpsStart") {
            this.gpsStart(event.eventStream);
        } else if (method == "gpsStop") {
            this.gpsStop(event.eventStream);
        } else if (method == "deviceAccelerometerAvailable") {
            this.deviceAccelerometerAvailable(event.eventStream);
        } else if (method == "deviceGyroscopeAvailable") {
            this.deviceGyroscopeAvailable(event.eventStream);
        } else if (method == "deviceDeviceMotionAvailable") {
            this.deviceDeviceMotionAvailable(event.eventStream);
        } else if (method == "deviceGPSAvailable") {
            this.deviceGPSAvailable(event.eventStream);
        } else if (method == "deviceMagnetometerAvailable") {
            this.deviceMagnetometerAvailable(event.eventStream);
        } else if (method == "deviceVibrateAvailable") {
            this.deviceVibrateAvailable(event.eventStream);
        } else if (method == "deviceEmailAvailable") {
            this.deviceEmailAvailable(event.eventStream);
        } else if (method == "deviceSMSAvailable") {
            this.deviceSMSAvailable(event.eventStream);
        } else if (method == "deviceShakeListeningAvailable") {
            this.deviceShakeListeningAvailable(event.eventStream);
        } else if (method == "deviceVibrate") {
            this.deviceVibrate(event.eventStream);
        } else if (method == "deviceStartShakeListening") {
            this.deviceStartShakeListening(event.eventStream);
        } else if (method == "deviceStopShakeListening") {
            this.deviceStopShakeListening(event.eventStream);
        } else if (method == "deviceAlert") {
            this.deviceAlert(event.eventStream);
        } else if (method == "deviceBatteryState") {
            this.deviceBatteryState(event.eventStream);
        } else if (method == "deviceUniqueId") {
            this.deviceUniqueId(event.eventStream);
        } else if (method == "deviceModel") {
            this.deviceModel(event.eventStream);
        } else if (method == "deviceSystemVersion") {
            this.deviceSystemVersion(event.eventStream);
        } else if (method == "deviceHardwareModel") {
            this.deviceHardwareModel(event.eventStream);
        } else if (method == "deviceConnectionType") {
            this.deviceConnectionType(event.eventStream);
        } else if (method == "deviceLanguage") {
            this.deviceLanguage(event.eventStream);
        } else if (method == "deviceLocale") {
            this.deviceLocale(event.eventStream);
        } else if (method == "deviceScalingFactor") {
            this.deviceScalingFactor(event.eventStream);
        } else if (method == "devicePlatform") {
            this.devicePlatform(event.eventStream);
        } else if (method == "deviceScreenSize") {
            this.deviceScreenSize(event.eventStream);
        } else if (method == "deviceScreenDensity") {
            this.deviceScreenDensity(event.eventStream);
        } else if (method == "deviceInterfaceOrientation") {
            this.deviceInterfaceOrientation(event.eventStream);
        } else if (method == "deviceCurrentOrientation") {
            this.deviceCurrentOrientation(event.eventStream);
        } else if (method == "displayExpandToFullScreen") {
            this.displayExpandToFullScreen(event.eventStream);
        } else if (method == "displayResizeTo") {
            this.displayResizeTo(event.eventStream);
        } else if (method == "displayContractAd") {
            this.displayContractAd(event.eventStream);
        } else if (method == "displayOpenInBrowser") {
            this.displayOpenInBrowser(event.eventStream);
        } else if (method == "displaySetAdDidDisplayCallback") {
            this.setAdDidDisplayCallback(event.eventStream);
        } else if (method == "displaySetAdFinishedResizingCallback") {
            this.setAdFinishedResizingCallback(event.eventStream);
        } else if (method == "displaySetAdWillContractCallback") {
            this.setAdWillContractCallback(event.eventStream);
        } else if (method == "displaySetAdWillTerminateCallback") {
            this.setAdWillTerminateCallback(event.eventStream);
        } else if (method == "displaySetAdWillBecomeHiddenCallback") {
            this.setAdWillBecomeHiddenCallback(event.eventStream);
        } else if (method == "displaySetAdDidReturnFromHiddenCallback") {
            this.setAdDidReturnFromHiddenCallback(event.eventStream);
        } else if (method == "displaySetAllDisplayCallbacks") {
            this.setAllDisplayCallbacks(event.eventStream);
        } else
            this.loadUrl("http://www.yahoo.com");
	},
    
    guidGenerator: function()
    {
        var S4 = function() {
           return (((1+Math.random())*0x10000)|0).toString(16).substring(1);
        };
        return (S4()+S4()+"-"+S4()+"-"+S4()+"-"+S4()+"-"+S4()+S4()+S4());
    },
    
    callback: function(callbackFunctionName, value, addQuotes)
    {
        var js = callbackFunctionName;
        if (addQuotes)
            js += "(\"";
        else
            js += "(";
        
        if (value != null)
            js += value;
        
        if (addQuotes)
            js += "\")";
        else
            js += ")";
            
        NGWindow.log(["WebView - callback: ", js]);
        return js;
    },
    
    domReady: function()
    {
        this.uniqueKey = this.guidGenerator();
        this.invoke("window.addEventListener('click', function(){mAdViewPermissionsKey=" + this.uniqueKey + ";}, true);");
    },
    
    checkPermissionsForUserInteraction: function(callback, errorCallbackFunctionName)
    {
        var js = "try { window.location=\"ngcore://checkPermissionsForUserInteractionResponse?uniquekey=mAdViewPermissionsKey";
        if (callback != null && callback != "") {
            js += "&callback=" + escape(callback)
        }
        js += "; } catch (e) { + " + errorCallbackFunctionName + "('User has not interacted with ad yet.');}";
        this.invoke(js);
    },
    
    checkPermissionsForUserInteractionResponse: function(uri)
    {
        var uniqueKey = this.getParameterByName(uri, "uniqueKey") || null;
        var callback = this.getParameterByName(uri, "callback") || null;
        if (this.uniqueKey == uniqueKey) {
            this.hasUserInteracted = true;
            
            if (callback != null && callback != "null") {
                this.invoke(unescape(callback));
            }
        }
    },
    
    
    // ****** SENSORS *********
    
    accelerometerStart: function(uri)
    {
        NGWindow.log(['WebView - accelerometerStart: ', uri]);
        var interval = this.getParameterByName(uri, "interval") || null;
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            if (Core.Capabilities.getHasAccel()) {
                this.messageListener.accelerometerListenerCallbackFunctionName = callbackFunctionName;
                this.messageListener.accelerometerListenerInterval = interval * 1000;
                Device.MotionEmitter.addListener(this.messageListener, this.messageListener.onMotionEvent, 10000);
                
                if (successCallbackFunctionName != null)
                    this.invoke(this.callback(successCallbackFunctionName, null, false));
            } else {
                if (errorCallbackFunctionName != null)
                        this.invoke(this.callback(errorCallbackFunctionName, "Device does not support an accelerometer.", false));
            }
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    accelerometerStop: function(uri)
    {
        NGWindow.log(['WebView - accelerometerStop: ', uri]);
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            this.messageListener.accelerometerListenerCallbackFunctionName = null;
            this.messageListener.checkRemoveMotionListener();
            
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    gyroscopeStart: function(uri)
    {
        NGWindow.log(['WebView - gyroscopeStart: ', uri]);
        var interval = this.getParameterByName(uri, "interval") || null;
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            if (Core.Capabilities.getHasGyro()) {
                this.messageListener.gyroscopeListenerCallbackFunctionName = callbackFunctionName;
                this.messageListener.gyroscopeListenerInterval = interval * 1000;
                Device.MotionEmitter.addListener(this.messageListener, this.messageListener.onMotionEvent, 10000);
                
                if (successCallbackFunctionName != null)
                    this.invoke(this.callback(successCallbackFunctionName, null, false));
            } else {
                if (errorCallbackFunctionName != null)
                        this.invoke(this.callback(errorCallbackFunctionName, "Device does not support a gyroscope.", false));
            }
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    gyroscopeStop: function(uri)
    {
        NGWindow.log(['WebView - gyroscopeStop: ', uri]);
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            this.messageListener.gyroscopeListenerCallbackFunctionName = null;
            this.messageListener.checkRemoveMotionListener();
            
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    magnetometerStart: function(uri)
    {
        NGWindow.log(['WebView - magnetometerStart: ', uri]);
        var interval = this.getParameterByName(uri, "interval") || null;
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            if (Core.Capabilities.getHasCompass()) {
                this.messageListener.compassListenerCallbackFunctionName = callbackFunctionName;
                this.messageListener.compassListenerInterval = interval * 1000;
                Device.MotionEmitter.addListener(this.messageListener, this.messageListener.onMotionEvent, 10000);
                
                if (successCallbackFunctionName != null)
                    this.invoke(this.callback(successCallbackFunctionName, null, false));
            } else {
                if (errorCallbackFunctionName != null)
                        this.invoke(this.callback(errorCallbackFunctionName, "Device does not support the magnetometer.", false));
            }
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    magnetometerStop: function(uri)
    {
        NGWindow.log(['WebView - magnetometerStop: ', uri]);
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            this.messageListener.magnetometerListenerCallbackFunctionName = null;
            
            this.messageListener.checkRemoveMotionListener();
            
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    deviceMotionStart: function(uri)
    {
        NGWindow.log(['WebView - deviceMotionStart: ', uri]);
        var interval = this.getParameterByName(uri, "interval") || null;
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        if (errorCallbackFunctionName != null)
            this.invoke(this.callback(errorCallbackFunctionName, "Device does not support device motion.", false));
    },
    
    deviceMotionStop: function(uri)
    {
        NGWindow.log(['WebView - deviceMotionStop: ', uri]);
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        if (errorCallbackFunctionName != null)
            this.invoke(this.callback(errorCallbackFunctionName, "Device does not support device motion.", false));
    },
    
    gpsStart: function(uri)
    {
        NGWindow.log(['WebView - gpsStart: ', uri]);
        var distanceFilter = this.getParameterByName(uri, "distanceFilter") || null;
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            if (Core.Capabilities.getHasGps()) {
                this.messageListener.gpsListenerCallbackFunctionName = callbackFunctionName;
                this.messageListener.gpsListenerDistanceFilter = distanceFilter;
                Device.LocationEmitter.addListener(this.messageListener, this.messageListener.onLocationEvent, 10000);
                
                if (successCallbackFunctionName != null)
                    this.invoke(this.callback(successCallbackFunctionName, null, false));
            } else {
                if (errorCallbackFunctionName != null)
                        this.invoke(this.callback(errorCallbackFunctionName, "Device does not support GPS location.", false));
            }
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    gpsStop: function(uri)
    {
        NGWindow.log(['WebView - gpsStop: ', uri]);
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            this.messageListener.gpsListenerCallbackFunctionName = null;
            this.messageListener.gpsListenerDistanceFilter = 0;
            this.messageListener.gpsListenerLastReportedLongitude = 0;
            this.messageListener.gpsListenerLastReportedLatitude = 0;
            
            Device.LocationEmitter.removeListener(this.messageListener);
            
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    
    
    
    
    // ******* DEVICE *********
    
    deviceAccelerometerAvailable: function(uri)
    {
        NGWindow.log(['WebView - deviceAccelerometerAvailable: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var b = "false";
        if (Core.Capabilities.getHasAccel())
            b = "true";
        else
            b= "false";
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, b, false));
    },
    
    deviceGyroscopeAvailable: function(uri)
    {
        NGWindow.log(['WebView - deviceGyroscopeAvailable: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var b = "false";
        if (Core.Capabilities.getHasGyro())
            b = "true";
        else
            b= "false";
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, b, false));
    },
    
    deviceDeviceMotionAvailable: function(uri)
    {
        NGWindow.log(['WebView - deviceDeviceMotionAvailable: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var b = "false";
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, b, false));
    },
    
    deviceGPSAvailable: function(uri)
    {
        NGWindow.log(['WebView - deviceGPSAvailable: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var b = "false";
        if (Core.Capabilities.getHasGps())
            b = "true";
        else
            b= "false";
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, b, false));
    },

    deviceMagnetometerAvailable: function(uri)
    {
        NGWindow.log(['WebView - deviceMagnetometerAvailable: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var b = "false";
        if (Core.Capabilities.getHasCompass())
            b = "true";
        else
            b= "false";
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, b, false));
    },
    
    deviceVibrateAvailable: function(uri)
    {
        NGWindow.log(['WebView - deviceVibrateAvailable: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;

        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, "false", false));
    },
    
    deviceEmailAvailable: function(uri)
    {
        NGWindow.log(['WebView - deviceEmailAvailable: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, "true", false));
    },
    
    deviceSMSAvailable: function(uri)
    {
        NGWindow.log(['WebView - deviceSMSAvailable: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, "true", false));
    },
    
    deviceShakeListeningAvailable: function(uri)
    {
        NGWindow.log(['WebView - deviceShakeListeningAvailable: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var b = "false";
        if (Core.Capabilities.getHasAccel())
            b = "true";
        else
            b= "false";
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, b, false));
    },
    
    deviceVibrate: function(uri)
    {
        NGWindow.log(['WebView - deviceVibrate: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;

        if (errorCallbackFunctionName != null)
            this.invoke(this.callback(errorCallbackFunctionName, "Device does not support vibrate.", false));
    },
    
    deviceStartShakeListening: function(uri)
    {
        NGWindow.log(['WebView - deviceStartShakeListening: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            if (Core.Capabilities.getHasAccel()) {               
                this.messageListener.shakeListenerCallbackFunctionName = callbackFunctionName;
                
                Device.ShakeEmitter.addListener(this.messageListener, this.messageListener.onShakeEvent, 10000);
                
                if (successCallbackFunctionName != null)
                    this.invoke(this.callback(successCallbackFunctionName, null, false));
            } else {
                if (errorCallbackFunctionName != null)
                        this.invoke(this.callback(errorCallbackFunctionName, "Device does not support shaking.", false));
            }
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    deviceStopShakeListening: function(uri)
    {
        NGWindow.log(['WebView - deviceStopShakeListening: ', uri]);
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            Device.ShakeEmitter.removeListener(this.messageListener);
            
            this.messageListener.shakeListenerCallbackFunctionName = null;
            
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    deviceAlert: function(uri)
    {
        NGWindow.log(['WebView - deviceAlert: ', uri]);
        var title = this.getParameterByName(uri, "title") || null;
        var message = this.getParameterByName(uri, "message") || null;
        var buttonTitles = this.getParameterByName(uri, "buttonTitles") || null;
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        
        try {
            var dialog = new UI.AlertDialog();
            dialog.setTitle(title);
            dialog.setText(message);
            var buttonArray = buttonTitles.split("|");
            dialog.setChoices(buttonArray);
            var self = this;
            dialog.setOnChoice( function(event) {
                NGWindow.log(['WebView - deviceAlert - choice: ', event, callbackFunctionName]);
                self.invoke(self.callback(callbackFunctionName, event.choice + ", '" + buttonArray[event.choice] + "'", false));
                dialog.hide();
            });
            dialog.show();
        } catch (error) { }
    },
    
    deviceBatteryState: function(uri)
    {
        NGWindow.log(['WebView - deviceBatteryState: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, "unavailable", true));
    },
    
    deviceUniqueId: function(uri)
    {
        NGWindow.log(['WebView - deviceUniqueId: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getUniqueId(), true));
    },

    deviceModel: function(uri)
    {
        NGWindow.log(['WebView - deviceModel: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getDeviceName(), true));
    },
    
    deviceSystemVersion: function(uri)
    {
        NGWindow.log(['WebView - deviceSystemVersion: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getPlatformOSVersion(), true));
    },
    
    deviceHardwareModel: function(uri)
    {
        NGWindow.log(['WebView - deviceHardwareModel: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getPlatformHW(), true));
    },
    
    deviceConnectionType: function(uri)
    {
        NGWindow.log(['WebView - deviceConnectionType: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Controller.getNetworkState(), true));
    },
    
    deviceLanguage: function(uri)
    {
        NGWindow.log(['WebView - deviceLanguage: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getLanguage(), true));
    },
    
    deviceLocale: function(uri)
    {
        NGWindow.log(['WebView - deviceLocale: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getLocale(), true));
    },
    
    deviceScalingFactor: function(uri)
    {
        NGWindow.log(['WebView - deviceScalingFactor: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getScreenUnits(), true));
    },
    
    devicePlatform: function(uri)
    {
        NGWindow.log(['WebView - devicePlatform: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getPlatformOS(), true));
    },
    
    deviceScreenSize: function(uri)
    {
        NGWindow.log(['WebView - deviceScreenSize: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getScreenWidth() + ", " +
                              Core.Capabilities.getScreenHeight(), false));
    },
    
    deviceScreenDensity: function(uri)
    {
        NGWindow.log(['WebView - deviceScreenDensity: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getScreenPixelUnits(), false));
    },
    
    deviceCurrentOrientation: function(uri)
    {
        NGWindow.log(['WebView - deviceScreenDensity: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        var r = "landscape";
    
        var o = Device.OrientationEmitter.getDeviceOrientation();
        if (o == Device.OrientationEmitter.Orientation.Portrait ||
                o == Device.OrientationEmitter.Orientation.PortraitUpsideDown) 
            r = "portrait";
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, r, true));
    },
    
    deviceInterfaceOrientation: function(uri)
    {
        NGWindow.log(['WebView - deviceScreenDensity: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        var r = "landscape";
    
        var o = Device.OrientationEmitter.getInterfaceOrientation();
        if (o == Device.OrientationEmitter.Orientation.Portrait ||
                o == Device.OrientationEmitter.Orientation.PortraitUpsideDown) 
            r = "portrait";
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, r, true));
    },
    
    

    
    
    
    
    
    // *********** DISPLAY ************
    
    displayExpandToFullScreen: function(uri)
    {
        NGWindow.log('ngcore: displayExpandToFullScreen');
            
        var animationDuration = this.getParameterByName(uri, "animationDuration") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            if (this.fullscreen) {
                if (errorCallbackFunctionName != null)
                    this.invoke(this.callback(errorCallbackFunctionName, "Cannot expand a fullscreen ad", false));
                return;
            }
        
            if (!this.autoplay && !this.userHasInteracted) {
                var js = "window.location=" + uri;
                this.checkPermissionsForUserInteraction(js);
                return;
            }
            
            if (this.expandTo(animationDuration,0,0,
                              Core.Capabilities.getScreenWidth(),
                              Core.Capabilities.getScreenHeight())) {                          
                if (successCallbackFunctionName != null)
                    this.invoke(this.callback(successCallbackFunctionName, null, false));
            } else {
                if (errorCallbackFunctionName != null)
                    this.invoke(this.callback(errorCallbackFunctionName, "Failed to expand", false));
            }
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error, false));
        }
    },
    
    displayResizeTo: function(uri)
    {
        NGWindow.log('ngcore: displayResizeTo');
        
        var x = this.getParameterByName(uri, "x", 0);
        var y = this.getParameterByName(uri, "y", 0);
        var w = this.getParameterByName(uri, "width", 0);
        var h = this.getParameterByName(uri, "height", 0);
        var animationDuration = this.getParameterByName(uri, "animationDuration") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            if (this.fullscreen) {
                if (errorCallbackFunctionName != null)
                    this.invoke(this.callback(errorCallbackFunctionName, "Cannot resize a fullscreen ad", false));
                return;
            }
        
            if (!this.autoplay && !this.userHasInteracted) {
                var js = "window.location=" + uri;
                this.checkPermissionsForUserInteraction(js);
                return;
            }
            
            if (this.expandTo(animationDuration,x,y,w,h)) {
                if (successCallbackFunctionName != null)
                    this.invoke(this.callback(successCallbackFunctionName, null, false));
            } else {
                if (errorCallbackFunctionName != null)
                    this.invoke(this.callback(errorCallbackFunctionName, "Failed to expand", false));
            }
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error, false));
        }
    },
    
    displayContractAd: function(uri)
    {
        NGWindow.log('ngcore: displayContractAd');
        var animationDuration = this.getParameterByName(uri, "animationDuration") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            if (this.fullscreen) {
                if (errorCallbackFunctionName != null)
                    this.invoke(this.callback(errorCallbackFunctionName, "Cannot contract a fullscreen ad", false));
                return;
            }
        
            if (this.close(animationDuration)) {
                if (successCallbackFunctionName != null)
                    this.invoke(this.callback(successCallbackFunctionName, null, false));
            } else {
                if (errorCallbackFunctionName != null)
                    this.invoke(this.callback(errorCallbackFunctionName, "Failed to contract ad", false));
            }
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error, false));
        }
    },

    exitCallback: function(event)
    {
        NGWindow.log(['WebView - exitCallback: ', event]);
        
        this.close(300);
    },
    
    close: function(duration)
    {
        if (this.expanded == false)
            return false;
        
        if (this.detaching)
            return false;
        this.detaching = true;
        
        if (duration <= 0) duration = 1;
        if (duration > 3000) duration = 3000;
        
        
        var self = this;
        var parentAdViewFrame;
        parentAdViewFrame = this.parentCreative.adView.getFrame();
        this.adWillContract();
        
        this.backButton.removeFromParent();
        
        UI.animate( function() {
                self.setFrame(parentAdViewFrame);
            }, duration, function() {
                self.adFinishedResizing();
            
                self.dont_destroy_me = true;
                self.removeFromParent();
                self.parentCreative.addChild(self);
                self.dont_destroy_me = false;
                
                self.setFrame(self.adView_frame);
                
                self.screenCover.removeFromParent();
                self.expanded = false;
                self.detaching = false;
                
                self.parentCreative.adView.didTouchThrough(this.parentCreative);
            });
        return true;
    },


    expandTo: function(duration, x, y, width, height)
    {
        NGWindow.log('WebView - expandTo');
        
        if (duration <= 0) duration = 1;
        if (duration > 3000) duration = 3000;
        
        var self = this;
        if (this.expanded == false) {
            if (!this.parentCreative.adView.shouldTouchThrough())
                return false;

            this.parentCreative.adView.willTouchThrough(this.parentCreative);
        
            if (this.detaching)
                return false;
            this.detaching = true;
        
            NGWindow.log('WebView - expandTo - expanding');
            this.adView_frame = this.getFrame(this.adView_frame);
            NGWindow.log(['WebView - expandTo - adView_frame: ', this.adView_frame]);
            
            this.screenCover = new UI.View();
            this.screenCover.setFrame([0,0,
                                       Core.Capabilities.getScreenWidth(),
                                       Core.Capabilities.getScreenHeight()]);
            
            /*var backgroundView = new UI.Button();
            backgroundView.setFrame([0,0,320,800]);
            backgroundView.setBackgroundColor("000000");
            backgroundView.setAlpha(0.3);
            this.screenCover.addChild(backgroundView);*/
            
            var closeCover = new UI.Button();
            closeCover.setFrame([0,0,
                                 Core.Capabilities.getScreenWidth(),
                                 Core.Capabilities.getScreenHeight()]);
            closeCover.setBackgroundColor("000000");
            closeCover.setAlpha(0.3);
            this.screenCover.addChild(closeCover);
            
            
            closeCover.setOnClick(function(event) {
                self.exitCallback(event);
            });
            
            NGWindow.document.addChild(this.screenCover);
            
            this.dont_destroy_me = true;
            this.parentCreative.removeChild(this);
            this.screenCover.addChild(this);
            this.dont_destroy_me = false;
            
            var parentAdViewFrame;
            parentAdViewFrame = this.parentCreative.adView.getFrame();
            this.setFrame(parentAdViewFrame);
            
            this.detaching = false;
            this.expanded = true;

        }
        
        try {
            this.backButton.removeFromParent();
        } catch (error) {}
        if (width >= Core.Capabilities.getScreenWidth() * .8 ||
                height >= Core.Capabilities.getScreenHeight() * .8) {
            this.screenCover.addChild(this.backButton);
        }
        
        UI.animate( function() {
                self.setFrame([x,y,width,height]);
            }, 500, function() {
                self.adFinishedResizing();
            });
        
        return true;
    },
    
    displayOpenInBrowser: function(uri)
    {
        NGWindow.log('ngcore: displayOpenInBrowser');
        var url = this.getParameterByName(uri, "url");
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            if (!this.autoplay && !this.userHasInteracted) {
                var js = "window.location=" + uri;
                this.checkPermissionsForUserInteraction(js);
                return;
            }
        
            var browser = new Browser();
            browser.onDidFinish = function() {
                // Whatever you need to do
            };
            
            browser.loadUrl(url);
            browser.presentViewController(true);
            browser.release();
            browser = null;
            
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), true));
        }
    },
    
    
    
    // ************** DISPLAY LISTENERS *****************
    
    setAdDidDisplayCallback: function(uri)
    {
        var adDidDisplayCallback = this.getParameterByName(uri, "adDidDisplayCallbackFunctionName");
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName");
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName");
        try {
            this.adDidDisplayCallback = adDidDisplayCallback;
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, escape(error.toString()), true));
        }
    },
    
    adDidDisplay: function()
    {
        if (this.adDidDisplayCallback != null)
            this.invoke(this.callback(this.adDidDisplayCallback, null, false));
    },
    
    setAdFinishedResizingCallback: function(uri)
    {
        var adFinishedResizingCallback = this.getParameterByName(uri, "adFinishedResizingCallbackFunctionName");
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName");
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName");
        try {
            this.adFinishedResizingCallback = adFinishedResizingCallback;
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, escape(error.toString()), true));
        }
    },
    
    adFinishedResizing: function()
    {
        if (this.adFinishedResizingCallback != null)
            this.invoke(this.callback(this.adFinishedResizingCallback, null, false));
    },
    
    setAdWillContractCallback: function(uri)
    {
        var adWillContractCallback = this.getParameterByName(uri, "adWillContractCallbackFunctionName");
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName");
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName");
        try {
            this.adWillContractCallback = adWillContractCallback;
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, escape(error.toString()), true));
        }
    },
    
    adWillContract: function()
    {
        if (this.adWillContractCallback != null)
            this.invoke(this.callback(this.adWillContractCallback, null, false));
    },
    
    setAdWillTerminateCallback: function(uri)
    {
        var adWillTerminateCallback = this.getParameterByName(uri, "adWillTerminateCallbackFunctionName");
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName");
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName");
        try {
            this.adWillTerminateCallback = adWillTerminateCallback;
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, escape(error.toString()), true));
        }
    },
    
    adWillTerminate: function()
    {
        if (this.adWillTerminateCallback != null)
            this.invoke(this.callback(this.adWillTerminateCallback, null, false));
    },
    
    setAdWillBecomeHiddenCallback: function(uri)
    {
        var adWillBecomeHiddenCallback = this.getParameterByName(uri, "adWillBecomeHiddenCallbackFunctionName");
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName");
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName");
        try {
            this.adWillBecomeHiddenCallback = adWillBecomeHiddenCallback;
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, escape(error.toString()), true));
        }
    },
    
    adWillBecomeHidden: function()
    {
        if (this.adWillBecomeHiddenCallback != null)
            this.invoke(this.callback(this.adWillBecomeHiddenCallback, null, false));
    },
    
    setAdDidReturnFromHiddenCallback: function(uri)
    {
        var adDidReturnFromHiddenCallback = this.getParameterByName(uri, "adDidReturnFromHiddenCallbackFunctionName");
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName");
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName");
        try {
            this.adDidReturnFromHiddenCallback = adDidReturnFromHiddenCallback;
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, escape(error.toString()), true));
        }
    },
    
    adDidReturnFromHidden: function()
    {
        if (this.adDidReturnFromHiddenCallback != null)
            this.invoke(this.callback(this.adDidReturnFromHiddenCallback, null, false));
    },
    
    setAllDisplayCallbacks: function(uri)
    {
        var adFinishedResizingCallback = this.getParameterByName(uri, "adFinishedResizingCallbackFunctionName");
        var adWillContractCallback = this.getParameterByName(uri, "adWillContractCallbackFunctionName");
        var adWillTerminateCallback = this.getParameterByName(uri, "adWillTerminateCallbackFunctionName");
        var adWillBecomeHiddenCallback = this.getParameterByName(uri, "adWillBecomeHiddenCallbackFunctionName");
        var adDidReturnFromHiddenCallback = this.getParameterByName(uri, "adDidReturnFromHiddenCallbackFunctionName");
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName");
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName");
        try {
            this.adFinishedResizingCallback = adFinishedResizingCallback;
            this.adWillContractCallback = adWillContractCallback;
            this.adWillTerminateCallback = adWillTerminateCallback;
            this.adWillBecomeHiddenCallback = adWillBecomeHiddenCallback;
            this.adDidReturnFromHiddenCallback = adDidReturnFromHiddenCallback;
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, escape(error.toString()), true));
        }
    },
    
    
    /**
	 * Destroys the current object
	 * @private
	 */
	destroy: function($super) {
        NGWindow.log('WebView - destroy');
        if (this.dont_destroy_me) {

        } else {
            if (this.screenCover != null) {
                this.screenCover.removeFromParent();
                this.screenCover.destroy();
            }
            
            messageListener.destroy();
            
            $super();
        }
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/CreativeView/WebViewMessageListener'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/WebViewMessageListener'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/WebViewMessageListener'] = exports; //
//  Mobclix.Core.MMWebViewMessageListener.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var UI = require('NGCore/Client/UI').UI;
var Core = require('NGCore/Client/Core').Core;
var Device = require('NGCore/Client/Device').Device;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var WebViewMessageListener = exports.WebViewMessageListener = Core.MessageListener.subclass({
	__className: "WebViewMessageListener",
    
    webview: null,
    
    accelerometerListenerCallbackFunctionName: null,
    accelerometerListenerInterval: 0,
    accelerometerListenerLastTimestamp: 0,
    
    gyroscopeListenerCallbackFunctionName: null,
    gyroscopeListenerInterval: 0,
    gyroscopeListenerLastTimestamp: 0,
    
    compassListenerCallbackFunctionName: null,
    compassListenerInterval: 0,
    compassListenerLastTimestamp: 0,
    
    shakeListenerCallbackFunctionName: null,
    gpsListenerCallbackFunctionName: null,
    gpsListenerDistanceFilter: 0,
    gpsListenerLastReportedLongitude: 0,
    gpsListenerLastReportedLatitude: 0,
    
    initialize: function($super, webview) {
		$super();
		this.webview = webview;
	},
    
    pauseListeners: function()
    {
        try {
            Device.ShakeEmitter.removeListener(this);
        } catch (error) {}
        try {
            Device.MotionEmitter.removeListener(this);
        } catch (error) {}
        try {
            Device.LocationEmitter.removeListener(this);
        } catch (error) {}
    },
    
    resumeListeners: function()
    {
        try {
            if (this.shakeListenerCallbackFunctionName != null) {
                Device.ShakeEmitter.addListener(this, this.onShakeEvent, 10000);
            }
        } catch (error) {}
        try {
            Device.MotionEmitter.addListener(this, this.onMotionEvent, 10000);
            this.checkRemoveMotionListener();
        } catch (error) {}
        try {
            if (this.gpsListenerCallbackFunctionName != null) {
                Device.LocationEmitter.addListener(this, this.onLocationEvent, 10000);
            }
        } catch (error) {}
    },
    
    onKeyEvent: function(params) {
        NGWindow.log(["MMWebViewMessageListener - onKeyEvent - event: ", params]);
    },
    
    onLifecycleEvent: function(params) {
        NGWindow.log(["MMWebViewMessageListener - onLifecycleEvent - event: ", params]);
        if (params == Device.LifecycleEmitter.Event.Suspend) {
            this.webview.adWillBecomeHidden();
            this.pauseListeners();
        } else if (params == Device.LifecycleEmitter.Event.Resume) {
            this.webview.adDidReturnFromHidden();
            this.resumeListeners();
        } else if (params == Device.LifecycleEmitter.Event.Terminate) {
            this.webview.adWillTerminate();
            this.pauseListeners();
        }
    },
 
    onMotionEvent: function(params) {
        var t = (new Date()).getTime();
        if (this.accelerometerListenerCallbackFunctionName != null &&
                t > this.accelerometerListenerLastTimestamp + this.accelerometerListenerInterval) {
            this.accelerometerListenerLastTimestamp = t;
            var data = params.getAccelData();
            try {
                this.webview.invoke(this.webview.callback(this.accelerometerListenerCallbackFunctionName,
                                                          data[0] + "," + data[1] + "," + data[2],
                                                          false));
            } catch (error) {}
        }
        if (this.gyroscopeListenerCallbackFunctionName != null &&
                t > this.gyroscopeListenerLastTimestamp + this.gyroscopeListenerInterval) {
            this.gyroscopeListenerLastTimestamp = t;
            var data = params.getGyroData();
            try {
                this.webview.invoke(this.webview.callback(this.gyroscopeListenerCallbackFunctionName,
                                                          data[0] + "," + data[1] + "," + data[2],
                                                          false));
            } catch (error) {}
        }
        if (this.compassListenerCallbackFunctionName != null &&
                t > this.compassListenerLastTimestamp + this.compassListenerInterval) {
            this.compassListenerLastTimestamp = t;
            var data = params.getCompassData();
            try {
                this.webview.invoke(this.webview.callback(this.compassListenerCallbackFunctionName,
                                                          data[0],
                                                          false));
            } catch (error) {}
        }
    },
    
    checkRemoveMotionListener: function() {
        NGWindow.log(["MMWebViewMessageListener - checkRemoveMotionListener"]);
        if (this.accelerometerListenerCallbackFunctionName == null &&
                this.gyroscopeListenerCallbackFunctionName == null &&
                this.compassListenerCallbackFunctionName == null) {
            try {
                NGWindow.log(["MMWebViewMessageListener - checkRemoveMotionListener - trying to remove listener"]);
                Device.MotionEmitter.removeListener(this);
            } catch (error) {
                NGWindow.log(["MMWebViewMessageListener - checkRemoveMotionListener - error: ", error.toString()]);
            }
        }
    },
 
    onLocationEvent: function(params)
    {
        if (this.gpsListenerCallbackFunctionName != null) {
            try {
                if (distanceBetweenCoordinates(
                        params.getPosition().getX(),
                        params.getPosition().getY(),
                        this.gpsListenerLastReportedLongitude,
                        this.gpsListenerLastReportedLatitude) < this.gpsListenerDistanceFilter) {
                    return;
                }
                
                this.gpsListenerLastReportedLongitude = params.getPosition().getX();
                this.gpsListenerLastReportedLatitude = params.getPosition().getY();
            
                var locationData = { "coordinate": { "latitude": params.getPosition().getX(),
                                                     "longitude": params.getPosition().getY() },
                                     "course": params.getHeading(),
                                     "speed": 0,
                                     "timestamp": params.getTimestamp(),
                                     "horizontalAccuracy": params.getAccuracy(),
                                     "verticalAccuracy": params.getAccuracy() };
                this.webview.invoke(this.webview.callback(this.gpsListenerCallbackFunctionName,
                                                          "eval('(" + JSON.stringify(locationData) + ")')",
                                                          false));
            
            } catch (error) {}
        }
    },
    
    distanceBetweenCoordinates: function(long1, lat1, long2, lat2)
    {
        var R = 6371000; // meters
        return Math.acos(Math.sin(lat1)*Math.sin(lat2) + 
                         Math.cos(lat1)*Math.cos(lat2) *
                         Math.cos(long2-long1)) * R;
    },
 
    onShakeEvent: function(params)
    {
        NGWindow.log(['MMWebViewMessageListener - onShakeEvent: ', params]);
        if (this.shakeListenerCallbackFunctionName != null)
            webview.invoke(this.callback(this.shakeListenerCallbackFunctionName, null, false));
    },
    
    /**
	 * Destroys the current object
	 * @private
	 */
	destroy: function($super) {
        NGWindow.log('MMWebViewMessageListener - destroy');
        
        try {
            Device.KeyEmitter.removeListener(this);
        } catch (error) {}
        try {
            Device.LifecycleEmitter.removeListener(this);
        } catch (error) {}
        try {
            Device.ShakeEmitter.removeListener(this);
        } catch (error) {}
        try {
            Device.MotionEmitter.removeListener(this);
        } catch (error) {}
        try {
            Device.LocationEmitter.removeListener(this);
        } catch (error) {}
        
        $super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/FullScreenAdView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/FullScreenAdView'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/FullScreenAdView'] = exports; //
//  Mobclix.FullScreenAdView.Base.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var AdViewInternal = require('NGCore/Client/Mobclix/AdViewInternal').AdViewInternal;

var FullScreenAdView = exports.FullScreenAdView = AdViewInternal.subclass(
/** @lends Mobclix.FullScreenAdView.prototype */
{
	__className: "Mobclix.FullScreenAdView",
	_subsequent: false,
	_canRequestNextAd: true,
    
	/**
	 * @class 
	 * This class should not be instantiated directly, instead use one of the following subclasses:
	 * <ul>
	 * <li>{@link Mobclix.AdView_FullScreen}</li>
	 * </ul>
     * <br>
     * This view does not need to be added to the view hierarchy. The
     * requested fullscreen ad will automatically be attached.
     * The easiest implementation of the FullScreenAdView can be done in
     * the following manner:<br><br>
     * var fullScreenAdView = new Mobclix.AdView_FullScreen();<br>
     * fullScreenAdView.requestAndDisplayAd();<br>
     *
	 * @constructs The default constructor.
	 * @public
	 */
	initialize: function($super) {
		$super();
	},

	/**
	 * Requests a new ad from the server. This ad will preload, but will not
     * display until displayAd is called.
     *
	 * @public
	 */
	requestAd: function() {
        if (!this._canRequestNextAd)
            return;
        this._canRequestNextAd = false;
		this._subsequent = false;
        this.prefetchAd();
	},


    /**
	 * Displays a requested ad. If no ad has been previously requested, this
     * method will not do anything.
     *
	 * @public
	 */
	displayAd: function() {
		AdViewInternal.prototype.displayAd.apply(this, arguments);
	},
    
    /**
	 * Requests and displays a requested ad as soon as it is finished
     * loading.
     *
	 * @public
	 */
	requestAndDisplayAd: function() {
        if (!this._canRequestNextAd)
            return;
        this._canRequestNextAd = false;
        this.getAd();
	},
    
    /**
	 * Returns if the FullScreenAdView has an ad prepared for display.
     *
     * @return	{bool}	If true, the FullScreenAdView is ready to display an
     * ad via the displayAd method.
	 * @public
	 */
    hasAd: function() {
        return this._hasPrefetchedAd;
    },

	/**
	 * Cancels any ads currently load and calls pauseAdRefresh
	 *
	 * This should be called in viewDidUnload/dealloc
	 * @public
	 */
	cancelAd: function() {
		this._cancelAd();
	},
});

/**
 * @class
 * Use this class to create a full screen adview.
 * @name Mobclix.AdView_FullScreen
 * @extends Mobclix.FullScreenAdView
 * @public
 */
exports.AdView_FullScreen = FullScreenAdView.subclass({
	_size: {
		width: 999,
		height: 999
	}
});; return exports;};
(function()
{
	if(!Function.prototype.hasOwnProperty('bind'))
	{
		var slice = Array.prototype.slice;
		Function.prototype.bind = function(context)
		{
			var func = this;
			if(arguments.length > 1)
			{
				var args = slice.call(arguments, 1);
				return function()
				{
					if(arguments.length)
					{
						var finalArgs = args.concat(slice.call(arguments));
						return func.apply(context, finalArgs);
					}
					else
					{
						return func.apply(context, args);
					}
				}
			}
			else
			{
				return function()
				{
					if(arguments.length)
						return func.apply(context, arguments);
					else
						return func.call(context);
				}
			}
		}
	}
})();

(function()
{
	if(!Array.prototype.hasOwnProperty('indexOf'))
	{
		Array.prototype.indexOf = function(obj)
		{
			var len = this.length;
			for(var i=0; i < this.length; ++i)
			{
				if(obj === this[i])
					return i;
			}
			return -1;
		}
	}
})();

(function()
{
	if (typeof(console) == 'undefined') { 
		console = { log: function(str) {} };
	}
})();

function userGameInit()
{
	console.log("ngCore calling main()");
	main();
}
//////////////////////////////////////////////////////////////////////////////
/** 
 *  @date:      2010-11-0?
 *  @file:      NgWebEngine.js
 *  Website:    http://www.ngmoco.com/
 *  Copyright:  2010, by ngmoco:)
 *              Unauthorized redistribution of source code is 
 *              strictly prohibited. Violators will be prosecuted.
 * 
 *  @brief:
 */
//////////////////////////////////////////////////////////////////////////////
var NGSetTimeoutRunTimers = require('NGCore/Client/UI/NGJSEnvironmentSupport').NGSetTimeoutRunTimers;
var SystemBinding = require('NGCore/Client/UI/SystemBinding').SystemBinding;
var UI = require('NGCore/Client/UI').UI;
var AlertDialog = UI.AlertDialog;
var ProgressDialog = UI.ProgressDialog;
var Downloader = require('NGCore/Client/Network/DownloadManifest').Downloader;
var LocalGameList = require('NGCore/Client/Core/LocalGameList').LocalGameList;
var Device = require('NGCore/Client/Device').Device;
var Core = require('NGCore/Client/Core').Core;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Localization = require('NGCore/Client/Core/Localization').Localization;

// Global until oauth does not depend on storage.
Storage = require('NGCore/Client/Storage').Storage;

//////////////////////////////////////////////////////////////////////////////////////////////////
// App switching.

var NgProcID =
{
    PersistProc: -1,
    GameProc: -2
};

//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */

var gNgShutdownPending = false;


/////////////////////////////////////////////////////////////////////////////////////////////////
// Global data.
//////////////////////////////////////////////////////////////////////////////////////////////////

var gNgEngineEntities;
var gNgAddedEngineEntities;
var gNgRemovedEngineEntities;

var gNgUpdateEngineEntities;
var gNgTouchEngineEntities;
var gNgKeyPressEngineEntities;

//////////////////////////////////////////////////////////////////////////////////////////////////
// This function is called once by the html container to initialize the game.
//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */

function NgEngineInitPrivate()
{
	NgLogInit();

	NgApplication.getInstance().restart();

	gNgEngineEntities = new Array();
	gNgAddedEngineEntities = new Array();
	gNgRemovedEngineEntities = new Array();

	gNgUpdateEngineEntities = new Array();
	gNgTouchEngineEntities = new Array();
    gNgKeyPressEngineEntities = new Array();

	Core.Analytics.instantiate();
}

//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */

function NgEngineProcessEntityAddRemove()
{
	for(var i in gNgAddedEngineEntities)
	{
		var e = gNgAddedEngineEntities[i];
		if(e.mIsTouchable) NgInsertSortedTouch(e);
		if(e.mIsKeyable)	NgInsertSortedKeyPress(e);
		if(e.mIsUpdatable) gNgUpdateEngineEntities[e.mId] = e;
	}
	gNgAddedEngineEntities = [];

	for(var i in gNgRemovedEngineEntities)
	{
		var e = gNgRemovedEngineEntities[i];

		if(e.mIsTouchable)	gNgTouchEngineEntities.splice(NgFindIndex(gNgTouchEngineEntities,e),1);
		if(e.mIsKeyable) gNgKeyPressEngineEntities.splice(NgFindIndex(gNgKeyPressEngineEntities,e),1);
		if(e.mIsUpdatable) delete gNgUpdateEngineEntities[e.mId];
	}
	gNgRemovedEngineEntities = [];
}

/**
  * @private
  */

function NgHandleException(ex)
{
	if (Core.Proc.isPrivileged()) {
		NgLogException( ex );
	}
	else {
		var exStr = JSON.stringify(ex);
		NgLogException( ex );
		Core.LocalGameList._forwardException(exStr);
	}
}

function NgEngineInit(inputs)
{
	NgLogD("NgEngineInit beg");
	try
	{
		NgEngineInitPrivate();

		time.setCtr('frame',1000,NgLogD);

		//NgLogD("Initializing Storage");
		//Storage.init();
		//NgLogD("Storage initialized");
		NgLogD("KeyValue Storage initializing...");
		Storage.KeyValueCache.init();
		NgLogD("KeyValue Storage initialized...");
	
		Core.Time.instantiate();
	
		NgLogD("Instantiate the Localization context (singleton), depends on Capabilities");
		Localization.instantiate();

	}
	catch( ex )
	{
		NgHandleException(ex);
	}
	NgLogD("NgEngineInit end");	
	
	return NgEngineUpdate(inputs);
}

function NgPreInit(inputs)
{
	NgLogD("Localization NgPreInit beg");
	return update(inputs);
}

/**
  * @private
  */

function NgGameInit(inputs)
{
	NgLogD("NgGameInit beg");
	try
	{
		NGWindow = UI.Window;

		userGameInit();
	}
	catch( ex )
	{
		NgHandleException(ex);
	}
	NgLogD("NgGameInit end");

	return update(inputs);
}

/**
  * @private
  */

// TEMPORARY: Until native code is updated to call NgEngineUpdate.
function update ( inputs )
{
	return NgEngineUpdate ( inputs );
}

//Frame loop calls this every time, get the object out of require once ahead of time.
var NGSetTimeoutRunTimers = require('NGCore/Client/UI/NGJSEnvironmentSupport').NGSetTimeoutRunTimers;

var setTimeoutOrig = setTimeout;
setTimeout  = function(fn, time)
{
	return setTimeoutOrig(function() 
	{
		try
		{
			fn();
		}
		catch( ex )
		{
			NgHandleException(ex);
		}
	}, time);
	
}


var setIntervalOrig = setInterval;
setInterval  = function(fn, time)
{
	return setIntervalOrig(function() 
	{
		try
		{
			fn();
		}
		catch( ex )
		{
			NgHandleException(ex);
		}
	}, time);
	
}



/**
  *	Main entry point for native to invoke JS.
  * @private
  */
var NgEngineUpdate = (function()
{
	var Core = require('NGCore/Client/Core').Core;
	
return function ( inputs )
{
	// time causes a racehorse-sized leak in v8. Only use this for single profiling runs. DO NOT CHECK IN.
//	time.stop('frame');
//	time.start('frame');
	
	try {
		NGSetTimeoutRunTimers();

		if(inputs.length)
		{
			NgEngineProcessEntityAddRemove();
			var commands = inputs.split(':');
			for(var i=0; i<commands.length; ++i)
			{
				command = commands[i];

				// Make sure this isn't an empty input.
				if(0 == command.length) {
					continue;
				}

				switch(parseInt(command))
				{
					case NgEntityTypes.App:
						NgApplication.getInstance().handleCommand(command);
						break;
					case NgEntityTypes.NgFileSys:
						NgApplication.getInstance().getFileSys().handleCommand(command);
                        break;
					case NgEntityTypes.Storage:
						NgLogD("Command for storage is " + command);
						Storage.getInstanceForCommand(command).handleCommand(command);
						break;
					case NgEntityTypes.NgUI:
						NGWindow.handleCommand(command);
						break;
					case NgEntityTypes.NgSystemBinding:
						SystemBinding.handleCommand(command);
						break;
					case 3117:
						console.log('got leet response');
						if(typeof(_WifiDiagCallback) != 'undefined')
							_WifiDiagCallback(command);
						break;
					default:
						Core.Proc._classRecvGen( command.split( ',' ) );
						break;
				}
			}
		}

		if( gNgShutdownPending )
		{
			gNgShutdownPending = false;
		}
		else	// Don't do updates if we're resetting.
		{
			NgEngineProcessEntityAddRemove();
			for(var i in gNgUpdateEngineEntities)
			{
				var entity = gNgUpdateEngineEntities[i];
				if(!entity.mRegistered) continue;
				entity.onUpdate();
			}
		}
	}
	catch(ex)
	{
		NgHandleException(ex);
	}
		
	var tmp = Core.Proc.getCommandString() + gNgCommandString;
	gNgCommandString = tmp;
	Core.Proc.clearCommandString();

	return NgFlushCommandsToString();
}
})();


//////////////////////////////////////////////////////////////////////////////////////////////////
////	NgApplication class
//////////////////////////////////////////////////////////////////////////////////////////////////

var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Logger = require('NGCore/Client/Core/Logger').Logger;

/** @private */

var NgApplicationCommands = {
	Caps : 0,
	Debug : 1,
	FrameTime : 2,
	FrameRate : 3,
	Start : 4,
	DeviceOrientation: 10,
	SetOrientation: 11,
	BackPress: 12,
	OnBackPressed: 13,
	LaunchExternalNativeApp: 15,
	ExitSystemProcess: 16
};

/**
  * Enumeration values for orientation change events received by
  * {@link NgApplicationObserver}.
  */

var NgApplicationOrientation = {
	Portrait : 0,
	PortraitUpsideDown : 1,
	LandscapeLeft : 2,
	LandscapeRight : 3,
	FaceUp : 4,
	FaceDown : 5
};

/**
  * The NgApplication constructor is invoked during application bootstrap and
  * should not be created by the ngGame application.  Access to the application
  * object should be through the singleton accessor {@link NgApplication#getInstance}.
  * @constructor
  *
  * @class
  * The NgApplication class represents global state and services that are available to
  * ngGame applications.  This includes file system operations,
  * download services, etc.  The application class also manages a time source
  * that is synchronized between the native engine and the ngGame application. <br>
  * The application object is a singleton and should only be accessed through the
  * {@link NgApplication#getInstance} method.
  */

function NgApplication()
{
	/** @private */
	this.mFileSys = Storage.FileSystem;
	/** @private */
	this.mFrameTime = 0.0;
	/** @private */
	this.mObservers = [];
}

// Singleton instance.
/** @private */
NgApplication.sInstance = null;

/**
  * Acquire the singleton instance of the application class.
  * @type NgApplication
  * @return The global application object.
  */

NgApplication.getInstance = function()
{
	if( NgApplication.sInstance == null )
		NgApplication.sInstance = new NgApplication();

	return NgApplication.sInstance;
};

// APITODO: Switch these methods to be defined out-of-line, not by an object literal.

NgApplication.prototype =
{
	mFileSys : null,
	mObservers : [],
	mFrameTime : 0.0,
	
	/** @private */
	restart : function()
	{
	},
	
	/** @private */
	handleCommand : function(command)
	{
		//		NgLogD( "NgApplication command = " + command );

		var commandId = NgPeekCommandId( command );

		switch( commandId )
		{
			case NgApplicationCommands.FrameTime:
				this.parseFrameTime( command );
				break;
			case NgApplicationCommands.Start:
				this.onApplicationStart();
				break;
			case NgApplicationCommands.OnBackPressed:
				this.onApplicationBackPressed();
				break;
			default:
				NgLogE( "NgApplication command unknown: " + command);
				break;
		}
	},
	
	/**
	  * Acquire the file system object.
	  * @type NgFileSys
	  * @return The file system instance.
	  */
	getFileSys : function()
	{
		return this.mFileSys;
	},

	/** @private */
	ngLog : function( level, dbgStr )
	{
		NgPushCommand4( NgEntityTypes.App, NgApplicationCommands.Debug, Core.Base64.encode( dbgStr ), level );
	},
	
	/** @private */
	parseFrameTime : function( command )
	{
		var fields = NgParseCommand2(command,parseInt,parseFloat);
		var frameTime = fields[1];

		if(this.mFrameDelta == undefined)
			this.mFrameDelta = 0;
		else
			this.mFrameDelta = frameTime - this.mFrameTime;

		this.mFrameTime = frameTime;
	},
	
	/**
	  * Get the application time for the current frame.
	  * @type number
	  * @return The time in milliseconds.
	  */
	getFrameTime : function()
	{
		return this.mFrameTime;
	},
	
	/**
	  * Get the application time delta between the current frame and the last frame.
	  * @type number
	  * @return The time delta in milliseconds.
	  */
	getFrameDelta : function()
	{
		return this.mFrameDelta;
	},

	/**
	  * Set the desired application frame rate. <br>
	  * Note: The frame rate specification is not currently fully functional on all 
	  * platforms.
	  * @param {number} frameRate The desired frame rate in hz.
	  * @type void
	  */
	setFrameRate : function(frameRate)
	{
		NgPushCommand3( NgEntityTypes.App, NgApplicationCommands.FrameRate, frameRate);
	},

	/**
	  * Set the current device orientation for the application. <br>
	  * Note: Setting the orientation is not currently fully functional on all
	  * platforms.
	  * @param {NgApplicationOrientation} orientation The desired orientation.
	  * @type void
	  */
	setOrientation : function(orientation)
	{
		NgPushCommand3( NgEntityTypes.App, NgApplicationCommands.SetOrientation, orientation);
	},

	/**
	  * Register an application observer to receive application callbacks.
	  * @param {NgApplicationObserver} obs The observer to register.
	  * @type void
	  */
	registerObserver : function(obs)
	{
		obs.index = this.mObservers.push(obs);
	},

	unregisterObserver : function(obs)
	{
		if (obs.index)
			delete this.mObservers[obs.index - 1];
	},

	/** @private */
	onApplicationStart : function()
	{
		NgUI.onLoad();
		for (i in this.mObservers)
		{
			// TODO is this even possible?
			this.mObservers[i].onApplicationStart();
		}
	},
	
	/** @private */
	onApplicationReceivedCustomMessage : function( message )
	{
		for (i in this.mObservers)
		{
			this.mObservers[i].onApplicationReceivedCustomMessage( message );
		}
	},
	
	/** @private */
	onApplicationBackPressed : function()
	{
			var observerResult = false;
			for (i in this.mObservers)
			{
				 if (this.mObservers[i].onApplicationBackPressed())
				 {
					observerResult = true;
					break;
				 }
			}
			if (!observerResult)
			{
				// back button was not fully handled. Ask the native application to handle it.
				NgPushCommand2(NgEntityTypes.App, NgApplicationCommands.BackPress);
			}
	},
	
	/** @private */
	exitSystemProcess : function ()
	{
		NgLogD ( "pushing exit command" );
		//This makes java exit the app through android lifecycle
		NgPushCommand2(NgEntityTypes.App, NgApplicationCommands.BackPress);
		NgLogD ( "pushed exit command" );
	}
};

// Observer base class for application events.

/**
  * Initialize a new application observer.
  * @constructor
  *
  * @class
  * The NgApplicationObserver class is used as the base class for any user-defined
  * class that receives application-level callbacks.  This currently includes
  * notifications on all application lifecycle events and device orientation
  * changes. <br>
  * Register the application observer by calling {@link NgApplication#registerObserver}.
  */

function NgApplicationObserver() {}

NgApplicationObserver.prototype =
{
	index: 0,
	/**
	  * Callback for application lifecycle start event.
	  * @type void
	  */
	onApplicationStart:function() {},

	/** @private */
	onApplicationReceivedCustomMessage:function( message ) {},

	/**
	  * Callback for device orientation change events.
	  * @param {NgApplicationOrientation} orientation Orientation enumeration value.
	  * @type void
	  */
	onApplicationDeviceOrientation:function( orientation ) {},

	/*
	 * Listener for when the user pushes the HW back button. Currently Android only.
	 *
	 * @return boolean true if back was handled entirely (eat the event), 
	 * false if it was not
	 *
	 */
	onApplicationBackPressed:function()
	{
		return false;
	}
};

//////////////////////////////////////////////////////////////////////////////////////////////////
// class Entity
// Base class for other entity types.
//////////////////////////////////////////////////////////////////////////////////////////////////

// ObjectTypes
// Defined in
//		JS:  NgEntityTypes in NgWebEngine.js and
//		C++: EntityCommandIds in GameView.h
// 1 = App
// 2 = NgTouchEvent
// 3 = NgKeyPressEvent
// 4 = Accel
// 5 = NgTextInputBox2D
// 6 = Animation (completion events)
// 7 = Sound (completion events)
// 8 = EngineEntity
// 9 = DrawableEntity2D
// 10 = NgCanvas2D
// 11 = NgCamera2D
// 12 = NgSprite2D
// 13 = NgText2D
// 14 = NgWebView2D
// 15 = NgAudioManager
// 16 = NgGroup2D
// 100 = LoadApp

// App Commands
// in:
// capabilities = 0, command dictionary format
// frameTime = 2, double
// out:
// NgLogD = 1, string

// NgTouchEvent Commands
// non-native
//	action: 1 = add, 2 = remove, 3 = modify
//	id: touch instance ID
//	x: x position
//	y: y position
// native
//	action: 4 = add, 5 = remove, 6 = modify
//	id: touch instance ID
//	x: x pos
//	y: y pos
//  eid: entity instance ID
//	lx: local x pos
//  ly: local y pos

// NgKeyPressEvent Commands
// action: 1 = down, 2 = up
// id: instance ID
// value: key value

// InputText Box Commands

// Animation
// in:
// only one kind of event, so first value is id of sprite to callback.

// Sound
// in:
//

// Accel Commands
// out:
// SetEventRate = 0, rate (hz)
// in:
// x, y, z position (floats)

// EngineEntity commands

// DrawableEntity2D commands:
// SetNativeTouchType=1,id,value (None=1, Enable = 2, EnableBounds = 3)

// NgCanvas2D Commands
// NewNgCanvas2D=1, id
// DeleteNgCanvas2D=2, id
// Update=3, id, args... not used currently
// SetRoot=4, id, grp id
// ClearRoot=5, id
// EnableNativePicking=6, id, bool

// NgCamera2D Commands
// NewNgCamera2D=1,		id, canvasId, porperties
// DeleteNgCamera2D=2,	id
// UpdateNgCamera2D=3,	id, properties
//	Properties: vx, vy, vz, vh, vw, cx, cy, ch, cw

// NgSprite2D Commands
// NewNgSprite2D=1,		id, canvasId, texture, properties
// DeleteNgSprite2D=2,	id
// UpdateNgSprite2D=3,	id, properties
//   Properties: x, y, z, w, h, r, a

// NgText2D Operations
// NewNgText2D=1		id, canvasId, properties
// DeleteNgText2D=2	id
// UpdateNgText2D=3	id, properties
//  Properties: x, y, z, w, h, justify, text

// NgGroup2D Operations
// New = 1			id, canvasId, [properties/todo]
// Delete = 2		id
// Update = 3		id, [properties/todo]
// Child = 4		id, subcmd, [child id]
//						subcmd 0 = add, 1 = rem, 2 = remAll (no child id)
// Rot = 5			id, anglef
// Pos = 6			id, xf, yf, zf
// Alpha = 7		id, alphaf
// Scale = 8		id, xf, yf

// APITODO: Clean up these identifiers.
// APITODO: Sound is probably not used any more.
// APITODO: Animation is probably not used any more.

var NgEntityTypes = {
	App : 1,
	NgTouchEvent : 2,
	NgKeyPressEvent : 3,
	Accel : 4,
	NgTextInputBox2D : 5,
	Animation : 6,
	Sound : 7,
	NgEngineEntity : 8,
	NgDrawableEntity2D : 9,
	NgCanvas2D : 10,
	NgCamera2D : 11,
	NgSprite2D : 12,
	NgText2D : 13,
	NgWebView2D : 14,
	NgGroup2D : 16,
	NgPhysics2D: 17,
	NgPrimitive2D: 18,
	NgFileSys: 19,
	Gyro : 22,
	NgUI : 23,
	Storage: 24,
	NgSystemBinding: 25,
	NgCustomMessage : 50,
	LoadApp : 100
};

var NgEngineEntityCommandIDs = {
	SetNativeTouchType : 1
};

/**
 * Initializes instance to default values. <br>
 * mId member defaults to 0 but can be set by application before calling {@link NgEngineEntity#register}.
 * @constructor
 *
 * @class
 * NgEngineEntity is the base class for all game entities, such as NgSprite2D and NgText2D. <br>
 * This class introduces key callback functions for touch, key press and per-frame update
 * notification. <br>
 * Additionally, the class introduces a register/unregister mechanism
 * for controlling the existence of the entity in the native game engine.
 *
 */

function NgEngineEntity()
{
	/** The entity id.  Used by the native engine for identification.  @type number */
	this.mId = 0;
	/** The touch priority.  Touches are routed first to the highest priority entities.  @type number */
	this.mTouchPriority = 0;
	/** The key press priority.  Key presses are routed first to the highest priority entities.  @type number */
	this.mKeyPressPriority = 0;
	/** @private */
	this.mIsTouchable = false;
	/** @private */
	this.mIsKeyable = false;
	/** @private */
	this.mIsUpdatable = false;
	/** @private */
	this.mNativeTouchType = NgEngineEntity.NativeTouchType.Enable;
	/** @private */
	this.mRegistered = false;
}

// Static methods and data.

/**
  * NgEngineEntity touch policy enumeration. <br>
  * Used with {@link NgEngineEntity#setNativeTouchType} and {@link NgCanvas2D#enableNativePicking}. <br>
  * Values: <br>
  * None : Disables native touches for this entity (and its children). <br>
  * Enable : Enables this entity to receive touches (or visits child entities) <br>
  * EnableBounds : Enables this entity to receive touches on its axis-aligned bounding box.  If
  * a touch is received on a group, it will report the touch and _not_ visit the group's children.
  */

NgEngineEntity.NativeTouchType = {
	None : 0,
	Enable : 1,
	EnableBounds : 2
};

/**
  * @private
  */

NgEngineEntity.engineCurrentId = 1;

/**
  * Allocate a unique ID for an entity.
  * @return ID value.
  * @type number
  * @private
  */

NgEngineEntity.newEngineId = function ()
{
	return NgEngineEntity.engineCurrentId++;
}

/**
  * Reclaim an entity ID.
  * @private
  */

NgEngineEntity.deleteEngineId = function ()
{
	// Nothing.
}

// Instance methods.

// Basic entity callbacks.

/** @private */

NgEngineEntity.prototype.newEntity = function() {}

/** @private */

NgEngineEntity.prototype.deleteEntity = function() {}

/**
  *	Callback for standard touch events. <br>
  * Standard touch events correspond to all touches
  * within the game view.  For each touch on the game view, all registered touchable
  * entities will receive the event.  Application logic must perform filtering to determine
  * if a particular entity corresponds to the touch event. <br>
  * Refer to {@link NgEngineEntity#toggleTouchable} for control of an entity's touchable state.
  * @param {NgTouchEvent} touch The touch event.
  * @return The application can return true to indicate that it has consumed this event or false
  * to allow other entities to continue processing this event.
  * @type bool
  */

NgEngineEntity.prototype.onTouch = function(touch)
{
	return false;
}

/**
  * Callback for native touch events. <br>
  * Native touch events are pre-filtered by the game engine
  * to correspond to a specific touchable entity.  For each touch on the game view, the game
  * engine will determine which game entities are selected by the touch event.  Only the 
  * selected entities will receive the onNativeTouch event callback. <br>
  * Native touch capability is not affected by touchable state of the entity determined by
  * {@link NgEngineEntity#toggleTouchable}.  Refer to {@link NgEngineEntity#setNativeTouchType} 
  * for management of an entity's native touch policy.
  * @param {NgNativeTouchEvent} touch The touch event.
  * @return The application can return true to indicate that it has consumed this event or false
  * to allow other entities to continue processing this event.
  * @type bool
  */

NgEngineEntity.prototype.onNativeTouch = function(touch)
{

}

/**
  * Callback for keyboard events. <br>These events correspond to physical or software keyboard events. <br>
  * Enable/disable key press events for an entity with {@link NgEngineEntity#toggleKeyable}.
  * @param {NgKeyPressEvent} keyPress The key press event.
  * @return The application can return true to indicate that it has consumed this event or false
  * to allow other entities to continue processing this event.
  * @type bool
  */

NgEngineEntity.prototype.onKeyPress = function(keyPress)
{
	return false;
}

/**
  *	Callback for update events. <br>Per-frame entity logic should be implemented in this callback. <br>
  * Enable/disable update events for an entity with {@link NgEngineEntity#toggleUpdatable}.
  * The return value of this method is ignored.
  * @type void
  */

NgEngineEntity.prototype.onUpdate = function()
{
}

/**
  *	Register this entity instance with the native game engine. <br>
  * The initialization sequence of engine entities has specific constraints: <br>
  * After construction and before calling
  * the register method, class methods that affect the native engine state cannot be called.  
  * During this period, changes to entity state by changing instance variables will be
  * sent to the native engine on the call to register. <br>
  * After register is called, 
  * changes to instance variables will be ignored.  During this phase, the only
  * way to affect native engine state is through methods that push commands to
  * the native side.
  * @type void
  */

NgEngineEntity.prototype.register = function()
{
	this.mParents = new Array();

	if( this.mId >= 0 )
	{
		this.mId = NgEngineEntity.newEngineId();
	}

	this.mRegistered = true;
	gNgEngineEntities[this.mId] = this;
	gNgAddedEngineEntities[this.mId] = this;
	this.newEntity();
}

/**
  * Unregister this entity from the native game engine.
  * @type void
  */

NgEngineEntity.prototype.unregister = function()
{
	var parents = this.mParents.concat(new Array());

	for (var i in parents)
	{
		NgLogD ( "Removing child " + this.mId + " from parent Group " + parents[i].mId + " because the Entity was unregistered");
		parents[i].removeChild( this );
	}

	this.mRegistered = false;
	delete gNgEngineEntities[this.mId];
	// CAUTION : DO NOT SPLICE gNgEngineEntities EVER.
	//gNgEngineEntities.splice(this.mId,1);

	gNgRemovedEngineEntities[this.mId] = this;
	this.deleteEntity();

	if(this.mId >= 0)
		NgEngineEntity.deleteEngineId(this.mId);
}

/**
  * Enable/disable key press callbacks for this entity. <br>This method flips the enable state
  * for key press events. <br>
  * In order to receive key press callbacks, an entity
  * must override the onKeyPress event and enable keyable state by calling this 
  * method. <br>
  * The default state is false.
  * @type void
  */

NgEngineEntity.prototype.toggleKeyable = function()
{
	if(this.mIsKeyable)
		gNgKeyPressEngineEntities.splice(NgFindIndex(gNgKeyPressEngineEntities,this),1);
	else
		NgInsertSortedKeyPress(this);

	this.mIsKeyable = !this.mIsKeyable;
}

/**
  * Enable/disable update callbacks for this entity. <br>
  * This method flips the enable state
  * for update events. <br>
  * In order to receive update callbacks, an entity
  * must override the onUpdate event and enable updatable state by calling this 
  * method. <br>
  * The default state is false.
  * @type void
  */

NgEngineEntity.prototype.toggleUpdatable = function()
{
	if(this.mIsUpdatable)
	{
		delete gNgUpdateEngineEntities[this.mId];
	}
	else
	{
		gNgUpdateEngineEntities[this.mId] = this;
	}
	this.mIsUpdatable = !this.mIsUpdatable;
}

/**
  * Enable/disable touch callbacks for this entity. <br>
  * This method flips the enable state for touch events. <br>
  * In order to receive touch callbacks, an entity
  * must override the onTouch event and enable touchable state by calling this 
  * method. <br>
  * The default state is false.
  * @type void
  */

NgEngineEntity.prototype.toggleTouchable = function()
{
	if(this.mIsTouchable)
		gNgTouchEngineEntities.splice(NgFindIndex(gNgTouchEngineEntities,this),1);
	else
		NgInsertSortedTouch(this);

	this.mIsTouchable = !this.mIsTouchable;
}

/**
  * Set native touch traversal policy. <br>
  * This method controls how the native game engine
  * traverses the game scene graph. <br>
  * The policies are described in further detail with {@link NgEngineEntity#NativeTouchType}. <br>
  * The default state is "Enable".
  * @param {NativeTouchType} type The policy enum for native touch processing.
  * @type void
  */

NgEngineEntity.prototype.setNativeTouchType = function( type )
{
	this.mNativeTouchType = type;
	NgPushCommand4(NgEntityTypes.NgDrawableEntity2D, NgEngineEntityCommandIDs.SetNativeTouchType, this.mId, this.mNativeTouchType );
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
var Core = require('NGCore/Client/Core').Core;

// These methods handle all composition for commands being sent back to the
// native engine.

/**
  * @private
  */

var gNgCommandStrings = [];

/**
  * @private
  */

var gNgCommandString = '';

// 0 deferred string composition via user loop
// 1 deferred string composition via internal loop
// 2 on-the-fly string composition.

// TODO: Benchmark all variation on all platforms.  Choose appropriate one(s)
// and prune code for others.

// UPDATE: ALL variations on contructing a string performed IDENTICALLY in
// the iPhone's UIWebView.  Unbelievable.

/**
  * @private
  */

var gNgCommandMode = 2;

/**
  * @private
  */

function NgQueueCommandText(command)
{
	switch(gNgCommandMode)
	{
		case 0:
		case 1:
			gNgCommandStrings.push( command );
			break;
		case 2:
			gNgCommandString += command;
			break;
	}
}

/**
  * @private
  */

function NgFlushCommandsToString()
{
	var outputString = '';
	
	switch(gNgCommandMode)
	{	
		case 0:
			for( var num = 0, end = gNgCommandStrings.length; num < end; ++num )
			{
				outputString += gNgCommandStrings[ num ];
			}
			break;
			
		case 1:
			outputString = String.prototype.concat.apply(gNgCommandStrings);
			break;
	}
	
	switch(gNgCommandMode)
	{
		case 0:
		case 1:
			gNgCommandStrings = [];
			break;
		case 2:
			outputString = gNgCommandString;
			gNgCommandString = '';
			break;
	}
	
	return outputString;	
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

function NgParseString(txt)
{
	return txt;
}

/**
  * @private
  */

function NgParseBase64(txt)
{
	if( txt )
		return Core.Base64.decode(txt);
	else
		return "";
}

/**
  * @private
  */

function NgParseBool(txt)
{
	return parseInt(txt) ? true : false;
}

function NgParseInt(txt)
{
	return parseInt(txt, 10);
}

function NgKVArrayToCmd(kvArray)
{
	var out = "";
	var count = 0
	for (var s in kvArray)
	{
		var value = kvArray[s];
		
		out += "," + s + "," + Core.Base64.encode(value);
		++count;
	}
	return count + out;
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

/**
 * Submit a command with 1 argument to the native engine.
 * @private
 */
function NgPushCommand1(arg1)
{
	gNgCommandString += ":" + arg1;
}

/**
 * Submit a command with 2 arguments to the native engine.
 * @private
 */
function NgPushCommand2(arg1, arg2)
{
	gNgCommandString += ":" + arg1 + "," + arg2;
}

/**
 * Submit a command with 3 arguments to the native engine.
 * @private
 */
function NgPushCommand3(arg1, arg2, arg3)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3;
}

/**
 * Submit a command with 4 arguments to the native engine.
 * @private
 */
function NgPushCommand4(arg1, arg2, arg3, arg4)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4;
}

/**
 * Submit a command with 5 arguments to the native engine.
 * @private
 */
function NgPushCommand5(arg1, arg2, arg3, arg4, arg5)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5;
}

/**
 * Submit a command with 6 arguments to the native engine.
 * @private
 */
function NgPushCommand6(arg1, arg2, arg3, arg4, arg5, arg6)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6;
}

/**
 * Submit a command with 7 arguments to the native engine.
 * @private
 */
function NgPushCommand7(arg1, arg2, arg3, arg4, arg5, arg6, arg7)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6 + "," + arg7;
}

/**
 * Submit a command with 8 arguments to the native engine.
 * @private
 */
function NgPushCommand8(arg1, arg2, arg3, arg4, arg5, arg6, arg7,arg8)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6 + "," + arg7 + "," + arg8;
}

/**
 * Submit a command with 8 arguments to the native engine.
 * @private
 */
function NgPushCommand9(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6 + "," + arg7 + "," + arg8 + "," + arg9;
}

/**
 * Submit a command with n arguments to the native engine.
 * @private
 */
function NgPushCommandN()
{
	var argv = arguments;
	var argc = argv.length;
	
	var tmp = ":";
	
	if( argc > 0 )
	{
		tmp += argv[ 0 ];
		
		for( var num = 1; num < argc; ++num )
		{
			tmp += "," + argv[ num ];
		}
	}
	
	gNgCommandString += tmp;
}

/**
 * Peek at the command ID in a command string.  This helps avoid 
 * splitting the string twice in a number of cases.
 * @return Command id or null if parsing failed.
 * @private
 */

function NgPeekCommandId(str)
{
	var vals = str.split ( ",", 2 );
	if( vals.length == 2 )
		return parseInt ( vals[ 1 ] );
	else
		return null;
}

/**
 * Peek at the class and command ID in a command string.  This helps avoid 
 * splitting the string twice in a number of cases.
 * @return Two-element array of ids or null if parsing failed.
 * @private
 */

function NgPeekClassAndCommandId(str)
{
	var vals = str.split ( ",", 2 );
	if( vals.length == 2 )
	{
		vals[ 0 ] = parseInt ( vals[ 0 ] );
		vals[ 1 ] = parseInt ( vals[ 1 ] );
		return vals;
	}
	else
		return null;
}


/**
 * Parse an incoming command string to individual strings.
 * @return an array of fields in serialization order.
 * @private
 */
function NgParseCommandToStrings(src)
{
	return src.split(",");
}

/**
  * @private
  */

function NgParseCommand1(src, func1)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand2(src, func1, func2)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand3(src, func1, func2, func3)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	ret[ 2 ] = func3( fields[ 3 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand4(src, func1, func2, func3, func4)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	ret[ 2 ] = func3( fields[ 3 ] );
	ret[ 3 ] = func4( fields[ 4 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand5(src, func1, func2, func3, func4, func5)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	ret[ 2 ] = func3( fields[ 3 ] );
	ret[ 3 ] = func4( fields[ 4 ] );
	ret[ 4 ] = func5( fields[ 5 ] );
	
	return ret;
}


/**
 * Parse an incoming command string to typed values based on passed-in functions.
 * ex: NgParseCommandN("1:1,1.0,ACFHENA==",parseInt, parseFloat, NgParseString);
 * NOTE: The first item is assumed to be the command type, and will be
 * discarded in the output.  I.e., the output starts with the second src element.
 * @return an array of parsed fields in serialization order.
 * @private
 */

function NgParseCommandN(src)
{
	var ret = [];
	
	var argv = arguments;
	var argc = argv.length;
	
	var fields = src.split(",");
	for( var num = 1; num < argc; ++num )
	{
		ret[ num - 1 ] = argv[ num ]( fields[ num ] );
	}
	
	return ret;
}

/**
 * Parse an incoming typed dictionary.  The format of the dictionary is:
 * type,field name,value,type,field name,value[...]
 * Parsed values will be asigned to the field name in the dst array/object.
 * NOTE: Strings passed in this format must not have embedded commas (use
 * base64 encoding if arbitrary strings are being used.
 * @arg src The source command string.
 * @arg srcStart The field index to start parsing dictionary entries from.
 * @arg dst The destination object/array for parsed values.
 * @arg initialFields Optionally store the fields before srcStart in the passed-in array.
 * @return true if all fields were successfully parsed.
 * @private
 */

function NgParseCommandDictionary(src,srcStart,dst,initialFields)
{
	var ret = true;
	var fields = src.split(",");
	var end = fields.length;
	
	if(initialFields)
	{
		for( var num = 0; num < srcStart; ++num )
		{
			initialFields[ num ] = fields[ num ];
		}
	}
	
	for( var num = srcStart; num < end; )
	{
		var type = fields[ num++ ];
		var name = fields[ num++ ];
		var val = fields[ num++ ];
		var good = true;
		
		switch(type)
		{
			case 'i':	// int
				val = parseInt( val );
				break;
			case 'f':	// float
				val = parseFloat( val );
				break;
			case 's':	// string
				break;
			case 'S':	// base64 string
				val = Core.Base64.decode(val);
				break;
			case 'b':	// bool
				val = parseInt(val) ? true : false;
				break;
			default:
				//				NgLogD("NgParseCommandDictionary unknown type for " + type + " " + name + " " + val);
				ret = false;
				good = false;
				break;
		}
		
		if( good )
		{
			dst[ name ] = val;
			
			// TEMP PRW
			NgLogD( "dict: " + name + " : " + dst[ name ] );
		}
		else
		{
			NgLogD("dict: could not process " + type );
		}
	}
	
	return ret;
}
/**
  * @private
  */

var gNgTrace=null;

//////////////////////////////////////////////////////////////////////////////////////////////////
// Logging functions.
//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */
var NgDebugModes = {
	BrowserTrace : {},
	NgCommand : {},
	NgCommandDocLoc : {}
};

/**
  * @private
  */
var NgLogLevel = {
	Verbose : 5,
	Debug : 4,
	Info : 3,
	Warning : 2,
	Error : 1
};

/**
  * @private
  */
var NgLogStr = [ '', 'e', 'w', 'i', 'd', 'v'];


/**
  * @private
  */

// TEMP... this is not how we want to do this long-term.
function NgSetDebugDefaultDestination()
{
	if (typeof navigator == 'undefined')
	{
		return NgDebugModes.NgCommand;
	}

	var agent=navigator.userAgent.toLowerCase();
	if( ! ( (agent.indexOf('iphone') >=0) || (agent.indexOf('ipad') >= 0) ) )
	{
		return NgDebugModes.BrowserTrace;
	}
	else
	{
		return NgDebugModes.NgCommand;
	}
}

/**
  * @private
  */

var gNgDebugMode = NgSetDebugDefaultDestination();

/**
  * @private
  */

function NgLogInit()
{
	if( gNgDebugMode == NgDebugModes.BrowserTrace )
	{
		gNgTrace = document.getElementById("trace");
	}

	// Other modes don't need initialization.
}

function NgLogSetLevel(level)
{
	switch( level )
	{
		case NgLogLevel.Debug:
		{
			NgLogV = NgNoLog;
			NgLogD = NgDoDebugLog;
			NgLogI = NgDoInfoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		case NgLogLevel.Info:
		{
			NgLogV = NgNoLog;
			NgLogD = NgNoLog;
			NgLogI = NgDoInfoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		case NgLogLevel.Warning:
		{
			NgLogV = NgNoLog;
			NgLogD = NgNoLog;
			NgLogI = NgNoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		case NgLogLevel.Error:
		{
			NgLogV = NgNoLog;
			NgLogD = NgNoLog;
			NgLogI = NgNoLog;
			NgLogW = NgNoLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		default:
		case NgLogLevel.Verbose:
		{
			NgLogV = NgDoVerboseLog;
			NgLogD = NgDoDebugLog;
			NgLogI = NgDoInfoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;
	}
}

NgDoVerboseLog = function ( msg ) {
	NgLog(NgLogLevel.Verbose, msg);
}

NgDoDebugLog = function ( msg ) {
	NgLog(NgLogLevel.Debug, msg);
}

NgDoInfoLog = function ( msg ) {
	NgLog(NgLogLevel.Info, msg);
}

NgDoWarningLog = function ( msg ) {
	NgLog(NgLogLevel.Warning, msg);
}

NgDoErrorLog = function ( msg ) {
	NgLog(NgLogLevel.Error, msg);
}

NgNoLog = function() {};
NgLogSetLevel(NgLogLevel.Verbose);

var useConsole = ((typeof console != 'undefined') && (typeof console.log == 'function'));

function NgLog( level, msg )
{
	console.log(NgLogStr[level] + ": " + msg);
}

function NgLogException( ex )
{
    var str = "\nEXCEPTION:\n";

    for( var prop in ex )
    {
		str += "property: "+ prop+ " value: ["+ ex[prop]+ "]\n";
    }

    str += "toString(): " + " value: [" + ex.toString() + "]\n\n";

	NgLogD( str );
}
/*
 @author: Remy Sharp / http://remysharp.com
 @date: 2007-04-20
 @name: time
 @methods:
 start - start named timer
 stop - stop named timer
 event - hook predefined event
 func - hook existing function, or hook anonymous function (note refrence is passed back)
 report - output timings
 */
if ((typeof window == 'undefined') || (typeof window.time == 'undefined'))
{
	(function() {
		time = {
			// start + stop taken from firebuglite.js -
			// http://getfirebug.com/firebuglite
			start : function(name) {
				if (!name) {
					error('start: If starting a timer manually a name must be set');
				} else {
					timeMap[name] = (new Date()).getTime();
					if (name in NgRecordMap) {
					} else {
						NgRecordMap[name] = new NgRecord(name);
					}
				}
			},

			stop : function(name) {
				if (name in timeMap) {
					var stop = (new Date()).getTime();
					// var l = new Report(name, timeMap[name], stop);
					var l = NgRecordMap[name].addRecord(stop - timeMap[name]);
					log.push(l);
					if (NgRecordMap[name].records % NgRecordMap[name].ctr == 0) {
						NgRecordMap[name].lineReportMethod.call(this, l);
						NgRecordMap[name].records = 0;
						NgRecordMap[name].avg = 0;
						NgRecordMap[name].min = 55555;
						NgRecordMap[name].max = 0;
					}
					delete timeMap[name];
				} else {
					error('stop:' + name + ' not found');
				}
			},

			event : function(name, elm, type) {
				if (typeof name != 'string') {
					// name has not been passed in
					type = elm;
					elm = name;
					name = '';
				}

				if (!elm.length) {
					elm = [ elm ];
				}

				if (type.indexOf('on') == -1) {
					type = 'on' + type;
				}

				var i = elm.length;
				var timerN = null;
				var c = null;
				while (i--) {
					timerN = name;
					if (!timerN) {
						timerN = elm[i].id || elm[i].getAttribute('class')
								|| elm[i].getAttribute('className')
								|| elm[i].tagName;
					}

					mapEvent(elm[i], type, timerN);
				}
			},

			func : function(name, fn) {
				if (typeof name == 'function') {
					fn = name;
				}

				// get function name as this browser may not support fn.name (IE
				// + Safari + Opera)
				if (!fn.name && typeof fn == 'function') {
					var m = fn.toString().match(/function\s*(.*)\s*\(/);
					if (m[1]) {
						fn.name = m[1];
					}
				}

				if (typeof fn == 'function' && !fn.name) {
					// function is anonymous -
					// time function using var func = time.fn(function() { ...do
					// stuff });
					if (typeof name != 'string') {
						anonFuncId++;
						name = 'anonymous' + anonFuncId;
					}

					return function() {
						time.start(name);
						var ret = fn.apply(window, arguments);
						time.stop(name);
						return ret;
					};
				} else {
					var fnName = fn.name || fn;
					if (typeof name != 'string') {
						name = fnName;
					}

					eval('var fnCopy = ' + fnName);
					if (typeof fnCopy == 'function') {
						var wrap = function() {
							time.start(name);
							var ret = fnCopy.apply(this, arguments);
							time.stop(name);
							return ret;
						};
						wrap.hooked = true;
						eval(fnName + ' = wrap;');
						return eval(fnName);
					} else {
						// error hooking
						error('func: Could not hook function (name: ' + name + ')');
					}
				}
			},

			report : function(name) {
				if (typeof name == 'undefined') {
					reportMethod.call(this, log);
				} else {
					var i = log.length;
					var l = [];
					while (i--) {
						if (name == log[i].name) {
							l.push(log[i]);
						}
					}
					reportMethod.call(this, l);
				}
			},

			setReportMethod : function(fn) {
				if (fn.hooked) {
					error('setReportMethod: Cannot use hooked method ' + fn.name);
				} else {
					reportMethod = fn;
				}
			},

			setCtr : function(name, ctr, fn) {
				if (name in NgRecordMap) {
				} else
					NgRecordMap[name] = new NgRecord(name, ctr, fn);
			},

			setLineReportMethod : function(fn) {
				if (fn.hooked) {
					error('setLineReportMethod: Cannot use hooked method ' + fn.name);
				} else {
					lineReportMethod = fn;
					lineReport = true;
				}
			},

			errors : false
		};

		var timeMap = {};
		var NgRecordMap = {};
		var log = [];
		var reportMethod = defaultReport;
		var lineReport = false;
		var lineReportMethod = defaultLineReport;
		var anonFuncId = 0;

		var Report = function(n, s, e) {
			this.name = n;
			this.start = s;
			this.stop = e;
			this.delta = e - s;
			// useful if I could grab the call - but can't see how due to anon
			// functions (though I can see them in the start method)
		};

		Report.prototype.toString = function() {
			return this.name + ": " + this.delta + "ms";
		};

		function defaultReport(l) {
			alert(l.join("\n"));
		}

		function defaultLineReport(l) {
			alert(l);
		}

		function error(e) {
			if (time.errors)
				alert(e);
		}

		var NgRecord = function(name, ctr, fn) {
			this.name = name;
			this.records = 0;
			this.avg = 0;
			this.min = 555555;
			this.max = 0;
			this.ctr = ctr;
			if (fn.hooked) {
				error('setLineReportMethod: Cannot use hooked method. Will use default method' + fn.name);
				this.lineReportMethod = defaultLineReport;
			} else {
				this.lineReportMethod = fn;
			}

		}

		NgRecord.prototype.addRecord = function(delta) {
			this.avg = (this.avg * this.records + delta) / (this.records + 1);
			if (this.min > delta)
				this.min = delta;
			if (this.max < delta)
				this.max = delta;
			this.records++;
			frq = 1000 / this.avg;
			return this.name + '->  max:' + this.max + '  min:' + this.min
					+ '  avg:' + this.avg.toFixed(2) + '  freq:'
					+ frq.toFixed(2) + '\n';
		}

		// required to create a brand new instance of our copied function
		function mapEvent(e, t, n) {
			var c = e[t];
			if (typeof c == 'function') {
				e[t] = function() {
					time.start(n + ':' + t);
					var ret = c.apply(this, arguments);
					time.stop(n + ':' + t);
					return ret;
				};
			} else {
				error('event: Function must be set on element.' + t
						+ ' before hooking (name: ' + n + ')');
			}
		}
	})();
}

var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var UI = require('NGCore/Client/UI').UI;
var Storage = require('NGCore/Client/Storage').Storage;
var LayoutEmitter = require('NGCore/Client/Device/LayoutEmitter').LayoutEmitter;

var Vector2 = require('Code/util/Vector').Vector2;
var Level = require('Code/Level').Level;
var Ragdoll = require('Code/Ragdoll').Ragdoll;
var Target = require('Code/Target').Target;
var Cannon = require('Code/Cannon').Cannon;
var GameConstants = require('Code/GameConstants').GameConstants;
var LevelSelect = require('Code/LevelSelect').LevelSelect;
var SaveData = require('Code/util/SaveData').SaveData;
var KillScreen = require('Code/KillScreen').KillScreen;
var LeaderboardHandler = require('Code/util/Leaderboards').LeaderboardHandler;
var JSON = require('Code/util/json2').JSON;
var AdManager = require('Code/util/AdManager').AdManager;
var BFAudio = require('Code/util/BFAudio').BFAudio;
var Menu = require('Code/Menu').Menu;
if(GameConstants.ENABLE_FPS)
{
	var FPS = require('Code/util/FPS').FPS;
}
if(GameConstants.ENABLE_TTV)
{
	var TouchTargetVisualizer = require('Code/util/TouchTargetVisualizer').TouchTargetVisualizer;
}

var lvl;
var level_select;
var msg_listener;
var killScreen;
var ad_manager;
var currentLevelNo;
var levelsCompletedThisSession;
var menu;
var splash_screen;
var rate_dialog

function main(){
	var glView = new UI.GLView();
	Device.OrientationEmitter.setInterfaceOrientation(Device.OrientationEmitter.Orientation.LandscapeLeft, false);
	// SUPER MEGA HACK INCOMING!
	GameConstants.SCREEN_HEIGHT = Math.max(UI.Window.getHeight(), UI.Window.getWidth());
	GameConstants.SCREEN_WIDTH = Math.min(UI.Window.getWidth(), UI.Window.getHeight());
	console.log("\n\n\n\n\n\n\n\n\nIDTHHEIGHT=" + GameConstants.SCREEN_HEIGHT + ", " + GameConstants.SCREEN_WIDTH);
	console.log("UI OuterHeight: " + UI.Window.outerWidth);
	console.log("LayoutEmitter: " + LayoutEmitter.getWidth());
	console.log("CoreCapabilities: " + Core.Capabilities.getScreenWidth());
	console.log("UI Frame: " + UI.Window.getFrame());
	console.log("UI Window: " + UI.Window.getWidth() + ", " + UI.Window.getHeight());
	SaveData.forceInit();
	if (GameConstants.ENABLE_FPS) {
		FPS.instantiate();
	}
	if (GameConstants.ENABLE_TTV) {
		TouchTargetVisualizer.instantiate();
	}
	glView.onload = function() {
//		dolls = new Array();
		if (!GameConstants.PURE_DEBUG) {
			GameConstants.WIDTH_SCALE = GameConstants.SCREEN_WIDTH / GameConstants.ORIGINAL_WIDTH;
			GameConstants.HEIGHT_SCALE = GameConstants.SCREEN_HEIGHT / GameConstants.ORIGINAL_HEIGHT;
			GameConstants.WIDTH_SCALE = Math.min(GameConstants.WIDTH_SCALE, GameConstants.HEIGHT_SCALE);
			GameConstants.HEIGHT_SCALE = Math.min(GameConstants.WIDTH_SCALE , GameConstants.HEIGHT_SCALE);
		}
		else {
			GameConstants.BOX2D_SCALE = 1;
		}
		if (GameConstants.GL_DRAW) {
			// if using mobage draw, physics scale must be 1
			GameConstants.BOX2D_SCALE = 1;
		}
		GameConstants.BOX2D_HEIGHT_SCALE = GameConstants.BOX2D_SCALE * GameConstants.HEIGHT_SCALE;
		GameConstants.BOX2D_WIDTH_SCALE = GameConstants.BOX2D_SCALE * GameConstants.WIDTH_SCALE;
		//GameConstants.DENSITY_SCALE = GameConstants.BOX2D_SCALE * GameConstants.WIDTH_SCALE * GameConstants.HEIGHT_SCALE;
		
		//GL2.Root.addChild(killScreen.getNode());
		
		splash_screen = new GL2.Sprite();
		console.log("SCREEN DIMENSIONS: " + GameConstants.SCREEN_WIDTH + ", " + GameConstants.SCREEN_HEIGHT);
		splash_screen.setImage("Content/Default.png", [GameConstants.SCREEN_WIDTH, GameConstants.SCREEN_HEIGHT], [0.5, 0.5]);
		splash_screen.setRotation(-90);
		splash_screen.setPosition(GameConstants.SCREEN_HEIGHT / 2, GameConstants.SCREEN_WIDTH / 2);
		GL2.Root.addChild(splash_screen);
		//setTimeout(changeSplashToRB, 2000);
		setTimeout(initGame, 2000);
	};
	glView.setAttribute('frame', [0, 0, UI.Window.outerHeight, UI.Window.outerWidth]);
	glView.setAttribute('active', true);
	
}

function changeSplashToRB(){
	GL2.Root.removeChild(splash_screen);
	splash_screen.destroy();
	splash_screen = new GL2.Sprite();
	splash_screen.setImage("Content/ragdoll_intro.png", [GameConstants.SCREEN_WIDTH, GameConstants.SCREEN_HEIGHT], [0.5, 0.5]);
	splash_screen.setPosition(GameConstants.SCREEN_HEIGHT / 2, GameConstants.SCREEN_WIDTH / 2);
	GL2.Root.addChild(splash_screen);
	setTimeout(initGame, 2000);
}

function initGame(){
	console.log("SCREEN DIMENSIONS: " + GameConstants.SCREEN_WIDTH + ", " + GameConstants.SCREEN_HEIGHT);
	GL2.Root.removeChild(splash_screen);
	splash_screen.destroy();
	levelsCompletedThisSession = 0;
	//lvl = new Level();
	//lvl.loadNewLevel("Content/Levels/Asteroid_Field.json");
	//lvl.loadNewLevel("Content/Levels/Funnel.json");
	//lvl.loadNewLevel("Content/Levels/Recoil.json");
	msg_listener = new MsgHandler();
	LeaderboardHandler.instantiate();
	ad_manager = new AdManager();
	ad_manager.setInterstitialCloseCallback(interstitialClosed);
	killScreen = new KillScreen();
	killScreen.addListener(msg_listener, msg_listener.onKillScreenEmit);
	menu = new Menu();
	menu.addListener(msg_listener, msg_listener.onMenuEmit);
	Storage.FileSystem.readFile("./Content/levels.json", jsonLoaded);
	ad_manager.putMobageButtonBottom();
}

function interstitialClosed(){
	if (level_select != null && currentLevelNo != null) {
		level_select.getLevelData(currentLevelNo + 1);
	}
}

function transistionFromLevelToMenu(){
	level_select.setActive();
	lvl.destroy();
	lvl = null;
	if (level_select.getNode().getParent() != null) {
		level_select.getNode().getParent().removeChild(level_select.getNode());
	}
	GL2.Root.addChild(menu.getNode());
	ad_manager.putMobageButtonBottom();
}

function loadLevel(levelPath, levelNo){
	// TODO: make pretty;
	if (lvl) {
		lvl.destroy();
	}
	
	lvl = new Level();
	lvl.addListener(msg_listener, msg_listener.levelMessageHandler);
	lvl.loadNewLevel(levelPath, levelNo);
	
	
}

function jsonLoaded(){
	BFAudio.instantiate();
	level_select = new LevelSelect(JSON.parse(arguments[1]));
	level_select.addListener(msg_listener, msg_listener.onLevelSelect);
	//GL2.Root.addChild(level_select.getNode());
	GL2.Root.addChild(menu.getNode());
}

function transistionFromKillScreenToMenu(){
	if (killScreen.getNode().getParent() != null) {
		killScreen.getNode().getParent().removeChild(killScreen.getNode());
	}
	GL2.Root.addChild(menu.getNode());
}

function transistionFromMenuToKillScreen(){
	killScreen.updateDollText();
	GL2.Root.addChild(killScreen.getNode());
}

function transisitionFromMenuToLevelSelect(){
	if (menu.getNode().getParent() != null) {
		menu.getNode().getParent().removeChild(menu.getNode());
	}
	GL2.Root.addChild(level_select.getNode());
}

function transistionFromLevelSelectToMenu(){
	if (level_select.getNode().getParent() != null) {
		level_select.getNode().getParent().removeChild(level_select.getNode());
	}
	GL2.Root.addChild(menu.getNode());
}

function transistionFromLevelToSelect(){
	level_select.setActive();
	lvl.destroy();
	lvl = null;
	GL2.Root.addChild(menu.getNode());
	menu.goToLevelSelect();
	ad_manager.putMobageButtonBottom();
}

var MsgHandler = Core.MessageListener.subclass({
	initialize: function(){
		// TODO: stuff
		Device.KeyEmitter.addListener(this, this.onKey);
		Device.LayoutEmitter.addListener(this, this.onLayout);
	},
	
	onLayout: function() {
		console.log("\n\n\n\n\n\n\n\n\n\n LAYOUT CHANGE!!!!" + LayoutEmitter.getHeight() + ", " + LayoutEmitter.getWidth());
	},
	
	onLevelSelect: function(arg){
		console.log("Level Select wants to load: " + arg);
		if (arg[0] == "KILLSCREEN") {
			transistionFromLevelToMenu();
			transistionFromMenuToKillScreen();
		}
		else if (arg[0] == "MENU") {
			transistionFromLevelSelectToMenu();
		}
		else if (arg[0] == "LEVELSELECT") {
			transistionFromLevelToSelect();
		}
		else {
			loadLevel(GameConstants.LEVEL_JSON_PATH + arg[0], arg[1]);
		}
		
	},
	
	onKillScreenEmit: function(arg) {
		if (arg == "MENU") {
			transistionFromKillScreenToMenu();
		}
	},
	
	levelMessageHandler: function(arg){
		if (arg == "MENU") {
			transistionFromLevelToMenu();
		}
		else if (arg == "BUTTONTOP") {
			ad_manager.putMobageButtonTop();
		}
		else if (arg == "BUTTONBOTTOM") {
			ad_manager.putMobageButtonBottom();
		}
		else if (arg[0] == "GETNEXT") {
			level_select.updateBestScore(arg[1] - 1);
			levelsCompletedThisSession++;
			if(parseInt(SaveData.getValue("LEVELSBEATEN", "0")) % GameConstants.LEVELS_BEFORE_RATE == 0 && parseInt(SaveData.getValue("HASRATED", "0")) < GameConstants.TIMES_TO_PROMPT_FOR_RATE)
			{
				SaveData.updateValue("HASRATED", String(parseInt(SaveData.getValue("HASRATED")) + 1));
				lvl.setAdViewing();
				currentLevelNo = arg[1];
				rate_dialog = new UI.AlertDialog();
    
				rate_dialog.setTitle(GameConstants.RATE_TITLE); // Core.Localization.getString("Hello World")
				rate_dialog.setText(GameConstants.RATE_TEXT);
				rate_dialog.setChoices([GameConstants.RATE_OPTION_YES, GameConstants.RATE_OPTION_NO]);
				rate_dialog.setOnChoice(rateDialogCallback);

				rate_dialog.show();

			}
			else if (levelsCompletedThisSession >= GameConstants.LEVELS_BEFORE_ADS && SaveData.getValue("LEVELSBEATEN", "0") >= GameConstants.NUM_TUTORIAL_LEVELS) {
				lvl.setAdViewing();
				ad_manager.showInterstitial();
				currentLevelNo = arg[1];
				levelsCompletedThisSession = 0;
			}
			else {
				level_select.getLevelData(arg[1] + 1);
			}
		}
	},
	
	onKey: function(key_event) {
		if (key_event.code === Device.KeyEmitter.Keycode.back) {
			if (ad_manager.isAdShown()) {
				ad_manager.closeFattyAd();
				return true;
			}
			else if (killScreen.getNode().getParent() != null) {
				killScreen.backKeyHandler();
				return true;
			}
			else if (lvl != null && lvl.getNode().getParent() != null) {
				transistionFromLevelToSelect();
				return true;
			}
			else if (level_select.getNode().getParent() != null) {
				transistionFromLevelSelectToMenu();
				return true;
			}
			else if (menu.getNode().getParent() != null) {
				return menu.backKeyHandler();
				
			}
			else {
				console.log("mobage can have it");
				return false;
			}
		}
	},
	
	onMenuEmit: function(arg){
		switch (arg) {
			case ("KILLSCREEN"):{
				transistionFromMenuToKillScreen();
				break;
			}
			case ("LEVELSELECT"):{
				transisitionFromMenuToLevelSelect();
				break;
			}
			case ("LEAKCHECK"):{
				console.log("you so leaky");
				Storage.FileSystem.readFile("/Content/levels/invasion.json", false, levelLoadCallback);
//				FPS.start();
//				try {
//					var templvl = new Level();
//					templvl.addListener(msg_listener, msg_listener.levelMessageHandler);
//					templvl.loadNewLevel("/Content/levels/tutorial.json", 1);
//					
//					templvl.destroy();
//				} 
//				catch (e) {
//					console.log("FAIL!");
//					console.log(e.stack);
//				}
//				FPS.stop();
			}
		}
	},
	
});

function rateDialogCallback(event)
{
	switch(event.choice) 
	{
		case 0:
			SaveData.updateValue("HASRATED", String(GameConstants.TIMES_TO_PROMPT_FOR_RATE));
			var marketUrl = "market://details?id=" + Core.Capabilities.getBundleIdentifier();
			Device.IPCEmitter.launch(marketUrl, function(error){
					console.log("rateGamePrompt: Error launching URL: " + marketUrl);
				});
			break;
		default:
	}
	rate_dialog.destroy();
	if (level_select != null && currentLevelNo != null) {
		level_select.getLevelData(currentLevelNo + 1);
	}

}

function levelLoadCallback(){
	FPS.start();
	var templvl = new Level();
	templvl.addListener(msg_listener, msg_listener.levelMessageHandler);
	templvl.processJSON(JSON.parse(arguments[1]));
	templvl.destroy();
	FPS.stop();
}
